dojo.provide("dojox.widget.AnalogGauge2.BaguetteStyle");

dojo.require("dojo.fx");
dojo.require("dojo.fx.easing");
dojo.require("dojox.widget.AnalogGauge2._Style");

dojo.declare("dojox.widget.AnalogGauge2.BaguetteStyle", [dojox.widget.AnalogGauge2._Style], {
       /**
        * font
        * maybe later used
        */
//        font: {family: "Helv", weight: 'bold', size:'10px'},
        font: {family: "Arial", weight: 'bold', size:'10px'},

		fontcolor: "black",
		
		_fh: 10,
		_maxtextlen: 1,

		showunits: true,
		thickness: 20,
		maxvalue: 0,
		legend: true,

//default colors when use the 'default' word
        colorIndex: 0,
	    colors:['#FF9090','#90FF90','#9090FF','#B9D3EE','#FFD39B',
                '#70DB93','#F4A460','#8B7355','#FFF68F','#BA55D3',
                '#FFFF00','#236B8E','#EEA9B8','#FF2400','#F0FFF0'],

        overlayName: dojo.moduleUrl("dojox.widget.AnalogGauge2.BaguetteStyle", "overlayBaguette.png"),


    
    constructor: function(args){
       dojo.mixin(this, args);
	   this.series=[];
	   if(this.colorMap == null){
            this.colorMap = {};
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CLEAR_STATUS         ]   = "#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NORMAL_STATUS        ]   = "green"; //#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CRITICAL_STATUS      ]   = "red"; //#e51717";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.FATAL_STATUS         ]   = "#222222";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MAJOR_STATUS         ]   = "#FFB31A";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MINOR_STATUS         ]   = "#ffff1a";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INDETERMINANT_STATUS ]   = "#2EA8E5";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NOT_APPLICABLE_STATUS]   = "#6963A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNKNOWN_STATUS       ]   = "#A6A6A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNDEFINED_STATUS     ]   = "#9294f3";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INFORMATIONAL_STATUS ]   = "#2ea8e5";
        }
	},

     /**
      * private fnciton computefont
      */
      _computefont: function(state){
         this._fh=((state.width/20.0)|0);
         this.font.size= this._fh+"px";

      },
      
      _getColor: function(state){
		  if (state.thresholds.length==0){
			  return "#33cc14";
		  }
		  var c=this.getThresholdFromValue(state.endValue, state.thresholds);
		  return this.colorMap[c.name];
		},
      
      _computeSeries: function(state){
      	console.log("_computeSeries");
      	while( this.series.length >0 ) this.series.pop();
      	var color = this._getColor(state);
      	this.addSeries({data:state.endValue, title:state.units,color:color});
      	console.log(this.series);
      	
      },

    /*
     *  clear series
	 **/
	clear : function(){
       this.colorIndex=0;
       this.series=[];
    },

    /*
     *  addSeries({ data: value, title: string,  color: string} )
     *
	 **/
	addSeries: function(s) {
		console.log("addSeries");
       if (s.color=='default'){
          s.color= this.colors[this.colorIndex];
          ++this.colorIndex;
          if (this.colorIndex>=this.colors.length)
             this.colorIndex=0;
       }
       var t= this._getTextBox(s.title);
	   var textsize= t.w;
       this._fh= t.h;
       s._textlen= t.w+30+10;

	   if(this._maxtextlen<textsize)
		  this._maxtextlen=textsize;

       this.series.push(s);
	   return this;
	},




    getDrawOrder: function(){
        return ["drawSeries",  "drawForeground","drawLegend"]; //"drawTicks", "drawForeground"];
	},
    
    getDrawSemantics: function(){
        return {
//            background: "drawBackground",
			background: "drawForeground",
			foreground: "drawLegend",
            updateValue: "drawSeries",
            needle: "drawSeries",
        };
    },
    
    _backGroup: null,
    drawBackground: function(state){
    	console.log("drawBackground");
        this._computefont(state);

        var ph=this.thickness;
        var pw=state.width;
        var cx = state.width/2.0;
        var cy = state.height/2.0;

        if (this._backGroup==null){
           this._backGroup= state.group.createGroup();
        }

        this._backGroup.clear();
        var shape;

        var scaler= 100.0/state.height;  //because thats what the root does

        this._backGroup.setTransform({xx: scaler, yy: scaler, dx: 0, dy:0 });

        return this._backGroup;
    },

    drawNeedle: function(state){
      return null;
	},

	_foreGroup: null,
    drawForeground: function(state){
    	console.log("drawForeground");
        var ph=this.thickness;
        var pw=state.width;
        var cx = state.width/2.0;
        var cy = state.height/2.0;

        if(this._foreGroup == null){
            this._foreGroup= state.group.createGroup();
        }
        this._foreGroup.clear();
		var pat;

		if (document.all){ //isIE
         pat= {
           type: "pattern",
           x:0,          
           y:0,      //IE
//           y:-cy,  //firefox
           width: ((69.0*ph)/19.0)|0, //isotropic ansiotropic?
           height: ph,
           src: this.overlayName};
        }else{
         pat= {
           type: "pattern",
           x:-cx,          
           y:-cy,  //firefox
           width: ((69.0*ph)/19.0)|0, //isotropic ansiotropic?
		   height: ph,
           src: this.overlayName};
       }



        this._foreGroup.createRect({x: -cx, y: -cy, width: pw, height: ph-1, r: ph/2 }).setFill(pat);

		var scaler= 100.0/state.height;  //because thats what the root does
        this._foreGroup.setTransform({xx: scaler, yy: scaler, dx: 0, dy: 0});

        return this._foreGroup;
    },

	 measuringNode: null,
	_getTextBox: function(text){
		console.log("_getTextBox");
		var m, s;
		if(this.measuringNode==null){
			m = this.measuringNode = dojo.doc.createElement("div");
			s = m.style;
			m.style.fontSize=this.font.size;
            m.style.fontFamily=this.font.family;
			s.position = "absolute";
			s.left = "-10000px";
			s.top = "0";

			dojo.body().appendChild(m);
		}else{
			m = this.measuringNode;
			s = m.style;
		}
		// reset styles

		m.className = "";
		s.border = "0";
		s.margin = "0";
		s.padding = "0";
		s.outline = "0";
		// take a measure
		m.innerHTML = text;
		return dojo.marginBox(m);
	},



_legendGroup: null,
	drawLegend: function(state){
		console.log("_legend");
        var ph=this._fh;
        var pw=state.width;
        var boxwidth=10;
		var cx = state.width/2.0;
        var cy = state.height/2.0;

		var margin=10;
        var rowsize= this._maxtextlen+30+5;
		var legendrows= (state.width-margin)/rowsize;

		if (legendrows<1)
			legendrows=1;

		var modulo= legendrows|0; //two columns only


		var y=-cy+10;

		var x=-cx+margin;
		var i,j;
		var fontH= this._fh;
		var pat;

 //compute rows widths to tighten them a little bit.
		var row= new Array(modulo);
		for (i=0; i<modulo; i++) 
           row[i]=0;
        for (i=0; i<this.series.length; i++) {
		  j=i%modulo;
		  if (row[j]<this.series[i]._textlen)
               row[j]=this.series[i]._textlen;
		}
//

		if (document.all){ //isIE
         pat= {
           type: "pattern",
           x:0,          
           y:0,      //IE
           width: ((69.0*ph)/19.0)|0, //isotropic ansiotropic?
           height: ph,
           src: this.overlayName};
        }else{
         pat= {
           type: "pattern",
           x:0,          
           y:-1,  //firefox
           width: ((69.0*ph)/19.0)|0, //isotropic ansiotropic?
           height: ph,
           src: this.overlayName};
        }



        if (this._legendGroup==null)
           this._legendGroup = state.group.createGroup();
        this._legendGroup.clear();


        for (i=0; i<this.series.length; i++) {
			var item= this.series[i];
		  if ((i%modulo)==0){
			  x=-cx+margin;
			  y+=2*this._fh;
              if (this.showunits) 
	  			  y+=this._fh;
		  }
		  else{
			  x+= row[(i%modulo)-1];
		  }
		   this._legendGroup.createText({x: x+5+boxwidth, y: y, text: item.title})
		                 .setFill(this.fontcolor).setFont(this.font);

           if (this.showunits) {
    		   this._legendGroup.createText({x: x+5+boxwidth, y: y+this._fh, text: ""+item.data+state.units})
		                 .setFill(this.fontcolor).setFont(this.font);
		   }
		   this._legendGroup.createRect({
							 x: x,
							 y: y-fontH,
							 width: 10, height: fontH
						 }).setFill(item.color).setStroke(null);
		   this._legendGroup.createRect({
							 x: x,
							 y: y-fontH,
							 width: 10, height: fontH
						 }).setFill(item.color).setFill(pat);



		}

		var scaler= 100.0/state.height;  //because thats what the root does

        this._legendGroup.setTransform({xx: scaler, yy: scaler, dx: 0, dy:0 });


	},
	
	_drawHalfCricle:function(x,y,radius,width, group,left,color){
				var path = group.createPath();
				var delta = Math.sqrt(radius*radius - (radius-width)*(radius-width));
				//path.moveTo(x,y-delta);
				path.moveTo(x,y+delta);
				
				path.arcTo(radius , radius, 0, 0, left, x, y-delta);
				
				path.closePath();
				//path.setStroke(color);
				path.setFill(color);
	},
	
	_seriesGroup:null,

    drawSeries: function(state){
    	console.log("drawSeries");
    	if(this.series.length <= 1){
    		this._computeSeries(state);
    	}
    	
        var ph=this.thickness;
        var pw=state.width;
        var cx = state.width/2.0;
        var cy = state.height/2.0;
		var max=0;


        if (this._seriesGroup==null)
           this._seriesGroup = state.group.createGroup();
        this._seriesGroup.clear();
        var i;

		/*for (var i=0; i<this.series.length; i++) 
            max+=this.series[i].data;
        if (max==0) 
           return this._seriesGroup;
        if (this.maxvalue!=0) */
			max= state.maxValue;

		var len;
		var x=0,shape;
		console.log("before draw:",this.series);
		for (var i=0; i<this.series.length; i++) {
			console.log("pw",pw,"this.series[i].data",this.series[i].data,"max",max);
           len = ((pw*this.series[i].data)/max)|0;
           console.log("len",len,"cx",cx,"cy",cy,"this.series[i]",this.series[i]);
           if (i==0) {
           	console.log("in i==0");
           	if(len<=ph/2){
           		this._drawHalfCricle(x-cx+len, -cy+ph/2, ph/2, len,this._seriesGroup,true,this.series[i].color);
           	}else{
     		   	this._seriesGroup.createRect({x: x-cx, y: -cy, 
                                     r: ph/2,
									 width : len,
									 height: ph-1}).setFill(this.series[i].color);
				if(len<=pw-ph/2){
   		      		this._seriesGroup.createRect({x: x-cx+ph/2, y: -cy, 
									 width : len-ph/2,
									 height: ph-1}).setFill(this.series[i].color);
				}
           	}
		   }else{
               if ((len+x)>(state.width-ph/2) ){
     		   		this._seriesGroup.createRect({x: x-cx, y: -cy, 
                                     r: ph/2,
									 width : len,
									 height: ph-1}).setFill(this.series[i].color);
     		     	this._seriesGroup.createRect({x: x-cx, y: -cy, 
									 width : ph/2,
									 height: ph-1}).setFill(this.series[i].color);
			   }else
			     	this._seriesGroup.createRect({x: x-cx, y: -cy, 
									 width : len,
									 height: ph-1}).setFill(this.series[i].color);
		   }
		   x+=len;
		}
        var scaler= 100.0/state.height;  //because thats what the root does

        this._seriesGroup.setTransform({xx: scaler, yy: scaler, dx: 0, dy:0 });
        
		return this._seriesGroup;
	},
	
	/*drawLegend:function(state){
		if (this.legend) 
    		return this._legend(state);
	},*/


    
    reset: function(){
        // summary:
        //          Deletes any locally-stored shape objects when the gauge 
        //          needs to be reset.

        delete this._backGroup;
        delete this._foreGroup;
        delete this._legendGroup;
        delete this._seriesGroup;
 
		this._backGroup=null;
		this._legendGroup=null;
		this._foreGroup=null;
		this._seriesGroup=null
    }
});