dojo.provide("dojox.widget.AnalogGauge2.ChevronStyle");

dojo.require("dojo.fx");
dojo.require("dojo.fx.easing");
dojo.require("dojox.widget.AnalogGauge2._Style");
dojo.require("dojox.widget.AnalogGauge2"); // for the AnalogGaugeThreshold


dojo.declare("dojox.widget.AnalogGauge2.ChevronStyle", [dojox.widget.AnalogGauge2._Style], {
	/**
	 * lable and value's text style
	 */
	textColor: [0,0,0],
	textFont:  {family: 'Verdana, sans-serif', size:'15px'},
	labelFont:  {family: 'Verdana, sans-serif', size:'15px'},
	
	_label: "label",
	_height:60,
	_width:180,
	_angleIn:30,
	_highlightImage:"",
	_scaler:100,
	_status:"normal",
	_value:0,
	_bgcolor1:"#E7F3FF",
	_bgcolor2:"#C6E3F7",
	_linecolor:"#4A86A5",
	_oneline: false,
	
	// colorMap: Object
    //          Mapping from dojox.widget.AnalogGaugeThreshold.***_STATUS values 
    //          to colors.
    colorMap: null,
    iconMap: null,

    /**
     * Set outline thickness and color, set to zero to remove outline
     */
    outlinewidth: 1,
    outlinecolor: "black",
	
	rainbow : {type: "linear",
             x1: 0, y1: 0,
             x2: 80, y2: 0,
             colors: [
                { offset: 0.1, color: "#FFB31A" },
                { offset: 0.9, color: "#ffffff" }
                 ]
            },
	
    constructor: function(args){
		dojo.mixin(this, args);
		// if the colorMap wasn't set, use a default one.
        if(this.colorMap == null){
            this.colorMap = {};
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CLEAR_STATUS         ]   = "#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NORMAL_STATUS        ]   = "#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CRITICAL_STATUS      ]   = "#e51717";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.FATAL_STATUS         ]   = "#222222";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MAJOR_STATUS         ]   = "#FFB31A";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MINOR_STATUS         ]   = "#ffff1a";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INDETERMINANT_STATUS ]   = "#2EA8E5";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NOT_APPLICABLE_STATUS]   = "#6963A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNKNOWN_STATUS       ]   = "#A6A6A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNDEFINED_STATUS     ]   = "#9294f3";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INFORMATIONAL_STATUS ]   = "#2ea8e5";
        }
        
        if(this.iconMap == null){
        	this.iconMap = {};
            var baseString = "dojox.widget.AnalogGauge2.ChevronStyle";
            this.iconMap[dojox.widget.AnalogGaugeThreshold.CLEAR_STATUS         ]   = dojo.moduleUrl(baseString, "normal.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.NORMAL_STATUS        ]   = dojo.moduleUrl(baseString, "normal.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.CRITICAL_STATUS      ]   = dojo.moduleUrl(baseString, "critical.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.FATAL_STATUS         ]   = dojo.moduleUrl(baseString, "fatal.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.MAJOR_STATUS         ]   = dojo.moduleUrl(baseString, "warning_major.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.MINOR_STATUS         ]   = dojo.moduleUrl(baseString, "warning.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.INDETERMINANT_STATUS ]   = dojo.moduleUrl(baseString, "indeterminate.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.NOT_APPLICABLE_STATUS]   = dojo.moduleUrl(baseString, "unknown.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.UNKNOWN_STATUS       ]   = dojo.moduleUrl(baseString, "unknown.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.UNDEFINED_STATUS     ]   = dojo.moduleUrl(baseString, "undefined.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.INFORMATIONAL_STATUS ]   = dojo.moduleUrl(baseString, "information.png");
        }
		
	},
	
	_computeSizing: function(state){
		//compute width & height
		if(state.height * 3 > state.width){
			this._width = state.width;
			this._height = state.width / 3;
			//this._scaler = 100.0 / this._width;
		}else if(state.height * 3 < state.width){
			this._height = state.height;
			this._width = state.height * 3;
			//this._scaler = 100.0 / (this._height * 3);
		}else {
			this._height = state.height;
			this._width = state.width;
			//this._scaler = 100.0 / this._width;
		}
		
		
		this._angleIn = this._height / 2;
		this.textFont.size = (this._angleIn / 2);
		this.labelFont.size = (this._angleIn / 2);
		var textLength = this._width - 3 * this._angleIn - 2 * this._angleIn / 3;
		
		var realLength = (state.units+" "+state.endValue).length;
		var newSize = (textLength / realLength);
		this._oneline = false;
		if(newSize > Number(this.textFont.size) / 2){
			this._oneline = true;
			this.textFont.size += "px";
			this.labelFont.size += "px"
		}else{
		
			var text1Size = 2 * textLength / (state.endValue+"").length;
			var text2Size = 2 * textLength / state.units.length;
			this.textFont.size = this.textFont.size > text1Size ? text1Size+"px" : this.textFont.size+"px";
			this.labelFont.size = this.labelFont.size > text2Size ? text2Size+"px" : this.labelFont.size+"px";
		}
		
		
		if(state.width < state.height){
			this._scaler = 100.0 / state.width;
		}else if(state.width <= state.height * 3 ){
			this._scaler = 100.0 / state.height;
		}else{
			this._scaler = 100.0 / state.height;
		}
		
		//compute value / status
		this._value = state.endValue;
		this._status = this.getThresholdFromValue(state.endValue, state.thresholds).status;
		
	},


    getDrawOrder: function(){
        return ["drawBackground",  "drawForeground", "drawText"];
	},
  
    
    getDrawSemantics: function(){
        return {
            background: "drawBackground",
            foreground: "drawForeground",
			text: "drawText",
            updateValue: ["drawBackground", "drawForeground", "drawText"]
        };
    },
    


	_backGroup: null,

	drawBackground: function(state){
		console.log("drawBackground",state);
		this._computeSizing(state);
		
		if(this._backGroup == null){
            this._backGroup = state.group.createGroup();
        } else {
            this._backGroup.clear();
        }
        //alert(this._width + "," + this._height);
        //var rec = this._backGroup.createRect({x:-(this._width / 2), y: - (this._height / 2),width:this._width, height:this._height});
       	//alert("drawBackground "+this._status+":"+this.colorMap[this._status]);
       	/*
       	var half1 = this._backGroup.createPath("").setStroke({color:this._bgcolor1}).setFill(this._bgcolor1);
       	half1.moveTo(-(this._width / 2),- (this._height / 2));
       	half1.hLineTo(-(this._width / 2) + this._width - this._angleIn);
       	half1.lineTo(-(this._width / 2) + this._width, 0);
       	half1.hLineTo(-(this._width / 2) + this._angleIn);
       	half1.lineTo(-(this._width / 2),- (this._height / 2));
       	
       	var half2 = this._backGroup.createPath("").setStroke({color:this._bgcolor2}).setFill(this._bgcolor2);
       	half2.moveTo(-(this._width / 2), (this._height / 2));
       	half2.hLineTo(-(this._width / 2) + this._width - this._angleIn);
       	half2.lineTo(-(this._width / 2) + this._width, 0);
       	half2.hLineTo(-(this._width / 2) + this._angleIn);
       	half2.lineTo(-(this._width / 2), (this._height / 2));
       	
       	var lines = this._backGroup.createPath("").setStroke({color:this._linecolor});
       	lines.moveTo(-(this._width / 2),- (this._height / 2));
       	lines.hLineTo(-(this._width / 2) + this._width - this._angleIn);
       	lines.lineTo(-(this._width / 2) + this._width, 0);
       	lines.lineTo(-(this._width / 2) + this._width - this._angleIn, (this._height / 2));
       	lines.hLineTo(-(this._width / 2));
       	lines.lineTo(-(this._width / 2) + this._angleIn,0);
       	lines.lineTo(-(this._width / 2),- (this._height / 2));
       	
		var decorateLines = [];
       	decorateLines.push(this._backGroup.createLine({x1: -(this._width / 2) +1 ,y1: (this._height / 2) - 1,x2: -(this._width / 2) + this._width - this._angleIn + 1,y2: (this._height / 2) - 1}).setStroke({color:"#6396AD",weight:1}));
       	decorateLines.push(this._backGroup.createLine({x1: -(this._width / 2) +3 ,y1: (this._height / 2) - 2,x2: -(this._width / 2) + this._width - this._angleIn + 1,y2: (this._height / 2) - 2}).setStroke({color:"#ADCBDE",weight:1}));
       	
       	decorateLines.push(this._backGroup.createLine({x1: -(this._width / 2) + this._width - 1 ,y1: 0 ,x2: -(this._width / 2) + this._width - this._angleIn - 1,y2: (this._height / 2) }).setStroke({color:"#6396AD",weight:1}));
       	decorateLines.push(this._backGroup.createLine({x1: -(this._width / 2) + this._width - 2 ,y1: 0 ,x2: -(this._width / 2) + this._width - this._angleIn,y2: (this._height / 2)-2 }).setStroke({color:"#ADCBDE",weight:1}));
       	
       	decorateLines.push(this._backGroup.createLine({x1: -(this._width / 2) + 3 ,y1: (this._height / 2) -1 ,x2: -(this._width / 2) + this._angleIn + 3,y2: -1 }).setStroke({color:this._bgcolor1,weight:1}));
       	
       	decorateLines.push(this._backGroup.createLine({x1: -(this._width / 2) + 3 ,y1: - (this._height / 2) + 1 ,x2: -(this._width / 2) + this._angleIn + 1,y2: -1 }).setStroke({color:"#BDD3EF",weight:1}));
       	
       	decorateLines.push(this._backGroup.createLine({x1: -(this._width / 2) +3 ,y1: - (this._height / 2) + 2,x2: -(this._width / 2) + this._width - this._angleIn + 1,y2: - (this._height / 2) + 2}).setStroke({color:"#FFFFFF",weight:1}));
       	
       	console.log(this._status+":"+this.colorMap[this._status]);
        //rec.setStroke(this.colorMap[this._status]);
        //rec.setFill(this.colorMap[this._status]);
        
        this._backGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
        if(this.dir=='rtl'){
			half1.setTransform(dojox.gfx.matrix.flipX);
			half2.setTransform(dojox.gfx.matrix.flipX);
			lines.setTransform(dojox.gfx.matrix.flipX);
			for(var i=0;i<decorateLines.length;i++){
				decorateLines[i].setTransform(dojox.gfx.matrix.flipX);
			}
		}*/
		this._backGroup.createImage({x:-this._width/2, y:-this._height/2, width:this._width, height:this._height, src:dojo.moduleUrl("dojox.widget.AnalogGauge2.ChevronStyle","ChevronBG.png")});
		this._backGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
        return this._backGroup;
	},

    _foreGroup: null,
    drawForeground: function(state){
    	console.log("drawForeground",state);
    	
    	if(this._foreGroup == null){
            this._foreGroup = state.group.createGroup();
        } else {
            this._foreGroup.clear();
        }
        var icon;
        if(this.dir == 'rtl'){
        	icon = this._foreGroup.createImage({x: -(this._width / 2) + this._angleIn*10/3 + 10 * this._height / 60, y: - (this._angleIn / 2), width: this._angleIn , height: this._angleIn , src: this.iconMap[this._status]});
        }else{
        	icon = this._foreGroup.createImage({x: -(this._width / 2) + this._angleIn + 10 * this._height / 60, y: - (this._angleIn / 2), width: this._angleIn , height: this._angleIn , src: this.iconMap[this._status]});
        }
        //alert("drawForeground "+this._status+":"+this.iconMap[this._status]);
        console.log(this._status+":"+this.iconMap[this._status]);
        //icon.setShape({x: 20, y: 20});
        
        this._foreGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
        
        if(this.dir=='rtl'){
        	icon.setTransform(dojox.gfx.matrix.flipX);
        }
        return this._foreGroup;
        
    },

	
	/**
     *  draw lable and value
     */
    _textGroup: null,
    drawText: function(state){
    	console.log("drawText",state);
		
		if(this._textGroup == null){
            this._textGroup = state.group.createGroup();
        } else {
            this._textGroup.clear();
        }
        
		if(this._oneline){
			var text;
			if(this.dir=='rtl'){
				text = this._textGroup.createText({
		        	x:-(this._width / 2) + this._angleIn*7/2,
		        	y:this._angleIn / 4,
		        	text:(state.endValue ? state.endValue : this._value) + " " + (state.units ? state.units : this._label),
		        	align:"end"
		        });
			}else{
				text = this._textGroup.createText({
		        	x:-(this._width / 2) + this._angleIn*2 + 15 * this._height / 60,
		        	y:this._angleIn / 4,
		        	text:(state.endValue ? state.endValue : this._value) + " " + (state.units ? state.units : this._label),
		        	align:"start"
		        });
			}
			
			text.setFont(this.textFont);
	        text.setFill(this.textColor);
	        
	        this._textGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
	        
	        if (this.dir=='rtl'){
				text.setTransform(dojox.gfx.matrix.flipX);
			}
			
		}else {
        
	        var text1,text2;
	        if(this.dir=='rtl'){
	        	text1 = this._textGroup.createText({
		        	x:-(this._width / 2) + this._angleIn*7/2,
		        	y:0,
		        	text:state.endValue ? state.endValue : this._value,
		        	align:"end"
		        });
		        
		        
		        text2 = this._textGroup.createText({
		        	x:-(this._width / 2) + this._angleIn*7/2,
		        	y:this._angleIn / 2,
		        	text:state.units ? state.units : this._label,
		        	align:"end"
		        });
	        }else {
		        text1 = this._textGroup.createText({
		        	x:-(this._width / 2) + this._angleIn*2 + 15 * this._height / 60,
		        	y:0,
		        	text:state.endValue ? state.endValue : this._value,
		        	align:"start"
		        });
		        
		        
		        text2 = this._textGroup.createText({
		        	x:-(this._width / 2) + this._angleIn*2 + 15 * this._height / 60,
		        	y:this._angleIn / 2,
		        	text:state.units ? state.units : this._label,
		        	align:"start"
		        });
	        }
	        
	        text1.setFont(this.textFont);
	        text1.setFill(this.textColor);
	        text2.setFont(this.labelFont);
	        text2.setFill(this.textColor);
	        
	        this._textGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
	        
	        if (this.dir=='rtl'){
				text1.setTransform(dojox.gfx.matrix.flipX);
				text2.setTransform(dojox.gfx.matrix.flipX);
			}
		}
        
        return this._textGroup;
	},
	
	adjust: function(opt){
        dojo.mixin(this, opt);
        console.log("*************adjust***********",opt);
    },

    reset: function(){
    	if(this._backGroup)this._backGroup.clear();
        if(this._foreGroup)this._foreGroup.clear();
		if(this._textGroup)this._textGroup.clear();
    	
        delete this._backGroup;
        delete this._foreGroup;
		delete this._textGroup;

        this._backGroup=null;
        this._foreGroup=null;
		this._textGroup=null; 
    }
});