dojo.provide("dojox.widget.AnalogGauge2.GraduatedBarStyle");

dojo.require("dojo.fx");
dojo.require("dojo.fx.easing");
dojo.require("dojox.widget.AnalogGauge2._Style");
dojo.require("dojox.widget.AnalogGauge2"); // for the AnalogGaugeThreshold

dojo.declare("dojox.widget.AnalogGauge2.GraduatedBarStyle", [dojox.widget.AnalogGauge2._Style], {
       /**
        * font
        * maybe later used
        */
        font: {family: "Arial", style: "italic", variant: 'small-caps', weight: 'bold', size:'8px'},
        fontv: {family: "Arial", style: "italic", variant: 'small-caps', weight: 'bold', size:'8px'},
        _fh: 8,
        _fhv:8,

       /**
        * To choose round or square
        */
        round: false,
    /** colorMap: Object
     *          Mapping from dojox.widget.AnalogGaugeThreshold.***_STATUS values 
     *         to colors.
	 */
        colorMap: null,

	   /**
        * lines on status bar
        */
        lines:  true,
       /**
        * values on status bar
        */
        values: true,
       /**
        * to allow you to adjust the rainbow areas
        */
        garea: 0.1,
        yarea: 0.4,
        oarea: 0.7,
        rarea: 0.8,
        rainbow : {type: "linear",
                   x1: 0, y1: 0,
                   x2: 400, y2: 0,
                   colors: [{ offset: 0.1, color: "green" },
                            { offset: 0.4, color: "yellow" },
                            { offset: 0.7, color: "#D98719" },
                            { offset: 0.8, color: "red" }
						   ]
                  },
       /**
       * The value color
       **/
        vcolor: "black",
	   /**
       * for  filling your own color
       * fillcolor="'lime'"
       * fillcolor="{'type': 'linear',
       *                 'x1': 0,
       *                 'x2': 400,
       *                 'y2': 0,
       *                 'y1': 0,
       *                 'colors': [{offset: 0, color: '#0000FF'},{offset: 1, color: 'lime'}] }"
       *
       **/
        fillcolor: null,
       /**
        * majorTicks control the min and max range as well as the interval
        *
        */
        majorTicksColor: 'black',
        majorTicksLength: 6,
       /**
        * minorTicks control drawing minor ticks only
        */
        minorTicksColor: "black",
        minorTicksLength: 3,
        overlayName: dojo.moduleUrl("dojox.widget.AnalogGauge2.GraduatedBarStyle", "overlayGrad.png"),


    
    constructor: function(args){
       dojo.mixin(this, args);
        // if the colorMap wasn't set, use a default one.
        if(this.colorMap == null){
            this.colorMap = {};
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CLEAR_STATUS         ]   = "#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NORMAL_STATUS        ]   = "green"; //#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CRITICAL_STATUS      ]   = "red"; //#e51717";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.FATAL_STATUS         ]   = "#222222";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MAJOR_STATUS         ]   = "#FFB31A";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MINOR_STATUS         ]   = "#ffff1a";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INDETERMINANT_STATUS ]   = "#2EA8E5";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NOT_APPLICABLE_STATUS]   = "#6963A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNKNOWN_STATUS       ]   = "#A6A6A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNDEFINED_STATUS     ]   = "#9294f3";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INFORMATIONAL_STATUS ]   = "#2ea8e5";
        }
	   this.rainbow.colors[0].offset= this.garea;
       this.rainbow.colors[1].offset= this.yarea;
       this.rainbow.colors[2].offset= this.oarea;
       this.rainbow.colors[3].offset= this.rarea;

	   },
	
		/**
		 * Note you can use the word rainbow for  threshold color
		 */
		_getColor: function(state){
		  if (state.thresholds.length==0){
			  if (this.fillcolor==null) 
				   return "rainbow";
			  return this.fillcolor;
		  }
		  var c=this.getThresholdFromValue(state.endValue, state.thresholds);
		  return this.colorMap[c.name];
		},

     /**
      * private fnciton computefont
      */
      _computefont: function(state){
         this._fh=((state.width/20.0)|0);
         this._fhv=(((state.height-this._fh)/3.0)|0);
         if (this._fhv<this._fh)
             this._fh=this._fhv;
         this.font.size= this._fh+"px";
         this.fontv.size= this._fhv+"px";

      },


    getDrawOrder: function(){
        return ["drawBackground", "drawNeedle", "drawForeground", "drawTicks"]; 
    },
    
    getDrawSemantics: function(){
        return {
            background: "drawBackground",
            ticks: "drawTicks",
            needle: "drawNeedle",
            foreground: "drawForeground",
            updateValue: "drawNeedle",
            attentionUp: ["drawBackground",    "drawNeedle", "drawForeground", "drawTicks"],
            attentionDown: ["drawBackground",  "drawNeedle", "drawForeground", "drawTicks"]
        };
    },
    
    _backGroup: null,
    drawBackground: function(state){
        this._computefont(state);

		var ph=state.height-this._fh;
        var pw=state.width;
        var cx = state.width/2.0;
        var cy = state.height/2.0;

        if (this._backGroup==null){
           this._backGroup= state.group.createGroup();
		}

        this._backGroup.clear();
        var shape;
        if (this.round)
           shape=this._backGroup.createRect({x: -cx, y: -cy,
                                     width : pw,
                                     height: ph,
                                     r     : ph/2.0 }).setStroke("gray");
        else
           shape=this._backGroup.createRect({x: -cx, y: -cy, 
                                     width : pw,
                                     height: ph-1}).setStroke("gray");




 	    var c=this._getColor(state);
	    if (c=="rainbow"){
           this.rainbow.x2=state.width/2;
           this.rainbow.x1=(-cx);
		   shape.setFill(this.rainbow);
		}else{
			if (c.x2!="undefined") {
			  c.x2=state.width/2;
			  c.x1=(-cx);
			}
           shape.setFill(c);
		}

        var scaler= 100.0/state.height;  //because thats what the root does

        this._backGroup.setTransform({xx: scaler, yy: scaler, dx: 0, dy:0 });

        return this._backGroup;
    },

    _foreGroup: null,
    drawForeground: function(state){
        var ph=state.height-this._fh;
        var pw=state.width;
        var cx = state.width/2.0;
        var cy = state.height/2.0;

        if(this._foreGroup == null){
            this._foreGroup= state.group.createGroup();
        }
        this._foreGroup.clear();
        var pat;
if (document.all){ //isIE
         pat= {
           type: "pattern",
           x:0,          
           y:0,      //IE
//           y:-cy,  //firefox
           width: ((280.0*ph)/16.0)|0, //isotropic ansiotropic?
           height: ph,
           src: this.overlayName};
}else{
         pat= {
           type: "pattern",
           x:0,          
//           y:0,      //IE
           y:-cy,  //firefox
           width: ((280.0*ph)/16.0)|0, //isotropic ansiotropic?
           height: ph,
           src: this.overlayName};
}
         if (this.round)
           this._foreGroup.createRect({x: -cx, y: -cy, width: pw, height: ph-2, r: ph/2 }).setFill(pat);
         else
           this._foreGroup.createRect({x: -cx, y: -cy, width: pw, height: ph-2}).setFill(pat);
        var scaler= 100.0/state.height;  //because thats what the root does

        this._foreGroup.setTransform({xx: scaler, yy: scaler, dx: 0, dy: 0});

        return this._foreGroup;
    },


    _ticksGroup: null,
    drawTicks: function(state){
        var ph=state.height-this._fh;
        var pw=state.width;
        var cx = state.width/2.0;
        var cy = state.height/2.0;


        if (this._ticksGroup==null)
           this._ticksGroup = state.group.createGroup();
        this._ticksGroup.clear();


        var sum    = Math.abs(state.maxValue - state.minValue);
        var left= (Math.abs(state.endValue - state.minValue)/sum)*pw;
        var x=0;
        var inc = (state.majorTickSeparation/sum)*pw;
        var len= this.majorTicksLength;
        var i,shape;



        for(i=state.minValue; i<=state.maxValue; i+=state.majorTickSeparation){

              if (x!=0)
               if (this.lines){
                 shape = this._ticksGroup.createLine({x1: -cx, y1: -cy, x2: -cx, y2: len-cy})
                  .setStroke({color: this.majorTicksColor, width: 1}).setTransform({dx:x,dy:ph-len});
              }
              var st= ""+(i|0);
              align = 'middle';
              if (i==state.minValue)
                 align='start';
              if (i==state.maxValue)
                 align='end';
              if (this.values){

              var t = this._ticksGroup.createText({x: -cx+x, y:ph+this._fh-cy, text: st, align: align});
                 t.setFill(this.majorTicksColor).setFont(this.font);
              }
              x+=inc;
          }

        x=0;
        inc = (state.minorTickSeparation/sum)*pw;
        len=this.minorTicksLength;
        if (this.lines)
          for(i=state.minValue; i<=state.maxValue; i+=state.minorTickSeparation){
              if (x!=0)
                shape = this._ticksGroup.createLine({x1: -cx, y1: -cy, x2: -cx, y2: len-cy}).setStroke({color: this.minorTicksColor, width: 1}).setTransform({dx:x,dy:ph-len});
              x+=inc;
          }

        var scaler= 100.0/state.height;  //because thats what the root does

//        this._ticksGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy: -state.height});
        this._ticksGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
        return this._ticksGroup;

    },



    _needleGroup: null,
    
    _drawHalfCricle:function(x,y,radius,width, group){
				var path = group.createPath();
				var delta = Math.sqrt(radius*radius - (radius-width)*(radius-width));
				//path.moveTo(x,y-delta);
				path.moveTo(x,y+delta);
				
				path.arcTo(radius , radius, 0, 0, 0, x, y-delta);
				
				path.closePath();
				path.setStroke("white");
				path.setFill("white");
	},
    drawNeedle: function(state){
        var ph=state.height-this._fh;
        var pw=state.width;
        var cx = state.width/2.0;
        var cy = state.height/2.0;

        if(this._needleGroup == null){
          this._needleGroup= state.group.createGroup();
        }
        this._needleGroup.clear();


        var sum    = Math.abs(state.maxValue - state.minValue);
        var left   = (Math.abs(state.endValue - state.minValue) < sum) ? Math.abs(state.endValue - state.minValue) * pw / sum : pw;


        var w  = pw-left-1;
        var ww = ph;
        if ((pw-left)<=ww) //don't do it
           w=0;
        if (left<ww)
          ww=0;

        /*if (w>0){
          if (ww>0)
             this._needleGroup.createRect({x: -cx+(left+1), y: -cy+1, width:w, height: ph-2}).setFill("white");
          if (this.round)
            this._needleGroup.createRect({x: -cx+(left+1), y: -cy+1, width: w, height: ph-2, r: ph/2.0}).setFill("white");
          else
            this._needleGroup.createRect({x: -cx+(left+1), y: -cy+1, width: w, height: ph-2}).setFill("white");
        }
		if(!this.round){
        	this._needleGroup.createRect({x: -cx+(left+1), y: -cy+1, width: pw-left-1, height: (ph-2)-2}).setFill("white");
        }*/
        if(this.round){
        	if(w==0 && ww==0){
        		//a too short case
        		this._needleGroup.createRect({x: -cx+1, y: -cy+1, width: pw-2, height: ph-2,r: (ph-2)/2.0}).setFill("white");
        	}else if(ww==0){
        		//value is very small, in the left circle
        		this._needleGroup.createRect({x: -cx+1+left, y: -cy+1, width: pw-2-left, height: ph-2,r: (ph-2)/2.0}).setFill("white");
        	}else if(w==0){
        		if((pw-left) >= ww/2){
        			this._drawHalfCricle(cx-ww/2.0-1,-this._fh/2.0,ww/2.0,ww/2.0,this._needleGroup);
        			this._needleGroup.createRect({x: -cx+1+left, y: -cy+1, width: pw-2-left - ww/2, height: ph-2}).setFill("white");
        		}else{
        			this._drawHalfCricle(-cx+1+left,-this._fh/2.0,ww/2.0,pw-left-1,this._needleGroup);
        		}
        	}else{
        		this._needleGroup.createRect({x: -cx+1+left, y: -cy+1, width: pw-3-ph/2.0-left, height: ph-2}).setFill("white");
        		this._needleGroup.createRect({x: cx-ph-1, y: -cy+1, width: ph, height: ph-2,r: ph/2.0}).setFill("white");
        	}
        }else{
        	this._needleGroup.createRect({x: -cx+(left), y: -cy+1, width: pw-left-1, height: (ph)-2}).setFill("white");
        }

        //this.font.size= this._fh+"px";
        var align="end";
        i=left;
        
        
		var currentValue= state.endValue;
	    if (state.formatOptions!=null) 
             currentValue=    dojo.number.format(currentValue, state.formatOptions);
        console.log(currentValue);
        
        var maxTextLength = 0;
        maxTextLength = (""+currentValue+"").length;
        if(state.units!=null && maxTextLength < (""+state.units+"").length)maxTextLength = (""+state.units).length;
        
        console.log("(this._fh * maxTextLength / 2)",(this._fhv * maxTextLength / 2));
        if (i < (this._fhv * maxTextLength / 2) )
          align="start";
        

		if(state.units!=null){
			this._needleGroup.createText({x: -cx+i, y:-cy+(ph/2), text: ""+(currentValue)+"", 
	                               align: align}).setFill(this.vcolor).setFont(this.fontv);
	        this._needleGroup.createText({x: -cx+i, y:-cy+(5*ph/6), text: ""+state.units+"", 
	                               align: align}).setFill(this.vcolor).setFont(this.fontv);
		}else{
			this._needleGroup.createText({x: -cx+i, y:ph/2.0-cy+(this._fh/3.0), text: ""+(currentValue)+"", 
	                               align: align}).setFill(this.vcolor).setFont(this.fontv);
		}

        var scaler= 100.0/state.height;  //because thats what the root does

        this._needleGroup.setTransform({xx: scaler, yy: scaler, dx: 0, dy:0});

        return this._needleGroup;
    },
    
    
	reset: function(){
        // summary:
        //          Deletes any locally-stored shape objects when the gauge 
        //          needs to be reset.

        delete this._backGroup;
        delete this._foreGroup;
        delete this._ticksGroup;
        delete this._needleGroup;

        this._needleGroup=null;
        this._backGroup=null;
        this._foreGroup=null;
        this._ticksGroup=null;
    }
});