dojo.provide("dojox.widget.AnalogGauge2.SegmentedBarStyle");

dojo.require("dojo.fx");
dojo.require("dojo.fx.easing");
dojo.require("dojox.widget.AnalogGauge2._Style");
dojo.require("dojox.widget.AnalogGauge2"); // for the AnalogGaugeThreshold


dojo.declare("dojox.widget.AnalogGauge2.SegmentedBarStyle", [dojox.widget.AnalogGauge2._Style], {
       /**
        * font
        * maybe later used
        */
        font: {family: "Arial", style: "italic", variant: 'small-caps', weight: 'bold', size:'8px'},
        fontv: {family: "Arial", style: "italic", variant: 'small-caps', weight: 'bold', size:'8px'},
        _fh: 8,
        _fhv:8,
        fs:0,
		_spacing: 4,

    /** colorMap: Object
     *          Mapping from dojox.widget.AnalogGaugeThreshold.***_STATUS values 
     *         to colors.
	 */
        colorMap: null,
	   /**
        * to allow you to adjust the rainbow areas
        */
			garea: 0.1,
			yarea: 0.4,
			oarea: 0.7,
			rarea: 0.8,
			rainbow : {type: "linear",
					   x1: 0, y1: 0,
					   x2: 100, y2: 0,
					   colors: [{ offset: 0.1, color: "green" },
								{ offset: 0.4, color: "yellow" },
								{ offset: 0.7, color: "#D98719" },
								{ offset: 0.8, color: "red" }
							   ]
					  },
		   vrainbow : {type: "linear",
					   x1: 0, y1: 0,
					   x2: 0, y2: 400,
					   colors: [{ offset: 0.1, color: "red" },
								{ offset: 0.2, color: "#D98719" },
								{ offset: 0.5, color: "yellow" },
								{ offset: 0.8, color: "green" }
							   ]
					  },

	   /**
       * for  filling your own color
       * fillcolor="'lime'"
       * fillcolor="{'type': 'linear',
       *                 'x1': 0,
       *                 'x2': 400,
       *                 'y2': 0,
       *                 'y1': 0,
       *                 'colors': [{offset: 0, color: '#0000FF'},{offset: 1, color: 'lime'}] }"
       *
       **/
        fillcolor: null,


	   /**
        * Set the number of SegmentedBarStyles
		*/
		segments: 10,

	   /**
        * dont animate when setting values
		*/
		dontAnimate: false,
		_save: false,

	   /**
        * Set outline thickness and color, set to zero to remove outline
		*/
		outlinewidth: 1,
		outlinecolor: "black",


	   /**
        * Set the vertical otherwise horizontal by default
		*/
		vert: false,
		chicklet:0,

//		overlayName: dojo.moduleUrl("dojox.widget.AnalogGauge2.SegmentedBarStyle", "overlaySeg.png"),

    
    constructor: function(args){
       //The VML renderer has following restrictions:
       //    Linear gradient Should start and stop on a border of a shape.
	   if (document.all){ //isIE
		   this.rainbow ="blue";
		   this.vrainbow="blue";
	   }
	   dojo.mixin(this, args);
        // if the colorMap wasn't set, use a default one.
        if(this.colorMap == null){
            this.colorMap = {};
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CLEAR_STATUS         ]   = "#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NORMAL_STATUS        ]   = "green"; //#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CRITICAL_STATUS      ]   = "red"; //#e51717";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.FATAL_STATUS         ]   = "#222222";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MAJOR_STATUS         ]   = "#FFB31A";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MINOR_STATUS         ]   = "#ffff1a";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INDETERMINANT_STATUS ]   = "#2EA8E5";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NOT_APPLICABLE_STATUS]   = "#6963A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNKNOWN_STATUS       ]   = "#A6A6A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNDEFINED_STATUS     ]   = "#9294f3";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INFORMATIONAL_STATUS ]   = "#2ea8e5";
        }
	},

		/**
		 * Note you can use the word rainbow for  threshold color
		 */
		_getColor: function(state){
		  if (state.thresholds.length==0){
			  if (this.fillcolor==null) 
				   return "rainbow";
			  return this.fillcolor;
		  }
		  var statecolor=this.getThresholdFromValue(state.endValue, state.thresholds);
		  console.log("statecolor",statecolor);
		  return this.colorMap[statecolor.name];
		},

	 /**
      * private fnciton compute
      */
      _computeSizing: function(state){
        this._fh=this.fs;
		 if (this.fs==0) {

			if (state.width>state.height) 
	    	   this._fh=((state.height/6.0)|0);
			else{
	    	   this._fh=((state.width/6.0)|0);
	    	   var maxLength = (state.units+"").length;
	    	   if((state.maxValue+"9").length > maxLength)maxLength=(state.maxValue+"9").length;
	    	   if(maxLength > 6) this._fh = state.width / maxLength;
			}
	    	   
		 }

         this.font.size= this._fh+"px";
		 this._padh= this._fh;	//this._getTextBox("99").h;
   		 if (state.width>state.height) {
		    this._padh += 2;
   		 }
		 else {
  		   this._padh *= 2;
  		   this._padh += 2;
		 }
		 
		 this._topmargin=this._padh;
		 
         if (this.outlinewidth>0) {
            if (state.width>30) 
			  this._spacing=3;
            else
              if (state.width>20) 
			     this._spacing=3;
			  else
                if (state.width>10) 
				   this._spacing=2;
				else{
				   this._spacing=0;
				}

		 }else{
            if (state.width>60) 
			  this._spacing=2;
            else
  		      this._spacing=1;
		 }
		 
		 if (state.width>state.height) {
		 	this.chicklet = ( state.width / this.segments ) - this._spacing;
		 }else{
		 	this.chicklet = ( (state.height - this._topmargin) / this.segments ) - this._spacing;
		 }
	  },


    getDrawOrder: function(){
        return ["drawNeedle", "drawBackground",  "drawForeground"];
	},
	
    
    getDrawSemantics: function(){
        return {
            background: "drawBackground",
            needle: "drawNeedle",
            updateValue: "drawNeedle",
            attentionUp: ["_saveanimate", "drawBackground", "drawNeedle",  "_restoreanimate"],
            attentionDown: ["_saveanimate", "drawBackground", "drawNeedle",  "_restoreanimate"]
        };
    },
    
    _saveanimate: function(state){
		this._save=this.dontAnimate;
		this.dontAnimate=true;
	},

    _restoreanimate: function(state){
		this.dontAnimate=this._save;
	},

	_backGroup: null,
	_drawBackgroundV: function(state){
		console.log("_drawBackgroundV");
        var ph=state.height - this._topmargin;
        var pw=state.width;
		//var this.chicklet=(state.height/this.segments)-this._spacing; 
        var cx = state.width/2.0;
        var cy = state.height/2.0;
        
        console.log("ph",ph,"pw",pw,"this.chicklet",this.chicklet,"cx",cx,"cy",cy);


        if (this._backGroup==null){
           this._backGroup= state.group.createGroup();
        }
        this._backGroup.clear();
		var shape,i,y;
		y=-cy;
        --cx;
	    pw-=2;
	   for (i=0; i<this.segments; i++){
         if (this.outlinewidth>0) 
		   shape=this._backGroup.createRect({x:-cx, y: y,
                   width :pw, height: this.chicklet}).setStroke({color: this.outlinecolor, width: this.outlinewidth});
		   y+=this.chicklet+this._spacing;
	   }

	   var scaler= 100.0/state.width;  //because thats what the root does
	   this._backGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});

		return this._backGroup;
	},

	_drawBackgroundH: function(state){
		console.log("_drawBackgroundH");
        var ph=state.height - this._topmargin;
        var pw=state.width;
		//var this.chicklet=(state.width/this.segments)-this._spacing;
        var cx = state.width/2.0;
        var cy = state.height/2.0;
        
        console.log("ph",ph,"pw",pw,"this.chicklet",this.chicklet,"cx",cx,"cy",cy);


        if (this._backGroup==null){
           this._backGroup= state.group.createGroup();
        }
        this._backGroup.clear();

        var shape,i,x;
        x=-cx;
        --cy;       
		ph-=2;
	   for (i=0; i<this.segments; i++){
         if (this.outlinewidth>0) 
		   shape=this._backGroup.createRect({x: x, y:-cy, 
                   width : this.chicklet, height: ph}).setStroke({color: this.outlinecolor, width: this.outlinewidth});

		   x+=this.chicklet+this._spacing;
	   }

	   var scaler= 100.0/state.height;  //because thats what the root does
	   this._backGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
		return this._backGroup;
	},

	drawBackground: function(state){
        //this._computeSizing(state);
		if (state.width>state.height) 
    	    return this._drawBackgroundH(state);
		else
    	    return this._drawBackgroundV(state);
	},

    _foreGroup: null,
    
    _drawForegroundH: function(state){
    	var cy = state.height / 2;
    	var st = state.endValue + " " + state.units;
    	
    	if(this._foreGroup == null)
          this._foreGroup= state.group.createGroup();
        this._foreGroup.clear();
        
        var text = this._foreGroup.createText({x: 0, y: cy-1, text: st, align: "middle"});
        text.setFill(this.outlinecolor).setFont(this.font);
        
        
        var scaler= 100.0/state.height;
   	    this._foreGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
		return this._foreGroup;
    },
    
    _drawForegroundV: function(state){
    	var cy = state.height / 2;
    	var st1 = state.endValue+"";
    	var st2 = state.units+"";
    	
    	if(this._foreGroup == null)
          this._foreGroup= state.group.createGroup();
        this._foreGroup.clear();
        //alert(cy);
        var text1 = this._foreGroup.createText({x: 0, y: cy-1, text: st2, align: "middle"});
        text1.setFill(this.outlinecolor).setFont(this.font);
        var text2 = this._foreGroup.createText({x: 0, y: cy-1-this._fh, text: st1, align: "middle"})
        text2.setFill(this.outlinecolor).setFont(this.font);
        
        
        var scaler= 100.0/state.width;
   	    this._foreGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
		return this._foreGroup;
    },
    
    drawForeground: function(state){
        /*if (state.width>state.height) 
    	    return this._drawForegroundH(state);
		else
    	    return this._drawForegroundV(state);*/
    },



    _needleGroup: null,
	_drawNeedleV: function(state){
        var ph=state.height - this._topmargin;
        var pw=state.width;

		//var this.chicklet=(state.height/this.segments)-this._spacing;
        var cx = state.width/2.0;
        var cy = state.height/2.0;
        
    	var st1 = state.endValue+"";
    	var st2 = state.units+"";
    	
        if(this._needleGroup == null)
          this._needleGroup= state.group.createGroup();
        this._needleGroup.clear();
        
        var text1 = this._needleGroup.createText({x: 0, y: cy-1, text: st2, align: "middle"});
        text1.setFill(this.outlinecolor).setFont(this.font);
        var text2 = this._needleGroup.createText({x: 0, y: cy-1-this._fh, text: st1, align: "middle"})
        text2.setFill(this.outlinecolor).setFont(this.font);

		var shape,i,y;

    	y=cy-this._topmargin;
    	
    	var total = Math.abs(state.maxValue - state.minValue);
        var realendValue = Math.abs(state.endValue - state.minValue);
        var realstartValue = Math.abs(state.startValue - state.minValue);
        
        console.log("total",total,"realendValue",realendValue,"realstartValue",realstartValue);
        var c=Math.floor( realstartValue * this.segments / total ) | 0;

		var v=Math.floor( realendValue * this.segments / total ) | 0;

        var b=(realendValue * this.segments/total);
        
        console.log("in _drawNeedleV","c",c,"v",v,"b",b);
        
        console.log(1);
        if(c > this.segments)c = this.segments;
        if(v >= this.segments){
        	v=this.segments;
        	b=this.segments;
        }
        console.log(2);
        var partial= ((b-v)*this.chicklet)|0;
		var count=0;
        pw-=2;
        
        console.log("in _drawNeedleV","c",c,"v",v,"b",b,"partial",partial,"this.chicklet",this.chicklet,"endValue",state.endValue);

	   if(this.dontAnimate){
		   for (i=0; i<c; i++) {
			   y-=this.chicklet+this._spacing;
			   shape=this._needleGroup.createRect({x: -cx+2, y: y,
												 width : pw, height: this.chicklet}).setStroke(null);
               var color=this._getColor(state);
	           if (color=="rainbow"){
		          this.vrainbow.y1=-cy;
       			  this.vrainbow.y2=cy-this._topmargin;
				 shape.setFill(this.vrainbow);
		       }
               else{
				   if (color.x2!="undefined") {
					 color.x2=state.width/2;
					 color.x1=(-cx);
				   }
				 shape.setFill(color);
               }
		   }

		   shape=this._needleGroup.createRect({x: -cx+2, y: y-partial-this._spacing,
						 width : pw, height: partial}).setStroke(null);
           var color=this._getColor(state);
           if (color=="rainbow"){
	          this.vrainbow.y1=-cy;
   			  this.vrainbow.y2=cy-this._topmargin;
			  shape.setFill(this.vrainbow);
		   }
           else{
			if (color.x2!="undefined") {
			  color.x2=state.width/2;
			  color.x1=(-cx);
			}
			 shape.setFill(color);
		   }

		}else{
			i=(-1);

			if(c!=v){													 
			   var anim = new dojo._Animation({curve: [c, v], duration: 1000, easing: dojo.fx.easing.linear});
			   dojo.connect(anim, "onAnimate", dojo.hitch(this, function(step){
			   var temp= step|0;
			   if (temp!=0){
				 if (temp!=i) {
					i=temp;
                    y-=(this.chicklet+this._spacing);
					++count;

					shape=this._needleGroup.createRect({x: -cx+2, y: y,  
												   width : pw, height: this.chicklet}).setStroke(null);
                      var color=this._getColor(state);
	                  if (color=="rainbow"){
			            this.vrainbow.y1=-cy;
         			    this.vrainbow.y2=cy-this._topmargin;
					    shape.setFill(this.vrainbow);
					   }
					   else{
                 		 if (color.x2!="undefined") {
			               color.x2=state.width/2;
			               color.x1=(-cx);
			             }
						 shape.setFill(color);
					  }

				 }
			   }

			   this.valueStart=step;
			   if (step==v) {
//make sure the easing created all the this.chicklets
//if you have many animations it skips frames
				 for (i=count; i<v; i++) {
			       y-=this.chicklet+this._spacing;
			       shape=this._needleGroup.createRect({x: -cx+2, y: y,
												 width : pw, height: this.chicklet}).setStroke(null);
                   var color=this._getColor(state);
	               if (color=="rainbow"){
		             this.vrainbow.y1=-cy;
       			     this.vrainbow.y2=cy;
				     shape.setFill(this.vrainbow);
		           }
                   else{
			         if (color.x2!="undefined") {
			            color.x2=state.width/2;
			            color.x1=(-cx);
			         }
					 shape.setFill(color);
                   }
		         }
//partial
                 shape=this._needleGroup.createRect({x: -cx+2, y:y-partial-this._spacing,
						 width : pw, height: partial}).setStroke(null);
                   var color=this._getColor(state);
	               if (color=="rainbow"){
		              this.vrainbow.y1=-cy;
       			      this.vrainbow.y2=cy;
					  shape.setFill(this.vrainbow);
		         }
                 else{
			         if (color.x2!="undefined") {
			            color.x2=state.width/2;
			            color.x1=(-cx);
			         }
					shape.setFill(color);
                 }

			   }
			  }));
			  anim.play();
			}
		}
	   var scaler= 100.0/state.width;  //because thats what the root does
	   this._needleGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
	   console.log("after _drawNeedleV");
		return this._needleGroup;
	},


	_drawNeedleH: function(state){
        var ph=state.height - this._topmargin;
        var pw=state.width;
		//var this.chicklet=(state.width/this.segments)-this._spacing;
        var cx = state.width/2.0;
        var cy = state.height/2.0;
        
    	var st = state.endValue + " " + state.units;
    	
        
        

        if(this._needleGroup == null)
          this._needleGroup= state.group.createGroup();
        this._needleGroup.clear();
        
        
        var text = this._needleGroup.createText({x: 0, y: cy-1, text: st, align: "middle"});
        text.setFill(this.outlinecolor).setFont(this.font);


		var shape,i,x;
        x=-cx;
        
        var total = Math.abs(state.maxValue-state.minValue);
        var realendValue = Math.abs(state.endValue -state.minValue);
        var realstartValue = Math.abs(state.startValue -state.minValue);
        
        console.log("total",total,"realendValue",realendValue,"realstartValue",realstartValue);
        var c=Math.floor( realstartValue * this.segments / total) | 0;

		var v=Math.floor(realendValue * this.segments / total) | 0;

        var b=((realendValue*this.segments)/total);
        
        console.log("in _drawNeedleH","c",c,"v",v,"b",b);
        
        console.log(1);
        if(c > this.segments)c = this.segments;
        if(v >= this.segments){
        	v=this.segments;
        	b=this.segments;
        }
        console.log(2);
        var partial= ((b-v)*this.chicklet) | 0;
        
        
		var count=0;
		
		console.log("in _drawNeedleH","c",c,"v",v,"b",b,"partial",partial,"this.chicklet",this.chicklet,"endValue",state.endValue);

       if(this.dontAnimate){
     	   for (i=0; i<c; i++) {
			   shape=this._needleGroup.createRect({x: x, y: -cy, 
												 width : this.chicklet, height: ph}).setStroke(null);
               var color=this._getColor(state);
	           if (color=="rainbow"){
				 this.rainbow.x1=-cx;
				 this.rainbow.x2=cx;
		         shape.setFill(this.rainbow);
		       }
               else{
			         if (color.x2!="undefined") {
			            color.x2=state.width/2;
			            color.x1=(-cx);
			         }
				 shape.setFill(color);
               }
		       x+=this.chicklet+this._spacing;
		   }

		   shape=this._needleGroup.createRect({x: x, y: -cy,  
						 width : partial, height: ph}).setStroke(null);
               var color=this._getColor(state);
	           if (color=="rainbow"){
				 this.rainbow.x1=-cx;
				 this.rainbow.x2=cx;
		         shape.setFill(this.rainbow);
		   }
           else{
			         if (color.x2!="undefined") {
			            color.x2=state.width/2;
			            color.x1=(-cx);
			         }
				 shape.setFill();

		   }

		}else{
			i=(-1);
			if(c!=v){

			   var anim = new dojo._Animation({curve: [c, v], duration: 1000, easing: dojo.fx.easing.linear});
			   dojo.connect(anim, "onAnimate", dojo.hitch(this, function(step){
			   var temp= step|0;

			   if (temp!=0){
				 if (temp!=i) {
					i=temp;
					++count;
					shape=this._needleGroup.createRect({x: x, y: -cy,  
												   width : this.chicklet, height: ph}).setStroke(null);
               var color=this._getColor(state);
	           if (color=="rainbow"){
	                  this.rainbow.x1=-cx;
			          this.rainbow.x2=cx;
   		              shape.setFill(this.rainbow);
					}
					else{
				   if (color.x2!="undefined") {
					 color.x2=state.width/2;
					 color.x1=(-cx);
				   }
					  shape.setFill(color);
					}
					x+=this.chicklet+this._spacing;
				 }
			   }
			   this.valueStart=step;
			   if (step==v) {

//make sure the easing created all the this.chicklets
//if you have many animations it skips frames
				 for (i=count; i<v; i++) {
					 shape=this._needleGroup.createRect({x: x, y: -cy, 
													   width : this.chicklet, height: ph}).setStroke(null);
               var color=this._getColor(state);
	           if (color=="rainbow"){
					   this.rainbow.x1=-cx;
					   this.rainbow.x2=cx;
					   shape.setFill(this.rainbow);
					 }
					 else{
				   if (color.x2!="undefined") {
					 color.x2=state.width/2;
					 color.x1=(-cx);
				   }
					   shape.setFill(color);
					 }
					 x+=this.chicklet+this._spacing;
		         }
//partial
				 shape=this._needleGroup.createRect({x: x, y: -cy,
						 width : partial, height: ph}).setStroke(null);
               var color=this._getColor(state);
	           if (color=="rainbow"){
	                  this.rainbow.x1=-cx;
			          this.rainbow.x2=cx;
   		              shape.setFill(this.rainbow);
		         }
                 else{
				   if (color.x2!="undefined") {
					 color.x2=state.width/2;
					 color.x1=(-cx);
				   }
					shape.setFill(color);
                 }
			   }
			  }));
			  anim.play();
			}
		}
	   var scaler= 100.0/state.height;  //because thats what the root does
	   this._needleGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
	   console.log("after _drawNeedleH");
		return this._needleGroup;
    },
    

	drawNeedle: function(state){
        this._computeSizing(state);
		if (state.width>state.height) 
    	    return (this._drawNeedleH(state));
		else
    	    return (this._drawNeedleV(state));
    	
	},

    reset: function(){
        // summary:
        //          Deletes any locally-stored shape objects when the gauge 
        //          needs to be reset.

        delete this._backGroup;
        delete this._foreGroup;
        delete this._needleGroup;

        this._needleGroup=null;
        this._backGroup=null;
        this._foreGroup=null;
    }
});

