dojo.provide("dojox.widget.AnalogGauge2.SimpleBarStyle");

dojo.require("dojo.fx");
dojo.require("dojo.fx.easing");
dojo.require("dojox.widget.AnalogGauge2._Style");
dojo.require("dojox.widget.AnalogGauge2"); // for the AnalogGaugeThreshold

dojo.declare("dojox.widget.AnalogGauge2.SimpleBarStyle", [dojox.widget.AnalogGauge2._Style], {
        /**
	     * Set the display text size, if set to zero it computes the size.
		 */
    	fs: 0,

        segments: 10,
		background: "black",

    /** colorMap: Object
     *          Mapping from dojox.widget.AnalogGaugeThreshold.***_STATUS values 
     *         to colors.
	 */
        colorMap: null,

	   /**
        * font
        * maybe later used
        */
        font: {family: "Arial", style: "italic", variant: 'small-caps', weight: 'bold', size:'8px'},
        fontv: {family: "Arial", style: "italic", variant: 'small-caps', weight: 'bold', size:'8px'},
        _fh: 8,
        //_fhv:8,
		_padh: 0,
		_padw: 0,
		_topmargin: 0,


       /**
        * to allow you to adjust the rainbow areas
        */
			garea: 0.1,
			yarea: 0.4,
			oarea: 0.7,
			rarea: 0.8,
				rainbow : {type: "linear",
						   x1: 0, y1: 0,
						   x2: 100, y2: 0,
						   colors: [{ offset: 0.1, color: "green" },
									{ offset: 0.4, color: "yellow" },
									{ offset: 0.6, color: "#D98719" },
									{ offset: 0.7, color: "red" }
								   ]
					  },
		   vrainbow : {type: "linear",
					   x1: 0, y1: 0,
					   x2: 0, y2: 400,
					   colors: [{ offset: 0.1, color: "red" },
								{ offset: 0.4, color: "#D98719" },
								{ offset: 0.6, color: "yellow" },
								{ offset: 0.7, color: "green" }

							   ]
					  },

	   /**
       * for  filling your own color
       * fillcolor="'lime'"
       * fillcolor="{'type': 'linear',
       *                 'x1': 0,
       *                 'x2': 400,
       *                 'y2': 0,
       *                 'y1': 0,
       *                 'colors': [{offset: 0, color: '#0000FF'},{offset: 1, color: 'lime'}] }"
       *
       **/
        fillcolor: null,
        lines: true,
        values: true,
		_dispw: 0,
       /**
        * majorTicks control the min and max range as well as the interval
        *
        */
        majorTicksColor: 'black',
        majorTicksLength: 6,
       /**
        * minorTicks control drawing minor ticks only
        */
        minorTicksColor: "black",
        minorTicksLength: 3,


	   /**
        * dont animate when setting values
		*/
		dontAnimate: false,
		_save: false,

	   /**
        * Set outline thickness and color, set to zero to remove outline
		*/
		outlinewidth: 1,
		outlinecolor: "black",



    
    constructor: function(args){
	   dojo.mixin(this, args);
        // if the colorMap wasn't set, use a default one.
        if(this.colorMap == null){
            this.colorMap = {};
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CLEAR_STATUS         ]   = "#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NORMAL_STATUS        ]   = "green"; //#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CRITICAL_STATUS      ]   = "red"; //#e51717";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.FATAL_STATUS         ]   = "#222222";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MAJOR_STATUS         ]   = "#FFB31A";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MINOR_STATUS         ]   = "#ffff1a";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INDETERMINANT_STATUS ]   = "#2EA8E5";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NOT_APPLICABLE_STATUS]   = "#6963A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNKNOWN_STATUS       ]   = "#A6A6A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNDEFINED_STATUS     ]   = "#9294f3";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INFORMATIONAL_STATUS ]   = "#2ea8e5";
        }
	},

		measuringNode: null,
	   _getTextBox: function(text){
		   var m, s;
		   if(this.measuringNode==null){
			   m = this.measuringNode = dojo.doc.createElement("div");
			   s = m.style;
			   m.style.fontSize=this._fh;
			   m.style.fontFamily=this.font.family;
			   s.position = "absolute";
			   s.left = "-10000px";
			   s.top = "0";

			   dojo.body().appendChild(m);
		   }else{
			   m = this.measuringNode;
			   s = m.style;
			   s.fontSize=this._fh;
			   s.fontFamily=this.font.family;
		   }
		   // reset styles

		   m.className = "";
		   s.border = "0";
		   s.margin = "0";
		   s.padding = "0";
		   s.outline = "0";
		   // take a measure
		   m.innerHTML = text;
		   return dojo.marginBox(m);
	   },

	 /**
      * private function compute
      */
      _computeSizing: function(state){
         this._fh=this.fs;
		 if (this.fs==0) {

			if (state.width>state.height) 
	    	   this._fh=((state.height/6.0)|0);
			else
	    	   this._fh=((state.width/6.0)|0);
		 }

		 //this._fhv=((state.height/3.0)|0);
         //if (this._fhv<this._fh)
         //    this._fh=this._fhv;
         this.font.size= this._fh+"px";
         //this.fontv.size= this._fhv+"px";

		 this._padw= ("9"+state.maxValue).length / 2 * this._fh; //this._getTextBox("9"+state.maxValue).w;
		 this._padw2 = this._padw / 2;
		 this._padh= this._fh;	//this._getTextBox("99").h;
   		 if (state.width>state.height) {
		    this._padh += (2+this.majorTicksLength);
   		 }
		 else {
  		   this._padw += (2+this.majorTicksLength);
		 }
		 this._topmargin=this._padh;

 		if(state.width > state.height){
		 	var pw = state.width - this._padw;
		 	var sum = Math.abs(state.maxValue - state.minValue);
		 	var inc =  pw / ( sum / state.majorTickSeparation);
		 	if (inc <  (("9"+state.maxValue).length / 2 * this._fh)){
		 		this._fh = inc / ("9"+state.maxValue).length * 2;
		 		this.font.size = this._fh+"px";
		 	}
		 }else{
		 	var ph = state.height-this._padh-this._padh;
			var sum = Math.abs(state.maxValue - state.minValue);
			var inc =  ph/(sum/state.majorTickSeparation);
			if (inc < this._fh){
		 		this._fh = inc;
		 		this.font.size = this._fh+"px";
		 	}
		 }
		 
		 if(state.width < (("9"+state.maxValue+": "+state.units).length / 2 * this._fh)){
		 	this._fh = state.width / ("9"+state.maxValue+": "+state.units).length * 2;
		 	this.font.size = this._fh+"px";
		 }
		 
		  //if (state.units!=null) {
		  //  this._dispw= ("W"+state.units+": "+state.maxValue).length / 2 * this._fh;//this._getTextBox("W"+state.units+state.maxValue).w;
		  //}
		 
		 console.log("this.fs",this.fs,"this._fh",this._fh,"this._padw",this._padw,"this._padh",this._padh,
		  			"this._topmargin",this._topmargin);
	  },


    getDrawOrder: function(){
        return ["drawBackground", "drawTicks","drawNeedle"];
	},
	
    
    getDrawSemantics: function(){
        return {
            background: "drawBackground",
            needle: "drawNeedle",
            updateValue: ["drawBackground", "drawNeedle"],
            attentionUp: ["drawBackground", "drawTicks", "drawNeedle"],
            attentionDown: ["drawBackground", "drawTicks", "drawNeedle"]
        };
    },
    

    /**
     * Note you can use the word rainbow for  threshold color
	 */
	_getColor: function(state){
      if (state.thresholds.length==0){
          if (this.fillcolor==null) 
		       return "rainbow";
		  return this.fillcolor;
	  }
      var c=this.getThresholdFromValue(state.endValue, state.thresholds);
	  return this.colorMap[c.name];
	},



	_drawTicksH: function(state){

		var ph=state.height-this._padh-this._padh;
        var pw=state.width-this._padw;//-this._padw2
		var cx = state.width/2.0;
        var cy = state.height/2.0;

		var sum    = Math.abs(state.maxValue - state.minValue);
        var i,x=0;

		var inc =  pw/(sum/state.majorTickSeparation);

		var len= this.majorTicksLength;

		if (this._tickGroup==null){
           this._tickGroup= state.group.createGroup();
        }
        this._tickGroup.clear();

		var shape;

		for(i=state.minValue; i<=state.maxValue; i+=state.majorTickSeparation){

			   if (this.lines){
                 shape = this._tickGroup.createLine({x1: x, y1: 0, x2: x, y2: len})
                  .setStroke({color: this.majorTicksColor, width: 1})
                  .setTransform({dx:-cx,dy:cy-this._padh});
               }

			  var st= ""+(i|0);

			  var align='middle';
			  if (i==state.minValue) 
			     align='start';

			  if (this.values){
                var t = this._tickGroup.createText({x: -cx+x, y: cy, text: st, align: align});
                 t.setFill(this.majorTicksColor).setFont(this.font);
              }

			  x+=inc;
		  }
        var scaler= 100.0/state.height;  //because thats what the root does
   	    this._tickGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
		return this._tickGroup;
	},

	_drawTicksV: function(state){
        var ph=state.height-this._padh-this._padh;
        var pw=state.width-this._padw;
		var cx = state.width/2.0;
        var cy = state.height/2.0;

		var sum    = Math.abs(state.maxValue - state.minValue);
        var y=ph+this._padh;

		var i,inc =  ph/(sum/state.majorTickSeparation);

		var len= this.majorTicksLength;

		if (this._tickGroup==null){
           this._tickGroup= state.group.createGroup();
        }
        this._tickGroup.clear();

		var shape;

		for(i=state.minValue; i<=state.maxValue; i+=state.majorTickSeparation){
  			   if (this.lines){
                 shape = this._tickGroup.createLine({x1: 0, y1: y, x2: len, y2: y})
                  .setStroke({color: this.majorTicksColor, width: 1})
                  .setTransform({dx:cx-this._padw,dy:-cy});
               }
              var st= ""+(i|0);

			  var align='start';
			  if (this.values){
                var t = this._tickGroup.createText({x: cx-this._padw+len, y:(-cy+y+5), text: st, align: align});
                 t.setFill(this.majorTicksColor).setFont(this.font);
              }

			  y-=inc;
		  }
	   var scaler= 100.0/state.width;  //because thats what the root does
	   this._tickGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
       return  this._tickGroup;
	},


	_backGroup: null,
	_drawBackgroundV: function(state){
        var ph=state.height-this._padh;
        var pw=state.width-this._padw;
        var cx = state.width/2.0;
        var cy = state.height/2.0;


		if (this._backGroup==null){
           this._backGroup= state.group.createGroup();
        }
        this._backGroup.clear();
        var base= state.maxValue-state.minValue;

		var index= (ph*state.endValue-state.minValue)/base;




		var shape=this._backGroup.createRect({x:-state.width/2.0+1, y:-state.height/2.0,
                   width : pw-2, height: ph, r:2})
				   .setFill(this.background)
                   .setStroke({color: this.background, width: this.outlinewidth});

		ph-=this._padh;
		var i,y;
		y=-cy;
        --cx;
	    pw-=2;
   	   shape=this._backGroup.createRect({x:-cx+3, y: y+this._padh,
                   width :pw-6 > 0 ? pw-6 : 1, height: ph-1, r: 2}); //.setStroke({color: this.outlinecolor, width: this.outlinewidth});
		   var c=this._getColor(state);
		   if (c=="rainbow"){
  		     this.vrainbow.y1=-cy;
   		     this.vrainbow.y2=cy;
   		     shape.setFill(this.vrainbow);
		   }else{
			 shape.setFill(c);
		   }


         var chicklet=ph/this.segments;
         var i,y;
		 y=-cy;
		 for (i=0; i<this.segments; i++){
			if (this.outlinewidth>0) 
			  shape=this._backGroup.createRect({x:-cx, y: y+this._padh,
					  width :pw, height: chicklet}).setStroke({color: this.background, width: this.outlinewidth});
			  y+=chicklet;
		 }


	   var scaler= 100.0/state.width;  //because thats what the root does
	   this._backGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
       return this._backGroup;
	},

	_tickGroup: null,
	drawTicks: function(state){
	  if (state.width>state.height) 
	     return this._drawTicksH(state);
      return this._drawTicksV(state);
	},



	_drawBackgroundH: function(state){
        var ph=state.height-this._padh-this._topmargin;
        var pw=state.width; 
        var cx = state.width/2.0;
        var cy = state.height/2.0;

		if (this._backGroup==null){
           this._backGroup= state.group.createGroup();
        }
        this._backGroup.clear();
        var base= state.maxValue-state.minValue;



		var shape=this._backGroup.createRect({x:-state.width/2.0+1, y:-state.height/2.0+this._topmargin,
						 width : pw-2, height: ph, r:2})
						 .setFill(this.background)
						 .setStroke({color: this.outlinecolor, width: this.outlinewidth});


		pw-=this._padw;
		console.log("in SimpleBarStyle before createRect","ph=",ph,"pw=",pw,"-state.height/2.0 + 3 + this._topmargin=",-state.height/2.0 + 3 + this._topmargin);
	   shape=this._backGroup.createRect({
	   			x:-state.width/2.0 + 3, 
	   			y: -state.height/2.0 + 3 + this._topmargin,
                width : pw > 2 ? pw-2 : 1, 
                height: ph > 6 ? ph-6 : 1, 
                r: 2
                });
           console.log("in SimpleBarStyle after createRect");
		   var c=this._getColor(state);
		console.log("in SimpleBarStyle after _getColor");
		   if (c=="rainbow"){
  		     this.rainbow.x1=-cx;
   		     this.rainbow.x2=cx;
   		     console.log("in SimpleBarStyle before setFill with rainbow");
   		     shape.setFill(this.rainbow);
   		     console.log("in SimpleBarStyle after setFill with rainbow");
		   }else{
             console.log("in SimpleBarStyle before setFill with color");
             shape.setFill(c);
             console.log("in SimpleBarStyle after setFill with color");
		   }
		   var chicklet=((pw > 2 ? pw-2 : 1)/this.segments);
		   var  i,x;
		   x=-cx+3;
		   for (i=0; i<this.segments; i++){
			 if (this.outlinewidth>0) 
				shape=this._backGroup.createRect({x: x, y:-state.height/2.0+3+this._topmargin, 
					  width : chicklet, height: ph > 6 ? ph-6 : 1}).setStroke({color: this.background, width: this.outlinewidth});

			  x+=chicklet;
		 }


	   var scaler= 100.0/state.height;  //because thats what the root does
	   this._backGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
       return this._backGroup;
	},

	drawBackground: function(state){
        this._computeSizing(state);
		if (state.width>state.height) 
			return (this._drawBackgroundH(state));
  	    return (this._drawBackgroundV(state));
	},



    _needleGroup: null,
	_drawNeedleV: function(state){
        var ph=state.height-this._padh-this._padh;
        var pw=state.width-this._padw;
		var cx = pw/2.0;
        var cy = ph/2.0;
        var base= state.maxValue-state.minValue;
        var index= (ph*(state.endValue-state.minValue))/base;



		if(this._needleGroup == null)
          this._needleGroup= state.group.createGroup();
        this._needleGroup.clear();




		var shape=this._needleGroup.createRect({x:-state.width/2, y:-state.height/2.0,
                   width : pw-2, height: ph-index+this._padh, r:2})
				   .setFill(this.background);

		//var scaler= 100.0/state.width;  //because thats what the root does
	    //this._needleGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});

		var st="";//+state.endValue;
		var t;
	 	if (state.units!=null) {
 		  st+=state.units+": "+state.endValue;
		}else {
			st+=state.endValue;
		}
	    t = this._needleGroup.createText({x: -state.width/2, y:cy+this._padh, text: st, align: 'start'});
        t.setFill(this.majorTicksColor).setFont(this.font);
        
        var scaler= 100.0/state.width;  //because thats what the root does
	    this._needleGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
		return  this._needleGroup;
	},



	_drawNeedleH: function(state){
        var ph=state.height-this._padh-this._topmargin;
        var pw=state.width-this._padw;//-this._padw2
		var cx = state.width/2.0;
        var cy = state.height/2.0;
        var base= state.maxValue-state.minValue;
        var index= (pw*(state.endValue-state.minValue))/base;



		if(this._needleGroup == null)
          this._needleGroup= state.group.createGroup();
        this._needleGroup.clear();




		var shape=this._backGroup.createRect({x:-state.width/2.0, y:-state.height/2.0+this._topmargin+1,
				   width : pw-index+1, height: ph-2, r:2})
                   .setFill(this.background);

	    shape.setTransform({xx: 1, yy: 1, dx:state.width-(pw-index)-this._padw/*this._padw2*/, dy:0});



		var st="";//+state.endValue;
        if (state.units!=null) {
		  st+=state.units+": "+state.endValue;
	      t = this._needleGroup.createText({x: cx, y: -cy+this._topmargin-1/*this._padh/2.0+1+this.majorTickslength*/, text: st, align: 'end'});
		}else{
			st+=state.endValue;
			t = this._needleGroup.createText({x: cx, y: -cy+this._padh/2.0+1, text: st, align: 'end'});
		}
    	t.setFill(this.majorTicksColor).setFont(this.font);

		var scaler= 100.0/state.height;  //because thats what the root does
	    this._needleGroup.setTransform({xx: scaler, yy: scaler, dx:0, dy:0});
		return  this._needleGroup;
    },
    

	drawNeedle: function(state){
		if (state.width>state.height) 
    	    return (this._drawNeedleH(state));
   	    return (this._drawNeedleV(state));
	},

    reset: function(){
        // summary:
        //          Deletes any locally-stored shape objects when the gauge 
        //          needs to be reset.

        delete this._backGroup;
        delete this._needleGroup;
        delete this._tickGroup;

        this._needleGroup=null;
        this._backGroup=null;
        this._foreGroup=null;
    }
});

