dojo.provide("dojox.widget.AnalogGauge2.SimpleButtonStyle");

//dojo.require("dojo.fx");
//dojo.require("dojo.fx.easing");
dojo.require("dojox.widget.AnalogGauge2._Style");


dojo.declare("dojox.widget.AnalogGauge2.SimpleButtonStyle", [dojox.widget.AnalogGauge2._Style], {
	_height:62,
	_width:62,
	textFont: {family: 'Verdana',weight:'bold'},
	textColor: "#f5f5f5",
	_textX:0,
	_textY:0,
	_textSize:50,
	_scaler:1,
	_backImage: "",
	

    constructor: function(args){
		dojo.mixin(this, args);
	},


	/**
	 * private fnciton compute
	 */
    _computeSizing: function(state){
		//status
		var status = this.getThresholdFromValue(state.endValue, state.thresholds).status;
		
		//compute width & height 
		if(status == "Not Applicable"){
			if(state.height>state.width*0.5688){
				this._width = state.width;
				this._height = state.width*0.5688;
			}
			else{
				this._width = state.height/0.5688;
				this._height = state.height;
			}
		}
		else{
			if(state.width>state.height){
				this._width = state.height;
				this._height = state.height;
			}
			else{
				this._width = state.width;
				this._height = state.width;
			}
		}
		
		//compute the backgroud image, number positiion/style
		if(status == "Clear"){
			this._backImage = "simple_clear.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
		}
		else if(status == "Normal"){
			this._backImage = "simple_normal.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
		}
		else if(status == "Critical"){
			this._backImage = "simple_critical.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
		}
		else if(status == "Fatal"){
			this._backImage = "simple_fatal.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
		}
		else if(status == "Major"){
			this._backImage = "simple_major.png";
			this._textX=0;
			this._textY=this._height*0.05;
			this._textSize = 45;
		}
		else if(status == "Minor"){
			this._backImage = "simple_minor.png";
			this._textX=0;
			this._textY=this._height*0.35;
			this._textSize = 45;
		}
		else if(status == "Indeterminant"){
			this._backImage = "simple_indeterminant.png";
			this._textX=0;
			this._textY=this._height*0.15;
			this._textSize = 45;
		}
		else if(status == "Not Applicable"){
			this._backImage = "simple_not_applicable.png";
			this._textX=0;
			this._textY=this._height*0.3;
			this._textSize = 40;
		}
		else if(status == "Unknown"){
			this._backImage = "simple_unknown.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 45;
		}
		else if(status == "Undefined"){
			this._backImage = "simple_undefined.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 45;
		}
		else if(status == "Informational"){
			this._backImage = "simple_informational.png";
			this._textX=0;
			this._textY=this._height*0.2;
			this._textSize = 50;
		}
		
		//compute scaler
		if(state.width>state.height){
			this._scaler = 100.0/state.height;
		}
		else{
			this._scaler = 100.0/state.width;
		}

    },

    getDrawOrder: function(){
        return ["drawBackground",  "drawForeground", "drawText"];
	},
    
    getDrawSemantics: function(){
        return {
            background: "drawBackground",
            foreground: "drawForeground",
			text: "drawText",
            updateValue: ["drawBackground", "drawForeground", "drawText"]
        };
    },

	
	_backGroup: null,

	drawBackground: function(state){
		
		this._computeSizing(state);
		
		var cx = this._width*0.5;
        var cy = this._height*0.5;
		
		if (this._backGroup==null){
           this._backGroup= state.group.createGroup();
        }
        this._backGroup.clear();
		
		//draw high light
		var background = this._backGroup.createImage({
			x: -cx, y: -cy, 
			width: this._width, height: this._height, 
			src: dojo.moduleUrl("dojox.widget.AnalogGauge2.SimpleButtonStyle", this._backImage)
		});
		
		this._backGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
		return this._backGroup;
		
	},

	
    _foreGroup: null,
    drawForeground: function(state){
        
    },

	
	/**
     *  draw lable and value
     */
    _textGroup: null,
    drawText: function(state){
		if (this._textGroup == null) {
			this._textGroup = state.group.createGroup();
		}
		this._textGroup.clear();
		
		var value = this._textGroup.createText({
			x: this._textX,
			y: this._textY,
			text: state.endValue,
			align: "middle"
		}).setFill(this.textColor);
		this.textFont.size=this._textSize*this._width/100;
		value.setFont(this.textFont);
		//value.setStroke({color:"#c0c0c0",width:1});
		value.setStroke({color:"#61671d",width:1});
		
		this._textGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
		return this._textGroup;
	},

    reset: function(){
        // summary:
        //          Deletes any locally-stored shape objects when the gauge 
        //          needs to be reset.

        delete this._backGroup;
        delete this._foreGroup;
		delete this._textGroup;

        this._backGroup=null;
        this._foreGroup=null;
		this._textGroup=null; 
    }
});