dojo.provide("dojox.widget.AnalogGauge2.SimpleStyle");

dojo.require("dojo.fx");
dojo.require("dojo.fx.easing");
dojo.require("dojox.widget.AnalogGauge2._Style");
dojo.require("dojox.widget.AnalogGauge2"); // for the AnalogGaugeThreshold

dojo.declare("dojox.widget.AnalogGauge2.SimpleStyle", dojox.widget.AnalogGauge2._Style, {
    /** colorMap: Object
     *          Mapping from dojox.widget.AnalogGaugeThreshold.***_STATUS values 
     *         to colors.
	 */
        colorMap: null,
	/**
     * parms are 'ltr' and 'rtl'
	 */
	 dir: 'ltr',      
	/**
     * Slicecolors when set to 'rainbow' will produce a rainbow gauge with black ring
     * when set to 'rainbowx' it will  produce a rainbow gauge without a black ring
     * when set to an array of values it will produce a slice colored gauge
     * when set to null it will not do slice coloring.
     */
    //slicecolors: ['#808080','#909090', '#A0A0A0','#B0B0B0','#C0C0C0','#D0D0D0','#E0E0E0'],
    //slicecolors: 'rainbow',
    //slicecolors: 'rainbowx',
    slicecolors: null,
    dontAnimate: false,
    /**
     * Show the full circle body of the gauge.
     */
    fullbody: false,
	_height: 0,

    /**
     * font
     * The size is really chosen for you.
     */
    font: {family: "Arial", weight: 'bold', size:'12px'},
    displaytextfont: {family: "Arial", weight: 'bold', size:'12px'},

    trend: false,   //missing in the AnalogGauge2 to turn on
    trendvalue: 0,   //missing in the AnalogGauge2 
    ceiling: false,   //missing in the AnalogGauge2
    ceilvalue: 0,  //missing in the AnalogGauge2


    /**
     *  Set tolerance for enable look
     */
    enamel: 35,
    /**
     * Body start and end angle
     */
    startAngle: -120,
    endAngle: 120,
    needlewidth: 2,
    /**
     *  Gauge color
     */
    gcolor: 'black',
   /**
    *  Needle color
    */
    ncolor: 'red',

   /**
    *  text value color
    */
    tcolor: 'black',

   /**
    *  MarkerNeedle color
    */
     mncolor: 'black',

   /**
    *  Turn needle marker off
    */
    mark:  false,
    markerValue: 0,
   _markerStart: 0,

    /**
     * Leap colors not in  AnalogGauge2
     */
    leapgcolor:     'none',  //change leap color gauge
    leapmajorcolor: 'none',  //change leap color major ticks
    leapminorcolor: 'none',  //change leap color minor ticks
    leapncolor: 'none',      //change leap color needle color
    _savecolor: {gcolor: 'black', major: 'none', minor: 'none', ncolor: 'none'},

    _leapstart: false,
	/**
     *  Your can set the top margin of the gauge in the bounding box
     */
    _topmargin: 0,

    /**
     * Control the illumination of the rainbow coloring
     * This value varies from  0.0 to 1.0
     */
    illumination: 0.80,

    //temporary
    cx: 0,
    cy:0,
    radius: 50,
    _fontw: 21,
    _fontsize: 10,

    
    /**
     * Ticks style
     */
    majorTicksColor: 'white',
    majorTicksLines: true,
    majorTicksLength: 10,

    minorTicksColor: 'white',
    minorTicksLines: true,
    minorTicksLength: 5,

    constructor: function(args){
        dojo.mixin(this, args);
        // if the colorMap wasn't set, use a default one.
        if(this.colorMap == null){
            this.colorMap = {};
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CLEAR_STATUS         ]   = "#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NORMAL_STATUS        ]   = "green"; //#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CRITICAL_STATUS      ]   = "red"; //#e51717";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.FATAL_STATUS         ]   = "#222222";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MAJOR_STATUS         ]   = "#FFB31A";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MINOR_STATUS         ]   = "#ffff1a";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INDETERMINANT_STATUS ]   = "#2EA8E5";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NOT_APPLICABLE_STATUS]   = "#6963A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNKNOWN_STATUS       ]   = "#A6A6A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNDEFINED_STATUS     ]   = "#9294f3";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INFORMATIONAL_STATUS ]   = "#2ea8e5";
        }
//testing
//this.dir='ltr';      
    this._savecolor.gcolor= this.gcolor, 
	this._savecolor.major= this.majorTicksColor, 
    this._savecolor.minor= this.minorTicksColor, 
    this._savecolor.ncolor= this.ncolor;
 
	this.leapgcolor    = this.gcolor;
    this.leapmajorcolor= this.majorTicksColor;
    this.leapminorcolor= this.minorTicksColor;
    this.leapncolor    = this.ncolor;
	},


	/**
	 * Note you can use the word rainbow for  threshold color
	 */
	_getColor: function(state){
		  if (state.thresholds.length==0)
			  return this.gcolor;
		  var c=this.getThresholdFromValue(state.endValue, state.thresholds);
		  return this.colorMap[c.name];
	},

	getDrawOrder: function(){
        return ["drawBacking", "drawTicks", "drawNeedle", "drawText", "drawHighlight", "flip"];
    },
    
    getDrawSemantics: function(){
        return {
            background: ["drawBacking"],
            ticks: "drawTicks",
            needle: "drawNeedle",
            foreground: "drawHighlight",
            textDisplay: "drawText",
            updateValue: ["drawBacking", "setMarker", "drawNeedle", "drawText"],
            attentionUp: [ "beforeLeap","drawBacking", "drawTicks", "drawNeedle", "drawText", "drawHighlight"],
            attentionDown: ["afterLeap", "drawBacking", "drawTicks", "drawNeedle", "drawText", "drawHighlight"]
        };
    },
    
    reset: function(){
        // summary:
        //          Deletes any locally-stored shape objects when the gauge 
        //          needs to be reset.
        

        delete this._backGroup;
        delete this._highGroup;
        delete this._needle;
        delete this._needleGroup;
        if (this._markneedle!=null){
          delete this._markneedle;
          delete this._markneedleGroup;
        }
        delete this._textDisplay;
        delete this._textGroup;
        delete this._tickGroup;


        this._backGroup = null;
        this._highGroup = null;
        this._needle = null;
        this._needleGroup = null;
        this._markneedle= null;
        this._markneedleGroup=null;
        this._textDisplay = null;
        this._textGroup = null;
        this._tickGroup = null;
    },
    

    
    flip: function(state){

	},

    /**
     *
     */
    _highGroup: null,
    drawHighlight: function(state){

        if (this._highGroup==null){
           this._highGroup = state.group.createGroup();
        }

        var result = this._highGroup;
        result.clear();


        if  ((this.startAngle<=-90) && ( this.endAngle>=90) ){
           var mod;
           if (state.width <= 48)
              mod= dojo.moduleUrl("dojox.widget.AnalogGauge2.SimpleStyle","gaugeOpalsmall.png");
           else
              mod= dojo.moduleUrl("dojox.widget.AnalogGauge2.SimpleStyle","gaugeOpal.png");
           var img = result.createImage({
                x: -50, y: -50, 
                width: 100, height: 50, 
                src: mod
            });
           return result;
        }
        //really prototype to resolve the highlight of 
        var a1 = this._getRadians(this.startAngle);
        var a2 = this._getRadians(this.endAngle);
        var rad=this.radius;
        var x1=this.cx+rad*Math.sin(a1);
        var y1=this.cy-rad*Math.cos(a1);
        var x2=this.cx+rad*Math.sin(a2);
        var y2=this.cy-rad*Math.cos(a2);
        var big=0;
        
        if((a2 - a1) > Math.PI){
            big=1;
        }
        
        shape = result.createPath();
        shape.moveTo(this.cx,this.cy);
        shape.lineTo(x1,y1);
        shape.arcTo(rad,rad,0,big,1,x2,y2);
        
        var patbase= {
            type: "pattern",
            x:0,          
            y:0,
            width:  100,
            height: 100,
            src: dojo.moduleUrl("ibm.tivoli.widget.gauge.SimpleGauge","gaugeOpal.png")
        };
        
        shape.closePath().setFill(patbase);
        
        return result;
    },

    //
    // Slice body
    //
    _slicebody: function(group){
        var a1 = this._getRadians(this.startAngle);
        var a2 = this._getRadians(this.endAngle);
        var len = this.slicecolors.length;
        var z= (Math.abs(a1)+ Math.abs(a2))/len;
        var rad=this.radius;

        for (var i = 0; i<len; i++){
            a2 = a1+z;
            var x1 = this.cx+rad*Math.sin(a1);
            var y1 = this.cy-rad*Math.cos(a1);
            var x2 = this.cx+rad*Math.sin(a2);
            var y2 = this.cy-rad*Math.cos(a2);
            var big=0;
            if((a2 - a1) > Math.PI){
                big=1;
            }
            shape = group.createPath();
            shape.moveTo(this.cx,this.cy);
            shape.lineTo(x1,y1);
            shape.arcTo(rad,rad,0,big,1,x2,y2);
            var ccc=this.slicecolors[i];

            shape.closePath().setFill(ccc).setStroke(ccc);
            a1=a2;
        }
    },


    //
    // Draw rainbow body
    //
    _rainbowbody: function(group){
        var a1 = this._getRadians(this.startAngle);
        var a2 = this._getRadians(this.endAngle);
        var z= (Math.abs(a1) + Math.abs(a2)) / 68.0;
        var r = 0,
            g = 0,
            b = 255;
        
        var rad = this.radius - 5;
        if (this.slicecolors == 'rainbowx'){
            rad = this.radius;
        }
        
        for (var i = 0; i < 17; i++){
            a2=a1+z;
            var x1 = this.cx+rad*Math.sin(a1);
            var y1 = this.cy-rad*Math.cos(a1);
            var x2 = this.cx+rad*Math.sin(a2);
            var y2 = this.cy-rad*Math.cos(a2);
            var big = 0;
            if((a2 - a1) > Math.PI){
                big=1;
            }
            shape = group.createPath();
            shape.moveTo(this.cx, this.cy);
            shape.lineTo(x1, y1);
            shape.arcTo(rad, rad, 0, big, 1, x2, y2);
            var ccc = new dojo.Color([ r|0, (g*this.illumination)|0,(b*this.illumination)|0 ]);
            g += 15;
            shape.closePath().setFill(ccc).setStroke(ccc);
            shape.setTransform({dx: 0, dy: this._topmargin});
            a1 = a2;
        }
        
        for (var i = 0; i < 17; i++){
            a2 = a1+z;
            var x1 = this.cx+rad*Math.sin(a1);
            var y1 = this.cy-rad*Math.cos(a1);
            var x2 = this.cx+rad*Math.sin(a2);
            var y2 = this.cy-rad*Math.cos(a2);
            var big=0;
            if((a2 - a1) > Math.PI){
                big = 1;
            }
            shape = group.createPath();
            shape.moveTo(this.cx,this.cy);
            shape.lineTo(x1,y1);
            shape.arcTo(rad,rad,0,big,1,x2,y2);
            var ccc = new dojo.Color([ r|0, (g*this.illumination)|0,(b*this.illumination)|0 ]);
            b -= 15;
            shape.closePath().setFill(ccc).setStroke(ccc);
            shape.setTransform({dx: 0, dy: this._topmargin});
            a1 = a2;
        }
        
        for (var i=0; i<17; i++){
            a2 = a1+z;
            var x1 = this.cx+rad*Math.sin(a1);
            var y1 = this.cy-rad*Math.cos(a1);
            var x2 = this.cx+rad*Math.sin(a2);
            var y2 = this.cy-rad*Math.cos(a2);
            var big = 0;
            if((a2-a1) > Math.PI){
                big=1;
            }
            shape = group.createPath();
            shape.moveTo(this.cx,this.cy);
            shape.lineTo(x1,y1);
            shape.arcTo(rad,rad,0,big,1,x2,y2);
            var ccc=new dojo.Color([ (r*this.illumination)|0, (g*this.illumination)|0,(b*this.illumination)|0 ]);
            r += 15;
            shape.closePath().setFill(ccc).setStroke(ccc);
            shape.setTransform({dx: 0, dy: this._topmargin});
            a1 = a2;
        }
        
        for (var i=0; i<17; i++){
            a2 = a1+z;
            var x1 = this.cx+rad*Math.sin(a1);
            var y1 = this.cy-rad*Math.cos(a1);
            var x2 = this.cx+rad*Math.sin(a2);
            var y2 = this.cy-rad*Math.cos(a2);
            var big = 0;
            if((a2 - a1) > Math.PI){
                big=1;
            }
            shape = group.createPath();
            shape.moveTo(this.cx,this.cy);
            shape.lineTo(x1,y1);
            shape.arcTo(rad, rad, 0, big, 1, x2, y2);
            var ccc = new dojo.Color([ (r*this.illumination)|0, (g*this.illumination)|0,(b*this.illumination)|0 ]);
            g -= 15;
            shape.closePath().setFill(ccc).setStroke(ccc);
            shape.setTransform({dx: 0, dy: this._topmargin});
            a1 = a2;
        }
    },


    _getAngle: function(/*Number*/value, min, max){
        return (value - min)/(max - min)*(this.endAngle - this.startAngle) + this.startAngle;
    },
    
    _getRadians: function(/*Number*/angle){
        return angle*Math.PI/180;
    },


    setMarker: function(state){
     var v = state.endValue;
	 if (v>this.markerValue){
        this._markerStart= this.markerValue;
        this.markerValue=v;
     }
    },

	beforeLeap: function(state){
     if (this._leapstart) 
	   return;
     this._leapstart=true;
	 this._savecolor.gcolor= this.gcolor; 
     this._savecolor.major = this.majorTicksColor; 
     this._savecolor.minor = this.minorTicksColor; 
     this._savecolor.ncolor= this.ncolor;


	 this.gcolor         = this.leapgcolor;    
     this.majorTicksColor= this.leapmajorcolor;
     this.minorTicksColor= this.leapminorcolor;
     this.ncolor         = this.leapncolor;
	},

	afterLeap: function(state){
     var v = state.minValue;
     this._markerStart=this.markerValue;
     this.markerValue=v;

     this._leapstart=false;
	 this.gcolor         = this._savecolor.gcolor;  
	 this.majorTicksColor= this._savecolor.major;
     this.minorTicksColor= this._savecolor.minor;
     this.ncolor         = this._savecolor.ncolor;
  	},

    _backGroup: null,
    drawBacking: function(state){
        if (this._backGroup==null){
           this._backGroup= state.group.createGroup();
		}
		var result = this._backGroup;
        var shape;

        result.clear();
        var c=this._getColor(state);

		if (dojo.isArray(this.slicecolors)){
            this._slicebody(result);
        } else {        
            if (this.fullbody){
                shape= result.createCircle({cx: 0, cy: 0, r:this.radius}).setFill(c);
            } else {
        
                var a1 = this._getRadians(this.startAngle);
                var a2 = this._getRadians(this.endAngle);
                
                var x1=this.cx+this.radius*Math.sin(a1); 
                
                var y1=this.cy-this.radius*Math.cos(a1);
                var x2=this.cx+this.radius*Math.sin(a2);
                var y2=this.cy-this.radius*Math.cos(a2);
                var big=0;
                if((a2-a1)>Math.PI){big=1;}
                shape = result.createPath();
                shape.moveTo(this.cx,this.cy);
                shape.lineTo(x1,y1);
                shape.arcTo(this.radius,this.radius,0,big,1,x2,y2);
                shape.closePath().setFill(c);
            
                if((this.slicecolors != null) && (typeof(this.slicecolors) == 'string') && (this.slicecolors.substr(0,7) == 'rainbow')){
                    this._rainbowbody(result);
                }
            }
        }
        
        return result;
    },
    
    computefont: function(){
        var f = 0;
        this.majorTicksLines = true;
        this.minorTicksLines = true;
        this.needlewidth = 2;
        
        this._fontw=21;
        this.gap=10;
        if (this.radius <= 60) {
            this._fontw=16;
        }
        if (this.radius >= 125) {
            this._fontw=25;
        }
        
        if (this.radius <= 20) {
            f = 3;
            this.gap = 4;
            this.needlewidth = 1;
            this._fontw = 0;
            this.majorTicksLines = false;
            this.minorTicksLines = false;
        } else if (this.radius <= 30) {
            f = 4;
            this.gap = 5;
            this._fontw = 9;
            this.majorTicksLength = 6;
            this.majorTicksLines = true;
            this.minorTicksLength = 2;
            this.minorTicksLines = true;
        } else if (this.radius<=40) {
            f = 4;
            this.majorTicksLength = 6;
            this.minorTicksLength = 2;
        } else if (this.radius<=60) {
            f=6;
        } else if (this.radius<=70) {
            f=8;
        } else{
            this.needlewidth=4;
            if (this.radius<=100){
                f=12;
            } else if (this.radius<=125){
                f=14;
            } else if (this.radius<=150){
                f=16;
            } else {
                f=16;
            }
        }
        this.font.size= f+"px";
    },


	 measuringNode: null,
	_getTextBox: function(text){
		var m, s;
		if(this.measuringNode==null){
			m = this.measuringNode = dojo.doc.createElement("div");
			s = m.style;
			m.style.fontSize=this.displaytextfont.size;
            m.style.fontFamily=this.displaytextfont.family;
			s.position = "absolute";
			s.left = "-10000px";
			s.top = "0";

			dojo.body().appendChild(m);
		}else{
			m = this.measuringNode;
			s = m.style;
		}
		// reset styles

		m.className = "";
		s.border = "0";
		s.margin = "0";
		s.padding = "0";
		s.outline = "0";
		// take a measure
		m.innerHTML = text;
		return dojo.marginBox(m);
	},


    _setTicks: function(state,group){
        var st;
        var a,i;
        //works like crap
        //though I would love to use it.
        //   var fontw=dojox.gfx._base._getTextBox("000", {font: this.font}).w;
        var rad = this.radius;

        fontw = this._fontw;
        var f = parseInt(this.font.size);
        //            var r=this.radius-10-f;
        //this.gap=5;


        if (state.width <= this.enamel){
          return;
        }


        var r = rad-this.gap-f;
        var rr = rad-this._fontw-f;
        var x, y;
        var shape;
        if (this.ceiling == true){
            a = this._getAngle(this.ceilvalue, state.minValue, state.maxValue);
            x = this.cx+rr*Math.sin(this._getRadians(a));
            y = this.cy+this._topmargin-rr*Math.cos(this._getRadians(a));
            group.createCircle({cx: x, cy: y, r: f/2.0}).setFill("red");
        }


        for(i = state.minValue; i <= state.maxValue; i += state.minorTickSeparation){
            a = this._getAngle(i, state.minValue, state.maxValue);
            if (this.minorTicksLines){
                shape = group.createLine({x1: 0, y1: 0, x2: 0, y2: this.minorTicksLength}).setStroke({color: this.minorTicksColor, width: 1});
                x = this.cx+rr*Math.sin(this._getRadians(a));
                y = this.cy+this._topmargin-rr*Math.cos(this._getRadians(a));
                shape.setTransform([{dx:x,dy:y}, dojox.gfx.matrix.rotateg(a)]);
            }
        }


        if (this.trend){
            var len = this.majorTicksLength*2;
            a = this._getAngle(this.trendvalue, state.minValue, state.maxValue);
            shape = group.createLine({x1: 0, y1: 0, x2: 0, y2: len}).setStroke({color: this.majorTicksColor, width: 2});
            x = this.cx+rr*Math.sin(this._getRadians(a));
            y = this.cy+this._topmargin-rr*Math.cos(this._getRadians(a));
            shape.setTransform([{dx:x,dy:y}, dojox.gfx.matrix.rotateg(a)]);
        }


        for(i = state.minValue; i <= state.maxValue; i += state.majorTickSeparation){  //this.majorTicks.interval){
            a = this._getAngle(i, state.minValue, state.maxValue);
            if(this.majorTicksLines){
                shape = group.createLine({x1: 0, y1: 0, x2: 0, y2: this.majorTicksLength}).setStroke({color: this.majorTicksColor, width: 1});
                x = this.cx+rr*Math.sin(this._getRadians(a));
                y = this.cy+this._topmargin-rr*Math.cos(this._getRadians(a));
                shape.setTransform([{dx:x,dy:y}, dojox.gfx.matrix.rotateg(a)]);
            }
            
            
            x = this.cx+r*Math.sin(this._getRadians(a));
            y = this.cy+this._topmargin-r*Math.cos(this._getRadians(a));
            var align = 'middle';
            st = ""+i;
            //var foo=(fonth/2.0)*Math.cos(this._getRadians(a));
            if(i == state.minValue){
                align = 'end';
            }
            if(i == state.maxValue){
                align = 'start';
            }
            
            if (this.dir=='rtl') {
                st=""+ state.maxValue-i;
			}
			//y+=foo;
            //console.log(foo+ "x="+ x+" y="+y+" "+a+" "+st);
            //var  p = this.surface.createPath();
            var t = group.createText({x: x, y: y, text: st, align: align});

			t.setFill(this.majorTicksColor).setFont(this.font);
            if (this.dir=='rtl') 
            	t.setTransform(dojox.gfx.matrix.flipX);
		}

    },



    
    /**
     *
     */
    _tickGroup: null,
    drawTicks: function(state){
        this.computefont();
        if(this._tickGroup == null){
            this._tickGroup= state.group.createGroup();
        }
        var result=this._tickGroup;
        result.clear();
        this._setTicks(state,result);
        return result;
    },
    
    _makeNeedle: function(state, group, bodycolor){
            var width=this.needlewidth;
            var length= this.radius-10;
            var x = (width/2)|0;
            var odd = (width & 1);
            var shapes = [];
            var stroke = {color: bodycolor, width: 1};
            
            var xy = (Math.sqrt(2) * (x));
            shapes[0] = group.createPath()
                    .setStroke(stroke).setFill(bodycolor)
                    .moveTo(xy, -xy).arcTo((2*x), (2*x), 0, 0, 0, -xy, -xy)
                    .lineTo(0, -length).closePath();
            shapes[1] = group.createCircle({cx: 0, cy: 0, r: width})
                    .setStroke({color: bodycolor})
                    .setFill(bodycolor);
            shapes[0].setTransform({dx: this.cx, dy: this.cy});
            shapes[1].setTransform({dx: this.cx, dy: this.cy});

       return shapes[0];
    },

    /**
     *
     */
    _needle: null,
    _needleGroup: null,
    _markneedle: null,
    _markneedleGroup: null,
    drawNeedle: function(state){
        if ((this._markneedleGroup == null) && (this.mark==true) ) {
            var parentGroup = state.group;
            this._markneedleGroup = parentGroup.createGroup();
            this._markneedle= this._makeNeedle(state,this._markneedleGroup, this.mncolor);
        }
        if(this._needleGroup == null){
            var parentGroup = state.group;
            this._needleGroup     = parentGroup.createGroup();
            this._needle= this._makeNeedle(state,this._needleGroup, this.ncolor);
        }

        this.max=state.maxValue;
        this.min=state.minValue;

//marker

            v = this.markerValue;
            c = this._markerStart;   //current value   
            if(this.dontAnimate){
              var angle = this._getAngle(v, state.minValue, state.maxValue);
              if (this._markneedle!=null){
                  this._markneedle.setTransform([{dx:this.cx,dy:this.cy+this._topmargin}, dojox.gfx.matrix.rotateg(angle)]);
              }
            }else{
                if(c!=v){
                    var anim = new dojo._Animation({curve: [c, v], duration: 1000, easing: dojo.fx.easing.quadratic});
                    dojo.connect(anim, "onAnimate", dojo.hitch(this, function(step){
                        if (this._markneedle!=null){
                          this._markneedle.setTransform([{dx:this.cx,dy:this.cy+this._topmargin}, dojox.gfx.matrix.rotateg(this._getAngle(step,this.min, this.max))]);
                        }
                     this._markerStart=step;
                    }));
                    anim.play();
                }

            }


//needle on top
        var v = state.endValue;  //go toward value
        if(v < state.minValue){
            v = state.minValue;
        } 
        if(v > state.maxValue){
            v = state.maxValue;
        }
        var c = state.startValue; //current value
        
        if(this.dontAnimate){
            var angle = this._getAngle(v, state.minValue, state.maxValue);
            if (this._needle!=null){
                this._needle.setTransform([{dx:this.cx,dy:this.cy+this._topmargin}, dojox.gfx.matrix.rotateg(angle)]);
            }
        }else{
            if(c!=v){
                var anim = new dojo._Animation({curve: [c, v], duration: 1000, easing: dojo.fx.easing.quadratic});
                dojo.connect(anim, "onAnimate", dojo.hitch(this, function(step){
                    if (this._needle!=null){
                      this._needle.setTransform([{dx:this.cx,dy:this.cy+this._topmargin}, dojox.gfx.matrix.rotateg(this._getAngle(step,this.min, this.max))]);
                    }
                }));
                anim.play();
            }
        }


        return this._needleGroup;
    },
    
    
    /**
     *
     */
    _textDisplay: null,
    _textGroup: null,
    drawText: function(state){
        // summary:
        //          Draws the text display of the gauge.
        // state: Object
        //          Big state object, see dojox.widget.gauge._Style for info.
        // returns:
        //          Group with the necessary shapes.
	    var height=this._getTextBox(state.displaytextfont).h;

		if(this._textGroup == null){
            this._textGroup = state.group.createGroup();
            
            this._textDisplay = this._textGroup.createText({
                x: 0, y: height, 
                text: state.endValue, 
                align: "middle"
            }).setFill(this.tcolor);

            this._textDisplay.setFont(this.displaytextfont); 


            var units = this._textGroup.createText({
                x: 0, y: height+height, 
                text: state.units, 
                align: "middle"
            }).setFont(this.displaytextfont).setFill(this.tcolor);
        }
        
        this._textDisplay.setShape({
            x: 0, y: height+height, 
            text: state.endValue + "" + state.units, 
            align: "middle"
        });
        
        
        // Animate it! (if it's an integer value to an integer value... decimals look weird)
            this._textDisplay.setShape({
                x: 0, y: height+height,  
                text: state.startValue, 
                align: "middle"
            });
			new dojo._Animation({
                curve: [0, 1], 
                duration: 1000, 
                easing: dojo.fx.easing.quadratic,
                onAnimate: dojo.hitch(this, function(step){
                    var percent = step;
                    var currentValue = Math.floor(percent * (state.endValue - state.startValue) + state.startValue);
                    if(this._textDisplay != null){
						if (step==1) {
                           currentValue = state.endValue;
						   if (state.formatOptions!=null) 
                             currentValue=    dojo.number.format(currentValue, state.formatOptions);
						}
						this._textDisplay.setShape({
                            x: 0, y: height, 
                            text:  currentValue, 
                            align: "middle"
                        });
                    }
                })
            }).play();
        
        
        return this._textGroup;
    }
});