dojo.provide("dojox.widget.AnalogGauge2.TrendingBarStyle");

dojo.require("dojo.fx");
dojo.require("dojo.fx.easing");
dojo.require("dojox.widget.AnalogGauge2._Style");


dojo.declare("dojox.widget.AnalogGauge2.TrendingBarStyle", [dojox.widget.AnalogGauge2._Style], {
	_height:62,
	_width:109,
	_arrowY:0,
	_arrowX:0,
	_arrowHeight:0,
	_arrowWidth:0,
	_scaler:0,
	_value:50,
	_prevalue:50,
	_arrowImage: "",
	_backImage: "",
	_fontSize:8,
	font:  {family: 'Verdana, sans-serif', size:'15px'},

    constructor: function(args){
		dojo.mixin(this, args);
		// if the colorMap wasn't set, use a default one.
        if(this.colorMap == null){
            this.colorMap = {};
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CLEAR_STATUS         ]   = "#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NORMAL_STATUS        ]   = "#33cc14";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.CRITICAL_STATUS      ]   = "#e51717";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.FATAL_STATUS         ]   = "#222222";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MAJOR_STATUS         ]   = "#FFB31A";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.MINOR_STATUS         ]   = "#ffff1a";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INDETERMINANT_STATUS ]   = "#2EA8E5";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.NOT_APPLICABLE_STATUS]   = "#6963A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNKNOWN_STATUS       ]   = "#A6A6A6";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.UNDEFINED_STATUS     ]   = "#9294f3";
            this.colorMap[dojox.widget.AnalogGaugeThreshold.INFORMATIONAL_STATUS ]   = "#2ea8e5";
        }
        
        if(this.iconMap == null){
        	this.iconMap = {};
            var baseString = "dojox.widget.AnalogGauge2.TrendingBarStyle";
            this.iconMap[dojox.widget.AnalogGaugeThreshold.CLEAR_STATUS         ]   = dojo.moduleUrl(baseString, "trending_clear.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.NORMAL_STATUS        ]   = dojo.moduleUrl(baseString, "trending_normal.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.CRITICAL_STATUS      ]   = dojo.moduleUrl(baseString, "trending_critical.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.FATAL_STATUS         ]   = dojo.moduleUrl(baseString, "trending_fatal.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.MAJOR_STATUS         ]   = dojo.moduleUrl(baseString, "trending_major.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.MINOR_STATUS         ]   = dojo.moduleUrl(baseString, "trending_minor.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.INDETERMINANT_STATUS ]   = dojo.moduleUrl(baseString, "trending_indeterminant.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.NOT_APPLICABLE_STATUS]   = dojo.moduleUrl(baseString, "trending_not_applicatable.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.UNKNOWN_STATUS       ]   = dojo.moduleUrl(baseString, "trending_unknown.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.UNDEFINED_STATUS     ]   = dojo.moduleUrl(baseString, "trending_undefined.png");
            this.iconMap[dojox.widget.AnalogGaugeThreshold.INFORMATIONAL_STATUS ]   = dojo.moduleUrl(baseString, "trending_informational.png");
        }
		
	},


	/**
	 * private fnciton compute
	 */
    _computeSizing: function(state){
		//compute width & height 
		if(state.width*0.569>state.height){
			this._width = state.height / 0.569 * 5 / 6;
			this._height = state.height * 5 / 6;
		}
		else if(state.height > state.width*0.569 * 6 / 5){
			this._height = state.width*0.569;
			this._width = state.width;
		}
		else{
			this._width = state.height / 0.569  * 5 / 6;
			this._height = state.height  * 5 / 6;
		}
		
		this._fontSize = this._height / 5;
		this.font.size = this._fontSize+"px";
		
		//compute scaler
		if(state.width>state.height){
			this._scaler = 100.0/state.height;
		}
		else{
			this._scaler = 100.0/state.width;
		}

		//compute image
		this._prevalue = this._value;  //save the previous value
		this._value = state.endValue;
		if(this._value > this._prevalue){
			this._arrowImage = "trending_arrow_up.png";
			this._arrowHeight=49*this._width/109;
			this._arrowWidth=75*this._width/109;
			this._arrowY=this._height*0.97-this._arrowHeight;
			this._arrowX=this._width*0.03;
		}
		else if(this._value < this._prevalue){
			this._arrowImage = "trending_arrow_down.png";
			this._arrowHeight=49*this._width/109;
			this._arrowWidth=75*this._width/109;
			this._arrowY=this._height*0.03;
			this._arrowX=this._width*0.03;
		}
		else{
			this._arrowImage = "trending_arrow_normal.png";
			this._arrowHeight=26*this._width/109;
			this._arrowWidth=97*this._width/109;
			this._arrowY=(this._height-this._arrowHeight)/2;
			this._arrowX=this._width*0.03;
		}
		
		var status = this.getThresholdFromValue(state.endValue, state.thresholds).status;
		
		this._backImage = this.iconMap[status];
    },


    getDrawOrder: function(){
        return ["drawBackground",  "drawForeground", "drawText"];
	},
  
    
    getDrawSemantics: function(){
        return {
            background: "drawBackground",
            foreground: "drawForeground",
			text: "drawText",
            updateValue: ["drawBackground", "drawForeground", "drawText"]
        };
    },
    


	_backGroup: null,

	drawBackground: function(state){
		this._computeSizing(state);
		var cx = this._width*0.5;
        var cy = state.height*0.5;
		
		if (this._backGroup==null){
           this._backGroup= state.group.createGroup();
        }
        this._backGroup.clear();
		
		//draw high light
		var background = this._backGroup.createImage({
			x: -cx, y: -cy, 
			width: this._width, height: this._height, 
			src: this._backImage
		});
		
		this._backGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
		return this._backGroup;
		
	},

    _foreGroup: null,
    drawForeground: function(state){
        var cx = this._width*0.5;
        var cy = state.height*0.5;


        if (this._foreGroup==null){
           this._foreGroup= state.group.createGroup();
        }
        this._foreGroup.clear();
		
		//draw arrow
		var arrow = this._foreGroup.createImage({
			x: -cx+this._arrowX, 
			y: -cy+this._arrowY,
			width: this._arrowWidth,
			height: this._arrowHeight,
			src: dojo.moduleUrl("dojox.widget.AnalogGauge2.TrendingBarStyle", this._arrowImage)
		});

		this._foreGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
		return this._foreGroup;
    },

	
	/**
     *  draw lable and value
     */
    _textGroup: null,
    drawText: function(state){
    	var cx = this._width*0.5;
        var cy = state.height*0.5;
        
		if(this._textGroup == null){
			this._textGroup = state.group.createGroup();
		}
		this._textGroup.clear();
		var text=this._textGroup.createText({x:0,y:-cy+this._height+this._fontSize,text:state.endValue+" "+state.units,align:"middle"});
		text.setFont(this.font).setStroke("black");
		
		this._textGroup.setTransform({xx: this._scaler, yy: this._scaler, dx:0, dy:0});
		return this._textGroup;
	},

    reset: function(){
        // summary:
        //          Deletes any locally-stored shape objects when the gauge 
        //          needs to be reset.

        delete this._backGroup;
        delete this._foreGroup;
		delete this._textGroup;

        this._backGroup=null;
        this._foreGroup=null;
		this._textGroup=null; 
    }
});