/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Extensions for Dojo
*
* (C) Copyright IBM Corp. 2011.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("dojoe.notebook.tests.functions.apiTest");

//Import in the code being tested.
dojo.require("dojoe.notebook.Notebook");

dojo.addOnLoad(function(){var nb = new dojoe.notebook.Notebook ({layout:"vertical",id:"notebook"});});

doh.register("dojoe.notebook.tests.functions.apiTest", [
				
				
				function test_enableCancelButton(){
					dijit.byId("notebook").enableCancelButton(true);
					var isDisabled = dijit.byId("notebook")._cancelButton.attr("disabled");
	                doh.assertFalse(isDisabled);
        		},
				function test_enableOKButton(){
					dijit.byId("notebook").enableOKButton(true);
					var isDisabled = dijit.byId("notebook")._finishButton.attr("disabled");
	                doh.assertFalse(isDisabled);
        		},
				function test_enableApplyButton(){
					dijit.byId("notebook").enableApplyButton(true);
					var isDisabled = dijit.byId("notebook")._applyButton.attr("disabled");
	                doh.assertFalse(isDisabled);
        		},
				function test_hideApplyButton(){
					dijit.byId("notebook").hideApplyButton(true);
					var styleApply = dojo.style(dijit.byId("notebook")._applyButton.domNode, "display");
					doh.assertEqual("none", styleApply);
	            },
				function test_hideOKButton(){
					dijit.byId("notebook").hideOKButton(true);
					var styleApply = dojo.style(dijit.byId("notebook")._finishButton.domNode, "display");
					doh.assertEqual("none", styleApply);
	            },
				function test_hideCancelButton(){
					dijit.byId("notebook").hideCancelButton(true);
					var styleApply = dojo.style(dijit.byId("notebook")._cancelButton.domNode, "display");
					doh.assertEqual("none", styleApply);
	            },
				function test_OnCancel(){
					dijit.byId("notebook").OnCancel();
					var status = dojo.hasClass(dijit.byId("notebook")._buttonArea.domNode,"tiv-notebook-footer-hidden");
					doh.assertTrue(status);
					
				},
				function test_hideAllButtons(){
					dijit.byId("notebook").hideAllButtons();
					var status = dojo.hasClass(dijit.byId("notebook")._buttonArea.domNode,"tiv-notebook-footer-hidden");
					doh.assertTrue(status);
				},
				function test_showAllButtons(){
					dijit.byId("notebook").showAllButtons();
					var status = dojo.hasClass(dijit.byId("notebook")._buttonArea.domNode,"tiv-notebook-footer-hidden");
					doh.assertFalse(status);
				},
				function test_resize(){
					var newsize = {};
					newsize.w = 750;
					newsize.h = 500;
					dijit.byId("notebook").resize(newsize);
					var width = dojo.style(dijit.byId("notebook").domNode, 'width');
					var height = dojo.style(dijit.byId("notebook").domNode, 'height');
					doh.assertEqual(newsize.w, width);
					doh.assertEqual(newsize.h, height);
				}
				
				
	
]);
