dojo.provide("ibm.tivoli.common.listtree.dijit.ModelListTree");

dojo.require("ibm.tivoli.common.listtree.dijit.ListTree");

dojo.declare("ibm.tivoli.common.listtree.dijit.ModelListTree",[ibm.tivoli.common.listtree.dijit.ListTree], {
	model : null, /*Forest model containing children*/	
	constructor : function() {
		this.inherited(arguments);
	},
	postCreate : function() {
		this.inherited(arguments);
		
		/*populate list from model*/
		this._addModelItems();
	},
	_addModelItems : function(){
		var _this = this;
		//if there is no data associated with this node assume we are the root 
		//and start building off the root data.  
		if (!this.data) {
			this.model.getRoot(function(item) {_this.model.getChildren(item,function(items) {_this.addModelChildren(_this, items);});}, function(error) {alert(error);});
		}
			
	},

	addModelChildren: function (/*obj*/ ofThisObj, /*[obj]*/ children) {
		//console.group(this.label, ": add Children");
			if(children && children.length > 0)  {
				// adding children may change this node from a leaf to a branch node
				
				if(this.listItemWidget) {
					this.listItemWidget.toBranch();
				}
			
				
				
					dojo.forEach(children, dojo.hitch(this, function(child) { 
						childitem = new ibm.tivoli.common.listtree.dijit.ModelListTree({
								model: this.model,
								data: child,
								fillOrder: this.fillOrder, colCount: this.colCount,
								keyField: this.keyField, labelField: this.labelField, descField: this.descField, iconField: 
								this.iconField, childField: this.childField, leafField: this.leafField});
						childitem.label = child[this.labelField][0].htmlencode();
						
						childitem.description = this.formatChildDescription(child[this.descField][0]);
											
						// if no icon is given, use the parent's
						childitem.icon = child[this.iconField][0] ? child[this.iconField][0] : this.icon;
						childitem.iconSize = (undefined !== this.iconSizeField && this.iconSizeField.length > 0 && typeof child[this.iconSizeField][0] == "number") ? child[this.iconSizeField][0] : this.defaultIconSize;
						//console.log("child.icon = ", childitem.icon);
						this.subitems.push(childitem);			// add the new ListTree node to my sublist
						childitem.parentList = this;			// back-pointer to the new node's parent ListTree
						// TODO: eventyally handle boh sub-trees and leaf-nodes
						if(this.model.mayHaveChildren(child)) {
							var _thisLevel = childitem;
							this.model.getChildren(childitem.data,function(items) {
								_thisLevel.addModelChildren(_thisLevel,items);	
							}, function(error) {alert("uh oh!");});
						}
					}));
			}
			//console.groupEnd();
		
		
	}
	
}); 