/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */
dojo.provide("ibm.tivoli.navmodel.DatasetInfo"); 

////////////////////////////////////
// DatasetInfo
////////////////////////////////////  
dojo.declare("ibm.tivoli.navmodel.DatasetInfo", null, {
	// private members       
	_dataset: null,
	_version: null,
	
	/*=====
	constructor_kwArgs: function(dataset, version) {
		// dataset: Object
		//		json dataset object
		// version: Float
		//		optional: version used to communicate with rest service (i.e. json version)
	},
	=====*/
	constructor: function(/*constructor_kwArgs*/ kwArgs) {
		// summary:
		//		Constructs Provider object.
		this._version = kwArgs.version;
		this._dataset = kwArgs.dataset;
		if (!this._dataset) {
			this._dataset = {};
		}
	},

	getAttribute: function(key) {
		// summary:
		//		Returns general attribute for requested key
		return this._dataset[key];
	},

	setAttribute: function(key, value) {		
		// summary:
		//		Set general attribute for requested key
		this._dataset[key] = value;
	},
	
	removeAttribute: function(key) {
		// summary:
		//		Remove general attribute for requested key
		delete this._dataset[key];
	},
	
	getProviderId: function() {
		// summary:
		//		Returns the providerId of this dataset
		return this._dataset.providerId;
	},
	
	getDatasourceId: function() {
		// summary:
		//		Returns the datasourceId of this dataset
		return this._dataset.datasourceId;
	},
	
	getId: function() {
		// summary:
		//		Returns the id of this dataset
		return this._dataset.id;
	},
	
	getLabel: function() {
		// summary:
		//		Returns the label of this dataset
		return this._dataset.label;
	},
	
	getDescription: function() {
		// summary:
		//		Returns the description of this dataset
		return this._dataset.description;
	},
	
	getType: function() {
		// summary:
		//		Returns the type of this dataset.
		return this._dataset.type;
	}
});
