/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.navmodel.NavWidgetDef"); 
 
// includes
dojo.require("ibm.tivoli.navmodel.WidgetDef");

////////////////////////////////////
// NavWidgetDef
////////////////////////////////////  
dojo.declare("ibm.tivoli.navmodel.NavWidgetDef", ibm.tivoli.navmodel.WidgetDef, {
	
	/*=====
	constructor_kwArgs: function(baseUrl, provider, datasource, widget, definition, type, version) {
		// baseUrl: String
		//		base url for identifying rest service
		// provider: String
		//		provider id
		// datasource: String
		//		datasource id
		// widget: String
		//		widget type in form <type>-<version>
		// definition: String
		//		widget definition id in form <id>-<version>
		// type: String
		//		definition type:  "user", "shared", or "base"
		// version: Float
		//		version used to communicate with rest service
	},
	=====*/ 
	
	constructor: function(/*constructor_kwArgs*/ kwArgs) {		
		// summary:
		//		
	},

	/////////////////////////////
	// public methods
	/////////////////////////////
	getBreadcrumbs: function(){
		var returnValue = this._widgetDef.navwidget.breadcrumbs;
		if(!returnValue) {
			var parent = this.getParentWidgetDef();
		 	if (parent && parent.getBreadcrumbs) {
				returnValue = parent.getBreadcrumbs();
			}
		}		
		return returnValue;			
	},
	
	getNotebook: function(){
		var returnValue = this._widgetDef.navwidget.notebook;
		if(!returnValue) {
			var parent = this.getParentWidgetDef();
		 	if (parent && parent.getNotebook) {
				returnValue = parent.getNotebook();
			}
		}		
		return returnValue;			
	},
	
	getViewsLayout: function(){
		var returnValue = this._widgetDef.navwidget.viewsLayout;
		if(!returnValue) {
			var parent = this.getParentWidgetDef();
		 	if (parent && parent.getViewsLayout) {
				returnValue = parent.getViewsLayout();
			}
		}		
		return returnValue;					
	},
	

	destroy: function() {		
		// summary:
		//		Do any necessary clean up 
		if (!this.isDestroyed()) {
			// call base class
			this.inherited(arguments);
		}
	}
	
	/////////////////////////////
	// private methods
	/////////////////////////////

});
