/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */
dojo.provide("ibm.tivoli.navmodel.WidgetDefInfo"); 

////////////////////////////////////
// WidgetDefInfo
////////////////////////////////////  
dojo.declare("ibm.tivoli.navmodel.WidgetDefInfo", null, {
	// private members       
	_widgetDef: null,
	_version: null,
	
	/*=====
	constructor_kwArgs: function(widgetDef, version) {
		// widgetDef: Object
		//		json widget definition information object
		// version: Float
		//		optional: version used to communicate with rest service (i.e. json version)
	},
	=====*/
	constructor: function(/*constructor_kwArgs*/ kwArgs) {
		// summary:
		//		Constructs Provider object.
		this._version = kwArgs.version;
		this._widgetDef = kwArgs.widgetDef;
		if (!this._widgetDef) {
			this._widgetDef = {};
		}
	},

	getAttribute: function(key) {
		// summary:
		//		Returns general attribute for requested key
		return this._widgetDef[key];
	},	
	
	getId: function() {
		// summary:
		//		Returns the id of this definition
		return this._widgetDef.id;
	},
	
	getVersion: function() {
		// summary:
		//		Returns the definition schema version
		return this._widgetDef.version;
	},
	
	getType: function() {
		// summary:
		//		Returns the widget type
		return this._widgetDef.type;
	},
	
	getProviderType: function() {
		// summary:
		//		Returns the provider type (can also be "any")
		return this._widgetDef.providerType;
	},
	
	getDatasourceType: function() {
		// summary:
		//		Returns the datasource type (can also be "any")
		return this._widgetDef.datasourceType;
	}
});
