/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */
dojo.provide("ibm.tivoli.navmodel.WidgetGroupInfo"); 

////////////////////////////////////
// WidgetGroupInfo
////////////////////////////////////  
dojo.declare("ibm.tivoli.navmodel.WidgetGroupInfo", null, {
	// private members       
	_widgetGroup: null,
	_version: null,
	
	/*=====
	constructor_kwArgs: function(widgetGroup, version) {
		// widgetGroup: Object
		//		json widget group information object
		// version: Float
		//		optional: version used to communicate with rest service (i.e. json version)
	},
	=====*/
	constructor: function(/*constructor_kwArgs*/ kwArgs) {
		// summary:
		//		Constructs Provider object.
		this._version = kwArgs.version;
		this._widgetGroup = kwArgs.widgetGroup;
		if (!this._widgetGroup) {
			this._widgetGroup = {};
		}
	},

	getAttribute: function(key) {
		// summary:
		//		Returns general attribute for requested key
		return this._widgetGroup[key];
	},	
	
	getId: function() {
		// summary:
		//		Returns the id of this definition
		return this._widgetGroup.id;
	},
	
	getLabel: function() {
		// summary:
		//		Returns the widget group label
		return this._widgetGroup.label;
	},
	
	getDescription: function() {
		// summary:
		//		Returns the widget group description
		return this._widgetGroup.description;
	},
	
	getProviderType: function() {
		// summary:
		//		Returns the widget group provider type
		return this._widgetGroup.providerType;
	},
	
	getDatasourceType: function() {
		// summary:
		//		Returns the widget group datasource type
		return this._widgetGroup.datasourceType;
	}
});
