/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */
dojo.provide("ibm.tivoli.navmodel.WidgetTypeInfo"); 

////////////////////////////////////
// WidgetTypeInfo
////////////////////////////////////  
dojo.declare("ibm.tivoli.navmodel.WidgetTypeInfo", null, {
	// private members       
	_widgetType: null,
	_version: null,
	
	/*=====
	constructor_kwArgs: function(widgetType, version) {
		// widgetType: Object
		//		json widget type information object
		// version: Float
		//		optional: version used to communicate with rest service (i.e. json version)
	},
	=====*/
	constructor: function(/*constructor_kwArgs*/ kwArgs) {
		// summary:
		//		Constructs Provider object.
		this._version = kwArgs.version;
		this._widgetType = kwArgs.widgetType;
		if (!this._widgetType) {
			this._widgetType = {};
		}
	},

	getAttribute: function(key) {
		// summary:
		//		Returns general attribute for requested key
		return this._widgetType[key];
	},	
	
	getId: function() {
		// summary:
		//		Returns the id of this definition
		return this._widgetType.id;
	},
	
	getType: function() {
		// summary:
		//		Returns the widget type
		return this._widgetType.type;
	},
	
	getVersion: function() {
		// summary:
		//		Returns the schema version
		return this._widgetType.version;
	}
});
