/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009, 2010 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
// test version control - 2.2.0

dojo.provide("ibm.tivoli.tip.charts.dijit.ChartBuilder");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.charting.Chart2D");
dojo.require("dojot.visual.ColumnsEmbossed");
dojo.require("dojot.visual.ClusteredColumnsEmbossed");
dojo.require("dojot.visual.StackedColumnsEmbossed");
dojo.require("dojot.visual.BarsEmbossed");
dojo.require("dojot.visual.ClusteredBarsEmbossed");
dojo.require("dojot.visual.StackedBarsEmbossed");
dojo.require("dojox.charting.plot2d.Pie");
dojo.require("dojox.charting.plot2d.Lines");
dojo.require("dojox.charting.plot2d.Columns");
dojo.require("dojox.charting.plot2d.ClusteredColumns");
dojo.require("dojox.charting.plot2d.StackedColumns");
dojo.require("dojox.charting.plot2d.ClusteredBars");
dojo.require("dojox.charting.plot2d.StackedBars");
dojo.require("dojox.charting.plot2d.Bars");
dojo.require("dijit.Tooltip");
dojo.require("dojox.gfx");
dojo.require("dojox.gfx.matrix");
dojo.require("dojox.charting.Theme");
dojo.require("ibm.tivoli.tip.dijit.themes.ChartTheme");
dojo.require("ibm.tivoli.tip.dijit.themes.ChartThemeTivoliStandard");
dojo.require("ibm.tivoli.tip.dijit.themes.ChartThemeTivoliDark");
dojo.require("dojox.charting.action2d.Tooltip");
dojo.require("dojox.charting.widget.Legend");
dojo.require("dojox.charting.action2d.MoveSlice");
dojo.require("dojo._base.html");
dojo.require("dojox.charting.action2d.Magnify");
dojo.require("dojox.charting.action2d.Shake");
dojo.require("ibm.tivoli.tip.charts.dojo.ChartFetcher");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartPager");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartToolbar");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartTitle");
dojo.require("ibm.tivoli.tip.dijit.TIPTable");
dojo.require("ibm.tivoli.tip.dojo.Global");
dojo.require("ibm.tivoli.tip.dojo.Server");
dojo.require("ibm.tivoli.tip.dijit.ContextMenuAdapter");
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenu");
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenuProvider");
dojo.require("ibm.tivoli.tip.dijit.CMSMenuProvider");
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenuProxy");
dojo.require("ibm.tivoli.tip.charts.dijit.Builder");
dojo.require ("ibm.tivoli.tip.charts.dojo.DojoChartUtil");
dojo.require ("ibm.tivoli.tip.dojo.TIPHelper");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartBuilder",
	          [ dijit._Widget, dijit._Templated, ibm.tivoli.tip.charts.dijit.Builder ],
{
	widgetsInTemplate: true,
	templatePath:dojo.moduleUrl("ibm.tivoli.tip.charts.dijit" , "templates/ChartBuilder.html"),

	namespace: "namespace1_",
	global: null,
	chartID: null,
	chartPreferences: null,
	widgetDefinition: null,
	updateMultiplier: 10,
    updateMinInterval: 30000,
    updateMaxInterval: 180000,
	interval: null,
	runReportStartTime: 0,
    runReportResponseTime: 5,
    datasourceID: null,
	dataSetID: null,
	providerID: "tip.charts",
	chartPager: null,
	axisLabelCount: 0,
	theme: ibm.tivoli.tip.dijit.themes.ChartThemeTivoliStandard.clone(),
	custom: ibm.tivoli.tip.dijit.themes.ChartThemeTivoliStandardCustom,
	standalone: false,
	ignoreContextMenu: false,
	ignoreTitlebar: false,
	ignoreToolbar: false,
	initSize: null,
    timeVar: null,
	trigger: null,
	drillUpItems: [],
	pieCMTargetNodeIds: [],
	isChart: true,
	themeIndex: 0,
	_currentSize: null,
	chartDivSize: null,

	constructor: function () {		
	    //dojo.mixin( this, mixinData );
		this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
		this.chartBuilder = true;		
		this.dc = dojox.charting;
		this.firstRun = true;
		this.chart = null;
		this.charts = [];
		this.columns = null;
		this.rows = null;
		this.store = null;
		this.chartFetcher = null;
		this.chartDef = null;
		this.legend = null;
		this.dataset = null;
		this.toolbarSelf  =  null;
        this.common = null;
        this.pieCMTargetNodeIds = [];
		this.seriesLength = 0;
		this._currentSize = null;
		this.chartDivSize = null;
		this.drillUpItems = [];
	},
	startup: function () {
		this.chartDef = this.getChartDef (this.chartID);
		this.setupTheme();		 
		this.fetchChartData();
		this.dataset = this.getDataSet (this.dataSetID);
		this.common = this.getCommonData ();
		/*
		if(!this.standalone || (this.standalone && !this.ignoreContextMenu)){
			this.makeChartContextMenu();
		}
		*/
	},
	
	setupTheme: function(){
		if (this.chartDef.theme !== undefined) {
			console.log ("setting theme from widget definition: " + this.chartDef.theme.name);
			this.setTheme(this.chartDef.theme.name);
			this.themeIndex = this.chartDef.theme.startIndex;
			console.log ("themeIndex: " + this.themeIndex);
		} else if ((this.global.theme  !== undefined) && (this.global.theme !== null)) {
			console.log ("setting theme from global: " + this.global.theme);		
			this.setTheme(this.global.theme);
		} else {
			console.log ("no theme from widget def or global");
		}
		
		if ((this.theme.colors) && (this.theme.colors !== null)) {
			this.arrangeColorPalette();
		} else {
			this.arrangeGradientPalette();
		}
	},
	
	getChartDef: function (chartID) {
		var chartDef = null;		
		if(this.widgetDefinition.charts === undefined)
		{
			chartDef = this.widgetDefinition.tables[0];
			return(chartDef);
		}

		for (var i=0; i < this.widgetDefinition.charts.length; i++) {
			if (this.widgetDefinition.charts[i].id == chartID) {
				return (this.widgetDefinition.charts[i]);
			}			
		}
		
		console.error ("no chart definition found for: " + chartID + " in widgetDefinition:");
		
		return (null);
	},
	makeChartContextMenu: function () {
		
		var cmClientProvider = new ibm.tivoli.tip.dijit.TIPContextMenuProvider(
					{ iscPortletNamespace: this.iscPortletNamespace,
					  getMenuItemsCallback: dojo.hitch (this, this.getMenuItems)
					});
		
		var provider = new ibm.tivoli.tip.dijit.CMSMenuProviderV2(
				{ global: this.global,
				  menuName: "DojoTableV2",
				  getMenusCommandName: "getMenuItems",
				  getMenuActionCommandName: "getMenuCommand",	
				  createCMSEventCallback: this.createCMSEventCallback,			  
				  iscPortletNamespace: this.global.iscPortletNamespace
				});
		
		console.log ("after make provider");		

		this.chartMenu = new ibm.tivoli.tip.dijit.TIPContextMenuProxy(
			{cmProvider: provider, 
			 cmClientProvider: cmClientProvider,
			 //targetNodeIds: [this.id + "chart0"],
			 targetNodeIds: this.pieCMTargetNodeIds,
			 getContextCallback: dojo.hitch (this, this.getSelectedData),
			 id: this.global.namespace + "chartMenu"
			});
		console.log ("after create context menu");
	
	},
	getSelectedData: function (event) {
		var contextData = {};
		contextData.rcfs = [];
		var colNames = this.widgetDefinition.datasets[0].columns;
		var datasourceType = this.widgetDefinition.datasource.type;
		var datasourceId = this.datasourceID;		
		var datasetId = this.widgetDefinition.datasets[0].id;		
		var rowIndex = this.chartDef.type == "Pie" ? event.currentTarget.id.substr(event.currentTarget.id.length-1)-1 : event.index ;		
		var resourceAttrs = [];
		var attr = null;					
		for(var i=0; i<colNames.length; i++){
			attr = {};
			//attr.name = colNames[i].label.key;			
			attr.name = colNames[i].id;			
			attr.value = this.store.getValue (this.rows[rowIndex], colNames[i].id);			
			attr.isNamingAttribute = false;
			if(attr.value!==undefined && attr.value!==null){
				resourceAttrs.push(attr);
			}
		}			
		
		attr = {};
		attr.name = "Class";
		attr.value = "*";
		attr.isNamingAttribute = false;
		resourceAttrs.push(attr);
		contextData.rcfs.push (resourceAttrs);
		
		contextData.launchTypes = ["WEB_URL", "PORTAL_PAGE", "PORTLET", "CLIENT_EVENT"];
		contextData.excludedAppIDs = [];
		contextData.substitutionVariables = [];
		
		attr = {};
		attr.name = "RowIndex";
		attr.value = this.store.getIdentity(this.rows[rowIndex]);	
		contextData.substitutionVariables.push(attr);
		
		var selectedItem = this.rows[rowIndex];
				
		attr = {};
		attr.name = "MSSName";
		if(selectedItem._item.MSSName){
			attr.value = selectedItem._item.MSSName;
		}else{
			attr.value = this.fetchMSSName(true);
		}		
		if(attr.value!==undefined && attr.value!==null){
			contextData.substitutionVariables.push(attr);
		}
		
		attr = {};
		attr.name = "SourceToken";		
		if(selectedItem._item.SourceToken){
			attr.value = selectedItem._item.SourceToken;
		}		
		if(attr.value!==undefined && attr.value!==null){
			contextData.substitutionVariables.push(attr);
		}
		
		attr = {};
		attr.name = "DatasourceType";
		attr.value = datasourceType;	
		contextData.substitutionVariables.push(attr);
		
		attr = {};
		attr.name = "DatasourceId";
		attr.value = datasourceId;	
		contextData.substitutionVariables.push(attr);	
		
		attr = {};
		attr.name = "DatasetId";
		attr.value = datasetId;	
		contextData.substitutionVariables.push(attr);
		contextData.options = [];		
		return contextData;		
	},
	getCommonMenuItems: function () {
		var menuItems = [{ 
			id: this.id + "RefreshChartMenuItem", 
			label: this.resources_.REFRESH, 
			iconClass: "refreshIcon", 
			launchType: "JavaScript", 
			uri: "dijit.byId ('" + this.id + "toolbar" + "').onRefresh();", 
			enabled: true 
		}];
        var subMenuItems = null;
		if(this.widgetDefinition.drillDown !== undefined) {				
			subMenuItems = this.getDrillDownMenuItems();
			var oldDrillDownNode = dijit.byId (this.id + "DrillDown");		
			if(oldDrillDownNode) {
				oldDrillDownNode.destroy();
			}
			menuItems.push ({ 
				id: this.id + "DrillDown", 
				label: this.resources_.DRILL_DOWN, 
				icon: "", 
				launchType: "NOOP", 
				submenu_items: subMenuItems, 
				enabled: true 
			});
		}
		if(this.drillUpItems !== undefined && this.drillUpItems.length > 0) {	
			subMenuItems = this.getDrillUpMenuItems();
			var oldDrillUpNode = dijit.byId (this.id + "DrillUp");		
			if(oldDrillUpNode) {
				oldDrillUpNode.destroy();
			}				
			menuItems.push ({ 
				id: this.id + "DrillUp", 
				label: this.resources_.DRILL_UP, 
				icon: "", 
				launchType: "JavaScript", 
				submenu_items: subMenuItems, 
				enabled: true 
			});
		}	
		return (menuItems);
	},
	getCustomMenuItems: function () {
			var menuItems = [{ 
				id: this.id + "ShowHideToolbarMenuItem", 
				label: this.resources_.SHOW_HIDE_TOOLBAR, 
				iconClass: "toggleIcon", 
				launchType: "JavaScript", 
				uri: "dijit.byId ('" + this.id + "toolbar" +"').toggleToolbar();", 
				enabled: true 
			}];						
			if(!this.global.isFromPortletPref){
				menuItems.push({ 
					id: this.id + "ReturnToChartSelectorMenuItem", 
					label: this.resources_.RETURN_TO_CHART_SELECTOR, 
					iconClass: "backIcon", 
					launchType: "JavaScript", 
					uri: "dijit.byId ('" + this.id +"toolbar"+ "').showChartSelector();", 
					enabled: true 
				});
			}
			menuItems.push({ id: "separator" });
			menuItems.push({ 
				id: this.id + "PreferencesMenuItem", 
				label: this.resources_.PREFERENCES, 
				iconClass: "propertiesIcon", 
				launchType: "JavaScript", 
				uri: "dijit.byId ('" + this.id + "toolbar" + "').onPreferences();", 
				enabled: true 
			});
			var context = ibm.tivoli.tip.dojo.Global.getSingleton(this.global.namespace);
			if (context.roles.admin || context.roles.creator) {
			    menuItems.push ({ 
			    	id: this.id + "SaveForAll", 
			    	label: this.resources_.SAVE_FOR_OTHERS, 
			    	icon: "", 
			    	launchType: "JavaScript", 
			    	uri: "dijit.byId ('" + this.id +"toolbar"+ "').onSave();", 
			    	enabled: true 
			    });
				menuItems.push ({ 
					id: this.id + "ResetForAll", 
					label: this.resources_.CLEAR_DEFAULT_PREFERENCES, 
					icon: "", 
					launchType: "JavaScript", 
					uri: "dijit.byId ('" + this.id +"toolbar" + "').onReset();", 
					enabled: true 
				});
			}
			menuItems.push ({ 
				id: this.id + "ResetForMe", 
				label: this.resources_.CLEAR_MY_PREFERENCES, 
				icon: "", 
				launchType: "JavaScript", 
				uri: "dijit.byId ('" + this.id + "toolbar" +"').onResetMyPreferences();", 
				enabled: true 
			});				
			menuItems.push({ id: "separator" });
			return (menuItems);
	},
	
	getMenuItems: function () {
		var menuItems = null;
		var commonMenuItems = this.getCommonMenuItems();
		if(this.standalone){
			if(!this.ignoreContextMenu){
				menuItems = commonMenuItems;
			}
		}else{
			var customMenuItems = this.getCustomMenuItems();
			menuItems = commonMenuItems.concat(customMenuItems);
		}		
		return (menuItems);
	},
	
	getDrillDownMenuItems: function() {
		var subMenuItems = [];		
		for (var i=0; i<this.chartDef.contextMenu.length; i++) {
			var drillDownObj = this.getDrillDown(this.chartDef.contextMenu[i].reference);
			subMenuItems.push ({ id: this.id + this.chartDef.contextMenu[i].reference, label: drillDownObj.widgetId, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.id +"').drillDown('"+drillDownObj.id+"');", enabled: true });						
		}
		return (subMenuItems);
	
	},

	getDrillUpMenuItems: function() {
		var subMenuItems = [];
		for (var i=0; i<this.drillUpItems.length; i++) {
			var drillUpObj = this.drillUpItems[i];
			subMenuItems.push ({ id: this.id + drillUpObj.chartIdWithCount, label: drillUpObj.chartIdWithCount, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.id +"').drillUp('"+drillUpObj.chartIdWithCount+"');", enabled: true });						
		}		
		return (subMenuItems);

	},

	getDataSet: function (dataSetID) {
	/*	for (var i=0; i < this.widgetDefinition.dataSets.length; i++) {
			if (this.widgetDefinition.dataSets[i].id == dataSetID) {
				return (this.widgetDefinition.dataSets[i]);
			}
		}*/ 
		return (this.widgetDefinition.datasets[0]);
		
//		console.error ("no dataset found for: " + dataSetID + " in widgetDefinition:");		
//		return (null);
	
	},
	getCommonData: function () {

		return (this.chartDef.common);
	},
	makeSeriesData: function (dataColumn) {
		console.log ("enter ChartBuilder.makeSeriesData: " + dataColumn);
		var result = [];
		if(this.rows !== null){
			for (var i=0; i<this.rows.length; i++) {
				if (i !== undefined) {
					var values = this.store.getValues(this.rows[i], dataColumn, true, true); 
					var value = values[0]; 
                    //result.push (dojo.number.parse(value));		
                    result.push (value);
				}
			}
		}

		this.seriesLength = result.length;
		
		console.log ("exit ChartBuilder.makeSeriesData: ");
		console.log (result);
		return (result);
	},
	makeMultiPieSeriesData: function (i, dataColumn, textColumn, tooltipColumn) {
		//   {y: 4, text: "Red",   stroke: "black", tooltip: "Red is 50%"},
		var object = null;
		object = {};
		var values = this.store.getValues(this.rows[i], dataColumn, true, true); 
		//object.y = dojo.number.parse(values[0]);
		object.y = values[0];
		//object.y = this.store.getValue (this.rows[i], dataColumn);		
		if (textColumn) {
			//object.text = this.store.getValue (this.rows[i], textColumn);			
			object.text = textColumn;
		}
				
		if (tooltipColumn) {
			values = this.store.getValues(this.rows[i], tooltipColumn, true); 
			object.tooltip = values[0];
			//object.tooltip = this.store.getValue (this.rows[i], tooltipColumn);
		}	
		//return({y: object.y, text: object.text, stroke: "black", tooltip: object.tooltip});
		var color = this.custom.piestroke.color;
		console.log ("makeMultiPieSeriesData color: " + color);
		return({y: object.y, text: object.text, stroke: color, tooltip: object.tooltip});
//		return({y: object.y, stroke: color, tooltip: object.tooltip});
	},
	makeXAxisLabels: function (columnID) {
		console.log ("enter makeXAxisLabels: " + columnID);
		console.log (this.rows);
		var result = [];
		var label = {};
		if(this.rows !== null){
		for (var i=0; i<this.rows.length; i++) {
			if (i !== undefined) {
				label = {};
				label.value = i+1;								
				var values = this.store.getValues (this.rows[i], columnID, false);
				//label.text = this.store.getValue (this.rows[i], columnID);
				label.text = values[0];			
				
				result.push (label);
				}
			}
		}
		
		console.log ("exit makeXAxisLabels: ");
		console.log (result);
		return (result);
	},
	afterFetch: function (columns, rows, store) {
		console.log ("enter ChartBuilder.afterFetch");
		
		var busyPane = dijit.byId(this.global.namespace+"busy_pane");
		if ( busyPane )
		{
			busyPane.hide();
		}
		
		this.columns = columns;
		this.rows = rows;
		this.store = store;
		
		if (this.chart === null) {
			this.buildChart ();
			this.resize(this.initSize);	
		} else {
			this.replaceData (rows);
		}

		this.addDrillButtons();
		if ((this.interval !== null) && (!this.chartDef.common.autoUpdate)) {
           clearTimeout (this.interval);
           this.interval = null;
        }
		
		this.updateMetaData();
		if (this.chartDef.common.showLastUpdateTime) {
			dojo.style (this.metaDiv, "display", "");
		} else {
			dojo.style (this.metaDiv, "display", "none");
		}
		
		this.configAutoUpdate();
		console.log ("exit ChartBuilder.afterFetch");		
	},
	
	addDrillButtons: function(){
		var toolbar = this.getToolbar();
		
		if(this.drillUpItems !== undefined && this.drillUpItems.length > 0) {			
			var drillUpOptions = [];
			drillUpOptions[0] = {
							"id": "Drill Up",
							"label": "Drill Up"
						};
			for (var j=0; j<this.drillUpItems.length; j++) {	
				drillUpOptions[j+1] = {
							"id": this.drillUpItems[j].chartIdWithCount,
							"label": this.drillUpItems[j].chartIdWithCount
						};
			}

			var oldDrillUpComboBox = dijit.byId(this.id + "drillUpCombo");
			if(oldDrillUpComboBox) {
				oldDrillUpComboBox.destroyRecursive();
				dijit.registry.remove (this.id + "drillUpCombo");
			}

			var selectOptions = new dojo.data.ItemFileWriteStore({data: {identifier: 'label', items:drillUpOptions}});			
			var drillUpComboBox = new dijit.form.ComboBox({
				id: this.id + "drillUpCombo",
				name: this.id + "drillUpCombo",
				value: "Drill Up",
				store: selectOptions,
				searchAttr: "label",
				onChange: dojo.hitch (this, this.drillUp)
         	},this.id + "drillUpCombo");
			
			if(toolbar!==undefined && toolbar!==null){
				toolbar.addChild(drillUpComboBox);	
			}
		 	//dojo.connect(drillUpComboBox,'onChange','drillUp'); 
		 	//this.toolbarSelf.addChild(drillUpComboBox);
		
		}
	},
	
	_connectEvents: function(o){
		this._connectSingleEvent(o, "oncontextmenu");		
	},
	
	constructChart: function(){
		this.buildTitle();
		//this.buildToolbar();
		
		console.log ("chart type: " + this.chartDef.type);

		if (this.chartDef.plot === undefined) {
			this.chartDef.plot = {};
		}
		if (this.chartDef.plot.gap === undefined) {
			this.chartDef.plot.gap = 5;
		}
		if (this.chartDef.plot.markers === undefined) {
			this.chartDef.plot.markers = true;
		}
		if (this.chartDef.plot.labels === undefined) {
			this.chartDef.plot.labels = true;
		}
		
		if ((this.chartDef.xAxis.majorTicks === false) &&
			(this.chartDef.yAxis.majorTicks === false)) {
			this.theme.axis.majorTick = "";
		}
	},
	
	buildPieChart: function(){
		console.log ("ChartBuilder.buildChart. type is Pie");
			var divs = [];
			var row2divs = [];
			var row3divs = [];
			var charts = [];
			var label = null;
			var div = dojo.byId (this.id + "chart0");
			
			var table = dojo.doc.createElement("table");
			dojo.place (table, div, 0);
			var tableBody = dojo.doc.createElement("tbody");
			table.appendChild(tableBody);

			//TODO rename var names
			var chartRow = dojo.doc.createElement("tr");
			tableBody.appendChild(chartRow);			
			var labelRow = dojo.doc.createElement("tr");
			tableBody.appendChild(labelRow);
			var row3 = dojo.doc.createElement("tr");
			tableBody.appendChild(row3);
			//table.style.border = "0";
			if(this.rows !== null){
			var labels = this.makeXAxisLabels (this.chartDef.xAxis.dataColumn);
			var pieSize = null;
			if(this.chartDivSize){
				pieSize = {w: this.chartDivSize.w/this.rows.length-10, h: this.chartDivSize.h-50};
			}	
			for (var i=0; i<this.rows.length; i++) {	
				
				var td = dojo.doc.createElement("td"); 
			//	td.style.border = "0";	
				chartRow.appendChild(td);
				divs[i] = dojo.doc.createElement("div");
				divs[i].name = this.id + "chart" + (i+1);
				divs[i].id = this.id + "chart" + (i+1);	
				if(pieSize){
					divs[i].style.width = pieSize.w + 'px';
					divs[i].style.height = pieSize.h + 'px';	
				}else{
					divs[i].style.width = '200px';
					divs[i].style.height = '200px';
				}
				this.pieCMTargetNodeIds.push (divs[i]);
				
				td.appendChild(divs[i]);

				charts[i] = new dojox.charting.Chart2D(divs[i]);
				charts[i].setTheme(this.theme);				
				
				var plotParms = { 
					type: this.chartDef.type,  
					hAxis: this.chartDef.xAxis.id, 
					vAxis: this.chartDef.yAxis.id
				};
				dojo.mixin (plotParms, this.chartDef.plot);
				
				charts[i].addPlot("myChart"+i, plotParms); 			
								
				this.addXAxis (charts[i]);				
				this.addPieSlices (charts[i], i);
				this.addTooltips (charts[i], "myChart"+i);
				
				var anim_a = new dojox.charting.action2d.MoveSlice(charts[i], "myChart"+i);

				this.addEvents (charts[i], "myChart"+i);		
				charts[i].render(); 
				
				var row2td = dojo.doc.createElement("td"); 
				labelRow.appendChild(row2td);
				
				label = labels[i];
				if (label.text !== undefined) {
					dojo.place ("<div class='chartLabels' style='color: " + this.custom.xlabels.color + "'>"+label.text+"</div>", row2td, i);
				} 					
			}			
			}
					
			var temp = 0;
			var serverNames = this.makeXAxisLabels ("0");     //Argument is the Server Name Column id from widget file
			var oldServerName = serverNames[0];
			if(this.rows !== null){
			for (var j=0; j<this.rows.length; j++) {	
				var str = j.toString();
				if(oldServerName.text == serverNames[j].text) {					
					temp = temp + 1;	
				}
				
				if(oldServerName.text != serverNames[j].text || j == (this.rows.length - 1)) {					
					var row3td = dojo.doc.createElement("td"); 			
					row3td.colSpan = temp;
					row3.appendChild(row3td);
					if (oldServerName.text !== undefined) {
						dojo.place ("<div class='chartLabels'>"+oldServerName.text+"</div>", row3td, 0);
					}
						 
					oldServerName = serverNames[j];
					temp = 1;
					}					
				}					
			}			
			this.chart = charts[charts.length-1];
			this.charts = charts;
	},
	
	buildAxisChart: function(){
		var type = this.chartDef.type;
			console.log ("chart type: " + type);
			
			var divChart = dojo.byId (this.id + "chart0");
			if(!this.chartDivSize){
				divChart.style.width = '5000px';
				divChart.style.height = '5000px';
			}
			
			if(this.chartDef.chartProperties && this.chartDef.chartProperties.chartMargins){				
				var chartMargins = this.chartDef.chartProperties.chartMargins;
				for(var i=0;i<chartMargins.length;i++){
					if( dojo.isIE && chartMargins[i].browser=="IE"){
						this.chartDef.chartProperties.margins = chartMargins[i].marginValue;
					} 
					if ( dojo.isFF && chartMargins[i].browser=="FF") {
						this.chartDef.chartProperties.margins = chartMargins[i].marginValue;
					}
				}				
			}
			
			var chart = new dojox.charting.Chart2D(this.id + "chart0", this.chartDef.chartProperties);
			this.chart = chart;
			chart.removePlot("myChart");
			if (type == "dojot.visual.StackedColumnsEmbossed") {
				type = dojot.visual.StackedColumnsEmbossed;
			} else if (type == "dojot.visual.ColumnsEmbossed") {
				type = dojot.visual.ColumnsEmbossed;			
			} else if (type == "dojot.visual.ClusteredColumnsEmbossed") {
				type = dojot.visual.ClusteredColumnsEmbossed;			
			} else if (type == "dojot.visual.BarsEmbossed") {
				type = dojot.visual.BarsEmbossed;
			} else if (type == "dojot.visual.StackedBarsEmbossed") {
				type = dojot.visual.StackedBarsEmbossed;
			} else if (type == "dojot.visual.ClusteredBarsEmbossed") {
				type = dojot.visual.ClusteredBarsEmbossed;
			}

			this.addThresholdsPlot (chart);
			chart.setTheme(this.theme);
			
			console.log ("adding plot of type: ");
			console.log (type);
			
			var plotParms = { 
				type: type,  
				hAxis: this.chartDef.xAxis.id, 
				vAxis: this.chartDef.yAxis.id
			};
			
			dojo.mixin (plotParms, this.chartDef.plot);
			chart.addPlot("myChart", plotParms); 
			
			var plotObj = chart.stack[chart.plots.myChart];
			dojo.connect (plotObj, "_connectEvents", plotObj, this._connectEvents);
			this.addAxisLabel();
			this.addGrid (chart);    			
			

	},
	
	feedAxisChartData: function(){
			var chart = this.chart;
			this.addYAxis (chart);		
			this.addXAxis (chart);			
			
			console.log ("adding animations");
			var anim_1 = new dojox.charting.action2d.Shake(chart, "myChart");
			var anim_2 = new dojox.charting.action2d.Magnify(chart, "myChart", {scale: 1.5});
			this.addTooltips (chart, "myChart");
			this.addEvents (chart, "myChart");				
			this.addThresholdsData (chart);			
			this.chart.render();
	 		// this call to render is so that after we add the legend, it will show the legend colors.
 			// If we add the legend before we render then the legend will not show the colors.
 			// It will show an 'X' instead.	
	},
	
	buildChart: function () {
		console.log ("enter ChartBuilder.buildChart");
		var start = new Date();
		
		try {
		this.constructChart();
				
		if(this.chartDef.type == "Pie") {
			this.buildPieChart();	
		} else {	
			this.buildAxisChart();	
			this.feedAxisChartData();
		}
 		
//		if (this.chartDef.xAxis.label.value) {
//			this.setXAxisTitle(this.chart,this.chartDef.xAxis.id,this.chartDef.xAxis.label.value);
//		}
 		
 		
		if ((this.chartDef.legend.hidden !== undefined) && (this.chartDef.legend.hidden === false)) {
	 		console.log ("calling addLegend");
			this.addLegend (this.chart);

			// If we have a legend, then we must render once more (seems to be a dojo bug!)
			// If we render only after adding legend, then the legend has no colors for its 
			// labels.
			console.log ("calling chart.resize to render the chart after adding legend");			
		}
		
		// make sure we have called resize at least once
		// if we have already called it with this size, then this method will
		// return immediately.
		this.resize (this.initSize);
		
	 	var renderTime  = new Date() - start;
 		console.log ("renderTime: " + renderTime);

		this.configAutoUpdate();
 		
 		dojo.publish ("ChartBuilder.chartBuilt" + this.id, []);
 		
 		if(!this.standalone || (this.standalone && !this.ignoreContextMenu)){
			this.makeChartContextMenu();			
		}
 		
		console.log ("exit ChartBuilder.buildChart");
		} catch (e) {
			console.warn (e);	
			//alert (e);
			//alert(dojo.toJson(e));		
		}				
		
 		
 		return (this.chart); 
	},
	addThresholdsPlot: function (chart) {
		if ((this.dataset.thresholds !== undefined) &&
			(this.dataset.thresholds.length > 0)) {
			var plotParms = { 
				type: "Lines", 
				hAxis: this.chartDef.xAxis.id, 
				vAxis: this.chartDef.yAxis.id
//				hAxis: "hThresholdAxis", 
//				vAxis: "vThresholdAxis"
			};
			
			chart.addPlot("thresholds", plotParms);

			// update theme color
			if ((this.theme.colors) && (this.theme.colors != null)) {
				this.addThresholdColorsToTheme (this.dataset.thresholds);
			} else {
				this.addThresholdGradientsToTheme (this.dataset.thresholds);
			}
		}
	},
	addThresholdsData: function (chart) {
		console.log ("enter addThresholds");
		if ((this.dataset.thresholds !== undefined) &&
			(this.dataset.thresholds.length > 0)) {
			for (var i=this.dataset.thresholds.length - 1; i>=0; i--) {
				// do not understand why but for the colors to map right, we have to add the thresholds backwards
				console.log ("adding threshold: " + this.dataset.thresholds[i].label.value + ", " + this.dataset.thresholds[i].start);
				var seriesData = this.makeThresholdSeriesData(this.dataset.thresholds[i]);
				chart.addSeries(this.dataset.thresholds[i].label.value, seriesData, { plot: "thresholds" });
			}
		} else {
			console.log ("no thresholds to add");
		}
				
		console.log ("exit addThresholds");
	},
	addThresholdGradientsToTheme: function (thresholds) {
		this.resizeGradientArray();
		
		for (var i=0; i<thresholds.length; i++) {
			if (thresholds[i].color !== undefined) {
				this.theme.seriesThemes[this.chartDef.yAxis.series.length + i] = {fill: dojox.charting.Theme.generateGradient(this.theme.defaultFill, thresholds[i].color, thresholds[i].color)};
			}
		}
	},
	addThresholdColorsToTheme: function (thresholds) {
		console.log ("enter addThresholdColorToTheme");
		
		this.resizeColorArray();
		
		for (var i=0; i<thresholds.length; i++) {
			if (thresholds[i].color !== undefined) {
				this.theme.colors[this.chartDef.yAxis.series.length + i] = thresholds[i].color;
			}
		}
		
		console.log ("colors");
		console.log (this.theme.colors);
	},
	makeThresholdSeriesData: function (threshold) {
		var seriesData = [];
		// this.seriesLength is set by the addSeriesData
		// We will make the same number of data points as 
		// the y-axis series has, but a minimum of 2 so it 
		// will draw a line (a line needs 2 points!)
		for (var i=0; i<this.seriesLength || i<2; i++) {
			if(this.chartDef.type.indexOf("Bar")!=-1){
				seriesData.push ({
					x: Number(threshold.start),
					y: i
				});		
			}else{
				seriesData.push (Number(threshold.start));
			}
		}
		
		console.log ("seriesData: ");
		console.log (seriesData);

		return (seriesData);
	},
	resizeGradientArray: function () {
		console.log ("enter resizeGradientArray");
		var maxSize = this.chartDef.yAxis.series.length + this.dataset.thresholds.length;
		
		if (maxSize > this.theme.seriesThemes.length) {
			var seriesThemes = [];
			for (var i=0; i<maxSize; i++) {
				seriesThemes.push (this.theme.seriesThemes[i % this.theme.seriesThemes.length]);
			}
			
			this.theme.seriesThemes = seriesThemes;
		}
		
		console.log ("exit resizeGradientArray");
		console.log (this.theme.seriesThemes);
	},
	resizeColorArray: function () {
		console.log ("enter resizeColorArray");
		var maxSize = this.chartDef.yAxis.series.length + this.dataset.thresholds.length;
		
		if (maxSize > this.theme.colors.length) {
			var colors = [];
			for (var i=0; i<maxSize; i++) {
				colors.push (this.theme.colors[i % this.theme.colors.length]);
			}
			
			this.theme.colors = colors;
		}
		
		console.log ("exit resizeColorArray");
		console.log (this.theme.colors);
	},
	replaceData: function (rows) {
		console.log ("enter ChartBuilder.replaceData");
		this.rows = rows;
		this.chart.removeAxis (this.chartDef.xAxis.id);
		this.chart.removeAxis (this.chartDef.yAxis.id);
		this.addYAxis (this.chart);
		this.addXAxis (this.chart);
		this.addAxisLabel();
		if(this.chartDef.type == "Pie") {
			for(var i=0; i<this.rows.length; i++) {	
				this.addPieSlices (this.chart, i);
			}
		}
		this.chart.render(); 

//		if (this.chartDef.xAxis.label.value) {
//			this.setXAxisTitle(this.chart,this.chartDef.xAxis.id,this.chartDef.xAxis.label.value);	
//		}

		console.log ("exit ChartBuilder.replaceData");
	},
	configAutoUpdate: function () {

		if ((this.interval === null) && (this.updateMultiplier > 0) &&
			this.chartDef.common.autoUpdate) {
			var fnc = dojo.hitch (this, this.updateChartData);
		    var nextUpdate = this.getUpdateInterval();
		    this.interval = setTimeout(fnc, nextUpdate);
		} else {
            if ((this.interval !== null) && (!this.chartDef.common.autoUpdate)) {
                clearTimeout (this.interval);
                this.interval = null;
            }
	}
	},
    getUpdateInterval: function() {

      var nextUpdateInterval = this.runReportResponseTime * this.updateMultiplier;
      
      if ( nextUpdateInterval > this.updateMaxInterval ) {
        nextUpdateInterval = this.updateMaxInterval;
      } else if ( nextUpdateInterval < this.updateMinInterval ) {
        nextUpdateInterval = this.updateMinInterval;
      }
      return nextUpdateInterval;
    },
    addLegend: function (chart) {
		var legend = null;	
		
		var orientation = (this.chartDef.legend.orientation === "horizontal") ? true : false;
		try
		{			
		if ((this.chartDef.legend.hidden !== undefined) && (this.chartDef.legend.hidden === false)) {	
				
			var oldLegendNode = dijit.byId (this.id + "legend");		
			if(oldLegendNode) {
				oldLegendNode.destroy();
			}

			var legendDomNode = dojo.doc.createElement("div");
			legendDomNode.id = this.id + "legend";
			if(this.chartDef.legend.location === "right") {						
				orientation = false;
				dojo.place (legendDomNode, dojo.byId (this.id + "rightLegend"), 0);
					
			} else {						
				orientation = true;
				dojo.place (legendDomNode, dojo.byId (this.id + "bottomLegend"), 0);
			}					
			REVERSED_SERIES = /\.(StackedColumns|StackedAreas|ClusteredBars|ClusteredBarsEmbossed|StackedColumnsEmbossed)$/;	
			legend = new dojox.charting.widget.Legend({chart: chart, horizontal: orientation}, this.id + "legend");
		}
		}
		catch (e)
		{		
			console.error (e.message);
			
		}		
		this.legend = legend;
		return (chart);
	},
	hideLegend: function () {

		var rightLegend = dojo.byId(this.id + "rightLegend");
		var bottomLegend = dojo.byId(this.id + "bottomLegend");		

		dojo.style(rightLegend, 'display', 'none');		
		dojo.style(bottomLegend, 'display', 'none');	
	},
	updateLegend: function (chart) {

		var legend = this.legend;
		if(legend === null)
		{
			this.addLegend (this.chart);
			return;
		}
		if(this.chartDef.legend.location == "right") {				
			
			var rightLegend = dojo.byId (this.id + "rightLegend");			
			dojo.removeClass(dojo.byId(this.id + "legend"), "dojoxLegendHorizontal");

			//TODO how to set the value of the "Horizontal" attribute ?
			//legend.attr("horizontal", false);	
			dojo.place (dojo.byId(this.id + "legend"), rightLegend, 0);
			legend.refresh();			
			dojo.style(rightLegend, 'display', 'block');
		}else {
			
			var bottomLegend = dojo.byId (this.id + "bottomLegend");			
			dojo.place (dojo.byId(this.id + "legend"), bottomLegend, 0);
			//legend.attr("horizontal", false);
			legend.refresh();
			dojo.style(bottomLegend, 'display', 'block');				
			}
		this.legend = legend;
	},
	addEvents: function (chart, plotName) {
		console.log ("enter addEvents");
		chart.connectToPlot(
    		plotName,    // the unique plot name you specified when creating a plot
    		this,      // both object and method are the same used by dojo.connect()
    		this.onChartEvent       // you can supply a function without an object
		);
		
		console.log ("exit addEvents");
		return (chart);
	},
	addTooltips: function (chart, plotName) {
		console.log ("enter addTooltips");
		if ((this.chartDef.showTooltips) || (this.chartDef.showTooltips == "true")) {
			console.log ("adding tooltips");
			var anim_tooltip = new this.dc.action2d.Tooltip(chart, plotName);			
		} else {
			console.log ("not adding tooltips");
		}
		
		console.log ("exit addTooltips");
		return (chart);
	},
	addGrid: function (chart) {		
		console.log ("enter addGrid");	
 		if (this.chartDef.showGrid === true) {
 			console.log ("showGrid is true.  Adding grid");					
 			chart.addPlot("Grid", {type: "Grid",
		      	hAxis: this.chartDef.xAxis.id,
      			vAxis: this.chartDef.yAxis.id,
      			hMajorLines: true,
				hMinorLines: true,
      			vMajorLines: true,
      			vMinorLines: true
			});
		} else {
			console.log ("not adding grid");
		}
		
		return (chart);
	},
	
	getTextBoxCoords: function(text, style){		
		var node =  dojo.doc.createElement("div");
		var nodeStyle = {
			position: "absolute",
			top: "-10000px",
			left: "0",
			borderWidth: "0",
			margin: "0",
			padding: "0",
			outline: "0"
		};
		dojo.mixin(nodeStyle, style);		
		dojo.style (node, nodeStyle);
		dojo.body().appendChild(node);		
		node.innerHTML = text;
		var coords = dojo.marginBox(node);
		dojo.destroy(node);		
		return coords;		
	},
	
	getLabelCoords: function(labels, font, isHorizontal){
		var text = null;
		if(isHorizontal){
			text = labels.join();
		}else{
			text = labels.join("<br>");
		}
		return this.getTextBoxCoords(text, {font: font,whiteSpace:"nowrap"});	
	},
	
	truncateLabels: function(labels, font, width){		
		var labelWidth = this.getLabelCoords(labels,font,true).w;
		var rate = width/labelWidth;		
		if(labelWidth<=width){
			return labels;
		}else{
			var truncateLabels = [];
			for(var i=0; i<labels.length; i++){
				var chartCount = labels[i].length;				
				truncateLabels[i] = labels[i].substring(0,Math.floor(rate*chartCount));			
			}	
			return truncateLabels;
		}		
	},
	
	getMajorTickStep: function(){		
		//var font = "normal normal normal 7pt Tahoma";
		var majorTickStep = null;
		var font = this.chart.theme.axis.tick.font;		
		var labels = dojox.lang.functional.map(this.labels, function(label){ return label.text; });			
		if(this.chartDef.type == "Lines" || this.chartDef.type.indexOf("Columns")!=-1){
			var labelTotalLength = this.getLabelCoords(labels,font,true).w;
			if(labelTotalLength/(this.chartDivSize.w-200) > this.labels.length){ //200 = this.chart.offsets.l + this.chart.offsets.r
				majorTickStep = this.labels.length-1;
			}else{
				majorTickStep = Math.ceil(labelTotalLength/(this.chartDivSize.w-200));
			}			
		}else{
			var labelTotalHeight = this.getLabelCoords(labels,font,false).h;
			if(labelTotalHeight/(this.chartDivSize.h-100) > this.labels.length){ //100 = this.chart.offsets.t + this.chart.offsets.b
				majorTickStep = this.labels.length-1;
			}else{
				majorTickStep = Math.ceil(labelTotalHeight/(this.chartDivSize.h-100));
			}			
		}
		return majorTickStep;
	},
	
	
	addXAxis: function (chart) {
		console.log ("enter ChartBuilder.addXAxis");
		var labels = this.makeXAxisLabels (this.chartDef.xAxis.dataColumn);
		this.labels = labels;
		console.log ("labels: " + dojo.toJson (labels));
		if (this.chartDef.xAxis.minorLabels === undefined) {
			this.chartDef.xAxis.minorLabels = false;
		}
		if (this.chartDef.xAxis.majorLabels === undefined) {
			this.chartDef.xAxis.majorLabels = true;
		}
		
		if ((this.chartDef.xAxis.minorTicks === undefined) || (this.chartDef.xAxis.minorTicks === false)) {
			this.chartDef.xAxis.minorTicks = false;
		} 
		
		if (this.chartDef.xAxis.majorTicks === undefined) {
			this.chartDef.xAxis.majorTicks = true;
		} 
		var majorTickStep = null;
		if(this.chartDivSize){
			if((!this.chartDef.xAxis.rotation || this.chartDef.xAxis.rotation==0) && this.chartDef.type != "Pie"){
				if(!this.chartDef.xAxis.majorTickStep){					
					majorTickStep = this.getMajorTickStep();				
				}else if(this.chartDef.type == "Lines" || this.chartDef.type.indexOf("Columns")!=-1){
					var labels2 = dojox.lang.functional.map(this.labels, function(label){ return label.text; });	
					var labels3 = this.truncateLabels(labels2, this.chart.theme.axis.tick.font, this.chartDivSize.w-200);				
					for(var i=0;i<labels.length;i++){
						labels[i].text = labels3[i];
					}
				}
			}
		}
		
		console.log ("majorTicks: " + this.chartDef.xAxis.majorTicks);
		console.log ("minorTicks: " + this.chartDef.xAxis.minorTicks);
		
		console.log ("xAxis.majorLabels: " + this.chartDef.xAxis.majorLabels);
		console.log ("xAxis.minorLabels: " + this.chartDef.xAxis.minorLabels);
		console.log ("before addYAxis color");
		var color = this.custom.xlabels.color;
		console.log ("addYAxis color: " + color);
		var axisParms = { 
			fontColor: color,
			majorTickStep: majorTickStep 
		};
		
		if ((this.chartDef.type == "StackedBars") || (this.chartDef.type == "Bars") || (this.chartDef.type == "ClusteredBars") ||
			(this.chartDef.type == "dojot.visual.StackedBarsEmbossed") || (this.chartDef.type == "dojot.visual.BarsEmbossed") || (this.chartDef.type == "dojot.visual.ClusteredBarsEmbossed")) {
			axisParms.vertical = true;
			axisParms.labels = labels;
			dojo.mixin (axisParms, this.chartDef.xAxis);
			chart.addAxis(this.chartDef.xAxis.id, axisParms);
		} else if ((this.chartDef.type == "Columns") || (this.chartDef.type == "StackedColumns") || (this.chartDef.type == "ClusteredColumns")) {
			axisParms.vertical = false;
			axisParms.labels = labels;
			dojo.mixin (axisParms, this.chartDef.xAxis);
			chart.addAxis(this.chartDef.xAxis.id, axisParms);
		} else if (this.chartDef.type == "Lines") {	
			axisParms.labels = labels;
			dojo.mixin (axisParms, this.chartDef.xAxis);
			chart.addAxis(this.chartDef.xAxis.id, axisParms);
		} else if ((this.chartDef.type == "dojot.visual.StackedColumnsEmbossed") || (this.chartDef.type == "dojot.visual.ColumnsEmbossed") ||
				   (this.chartDef.type == "dojot.visual.ClusteredColumnsEmbossed") || (this.chartDef.type == "Columns")) {
			console.log ("add x axis for stacked columns embossed");						
			axisParms.labels = labels;
			dojo.mixin (axisParms, this.chartDef.xAxis);
			chart.addAxis(this.chartDef.xAxis.id, axisParms);
		} else if (this.chartDef.type == "Pie") {
			axisParms.labels = labels;
			dojo.mixin (axisParms, this.chartDef.xAxis);
			chart.addAxis(this.chartDef.xAxis.id, axisParms);
		} else {
			console.error ("Unsupported chart type: " + this.chartDef.type);
		}
		
		console.log ("exit ChartBuilder.addXAxis");
		return (chart);
	},
	addPieSlices: function (chart, rowNumber, update) {
		var isUpdate = (update === undefined) ? false : update;
		if (!isUpdate) {
			chart.addAxis(this.chartDef.yAxis.id, {vertical: true});
		}
		var series = null;		
		var resultPie = [];

		for (var i in this.chartDef.yAxis.series) {
			if (i) {
				series = this.chartDef.yAxis.series[i];
				//resultPie[i] = this.makeMultiPieSeriesData (rowNumber, series.dataColumn, series.textColumn, series.tooltipColumn);
				resultPie[i] = this.makeMultiPieSeriesData (rowNumber, series.dataColumn, series.label.value, series.tooltipColumn);
			
			if (isUpdate) {
			    	chart.updateSeries (series.label.value, resultPie[i]);
			    } else {
					chart.addSeries(series.label.value, resultPie, { plot: "myChart"+rowNumber });
				}
			}
		}
		return (chart);	
	},
	addYAxis: function (chart, update, pieFlag) {
		console.log ("enter addYAxis (..., update, pieFlag): " + update + ", " + pieFlag);
		// e.g.,
		// chart1.addAxis("other y", {vertical: true,
      	//	leftBottom: false,
      	//	max: 7,
      	//	stroke: "green",
      	//	font: "normal normal bold 14pt Tahoma",
      	//	fontColor: "red",
      	//	majorTick: {color: "red", length: 6},
		//    minorTick: {stroke: "black", length: 3}
		// });
		console.log ("before addYAxis color");
		var color = this.custom.ylabels.color;
		console.log ("addYAxis color: " + color);
		
		var isUpdate = (update === undefined) ? false : update;
		
		if (!isUpdate) {
			var vertical = true;
			if ((this.chartDef.type == "StackedBars") || (this.chartDef.type == "Bars") || (this.chartDef.type == "ClusteredBars") ||
				(this.chartDef.type == "dojot.visual.StackedBarsEmbossed") || (this.chartDef.type == "dojot.visual.BarsEmbossed") || (this.chartDef.type == "dojot.visual.ClusteredBarsEmbossed")) {	
				vertical = false;			
			}
				    	
//			chart.addAxis(this.chartDef.yAxis.id, {min: 0, vertical: true, fontColor: color});
			var axisParms = { 
				vertical: vertical,
				fontColor: color
			};
			
			if (this.chartDef.yAxis.minorLabels === undefined) {
				this.chartDef.yAxis.minorLabels = false;
			}
			if (this.chartDef.yAxis.majorLabels === undefined) {
				this.chartDef.yAxis.majorLabels = true;
			}
			if (this.chartDef.yAxis.minorTicks === undefined) {
				this.chartDef.yAxis.minorTicks = false;
			} 
			if (this.chartDef.yAxis.majorTicks === undefined) {
				this.chartDef.yAxis.majorTicks = true;
			} 
		
			console.log ("majorTicks: " + this.chartDef.yAxis.majorTicks);
			console.log ("minorTicks: " + this.chartDef.yAxis.minorTicks);
		
			console.log ("xAxis.majorLabels: " + this.chartDef.yAxis.majorLabels);
			console.log ("xAxis.minorLabels: " + this.chartDef.yAxis.minorLabels);

			dojo.mixin (axisParms, this.chartDef.yAxis);
			
			chart.addAxis(this.chartDef.yAxis.id, axisParms);
	    }
	     
		var series = null;
		var seriesData = null;
		var resultBars = null;
		
		for (var i in this.chartDef.yAxis.series) {
			if (i) {
				series = this.chartDef.yAxis.series[i];				
				seriesData = this.makeSeriesData (series.dataColumn);	

				if (isUpdate) {
					console.log ("ChartBuiler.addYAxis.  calling updateSeries with seriesData: ");
					console.log (seriesData);
			    	chart.updateSeries (series.label.value, seriesData);
			    } else {					 											
					console.log ("ChartBuiler.addYAxis.  calling addSeries with seriesData: ");
					console.log (dojo.toJson(seriesData));
					chart.addSeries(series.label.value, seriesData, { plot: "myChart" });
				}
			}
		}
		
		console.log ("exit addYAxis");
		return (chart);
	},
	addAxisLabel: function(){
		var vertical = true;
		if ((this.chartDef.type == "StackedBars") || (this.chartDef.type == "Bars") || (this.chartDef.type == "ClusteredBars") ||
				(this.chartDef.type == "dojot.visual.StackedBarsEmbossed") || (this.chartDef.type == "dojot.visual.BarsEmbossed") || (this.chartDef.type == "dojot.visual.ClusteredBarsEmbossed")) {	
				vertical = false;			
		}
		if (this.chartDef.type !== "Pie"){
			var node_y = dojo.byId(this.id + "axistitle");
			var node_x = dojo.byId(this.id + "axistitle_X");
			if (node_y && this.chartDef.yAxis.label && this.chartDef.xAxis.label) {
				if(vertical == true){
					node_y.innerHTML = this.chartDef.yAxis.label.value;
					dojo.addClass(node_y, this.chartDef.yAxis.label.cssClass);
					node_x.innerHTML = this.chartDef.xAxis.label.value;
					dojo.addClass(node_x, this.chartDef.xAxis.label.cssClass);
				}else{
					node_y.innerHTML = this.chartDef.xAxis.label.value;
					dojo.addClass(node_y, this.chartDef.xAxis.label.cssClass);
					node_x.innerHTML = this.chartDef.yAxis.label.value;
					dojo.addClass(node_x, this.chartDef.yAxis.label.cssClass);
				}
			} else {
				console.log ("cannot find node_y for "+this.id + "axistitle");
			}
		}
	},
	onChartEvent: function (event) {	
		if(event.type == "oncontextmenu"){
			/*
			var menuEvent = {};
			menuEvent.coords = {};
			menuEvent.target = event.event.target ? event.event.target : event.event.srcElement;
			menuEvent.coords.x = event.event.clientX;
			menuEvent.coords.y = event.event.clientY;
			*/	
			if(this.chartMenu){
				this.chartMenu.contextMenuOpen(event.event, this.getSelectedData(event));
			}
		}
		if (event.type == "onclick") {
		//	if (event.event.detail == 2) {
		//		clearTimeout(this.timeVar);
				this.getTrigger (event.hAxis, event.vAxis, event.type);				
					if (this.trigger.type == "DrillDown") {
						var builder = this.drillDown(this.trigger.reference);
						this.objReassign.call(builder);	

					} else if (this.trigger.type == "PORTAL_PAGE") {
						this.launchPage(this.trigger);

					} else if (this.trigger.type == "PORTLET") {
						this.launchPortlet(this.trigger);

					} else if (this.trigger.type == "WEB_URL") {		
						this.launchURL (this.trigger);

					} else if (this.trigger.type == "CLIENT_EVENT") {					
						this.sendEvent(this.trigger);

					} else if (this.trigger.type == "javascript") {
						this.handleJavaScriptTrigger (this.trigger, event);
					} else {
						console.error ("unknown Trigger type: " + this.trigger.type);
					}
				
			/*}
			else {
				this.timeVar = setTimeout(this.getTrigger (event.hAxis, event.vAxis, event.type), 250);				
				if (this.trigger !== null) {
					if (this.trigger.type == "javascript") {
						this.handleJavaScriptTrigger (this.trigger, event);
					} else {
						console.error ("unknown Trigger type: " + this.trigger.type);
				}
			}
			}*/
		}
	},
	launchURL: function(trigger) 
    {
      console.log ("enter launchURL");
      window.open (trigger.url);
    },	
	launchPortlet: function (trigger) 
   {		
      console.log ("enter launchPortlet");
      var portletEvent = {
                            name: "http://ibm.com/isclite#launchPortlet",
                            portletName: trigger.portletName,
                            portletApplicationID: trigger.portletApplicationId
                         };

      if (trigger.portletParameters) 
      {
         for (var j=0; j<trigger.portletParameters.length; j++) 
         {
			 try{
				 eval ("portletEvent." + trigger.portletParameters[j].id + "= '" + trigger.portletParameters[j].value + "'");
             }catch(e){
				 //tipChartsAll.js has variable names in a different format, so, eval will not work
             	portletEvent[trigger.portletParameters[j].id] = trigger.portletParameters[j].value;
             }
         }
      }

      try 
      {
         EventBroker.sendEvent (this.global.iscPortletNamespace, portletEvent);
      } catch (e) {
         console.error ("Caught javascript exception in ChartBuilder.launchPortlet: " + e);
         alert (e);
      }
   },
   
   launchPage: function (trigger) 
   {	  
      var pageEvent = {
                         name: "http://ibm.com/isclite#launchPage",
                         NavigationNode: trigger.pageId,
                         pageInstanceRef: null,
                         switchPage: true
                      };

      if (trigger.pageParameters) 
      {
         for (var k=0; k<trigger.pageParameters.length; k++) 
         {
			 try{
				 eval ("pageEvent." + trigger.pageParameters[k].id + "= '" + trigger.pageParameters[k].value + "'");
             }catch(e){
				  //tipChartsAll.js has variable names in a different format, so, eval will not work
             	pageEvent[trigger.pageParameters[k].id] = trigger.pageParameters[k].value;//shakeel
             }
         }
      }

      try 
      {
         EventBroker.sendEvent (this.global.iscPortletNamespace, pageEvent);
      } catch (ex) {
         console.error ("Caught javascript exception in ChartBuilder.launchPage: " + ex);
         alert (ex);
      }
   },
   
   sendEvent: function (trigger) 
   {
      var parms = trigger.payload;
      var event = {
                     name: trigger.eventName
                  };

      if (trigger.payload) 
      {
         for (var i=0; i<parms.length; i++) 
         {
            try{
                eval ("event." + parms[i].id + "= '" + parms[i].value + "'");
             }catch(e){
             	event[parms[i].id] = parms[i].value;
             }
         }
      }

	  console.log ("ChartBuilder: sending event: ");            
	  console.log (event);
      EventBroker.sendEvent (this.global.iscPortletNamespace, event);
    },
	
	getDrillDown: function (drillDownId) {		
		for (var i=0; i<this.widgetDefinition.drillDown.length; i++) {
				if (this.widgetDefinition.drillDown[i].id == drillDownId) {					
					return (this.widgetDefinition.drillDown[i]);
				}
		}		
		return (null);
	},

	getDrillUp: function (chartIdWithCount) {		
		for (var i=0; i<this.drillUpItems.length; i++) {				
				if(this.drillUpItems[i].chartIdWithCount == chartIdWithCount) {						
					return (this.drillUpItems[i]);
				}
		}		
		return (null);
	},

	objReassign: function() {
		console.log("builder");
		console.log(this);
	},	

	drillUp: function(chartIdWithCount) {		
		var drillUpObj = this.getDrillUp(chartIdWithCount);
		
		if(drillUpObj !== null) {
			/*
			var encodedChartId = encodeURIComponent(drillUpObj.chartId);
			var encodedProviderId = encodeURIComponent(drillUpObj.providerId);		
			var encodedDatasourceId = encodeURIComponent(drillUpObj.datasourceId);
			var encodedVersion = encodeURIComponent(drillUpObj.version);
			*/
			if(!this.global.widgetFetcher){
				this.global.widgetFetcher = new ibm.tivoli.tip.charts.dojo.WidgetFetcher ({
					global: this.global
				});
			}	
			var fetcher = this.global.widgetFetcher;			
			/*
			var domNode = dojo.byId (this.global.namespace+"widget");
			this.destroy();
			dojo.empty(domNode);
			dojo.place (domNode, dojo.byId (this.global.namespace + "birtChartWidget"), "after");
			*/
			this.destroyRecursive();		
			var domNode = dojo.byId (this.global.namespace+"widgetDiv");		
			dojo.destroy(domNode);
			domNode = dojo.doc.createElement("div");
			domNode.id = this.global.namespace+"widgetDiv";
			dojo.byId (this.global.namespace + "widgetContainer").appendChild(domNode);
			
			var newDrillUpArray = [];
			
			for (var i=0; i<this.drillUpItems.length; i++) {	
				
				if(this.drillUpItems[i].chartIdWithCount == drillUpObj.chartIdWithCount) {	
					break;
				}
				newDrillUpArray[i] = this.drillUpItems[i];
			}				
						
			
			var builder = fetcher.buildWidget(drillUpObj.providerId, drillUpObj.datasourceId, drillUpObj.chartId, domNode, drillUpObj.version, null, newDrillUpArray);
			
			this.global.builder = builder;
			return builder;
		}
		return this;

	},
	
	drillDown: function(drillDownId) {

		var drillDownObj = this.getDrillDown(drillDownId);
		if(drillDownObj !== null) {
			/*
			var encodedCID = encodeURIComponent(drillDownObj.widgetId);
			var encodedProviderID = encodeURIComponent(drillDownObj.provider);	
					
			var encodedDS = null;
			if(drillDownObj.connectionID != undefined)
			{
				encodedDS = encodeURIComponent(drillDownObj.connectionID);			
			}
			else 
			{
				if(drillDownObj.datasource == this.widgetDefinition.datasource.type)
				{
					encodedDS = encodeURIComponent(this.datasourceID);
				}
			}
			*/
			var widgetId = drillDownObj.widgetId;
			var providerId = drillDownObj.provider;
			var datasourceId = null;
			if(drillDownObj.connectionID != undefined){
				datasourceId = drillDownObj.connectionID;			
			}else if(drillDownObj.datasource == this.widgetDefinition.datasource.type){				
				datasourceId = this.datasourceID;				
			}
			
			if(!this.global.widgetFetcher){
				this.global.widgetFetcher = new ibm.tivoli.tip.charts.dojo.WidgetFetcher ({
					global: this.global
				});
			}	
			var fetcher = this.global.widgetFetcher;
			/*
			var domNode = dojo.byId (this.global.namespace+"widget");
			this.destroy();
			dojo.empty(domNode);
			dojo.place (domNode, dojo.byId (this.global.namespace + "birtChartWidget"), "after");
			*/
			this.destroyRecursive();		
			var domNode = dojo.byId (this.global.namespace+"widgetDiv");		
			dojo.destroy(domNode);
			domNode = dojo.doc.createElement("div");
			domNode.id = this.global.namespace+"widgetDiv";
			dojo.byId (this.global.namespace + "widgetContainer").appendChild(domNode);
						
			var drillUpLength = this.drillUpItems.length;
			var idCount = 1;
			for (var i=0; i<this.drillUpItems.length; i++) {				
				if(this.drillUpItems[i].chartId == this.chartDef.id) {
					idCount = idCount + 1;
				}
			}
				
			this.drillUpItems[drillUpLength] = {
				"chartId": this.chartDef.id,
				"providerId": this.widgetDefinition.provider.label.key,
				"datasourceId": this.datasourceID,
				"version": this.widgetDefinition.meta.version,
				"idCount": idCount,
				"chartIdWithCount": this.chartDef.id + "(" + idCount + ")"
			};			
			
			var builder = fetcher.buildWidget(providerId, datasourceId, widgetId, domNode, drillDownObj.version, null, this.drillUpItems);
			
			this.global.builder = builder;
			return builder;
		}
		return this;
	},
	// TODO: Using a closure, add context to calling of trigger.  
	// (i.e., pass event to trigger function).
	handleJavaScriptTrigger: function (trigger, event) {
		trigger.script = this.substituteTriggerKeywords (trigger.script);
		eval (trigger.script);
	},
	substituteTriggerKeywords: function (map) {
		console.log ("trigger before substitution: " + map);
		map = map.replace (/<iscPortletAPI:namespace\/>/g, this.global.iscPortletNamespace);
		map = map.replace (/<portlet:namespace\/>/g, this.namespace);
		map = map.replace (/<script>/gi," <br> <script defer>");
		console.log ("trigger after substitution: " + map);
		
		return (map);
	},
	getTrigger: function (xAxis, yAxis, triggerName) {
		
		//if (this.chartDef.yAxis.id == yAxis) {		
			for (var i=0; i<this.chartDef.yAxis.triggers.length; i++) {
				if (this.chartDef.yAxis.triggers[i].id == triggerName) {
					this.trigger = this.chartDef.yAxis.triggers[i];					
					return (this.chartDef.yAxis.triggers[i]);
				}
			}
		//}
		
		return (null);
	},
	updateMetaData: function () {
		var lastUpdated = new Date();
		var msg = dojo.string.substitute(this.resources_.LAST_UPDATED, { 0: dojo.date.locale.format(lastUpdated) });
		this.metaDiv.innerHTML = "<p class=\"lastUpdated\">" + msg + "</p>";
	},
	updateChartDef: function () {
		this.chartDef.description.value = this.widgetDefinition.user.charts[0].description.value;
		this.chartDef.label.value = this.widgetDefinition.user.charts[0].label.value;
		this.chartDef.common = this.widgetDefinition.user.charts[0].common;
		this.chartDef.legend.hidden = this.widgetDefinition.user.charts[0].legend.hidden;
		this.chartDef.legend.location = this.widgetDefinition.user.charts[0].legend.location;	
	},
	update: function (prefs, newWidgetDef) {		
		this.widgetDefinition = newWidgetDef;
		this.updateChartDef();
		if(prefs.charts[0].type) {			
			if(this.chartDef.type != prefs.charts[0].type) {				
				this.chartDef.type = prefs.charts[0].type;				
				this.chart = null;
				var div = dojo.byId (this.id + "chart0");
				console.log(div);
				dojo.html._emptyNode(div);
				this.buildChart();
			}
		}		
		
					
		this.setTitle (this.chartDef.label.value);	
		
		if(this.chartDef.legend.hidden === false) {
			this.updateLegend (this.chart);		
		} else if(this.chartDef.legend.hidden === true) {
			this.hideLegend();
		}

		this.updateMetaData();
		if (prefs.charts[0].common.showLastUpdateTime) {
			dojo.style (this.metaDiv, "display", "");
		} else {
			dojo.style (this.metaDiv, "display", "none");
		}

		if(this.widgetDefinition.user.datasets[0].parameters.length > 0){
			this.parameters = this.widgetDefinition.user.datasets[0].parameters;
			this.updateChartData();
		}

		this.dataset = this.getDataSet (this.dataSetID);	
		this.configAutoUpdate();
			
	},
	buildTitle: function () {
		console.log ("enter ChartBuilder.buildTitle");
		if (this.standalone && !this.ignoreTitlebar) {
			console.log ("building titlebar");
			var titleBar = new ibm.tivoli.tip.charts.dijit.ChartTitle ({
					title: this.chartDef.label.value,
					chartid: this.id,
					namespace: this.namespace
				}, dojo.byId (this.id + "title"));
		} else {
			console.log ("not building titlebar");
			if ((this.widgetDefinition.user !== undefined) && (this.widgetDefinition.user.charts !== undefined)) {			
				if (this.widgetDefinition.charts[0].id == this.widgetDefinition.user.charts[0].id) {
				this.chartDef.label.value = this.widgetDefinition.user.charts[0].label.value;
				this.chartDef.description.value = this.widgetDefinition.user.charts[0].description.value;
			}		
			}else {
				if ((this.widgetDefinition.shared !== undefined) && (this.widgetDefinition.shared.charts !== undefined)) {			
				if (this.widgetDefinition.charts[0].id == this.widgetDefinition.shared.charts[0].id) {
				this.chartDef.label.value = this.widgetDefinition.shared.charts[0].label.value;
				this.chartDef.description.value = this.widgetDefinition.shared.charts[0].description.value;
				}
			}			
			}		
			this.setTitle (this.chartDef.label.value);
		}
		console.log ("exit ChartBuilder.buildTitle");
	},
	setTitle: function (title) {
		console.log ("enter ChartBuilder.setTitle");
		if ((this.global.iscPortletNamespace === undefined) || (this.global.iscPortletNamespace === null)) {
			//var titleBar = dijit.byId (this.id + "title");
		} else {			
			var tipHelper = new ibm.tivoli.tip.dojo.TIPHelper();
			tipHelper.setPortletTitle (this.domNode, title);
		}
		console.log ("exit ChartBuilder.setTitle");
	},
	buildToolbar: function () {
		console.log ("enter ChartBuilder.buildToolbar");
		if(this.toolbarSelf === null && (!this.standalone || (this.standalone && !this.ignoreToolbar))) {
			console.log ("creating chartToolbar. global: " + this.global);
			var toolbar = new ibm.tivoli.tip.charts.dijit.ChartToolbar ({
				chartFetcher: this.chartFetcher,
				toolbarHidden_: this.chartDef.toolbar.hidden,
				chartBuilder: this,
				global: this.global
			}, dojo.byId (this.id + "toolbar"));
			this.toolbarSelf = toolbar;
		}
		console.log ("exit ChartBuilder.buildToolbar");
	},
	getToolbar: function () {
		var toolbarWidget = dijit.byId (this.id + "toolbar");
		if(toolbarWidget!==undefined && toolbarWidget!==null){
			return (toolbarWidget.getToolbar());
		}
	},
	buildPager: function (rowCount) {
		if(this.chartDef.common.paging){
			if(rowCount>this.chartFetcher.rowsPerPage){
				var pager = new ibm.tivoli.tip.charts.dijit.ChartPager ({
					chartBuilder: this,
					chartDef: this.chartDef,
					chartFetcher: this.chartFetcher 
				}, dojo.byId (this.id + "pager"));
				this.chartPager = pager;
				pager.startup();
			}
		}		
	},
	fetchChartData: function () {
		console.log ("Enter fetchChartData");
	    var busyPane = dijit.byId(this.global.namespace+"busy_pane");
	    if ( busyPane ) {
	      console.log ("showing busypane");
	      busyPane.show(true); // size to portlet
		}
	    
		this.chartFetcher = new ibm.tivoli.tip.charts.dojo.ChartFetcher ({
			global: this.global, 
			chartPreferences: this.chartPreferences,
			chartDef: this.chartDef,
			rowsPerPage: this.chartDef.common.pagingSize,
			widgetDefinition: this.widgetDefinition,
			providerID: this.providerID,
			chartParams: this.widgetDefinition.datasets[0].parameters,
			datasourceID: this.datasourceID	
		});
		
		this.buildToolbar();
		
		if(!this.standalone) {
			//dojo.require ("ibm.tivoli.tip.chartportlet.dijit.DojoChartWidget");
			this.chartUtil = new ibm.tivoli.tip.charts.dojo.DojoChartUtil ({
				namespace: this.global.namespace,
				chartBuilder: this,
				providerID: this.providerID,
				datasourceID: this.datasourceID,
				savePrefsOption: false
			});
		}
		
		dojo.subscribe ("ChartFetcher.dataFetched" + this.chartFetcher.id, dojo.hitch (this, this.afterFetch)); 
		//this.chartFetcher.fetchData();
		dojo.subscribe ("ChartFetcher.totalRowsFetched" + this.chartFetcher.id, dojo.hitch (this, this.buildPager));	
		if(this.chartDef.common.paging){		
			this.chartFetcher.fetchData(0,this.chartFetcher.rowsPerPage);
		}else{
			this.chartFetcher.fetchData();
		}
		console.log ("Chart data fetched");
	},        
	
	updateChartData: function (event) {
		console.log ("enter ChartBuilder.updateChartData");
		if (this.interval !== null) {
        	clearTimeout (this.interval);
            this.interval = null;
        }		
		//dojo.subscribe ("ChartFetcher.dataFetched" + this.chartFetcher.id, dojo.hitch (this, this.afterFetch));
		
		if ((event !== undefined) && (event !== null)  && (event != 0)) {
			console.log ("ChartBuilder.updateChartData: using parameters from event to update chart data");
			this.chartFetcher.chartParams = this.eventParametersToRestParameters (event);
			//this.chartFetcher.fetchData();	
		} else if(this.parameters !== undefined && this.parameters !== null) {		
			console.log ("ChartBuilder.updateChartData: using parameters from prefs/widget def to update chart data");
			this.chartFetcher.chartParams = this.parameters;
			//this.chartFetcher.fetchData();	
		} else {
			console.info ("no parameters for updateChartData");
		}
		if(this.chartPager){
	    	this.chartPager.onRefresh();
	    }else{
	    	this.chartFetcher.fetchData();
	    }
		console.log ("exit ChartBuilder.updateChartData");
	},
	
	updateChartByTimeSet: function(time){		
		this.global.restTimeParam = {
			id: "Time",
			value: time
		};
		/*
		if(this.parameters){
			this.chartFetcher.chartParams = this.parameters;
		}
		*/		
		if(this.chartPager){
	    	this.chartPager.onRefresh();
	    }else{
	    	if(this.chartDef.common.paging){				
				this.chartFetcher.fetchData(0,this.chartFetcher.rowsPerPage);
			}else{
				this.chartFetcher.fetchData();
			}	    	
	    }
	},
	
	/*
	eventParametersToRestParameters: function (event) {
		console.log ("enter ChartBuilder.eventParametersToRestParameters: ");
		var restParams = [];
		var param = null;
		
		for (var i in event) {
			param = {};
			param.id = i;
			param.value = event[i];
			restParams.push (param);
		}
		
		console.log ("exit ChartBuilder.eventParametersToRestParameters: ");
		console.log (restParams);
		
		return (restParams);
	},
	*/
	
	getChart: function () {
		return (this.chart);
	},
	initialSize: function () {
		var vp = dijit.getViewport();
		var coords = dojo.coords (dojo.byId (this.id + "pager"));
		vp.h = vp.h - coords.h;
		coords = dojo.coords (dojo.byId (this.id + "legend"));
		vp.h = vp.h - coords.h;
		
		dojo.style (dojo.byId (this.id + "chart"), "width", vp.w);
		dojo.style (dojo.byId (this.id + "chart"), "height", vp.h);
		
	},
	resize: function (size, forceResize) {
		size = dojo.clone (size);		// clone the size because we will adjust it and do not want to affect the local variable
		console.log ("enter ChartBuilder.resize: ");
		console.log (size);
		
		if (this.chart !== null) {
			if ((size === undefined) || (size === null) || (size.w === undefined) || (size.h === undefined)) {
				if ((this.global.iscPortletNamespace === undefined) || (this.global.iscPortletNamespace === null)) {
					console.log ("ChartBuilder.resize: getting viewport size");
					var vp = dijit.getViewport();
					size = { w: vp.w, h: vp.h };	
				} else {
					console.log ("ChartBuilder.resize: getting iscPortlet size");
					var portletSize = iscPortlet.getPortletSize(this.global.iscPortletNamespace);
					size = { w: portletSize.available.w, h: portletSize.available.h };
				}
			} else {
				console.log ("ChartBuilder.resize: using size passed into resize");
			}

			if(forceResize || !this._currentSize || this._currentSize.w != size.w || this._currentSize.h != size.h){
				console.log ("sizing chart using base size: ");
				console.dir (size);
				
				this._currentSize = dojo.clone(size);
				dojo.style (this.domNode, {
					"width": size.w + "px",
					"height": size.h + "px"
				});

				var coords;			
				if(this.chartPager){
					coords = dojo.coords (dojo.byId (this.id + "pager"));
					size.h = size.h - coords.h;
				}
			
				if (this.chartDef.common.showLastUpdateTime) {
					coords = dojo.coords (this.metaDiv);
					size.h = size.h - 25;				
				} 
			
				var toolbarWidget = dijit.byId (this.id + "toolbar");
				if (toolbarWidget !== undefined && toolbarWidget !== null) {
					coords = dojo.coords (dojo.byId (this.id + "toolbar"));
					size.h = size.h - coords.h;
				}

				if(this.standalone && !this.ignoreTitlebar){
					coords = dojo.coords (dojo.byId (this.id + "title"));
					size.h = size.h - coords.h;
				}
			
				dojo.style (dojo.byId (this.id + "chartContainer"), {
					"width": size.w + "px",
					"height": size.h + "px"
				});
				var axisLabel = this.chartDef.yAxis.label;
				if(axisLabel && axisLabel.value && axisLabel.value != ""){
					var yAxisTitleNode = dojo.byId (this.id + "axistitle");
					if(this.chartDef.type != "Pie") {
						yAxisTitleNode.style.width = "20px";
					}
					coords = dojo.coords (yAxisTitleNode);
					size.w = size.w - coords.w;
				}
				axisLabel = this.chartDef.xAxis.label;
				if(axisLabel && axisLabel.value && axisLabel.value != ""){
					coords = dojo.coords (dojo.byId (this.id + "axistitle_X"));
					size.h = size.h - coords.h;
				}
			
				if ((this.chartDef.legend.hidden !== undefined) && (this.chartDef.legend.hidden === false)) {
					if(this.chartDef.legend.location == "right") {
						coords = dojo.coords (dojo.byId (this.id + "rightLegend"));
						if(dijit.byId (this.id + "legend")){
							size.w = size.w - coords.w;
						}
					} else {
						coords = dojo.coords (dojo.byId (this.id + "bottomLegend"));
						if(dijit.byId (this.id + "legend")){		
							size.h = size.h - coords.h;
						}else{
							size.h = size.h - 30;
						}
					}
				}

				// without this, we get scroll bars on FF freeform pages
				if (dojo.isFF) {
					size.w = size.w - 5;
					size.h = size.h - 5;
				}
				
				this.chartDivSize = size;
				
				if((!this.chartDef.xAxis.rotation || this.chartDef.xAxis.rotation==0) && this.chartDef.type != "Pie"){		
					this.chart.removeAxis(this.chartDef.xAxis.id);
					this.addXAxis(this.chart);
				}

				if((this.charts !== undefined) && (this.charts.length > 1))	{
					console.log ("resizing lots of little pies");
					for (var i=0; i<this.charts.length; i++) {
						this.chart = this.charts[i];					
						this.chart.resize ({w: (size.w / this.charts.length - 10), h: size.h - 50}); 
					}
				} else { 
					if(this.chartDef.type == "Pie") {
						console.log ("resizing a single pie chart... subtracting extra pixels");
						size.w = size.w - 30;
						size.h = size.h - 40;
					} else {			
						size.w = size.w - 10;
						size.h = size.h - 10;
					}
					
					console.log ("calling chart.resize with size: ");
					console.dir (size);
					this.chart.resize (size);
				}			
				if (toolbarWidget !== undefined && toolbarWidget !== null) {
					toolbarWidget.resize(size);
				}
			}
		} else {
			console.warn ("ChartBuilder.resize. this.chart is null");
		}
				
		console.log ("exit ChartBuilder.resize");
	},
	setYAxisTitle: function(chart, axisname, label) {
		console.log ("enter setYAxisTitle w/ label: " + label);
		var axis = chart.axes[axisname];
		var dim = chart.dim;
		var offsets=chart.offsets;
		var ta = chart.theme.axis;		
		var x;
		var y;
		var rotate=0;
		var title = null;

		if(axis.vertical) {
			rotate=90;
			y=dim.height/2  - offsets.b/2;
			x=0+12;
		} else {
			x=dim.width/2 + offsets.l/2;
			y=dim.height;
		}		
		var browserName = navigator.appName;		
		var m = dojox.gfx.matrix;
		var surface = dojox.gfx.createSurface(this.id + "axistitle", 45, 140);
		if (browserName == "Microsoft Internet Explorer") {
			title = surface.createText({x: x, y: y, text:label, align: "start"});
		} else {
			title = surface.createText({x: 32, y: -15, text:label, align: "start"});
		}
		
		title.moveToFront();
		var ylabels = this.custom.ylabels;
		title.setFont({family:ylabels.fontFamily, size: ylabels.size, weight: ylabels.weight});
		//title.setFont("Verdana");
		var color = this.custom.ylabels.color;
		console.log ("setYAxisTitle color: " + color);
		
		title.setFill(color);
		title.setTransform(m.rotategAt(rotate,x,y));

		return(chart);
	},
	setXAxisTitle: function(chart, axisname, label) {
		console.log ("enter ChartBuilder.setXAxisTitle: " + label);
		var axis = chart.axes[axisname];		
		var dim = chart.dim;
		var offsets=chart.offsets;
		var x;
		var y;
		var rotate=0;		
		
		x=dim.width/2 + offsets.l/2;
		y=dim.height;
			
		var m = dojox.gfx.matrix;	
		var title;

		title = axis.group.createText({x:x, y:y-5, text:label, align: "end"});
		var xlabels = this.custom.xlabels;
		title.setFont({family:xlabels.fontFamily, size: xlabels.size, weight: xlabels.weight});
		//title.setFill('black');
		console.log ("before setXAxisTitle color");
		var color = this.custom.xlabels.color;
		console.log ("setXAxisTitle color: " + color);
				
		title.setFill(color);
		title.setTransform(m.rotategAt(rotate,x,y));
		title.moveToFront();
								
		console.log ("exit ChartBuilder.setXAxisTitle");
	},
	onRefresh: function () {
		this.chartFetcher.fetchData();
	},
	onPreferences: function () {
		this.preferencesDialog = new ibm.tivoli.tip.charts.dijit.ChartPreferences ( 
				{ global: this.global,
				  chartBuilder: this
				} 
			);
		
		this.preferencesDialog.show();
	},
	setTheme: function (activeTheme) {
		console.log ("enter setTheme: " + activeTheme);
		//if (this.themeChangeSupported()) {
			if (activeTheme == "TIPDark") {
				this.theme = ibm.tivoli.tip.dijit.themes.ChartThemeTivoliDark.clone();
				this.custom = ibm.tivoli.tip.dijit.themes.ChartThemeTivoliDarkCustom;
				console.log ("setting theme to Dark");
			} else if ((activeTheme == "TIPLight") || (activeTheme == "ISCTheme")) {
				this.theme = ibm.tivoli.tip.dijit.themes.ChartThemeTivoliStandard.clone();
				this.custom = ibm.tivoli.tip.dijit.themes.ChartThemeTivoliStandardCustom;
				console.log ("setting theme to Light");
			} else if ((this.chartDef.theme) && (this.chartDef.theme.name)) {
				// no short theme defined, so just use the long theme name passed into the chart
				console.log ("using theme that is part of the chart: " + this.chartDef.theme.name);
				var str = 'dojo.' + 'require("' + this.chartDef.theme.name + '");';
				console.log ("require string: " + str);
				eval (str);
				console.log ("about to eval the theme");
				this.theme = eval (this.chartDef.theme.name);
				console.log ("cloning the theme");
				this.theme = this.theme.clone();
				console.log ("eval-ing the Custom");
				this.custom = eval (this.chartDef.theme.name + 'Custom');
			} else {
				console.log ("using theme passed into chart because activeTheme is not recognized or null: " + activeTheme);
			}
		//} else {
		//	console.log ("theme change is not supported");
		//}
	},
	arrangeGradientPalette: function () {
		if (this.theme.rearranged !== true) {
			// start the index
			var i = this.themeIndex % this.theme.seriesThemes.length;
			var newColors = [];
		
			for (var total =0; total < this.theme.seriesThemes.length; total++) {	
				newColors.push (this.theme.seriesThemes[i]);
				i = ++i % this.theme.seriesThemes.length;
			}
		 
			this.theme.seriesThemes = newColors;
			this.theme.rearranged = true;
		}
	},
	arrangeColorPalette: function () {
		if (this.theme.rearranged !== true) {
			// start the index
			var i = this.themeIndex % this.theme.colors.length;
			var newColors = [];
		
			for (var total =0; total < this.theme.colors.length; total++) {	
				newColors.push (this.theme.colors[i]);
				i = ++i % this.theme.colors.length;
			}
		 
			this.theme.colors = newColors;
			this.theme.rearranged = true;
		}
	},
	themeChangeSupported: function () {
		if ((this.theme == ibm.tivoli.tip.dijit.themes.ChartThemeTivoliStandard) ||
			(this.theme == ibm.tivoli.tip.dijit.themes.ChartThemeTivoliDark)) {
			return (true);
		} else {
			return (false);
		}
	},
	changeTheme: function (event) {
		console.log ("changing active theme to: " + event.activeTheme);
		this.setTheme (event.activeTheme);		
		this.updateChart();
	},
	destroy: function () {
		console.log ("enter ChartBuilder.destroy");
		this.inherited ("destroy", arguments);
		//this.getToolbar().destroyRecursive();		
		if(this.toolbarSelf){
			this.toolbarSelf.destroyRecursive();
		}
		if(this.chartPager){
			this.chartPager.destroyRecursive();
		}
		if(this.legend){
			this.legend.destroy();
		}
		// remove auto-refresh
		if (this.interval !== null) {
			clearTimeout (this.interval);
			delete this.interval;
		}
		if(this.chartFetcher){
			this.chartFetcher.destroy();			
		}		

		console.log ("exit ChartBuilder.destroy");
	}
});