dojo.provide("ibm.tivoli.tip.charts.dijit.ChartBuilderWizard");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");

dojo.require("dojoe.wizard.Wizard");
dojo.require("ibm.tivoli.tip.charts.dijit.DataSetPage");
dojo.require("ibm.tivoli.tip.charts.dijit.ParametersPage");
dojo.require("ibm.tivoli.tip.charts.dijit.FiltersPage");
dojo.require("ibm.tivoli.tip.charts.dijit.VisualizationPage");
dojo.require("ibm.tivoli.tip.charts.dijit.ThresholdsPage");
dojo.require("ibm.tivoli.tip.charts.dijit.VisualizationOptionsPage");
dojo.require("ibm.tivoli.tip.charts.dojo.SyncController");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartBuilderWizard",[dijit._Widget,dijit._Templated,dijit._Container],{

	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/ChartBuilderWizard.html"),	
	DATASET_PAGE_ID: "visualDatasetPage", 
	GENERAL_PAGE_ID: "visualGeneralPage", 
	CHART_PAGE_ID: "visualChartPage", 
	widgetDef: null,
	_subs: [],
	_1stFlowPages: [],	
	widgetPref: null,
	userid: "custom",  // set the userid so that we can distinguish between user created charts and system charts
	
	constructor: function(){	
		this._resources = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");		
		this._subs = [];	
		this._1stFlowPages = [];	
		this.widgetPref = null;
	},	
	
	postMixInProperties: function(){			
		if(this.widgetPref.providerId!="null"&&this.widgetPref.datasourceId!="null"&&this.widgetPref.widgetId!="null"&&this.widgetPref.widgetVersion!="null"){
			this._getWidget();
			this._editMode = true;
		}
		if(!this.widgetDef){// widgetDef is not defined, so no saved preference
			this.widgetDef = {
				"meta": {//got from widget wizard
					"version":"2.2.0",
					"type": "charts-2.2.0",	
					"id": widgetObject.id,
					"label": { 
						"key":widgetObject.label,
						"value":widgetObject.label
					}, 
					"description": {
						"key": widgetObject.description,
						"value":widgetObject.description
					},
					"createdBy": this.userid				
				},		
				"details": {
				},
				"groups":[//got from catolog management
					{
						"id":groupObject.id,
						"label":{
							"key":groupObject.label,
							"value":groupObject.label
						},
						"description":{
							"key":groupObject.description,
							"value":groupObject.description
						}
					}
				],
				"provider":{},
				"datasource":{},
				"datasets": []	
			};
//			if(groupArray.length!=0){
//				 this.widgetDef.groups = [];
//			}
//			for (var i=0; i<groupArray.length; i++) {
//				 var groupObj = groupArray[i];
//				 this.widgetDef.groups.push({
//				   "id": groupObj.id,
//				   "label":{
//						 "key":groupObj.label,
//						 "value":groupObj.label
//					},
//					"description":{
//						 "key":groupObj.description,
//						 "value":groupObj.description
//					}
//				 });
//			}
			this._editMode = false;
		} else {
			// update label and description in case they have changed
			if ((widgetObject !== undefined) && (widgetObject.label !== undefined) && (widgetObject.label !== null)) {
				console.log ("updating widget def label: " + widgetObject.label);
				this.widgetDef.meta.label.key = widgetObject.label;
				this.widgetDef.meta.label.value = widgetObject.label;
			}
			if ((widgetObject !== undefined) && (widgetObject.description !== undefined) && (widgetObject.description !== null)) {
				console.log ("updating widget def description" + widgetObject.description);
				this.widgetDef.meta.description.key = widgetObject.description;
				this.widgetDef.meta.description.value = widgetObject.description;
			}
		}
	},
	
	postCreate: function(){	
		this.tivWizard._editMode = this._editMode;	
		this.tivWizard.globalConfig = {
			isEditWidget: this._editMode	
		};		
		this.connect(this.tivWizard, "OnNext", this._onNext);		
		this.connect(this.tivWizard, "OnOK", this._onFinish);		
	},
	
	_create1stFlow: function(){
		this._1stFlowPages.push(new ibm.tivoli.tip.charts.dijit.DataSetPage({title:this._resources.DATASET_TITLE,widgetDef:this.widgetDef},dojo.doc.createElement("div")));		
		this._1stFlowPages.push(new ibm.tivoli.tip.charts.dijit.ParametersPage({title:this._resources.PARAMETER_TITLE,widgetDef:this.widgetDef},dojo.doc.createElement("div")));		
		this._1stFlowPages.push(new ibm.tivoli.tip.charts.dijit.FiltersPage({title:this._resources.FILTERS_TITLE,widgetDef:this.widgetDef},dojo.doc.createElement("div")));		
		this._1stFlowPages.push(new ibm.tivoli.tip.charts.dijit.VisualizationPage({title:this._resources.VISUALIZATION_TITLE,widgetDef:this.widgetDef},dojo.doc.createElement("div")));		
		this._1stFlowPages.push(new ibm.tivoli.tip.charts.dijit.ThresholdsPage({title:this._resources.THRESHOLD_TITLE,widgetDef:this.widgetDef},dojo.doc.createElement("div")));
		this._1stFlowPages.push(new ibm.tivoli.tip.charts.dijit.VisualizationOptionsPage({title:this._resources.VISUALIZATION_OPTION_TITLE,widgetDef:this.widgetDef},dojo.doc.createElement("div")));		
	},
	
	_initWizardContent: function(){
		this._create1stFlow();
		this._onLoadPages = this._1stFlowPages; 
		//this._addPages();
		this._syncController = new ibm.tivoli.tip.charts.dojo.SyncController({
			datasetPanel: this._1stFlowPages[0],
			paramsPanel: this._1stFlowPages[1],
			filterPanel: this._1stFlowPages[2],
			visualPanel: this._1stFlowPages[3],
			thresholdPanel: this._1stFlowPages[4],
			visualOptionPanel: this._1stFlowPages[5]
		});		
		//dojo.connect(this._1stFlowPages[0],"onChange",this._syncController,"dataSetChange");
		dojo.connect(this._1stFlowPages[1],"onChange",this._syncController,"paramsChange");
		dojo.connect(this._1stFlowPages[2],"onChange",this._syncController,"filterChange");
		dojo.connect(this._1stFlowPages[3],"onChange",this._syncController,"visualChange");
		dojo.connect(this._1stFlowPages[4],"onChange",this._syncController,"thresholdChange");
		dojo.connect(this._1stFlowPages[5],"onChange",this._syncController,"visualOptionChange");
	},
	
	startup: function(){
		this.inherited(arguments);
		this._initWizardContent();
		this._setNextButtonState();
	},	
	
	_setNextButtonState: function(){
		this.tivWizard._nextButton.attr("disabled", false);		
	},
	
	_setFinishButton: function(){		
		var valid = true;
		for(var i=0;i<this.tivWizard._pages.length;i++){			
			if(!this.tivWizard._pages[i].widgetDefCont.isValid()){
				valid = false;
				break;
			}
		}
		if(valid){
			this.tivWizard._finishButton.attr("disabled", false);
		}else{
			this.tivWizard._finishButton.attr("disabled", true);
		}		
	},	
	
	_onNext: function(){		
		if(this.tivWizard.getSelectedPage().widgetDefCont && this.tivWizard.getSelectedPage().pageId.indexOf(this.DATASET_PAGE_ID)==-1){
			try{
			this.tivWizard.getSelectedPage().widgetDefCont.getWidgetDefinition();			
			}catch(e){
				console.error(e.message);
			}
		}		
	},	
	
	_getWidget: function(){		
		var providerId = encodeURIComponent(this.widgetPref.providerId);
		var dataSourceId = encodeURIComponent(this.widgetPref.datasourceId);
		var widgetId = encodeURIComponent(this.widgetPref.widgetId);
		var widgetVersion = encodeURIComponent(this.widgetPref.widgetVersion);
		var kw = {
        	sync: true,
			handleAs: "json",
			preventCache: true,
    		mimetype: "application/json",
        	url: "/ibm/tivoli/rest/providers/"+providerId+"/datasources/"+dataSourceId+ "/widgets/charts-2.2.0/definitions/"+widgetId+"-"+ widgetVersion+"?registryLocation=local",
            load: dojo.hitch(this, function (data) {
                this.widgetDef = data;
				this.paramsWidgetDef = dojo.clone(data);
				this.filterWidgetDef = dojo.clone(data);
				this.visualWidgetDef = dojo.clone(data);
				this.thresholdWidgetDef = dojo.clone(data);				
            }),                      
            error: function (error) {console.error("widget definition got failed. reason: "+error.responseText);}
        };   
        dojo.xhrGet(kw);
	},
	
	_saveWidget: function(){
		var prefWidget = this.getWidgetDefinition();
		var providerId = encodeURIComponent(prefWidget.provider.id);
		var dataSourceId = encodeURIComponent(prefWidget.datasource.id);
		var widgetId = encodeURIComponent(prefWidget.meta.id);
		var widgetVersion = encodeURIComponent(prefWidget.meta.version);
		var kw = {
        	sync: true,
        	headers: {'Content-Type': 'application/json',
        		'Content-Length': dojo.toJson(prefWidget).length
			},
        	url: "/ibm/tivoli/rest/providers/"+providerId+"/datasources/"+dataSourceId+ "/widgets/"+prefWidget.meta.type+"/definitions/"+widgetId+"-"+ widgetVersion+"?type=base&registryLocation=local&overwrite=true",
            putData: dojo.toJson(prefWidget),					  
            load: function () {console.log("widget definition saved successfully.");},
            error: function (error) {console.log("widget definition saved failed. reason: "+error.responseText);}
        };   
        dojo.xhrPut (kw);
	},
	
	_onFinish: function(){
		this._saveWidget();		
	},	
	
	_addPages: function(){
		for(var i=0;i<this._onLoadPages.length;i++){
			//this.tivWizard.addPage(this._onLoadPages[i]);
			this.tivWizard._setContainerType(this._onLoadPages[i]);
			this.tivWizard._pageContainer.addChild(this._onLoadPages[i]);
		}		
		this.tivWizard._pages = this.tivWizard._pageContainer.getChildren();
		this.tivWizard._buildToC();
		this.tivWizard.updateUI();
	},
	
	getWidgetDefinition: function(){		
		return this.widgetDef;
	},	
	
	resize: function(size){			
		console.log("enter ChartBuilderWizard.resize");
		console.log("size: "+dojo.toJson(size));
		var marginBox = dojo.marginBox(this.domNode);
		if(size && !(marginBox.w==0 && marginBox.h==0)){
			this.size = dojo.clone(size);  
			this.inherited(arguments);	
			dojo.style(this.domNode,{width:size.w+"px",height:size.h+"px"});
			this.tivWizard.resize(dojo.clone(this.size));	
		}
		console.log("exit ChartBuilderWizard.resize");
	},
	
	destroyFlow: function(){
		for(var i=0;i<this._onLoadPages.length;i++){
			this._onLoadPages[i].destroyRecursive();
		}
	},

	destroy: function(){	
		try{
			this._onLoadPages = this._1stFlowPages;
			this.destroyFlow();
		}catch(E){}
		this.inherited(arguments);
	}
	
});