dojo.provide("ibm.tivoli.tip.charts.dijit.ChartPanelPage");

dojo.require("dojoe.wizard.Page");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.ContentPane");

dojo.require("ibm.tivoli.tip.charts.dijit.ChartPanelPageHeader");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartPanelPage",[dojoe.wizard.Page],{		
	
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/ChartPanelPage.html"),
	contentTitle: null,
	contentDesc: null,
	widgetDef: null,
	widgetDefCont: null,
	_dataSetId: null,
	_pageSize: null,
	_isDatasetChange: true,
	syncContent: null,
	
	constructor: function(){		
		this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
		this.syncContent = null;
		this.widgetDef = null;
		this._dataSetId = null;
		this._pageSize = null;
		this._isDatasetChange = true;
	},
	
	postMixInProperties: function(){		
		if(this.widgetDef && this.widgetDef.datasets && this.widgetDef.datasets.length!=0){
			this._dataSetId = this.widgetDef.datasets[0].id;
		}
	},
	
	postCreate: function() {
		this.inherited(arguments);
		var headerWidget = new ibm.tivoli.tip.charts.dijit.ChartPanelPageHeader({		
			title:this.contentTitle, 
			desc: this.contentDesc},
			this.titleDiv);		
	},
	
	getWidgetDefinition: function(){
		if ( this.widgetDefCont ) {
			return this.widgetDefCont.getWidgetDefinition();
		}
	},
	
	setWidgetDefinition: function(widgetDef){
		this.widgetDef = widgetDef;		
		if ( this.widgetDefCont ) {
			this.widgetDefCont.setWidgetDefinition(this.widgetDef);
		}		
	},
	
	_setWidgetDefUponDatasetChange: function(){
		if(this._isDatasetChange){
			this.widgetDefCont.setWidgetDefinition(this.widgetDef);	
		}
	},
	
	onChange: function(){		
	},	
	
	syncWidgetDef: function(syncContent){
		this.syncContent = syncContent;
	},
	
	AfterPageSelected: function(){		
		if(this.syncContent===undefined){			
			this.setWidgetDefinition(this.widgetDef);
		}else if(this.syncContent){
			if(this.syncContent.summary){
				this.sumPanel.setWidgetDefinition(this.widgetDef);		
			}
			if(this.syncContent.preview){	
				this.previewPanel._beingBuilt = false;			
				this.previewPanel.setWidgetDefinition(this.widgetDef);		
			}
		}
		this.syncContent = null;		
	},
	
	OnPageSelected: function(){		
		if(!this.widgetDefCont){			
			if(this.widgetDef && this.widgetDef.datasets && this.widgetDef.datasets.length!=0){
				this._dataSetId = this.widgetDef.datasets[0].id;
				this._isDatasetChange = true;
			}
		}else if(this._dataSetId != this.widgetDef.datasets[0].id){
			this._dataSetId = this.widgetDef.datasets[0].id;
			this._isDatasetChange = true;				
		}else{
			this._isDatasetChange = false;
		}		
	},
	
	isValid: function(){
		//return this.widgetDefCont.isValid();
		return true;
	},	
	
	_triggerResize: function(size){
		var validSize = size && size.w && size.h;
		var sizeChange = !this._pageSize || this._pageSize.w != size.w || this._pageSize.h != size.h;
		if(validSize && sizeChange){
			this._pageSize = dojo.clone(size);
			return true;
		}else{
			return false;
		}		
	},
	
	resize: function(size){		
		this.inherited(arguments);
		this.pageContainer.resize({w:size.w-10,h:size.h-5});
	}
		
});

