/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: %W%
 * Version:       %I%
 * Last Modified: %G%
 *******************************************************************************/

dojo.provide("ibm.tivoli.tip.charts.dijit.ChartPreferences");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("ibm.tivoli.tip.Version");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.NumberSpinner");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.CheckBox");  // also contains RadioButton
dojo.require("dijit.form.Textarea");
dojo.require("dijit.form.SimpleTextarea");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojox.form.DropDownSelect");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.DateTextBox");
dojo.require("ibm.tivoli.tip.charts.dijit.ParametersWidget");
dojo.require("ibm.tivoli.tip.dijit.TIPTableOptions");
dojo.require ("ibm.tivoli.tip.charts.dojo.RESTErrorHandler");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");
dojo.requireLocalization("ibm.tivoli.tip.dijit", "messages");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartPreferences",
	          [ dijit._Widget, dijit._Templated, dijit._Container ],
{
	widgetsInTemplate: true,
	templatePath:dojo.moduleUrl("ibm.tivoli.tip.charts.dijit" , "templates/ChartPreferences.html"),
	global: null,
	chartBuilder: null,
	datasourceID: null,
    namespace: null,
	tableBuilder: null,
	builder: null,
	isTableFirst: null,

	constructor: function () {
		console.log ("enter ChartPreferences.ctor");
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
		this.messages_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "messages");
	    this.tipDojoVersion = dojo.string.substitute(this.resources_.TIPDOJO_VERSION, { 0: ibm.tivoli.tip.Version.getVersion() });
	    console.log ("tipDojoVersion: " + this.tipDojoVersion);
	    this.dojoVersion = dojo.string.substitute(this.resources_.DOJO_VERSION, { 0: dojo.version });
	    console.log ("dojoVersion: " + this.dojoVersion);
	    console.log ("exit ChartPreferences.ctor");
	},
	postCreate: function () {
		this.populate();
	},
	populate: function () {
		this.builder = this.tableBuilder;
		
		if(this.tableBuilder === null) {
			this.builder = this.chartBuilder;
			var legendLocation = this.builder.chartDef.legend.location;
			var legendEnabled = this.builder.chartDef.legend.hidden;	
			this.legendLoc.setValue (legendLocation);		
			this.isLegendEnabled.attr('checked', !legendEnabled);

			var columnsDivTab = dijit.byId (this.id + "columnsDivTab");		
			var mainDom = dijit.byId(this.id + "tabs");
			mainDom.removeChild(columnsDivTab);			
		}
		else
		{
			if(!this.builder.widgetDefinition.charts) {
				var chartTypeLabelDiv = dojo.byId(this.id + "chartTypeLabelDiv");
				dojo.style(chartTypeLabelDiv, 'display', 'none');
				var chartTypeDiv = dojo.byId(this.id + "chartTypeDiv");
				dojo.style(chartTypeDiv, 'display', 'none');
			}
			var legendDiv = dojo.byId(this.id + "legendDiv");
			dojo.style(legendDiv, 'display', 'none');

			var colDiv = dijit.byId (this.id + "columnsDiv");
			if (colDiv) {
				colDiv.destroy();
			}
			
			var columnsDiv = dojo.doc.createElement( 'div' );
			columnsDiv.id = this.id + "columnsDiv";
			dojo.place(columnsDiv, dojo.byId (this.id + "columnsDivContainer"), "after" );
			this.tableOptions = new ibm.tivoli.tip.dijit.TIPTableOptions ( 
					{ table: this.builder.table,
					  global: this.global
					}, 
				dojo.byId(this.id + "columnsDiv")
			);
			this.tableOptions.startup();	
		}
		var label = this.builder.chartDef.label.value;
		var description = this.builder.chartDef.description.value;			
		var chartType = this.builder.chartDef.type;		
		this.labelField.setValue (label);		
		this.descField.setValue (description);		
		this.selectedChartType.setValue (chartType);
		
		var pagingOption = this.builder.chartDef.common.paging;		
		var pagingSize = this.builder.chartDef.common.pagingSize;		
		
		if(pagingOption === true) {
			dijit.byId(this.id + "pageSize").attr('checked', true);
			this.pageSizeValue.setValue(pagingSize);
		}
		else {			
			dijit.byId(this.id + "allRows").attr('checked', true);			
			//this.pageSizeValue.setValue(0);
		}
		this.setPagingOption();

		var paramDiv = dijit.byId (this.id + "parametersDiv");
		if (paramDiv) {
			paramDiv.destroy();
		}
		
		var div = dojo.doc.createElement( 'div' );
		div.id = this.id + "parametersDiv";
    	        dojo.place(  div, dojo.byId (this.id + "parametersDivContainer"), "after" );
		
		this.paramWidget_=new ibm.tivoli.tip.charts.dijit.ParametersWidget (
			{
				namespace: this.namespace,
				data: this.builder.dataset.parameters
			}, 
			dojo.byId(this.id + "parametersDiv")
		);
		this.paramWidget_.startup();

		var isAutoUpdateEnabled = this.builder.chartDef.common.autoUpdate;
		this.isAutoUpdate.attr('checked', isAutoUpdateEnabled);

		var showLastUpdatedTime = this.builder.chartDef.common.showLastUpdateTime;
		this.showLastUpdate.attr('checked', showLastUpdatedTime);
		
		var contextRadio = dijit.byId (this.id + "contextualParametersSelected");
		var defaultRadio = dijit.byId (this.id + "defaultParametersSelected");
		var supportsWire = this.builder.widgetDefinition.datasets[0].supportsWire;

		if ((supportsWire === undefined) || (supportsWire === true)) {
			contextRadio.attr ('checked', true);
			defaultRadio.attr ('checked', false);
		} else {
			contextRadio.attr ('checked', false);
			defaultRadio.attr ('checked', true);
		}
	},
	getUserPreferences: function () {				
		this.builder = this.tableBuilder;				
		var userPrefs = null;
		var pagingOption = this.setPagingOption();		
		if((this.pageSizeValue.getValue() == "") || (isNaN(this.pageSizeValue.getValue()))|| !this.pageSizeValue.isInRange() || !this.pageSizeValue.isValid())
		{			
			dojo.style(dijit.byId(this.id + "pageSizeValue").textbox,{visibility:'hidden'});			
			this.pageSizeValue.setValue(25);
		}		
		if(this.tableBuilder === null) {
			this.builder = this.chartBuilder;					
			userPrefs = { 		
			"details": {				
				"preferredView": this.selectedChartType.getValue()
			},	
			"datasetsIdentifier":"id",
			"datasets": [{
				"id": this.builder.dataset.id,
				"parametersIdentifier": "id",
				"parameters": []
			}],	
			"chartsIdentifier":"id",
			"charts": [{
                   "common": {
					"autoUpdate": this.isAutoUpdate.checked,
					"showLastUpdateTime": this.showLastUpdate.checked,
					"paging": (pagingOption === this.resources_.PAGE_THE_DATA) ? true : false,
					"pagingSize": this.pageSizeValue.getValue()
				},
				"id": this.builder.chartID,				
				"label": {
					"key": "",
					"value": this.labelField.getValue()
				},
				"legend": {
					"hidden":!this.isLegendEnabled.checked,
					"location":this.legendLoc.getValue()
						},
                "type": this.selectedChartType.getValue(),
				"toolbar": {
						"hidden":this.builder.toolbarSelf.toolbarHidden_							
						},
				"description": {
					"key": "",
					"value": this.descField.getValue()
				}
			}]
			};
		}
		else
		{
			var chartViewType = null;
			if(!this.builder.widgetDefinition.charts){
				chartViewType = "Table";	
			}else{
				chartViewType = this.selectedChartType.getValue();
			}
			userPrefs = { 		
			"details": {				
				"preferredView": chartViewType
			},
			"datasetsIdentifier":"id",
			"datasets": [{
				"id": this.builder.dataset.id,
				"parametersIdentifier": "id",
				"parameters": []
			}],	
			"tablesIdentifier":"id",
			"tables": [{
                   "common": {
					"autoUpdate": this.isAutoUpdate.checked,
					"showLastUpdateTime": this.showLastUpdate.checked,
					"paging": (pagingOption === this.resources_.PAGE_THE_DATA) ? true : false,
					"pagingSize": this.pageSizeValue.getValue()
				},
				"datasource": this.builder.datasourceID,
				"dataset": this.builder.getTableFromDef().dataset,
				"selectionMode": "single",
				"id": this.builder.tableID,
				"label": {
					"key": "",
					"value": this.labelField.getValue()
				},
				"type": this.selectedChartType.getValue(),
				"toolbar": {
					"hidden":this.builder.toolbarHidden_							
				},
				"description": {
					"key": "",
					"value": this.descField.getValue()
				}
			}]
			};
			if(this.selectedChartType.getValue()==="Table" || !this.tableBuilder.widgetDefinition.charts){
			if(this.tableOptions){				
				var columns = this.builder.table.originalStructure.cells;
				if (columns !== undefined && columns.length > 0)
				{
					userPrefs.tables[0].viewIdentifier = "id";
					userPrefs.tables[0].view = [];							
				
					for (var x in columns) {
						if (x) {
							userPrefs.tables[0].view[x] = {};
							userPrefs.tables[0].view[x].id = columns[x].field;	
							userPrefs.tables[0].view[x].searchable = true;				
							userPrefs.tables[0].view[x].hidden = !dijit.byId (this.tableOptions.id + "column_" + columns[x].field).isVisible();															
							userPrefs.tables[0].view[x].width = columns[x].unitWidth;
						}
					}
				}
			}	
			} else{
				userPrefs.charts = this.tableBuilder.widgetDefinition.charts;
				dojo.mixin (userPrefs.charts[0], userPrefs.tables[0]);				
				delete userPrefs.tables;
			}
		}

		 if (this.paramWidget_ !== null) {			
				var model = this.paramWidget_.getParameters();
				var param = null;
				var value = null;
				
				var contextRadio = dijit.byId (this.id + "contextualParametersSelected");
				userPrefs.datasets[0].supportsWire = contextRadio.checked;
			
				for (var row in model) {
					if (row) {
						
						param = model[row];					
						value = this.paramWidget_.getParameterValue(param.id, param.type);		
						console.log ("retuned value from getparameter value: ");
						console.log (value);
						if (value !== null) {
							userPrefs.datasets[0].parameters[row] = {
								"id": param.id,
								"value": value
							};
						}
					}
				}
		}		
		return (userPrefs);		
	},
	setPagingOption: function () {	
		var pagingTypeOption1 = dojo.byId(this.id + "allRows");
		var pagingTypeOption2 = dojo.byId(this.id + "pageSize");	
		var result;
		
		if (pagingTypeOption1.checked)
		  {
			dojo.byId(this.id + "pageSizeValue").style.backgroundColor = "#ffffff";
			dojo.byId(this.id + "pageSizeValue").readOnly = 1;
			dojo.byId(this.id + "pageSizeValue").value = "";
			dojo.byId(this.id + "pageSizeValue").required = false;
			this.pageSizeValue.attr('promptMessage', "");
			result = pagingTypeOption1.value;
		  }
		 if (pagingTypeOption2.checked)
		  {			
			dojo.byId(this.id + "pageSizeValue").readOnly = 0;
			dojo.byId(this.id + "pageSizeValue").required = true;
			this.pageSizeValue.attr('promptMessage', this.resources_.PAGE_SIZE_RANGE_MESSAGE);
			result = pagingTypeOption2.value;
		  } 	
		 return result;
	},
	show: function () {
		this.dialog.show();
//		dijit.byId (this.id + "tabs").resize();
	},
	close: function () {
		this.dialog.hide();
		setTimeout (dojo.hitch (this, this.kill), 100);
	},
	kill: function () {
		var id = this.id;
		this.destroyRecursive();
		dijit.registry.remove (id);
	},
	onOK: function () {
		console.log ("enter chartPreferences.onOK");
		var widgetDef = this.saveUserPreferences();
		this.builder = this.tableBuilder;	
		var encodedCID = null;
		if(this.tableBuilder === null) {
			this.builder = this.chartBuilder;	
			encodedCID = encodeURIComponent(this.builder.chartID);
		}
		else {
			encodedCID = encodeURIComponent(this.builder.tableID);
			this.tableOptions.onSave();
		}
		var encodedProviderID = encodeURIComponent(this.builder.providerID);		
		var encodedDS = encodeURIComponent(this.builder.datasourceID);
		var encodedPID = encodeURIComponent(this.global.chartProfileID);
		var drillUpItems = this.builder.drillUpItems;
		//show busyPane
		var busyPane = dijit.byId(this.global.namespace+"busy_pane");
	    if ( busyPane ) {
	      console.log ("showing busypane");
	      busyPane.show(true); // size to portlet
		}
	    
		//when table is displayed first
		if ((this.isTableFirst !== undefined) && (this.isTableFirst !== null))
		{
			//when chart type changes from chart to table
			if(widgetDef.tables === undefined) {
				widgetDef.tables = widgetDef.user.charts;
			}
			if(this.isTableFirst === true || (this.tableBuilder !== null && widgetDef.details.preferredView == "Table"))
			{				
				widgetDef.details.preferredView = "Table";
				var userPrefs = this.getUserPreferences();
				if(userPrefs.tables === undefined) {
					userPrefs = this.updatePrefs(userPrefs);
				}
				this.builder.update (userPrefs, widgetDef);
				this.close();
				return ;
			}
		}	
		if(!this.global.widgetFetcher){
			this.global.widgetFetcher = new ibm.tivoli.tip.charts.dojo.WidgetFetcher ({
				global: this.global
			});
		}
		var fetcher = this.global.widgetFetcher;
		var domNode = dojo.byId (this.global.namespace+"widgetDiv");		
		this.builder.destroyRecursive();		
		dojo.destroy(domNode);
		domNode = dojo.doc.createElement("div");
		domNode.id = this.global.namespace+"widgetDiv";
		dojo.byId (this.global.namespace + "widgetContainer").appendChild(domNode);
		/*
		var domNode = dojo.byId (this.global.namespace+"widget");
		this.builder.destroy();		
		dojo.empty(domNode);
		dojo.place (domNode, dojo.byId (this.global.namespace + "birtChartWidget"), "after");
		*/	
		if (widgetDef.details.preferredView == "Table") {			
			this.builder = fetcher.buildTable (encodedProviderID, encodedDS, widgetDef, domNode, encodedCID, null, this.isTableFirst, drillUpItems);			
		} else {			
			//widgetDef.charts[0].type = widgetDef.details.preferredView;
			//when chart type changes from table to chart
			if(widgetDef.user.charts === undefined) {
				widgetDef.user.charts = widgetDef.user.tables;
			}
			this.builder = fetcher.buildChart (encodedProviderID, encodedDS, widgetDef, encodedCID, domNode, null, drillUpItems);
		}
		this.global.builder = this.builder;
		this.close();
		console.log ("exit ChartPreferences.onOK");
	},
	updatePrefs: function() {	
		var userPrefs = this.getUserPreferences();
		if(userPrefs.tables === undefined) {
			userPrefs.tables = userPrefs.charts;
		}
		return userPrefs;
	},	
	saveUserPreferences: function(syncflag) {	
		this.builder = this.tableBuilder;		
		var encodedCID = null;
		if(this.tableBuilder === null) {
			this.builder = this.chartBuilder;			
			encodedCID = encodeURIComponent(this.builder.chartID);
		}
		else
		{
			encodedCID = encodeURIComponent(this.builder.tableID);
		}
		var encodedProviderID = encodeURIComponent(this.builder.providerID);
		var result = null;
		var encodedDS = encodeURIComponent(this.builder.datasourceID);		
		var encodedPID = encodeURIComponent(this.global.chartProfileID);
		var widgetDefVersion = null;
		var widgetSchema = null;
		if(this.tableBuilder !== null){
			widgetDefVersion = this.tableBuilder.widgetDefinition.meta.version;
			widgetSchema = this.tableBuilder.widgetDefinition.meta.type;
		}else{
			widgetDefVersion = this.chartBuilder.widgetDefinition.meta.version;	
			widgetSchema = this.chartBuilder.widgetDefinition.meta.type;
		}
		var controller = "/ibm/tivoli/rest";
		var prefs = dojo.toJson(this.getUserPreferences());
		console.log ("preferences to be saved");
		console.log (prefs);
		console.log (controller + "/providers/tip.charts/datasources/" + encodedDS + "/widgets/" + widgetSchema + "/definitions/" + encodedCID + "-" + widgetDefVersion + "?type=user&profileID=" + this.global.chartProfileID + "&registryLocation=local");
		//    /ibm/tivoli/rest/providers/tip.charts/datasources/ITM/widgets/charts-2.1.0/definitions/MemoryAllocation-2.1.0?type=user&profileID=123
		
		if(syncflag === undefined || syncflag === null) {
			syncflag = true;
		}
		var profileIdUriParam = this.global.chartProfileID==null||this.global.chartProfileID==undefined||this.global.chartProfileID=="null"||this.global.chartProfileID=="undefined" ? "" : "&profileID=" + this.global.chartProfileID;
		var kw = {
        			  sync: syncflag,
        			  headers: {'Content-Type': 'application/json',
        			  		   'Content-Length': prefs.length
        			  		  },
        			  url: controller + "/providers/" + encodedProviderID + "/datasources/" + encodedDS + "/widgets/" + widgetSchema + "/definitions/" + encodedCID + "-" + widgetDefVersion + "?type=user" + profileIdUriParam + "&registryLocation=local",
                      putData: prefs,					  
                      load: dojo.hitch(this, function () {
                      		var fetcher = new ibm.tivoli.tip.charts.dojo.WidgetFetcher({global: this.global});
							result = fetcher.fetchWidgetDefinition(encodedProviderID, encodedDS, encodedCID, widgetDefVersion, encodedPID);
                      }),
                      error: dojo.hitch (this, function (error) {											
							var errHandler = new ibm.tivoli.tip.charts.dojo.RESTErrorHandler(this.global);		
							errHandler.showError(dojo.fromJson(error.responseText));	
		 			  })
                   };

          //ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).post( kw );
          dojo.xhrPut (kw);
        
          console.log ("exit ChartPreferences.saveUserPreferences");  
          return (result);
	},
	onSelectAll: function(){		
		this.tableOptions.onSelectAll();
	},	
	onDeselectAll: function(){		
		this.tableOptions.onDeselectAll();
	},
	saveSharedPreferences: function() {
	},
	onBlur: function(){		
		var chartName = this.labelField.attr('value');
		if(!chartName||chartName==""){
			this.okButton.attr('disabled',true);
		}else{
			this.okButton.attr('disabled',false);
		}
	},
	onCancel: function () {
		this.close();
	}
});