/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/

dojo.provide("ibm.tivoli.tip.charts.dijit.ChartTitle");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartTitle",
              [ dijit._Widget, dijit._Templated],
{
	widgetsInTemplate: true,
	templatePath:dojo.moduleUrl("ibm.tivoli.tip.charts.dijit" , "templates/ChartTitle.html"),
	title: null,
	namespace: "1234",
	chartid: null,
	
	constructor: function () {
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");    
	},
	postCreate: function () {
		if (this.title !== null) {
			this.setTitle (this.title);
		}
		
		this.makeTitleContextMenu();
	},
	setTitle: function (title) {
		var textDiv = dojo.byId (this.id + "text");
		
		var titleHTML = "<span>" + title + "</span>";
		textDiv.innerHTML = titleHTML;
	},
	makeTitleContextMenu: function () {
		console.log ("enter makeTitleContextMenu");	
		var provider = new ibm.tivoli.tip.dijit.TIPContextMenuProvider(
					{ iscPortletNamespace: this.iscPortletNamespace,
					  getMenuItemsCallback: dojo.hitch (this, this.getMenuItems)
					});
		console.log ("after make provider");

		var menu = new ibm.tivoli.tip.dijit.TIPContextMenuProxy(
			{cmProvider: provider, 
			 targetNodeIds: [this.id + "icon"],
			 getContextCallback: dojo.hitch (this, this.getSelectedData)
			});
		console.log ("after create context menu");
	},
	getSelectedData: function () {
	},
	getMenuItems: function () {
		var menuItems = [
			     			{ id: this.namespace + "RefreshChartMenuItem", label: this.resources_.REFRESH, iconClass: "refreshIcon", launchType: "JavaScript", uri: "tipdijit.byId ('" + this.chartid + "').onRefresh();", enabled: true },
			     			{ id: this.namespace + "PreferencesMenuItem", label: this.resources_.PREFERENCES, iconClass: "propertiesIcon", launchType: "JavaScript", uri: "tipdijit.byId ('" + this.chartid + "').onPreferences();", enabled: true }
			     		];		
		return (menuItems);
	}
});
