/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/

dojo.provide("ibm.tivoli.tip.charts.dijit.ChartToolbar");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Button");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartPreferences");
dojo.require ("ibm.tivoli.tip.charts.dojo.RESTErrorHandler");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartToolbar",
              [ dijit._Widget, dijit._Templated],
{
	widgetsInTemplate: true,
	templatePath:dojo.moduleUrl("ibm.tivoli.tip.charts.dijit" , "templates/ChartToolbar.html"),
	chartFetcher: null,
	chartBuilder: null,
	global: null,
	toolbarHidden_:null,
	CHART_SOURCE_TYPE_PAGE: "CHART_SOURCE_TYPE_PAGE",
	
	namespace:"namespace_",
	
	
	constructor: function () {
		try {
			console.log ("enter ChartToolbar.ctor");
		
			this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");    
	    	this.preferencesDialog = null;
			this.connections = [];
			this.allowSubmit_ = true;
			this.interval = null;
			this.nub=null;
		
			this.currentPage = this.CHART_SOURCE_TYPE_PAGE;
		} catch (ex) {
			alert("caught error:"+dojo.toJson(ex));
			console.error ("caught error in ChartToolbar.ctor: " + dojo.toJson(ex));
		}
	},
	postCreate: function () {
		if (this.chartBuilder.standalone === true) {
		} else {
			console.log ("instantiating chart messages");
			console.log (this.chartBuilder);
			dojo.requireLocalization("ibm.tivoli.tip.chartportlet.dijit", "chart_messages");
			this.messages_ = dojo.i18n.getLocalization("ibm.tivoli.tip.chartportlet.dijit", "chart_messages");
			dojo.require ("ibm.tivoli.tip.dojo.TIPHelper");
			this.tipHelper_ = new ibm.tivoli.tip.dojo.TIPHelper();
		}
		
		//this.toolbarHidden_ = (this.global.mode == "view") ? true : false;
		this.mode = this.global.mode;

		var div = document.createElement("div");
		this.nub=div;
		div.setAttribute("tabIndex","0");
		dojo.addClass(div,"nubOpen");
		dojo.style(div,"position","absolute");
		dojo.style(div,"bottom","-1px");
		dojo.style(div,"height","9px");
		dojo.style(div,"align","center");
		var coords = dojo.coords(this.toolbarBody);
		//var centerx =  coords.x + (coords.w/2);
		var centerx = coords.w/2;
		dojo.style(div,"left",centerx+"px");
		dojo.style(div,"display","block");

		this.nubArea.appendChild(div);		
		
		// connect toggle event to nub
		this.connections.push (dojo.connect (this.nub, "onclick", this, "toggleToolbar"));
		this.connections.push (dojo.connect (this.nub, "onkeypress", this, "onNubKeyPress"));
		
		this.chartNavigator = dijit.byId (this.global.namespace + "mainChartNavigatorDiv");
		if (this.toolbarHidden_ === true) {
			dojo.style (dojo.byId (this.id + "toolbar"), "display", "none");
			dojo.addClass (this.nub, "nubClosed");
			dojo.removeClass (this.nub, "nubOpen");
			dojo.style(this.nub,"position","relative");
		}
			
		console.log ("exit ChartToolbar.postCreate");
	},
	showChartSelector: function () {
    	if (this.interval !== null) {
      		// if auto update is on, cancel it
			clearTimeout (this.interval);
			this.interval = null;
		}
		var chartNavigator = dijit.byId (this.global.namespace + "mainChartNavigatorDiv");
		chartNavigator.setCurrentPage (chartNavigator.CHART_SOURCE_TYPE_PAGE);
		chartNavigator.showChartNavigator();
		this.restorePortletTitle();
		this.destroyRecreate();
	},
	destroyRecreate: function () {
		this.chartBuilder.destroyRecursive();
		var node = dojo.doc.createElement ("div");
		node.id = this.global.namespace + "widget";
		dojo.place (node, dojo.byId (this.global.namespace + "birtChartWidget"), "after");
	},
	
	restorePortletTitle: function () {
		// restore portlet title to translated Charting
		this.tipHelper_.setPortletTitle (this.chartBuilder.domNode, this.global.getPortletTitle());
	},

	onResetPrimitive: function (action, reloadPrefs) {
		var callback = null;
		
		if (reloadPrefs === false) {
			callback = null;
		} else {
			callback = dojo.hitch(this, this.afterReset);
		}
		
		var kw = {
	             content:   {
                        command: "savePreferences",
                        arg_portletNamespace: this.global.namespace,
                        action: action
                        },
            	 onResponse:{
                         callback: callback
       	                }
    	     };
	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		
		// do not submit
		return (false);
	},
	onReset: function () {
		//this.onResetPrimitive ("resetDefaults");
		this.chartBuilder.chartUtil.onResetPrimitive ("resetDefaults");
	},
	onResetMyPreferences: function (reloadDefaultPrefs) {
		//this.onResetPrimitive ("resetMine", reloadDefaultPrefs);
		this.chartBuilder.chartUtil.onResetPrimitive ("resetMine", reloadDefaultPrefs);
	},

	afterReset: function () {
		var chartNav = dijit.byId (this.global.namespace + "mainChartNavigatorDiv");
		chartNav.showChartNavigator();
		this.showChartSelector();
		chartNav.getPortletPreferences();
	},
	onNubKeyPress: function (event) {
	  	if (event.keyCode == 13) {
		  	event.cancelBubble = true;
	  		event.returnValue = false;
	  		console.log ("in onNubKeyPress: pressed enter");
	  		this.toggleToolbar();
	  	}
	},
	toggleToolbar: function () {
		this.toggleTableToolbar();
		this.toggleChartToolbar();
	},
	toggleTableToolbar: function () {
		console.log ("enter toggle table toolbar");
		
		var tipTable = dijit.byId (this.global.namespace + "tbl_tipChartData");
		if (tipTable) {
			dojo.unsubscribe (this.toggleSubscription);
			this.toggleSubscription = null;
			tipTable.toggleToolbar();	
			// subscribe to table toolbar toggle, so we can also toggle the chart toolbar			
			this.toggleSubscription = dojo.subscribe (tipTable.id + "#ToggleToolbar", this, "tableToolbarToggled");
		}
	},
	tableToolbarToggled: function () {
		//this.resizeTable();
		this.toggleChartToolbar();
	},
	toggleChartToolbar: function () {
		console.log ("enter toggle toolbar. existing state: " + this.toolbarHidden_);
		if (this.toolbarHidden_) {
			this.openChartToolbar();
		} else {
			this.closeChartToolbar();
		}
		this.saveToolbarStatus(this.toolbarHidden_);
	},
	saveToolbarStatus: function(toolbarHidden_) {
	  	if(this.preferencesDialog === null || this.preferencesDialog == undefined){
			this.preferencesDialog = new ibm.tivoli.tip.charts.dijit.ChartPreferences ( 
					{ global: this.global,
					  chartBuilder: this.chartBuilder
					} 
				);
		}
		this.preferencesDialog.startup();
		this.preferencesDialog.builder.toolbarSelf.toolbarHidden_ = toolbarHidden_;
		this.preferencesDialog.saveUserPreferences(false);
	},
	openChartToolbar: function () {
		this.toolbarHidden_ = false;
		console.log ("showing toolbar");
		this.animateToolbarOpen();
		dojo.addClass (this.nub, "nubOpen");
		dojo.removeClass (this.nub, "nubClosed");
		dojo.style(this.nub,"position","absolute");
	},
	closeChartToolbar: function () {
		this.toolbarHidden_ = true;
		console.log ("hiding toolbar");
		this.animateToolbarClose();
		dojo.addClass (this.nub, "nubClosed");
		dojo.removeClass (this.nub, "nubOpen");
		dojo.style(this.nub,"position","relative");
	},
	animateToolbarOpen: function () {
		dojo.fx.wipeIn ({
				node: dojo.byId (this.id + "toolbar"),
		        duration: 500,
                onEnd: dojo.hitch(this, function() {
                })
			}).play();
	},
	animateToolbarClose: function () {
		dojo.fx.wipeOut ({
				node: dojo.byId (this.id + "toolbar"),
		        duration: 500,
                onEnd: dojo.hitch(this, function() {
                })
			}).play();
	},
	resizeTable: function () {
		var portletSize = this.getTableSize();
		var size = { w: portletSize.available.w, h: portletSize.available.h };
		console.log ("in resize table with size: ");
		console.log (size);
		dojo.byId (this.global.namespace + "tbl_tipChartData").resize (size);
	},
	resize: function (size) {
		try {
		console.log ("enter ChartToolbar.resize");
		var coords = dojo.coords(this.toolbarBody);
		var centerx =  coords.w/2;
		dojo.style(this.nub,"left",centerx+"px");
		console.log ("styled nub: " + centerx);
		console.log (this.nub);
		} catch (ex) {
			console.log (ex);
			alert (ex);
		}
	},
	getTableSize: function () {
		var size = iscPortlet.getPortletSize(this.global.iscPortletNamespace);
		console.log ("got portlet size, available.w: " + size.available.w + ", h: " + size.available.h);
		var coords = null;
		
		// temporary hack for IE
		if ((size.available.w === undefined) ||
			isNaN(size.available.w)) {
			// guess
			size.available.w = 450;
		}

		var tipTable = dojo.byId (this.global.namespace + "tbl_tipChartData");
		
		var node = this.metaDiv;
		//var showLastUpdated = dijit.byId (this.id + "showLastUpdated");
		if (node ) {
			// subtract size of date 
			coords = dojo.coords (node);
			if (coords.h < 16) {
				coords.h = 16;
			}
			size.available.h = size.available.h - coords.h;
			console.log ("removed meta data size: " + coords.h);
		} else 
		if (this.firstRender) {
			console.log ("firstRender and showLastUpdated is false.");
			// 1st render so those are not available yet, so use fixed size
			size.available.h = size.available.h - 16;
			this.firstRender = false;
		}
		
		// allow for extra space b/c we still get scroll bars on fixed size pages
		if (dojo.isIE) {
			size.available.h = size.available.h - 45;
			size.available.w = size.available.w - 11;
		} else {
			size.available.h = size.available.h - 0;
			size.available.w = size.available.w - 0;
		}

		// minimum height
		if (size.available.h <= 25) {
			size.available.h = 25;
		}
		
		console.log ("return chart size (after subtracting other UI elements): ");
		console.log (size);
		
		return (size);
	},


	onSave: function () {
		//this.savePrimitive ("saveShared", true);
		this.chartBuilder.chartUtil.savePrimitive ("saveShared", true);		
	},
	savePrimitive: function (action, showCompletion) {
		var callback = null;
		console.log ("enter savePrimitive with args: " + action + ", " + showCompletion);
		if (showCompletion) {
			callback = dojo.hitch (this, this.onSaveComplete);
		} 
		
		if (this.allowSubmit_) {
			var hiddenparams = this.getHiddenParameters();
			var url = "?" + hiddenparams;

			var kw = {
				 appendURL: url,
	             content:   {
                        command: "savePreferences",
                        arg_portletNamespace: this.global.namespace,
                        action: action
                        },
            	 onResponse:{
                         callback: callback
       	                }
    	     };
	        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		} else {
			this.allowSubmit_ = true;
		}
		
		// do not submit
		return (false);
	},
	onSaveComplete: function (data, ioArgs) {
		console.info ("enter onSaveComplete");

		var msgID = "TIPCH3005I";
		console.log("messages"+this.messages_);
		var msg = this.messages_.TIPCH3005I;
		this.global.showMessageDialog("info", msgID, msg, false);
	},
	getHiddenParameters: function () {
		var type = "TIPServer";
		var appID = this.chartBuilder.widgetDefinition.datasource.id;

		var urlfrag = this.global.namespace + "chartNameH=" + dojo.byId (this.global.namespace + "chartNameH").value;
		urlfrag += "&" + this.global.namespace + "descriptionH=" + dojo.byId (this.global.namespace + "descriptionH").value;
		urlfrag += "&" + this.global.namespace + "connectionNameH=" + dojo.byId (this.global.namespace + "connectionNameH").value;
		urlfrag += "&" + this.global.namespace + "chartIDH=" + this.chartBuilder.chartID;
		urlfrag += "&" + this.global.namespace+ "chartSourceTypeGroup=" + type;
		urlfrag += "&" + this.global.namespace + "appID=" + appID;
		urlfrag += "&arg_partialSave=false";

		return (urlfrag);	
	},

	
	
  	onRefresh: function () {
  		// TODO: Consider paging
//		var start = this.currentPage * this.chartFetcher.rowsPerPage + 1;
//		this.chartFetcher.fetchData (start, this.chartFetcher.rowsPerPage);
		var busyPane = dijit.byId(this.global.namespace+"busy_pane");
	    if ( busyPane ) {
	      console.log ("showing busypane");
	      busyPane.show(true); // size to portlet
		}
	    if(this.chartBuilder.chartPager){
	    	this.chartBuilder.chartPager.onRefresh();
	    }else{
	    	this.chartFetcher.fetchData();
	    }
  	},
  	onPreferences: function () {
  		console.log ("ChartToolbar.onPreferences: this.global: ");
  		console.log (this.global);
		this.preferencesDialog = new ibm.tivoli.tip.charts.dijit.ChartPreferences ( 
				{ global: this.global,
				  chartBuilder: this.chartBuilder
				} 
			);
		this.preferencesDialog.startup();
		this.preferencesDialog.show();
  	},
  	getToolbar: function () {
  		console.log ("ChartToolbar.getToolbar: returning this.toolbar: " + this.toolbar);
  		return (this.toolbar);
  	},
	saveSharedPreferences: function() {
		console.log("enter charttoolbar.saveSharedPreferences");
		if(this.chartBuilder.widgetDefinition.user == undefined) {
			return;
		}
		var prefs = dojo.toJson(this.chartBuilder.widgetDefinition.user);

		var encodedCID = encodeURIComponent(this.chartBuilder.chartID);		
		var encodedProviderID = encodeURIComponent(this.chartBuilder.providerID);		
		var encodedDS = encodeURIComponent(this.chartBuilder.datasourceID);		
		var encodedPID = encodeURIComponent(this.global.chartProfileID);
		var widgetDefVersion = this.chartBuilder.widgetDefinition.meta.version;	
		var widgetSchema = this.chartBuilder.widgetDefinition.meta.type;
		
		var controller = "/ibm/tivoli/rest";		
		console.log (controller + "/providers/tip.charts/datasources/" + encodedDS + "/widgets/" + widgetSchema + "/definitions/" + encodedCID + "-" + widgetDefVersion + "?type=shared&profileID=" + this.global.chartProfileID + "&registryLocation=local");
		
        var kw = {
        			  sync: true,
					  preventCache: true,
        			  headers: {'Content-Type': 'application/json',
        			  		   'Content-Length': prefs.length
        			  		  },
        			  url: controller + "/providers/" + encodedProviderID + "/datasources/" + encodedDS + "/widgets/" + widgetSchema + "/definitions/" + encodedCID + "-" + widgetDefVersion + "?type=shared&profileID=" + this.global.chartProfileID + "&registryLocation=local",
                      putData: prefs,
                      error: dojo.hitch (this, function (error) {											
							var errHandler = new ibm.tivoli.tip.charts.dojo.RESTErrorHandler(this.global);		
							errHandler.showError(dojo.fromJson(error.responseText));	
		 					})
                   };
          dojo.xhrPut (kw);         
          console.log ("exit charttoolbar.saveSharedPreferences");          
	},
  	destroy: function () {
		this.inherited ("destroy", arguments);
		if(this.toolbar){
			this.toolbar.destroyRecursive();
		}	
	}
});
