dojo.provide("ibm.tivoli.tip.charts.dijit.ChartVisualPreviewer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartBuilder");
dojo.require("ibm.tivoli.tip.charts.dijit.TableBuilder");
dojo.require("ibm.tivoli.tip.dojo.Global");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartVisualPreviewer",[dijit._Widget,dijit._Templated],{
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/ChartVisualPreviewer.html"),	
	widgetDef: null,
	_builder: null,
	globalConfig: null,
	_beingBuilt: null,
	
	constructor: function(){
		this.widgetParams = {
			standalone:true,
			ignoreTitlebar:true,
			ignoreToolbar:true,
			ignoreContextMenu:true
		};
		this.globalConfig = {};
		this.global = ibm.tivoli.tip.dojo.Global.setSingleton( "", {} );	
		/* No way to balance the value to fit into all cases
		this.barChartProperties = {
			"chartMargins" : [{
				"browser": "IE",
				"marginValue": {"l": -5, "t": 0, "r": 0, "b": 0}
			},
			{
				"browser": "FF",
				"marginValue": {"l": -40, "t": 0, "r": 10, "b": 0}
			}]
		};
		this.columnChartProperties = {
			"chartMargins" : [{
				"browser": "IE",
				"marginValue": {"l": -10, "t": 0, "r": -10, "b": 0}
			},
			{
				"browser": "FF",
				"marginValue": {"l": -30, "t": 0, "r": -40, "b": 0}
			}]
		};
		this.lineChartProperties = {
			"chartMargins" : [{
				"browser": "IE",
				"marginValue": {"l": -10, "t": 0, "r": 0, "b": 0}
			},
			{
				"browser": "FF",
				"marginValue": {"l": -20, "t": 0, "r": 10, "b": 0}
			}]
		};
		*/
		this.plotProperties = {
			gap: 5,
			maxBarSize: 15
		};
		this._beingBuilt = false;
	},
	
	startup: function(){
		this.inherited(arguments);
	},
	
	_buildParams: function(){
		var params = {
				global: this.global,
				providerID: this.widgetDef.provider.id,
				datasourceID: this.widgetDef.datasource.id,
				chartID: this.widgetDef.meta.id,		
				tableID: this.widgetDef.meta.id,
				widgetDefinition: this.widgetDef
		};			
		return params;
	},
	
	_buildChart: function(){	
		var params = this._buildParams();
		dojo.mixin (params, this.widgetParams);			
		var widgetDiv = dojo.doc.createElement( 'div' );
		this.chartDiv.appendChild(widgetDiv);
		this._builder = new ibm.tivoli.tip.charts.dijit.ChartBuilder(params, widgetDiv); 
		this.connect(this._builder, "afterFetch", dojo.hitch(this, function(){
			try{				
			this._builder.resize(dojo.clone(this.size));
			dojo.style(this.outerFrame, {width: this.size.w+"px"});
			}catch(e){
    		console.error(e.message);	
  			}finally{	
			this._beingBuilt = false;
			}
		}));	
		this._builder.startup();				
	},
	
	_buildTable: function(){
		var params = this._buildParams();
		params.widgetParams = this.widgetParams;
		var widgetDiv = dojo.doc.createElement( 'div' );
		this.chartDiv.appendChild(widgetDiv);
		params.div = widgetDiv;
		this._builder = new ibm.tivoli.tip.charts.dijit.TableBuilder( params,widgetDiv);	
		this.connect(this._builder, "loadComplete", dojo.hitch(this, function(){
			try{
			if(!this.widgetDef.tables[0].common.showLastUpdateTime){
				dojo.style(this._builder.table.footerToolbar.domNode,{"display":"none"});
			}						
			this._builder.resize(dojo.clone(this.size));
			}catch(e){
    		console.error(e.message);	
  			}finally{	
			this._beingBuilt = false;
			}		
		}));
		this._builder.startup();		
	},
	
	setWidgetDefinition: function(widgetDef){	
		this.widgetDef = dojo.clone(widgetDef);
		if(!this._beingBuilt){
		this._beingBuilt = true;
		try{
		if(this._builder){
			this._builder.destroyRecursive();
		}
		if(this.widgetDef.tables){	
			if(!this.globalConfig.isPagingSet && !this.globalConfig.isEditWidget){	
				this.widgetDef.tables[0].common.paging = false;	
			}	
			this._buildTable();			
		}else if(this.widgetDef.charts){			
			this.widgetDef.charts[0].plot = this.plotProperties;
			if(this.widgetDef.charts[0].type == "Lines"){
				if(!this.globalConfig.isPagingSet && !this.globalConfig.isEditWidget){	
					this.widgetDef.charts[0].common.paging = true;		
					this.widgetDef.charts[0].common.pagingSize = 10;			
				}
				//this.widgetDef.charts[0].chartProperties = this.lineChartProperties;
			}else{
				/* Remove all margin setting
				if(this.widgetDef.charts[0].type.indexOf("Bar")!=-1){
					this.widgetDef.charts[0].chartProperties = this.barChartProperties;
				}else{
					this.widgetDef.charts[0].chartProperties = this.columnChartProperties;
				}
				*/		
				if(!this.globalConfig.isPagingSet && !this.globalConfig.isEditWidget){	
					this.widgetDef.charts[0].common.paging = true;	
					this.widgetDef.charts[0].common.pagingSize = 2;
				}	
			}			
			this._buildChart();
		}else{
			this._beingBuilt = false;
		}
		}catch(e){
			this._beingBuilt = false;
			console.error(e.message);		
		}	
		}
	},
	
	destroyChart: function(){
		if(this._builder){
			this._builder.destroyRecursive();
		}
	},
	
	resize: function(size){		
		if(size){
			this.size = dojo.clone(size);
		}		
		if(this._builder){					
			this._builder.resize(dojo.clone(this.size));	
		}
	},
	
	destroy: function(){
		this.inherited (arguments);
		this.destroyChart();
	}
});