dojo.provide("ibm.tivoli.tip.charts.dijit.ChartVisualizationWizard");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartVisualization");
dojo.require("ibm.tivoli.tip.charts.dijit.TableVisualization");

dojo.declare("ibm.tivoli.tip.charts.dijit.ChartVisualizationWizard",[dijit._Widget, dijit._Templated],{
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/ChartVisualizationWizard.html"),
	widgetDef: null,	
	selectedChart: null,
	_chartPanels: [],
	_dataStore: null,
	_labelStore: null,
	_gridStore: null,
	_visualDefBak: null,
	
	_numericTypeEnum: ["java.lang.Integer", "java.lang.Double", 	"java.lang.Long", "java.lang.Decimal", 
					   "byte", "short", "int", "long", "byte[]", "short[]", "int[]", "long[]",
					   "ubyte", "ushort", "uint", "ulong", "ubyte[]", "ushort[]", "uint[]", "ulong[]",	
					   "float", "double", "percentage", "float[]", "double[]"],	
	
	constructor: function(){
		console.log ("enter ChartVisualizationWizard.constructor");
		this._resources = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");		
		this.widgetDef = null;		
		this.selectedChart = null;	
		this._chartPanels = [];
		this._gridStore = {items: []};
		this._visualDefBak = {};
		console.log ("exit ChartVisualizationWizard.constructor");
	},
	
	_buildGridStore: function(){
		console.log ("enter ChartVisualizationWizard._buildGridStore");
		this._gridStore.items = [];
		if(this.widgetDef && this.widgetDef.charts){
			this._chartLabelValue = this.widgetDef.charts[0].xAxis.dataColumn;
			var i=0;
			for(i=0;i<this.widgetDef.charts[0].yAxis.series.length;i++){
				var series = this.widgetDef.charts[0].yAxis.series[i];
				var item = {
					value: series.dataColumn,
					label: series.tooltipColumn
				};
				this._gridStore.items.push(item);
			}
		}else{
			this._gridStore.items.push({value:null,label:null});			
		}
		console.log ("exit ChartVisualizationWizard._buildGridStore");
	},
	
	_isnumericValue: function(aType){
		console.log ("enter ChartVisualizationWizard._isnumericvalue");
		var i=0;
		for(i=0;i<this._numericTypeEnum.length;i++){
			if(this._numericTypeEnum[i] === aType){
				console.log ("exit ChartVisualizationWizard._isnumericvalue: " + true);
				return true;
			}
		}
		console.log ("exit ChartVisualizationWizard._isnumericvalue: " + false);
		return false;
	},
	
	_buildDataStore: function(){
		console.log ("enter ChartVisualizationWizard._buildDataStore");
		var data = {
			'identifier': 'id',
			'label': this.SEARCH_ATTR,
			'items': [] };
		var label = {
			'identifier': 'id',
			'label': this.SEARCH_ATTR,
			'items': [] };
		if(this.widgetDef){
			var dataSetAttrs = dojo.clone(this.widgetDef.datasets[0].columns);
			console.log ("dataSetAttrs:");
			console.log (dojo.toJson (dataSetAttrs));
			console.dir (dataSetAttrs);
			var i=0;	
			for(i=0;i<dataSetAttrs.length;i++){
				dataSetAttrs[i].label = dataSetAttrs[i].label.value;
				if(this._isnumericValue(dataSetAttrs[i].type)){
					data.items.push(dataSetAttrs[i]);
				}
			}
			label.items = dojo.clone(dataSetAttrs);
		}
		this._dataStore = new dojo.data.ItemFileWriteStore({data: data});
		this._labelStore = new dojo.data.ItemFileWriteStore({data: label});
		console.log ("exit ChartVisualizationWizard._buildDataStore");
	},	
	
	postMixInProperties: function(){		
		console.log ("enter ChartVisualizationWizard.postMixInProperties");
		this._buildDataStore();		
		this._buildGridStore();		
		console.log ("exit ChartVisualizationWizard.postMixInProperties");
	},	
	
	_updateSelectedChart: function(){
		console.log ("enter ChartVisualizationWizard._updateSelectedChart");
		var chartTypedef = null;
		if(this.widgetDef && (this.widgetDef.charts || this.widgetDef.tables)){
			if(this.widgetDef.tables){
				chartTypedef = "Table";
			}else{
				chartTypedef = this.widgetDef.charts[0].type;
			}
			if(chartTypedef==="Pie"){
				this.pieChartPanel.selected= true;
				this.selectedChart = this._chartPanels[0];
			}else if(chartTypedef==="Lines"){
				this.lineChartPanel.selected= true;
				this.selectedChart = this._chartPanels[1];
			}else if(chartTypedef==="dojot.visual.ColumnsEmbossed"){
				this.columnChartPanel.selected= true;
				this.selectedChart = this._chartPanels[2];
			}else if(chartTypedef==="dojot.visual.StackedColumnsEmbossed"){
				this.stackedColumnChartPanel.selected= true;
				this.selectedChart = this._chartPanels[3];
			}else if(chartTypedef==="dojot.visual.ClusteredColumnsEmbossed"){
				this.clusteredColumnChartPanel.selected= true;
				this.selectedChart = this._chartPanels[4];
			}else if(chartTypedef==="dojot.visual.BarsEmbossed"){
				this.barChartPanel.selected= true;
				this.selectedChart = this._chartPanels[5];
			}else if(chartTypedef==="dojot.visual.ClusteredBarsEmbossed"){
				this.clusteredBarChartPanel.selected= true;
				this.selectedChart = this._chartPanels[6];
			}else if(chartTypedef==="dojot.visual.StackedBarsEmbossed"){
				this.stackedBarChartPanel.selected= true;
				this.selectedChart = this._chartPanels[7];
			}else if(chartTypedef==="Table"){
				this.tableChartPanel.selected= true;
				this.selectedChart = this._chartPanels[8];
			}else{
				this.pieChartPanel.selected= true;
				this.selectedChart = this._chartPanels[0];				
			}
		}else{
			console.log ("widgetDef or widgetDef.charts or widgetDef.tables is not defined");
			//this.pieChartPanel.selected= true;
			//this.selectedChart = this._chartPanels[0];
		}		
		console.log ("exit ChartVisualizationWizard._updateSelectedChart");
	},
	
	postCreate: function(){
		console.log ("enter ChartVisualizationWizard.postCreate");
		this.inherited(arguments);	
		var pieChart = new ibm.tivoli.tip.charts.dijit.ChartVisualization({
			widgetDef:this.widgetDef, 
			_chartLabelValue: this._chartLabelValue,
			_dataStore: this._dataStore,
			_labelStore: this._labelStore,
			_gridStore: this._gridStore,
			selectorLabel:this._resources.V_CHART_PIE_LABEL, 
			chartType: "Pie",
			gridHeaders:[this._resources.V_GRID_HEADER_PIE_VALUE_LABEL,this._resources.V_GRID_HEADER_PIE_LABEL_LABEL]},this.pieDiv);	
		this._chartPanels.push(pieChart);
	
		var lineChart = new ibm.tivoli.tip.charts.dijit.ChartVisualization({
			widgetDef:this.widgetDef, 
			_chartLabelValue: this._chartLabelValue,
			_dataStore: this._dataStore,
			_labelStore: this._labelStore,
			_gridStore: this._gridStore,
			selectorLabel:this._resources.V_CHART_AXIS_X_LABEL, 
			chartType: "Lines",
			gridHeaders:[this._resources.V_GRID_HEADER_CHART_AXIS_Y_LABEL,this._resources.V_GRID_HEADER_CHART_AXIS_Y_TOOLTIP_LABEL]},this.lineDiv);
		this._chartPanels.push(lineChart);
	
		var columnChart = new ibm.tivoli.tip.charts.dijit.ChartVisualization({
			widgetDef:this.widgetDef,
			_chartLabelValue: this._chartLabelValue,
			_dataStore: this._dataStore,
			_labelStore: this._labelStore,
			_gridStore: this._gridStore,			 
			selectorLabel:this._resources.V_CHART_AXIS_X_LABEL, 
			chartType: "dojot.visual.ColumnsEmbossed",
			gridHeaders:[this._resources.V_GRID_HEADER_CHART_AXIS_Y_LABEL,this._resources.V_GRID_HEADER_CHART_AXIS_Y_TOOLTIP_LABEL]},this.columnDiv);
		this._chartPanels.push(columnChart);
		
		var stackedColumnChart = new ibm.tivoli.tip.charts.dijit.ChartVisualization({
			widgetDef:this.widgetDef, 
			_chartLabelValue: this._chartLabelValue,
			_dataStore: this._dataStore,
			_labelStore: this._labelStore,
			_gridStore: this._gridStore,
			selectorLabel:this._resources.V_CHART_AXIS_X_LABEL, 
			chartType: "dojot.visual.StackedColumnsEmbossed",
			gridHeaders:[this._resources.V_GRID_HEADER_CHART_AXIS_Y_LABEL,this._resources.V_GRID_HEADER_CHART_AXIS_Y_TOOLTIP_LABEL]},this.stackedColumnDiv);
		this._chartPanels.push(stackedColumnChart);
		
		var clusteredColumnChart = new ibm.tivoli.tip.charts.dijit.ChartVisualization({
			widgetDef:this.widgetDef, 
			_chartLabelValue: this._chartLabelValue,
			_dataStore: this._dataStore,
			_labelStore: this._labelStore,
			_gridStore: this._gridStore,
			selectorLabel:this._resources.V_CHART_AXIS_X_LABEL, 
			chartType: "dojot.visual.ClusteredColumnsEmbossed",
			gridHeaders:[this._resources.V_GRID_HEADER_CHART_AXIS_Y_LABEL,this._resources.V_GRID_HEADER_CHART_AXIS_Y_TOOLTIP_LABEL]},this.clusteredColumnDiv);
		this._chartPanels.push(clusteredColumnChart);
	
		var barChart = new ibm.tivoli.tip.charts.dijit.ChartVisualization({
			widgetDef:this.widgetDef,
			_chartLabelValue: this._chartLabelValue, 
			_dataStore: this._dataStore,
			_labelStore: this._labelStore,
			_gridStore: this._gridStore,
			selectorLabel:this._resources.V_CHART_AXIS_Y_LABEL, 
			chartType: "dojot.visual.BarsEmbossed",
			gridHeaders:[this._resources.V_GRID_HEADER_CHART_AXIS_X_LABEL,this._resources.V_GRID_HEADER_CHART_AXIS_Y_TOOLTIP_LABEL]},this.barDiv);
		this._chartPanels.push(barChart);		
	
		var stackedBarChart = new ibm.tivoli.tip.charts.dijit.ChartVisualization({
			widgetDef:this.widgetDef, 
			_chartLabelValue: this._chartLabelValue,
			_dataStore: this._dataStore,
			_labelStore: this._labelStore,
			_gridStore: this._gridStore,
			selectorLabel:this._resources.V_CHART_AXIS_Y_LABEL, 
			chartType: "dojot.visual.StackedBarsEmbossed",
			gridHeaders:[this._resources.V_GRID_HEADER_CHART_AXIS_X_LABEL,this._resources.V_GRID_HEADER_CHART_AXIS_Y_TOOLTIP_LABEL]},this.stackedBarDiv);
		this._chartPanels.push(stackedBarChart);
		
		var clusteredBarChart = new ibm.tivoli.tip.charts.dijit.ChartVisualization({
			widgetDef:this.widgetDef, 
			_chartLabelValue: this._chartLabelValue,
			_dataStore: this._dataStore,
			_labelStore: this._labelStore,
			_gridStore: this._gridStore,
			selectorLabel:this._resources.V_CHART_AXIS_Y_LABEL, 
			chartType: "dojot.visual.ClusteredBarsEmbossed",
			gridHeaders:[this._resources.V_GRID_HEADER_CHART_AXIS_X_LABEL,this._resources.V_GRID_HEADER_CHART_AXIS_Y_TOOLTIP_LABEL]},this.clusteredBarDiv);
		this._chartPanels.push(clusteredBarChart);
	
		var tableChart = new ibm.tivoli.tip.charts.dijit.TableVisualization({
			widgetDef:this.widgetDef},this.tableDiv);
		this._chartPanels.push(tableChart);
	
		this.connect(this.chartContainer,"selectChild",dojo.hitch(this, function(child){
			this.selectedChart = child.getChildren()[0];
			if(this.selectedChart.chartType){
				if(!this.widgetDef.charts && this._visualDefBak.charts){
					this.widgetDef.charts = this._visualDefBak.charts;									
				}
				this.selectedChart._updateLabelSelector();	
			}else{
				if(!this.widgetDef.tables && this._visualDefBak.tables){
					this.widgetDef.tables = this._visualDefBak.tables;
				}	
			}
			delete this._visualDefBak.charts;
			delete this._visualDefBak.tables;
		}));
		
		this.connect(this.chartContainer,"selectChild","onChange");

		var i=0;		
		for(i=0;i<this._chartPanels.length;i++){
			this.connect(this._chartPanels[i],"onChange","onChange");
		}
		
		this._updateSelectedChart();
		
		if(!this.selectedChart){
			this.pieChartPanel.selected= true;
			this.selectedChart = this._chartPanels[0];
		}
		console.log ("exit ChartVisualizationWizard.postCreate");
	},
	
	/*
	Resolve defect 251886f_1, dojo component dijit.layout.ContentPane has some problem with iconclass attribute,
	can not display the tool tip on the image in IE8, Firefox is ok. So have to add alt attribute to img.
		*/
	startup: function(){
		this.inherited(arguments);
		if(dojo.isIE){
			try{
				var tabChildren = this.chartContainer.domNode.childNodes[0].childNodes;
				for(var i=0;i<tabChildren.length;i++){
					var imgNode = tabChildren[i].childNodes[0].childNodes[0].childNodes[0].childNodes[0];
					imgNode.setAttribute("alt",imgNode.parentNode.title);
				}
			}catch(error){}
		}
	},

	setWidgetDefinition: function(widgetDef){
		console.log ("enter ChartVisualizationWizard.setWidgetDefinition");
		this.widgetDef = widgetDef;
		this._buildDataStore();
		this._buildGridStore();
		if(this.selectedChart.chartType){
			this.selectedChart.setDataStore(this._dataStore);
			this.selectedChart.setLabelStore(this._labelStore);
		}
		this.selectedChart.setWidgetDefinition(this.widgetDef);
		var i=0;
		for(i=0;i<this._chartPanels.length;i++){
			if(this._chartPanels[i]!==this.selectedChart){
				if(this._chartPanels[i].chartType){
					this._chartPanels[i].setDataStore(this._dataStore);
					this._chartPanels[i].setLabelStore(this._labelStore);
				}
				this._chartPanels[i].setWidgetDefinition(this.widgetDef);
			}
		}
		this._updateSelectedChart();
		console.log ("exit ChartVisualizationWizard.setWidgetDefinition");
	},
	
	onChange: function(){
		console.log("ChartVisualizationWizard.onChange");
	},
	
	resize: function(size){
		console.log ("enter ChartVisualizationWizard.resize");
		dojo.style (this.domNode, {
				"width": size.w,
				"height": size.h
		});
		//size.w = size.w - 7;
		var coords = dojo.coords (this.titleDiv);
		size.h = size.h - coords.h;		
		this.chartContainer.resize(size);
		console.log ("exit ChartVisualizationWizard.resize");
	},
	
	isValid: function(){
		return this.selectedChart.isValid();
	},
	
	noChartConfig: function(){
		return this.selectedChart.noChartConfig();
	},
	
	getWidgetDefinition: function(){
		console.log ("enter ChartVisualizationWizard.getWidgetDefinition");
		//delete this.widgetDef.charts;
		//delete this.widgetDef.tables;
		var widgetDef = null;
		if(this.selectedChart.chartType){
			if(this.widgetDef.tables){
				this._visualDefBak.tables = this.widgetDef.tables;
			}
			delete this.widgetDef.tables;
			if(!this.widgetDef.charts){
				this.widgetDef.charts = this.selectedChart.getWidgetDefinition();
			}else{
				widgetDef = this.selectedChart.getWidgetDefinition();
				this.widgetDef.charts[0].type = widgetDef[0].type;
				this.widgetDef.details.preferredView = widgetDef[0].type;
				this.widgetDef.details.subType = widgetDef[0].type;
				
				dojo.mixin(this.widgetDef.charts[0].xAxis, widgetDef[0].xAxis);
				dojo.mixin(this.widgetDef.charts[0].yAxis, widgetDef[0].yAxis);	
			}			
		}else{
			if(this.widgetDef.charts){
				this._visualDefBak.charts = this.widgetDef.charts;
			}
			delete this.widgetDef.charts;			
			if(!this.widgetDef.tables){
				this.widgetDef.tables = this.selectedChart.getWidgetDefinition();
			}else{
				widgetDef = this.selectedChart.getWidgetDefinition();				
				this.widgetDef.tables[0].datasource = widgetDef[0].datasource;
				this.widgetDef.tables[0].dataset = widgetDef[0].dataset;
				this.widgetDef.tables[0].view = widgetDef[0].view;
				this.widgetDef.details.preferredView = "Table";
				this.widgetDef.details.subType = "Table";
			}
		}		
		console.log ("exit ChartVisualizationWizard.getWidgetDefinition");
		return this.widgetDef;
	}
});