dojo.provide("ibm.tivoli.tip.charts.dijit.DataSetPage");

dojo.require("ibm.tivoli.tip.charts.dijit.ChartPanelPage");
dojo.require("ibm.tivoli.widgetbuilder.datasetselector.DatasetSelector");

dojo.declare("ibm.tivoli.tip.charts.dijit.DataSetPage",[ibm.tivoli.tip.charts.dijit.ChartPanelPage],{
	
	constructor: function(){
		this.contentTitle = this.resources_.DATASET_CONTENT_TITLE; 
		this.contentDesc = this.resources_.DATASET_CONTENT_DESC;
		this.pageId = "1st_visualDatasetPage";
		this._columns = null;
	},
		
	isBackReady: function(){
		return this.widgetDefCont.isDone("back");
	},
	
	allowNext: function() {  		
		var allownext = false;   
		if( this.widgetDefCont.isDone("next") ) {			
			allownext = true;
		}else{
			this._setNextPage();			
			allownext = false;
		}		
		return allownext;
	},
	
	allowBack: function(){   		
		if( this.widgetDefCont.isDone("back") ){
			return true;
		}else{			
			this._setBackPage();
			return false;
		}
	},
  
    _setNextPage: function(){		
		if( this.widgetDefCont.currentview === null ){			
			this.widgetDefCont.setView("view_connections");
			this.widgetDefCont.displayView();             
		}else if( this.widgetDefCont.currentview == "view_connections"  && this.widgetDefCont.isItemSet("connection") ){			
			this.widgetDefCont.setView("view_datasources");
			this.widgetDefCont.displayView(); 
		}else if ( this.widgetDefCont.currentview == "view_datasources" && this.widgetDefCont.isItemSet("datasource")){			
			this.widgetDefCont.setView("view_datasets");
			this.widgetDefCont.displayView();
		}else if ( this.widgetDefCont.currentview == "view_datasets" && this.widgetDefCont.isItemSet("dataset") ){			
		}else{ 			
		}
	},
	
	_setBackPage: function(event){		
		if ( this.widgetDefCont.currentview === null ){        
			this.widgetDefCont.setView("view_datasets");
			this.widgetDefCont.displayView();     
		}else if( this.widgetDefCont.currentview == "view_datasets" ){       
			this.widgetDefCont.setView("view_datasources");
			this.widgetDefCont.displayView();     
		}else if ( this.widgetDefCont.currentview == "view_datasources" ){       
			this.widgetDefCont.setView("view_connections"); 
			this.widgetDefCont.displayView();
		}else {
		}
	},
	
	_customizeDataSelector: function(){
		try{
		dojo.style(dojo.byId("datasetselectorBorderContainer"),{width:"100%",height:"100%"});
		dojo.style(dojo.byId("datasetselectorResults"),{width:"61%"});
		dojo.style(dojo.byId("detailview"),{width:"35%"});
		}catch(e){		
		}
	},
	
	OnPageSelected: function(){	
		this.inherited(arguments);		
		if(!this.widgetDefCont){
			this.widgetDefCont = new ibm.tivoli.widgetbuilder.datasetselector.DatasetSelector({		
				width: this.operateAreaSize.w +"px",
				height: this.operateAreaSize.h +"px",
				wizardref :this.wizard,
				widgetDefinition: this.widgetDef
			},this.operateDiv);	
			this.widgetDefCont.startup();
			this.widgetDefCont.resize(this.operateAreaSize);
			//this._customizeDataSelector();
			this.connect(this.widgetDefCont, "onDataSetColumnsLoaded", dojo.hitch(this, function(response, ioagrs){ //connect to private method, may suffer from change
				this._columns = [];
				for(var i=0;i<response.items.length;i++){
					var col = {
						id: response.items[i].id,
						label: {
							key: response.items[i].label,
							value: response.items[i].label
						},
						type: response.items[i].valueType
					};					
					this._columns.push(col);
				}	
				this.widgetDefCont.getWidgetDefinition();		
				this.widgetDef.datasets[0].columns = this._columns;
				this.widgetDef.datasets[0].datasource = this.widgetDef.datasource.id;
				this.widgetDef.datasets[0].datasourceType = "com.ibm.tivoli.tip.rest";
				this.widgetDef.datasets[0].query = "";
			}));
			this.widgetDefCont.subscribe(dojo.hitch(this, this.updateNotify));		
		}		
	},
	
	updateNotify: function(){
		if(this.widgetDefCont.isValid()){
			this.onChange();
		}
	},
	
	getWidgetDefinition: function(){
		this.widgetDef = this.widgetDefCont.getWidgetDefinition();		
		this.widgetDef.datasets[0].columns = this._columns;
		this.widgetDef.datasets[0].datasource = this.widgetDef.datasource.id;
		this.widgetDef.datasets[0].datasourceType = "com.ibm.tivoli.tip.rest";
		this.widgetDef.datasets[0].query = "";
		return this.widgetDef;
	},
	
	resize: function(size){
		if(this._triggerResize(size)){		
		this.inherited(arguments);	
		this.operateAreaSize = {
			w: this._pageSize.w-5-10-5,
			h: this._pageSize.h-5-dojo.coords(this.titleArea.domNode).h
		};
		if(this.widgetDefCont){
			this.widgetDefCont.resize(this.operateAreaSize);
		}
		}
	}

});