dojo.provide("ibm.tivoli.tip.charts.dijit.DropdownColorPicker");

dojo.require("dijit.form.FilteringSelect");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Select");

dojo.declare("ibm.tivoli.tip.charts.dijit.DropdownColorPicker",[dijit._Widget,dijit._Templated],{
	
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/DropdownColorPicker.html"),
	_cachedDropDown: null,
	colorValue: null,
	colorIndex: null,	
	
	colors:[ "#205870", "#997fb2", "#f8d080", "#ffaa1c",  "#4ccc33", "#00005d", "#ccb2e5", "#d0a048", "#0758c4", "#c3c300", "#66667f", "#270e96", "#bcd2e8", "#986030", "#ffaa1c", "#205870", "#7faddc", "#99991d", "#997fb2", "#f8d080", "#153c05"],
	
	_isPaletteActive: false,
	colsCount: 7,
	rowsCount: 3,
	_hoverColorIndex: null,
	_colorUnitBlocks: [],
	
	constructor: function(){
		//this.colors = null;	
		this._cachedDropDown = null;
		this.colorValue = null;
		// this.colorIndex = null;		
	},
	
	_createColorPalette: function(){		
		var htmlString = "<table>";		
		var i=0;
		for(i=0;i<this.rowsCount;i++){		
			htmlString += "<tr>";
			for(var j=0;j<this.colsCount;j++){				
				htmlString += "<td>";				
				if(this.colsCount*i+j==this.colorIndex){
					htmlString += "<div style='width:14px;height:12px; border:2px solid #000000;background-color: "+this.colors[this.colsCount*i+j]+";'>";
				}else{
					htmlString += "<div style='width:14px;height:12px; border:1px solid #C0C0C0;background-color: "+this.colors[this.colsCount*i+j]+";'>";
				}				
				htmlString += "</div>";
				htmlString += "</td>";
			}
			htmlString += "</tr>";
		}
		htmlString += "</table>";
		this.colorBoxDiv.innerHTML = htmlString;
		dojo.query('div', this.colorBoxDiv).forEach(dojo.hitch(this, "_setColorUnit"));
	},	
	
	_setColorUnit: function(div, index, arr){
		this._colorUnitBlocks[index] = div;
		div.colorIndex = index;		
		this.connect( div,"onclick", "_pickColor");
		if(dojo.isSafari){
			this.connect( div,"onmousedown", "_pickColor");
		}
		this.connect( div,"onmouseover", function(event){					
			var target = event.currentTarget ? event.currentTarget : event.srcElement;
			target.style.borderColor = "#000000";			
		});
		this.connect( div,"onmouseout", function(event){			
			var target = event.currentTarget ? event.currentTarget : event.srcElement;
			if(target.style.borderWidth!="2px"){
				target.style.borderColor = "#C0C0C0";
			}			
		});		
		if(div.colorIndex == this.colorIndex){					
			dojo.style(div,{"border":"2px solid #000000", "width":"14px", "height":"12px","backgroundColor":this.colors[index]});
			this.selectedColorUnit = div;
		}
	},
	
	postCreate: function(){
		this.inherited(arguments);
		dojo.style(this.colorSelDialog,{"display":"none", "position": "fixed"});
		try{
			this._createColorPalette();
		}catch(e){
			alert(e.message);
		}
		
		this.connect(this.colorSelDropDown,"onClick","_showColorPalette");		
		this.connect(this.colorSelDropDown, "onKeyDown", "_onSelBoxKeyDown");
		this.connect(this, "onBlur", "_hideColorPalette");
	},	
	
	_onSelBoxKeyDown: function(e) {
		if(this._isPaletteActive == false) {
			if(e.keyCode == dojo.keys.DOWN_ARROW || e.keyCode == dojo.keys.ENTER) {
				this._showColorPalette();
				return;
			}
		}

		if(e.keyCode == dojo.keys.ENTER) {
			if(this._hoverColorIndex != null) {
				this._selectColorUnit(this._hoverColorIndex);
				return;
			}
		}
		
		var colorsCount = this.colsCount * this.rowsCount;
		var hoverColorIndex = -1;
		switch(e.keyCode) {
			case dojo.keys.DOWN_ARROW:
				if(this._hoverColorIndex + this.colsCount < colorsCount) {
					hoverColorIndex = this._hoverColorIndex + this.colsCount;
				}
				break;
			case dojo.keys.UP_ARROW:
				if(this._hoverColorIndex - this.colsCount < colorsCount) {
					hoverColorIndex = this._hoverColorIndex - this.colsCount;
				}
				break;
			case dojo.keys.LEFT_ARROW:
				if(this._hoverColorIndex - 1 < colorsCount) {
					hoverColorIndex = this._hoverColorIndex - 1;
				}
				break;
			case dojo.keys.RIGHT_ARROW:
				if(this._hoverColorIndex + 1 < colorsCount) {
					hoverColorIndex = this._hoverColorIndex + 1;
				}
				break;
		}
		
		if(hoverColorIndex > -1) {
			this._hoverColorUnit(hoverColorIndex);
		}
	},
	
	_hoverColorUnit: function(colorUnitIndex) {
		if(colorUnitIndex < 0 || colorUnitIndex >= this.colsCount * this.rowsCount) {
			return;
		}
		
		if(this._hoverColorIndex != this.colorIndex) {
			this._resetColorUnit(this._hoverColorIndex);
		}
		this._hoverColorIndex = colorUnitIndex;
		
		if(colorUnitIndex == this.colorIndex) {
			return;
		}
		
		var colorUnitBlock = this._retrieveColorUnitBlock(colorUnitIndex);
		if(colorUnitBlock != null) {
			dojo.style(colorUnitBlock, {'borderWidth': '1px', 'borderColor': 'black'});
		}
	},
	
	_selectColorUnit: function(colorUnitIndex) {
		var colorUnitBlock = this._retrieveColorUnitBlock(colorUnitIndex);
		if(colorUnitBlock != null) {
			this._resetColorUnit(this.colorIndex);
			dojo.style(colorUnitBlock, {'borderWidth': '2px', 'borderColor': 'black'});
			this._hideColorPalette();
			this.colorSelDropDown._popupStateNode.innerHTML = "<div style='background-color: "+colorUnitBlock.style.backgroundColor+"; width:15px;height:15px;margin-top:2px;'></div>";
			
			if(this.colorIndex != colorUnitIndex) {
				this.colorIndex = colorUnitIndex;
				this.onChange();
			}
		}
	},
	
	_resetColorUnit: function(colorUnitIndex) {
		var colorUnitBlock = this._retrieveColorUnitBlock(colorUnitIndex);
		if(colorUnitBlock != null) {
			dojo.style(colorUnitBlock, {'borderWidth': '1px', 'borderColor': '#C0C0C0'});
		}
	},
	
	_retrieveColorUnitBlock: function(colorUnitIndex) {
		if(colorUnitIndex < 0 || colorUnitIndex >= this.colsCount * this.rowsCount) {
			return null;
		}
		return this._colorUnitBlocks[colorUnitIndex];
	},
	
	_showColorPalette: function() {
		this._isPaletteActive = true;
		this._hoverColorIndex = this.colorIndex;
		dojo.style(this.colorSelDialog, {display: 'block'});
		var coords = dojo.coords(this.colorSelDropDown.domNode); 
		dojo.style(this.colorSelDialog,'top',(coords.y + 23)+'px');
		dojo.style(this.colorSelDialog,'left', coords.x+'px');
	},
	
	_hideColorPalette: function() {
		this._isPaletteActive = false;
		dojo.style(this.colorSelDialog, {display: 'none'});
	},
	
	startup: function(){
		this.inherited(arguments);
		this._showSelectedColor();
		this._cachedDropDown = this.colorSelDropDown.dropDown;
		this.colorSelDropDown.dropDown = null;
	},
	
	_showSelectedColor: function(){
		if(this.colorIndex!=-1){			
			this.colorSelDropDown._popupStateNode.innerHTML = "<div style='background-color: "+this.colors[this.colorIndex]+"; width:15px;height:15px;margin-top:2px;'></div>";
		}
	},
	
	_pickColor: function(event){		
		if(this.selectedColorUnit){			
			this.selectedColorUnit.style.borderWidth = "1px";
			this.selectedColorUnit.style.borderColor = "#C0C0C0";
		}
		var target = event.currentTarget ? event.currentTarget : event.srcElement;
		this._selectColorUnit(target.colorIndex);
		this.selectedColorUnit = target;
	},
	
	setColors: function(colors){
		this.colors = colors;			
		this.colorBoxDiv.removeChild(this.colorBoxDiv.firstChild);
		this._createColorPalette();
		this._showSelectedColor();		
	},
	
	onChange: function(){
	},
	
	getValue: function(){
		return this.colorIndex;
	},
	
	getColorIndex: function(){
		return this.colorIndex;
	},
	
	getColorValue: function(){
		return this.colors[this.colorIndex];
	},
	
	destroy: function(){
		this.colorSelDropDown.dropDown = this._cachedDropDown;
		this.inherited(arguments);		
	}
	
});