/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: TIPChartPortlet/WebContent/js/ibm/tivoli/tip/charts/dijit/ParametersWidget.js, tipcharts
 * Version:       1.0
 * Last Modified: 11/24/09
 *******************************************************************************/

dojo.provide("ibm.tivoli.tip.charts.dijit.ParametersWidget");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dijit.form.CheckBox");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");


// define the widget class
dojo.declare (
	"ibm.tivoli.tip.charts.dijit.ParametersWidget", 
    [ dijit._Widget, dijit._Templated, dijit._Container ],
{
    namespace: "namespace1_",
    widgetsInTemplate: true,
    data: [],
    context: [],
    hasContext_: false,
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/ParametersWidget.html"),

	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
	    //this.resourceMessages_ = dojo.i18n.getLocalization("ibm.tivoli.tip.charts.dijit", "resources");
	},

	postCreate: function() { 
		this.inherited ("postCreate", arguments);
		this.addParameters (this.data);
	},
	
	addParameters: function (model) {
		try {		
		var param = null;
		var widget = null;

		for (var row in model) {
			if (row) {
				param = model[row];
				widget = new ibm.tivoli.tip.charts.dijit.Parameter ({
					parmid: this.id + "param_" + param.id + param.type,
					baseid: param.name,
					value: param.value,
					type: param.type,
					required: param.required,
					options : param.options,
					label: param.label.value
				});				
				this.addChild (widget);
			}
		}
		} catch (ex) {
			console.error (ex);
			throw (ex);
		}
	},	
	isContextOn: function () {
		var receiveContextRadio = dijit.byId(this.id + "contextualParametersSelected");		
		return receiveContextRadio.checked;
	},
	
	hasContext: function() {
		return this.hasContext_;
	},
	
	getParameterValue: function (parameterId, parameterType) {
		
		var value = null;
		
		/*if (this.isContextOn() && this.hasContext()) {
			console.log ("context is on and we have context");
			if (this.context[parameterName]) {
				console.log ("from context w/ parameter: " + parameterName + " and value: " + this.context[parameterName]);
				value = this.context[parameterName];
			} else {
				console.log ("context value is null for name: " + parameterName);
				value = null;
			}
		} else {*/
			var textbox = dijit.byId (this.id + "param_" + parameterId + parameterType);

			if(parameterType == "java.util.Boolean") {
				value = textbox.checked;
			}
			else {
				value = textbox.getValue();
			}
	//	}
		
		//value = this.urlizeValue (value);
		
		return (value);
	},
	
	urlizeValue: function (value) {
		if (value !== null) {
			value = value.replace ("&", ":::");
		}
		
		return (value);
	},

	setParameterValue: function (parameterName, parameterValue) {
		var textbox = dijit.byId (this.namespace + "param_" + parameterName);
		textbox.setValue (parameterValue);
	},

	setAllContext: function (ctxt) {
		var params = this.getParameters();
		var param = null;
		var value = null;
		var x = null;
		
		for (x in params) {
			if (x) {
				param = params[x];
				value = eval ("ctxt." + param.name);
				if (value) {
					this.setContext (param.name, value);
				}
			}
		}
		
		this.hasContext_ = true;
	},
	
	setContext: function (parameterName, parameterValue) {
		this.context[parameterName] = parameterValue;
		this.hasContext_ = true;
	},
	
	getParameters: function () {
		return this.data;
	},
		
	removeParameters: function () {
		dojo.forEach (this.getChildren(), function (child) {
			this.removeChild (child);
			child.destroy();
		}, this);
	},
	
	resetParameters: function () {
		var param = null;
		var widget = null;
		for (var row in this.data) {
			if (row) {
				param = this.data[row];
				widget = dijit.byId (this.namespace + "param_" + param.name);
				if (param.value === undefined) {
					param.value = "";
				}
				widget.setValue (param.value);
			}
		}
	},
	
	destroy: function () {
//		this.removeParameters();
		dojo.forEach (this.data, function (datum) {
			var param = dijit.byId (this.id + "param_" + datum.name);
			if (param) {
				param.destroy();
			}
		}, this);
		
		this.data = null;
		this.destroyDescendants();
		this.inherited (arguments);
	}

});
	

// define the widget class
dojo.declare (
	"ibm.tivoli.tip.charts.dijit.Parameter", 
    [ dijit._Widget, dijit._Container ],
{
	parmid: null,
	baseid: null,
	label: null,
	description: null,
	value: null,
	type: null,
	required: null,
	options: null,

	constructor: function () {
		console.log ("enter ParametersWidget.constructor");
		console.log ("exit ParametersWidget.constructor");
	},
	postCreate: function () {
		console.log ("enter ParametersWidget.postCreate");
		 var label = dojo.doc.createElement("label");              
         dojo.attr(label, { "id":this.parmid,"for":"${id}"+this.parmid });        
         label.innerHTML = this.label; 
         this.domNode.appendChild(label); 
		 this.domNode.appendChild(document.createElement("br"));

		 var parWidget = null;
		console.log ("ParametersWidget.postCreate... this.type: " + this.type); 
		 if ((this.type == "java.util.Boolean") || (this.type == "boolean")) {
			var checkBoxChecked = false;
			if(this.value == "true") {
				checkBoxChecked = true;
			}				
			parWidget = new dijit.form.CheckBox({
				id : this.parmid,
				value : this.value,
				name : this.parmid,
				checked : checkBoxChecked
			});
			this.addChild (parWidget);	 
			
		 } else if ((this.type == "java.util.Date") || (this.type == "date")) {
			parWidget = new dijit.form.DateTextBox({
				id : this.parmid,
				value : this.value,
				name : this.parmid,
                constraints:{datePattern:'MM/dd/yyyy'},
                lang:"en",
                required:this.required,
                promptMessage:"mm/dd/yyyy",
                invalidMessage:"Invalid date. Use mm/dd/yy format."
            });            
            this.addChild(parWidget); 
		 } else if ((this.type == "java.lang.Integer") || (this.type == "int")) {
			parWidget = new dijit.form.NumberTextBox({
				id : this.parmid,
				value : this.value,
				name : this.parmid,
				constraints:{min:0,max:1000000,places:0,strict: true,pattern: '#,######0.0#'},
				invalidMessage:"",
                promptMessage:""
			});
			this.addChild(parWidget);
		 } else if (this.type == "java.util.List") {
			var options = dojo.clone(this.options);
			for(var i=0;i<options.length;i++){
				options[i].label = options[i].label.value;
			}
			var selectOptions = new dojo.data.ItemFileWriteStore({data: {identifier: 'label', items:options}});
			parWidget = new dijit.form.ComboBox({
				id: this.parmid,
				name: this.parmid,
				value: this.value,
				store: selectOptions,
				searchAttr: "label"
         	},this.parmid);
		 	this.addChild(parWidget);
		} else { 			  
			parWidget = new dijit.form.ValidationTextBox({
                    type: "text",
                    id: this.parmid,
                    name: this.parmid,
                    size: "20",
                    required: this.required,
                    promptMessage: "Update "+this.label,
                    invalidMessage: "",
                    trim: true,
					value: this.value,
                    style: "width: 14em;"
                },
                document.createElement("input"));
				this.addChild (parWidget);
			if ((this.type == "java.lang.String") || (this.type == "string")) {
				// nothing to do here... 
			} else {
				console.warn ("Unknown type in ParametersWidget.postCreate.  Rendering as text box: " + this.type);
				parWidget.set('disabled', true);
			}
		}
	},
	setValue: function (value) {
		this.value = value;
	},
	getValue: function () {
		return this.value;
	},
	destroy: function () {
//		if (dijit.byId(this.parmid)) {
//			console.log ("about to destroy: ");
//			console.log (dijit.byId (this.parmid));
//			dijit.byId (this.parmid).destroy();
//		} else {
//			console.log ("not found to destroy: " + this.parmid);
//		}

//		this.destroyDescendants();
		this.inherited (arguments);
	}
	
});

