/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/


dojo.provide("ibm.tivoli.tip.charts.dijit.SampleBarChart");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.charting.Chart2D");
dojo.require("dojox.charting.plot2d.ClusteredBars");
dojo.require("dojox.charting.plot2d.ClusteredColumns");
dojo.require("dojox.charting.plot2d.StackedBars");
dojo.require("dijit.Tooltip");
dojo.require("dojox.gfx");
dojo.require("dojox.gfx.matrix");
dojo.require("dojox.charting.action2d.Tooltip");
dojo.require("dojox.charting.widget.Legend");
dojo.require("dojox.charting.action2d.Highlight");
dojo.require("dojox.charting.action2d.Magnify");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.ContentPane");

dojo.declare("ibm.tivoli.tip.charts.dijit.SampleBarChart",
	          [ dijit._Widget, dijit._Templated ],
{
	widgetsInTemplate: true,
	templatePath:dojo.moduleUrl("ibm.tivoli.tip.charts.dijit" , "templates/SampleBarChart.html"),

	chartID: null,
	chartPreferences: null,
	widgetDefinition: null,

	constructor: function () {
		console.log ("enter ChartBuilder.ctor");
		this.cnt = 0;
	
	    //dojo.mixin( this, mixinData );
	
		this.chartBuilder = true;		
		this.dc = dojox.charting;
		this.firstRun = true;
		this.chart = null;
		this.charts = [];
		this.columns = null;
		this.store = null;
		this.chartFetcher = null;
		this.data = [{"0":"Primary:LOCO:NT","1":"cmd","2":"1488","3":8,"4":0,"5":0,"6":0,"7":1541545,"8":1,"9":"Mon Sep 21 12:48:36 EDT 2009","10":0}, {"0":"Primary:LOCO:NT","1":"cmd","2":"6524","3":8,"4":0,"5":0,"6":0,"7":505098,"8":1,"9":"Mon Sep 21 12:48:36 EDT 2009","10":1}, {"0":"Primary:LOCO:NT","1":"java","2":"1072","3":8,"4":0,"5":0,"6":0,"7":945136,"8":55,"9":"Mon Sep 21 12:48:36 EDT 2009","10":2}, {"0":"Primary:LOCO:NT","1":"cmd","2":"5220","3":8,"4":0,"5":0,"6":0,"7":868187,"8":1,"9":"Mon Sep 21 12:48:36 EDT 2009","10":3}, {"0":"Primary:LOCO:NT","1":"iexplore","2":"7336","3":8,"4":0,"5":0,"6":0,"7":247695,"8":16,"9":"Mon Sep 21 12:48:36 EDT 2009","10":4}, {"0":"Primary:LOCO:NT","1":"iexplore","2":"7516","3":8,"4":0,"5":0,"6":0,"7":255858,"8":11,"9":"Mon Sep 21 12:48:36 EDT 2009","10":5}, {"0":"Primary:LOCO:NT","1":"iexplore","2":"7356","3":8,"4":0,"5":0,"6":0,"7":255855,"8":12,"9":"Mon Sep 21 12:48:36 EDT 2009","10":6}, {"0":"Primary:LOCO:NT","1":"kntcma","2":"916","3":8,"4":1,"5":0,"6":1,"7":7784086,"8":37,"9":"Mon Sep 21 12:48:36 EDT 2009","10":7}, {"0":"Primary:LOCO:NT","1":"System","2":"4","3":8,"4":12,"5":12,"6":0,"7":10557944,"8":61,"9":"Mon Sep 21 12:48:36 EDT 2009","10":8}, {"0":"Primary:LOCO:NT","1":"Idle","2":"0","3":0,"4":84,"5":84,"6":0,"7":10557944,"8":2,"9":"Mon Sep 21 12:48:36 EDT 2009","10":9}, {"0":"Primary:LOCO:NT","1":"Rtvscan","2":"2324","3":13,"4":97,"5":25,"6":71,"7":10557899,"8":48,"9":"Mon Sep 21 12:48:36 EDT 2009","10":10}, {"0":"Primary:LOCO:NT","1":"_Total","2":"0","3":0,"4":197,"5":122,"6":74,"7":0,"8":1170,"9":"Mon Sep 21 12:48:36 EDT 2009","10":11}];
		this.chartDef = {
	"resourceBundle":"com.ibm.tivoli.itm.nl.ITMResources",
	"css":"css/itmstyles.css",
	"label": {
		"value":"CPU_UTILIZATION",
		"cssClass":"chartLabel"
	},
	"header" : {
		"label": {
			"value": "PROCESSES",
			"cssClass": "label"
		},
		"hidden":true
	},
	"footer" : {
		"label": {
			"value": "PROCESSES",
			"cssClass": "label"
		},
		"hidden":true
	},
	"type":"StackedBars",
	"showGrid":true,
	"id":"ProcessorUsage",
	"legend": {
		"hidden":false,
		"location":"bottom",
		"orientation":"horizontal",
		"cssClass":"legend"
	},
	"groups": [{"id":"KNT"}],
	"showTooltips":true,
	"description": {
		"value":"",
		"cssClass":"chartDescription"
	},
	"xAxis":{
		"dataSource":"ITM",
		"label": {
			"value": "Process_Name",
			"cssClass": "label"
		},
		"dataSet":"knt.01330_40_228",
		"dataColumn":"1",
		"id":"Process_Name"
	},
	"yAxis": {
		"label": {
			"value":"%_Processor_Time",
			"class":"label"
		},
		"triggers":[{
					"id":"onclick",
					"script":"alert (\"hello world\");",
					"type":"javascript"
		}],
		"series":[
			{
				"textColumn":"6",
				"dataSource":"ITM",
				"label": {
					"value":"%_User_Time",
					"cssClass":"label"
				},
				"dataSet":"knt.01330_40_228",
				"tooltipColumn":"6",
				"dataColumn":"6"
			},
			{
				"textColumn":"5",
				"dataSource":"ITM",
				"label": {
					"value":"%_Privileged_Time",
					"cssClass":"label"
				},
				"dataSet":"knt.01330_40_228",
				"tooltipColumn":"5",
				"dataColumn":"5"
			}
		],
		"id":"%_Processor_Time"
	}
};

		console.log ("exit ChartBuilder.ctor");
	},
	postCreate: function () {
		console.log ("enter postCreate");
		var div = dojo.byId (this.id + "chart0");
		console.log ("chart div: " + div);
		console.log ("exit postCreate");		
	},
	startup: function () {
		console.log ("enter ChartBuilder.startup");
		this.buildChart();		
		console.log ("exit ChartBuilder.startup");
	},
	makeSeriesData: function (dataColumn) {
		var result = [];
		if(this.data.length == 1)
		{
//			return (this.store.getValue (this.rows[0], dataColumn));
			return (this.data[0][dataColumn]);
		}
		else
		{
			for (var i=0; i<this.data.length; i++) {
				if (i) {
//					result.push (this.store.getValue (this.rows[i], dataColumn));			
					result.push (this.data[i][dataColumn]);
				}
			}
		}		
		
		if (this.cnt === 0) {
			result = [0,0,0,0,0,0,0,0,11,0,13];
			this.cnt++;
		} else {
			result = [0,0,0,0,0,0,1,0,42,137,185];
		}
		
		console.log ("returning from makeSeriesData with result: ");
		console.log (dojo.toJson (result));
		return (result);
	},
	makeXAxisLabels: function (columnID) {
		var result = [];
		var label = {};
		
		for (var i=0; i<this.data.length; i++) {
			if (i !== undefined) {
				label = {};
				label.value = i;			
				label.text = this.data[i][columnID];	
				result.push (label);
			}
		}


		result = [{"value":0,"text":"cmd"},
		{"value":1,"text":"java"},
// BAD		
		{"value":2,"text":"KfwServices"},
// GOOD
//		{"value":2,"text":"KfwService"},
		{"value":3,"text":"java"},
		{"value":4,"text":"cmd"},
		{"value":5,"text":"iexplore"},
		{"value":6,"text":"cmd"},
		{"value":7,"text":"wuauclt"},
		{"value":8,"text":"iexplore"},
		{"value":9,"text":"iexplore"},
		{"value":10,"text":"Idle"},
		{"value":11,"text":"_Total"}];
		
//		result = [{"value":0,"text":"java"},{"value":1,"text":"KfwService"},{"value":2,"text":"java"},{"value":3,"text":"cmd"},{"value":4,"text":"notepad"},{"value":5,"text":"cmd"},{"value":6,"text":"wuauclt"},{"value":7,"text":"iexplore"},{"value":8,"text":"db2syscs"},{"value":9,"text":"iexplore"},{"value":10,"text":"Idle"},{"value":11,"text":"_Total"}];		

		console.log ("returning from makeXAxisLabels (JSA): ");
		console.log (dojo.toJson(result));
		
		return (result);
	},
	buildChart: function () {
		var start = new Date();
//		this.buildTitle();
//		this.buildToolbar();

		var mainChart = null;
		var divs = [];
		var row2divs = [];
		var row3divs = [];
		var charts = [];
		var label = null;
				
		console.log ("ChartBuilder.buildChart. type is: " + this.chartDef.type);
		var chartdiv = dojo.byId (this.id + "chart0");
		console.log ("chartdiv: " + this.id + "chart0");
		console.log (chartdiv);
		//var chart = new dojox.charting.Chart2D(this.id + "chart0");
		var chart = new dojox.charting.Chart2D("mychart");		
		console.log ("created Chart2D object");
//		chart.setTheme(ibm.tivoli.tip.dijit.themes.ChartTheme);
			
		chart.addPlot("myChart", { 
			type: "StackedBars",  
			hAxis: "Process_Name", 
			vAxis: "%_Processor_Time",
			gap: 5 
		}); 
		console.log ("added plot");

		this.addXAxis (chart);
		this.addYAxis (chart);		
		this.addTooltips (chart, "myChart");
		this.addEvents (chart, "myChart");				
//		this.addGrid (chart);
		this.chart = chart;
 		this.resize();	
		console.log ("calling chart.render");
		chart.render(); 	
		console.log ("return from chart.render");
		mainChart = chart;	

 		var renderTime  = new Date() - start;
 		console.log ("renderTime: " + renderTime);

 		this.chart = mainChart;
 		this.resize();	
		this.addLegend (mainChart);

		if(this.chartDef.type == "StackedBars") {
			this.setXAxisTitle(this.chart,this.chartDef.xAxis.id,"Kilobytes");
		}
 		
// 		dojo.publish ("ChartBuilder.chartBuilt" + this.widgetDefinition.datasource.id + this.chartDef.id, []);
 		return (mainChart); 
	},
	addLegend: function (chart) {
		var legend = null;
		
		var orientation = true;	
		legend = new dojox.charting.widget.Legend({chart: chart, horizontal: orientation}, this.id + "bottomLegend");
		
		return (chart);
	},
	addEvents: function (chart, plotName) {
		console.log ("enter ChartBuilder.addEvents");
	
		chart.connectToPlot(
    		plotName,    // the unique plot name you specified when creating a plot
    		this,      // both object and method are the same used by dojo.connect()
    		this.onChartEvent       // you can supply a function without an object
		);
		
		console.log ("exit ChartBuilder.addEvents");
		return (chart);
	},
	addTooltips: function (chart, plotName) {
		var anim_tooltip = new this.dc.action2d.Tooltip(chart, plotName);			
		
		console.log ("exit ChartBuilder.addTooltips");
		return (chart);
	},
	addGrid: function (chart) {
		console.log ("enter ChartBuilder.addGrid");
	
			chart.addPlot("Grid", {type: "Grid",
		      	hAxis: "x-grid",
      			vAxis: "y-grid",
      			hMajorLines: true,
				hMinorLines: false,
      			vMajorLines: true,
      			vMinorLines: false
			});
	
		console.log ("exit ChartBuilder.addGrid");
		return (chart);
	},
	addXAxis: function (chart) {
		console.log ("enter ChartBuilder.addXAxis");
		chart.addAxis("Process_Name", {vertical: true, labels: this.makeXAxisLabels ("1"), majorLabels: true, minorLabels: true});
		
		console.log ("exit ChartBuilder.addXAxis");
		return (chart);
	},
	addYAxis: function (chart, update, pieFlag) {
		console.log ("enter ChartBuilder.addYAxis");
	
		var isUpdate = (update === undefined) ? false : update;
		if (!isUpdate) {
			chart.addAxis(this.chartDef.yAxis.id, {vertical: false});
	    }
	     
		var series = [
			{
				"textColumn":"6",
				"dataSource":"ITM",
				"label": {
					"value":"%_User_Time",
					"cssClass":"label"
				},
				"dataSet":"knt.01330_40_228",
				"tooltipColumn":"6",
				"dataColumn":"6"
			},
			{
				"textColumn":"5",
				"dataSource":"ITM",
				"label": {
					"value":"%_Privileged_Time",
					"cssClass":"label"
				},
				"dataSet":"knt.01330_40_228",
				"tooltipColumn":"5",
				"dataColumn":"5"
			}
		];


		var seriesData = null;
		var resultBars = null;
		
		for (var i in series) {
			if (i) {
				var oneSeries = series[i];				
				seriesData = this.makeSeriesData (oneSeries.dataColumn);	
			
				chart.addSeries(oneSeries.label.value, seriesData, { plot: "myChart" });
			}
		}
		
		console.log ("exit ChartBuilder.addYAxis");
		return (chart);
	},
	onChartEvent: function (event) {
		if (event.type == "onclick") {
			//if (chartDef.triggers
			var trigger = this.getTrigger (event.hAxis, event.vAxis, event.type);
			
			if (trigger !== null) {
				if (trigger.type == "javascript") {
					this.handleJavaScriptTrigger (trigger, event);
				} else {
					console.error ("unknown Trigger type: " + trigger.type);
				}
			}
		}
	},
	// TODO: Using a closure, add context to calling of trigger.  
	// (i.e., pass event to trigger function).
	handleJavaScriptTrigger: function (trigger, event) {
		eval (trigger.script);
	},
	getTrigger: function (xAxis, yAxis, triggerName) {
		if (this.chartDef.yAxis.id == yAxis) {
			for (var i=0; i<this.chartDef.yAxis.triggers.length; i++) {
				if (this.chartDef.yAxis.triggers[i].id == triggerName) {
					return (this.chartDef.yAxis.triggers[i]);
				}
			}
		}
		
		return (null);
	},
//	buildTitle: function () {
//			var titleBar = new ibm.tivoli.tip.charts.dijit.ChartTitle ({
//					title: this.chartDef.label.value
//				}, dojo.byId (this.id + "title"));
//	},
	getChart: function () {
		return (this.chart);
	},
	initialSize: function () {
		var vp = dijit.getViewport();
//		var coords = dojo.coords (dojo.byId (this.id + "pager"));
//		vp.h = vp.h - coords.h;
		var coords = dojo.coords (dojo.byId (this.id + "legend"));
		vp.h = vp.h - coords.h;
		
		dojo.style (dojo.byId (this.id + "chart"), "width", vp.w);
		dojo.style (dojo.byId (this.id + "chart"), "height", vp.h);
		
	},
	resize: function (size) {
		console.log ("enter ChartBuilder.resize");
		if (this.chart !== null) {
			if ((size === undefined) || (size === null) || (size.w === undefined) || (size.h === undefined)) {
				console.log ("no size sent to resize function, so using viewport size");						
				var vp = dijit.getViewport();
				size = { w: vp.w, h: vp.h };	
			} else {
				console.log ("using size received from resize function");
				console.log (size);
			}	
			var coords;
			console.log ("orig size: " + dojo.toJson (size));

			coords = dojo.coords (dojo.byId (this.id + "axistitle"));
			size.w = size.w - coords.w;
			size.w = size.w - coords.w;
//			coords = dojo.coords (dojo.byId (this.id + "pager"));
//			size.h = size.h - coords.h;
//			size.h = size.h - coords.h;
			if(this.chartDef.legend.location == "right") {
				coords = dojo.coords (dojo.byId (this.id + "legend"));
				size.w = size.w - coords.w;
			}
			else {
				coords = dojo.coords (dojo.byId (this.id + "bottomLegend"));							
				size.h = size.h - coords.h;
			}
			
//			coords = dojo.coords (dojo.byId (this.id + "toolbar"));
//			size.h = size.h - coords.h;
			coords = dojo.coords (dojo.byId (this.id + "title"));
//			size.h = size.h - coords.h;

			if(this.chartDef.type == "Pie") {
				size.h = size.h - 62;
			} else {
				size.h = size.h - 30; // for good measure :-)
			}
			size.w = size.w - 25;
			
			dojo.style (dojo.byId (this.id + "chartContainer"), {
				"width": size.w,
				"height": size.h
			});
			
			console.log ("calling chart.resize with size: " + dojo.toJson (size));
			if((this.charts !== undefined) && (this.charts.length > 1))	{
				for (var i=0; i<this.charts.length; i++) {
					this.chart = this.charts[i];					
					this.chart.resize ({w: (size.w / this.charts.length), h: size.h}); 
				}
			} else { 
				this.chart.resize ( size );
			}			
			if(this.chartDef.type == "StackedBars") {
				this.setXAxisTitle(this.chart,this.chartDef.xAxis.id,"Kilobytes");
			}
			
		} else {
			console.log ("this.chart is null so not calling resize");
		}
		console.log ("exit ChartBuilder.resize");		
	},
	setYAxisTitle: function(chart, axisname, label) {
		console.log ("enter ChartBuilder.setYAxisTitle");
		var axis = chart.axes[axisname];
		var dim = chart.dim;
		var offsets=chart.offsets;
		var ta = chart.theme.axis;		
		var x;
		var y;
		var rotate=0;
		var title = null;

		if(axis.vertical) {
			rotate=90;
			y=dim.height/2  - offsets.b/2;
			x=0+12;
		} else {
			x=dim.width/2 + offsets.l/2;
			y=dim.height;
		}		
		var browserName = navigator.appName;		
		var m = dojox.gfx.matrix;
		var surface = dojox.gfx.createSurface(this.id + "axistitle", 45, 140);
		if (browserName == "Microsoft Internet Explorer") {
			title = surface.createText({x: x, y: y, text:label, align: "start"});
		} else {
			title = surface.createText({x: 32, y: -15, text:label, align: "start"});
		}
		
		title.moveToFront();
		title.setFont({family:"Sans Serif", size: "14pt", weight: "normal"});
		title.setFill('black');

		title.setTransform(m.rotategAt(rotate,x,y));

		console.log ("exit ChartBuilder.setYAxisTitle");
		return(chart);
	},
	setXAxisTitle: function(chart, axisname, label) {
		console.log ("enter ChartBuilder.setXAxisTitle");
	
		var axis = chart.axes[axisname];		
		var dim = chart.dim;
		var offsets=chart.offsets;
		var x;
		var y;
		var rotate=0;		
		
		x=dim.width/2 + offsets.l/2;
		y=dim.height;
			
		var m = dojox.gfx.matrix;	
		var title;
		if(this.chartDef.type == "StackedColumnsDepth") {
			title = axis.group.createText({x:x, y:y-25, text:label, align: "end"});
		}
		else
		{
			title = axis.group.createText({x:x, y:y-5, text:label, align: "end"});
		}
		title.setFont({family:"San Serif", size: "12pt", weight: "normal"});
		title.setFill('black');
		title.setTransform(m.rotategAt(rotate,x,y));
		title.moveToFront();
		
		console.log ("enter ChartBuilder.setXAxisTitle");
	},
	destroy: function () {
		console.log ("enter ChartBuilder.destroy");
	
//		this.getToolbar().destroyRecursive();
		this.inherited ("destroy", arguments);	

		console.log ("exit ChartBuilder.destroy");
	}
});
