/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/


dojo.provide("ibm.tivoli.tip.charts.dijit.TableBuilder");
dojo.require("dojox.data.JsonRestStore");
dojo.require("ibm.tivoli.tip.dijit.TIPTable");
dojo.require("ibm.tivoli.tip.dijit.CMSMenuProvider");
dojo.require("ibm.tivoli.tip.dijit.Formatters");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartToolbar");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartTitle");
dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dojo.parser");
dojo.require("ibm.tivoli.tip.charts.dijit.Builder");
dojo.require ("ibm.tivoli.tip.charts.dojo.RESTErrorHandler");
dojo.require("ibm.tivoli.navmodel.Dataset");
dojo.require("ibm.tivoli.navmodel.DatasetItemsStore");
dojo.require("ibm.tivoli.tip.navwidget.dijit.DefaultMessageHandler");
dojo.require ("ibm.tivoli.tip.dojo.TIPHelper");
dojo.require("ibm.tivoli.tip.dojo.Server");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources", null, "ROOT,cs,de,en,en-us,es,fr,hu,it,ja,ko,pl,pt-br,ru,zh-cn,zh-tw");

dojo.declare("ibm.tivoli.tip.charts.dijit.TableBuilder",
	         [ dijit._Widget, dijit._Container, ibm.tivoli.tip.charts.dijit.Builder ],
{
	global: null,
	jsonStore: null,
	widgetDefinition: null,
    tableID: null,
	div: null,
	providerID: null,
	datasourceID: null,
    toolbarSelf: null,
	updateMultiplier: 10,
    updateMinInterval: 30000,
    updateMaxInterval: 180000,
	interval: null,
	runReportStartTime: 0,
    runReportResponseTime: 5,
	parameters: null,
	toolbarHidden_:null,
	CHART_SOURCE_TYPE_PAGE: "CHART_SOURCE_TYPE_PAGE",
	isTableFirst: false,
	trigger: null,
	drillUpItems: [],
	isTable: true,
	cmProvider: null,
	gridParms: null,
	tableClassName: "ibm.tivoli.tip.dijit.TIPTable",
	_isUserPrefSaved: false,
	dataSet: null,

	constructor: function (mixinData) {
		this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
	    dojo.mixin( this, mixinData );
	    this.table = null;
	    this.tableBuilder = true;
		this.chartDef = null;
		this.dataset = null;
		this.preferencesDialog = null;
		this.connections = [];
		this.createStoreConnection = null;
		this.nub=null;
		if(!this.widgetParams || !this.widgetParams.standalone){
			dojo.requireLocalization("ibm.tivoli.tip.chartportlet.dijit", "chart_messages");
			this.messages_ = dojo.i18n.getLocalization("ibm.tivoli.tip.chartportlet.dijit", "chart_messages");
		}
		this.currentPage = this.CHART_SOURCE_TYPE_PAGE;

		if ((this.global.iscPortletNamespace === undefined) || (this.global.iscPortletNamespace === null)) {
				//var titleBar = dijit.byId (this.id + "title");
		} else {			
			this.tipHelper_ = new ibm.tivoli.tip.dojo.TIPHelper();
		}
		this._isUserPrefSaved = false;
		this.drillUpItems = [];
		this.dataSet = null;
	},
	startup: function () {
		var busyPane = dijit.byId(this.global.namespace+"busy_pane");
	    if ( busyPane ) {
	      console.log ("showing busypane");
	      busyPane.show(true); // size to portlet
		}
	    
		this.titleDiv = dojo.doc.createElement( 'div' );
		this.titleDiv.id = this.id+"title";
		dojo.place (this.titleDiv, this.div, 0);
		
		this.tableDiv = dojo.doc.createElement( 'div' );
		this.tableDiv.id = this.id+"table";		
		dojo.place (this.tableDiv, this.div, 1);
		
		this.chartDef = this.getTableFromDef();		
		this.dataset = this.getDataSet (this.chartDef.dataset);
		this.toolbarHidden_ = (this.global.mode == "view") ? true : false;
		
		this.createStoreConnection = dojo.connect(this, "createStore", dojo.hitch (this, function(){
			this._makeTIPTable(this.gridParms);			
			//		if(this.table.filterBar){
			//			this.connections.push (dojo.connect (this.table.filterBar.nub, "onclick", this, "toggleToolbar"));
			//		}
        	this.connections.push (dojo.connect (this.table.grid, "onCellDblClick", this, "onDBClickEvent"));		
			this.connections.push (dojo.connect (this.table.grid, "onResizeColumn", this, "onResizeColumnEvent"));
			if(!this.widgetParams || !this.widgetParams.standalone){
				this.updateToolbar();
			}		
		}));
		this.createDataset();
		
	},
	getTableFromDef: function () {
		var tableDef = null;		
		if(this.widgetDefinition.tables === undefined)
		{
			tableDef = this.widgetDefinition.charts[0];
			tableDef.dataset = this.widgetDefinition.datasets[0].id;			
			tableDef.view = [];			
			for(var i=0; i<this.widgetDefinition.datasets[0].columns.length; i++) {				
				tableDef.view[i] = {
					"id": this.widgetDefinition.datasets[0].columns[i].id,
					"width":"9em",
					"hidden": false,
					"searchable": true
				};
			}
		}
		else
		{
			tableDef = this.widgetDefinition.tables[0];
		}		
		return (tableDef);
	},
	getQuery: function () {
		var dataSetID = this.getTableFromDef().dataset;
		var dataSet = this.getDataSet (dataSetID);
		//var query = dataSet.query + "?widgetID=" + this.widgetDefinition.tables[0].id;
		
		return (dataSet.query);
	},
	getDataSet: function (dataSetID) {
		
		var dataSets = this.widgetDefinition.datasets;
		for (var i=0; i<dataSets.length; i++) {
			if (dataSets[i].id == dataSetID) {
				return (dataSets[i]);
			}
		}
		
		console.error ("could not find dataset with ID: " + dataSetID);
		return (null);
	},
	onNubKeyPress: function (event) {
	  	if (event.keyCode == 13) {
		  	
	  		event.cancelBubble = true;
	  		event.returnValue = false;
	  		console.log ("in onNubKeyPress: pressed enter");
	  		this.toggleToolbar();
	  	}
	},
	toggleToolbar: function () {		
		this.toggleTableToolbar();
		
	},
	toggleTableToolbar: function () {
		console.log ("enter toggle table toolbar");
		
	if (this.table) {
		if (this.toolbarHidden_) {
			this.table.toggleToolbar();
		} else {
			this.table.toggleToolbarOff();
		}
			
		}
	},
	updateToolbar: function () {
		
		var button = new ibm.tivoli.tip.dijit.TIPButton(
				{	label: this.resources_.PREFERENCES, 
					showLabel: false, 
					iconClass: "propertiesIcon",
				 	onClick: dojo.hitch (this, this.onPreferences) 
				});
			this.table.toolbar.addChild(button);
			
			var backButton = new ibm.tivoli.tip.dijit.TIPButton(
					{	iconClass: "backIcon",
						label: this.resources_.RETURN_TO_CHART_SELECTOR,
						showLabel: false,
					 	onClick: dojo.hitch (this, this.showChartSelector) 
					});
			if(!this.global.isFromPortletPref){
				this.table.toolbar.addChild(backButton);
			}
						
			var ddMenu = new dijit.Menu();		
			var context = ibm.tivoli.tip.dojo.Global.getSingleton(this.global.namespace);			
			if (context.roles.admin || context.roles.creator) {
				var miShare = new dijit.MenuItem ({label: this.resources_.SAVE_FOR_OTHERS});
				miShare.onClick = dojo.hitch (this, "saveSharedPref");				
				ddMenu.addChild (miShare);				
				var miReset = new dijit.MenuItem ({label: this.resources_.CLEAR_DEFAULT_PREFERENCES});
				miReset.onClick = dojo.hitch (this, "onReset");				
				ddMenu.addChild (miReset);
			}			
			var miResetMine = new dijit.MenuItem ({label: this.resources_.CLEAR_MY_PREFERENCES});
			miResetMine.onClick = dojo.hitch (this, "onResetMyPreferences");			
			ddMenu.addChild (miResetMine);			
			button = new dijit.form.DropDownButton (
				{	label: this.resources_.PUBLISH,
					showLabel: false,
					iconClass: "editIcon",
					dropDown: ddMenu
				});			
			this.table.toolbar.addChild (button);

			//for drill up
			if(this.drillUpItems !== undefined && this.drillUpItems.length > 0) {			
				var drillUpOptions = [];
				drillUpOptions[0] = {
								"id": "Drill Up",
								"label": "Drill Up"
							};
				for (var j=0; j<this.drillUpItems.length; j++) {	
					drillUpOptions[j+1] = {
								"id": this.drillUpItems[j].chartIdWithCount,
								"label": this.drillUpItems[j].chartIdWithCount
							};
				}

				var oldDrillUpComboBox = dijit.byId(this.id + "drillUpCombo");
				if(oldDrillUpComboBox) {
					oldDrillUpComboBox.destroyRecursive();
					dijit.registry.remove (this.id + "drillUpCombo");
				}

				var selectOptions = new dojo.data.ItemFileWriteStore({data: {identifier: 'label', items:drillUpOptions}});			
				var drillUpComboBox = new dijit.form.ComboBox({
					id: this.id + "drillUpCombo",
					name: this.id + "drillUpCombo",
					value: "Drill Up",
					store: selectOptions,
					searchAttr: "label",
					onChange: dojo.hitch (this, this.drillUp)
			 },this.id + "drillUpCombo");
			
			 this.table.toolbar.addChild(drillUpComboBox);	
			}

	},
	
	saveUserPref: function () {
		if(!this._isUserPrefSaved){
			var callback = dojo.hitch (this, this.onSaveComplete);			
			var hiddenparams = this.getPageParameters();
			var url = "?" + hiddenparams;
			var kw = {
			 	appendURL: url,
	         	content:   {
                 	command: "savePreferences",
                 	arg_portletNamespace: this.global.namespace,
                 	action: "saveUser"
             	}             
    		};
	    	ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );
	    	this._isUserPrefSaved = true;
	    }
		return (false);
	},
	
	saveSharedPref: function () {		
		var callback = dojo.hitch (this, this.onSaveComplete);			
		var hiddenparams = this.getPageParameters();
		var url = "?" + hiddenparams;
		var kw = {
			 appendURL: url,
	         content:   {
                 command: "savePreferences",
                 arg_portletNamespace: this.global.namespace,
                 action: "saveShared"
             },
             onResponse:{
                 callback: callback
       	     }
    	};
	    ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );
		return (false);
	},
	
	getPageParameters: function () {
		var type = "TIPServer";	
		var urlfrag = this.namespace + "connectionNameH=" + this.datasourceID;
		urlfrag += "&" + this.global.namespace + "chartIDH=" + this.tableID;
		urlfrag += "&" + this.global.namespace + "versionH=" + this.widgetDefinition.meta.version;
		urlfrag += "&" + this.global.namespace + "chartSourceTypeGroup=" + type;
		urlfrag += "&" + this.global.namespace + "appID=" + this.datasourceID;
		urlfrag += "&" + this.global.namespace + "providerID=" + this.providerID;
		urlfrag += "&arg_partialSave=false";
		return (urlfrag);	
	},
	
	onPreferences: function () { 		
  		
		this.preferencesDialog = new ibm.tivoli.tip.charts.dijit.ChartPreferences ( 
				{ global: this.global,				  
				  tableBuilder: this,
				  isTableFirst: this.isTableFirst
				} 
			);	
		this.preferencesDialog.startup();
		this.preferencesDialog.show();
  	},
	createDataset: function () {
		//var url = this.global.controllerURL + "/dataset/";
		//url = url + this.getQuery();
		//this.jsonStore = new dojox.data.JsonRestStore({target:url, idAttribute:"field"});
		if ((this.interval !== null) && (!this.chartDef.common.autoUpdate)) {
                    clearTimeout (this.interval);
                    this.interval = null;
                }

		var url = "/ibm/tivoli/rest";		
		var dsParams = {};
		var tableParams = this.widgetDefinition.datasets[0].parameters;
		if(tableParams){
			for(var i=0;i<tableParams.length;i++){
				if(typeof tableParams[i].value == "string"){
					dsParams[tableParams[i].id] = tableParams[i].value.split(",");
				}else{
					dsParams[tableParams[i].id] = tableParams[i].value;
				}
			}
		}
		if(this.global.restTimeParam){
			dsParams[this.global.restTimeParam.id] = this.global.restTimeParam.value;
		}
		this.destroyDataSet();
		this.dataSet = new ibm.tivoli.navmodel.Dataset({
			baseUrl: url,	
			provider: this.providerID,
			datasource: this.datasourceID,
			dataset: this.getTableFromDef().dataset,
			createEventRouter: false,
			fetchMetaData: false,
			parameters: dsParams,
			onComplete: dojo.hitch(this, "createStore"),
			onError: function(error, exception, ioArgs) {
				var msgHandler = new ibm.tivoli.tip.navwidget.dijit.DefaultMessageHandler({});
				msgHandler.displayException(exception);
			}
		});

	},	
	
	createStore: function(dataSet){
		var navStore = new ibm.tivoli.navmodel.DatasetItemsStore({
			dataset: dataSet,						
			returnItem: false		
		});
		this.jsonStore = navStore;
	},
	
	destroyDataSet: function(){
		if(this.dataSet){
			this.dataSet.destroy();
			delete this.dataSet;
		}
	},
	
	getDataSetColumn: function (id) {
		var dataSetID = this.getTableFromDef().dataset;
		var dataSet = this.getDataSet (dataSetID);
		
		for (var i=0; i<dataSet.columns.length; i++) {
			if (dataSet.columns[i].id == id) {
				return dataSet.columns[i];
			}
		}
		
		console.error ("Cannot find dataSet column with ID: " + id);
		
		return (null);
	},
	getView: function () {
//		var url = this.global.controllerURL + "/queryMeta/";
//		var results = null;
//		var viewStore = new dojox.data.JsonRestStore({target:url});
//		viewStore.fetch ( {
//				query: this.getQuery(),
//				syncMode: true,
//				onComplete: function (result, request) {
//					results = result;
//				}
//			});
		var viewColumns = this.getTableFromDef().view;
		
		var cells = [];
		var cell = null;
		var viewColumn = null;
		
		for (var i=0; i<viewColumns.length; i++) {
			viewColumn = viewColumns[i];
			cell = {};
			cell.field = viewColumn.id;
			try{
			cell.name = this.getDataSetColumn(viewColumn.id).label.value;
			}catch(e)
			{
				alert(e.message);
			}
			cell.visible = !viewColumn.hidden;
			cell.hidden = viewColumn.hidden;
			cell.width = viewColumn.width;
			cell.isSearchable = viewColumn.searchable;
			/*
			if("ibm.tivoli.tip.dijit.Formatters.iconBackgroundFormatter"==viewColumn.formatter){
				cell.formatter = ibm.tivoli.tip.dijit.Formatters.iconBackgroundFormatter;
			}else if("ibm.tivoli.tip.dijit.Formatters.comboBoxFormatter"==viewColumn.formatter){
				cell.formatter = ibm.tivoli.tip.dijit.Formatters.comboBoxFormatter;
			}else if("ibm.tivoli.tip.dijit.Formatters.checkBoxFormatter"==viewColumn.formatter){
                cell.formatter = ibm.tivoli.tip.dijit.Formatters.checkBoxFormatter;
            }else if("ibm.tivoli.tip.dijit.Formatters.radioButtonFormatter"==viewColumn.formatter){
				cell.formatter = ibm.tivoli.tip.dijit.Formatters.radioButtonFormatter;
            }
            */
			cell.formatter = eval(viewColumn.formatter);
			cells.push(cell);	
		}
		var view = [ { cells: cells } ];

		return (view);
	},
	fetchRows: function () {
		this.jsonStore.fetch ( {
				query: this.getQuery(),
				onComplete: function (result, request) {
					
					
					this.printStore(result.items);
				}
			});
	},
	printStore: function (items) {
		for (var i=0; i<items.length; i++) {
			
		}
	},
	_makeTIPTable: function (gridParms) {
		console.log ("enter makeTIPTable");
		if (this.createStoreConnection !== null) {
			console.log ("disconnecting createStoreConnection: " + this.createStoreConnection);
			dojo.disconnect (this.createStoreConnection);
			this.createStoreConnection = null;
			console.log ("disconnected createStoreConnection");
		} else {
			console.log ("createStoreConnection is null. not disconnecting.");
		}

		var cmProvider = null;
		
		if (this.cmProvider === null) { 
			cmProvider = new ibm.tivoli.tip.dijit.CMSMenuProviderV2(
				{ global: this.global,
				  menuName: "DojoTableV2",
				  getMenusCommandName: "getMenuItems",
				  getMenuActionCommandName: "getMenuCommand",		
				  createCMSEventCallback: this.createCMSEventCallback,		  
				  iscPortletNamespace: this.global.iscPortletNamespace
				});
		} else {
			cmProvider = this.cmProvider;
		}
		
		var cmClientProvider = new ibm.tivoli.tip.dijit.TIPContextMenuProvider(
				{ iscPortletNamespace: this.global.iscPortletNamespace,
				  getMenuItemsCallback: dojo.hitch (this, this.getMenuItems)
				});
		
		if ((gridParms === null) || (gridParms === undefined)) {
			console.log ("creating gridParms");
			gridParms = {};
			gridParms.columnReordering = this.getTableFromDef().columnReordering;
			gridParms.rowsPerPage = this.getTableFromDef().common.pagingSize;
			gridParms.store = this.jsonStore;
			var query = {};			
			var filCond = this.widgetDefinition.datasets[0].conditions;
			var dsColumns = this.widgetDefinition.datasets[0].columns;
			if(filCond && filCond.filterString && filCond.filter.length>0){
				query.expression = filCond.filterString;	
				query.ids = {};			
				for(var i=0;i<filCond.filter.length;i++){
					if(filCond.filter[i].column == "anycolumn"){
						query.ids = {};
						for(var j=0;j<dsColumns.length;j++){
							query.ids[dsColumns[j].id] = true;
						}
						break;
					}else{
						query.ids[filCond.filter[i].column] = true;
					}
				}
			}	
			gridParms.query = query;
		} else {
			console.log ("using existing gridParms");
		}
		
		var view = this.getView();
		var multiSelect = true;
		if (this.getTableFromDef().selectionMode == "single" || this.widgetDefinition.tables === undefined) {
			multiSelect = false;
		}
		
		var tableClass = eval (this.tableClassName);
		var toolbarhidden = true;
		if(this.getTableFromDef().toolbar){
			toolbarhidden = this.getTableFromDef().toolbar.hidden;
		}
		var tipTable = new tableClass (
			{
				global: this.global,
				baseQuery: gridParms.query,
				toolbarHidden_: toolbarhidden,
				autoSavePreferences: false,
				tableOptionsEnabled: false,
				multiSelect: multiSelect,
				gridParms: gridParms,
				view: view,
				viewData: view,
				applicationID: this.widgetDefinition.datasource.id,
				widgetID: this.getTableFromDef().id,
				tableParams: this.widgetDefinition.datasets[0].parameters,
				tableBuilder: this,
				cmClientProvider: cmClientProvider,
				cmProvider: cmProvider	
			}, this.tableDiv);
		this.table = tipTable;

		var sub = dojo.subscribe (tipTable.id + "#LoadComplete", this, this.loadComplete);
		this.loadCmplteSub = sub;
		
		tipTable.startup();
		if (this.chartDef.common.showLastUpdateTime) {		
			var msg = this.updateMetaData();
			tipTable.getFooterToolbar().setTableUpdateAreaHTML(msg);
		} else {
			tipTable.getFooterToolbar().setTableUpdateAreaHTML("");
		}
		this.configAutoUpdate();
		
		return (tipTable);
	},	
	
	getCommonMenuItems: function () {
		var menuItems = [{ 
			id: this.namespace + "RefreshChartMenuItem", 
			label: this.resources_.REFRESH, 
			iconClass: "refreshIcon", 
			launchType: "JavaScript", 
			uri: "dijit.byId ('" + this.table.id + "').onRefresh();", enabled: true 
		}];
		var subMenuItems = null;		
		if(this.widgetDefinition.drillDown !== undefined) {			
			subMenuItems = this.getDrillDownMenuItems();
			var oldDrillDownNode = dijit.byId (this.id + "DrillDown");		
			if(oldDrillDownNode) {
				oldDrillDownNode.destroy();
			}
			menuItems.push ({ 
				id: this.id + "DrillDown", 
				label: this.resources_.DRILL_DOWN, 
				icon: "", launchType: "NOOP", 
				submenu_items: subMenuItems, 
				enabled: true 
			});
		}		
		if(this.drillUpItems !== undefined && this.drillUpItems.length > 0) {	
			subMenuItems = this.getDrillUpMenuItems();
			var oldDrillUpNode = dijit.byId (this.id + "DrillUp");		
			if(oldDrillUpNode) {
				oldDrillUpNode.destroy();
			}
			menuItems.push ({ 
				id: this.id + "DrillUp", 
				label: this.resources_.DRILL_UP, 
				icon: "", 
				launchType: "JavaScript", 
				submenu_items: subMenuItems, 
				enabled: true 
			});
		}		
		return (menuItems);
	},

	getCustomMenuItems: function () {
		var menuItems = [{ 
			id: this.namespace + "ShowHideToolbarMenuItem", 
			label: this.resources_.SHOW_HIDE_TOOLBAR, 
			iconClass: "toggleIcon", 
			launchType: "JavaScript", 
			uri: "dijit.byId ('" + this.id + "').toggleToolbar();", 
			enabled: true 
		}];				
		if(!this.global.isFromPortletPref){
			menuItems.push ({ 
				id: this.namespace + "ReturnToChartSelectorMenuItem", 
				label: this.resources_.RETURN_TO_CHART_SELECTOR, 
				iconClass: "backIcon", 
				launchType: "JavaScript", 
				uri: "dijit.byId ('" + this.id + "').showChartSelector();", 
				enabled: true 
			});		
		}
		menuItems.push ({ id: "separator" });  
		menuItems.push ({
			id: this.namespace + "PreferencesMenuItem", 
			label: this.resources_.PREFERENCES, 
			iconClass: "propertiesIcon", 
			launchType: "JavaScript", 
			uri: "dijit.byId ('" + this.id + "').onPreferences();", 
			enabled: true 
		});  		
		var context = ibm.tivoli.tip.dojo.Global.getSingleton(this.global.namespace);
		if (context.roles.admin || context.roles.creator) {
		    menuItems.push ({ 
		    	id: this.namespace + "SaveForAll", 
		    	label: this.resources_.SAVE_FOR_OTHERS, 
		    	icon: "", 
		    	launchType: "JavaScript", 
		    	uri: "dijit.byId ('" + this.id + "').onSave();", 
		    	enabled: true 
		    });
			menuItems.push ({ 
				id: this.namespace + "ResetForAll", 
				label: this.resources_.CLEAR_DEFAULT_PREFERENCES, 
				icon: "", 
				launchType: "JavaScript", 
				uri: "dijit.byId ('" + this.id + "').onReset();", 
				enabled: true 
			});
		}
		menuItems.push ({ 
			id: this.namespace + "ResetForMe", 
			label: this.resources_.CLEAR_MY_PREFERENCES, 
			icon: "", 
			launchType: "JavaScript", 
			uri: "dijit.byId ('" + this.id +"').onResetMyPreferences();", 
			enabled: true 
		});
		menuItems.push({ id: "separator" });
		return (menuItems);
	},

	
	getMenuItems: function () {
		var menuItems = null;
		var commonMenuItems = this.getCommonMenuItems();
		if(this.widgetParams && this.widgetParams.standalone){
			if(!this.widgetParams.ignoreContextMenu){
				menuItems = commonMenuItems;
			}
		}else{			
			var customMenuItems = this.getCustomMenuItems();
			menuItems = commonMenuItems.concat(customMenuItems);
		}		
		return (menuItems);
	},
	
	getDrillDownMenuItems: function() {
		var subMenuItems = [];		
		for (var i=0; i<this.chartDef.contextMenu.length; i++) {
			var drillDownObj = this.getDrillDown(this.chartDef.contextMenu[i].reference);
			subMenuItems.push ({ id: this.id + this.chartDef.contextMenu[i].reference, label: drillDownObj.widgetId, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.id +"').drillDown('"+drillDownObj.id+"');", enabled: true });						
		}
		return (subMenuItems);	
	},

	getDrillUpMenuItems: function() {
		var subMenuItems = [];
		for (var i=0; i<this.drillUpItems.length; i++) {
			var drillUpObj = this.drillUpItems[i];
			subMenuItems.push ({ id: this.id + drillUpObj.chartIdWithCount, label: drillUpObj.chartIdWithCount, icon: "", launchType: "JavaScript", uri: "dijit.byId ('" + this.id +"').drillUp('"+drillUpObj.chartIdWithCount+"');", enabled: true });						
		}		
		return (subMenuItems);
	},	
	
	buildTitle: function () {		
		var tableDef = this.getTableFromDef();
		if (this.widgetParams && this.widgetParams.standalone && !this.widgetParams.ignoreTitlebar) {
			var titleBar = new ibm.tivoli.tip.charts.dijit.ChartTitle ({
				title: tableDef.label.value
			}, dojo.byId (this.id + "title"));
		} else {
			// There is no need to read user or shared preferences from the embedded JSON
			// Those values are merged into the base widget def by CURI before it is returned
			// from the server.
			this.chartDef.label.value = this.getTableFromDef().label.value;
			this.chartDef.description.value = this.getTableFromDef().description.value;
			this.setTitle (this.chartDef.label.value);
		}
	},
	setTitle: function (title) {			
			var tipHelper = new ibm.tivoli.tip.dojo.TIPHelper();
			tipHelper.setPortletTitle (this.table.domNode, title);
	},
	loadComplete: function () {
		this.buildTitle();
		this.resizeTable();
		var busyPane = dijit.byId(this.global.namespace+"busy_pane");
		if ( busyPane ) {				
			busyPane.hide();
		}
	},
	resizeTable: function (size) {
		if ((size === undefined) || (size === null) || (size.w === undefined) || (size.h === undefined)) {
			if ((this.global.iscPortletNamespace === undefined) || (this.global.iscPortletNamespace === null)) {
				console.log ("no size sent to resize function, so using viewport size");
				var vp = dijit.getViewport();
				size = { w: vp.w, h: vp.h };
			} else {
				console.log ("no size sent to resize function, so using portlet size");
				var portletSize = iscPortlet.getPortletSize(this.global.iscPortletNamespace);
			
				size = { w: portletSize.available.w, h: portletSize.available.h };
			}
		} else {
			console.log ("using size received from resize function: " + size.w + ", " + size.h);
		}
	
		// without this, we get scroll bars on FF freeform pages
		if (dojo.isFF) {
			size.w = size.w - 2;
		}
		
		if ((this.table.filterBar) && (this.table.filterBar.stateMinimized === true)) {
			size.h = size.h - 7;
		} else if ((this.table.filterBar) && (this.table.filterBar.stateMinimized === false)) {
			size.h = size.h - 10;
		}
		
		this.table.resize ( { w: size.w, h: size.h } );
	},
	updateTableDef: function () {
		this.chartDef.description.value = this.widgetDefinition.tables[0].description.value;
		this.chartDef.label.value = this.widgetDefinition.tables[0].label.value;
		this.chartDef.common = this.widgetDefinition.tables[0].common;
	},
	update: function (prefs, newWidgetDef) {
		this.widgetDefinition = newWidgetDef;
		this.updateTableDef();		
		this.buildTitle();
		
		var msg = this.updateMetaData();
		if (prefs.tables[0].common.showLastUpdateTime) {			
			this.table.getFooterToolbar().setTableUpdateAreaHTML(msg);
		} else {
			
			this.table.getFooterToolbar().setTableUpdateAreaHTML("");
		}		
		this.dataset = this.widgetDefinition.datasets[0];

		if(this.widgetDefinition.user.datasets[0].parameters.length > 0){
			this.parameters = this.widgetDefinition.user.datasets[0].parameters;
			this.updateTableData();
		}else{
			var busyPane = dijit.byId(this.global.namespace+"busy_pane");
			if ( busyPane ) {				
				busyPane.hide();
			}
		}
		this.configAutoUpdate();
			
	},
	updateMetaData: function () {

		var lastUpdated = new Date();
		var msg = dojo.string.substitute(this.resources_.LAST_UPDATED, { 0: dojo.date.locale.format(lastUpdated) });
		return msg;
	},
	updateTableData: function () {

		if ((this.interval !== null)) {
           clearTimeout (this.interval);
           this.interval = null;
        }		
		if(this.parameters !== null) {
			this.table.tableParams = this.parameters;
		}

		var domNode = dojo.byId (this.id+"table");
		this.table.toolbar.destroyDescendants();
		this.table.destroyDescendants();
		//fix defect 248535
		dijit.registry.remove (this.id+"table");
		dojo.empty(domNode);
		this.tableDiv = dojo.doc.createElement( 'div' );
		this.tableDiv.id = this.id+"table";	
		
		dojo.place (this.tableDiv, this.div, 1);
		
		this.createDataset();
		this.createStoreConnection = dojo.connect(this, "createStore", dojo.hitch (this, function(){
			this._makeTIPTable(this.gridParms);
			this.connections.push (dojo.connect (this.table.grid, "onCellDblClick", this, "onDBClickEvent"));		
			if(!this.widgetParams || !this.widgetParams.standalone){
				this.updateToolbar();
			}
			var msg = this.updateMetaData();
			if (this.chartDef.common.showLastUpdateTime) {			
				this.table.getFooterToolbar().setTableUpdateAreaHTML(msg);
			} else {
				this.table.getFooterToolbar().setTableUpdateAreaHTML("");
			}
			this.configAutoUpdate();		
		}));
	},
	
	updateChartByTimeSet: function(time){	
		this.global.restTimeParam = {
			id: "Time",
			value: time
		};
		this.createDataset();
		this.connections.push (dojo.connect(this, "createStore", function(){
			this.table.grid.setStore(this.jsonStore);
		}));
	},
	
	configAutoUpdate: function () {		
		
		if ((this.interval === null) && (this.updateMultiplier > 0) &&
			this.chartDef.common.autoUpdate) {			
			var fnc = dojo.hitch (this, this.updateTableData);
		    var nextUpdate = this.getUpdateInterval();
		    this.interval = setTimeout(fnc, nextUpdate);
		} else {
            if ((this.interval !== null) && (!this.chartDef.common.autoUpdate)) {
                clearTimeout (this.interval);
                this.interval = null;
            }
		}		
	},
	onSave: function () {
		this.savePrimitive ("saveShared", true);
	},
	savePrimitive: function (action, showCompletion) {
		var callback = null;
		console.log ("enter savePrimitive with args: " + action + ", " + showCompletion);
		if (showCompletion) {
			callback = dojo.hitch (this, this.onSaveComplete);
		} 
		
		if (this.allowSubmit_) {
			var hiddenparams = this.getHiddenParameters();
			var url = "?" + hiddenparams;

			var kw = {
				 appendURL: url,
	             content:   {
                        command: "savePreferences",
                        arg_portletNamespace: this.global.namespace,
                        action: action
                        },
            	 onResponse:{
                         callback: callback
       	                }
    	     };
	        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		} else {
			this.allowSubmit_ = true;
		}
	},
	onSaveComplete: function (data, ioArgs) {
		console.info ("enter onSaveComplete");
                this.saveSharedPreferences();

		var msgID = "TIPCH3005I";
		console.log("messages"+this.messages_);
		var msg = this.messages_.TIPCH3005I;
		this.global.showMessageDialog("info", msgID, msg, false);
	},
	saveSharedPreferences: function() {
		console.log("enter tableBuilder.saveSharedPreferences");

		if(this.widgetDefinition.user == undefined) {
			return;
		}
		var prefs = dojo.toJson(this.widgetDefinition.user);
		
		var encodedCID = encodeURIComponent(this.tableID);		
		var encodedProviderID = encodeURIComponent(this.providerID);		
		var encodedDS = encodeURIComponent(this.datasourceID);		
		var encodedPID = encodeURIComponent(this.global.chartProfileID);
		var widgetDefVersion = this.widgetDefinition.meta.version;	
		var widgetSchema = this.widgetDefinition.meta.type;
		
		var controller = "/ibm/tivoli/rest";		
		console.log (controller + "/providers/tip.charts/datasources/" + encodedDS + "/widgets/" + widgetSchema + "/definitions/" + encodedCID + "-" + widgetDefVersion + "?type=shared&profileID=" + this.global.chartProfileID + "&registryLocation=local");
		
        var kw = {
        			  sync: true,
					  preventCache: true,
        			  headers: {'Content-Type': 'application/json',
        			  		   'Content-Length': prefs.length
        			  		  },
        			  url: controller + "/providers/" + encodedProviderID + "/datasources/" + encodedDS + "/widgets/"+ widgetSchema + "/definitions/" + encodedCID + "-" + widgetDefVersion + "?type=shared&profileID=" + this.global.chartProfileID + "&registryLocation=local",
                      putData: prefs,
                      error: dojo.hitch (this, function (error) {											
							var errHandler = new ibm.tivoli.tip.charts.dojo.RESTErrorHandler(this.global);		
							errHandler.showError(dojo.fromJson(error.responseText));	
						})
                   };
          dojo.xhrPut (kw);
          console.log ("exit tableBuilder.saveSharedPreferences");         
	},
	getUpdateInterval: function() {
      var nextUpdateInterval = this.runReportResponseTime * this.updateMultiplier;
      
      if ( nextUpdateInterval > this.updateMaxInterval ) {
        nextUpdateInterval = this.updateMaxInterval;
      } else if ( nextUpdateInterval < this.updateMinInterval ) {
        nextUpdateInterval = this.updateMinInterval;
      }
      return nextUpdateInterval;
    },
    getHiddenParameters: function () {
		var type = "TIPServer";
		var appID = this.widgetDefinition.datasource.id;
		var urlfrag = this.namespace + "connectionNameH=" + this.datasourceID;
		urlfrag += "&" + this.namespace + "chartIDH=" + this.tableID;
		urlfrag += "&" + this.namespace + "chartSourceTypeGroup=" + type;
		urlfrag += "&" + this.namespace + "appID=" + this.datasourceID;
		urlfrag += "&" + this.namespace + "providerID=" + this.providerID;
		urlfrag += "&" + this.namespace + "versionH=" + this.widgetDefinition.meta.version;
		urlfrag += "&arg_partialSave=false";

		return (urlfrag);	
	},
	showChartSelector: function () {
    	if (this.interval !== null) {
      		// if auto update is on, cancel it
			clearTimeout (this.interval);
			this.interval = null;
		}
		var chartNavigator = dijit.byId (this.global.namespace + "mainChartNavigatorDiv");
		chartNavigator.setCurrentPage (chartNavigator.CHART_SOURCE_TYPE_PAGE);
		chartNavigator.showChartNavigator();
		this.restorePortletTitle();
		this.destroyRecreate();
	},
	destroyRecreate: function () {
		this.destroy();
		var node = dojo.doc.createElement ("div");
		node.id = this.global.namespace + "widget";
		dojo.place (node, dojo.byId (this.global.namespace + "birtChartWidget"), "after");
	},
	restorePortletTitle: function () {
		// restore portlet title to translated Charting
		this.tipHelper_.setPortletTitle (this.table.domNode, this.global.getPortletTitle());
	},
	onResetPrimitive: function (action, reloadPrefs) {
		var callback = null;
		
		if (reloadPrefs === false) {
			callback = null;
		} else {
			callback = dojo.hitch(this, this.afterReset);
		}
		
		var kw = {
	             content:   {
                        command: "savePreferences",
                        arg_portletNamespace: this.global.namespace,
                        arg_chartProfileID: this.global.chartProfileID,
                        action: action
                        },
                 handle: callback
    	     };
	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		
		// do not submit
		return (false);
	},
	onReset: function () {
		this.onResetPrimitive ("resetDefaults");
	},
	afterReset: function () {
		if(!this.global.widgetFetcher){
			this.global.widgetFetcher = new ibm.tivoli.tip.charts.dojo.WidgetFetcher ({
				global: this.global
			});
		}		
		var providerID = this.providerID;
		var dsID = this.datasourceID;
		var widgetID = this.tableID;
		var widgetVersion = this.global.builder.widgetDefinition.meta.version;		
		var domNode = dojo.byId (this.global.namespace+"widgetDiv");			
		this.global.builder.destroyRecursive();		
		dojo.destroy(domNode);
		domNode = dojo.doc.createElement("div");
		domNode.id = this.global.namespace+"widgetDiv";
		dojo.byId (this.global.namespace + "widgetContainer").appendChild(domNode);		
		this.global.builder = this.global.widgetFetcher.buildWidget (providerID, dsID, widgetID, domNode, widgetVersion);	
	},

	onResetMyPreferences: function (reloadDefaultPrefs) {
		this.onResetPrimitive ("resetMine", reloadDefaultPrefs);
	},
	resize: function (size) {
		this.resizeTable (size);
	},
	onDBClickEvent: function () {
		this.getTrigger ("ondblclick");
		if (this.trigger.type == "DrillDown") {
			var builder = this.drillDown(this.trigger.reference);
			this.objReassign.call(builder);	
		}  else if (this.trigger.type == "PORTAL_PAGE") {
			this.launchPage(this.trigger);

		} else if (this.trigger.type == "PORTLET") {
			this.launchPortlet(this.trigger);

		} else if (this.trigger.type == "WEB_URL") {		
			this.launchURL (this.trigger);

		} else if (this.trigger.type == "CLIENT_EVENT") {					
			this.sendEvent(this.trigger);

		} else {
			console.error ("unknown Trigger type: " + this.trigger.type);
		}
	},
	onResizeColumnEvent: function() {
		if(this.widgetDefinition) {
			var columns = this.table.originalStructure.cells;
			if(columns){
				var ifColumnWidthChanged = false;
				var userPrefs;
				if(this.widgetDefinition.user){
					userPrefs = this.widgetDefinition.user;
				}else{
					userPrefs = this.widgetDefinition;
					userPrefs.details = {"preferredView": "Table"};
				}
				for (var i in columns) {
					if (i) {
						var column = columns[i];
						if(userPrefs.tables[0].view[i].width != columns[i].unitWidth){
							ifColumnWidthChanged = true;
						}
						userPrefs.tables[0].view[i].width = columns[i].unitWidth;
					}
				}

				if(ifColumnWidthChanged){
					var prefs = dojo.toJson(userPrefs);
					if(true){
						var encodedCID = encodeURIComponent(this.tableID);                
						var encodedProviderID = encodeURIComponent(this.providerID);                
						var encodedDS = encodeURIComponent(this.datasourceID);                
						var encodedPID = encodeURIComponent(this.global.chartProfileID);
						var widgetDefVersion = this.widgetDefinition.meta.version;        
						var widgetSchema = this.widgetDefinition.meta.type;
						
						var controller = "/ibm/tivoli/rest";                
						console.log (controller + "/providers/tip.charts/datasources/" + encodedDS + "/widgets/" + widgetSchema + "/definitions/" + encodedCID + "-" + widgetDefVersion + "?type=user&profileID=" + this.global.chartProfileID + "&registryLocation=local");
						
						var kw = {
								  sync: true,
								  preventCache: true,
								  headers: {'Content-Type': 'application/json',
												   'Content-Length': prefs.length
												  },
								  url: controller + "/providers/" + encodedProviderID + "/datasources/" + encodedDS + "/widgets/"+ widgetSchema + "/definitions/" + encodedCID + "-" + widgetDefVersion + "?type=user&profileID=" + this.global.chartProfileID + "&registryLocation=local",
								  putData: prefs,
								  error: dojo.hitch (this, function (error) {                                                                                        
												var errHandler = new ibm.tivoli.tip.charts.dojo.RESTErrorHandler(this.global);                
												errHandler.showError(dojo.fromJson(error.responseText));        
									})
							};
						dojo.xhrPut (kw);
					}
				}
			}
		}
	},
	launchURL: function(trigger) 
    {
      console.log ("enter launchURL");
      window.open (trigger.url);
    },	
	launchPortlet: function (trigger) 
   {		
      console.log ("enter launchPortlet");
      var portletEvent = {
                            name: "http://ibm.com/isclite#launchPortlet",
                            portletName: trigger.portletName,
                            portletApplicationID: trigger.portletApplicationId
                         };

      if (trigger.portletParameters) 
      {
         for (var j=0; j<trigger.portletParameters.length; j++) 
         {
            try{
            	eval ("portletEvent." + trigger.portletParameters[j].id + "= '" + trigger.portletParameters[j].value + "'");
             }catch(e){
				 //tipChartsAll.js has variable names in a different format, so, eval will not work
             	portletEvent[trigger.portletParameters[j].id] = trigger.portletParameters[j].value;
             }
         }
      }

      try 
      {
         EventBroker.sendEvent (this.global.iscPortletNamespace, portletEvent);
      } catch (e) {
         console.error ("Caught javascript exception in TableBuilder.launchPortlet: " + e);
         alert (e);
      }
   },
   
   launchPage: function (trigger) 
   {	  
      var pageEvent = {
                         name: "http://ibm.com/isclite#launchPage",
                         NavigationNode: trigger.pageId,
                         pageInstanceRef: null,
                         switchPage: true
                      };

      if (trigger.pageParameters) 
      {
         for (var k=0; k<trigger.pageParameters.length; k++) 
         {
             try{
            	 eval ("pageEvent." + trigger.pageParameters[k].id + "= '" + trigger.pageParameters[k].value + "'");
             }catch(e){
				  //tipChartsAll.js has variable names in a different format, so, eval will not work
             	pageEvent[trigger.pageParameters[k].id] = trigger.pageParameters[k].value;//shakeel
             }
         }
      }

      try 
      {
         EventBroker.sendEvent (this.global.iscPortletNamespace, pageEvent);
      } catch (ex) {
         console.error ("Caught javascript exception in TableBuilder.launchPage: " + ex);
         alert (ex);
      }
   },
   
   sendEvent: function (trigger) 
   {
      var parms = trigger.payload;
      var event = {
                     name: trigger.eventName
                  };

      if (trigger.payload) 
      {
         for (var i=0; i<parms.length; i++) 
         {
            try{
             	eval ("event." + parms[i].id + "= '" + parms[i].value + "'");
             }catch(e){
             	event[parms[i].id] = parms[i].value;
             }
         }
      }

	  console.log ("TableBuilder: sending event: ");            
	  console.log (event);
      EventBroker.sendEvent (this.global.iscPortletNamespace, event);
    },
	getTrigger: function (triggerName) {
		if(this.chartDef.triggers === undefined) {
			if(this.chartDef.yAxis !== undefined) {		//it is a change from a chart to a table
				this.chartDef.triggers = this.chartDef.yAxis.triggers;
			}else {
				return null;
			}
		}
			for (var i=0; i<this.chartDef.triggers.length; i++) {
				if (this.chartDef.triggers[i].id == triggerName) {
					this.trigger = this.chartDef.triggers[i];					
					return (this.chartDef.triggers[i]);
				}
			}		
		return (null);
	},
	getDrillDown: function (drillDownId) {
		for (var i=0; i<this.widgetDefinition.drillDown.length; i++) {
				if (this.widgetDefinition.drillDown[i].id == drillDownId) {					
					return (this.widgetDefinition.drillDown[i]);
				}
		}		
		return (null);
	},

	getDrillUp: function (chartIdWithCount) {		
		for (var i=0; i<this.drillUpItems.length; i++) {				
				if(this.drillUpItems[i].chartIdWithCount == chartIdWithCount) {						
					return (this.drillUpItems[i]);
				}
		}		
		return (null);
	},
	objReassign: function() {
		console.log("builder");
		console.log(this);
	},	

	drillUp: function(chartIdWithCount) {		
		var drillUpObj = this.getDrillUp(chartIdWithCount);
		
		if(drillUpObj !== null) {
			/*
			var encodedChartId = encodeURIComponent(drillUpObj.chartId);
			var encodedProviderId = encodeURIComponent(drillUpObj.providerId);		
			var encodedDatasourceId = encodeURIComponent(drillUpObj.datasourceId);
			var encodedVersion = encodeURIComponent(drillUpObj.version);
			*/
			if(!this.global.widgetFetcher){
				this.global.widgetFetcher = new ibm.tivoli.tip.charts.dojo.WidgetFetcher ({
					global: this.global
				});
			}	
			var fetcher = this.global.widgetFetcher;
			/*
			var domNode = dojo.byId (this.global.namespace+"widget");
			this.destroy();
			dojo.empty(domNode);
			dojo.place (domNode, dojo.byId (this.global.namespace + "birtChartWidget"), "after");
			*/
			this.destroyRecursive();		
			var domNode = dojo.byId (this.global.namespace+"widgetDiv");		
			dojo.destroy(domNode);
			domNode = dojo.doc.createElement("div");
			domNode.id = this.global.namespace+"widgetDiv";
			dojo.byId (this.global.namespace + "widgetContainer").appendChild(domNode);			
			var newDrillUpArray = [];
			
			for (var i=0; i<this.drillUpItems.length; i++) {	
				
				if(this.drillUpItems[i].chartIdWithCount == drillUpObj.chartIdWithCount) {	
					break;
				}
				newDrillUpArray[i] = this.drillUpItems[i];
			}								
			
			//var builder = fetcher.buildWidget(encodedProviderId, encodedDatasourceId, encodedChartId, domNode, encodedVersion, null, newDrillUpArray);
			var builder = fetcher.buildWidget(drillUpObj.providerId, drillUpObj.datasourceId, drillUpObj.chartId, domNode, drillUpObj.version, null, newDrillUpArray);
			this.global.builder = builder;
			return builder;
		}
		return this;

	},
	
	drillDown: function(drillDownId) {

		var drillDownObj = this.getDrillDown(drillDownId);
		if(drillDownObj !== null) {
			/*
			var encodedCID = encodeURIComponent(drillDownObj.widgetId);
			var encodedProviderID = encodeURIComponent(drillDownObj.provider);	
					
			var encodedDS = null;
			if(drillDownObj.connectionID != undefined)
			{
				encodedDS = encodeURIComponent(drillDownObj.connectionID);			
			}
			else 
			{
				if(drillDownObj.datasource == this.widgetDefinition.datasource.type)
				{
					encodedDS = encodeURIComponent(this.datasourceID);
				}
			}
			*/
			var widgetId = drillDownObj.widgetId;
			var providerId = drillDownObj.provider;
			var datasourceId = null;
			if(drillDownObj.connectionID != undefined){
				datasourceId = drillDownObj.connectionID;			
			}else if(drillDownObj.datasource == this.widgetDefinition.datasource.type){				
				datasourceId = this.datasourceID;				
			}
			
			if(!this.global.widgetFetcher){
				this.global.widgetFetcher = new ibm.tivoli.tip.charts.dojo.WidgetFetcher ({
					global: this.global
				});
			}	
			var fetcher = this.global.widgetFetcher;
			/*
			var domNode = dojo.byId (this.global.namespace+"widget");
			this.destroy();
			dojo.empty(domNode);
			dojo.place (domNode, dojo.byId (this.global.namespace + "birtChartWidget"), "after");
			*/
			this.destroyRecursive();		
			var domNode = dojo.byId (this.global.namespace+"widgetDiv");		
			dojo.destroy(domNode);
			domNode = dojo.doc.createElement("div");
			domNode.id = this.global.namespace+"widgetDiv";
			dojo.byId (this.global.namespace + "widgetContainer").appendChild(domNode);
					
			var drillUpLength = this.drillUpItems.length;
			var idCount = 1;
			for (var i=0; i<this.drillUpItems.length; i++) {				
				if(this.drillUpItems[i].chartId == this.chartDef.id) {
					idCount = idCount + 1;
				}
			}
				
			this.drillUpItems[drillUpLength] = {
				"chartId": this.chartDef.id,
				"providerId": this.widgetDefinition.provider.label.key,
				"datasourceId": this.datasourceID,
				"version": this.widgetDefinition.meta.version,
				"idCount": idCount,
				"chartIdWithCount": this.chartDef.id + "(" + idCount + ")"
			};			
			
			//var builder = fetcher.buildWidget(encodedProviderID, encodedDS, encodedCID, domNode, encodeURIComponent(drillDownObj.version), null, this.drillUpItems);
			var builder = fetcher.buildWidget(providerId, datasourceId, widgetId, domNode, drillDownObj.version, null, this.drillUpItems);
			this.global.builder = builder;
			return builder;
		}
		return this;
	},
	destroy: function () {		
		this.inherited ("destroy", arguments);
		dojo.unsubscribe(this.loadCmplteSub);
		dojo.forEach (this.connections, function (item) {
			dojo.disconnect (item);
		});
			
		//this.getToolbar().destroyRecursive();	
		//this.table.toolbar.destroyRecursive();	
		//this.table.destroyRecursive();	

		// remove auto-refresh
		if (this.interval !== null) {
			clearTimeout (this.interval);
			delete this.interval;
		}	
		this.destroyDataSet();
	}
});
