dojo.provide("ibm.tivoli.tip.charts.dijit.TableVisualization");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("ibm.tivoli.tip.dijit.ListBuilder");
dojo.require("ibm.tivoli.tip.charts.dojo.WidgetDefJsoner");

dojo.declare("ibm.tivoli.tip.charts.dijit.TableVisualization",[dijit._Widget, dijit._Templated],{	
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.charts.dijit","templates/TableVisualization.html"),
	widgetDef: null,	
	_availableColumns: null,	

	constructor: function(){
		this._resources = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");		
		this._availableColumns = null;
		this._isLBSizeSet = false;
	},
	
	postMixInProperties: function(){	
		this.inherited(arguments);
		this._buildColumnsStore();	
	},
	
	postCreate: function(){
		this.inherited(arguments);
		this.connect(this.listBuilder,"add","onChange");
		this.connect(this.listBuilder,"remove","onChange");
		this.connect(this.listBuilder,"moveUp","onChange");
		this.connect(this.listBuilder,"moveDown","onChange");
		this.listBuilder.startup();		
		this._buildColumn();		
	},
	
	_buildColumnsStore: function(){
		if(this.widgetDef){
			this._availableColumns = dojo.clone(this.widgetDef.datasets[0].columns);	
			for(var i=0;i<this._availableColumns.length;i++){
				this._availableColumns[i].label = this._availableColumns[i].label.value;
				this._availableColumns[i].toString = function(){return this.label;};
			}
			if(this.widgetDef.tables){			
				this._leftData = [];
				this._rightData = [];
				for(var j=0;j<this._availableColumns.length;j++){
					var isForLeft = true;
					for(var i=0;i<this.widgetDef.tables[0].view.length;i++){
						var viewItem = this.widgetDef.tables[0].view[i];
						if(viewItem.id == this._availableColumns[j].id){
							this._rightData.push(this._availableColumns[j]);
							isForLeft = false;
							break;
						}
					}
					if(isForLeft){
						this._leftData.push(this._availableColumns[j]);
					}
				}			
			}
		}
	},
	
	_buildColumn: function(){
		this.listBuilder.removeAll();
		this.listBuilder.left.deleteAll();
		if(this._leftData && this._rightData){
			this.listBuilder.addData(this._leftData);
			this.listBuilder.addDataToRight(this._rightData);			
		}else if(this._availableColumns){				
			this.listBuilder.addData(this._availableColumns);
		}
	},
	
	setWidgetDefinition: function(widgetDef){
		this.widgetDef = widgetDef;
		this._buildColumnsStore();
		this._buildColumn();
	},
	
	startup: function(){
		this.inherited(arguments);		
	},
	
	onChange: function(){
		console.log("TableVisualization.onChange");
	},
	
	resize: function(size){		
		if(!this._isLBSizeSet){	
			this._isLBSizeSet = true;
			var coords = dojo.coords(this.listBuilder.domNode);	
			dojo.style(this.listBuilder.domNode, {width: (coords.w+5)+"px"});
		}		
		dojo.style(this.lbContainter, {width: size.w+"px",height: size.h+"px"});
	},	
	
	isValid: function(){		
		if(this.listBuilder.right.getAllNodes().length<1){
			return false;
		}else{
			return true;
		}
	},
	
	noChartConfig: function(){
		if(this.listBuilder.right.getAllNodes().length<1){
			return true;
		}else{
			return false;
		}
	},
	
	getWidgetDefinition: function(){
		var selNodes = this.listBuilder.right.getAllNodes();
		var tableColumns = [];
		for(var i=0;i<selNodes.length;i++){
			tableColumns.push(this.listBuilder.right.getItem(selNodes[i].id).data.id);
		}			
		var widgetDefJson = new ibm.tivoli.tip.charts.dojo.WidgetDefJsoner({
			widgetDef: this.widgetDef, 
			columnIds: tableColumns,			
			chartType: "Table"
		});		
		return widgetDefJson.getJsonDef();
	}
});