dojo.provide("ibm.tivoli.tip.charts.dijit.ThresholdsPage");

dojo.require("ibm.tivoli.tip.charts.dijit.ChartPanelPreviewPage");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartThresholds");

dojo.declare("ibm.tivoli.tip.charts.dijit.ThresholdsPage",[ibm.tivoli.tip.charts.dijit.ChartPanelPreviewPage],{
	
	constructor: function(){
		this.inherited(arguments);
		this.contentTitle = this.resources_.THRESHOLD_CONTENT_TITLE; 
		this.contentDesc = this.resources_.THRESHOLD_CONTENT_DESC;
		this.pageId = "1st_threshold";
		this._isSkip = false;
	},
	
	startup: function() {
		this.inherited(arguments);		
		this.connect(this.wizard,"OnNext","_onNext");
		this.connect(this.wizard,"OnBack","_onBack");
	},
	
	_onNext: function(){		
		this._isNext = true;
	},
	
	_onBack: function(){		
		this._isNext = false;
	},
	
	OnPageSelected: function(){	
		this.inherited(arguments);		
		var charts = this.widgetDef.charts;
		if(charts && (charts[0].type == "Lines" || charts[0].type.indexOf("Bar")!=-1 || charts[0].type.indexOf("Column")!=-1)){
			this._isSkip = false;
			if(!this.widgetDefCont){
				var settings = { 		
					widgetDefinition: this.widgetDef, 
					numericAttributesOnly: true,
					testWidget: false, 
					width: this.operateAreaSize.w +"px",
					height: this.operateAreaSize.h +"px",
					useStatusColorSelector: true
				};
				this.widgetDefCont = new ibm.tivoli.tip.charts.dijit.ChartThresholds(settings, this.operateDiv); 
				this.widgetDefCont.startup();
				this.widgetDefCont.subscribe(dojo.hitch(this, this.updateNotify));	
				if(this.wizard._editMode){
					this.previewPanel.setWidgetDefinition(this.widgetDef);	
				}		
			}else{
				this._setWidgetDefUponDatasetChange();
			}	
		}else{
			this._isSkip = true;
			if(this._isNext){
				this.wizard._onClickNext();
			}else{
				this.wizard._onClickBack();
			}		
		}	
	},
	
	AfterPageSelected: function(){
		if(!this._isSkip){
			if((this.syncContent && this.syncContent.preview) || this.wizard._editMode){	
				if(this.widgetDefCont){			
					this.widgetDefCont.setWidgetDefinition(this.widgetDef);
				}
			}
			this.inherited(arguments);		
		}
	},
	
	updateNotify: function(){
		var isValidTresholdValue = true;		
		var thresholds = this.widgetDef.datasets[0].thresholds;
//		for(var i=0;i<thresholds.length;i++){			
//			if (typeof thresholds[i].start != "number"){
//				isValidTresholdValue = false;
//				break;
//			}
//		}
		if ( this.widgetDefCont && isValidTresholdValue) {
			this.previewPanel.setWidgetDefinition(this.widgetDefCont.getWidgetDefinition());
			this.wizard._nextButton.attr("disabled", false);	
		}else{
			this.wizard._nextButton.attr("disabled", true);	
		}
		this.onChange();	
		/*//a bug of SAPM UI widget builder
		if(this.widgetDefCont.isValid()){			
					
		}
		*/
	},
	
	getWidgetDefinition: function(){
		if ( this.widgetDefCont ) {
			this.widgetDef = this.widgetDefCont.getWidgetDefinition();
		}		
		return this.widgetDef;
	},
	
	resize: function(size){
		if(this._triggerResize(size)){		
		this.inherited(arguments);
		this.operateAreaSize = {
			w: (this._pageSize.w-5-10)*0.6-5,
			h: this._pageSize.h-5-dojo.coords(this.titleArea.domNode).h
		};
		if ( this.widgetDefCont ) {
			this.widgetDefCont.resize(this.operateAreaSize);	
		}	
		}
	}

});
