dojo.provide("ibm.tivoli.tip.charts.dijit.VisualizationPage");

dojo.require("ibm.tivoli.tip.charts.dijit.ChartPanelPreviewPage");
dojo.require("ibm.tivoli.tip.charts.dijit.ChartVisualizationWizard");

dojo.declare("ibm.tivoli.tip.charts.dijit.VisualizationPage",[ibm.tivoli.tip.charts.dijit.ChartPanelPreviewPage],{
	
	constructor: function(){		
		this.contentTitle = this.resources_.VISUALIZATION_CONTENT_TITLE;  //replace with resource bundles in future
		this.contentDesc = this.resources_.VISUALIZATION_CONTENT_DESC;
		this.pageId = "1st_visual";
	},
	
	_setWidgetDefUponDatasetChange: function(){
		if(this._isDatasetChange){
			if(this.widgetDef.charts){
				delete this.widgetDef.charts;
			}
			if(this.widgetDef.tables){
				delete this.widgetDef.tables;
			}
		}
		this.inherited(arguments);
	},
	
	OnPageSelected: function(){			
		this.inherited(arguments);		
		if(!this.widgetDefCont){
			this.widgetDefCont = new ibm.tivoli.tip.charts.dijit.ChartVisualizationWizard({widgetDef: this.widgetDef},this.operateDiv);		
			this.connect(this.widgetDefCont, "onChange", "updateNotify");	
			this.widgetDefCont.startup();	
			this.widgetDefCont.resize({w: this.operateAreaSize.w,h: this.operateAreaSize.h});		
			if(this.wizard._editMode){
				this.previewPanel.setWidgetDefinition(this.widgetDef);	
			}
		}else{
			this._setWidgetDefUponDatasetChange();
		}	
	},
	
	AfterPageSelected: function(){		
		this.inherited(arguments);	
		if(this.widgetDefCont.isValid()){
			this.wizard._nextButton.attr("disabled", false);
		}else{
			this.wizard._nextButton.attr("disabled", true);
		}
	},
	
	updateNotify: function(){		
		if(this.widgetDefCont.isValid()){
			this.onChange();			
			this.previewPanel.setWidgetDefinition(this.widgetDefCont.getWidgetDefinition());
			this.wizard._nextButton.attr("disabled", false);	
		}else{
			this.wizard._nextButton.attr("disabled", true);	
			if(this.widgetDefCont.noChartConfig()){
				this.previewPanel.destroyChart();
			}
		}
	},
	
	onChange: function(){				
	},

	getWidgetDefinition: function(){
		this.widgetDef = this.widgetDefCont.getWidgetDefinition();		
		return this.widgetDef;
	},
	
	resize: function(size){
		if(this._triggerResize(size)){		
		try{
		this.inherited(arguments);	
		this.operateAreaSize = {
			w: (this._pageSize.w-5-10)*0.6-5,
			h: this._pageSize.h-5-dojo.coords(this.titleArea.domNode).h
		};
		if(this.widgetDefCont){
			this.widgetDefCont.resize(this.operateAreaSize);
		}
		}catch(e){
			console.log ("VisualizationPage.resize");
		}
		}
	}
	
});