dojo.provide("ibm.tivoli.tip.charts.dojo.ChartEventController");

dojo.require("ibm.tivoli.tip.charts.dojo.ChartNodeClickedOn");
dojo.require("ibm.tivoli.tip.charts.dojo.RESTUtil");

dojo.declare("ibm.tivoli.tip.charts.dojo.ChartEventController", null, {	

	widgetController: null,
	widgetDef: null,
	widgetMap: null,
	event: null,
	nodeClickedOnManager: null,	
	global: null,

	constructor: function(params) {
		console.log ("enter ChartEventController.constructor");		
		this.widgetController = null;
		this.widgetDef = null;
		this.widgetMap = null;
		this.nodeClickedOnManager = null;
		this.event = null;
		this.global = null;
		dojo.mixin(this, params);	
		console.log ("exit ChartEventController.constructor");
	},
	
	handleNodeClickedOn: function(event){
		console.log ("enter ChartEventController.handleNodeClickedOn");	
		this.event = event;
		this.nodeClickedOnManager = new ibm.tivoli.tip.charts.dojo.ChartNodeClickedOn(event);	
		var doSwitch = this.switchWidgetDef();
		if(!doSwitch){
			if (this.widgetController.isWait) {	
				console.log ("widget waiting");						
				this.mergeDatasetParams();		
				this.widgetController.buildWidget();
			}else{
				console.log ("process parameters");
				this.widgetController.builder.processEvent(event);
			}
		}	
		console.log ("exit ChartEventController.handleNodeClickedOn");
	},
	
	getWidgetDefConfig: function(event){
		console.log ("enter ChartEventController.getWidgetDefConfig");	
		var widgetDefConfig = null;
		if(this.widgetMap.widgetDefMappingRuleClass == "null"){
			this.widgetMap.widgetDefMappingRuleClass = null;
		}
		if(this.widgetMap.widgetDefMappingRuleFilePath == "null"){
			this.widgetMap.widgetDefMappingRuleFilePath = null;
		}
		if(this.widgetMap.widgetDefMappingRuleFunction == "null"){
			this.widgetMap.widgetDefMappingRuleFunction = null;
		}
		if(this.widgetMap.widgetDefMappingRuleClass && this.widgetMap.widgetDefMappingRuleFilePath && this.widgetMap.widgetDefMappingRuleFunction){
			var lastDotIndex = this.widgetMap.widgetDefMappingRuleClass.lastIndexOf(".") + 1;
			var jsFileName = this.widgetMap.widgetDefMappingRuleClass.substring(lastDotIndex, this.widgetMap.widgetDefMappingRuleClass.length);
			dojo.registerModulePath(this.widgetMap.widgetDefMappingRuleClass, this.widgetMap.widgetDefMappingRuleFilePath+"/"+jsFileName);			
			dojo["require"](this.widgetMap.widgetDefMappingRuleClass);
			widgetDefConfig = eval(this.widgetMap.widgetDefMappingRuleFunction)(event);		
		}
		console.log ("widget config in preference: "+dojo.toJson(widgetDefConfig));	
		console.log ("exit ChartEventController.getWidgetDefConfig");	
		return widgetDefConfig;
	},
	
	switchWidgetDef: function(){
		console.log ("enter ChartEventController.switchWidgetDef");
		var doSwitch = false;
		var mssName = this.nodeClickedOnManager.getMssName();
		console.log ("MSSName from event: "+mssName);
		var widgetDefConfig = this.getWidgetDefConfig();			
		var providerId = null;
		if(widgetDefConfig){
			var providerType = widgetDefConfig.providerType;
			if(mssName&&providerType){
				providerId = ibm.tivoli.tip.charts.dojo.RESTUtil.getProviderIdFromREST({
					providerType: providerType,
					mssName: mssName,
					global: this.global
				});
			}
		}
		if(providerId){
			var widgetDef = ibm.tivoli.tip.charts.dojo.RESTUtil.getWidgetDefinition({
				widgetType: widgetDefConfig.widget,
				widgetDefId: widgetDefConfig.definition,
				providerId: providerId,
				datasourceId: widgetDefConfig.datasource,
				global: this.global			
			});			
			if(widgetDef){
				this.widgetDef = widgetDef;
				this.mergeDatasetParams();
				doSwitch = true;				
				this.widgetController.switchWidget(this.widgetDef);
			}			
		}	
		console.log ("exit ChartEventController.switchWidgetDef");
		return doSwitch;
	},
	
	mergeDatasetParams: function(){
		console.log ("enter ChartEventController.mergeDatasetParams");
		var eventParams = this.nodeClickedOnManager.getSingleResourceProp();		
		var widgetDefParams = this.widgetDef.datasets[0].parameters;		
		for(var i=0;i<widgetDefParams.length;i++){
			for(var j=0;j<eventParams.length;j++){
				if(widgetDefParams[i].id == eventParams[j].id){
					widgetDefParams[i] = eventParams[j];
					eventParams.splice(j,1);
					break;
				}
			}
		}
		this.widgetDef.datasets[0].parameters = widgetDefParams.concat(eventParams);		
		console.log ("exit ChartEventController.mergeDatasetParams");
	},
	
	destroy: function () {		
	}
});
