dojo.provide("ibm.tivoli.tip.charts.dojo.ChartNodeClickedOn");

dojo.declare("ibm.tivoli.tip.charts.dojo.ChartNodeClickedOn", null, {

	_event: null,

	constructor: function(evt) {
		console.log ("enter ChartNodeClickedOn.constructor");
		this._event = evt;
		console.log (this._event);
		console.log ("exit ChartNodeClickedOn.constructor");
	},	
	
	//Get MSSName from NodeClickedOn event, first single resource area, then multiple resources area
	getMssName: function(){
		console.log ("enter ChartNodeClickedOn.getMssName");
		var mssName = this.getMssNameSingleArea();
		if(!mssName){
			mssName = this.getMssNameMultiArea();
		}
		console.log ("MSSName from event: "+mssName);
		console.log ("exit ChartNodeClickedOn.getMssName");
		return mssName;
	},
	
	//Get MSSName from single resource area
	getMssNameSingleArea: function(){
		console.log ("enter ChartNodeClickedOn.getMssNameSingleArea");
		var mssName = null;				
		if(this._event.payload.product){
			for (x in this._event.payload.product){	
				if(this._event.payload.product[x].cdm && this._event.payload.product[x].cdm.MSSName){
					mssName = this._event.payload.product[x].cdm.MSSName;
					break;
				}				
			}
		}
		console.log ("MSSName in single resource area: "+mssName);
		console.log ("exit ChartNodeClickedOn.getMssNameSingleArea");
		return mssName;		
	},
	
	//Get MSSName from multiple resources area
	getMssNameMultiArea: function(){
		console.log ("enter ChartNodeClickedOn.getMssNameMultiArea");
		var mssName = null;	
		if(this._event.payload.resources && this._event.payload.resources.length>0){
			if(this._event.payload.resources[0].product){				
				for (x in this._event.payload.resources[0].product){	
					if(this._event.payload.resources[0].product[x].cdm && this._event.payload.resources[0].product[x].cdm.MSSName){
						mssName = this._event.payload.resources[0].product[x].cdm.MSSName;
						break;
					}					
				}						
			}
		}
		console.log ("MSSName in multiple resources area: "+mssName);
		console.log ("exit ChartNodeClickedOn.getMssNameMultiArea");
		return mssName;		
	},
	
	//Merge properties from single, multiple resource area into one list
	getSingleResourceProp: function(){
		console.log ("enter ChartNodeClickedOn.getSingleResourceProp");
		if(this._event.payload.product){
			return this.getResourcePropSingleArea();
		}else{
			return this.getResourcePropMultiArea();
		}
		console.log ("exit ChartNodeClickedOn.getSingleResourceProp");
	},
	
	//Merge common, product specific, product CDM properties into one list
	getResourcePropSingleArea: function(){
		console.log ("enter ChartNodeClickedOn.getResourcePropSingleArea");
		return this.getCommonAddiPropSingleArea().concat(this.getProductAddiPropSingleArea()).concat(this.getProductCdmDataSingleArea());
		console.log ("exit ChartNodeClickedOn.getResourcePropSingleArea");		
	},
	
	//Get product CDM properties from single area
	getProductCdmDataSingleArea: function(){
		console.log ("enter ChartNodeClickedOn.getProductCdmDataSingleArea");
		var props = [];						
		if(this._event.payload.product){
			for (x in this._event.payload.product){	
				if(this._event.payload.product[x].cdm){
					for(y in this._event.payload.product[x].cdm[y]){					
						props.push ({
							id: y,
							value: this._event.payload.product[x].cdm[y]
						});					
					}
				}				
			}
		}
		console.log ("exit ChartNodeClickedOn.getProductCdmDataSingleArea");
		return props;		
	},	
	
	//Get product specific properties from single resource area
	getProductAddiPropSingleArea: function(){
		console.log ("enter ChartNodeClickedOn.getProductAddiPropSingleArea");
		var props = [];
		if(this._event.payload.product){				
			for (x in this._event.payload.product){				
				for(y in this._event.payload.product[x]){					
					if(y != "cdm"){
						props.push ({
							id: y,
							value: this._event.payload.product[x][y]
						});
					}				
				}
			}									
		}
		console.log ("exit ChartNodeClickedOn.getProductAddiPropSingleArea");
		return props;		
	},
	
	//Get common properties from single resource area
	getCommonAddiPropSingleArea: function(){
		console.log ("enter ChartNodeClickedOn.getCommonAddiPropSingleArea");
		var props = [];						
		for (x in this._event.payload){				
			if(x!="cdm" && x!="product" && x!="resources"){
				props.push ({
					id: x,
					value: this._event.payload[x]
				});
			}			
		}	
		console.log ("exit ChartNodeClickedOn.getCommonAddiPropSingleArea");
		return props;		
	},		
	
	//Merge common, product specific, product CDM properties into one list
	getResourcePropMultiArea: function(){
		console.log ("enter ChartNodeClickedOn.getResourcePropMultiArea");
		return this.getCommonAddiPropMultiArea().concat(this.getProductAddiPropMultiArea()).concat(this.getProductCdmDataMultiArea());
		console.log ("exit ChartNodeClickedOn.getResourcePropMultiArea");		
	},
	
	//Get product CDM data from multiple resources area
	getProductCdmDataMultiArea: function(){
		console.log ("enter ChartNodeClickedOn.getProductCdmDataMultiArea");
		var props = [];
		if(this._event.payload.resources && this._event.payload.resources.length>0){
			if(this._event.payload.resources[0].product){				
				for (x in this._event.payload.resources[0].product){	
					if(this._event.payload.resources[0].product[x].cdm){
						for(y in this._event.payload.resources[0].product[x].cdm){					
							props.push ({
								id: y,
								value: this._event.payload.resources[0].product[x].cdm[y]
							});
						}
					}					
				}						
			}
		}
		console.log ("exit ChartNodeClickedOn.getProductCdmDataMultiArea");
		return props;		
	},
	
	//Get product specific properties from multiple resources area
	getProductAddiPropMultiArea: function(){
		console.log ("enter ChartNodeClickedOn.getProductAddiPropMultiArea");
		var props = [];
		if(this._event.payload.resources && this._event.payload.resources.length>0){
			if(this._event.payload.resources[0].product){
				for (x in this._event.payload.resources[0].product){				
					for(y in this._event.payload.resources[0].product[x]){					
						if(y != "cdm"){
							props.push ({
								id: y,
								value: this._event.payload.resources[0].product[x][y]
							});
						}				
					}
				}									
			}
		}
		console.log ("exit ChartNodeClickedOn.getProductAddiPropMultiArea");
		return props;		
	},		
	
	//Get common properties from multiple resources area
	getCommonAddiPropMultiArea: function(){
		console.log ("enter ChartNodeClickedOn.getCommonAddiPropMultiArea");
		var props = [];
		if(this._event.payload.resources && this._event.payload.resources.length>0){			
			for (x in this._event.payload.resources[0]){				
				if(x!="cdm" && x!="product"){
					props.push ({
						id: x,
						value: this._event.payload.resources[0][x]
					});
				}			
			}								
		}
		console.log ("exit ChartNodeClickedOn.getCommonAddiPropMultiArea");
		return props;	
	},	
	
	destroy: function () {		
	}
});
