dojo.provide("ibm.tivoli.tip.charts.dojo.DojoChartUtil");

dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("ibm.tivoli.tip.dojo.TIPHelper");

dojo.declare("ibm.tivoli.tip.charts.dojo.DojoChartUtil", null, {

	chartBuilder: null,
	namespace: null,
	providerID: null,
	datasourceID: null,
	savePrefsOption: true,

	constructor: function(mixinData) {
		console.log ("enter DojoChartUtil.ctor");
		dojo.mixin( this, mixinData );
		//Get rid of loading these resouces bundles when standalone
		dojo.requireLocalization("ibm.tivoli.tip.chartportlet.dijit", "chart_resources");
		dojo.requireLocalization("ibm.tivoli.tip.chartportlet.dijit", "chart_messages");
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.chartportlet.dijit", "chart_resources");
	    this.messages_ = dojo.i18n.getLocalization("ibm.tivoli.tip.chartportlet.dijit", "chart_messages");
		this.global = ibm.tivoli.tip.dojo.Global.getSingleton(this.namespace);
		this.allowSubmit_ = true;
		this.interval = null;
		this.tipHelper_ = new ibm.tivoli.tip.dojo.TIPHelper();			
		if(!this.chartBuilder.widgetParams || !this.chartBuilder.widgetParams.standalone){
			this.addToolbarButtons();
		}
		if(this.savePrefsOption == true) {
			this.saveUserPrefs();
		}
		console.log ("exit DojoChartUtil.ctor");
	},
	addToolbarButtons: function () {
		console.log ("enter DojoChartUtil.addToolbarButtons");
		var toolbar = this.chartBuilder.getToolbar();		
		var oldPropertiesButton = dijit.byId (this.chartBuilder.id + "propertiesButton");
		toolbar.removeChild(oldDropDownButton);
		if(oldPropertiesButton != null || oldPropertiesButton != undefined) {
			oldPropertiesButton.destroy();
		}
		var toolbarWidget = dijit.byId (this.chartBuilder.id + "toolbar");
		var buttonPref = new ibm.tivoli.tip.dijit.TIPButton({	
			label: this.resources_.PREFERENCES,
			id: this.chartBuilder.id + "propertiesButton",
			iconClass: "propertiesIcon",
			showLabel: false,
			onClick: dojo.hitch (toolbarWidget, toolbarWidget.onPreferences) 
		});			
		toolbar.addChild(buttonPref);
		var ddMenu = new dijit.Menu ();
		var mi = null;			
		var context = this.global;
		if (context.roles.admin || context.roles.creator) {
			mi = new dijit.MenuItem ({
				label: this.resources_.SAVE_FOR_OTHERS
			});
			mi.onClick = dojo.hitch (this, "onSave");
			ddMenu.addChild (mi);
			
			mi = new dijit.MenuItem ({
				label: this.resources_.CLEAR_DEFAULT_PREFERENCES
			});
			mi.onClick = dojo.hitch (this, "onReset");
			ddMenu.addChild (mi);
		}
			
		mi = new dijit.MenuItem ({
				label: this.resources_.CLEAR_MY_PREFERENCES
			});
		mi.onClick = dojo.hitch (this, "onResetMyPreferences");
		ddMenu.addChild (mi);
			
		var oldDropDownButton = dijit.byId (this.chartBuilder.id + "dropDownButton");
		//toolbar.removeChild(oldDropDownButton);
		if(oldDropDownButton != null || oldDropDownButton != undefined) {
			oldDropDownButton.destroy();
		}

		button = new dijit.form.DropDownButton (
			{	label: this.resources_.PUBLISH,
				id: this.chartBuilder.id + "dropDownButton",
				showLabel: false,
				iconClass: "editIcon",
				dropDown: ddMenu
			});
		toolbar.addChild (button);
		console.log ("made user prefs button: ");
		console.log (button);	
		
		console.log ("exit DojoChartUtil.addToolbarButtons");
	},
	saveUserPrefs: function () {
		this.savePrimitive ("saveUser", false);
	},
	onSave: function () {
		this.savePrimitive ("saveShared", true);
	},
	savePrimitive: function (action, showCompletion) {
		var callback = null;
		console.log ("enter savePrimitive with args: " + action + ", " + showCompletion);
		if (showCompletion) {
			callback = dojo.hitch (this, this.onSaveComplete);
		} 
		
		if (this.allowSubmit_) {
			var hiddenparams = this.getHiddenParameters();
			var url = "?" + hiddenparams;

			var kw = {
				 appendURL: url,
	             content:   {
                        command: "savePreferences",
                        arg_portletNamespace: this.namespace,
                        action: action
                        },
            	 onResponse:{
                         callback: callback
       	                }
    	     };
	        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		} else {
			this.allowSubmit_ = true;
		}
		
		// do not submit
		return (false);
	},
	onResetPrimitive: function (action, reloadPrefs) {
		var callback = null;
		
		if (reloadPrefs === false) {
			callback = null;
		} else {
			callback = dojo.hitch(this, this.afterReset);
		}
		
		var kw = {
	             content:   {
                        command: "savePreferences",
                        arg_portletNamespace: this.namespace,
						arg_chartProfileID: this.global.chartProfileID,
                        action: action
                        },
            	 handle: callback
    	     };
	
        ibm.tivoli.tip.dojo.Server.getSingleton( this.global ).get( kw );			
		
		// do not submit
		return (false);
	},
	onReset: function () {
		this.onResetPrimitive ("resetDefaults");
	},
	onResetMyPreferences: function (reloadDefaultPrefs) {
		this.onResetPrimitive ("resetMine", reloadDefaultPrefs);
	},
	afterReset: function () {
		if(!this.global.widgetFetcher){
			this.global.widgetFetcher = new ibm.tivoli.tip.charts.dojo.WidgetFetcher ({
				global: this.global
			});
		}		
		var providerID = this.providerID;
		var dsID = this.datasourceID;
		var widgetID = this.global.builder.chartID;
		var widgetVersion = this.global.builder.widgetDefinition.meta.version;		
		var domNode = dojo.byId (this.global.namespace+"widgetDiv");			
		this.global.builder.destroyRecursive();		
		dojo.destroy(domNode);
		domNode = dojo.doc.createElement("div");
		domNode.id = this.global.namespace+"widgetDiv";
		dojo.byId (this.global.namespace + "widgetContainer").appendChild(domNode);		
		this.global.builder = this.global.widgetFetcher.buildWidget (providerID, dsID, widgetID, domNode, widgetVersion);	
	},
	restorePortletTitle: function () {
		// restore portlet title to translated Charting
		this.tipHelper_.setPortletTitle (this.chartBuilder.domNode, this.global.getPortletTitle());
	},
	hide: function () {
		this.chartBuilder.domNode.style.display = "none";
	},
	show: function () {
		this.chartBuilder.domNode.style.display = "";
	},
	onSaveComplete: function (data, ioArgs) {
		console.info ("enter onSaveComplete");

		//PUT the shared preferences
		var toolbarWidget = dijit.byId (this.chartBuilder.id + "toolbar");			
		toolbarWidget.saveSharedPreferences();
		
		var msgID = "TIPCH3005I";
		var msg = this.messages_.TIPCH3005I;
		this.global.showMessageDialog("info", msgID, msg, false);
	},
	getHiddenParameters: function () {
		var type = "TIPServer";
		var appID = this.chartBuilder.widgetDefinition.datasource.id;
		var urlfrag = this.namespace + "connectionNameH=" + this.datasourceID;
		urlfrag += "&" + this.namespace + "chartIDH=" + this.chartBuilder.chartID;
		urlfrag += "&" + this.namespace + "chartSourceTypeGroup=" + type;
		urlfrag += "&" + this.namespace + "appID=" + this.datasourceID;
		urlfrag += "&" + this.namespace + "providerID=" + this.providerID;
		urlfrag += "&" + this.namespace + "versionH=" + this.chartBuilder.widgetDefinition.meta.version;
		urlfrag += "&arg_partialSave=false";

		return (urlfrag);	
	},
	destroy: function () {
		this.chartBuilder.destroyRecursive();
	}
});
