dojo.provide("ibm.tivoli.tip.charts.dojo.RESTUtil");

dojo.require("ibm.tivoli.navmodel.ProviderUtils");
dojo.require ("ibm.tivoli.tip.charts.dojo.RESTErrorHandler");

ibm.tivoli.tip.charts.dojo.RESTUtil.getProviderIdFromREST = function(params){
	console.log ("enter RESTUtil.getProviderIdFromREST");	
	//console.log ("Parameters: "+dojo.toJson(params));
	var providerId = null;
	ibm.tivoli.navmodel.ProviderUtils.getProviders({
		baseUrl: "/ibm/tivoli/rest",
        condition: "type = '"+params.providerType+"'",
		sync: true,
        onComplete: function(providers, providerCount, args) {						
						for ( var i = 0; i < providerCount; i++ ) {							
							if ( providers[i].getAttribute("MSSName") == params.mssName ) {								
								providerId = providers[i].getAttribute("id");					
								break;
							}
						}
					},
        onError: function(error, exception, ioArgs) {
        			var errHandler = new ibm.tivoli.tip.charts.dojo.RESTErrorHandler(params.global);		
					errHandler.showError(dojo.fromJson(error.responseText));	 
        			console.error(error); 
        		 }            
    });	
	console.log ("Provider Id got with mssName: "+providerId);
	console.log ("exit RESTUtil.getProviderIdFromREST");
	return providerId;
};

ibm.tivoli.tip.charts.dojo.RESTUtil.getWidgetDefinition = function(params){
	console.log ("enter RESTUtil.getWidgetDefinition");		
	//console.log ("Parameters: "+dojo.toJson(params));
	var widgetDef = null;
	var providerId = encodeURIComponent(params.providerId);
	var datasourceId = encodeURIComponent(params.datasourceId);
	var widgetId = encodeURIComponent(params.widgetDefId);
	var widgetVer = encodeURIComponent(params.widgetType.substring(params.widgetType.indexOf("-")+1));	
	var kw = {
        sync: true,
		handleAs: "json",
		preventCache: true,
    	mimetype: "application/json",        			 
        url: "/ibm/tivoli/rest/providers/" + providerId + "/datasources/" + datasourceId + "/widgets/charts-all/definitions/" + widgetId + "-" + widgetVer + "?registryLocation=local",
        load: function (data) {
            widgetDef = data;
			console.log ("widget definition: "+dojo.toJson(widgetDef));
        },
        error: dojo.hitch (this, function (error) { 
        	var errHandler = new ibm.tivoli.tip.charts.dojo.RESTErrorHandler(params.global);		
			errHandler.showError(dojo.fromJson(error.responseText));	
        	console.error(error); 
        })
    };          
    dojo.xhrGet (kw);
	widgetDef.provider.id = params.providerId;
	widgetDef.datasource.id = params.datasourceId;
	console.log ("exit RESTUtil.getWidgetDefinition");	
	return widgetDef;	
};



