dojo.provide("ibm.tivoli.tip.charts.dojo.SyncController");

dojo.declare("ibm.tivoli.tip.charts.dojo.SyncController",null,{
	
	datasetPanel: null,
	paramsPanel: null,
	filterPanel: null,
	visualPanel: null,
	thresholdPanel: null,
	visualOptionPanel: null,
	
	syncParamsDataChange: null,
	syncParamsVisualChange: null,
	syncParamsSummaryChange: null,
	
	constructor: function(params){
		dojo.mixin( this, params );
		this.syncParamsDataChange = {
			preview: true,
			summary: true	
		};
		this.syncParamsVisualChange = {
			preview: true
		};
		this.syncParamsSummaryChange = {
			summary: true
		};
	},
	
	dataSetChange: function(){
		this.paramsPanel.syncWidgetDef();
		this.filterPanel.syncWidgetDef();
		this.visualPanel.syncWidgetDef();
		this.thresholdPanel.syncWidgetDef();
		this.visualOptionPanel.syncWidgetDef();
	},
	paramsChange: function(){
		this.filterPanel.syncWidgetDef();		
		this.visualPanel.syncWidgetDef(this.syncParamsDataChange);
		this.thresholdPanel.syncWidgetDef(this.syncParamsDataChange);		
		this.visualOptionPanel.syncWidgetDef(this.syncParamsDataChange);		
	},
	filterChange: function(){
		this.paramsPanel.syncWidgetDef(this.syncParamsSummaryChange);
		this.visualPanel.syncWidgetDef(this.syncParamsDataChange);
		this.thresholdPanel.syncWidgetDef(this.syncParamsDataChange);
		this.visualOptionPanel.syncWidgetDef(this.syncParamsDataChange);
	},
	visualChange: function(){
		this.thresholdPanel.syncWidgetDef(this.syncParamsVisualChange);
		this.visualOptionPanel.syncWidgetDef(this.syncParamsVisualChange);
	},
	thresholdChange: function(){
		this.visualPanel.syncWidgetDef(this.syncParamsVisualChange);
		this.visualOptionPanel.syncWidgetDef(this.syncParamsVisualChange);
	},
	visualOptionChange: function(){
		this.visualPanel.syncWidgetDef(this.syncParamsDataChange);
		this.thresholdPanel.syncWidgetDef(this.syncParamsVisualChange);
	}
});