
dojo.provide("ibm.tivoli.tip.charts.dojo.WidgetController");

dojo.require ("ibm.tivoli.tip.charts.dijit.DojoChartBuilder");
dojo.require ("ibm.tivoli.tip.charts.dijit.TableBuilder");
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

dojo.declare("ibm.tivoli.tip.charts.dojo.WidgetController", null,{

	global: null,
	namespace: null,
	iscNamespace: null,
	widgetDef: null,
	widgetParams: null,
	builder: null,
	widgetDomNode: null,
	widgetSize: null,
	_isChart: null,
	isWait: false,
	
	constructor: function (params) {
		console.log("enter WidgetController.constructor");
		this.widgetDef = null;
		this.widgetParams = null;
		this.global = null;
		this.namespace = null;
		this.iscNamespace = null;
		this.builder = null;
		this.widgetDomNode = null;
		this.widgetSize = null;
		this._isChart = true;
		this.isWait = false;		
	    dojo.mixin( this, params );	
	    this._resources = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
	    this.autoUpdateConfig = {};
	    if(this.global.autoUpdateConfig){
			if(this.global.autoUpdateConfig.maxUpdateInterval){
				this.autoUpdateConfig.updateMaxInterval = this.global.autoUpdateConfig.maxUpdateInterval * 1000;
			}
			if(this.global.autoUpdateConfig.minUpdateInterval){
				this.autoUpdateConfig.updateMinInterval = this.global.autoUpdateConfig.minUpdateInterval * 1000;
			}
			if(this.global.autoUpdateConfig.multiplier){
				this.autoUpdateConfig.updateMultiplier = this.global.autoUpdateConfig.multiplier;
			}
		}	
		console.log("exit WidgetController.constructor");
	},
	
	_buildWidgetParams: function(){
		console.log("enter WidgetController._buildWidgetParams");
		var isResizeLate = false;
		if(!this.widgetSize){
			this.widgetSize = {w:400,h:400};
			isResizeLate = true;
		}
		var widgetParams = {
			global: this.global,
			_widgetSize: dojo.clone(this.widgetSize),
			isResizeLate: isResizeLate,
			providerID: this.widgetDef.provider.id,
			datasourceID: this.widgetDef.datasource.id,
			chartID: this.widgetDef.meta.id,		
			tableID: this.widgetDef.meta.id,
			widgetDefinition: this.widgetDef
		};	
		if ((this.widgetDef.charts) && (this.widgetDef.charts[0].type == "Table") || ((this.widgetDef.tables) && (this.widgetDef.tables.length > 0))) {
			widgetParams.widgetParams = this.widgetParams;
			this.widgetParams = widgetParams;
		}else{
			this.widgetParams = dojo.mixin (this.widgetParams, widgetParams);
		}		
		dojo.mixin (this.widgetParams, this.autoUpdateConfig);	
		console.log("exit WidgetController._buildWidgetParams");
	},

	buildWidget: function () {
		console.log("enter WidgetController.buildWidget");
		this.isWait = false;
		var dsParams = this.widgetDef.datasets[0].parameters;		
		if(dsParams){
			for(var i=0; i<dsParams.length; i++){
				if(dsParams[i].required && (dsParams[i].value === undefined || dsParams[i].value === null || (typeof dsParams[i].value == "string" && dojo.trim(dsParams[i].value)==""))){
					this.isWait = true;
					break;
				}
			}
		}
		if(!this.isWait){
			if(!this.busyPane){
				this.busyPane = new ibm.tivoli.tip.dijit.BusyPane({id: this.global.namespaceID('busy_pane')}, dojo.byId(this.namespace+"busy_pane"));
			}else{
				this.busyPane.messageArea.innerHTML = this.busyPane.processingLabel;
			}
			this.busyPane.show(true);
			this._buildWidgetParams();
			this.widgetDomNode = dojo.byId(this.namespace+"widgetDiv");
			if ((this.widgetDef.charts) && (this.widgetDef.charts[0].type == "Table") || ((this.widgetDef.tables) && (this.widgetDef.tables.length > 0))) {
				this._isChart = false;			
				this._buildTable();
			} else {
				this._isChart = true;
				this._buildChart();
			}
			this.global.builder = this.builder;		
		}else{
			//this.showWaitPane();
			if(!this.widgetSize){				
				this.busyPaneConn = dojo.connect(this, "resizeWidget", this, "showWaitPane");
			}else{
				this.showWaitPane();		
			}	
		}
		console.log("exit WidgetController.buildWidget");
	},
	
	showWaitPane: function(){
		if(!this.busyPane){
			this.busyPane = new ibm.tivoli.tip.dijit.BusyPane({
				id: this.global.namespaceID('busy_pane')					
			}, dojo.byId(this.namespace+"busy_pane"));				
		}	
		this.busyPane.messageArea.innerHTML = this._resources.WIDGET_WAIT_STATUS; 
		this.busyPane.show(true);	
		if(this.busyPaneConn){
			dojo.disconnect(this.busyPaneConn);
			this.busyPaneConn = null;
		}
	},
	
	switchWidget: function(widgetDef){
		this.widgetDef = widgetDef;
		this.destroyWidget();		
		this.buildWidget();
	},
	
	resizeWidget: function(size){
		console.log("enter WidgetController.resizeWidget");		
		if(!(size && size.w && size.h)){			
			var portletSize = iscPortlet.getPortletSize(this.iscNamespace);			
			size = { w: portletSize.available.w-10, h: portletSize.available.h-5 };
		}				
		if(!this.widgetSize||(this.widgetSize.w!=size.w || this.widgetSize.h!=size.h)){			
			this.widgetSize = size;		
			if(this.builder){		
				if(this.builder.isChartBuilt == true || !this.builder.setWidgetSize){				
					this.builder.resize(dojo.clone(this.widgetSize));	
				}else{		
					this.builder.setWidgetSize(dojo.clone(this.widgetSize));				
				}				
			}	
		}
		console.log("exit WidgetController.resizeWidget");
	},

	_buildChart: function () {	
		console.log("enter WidgetController._buildChart");
		this.builder = new ibm.tivoli.tip.charts.dijit.DojoChartBuilder(this.widgetParams,this.widgetDomNode); 
		this.builder.startup();		
		this.chartBuildSub = dojo.subscribe ("ChartBuilder.chartBuilt" + this.builder.id, dojo.hitch(this,function(){			
			this.busyPane.hide();			
		})); 
		console.log("exit WidgetController._buildChart");
	},
	
	_buildTable: function () {	
		console.log("enter WidgetController._buildTable");
		this.widgetParams.div = this.widgetDomNode;		
		this.builder = new ibm.tivoli.tip.charts.dijit.TableBuilder(this.widgetParams);			
		this.builder.startup();			
		console.log("exit WidgetController._buildTable");
	},
	
	destroyWidget: function(){
		console.log("enter WidgetController.destroyWidget");
		if(!this.isWait){
			this.builder.destroyRecursive();
			var domNode = dojo.byId (this.global.namespace+"widgetDiv");		
			dojo.destroy(domNode);
			domNode = dojo.doc.createElement("div");
			domNode.id = this.global.namespace+"widgetDiv";
			dojo.byId (this.global.namespace + "widgetContainer").appendChild(domNode);
		}
		console.log("exit WidgetController.destroyWidget");
	},	
	
	cleanup: function(){
		this.builder.destroyRecursive();
		this.busyPane.destroyRecursive();
		dojo.unsubscribe(this.chartBuildSub);
	}
});
