dojo.provide("ibm.tivoli.tip.charts.dojo.WidgetDefJsoner");

dojo.declare("ibm.tivoli.tip.charts.dojo.WidgetDefJsoner",null,{
	tables: null,
	charts: null,
	chartType: null,
	widgetDef: null,
	columnIds: null,
	xAxisDataAttr: null,
	yAxisDataAttrs: null,
	yAxisTooltipAttrs: null,
	constructor: function(params){
		this.widgetDef = null;
		this.columnIds = [];
		this.tables = [{}];
		this.charts = [{}];	
		this.xAxisDataAttr = null;
		this.yAxisDataAttrs = null;
		this.yAxisTooltipAttrs = null;
		dojo.mixin( this, params );		
		this.chart = this.charts[0];
		if(this.chartType==="Table"){
			this.chart = this.tables[0];
			this.chart.view = [];
			//this.chart.triggers = [];		
		}
		this.chart.groups = [];
		//this.chart.contextMenu = [];		
	},
	
	newLabelDesc: function(params){
		var obj = {
			key : "",
			value: "",
			cssClass: ""
		};
		if(params){
			dojo.mixin(obj, params);
		}
		return obj;
	},
	newGroup: function(){
		var obj = { id: ""};
		return obj;
	},
	newContextMenu: function(){
		var obj = {
			id: "",
			label: { 
	    		key:"",
	    		value:""
    		},
    		type: "",
    		reference: ""
		};
		return obj;
	},
	newTrigger: function(){
		var obj = {				
			id:"",
			pageId:"",
			type:"",
			pageParameters: [{
				id:"",
				value:""
			}]				
		};
		return obj;
	},
	newView: function(){
		var obj = {
			id:"",
			width:"9em",
			hidden: false,
			searchable: true
		};
		return obj;
	},
	setResourceBundle: function(param){
		this.chart.resourceBundle = "";
		if(param){
			this.chart.resourceBundle = param;
		}
	},
	setCommon: function(param){
		this.chart.common = {
			autoUpdate: false,
			showLastUpdateTime: false,
			paging: false,
			pagingSize: 25
		};
		if(param){
			dojo.mixin(this.chart.common,param);
		}
	},
	setLabel: function(param){
		this.chart.label = this.newLabelDesc();
		if(param){
			dojo.mixin(this.chart.label,param);
		}
	},
	setId: function(param){
		this.chart.id = "";		
		if(param){
			this.chart.id = param;	
		}
	},
	setHeader: function(param){
		this.chart.header = {
			label: this.newLabelDesc(),
			hidden: true
		};
		if(param){
			dojo.mixin(this.chart.header,param);
		}
	},
	setFooter: function(param){
		this.chart.footer = {
			label: this.newLabelDesc(),
			hidden: true
		};
		if(param){
			dojo.mixin(this.chart.footer,param);
		}
	},
	setToolbar: function(param){
		this.chart.toolbar = { 
			hidden: true
		};
		if(param){
			dojo.mixin(this.chart.toolbar,param);
		}
	},
	addGroup: function(param){
		var grp = this.newGroup();
		if(param){
			dojo.mixin(grp,param);
		}
		this.chart.groups.push(grp);
	},
	setDescription: function(param){
		this.chart.description = this.newLabelDesc();
		if(param){
			dojo.mixin(this.chart.description,param);
		}
	},
	addContextMenu: function(param){
		var cxtMenu = this.newContextMenu();
		if(param){
			dojo.mixin(cxtMenu,param);
		}
		this.chart.contextMenu.push(cxtMenu);
	},
	addTrigger: function(param){
		var tri = this.newTrigger();
		if(param){
			dojo.mixin(tri,param);
		}
		this.chart.triggers.push(tri);
	},
	setDatasource: function(param){
		this.chart.datasource = "";
		if(param){
			this.chart.datasource = param;
		}
	},
	setDataset: function(param){
		this.chart.dataset = "";
		if(param){
			this.chart.dataset = param;
		}
	},
	setSelectionMode: function(param){
		this.chart.selectionMode = "single";
		if(param){
			this.chart.selectionMode = param;
		}
	},
	setColumnReordering: function(param){
		this.chart.columnReordering = true;
		if(param){
			this.chart.columnReordering = param;
		}
	},
	addView: function(param){
		var view = this.newView();
		if(param){
			dojo.mixin(view,param);
		}
		this.chart.view.push(view);
	},
	
	setCommonAttr: function(){
		//this.setResourceBundle(this.widgetDef.meta.resourceBundle);
		this.setCommon();
		this.setLabel(this.widgetDef.meta.label);
		this.setId(this.widgetDef.meta.id);	
		this.setToolbar();
		this.addGroup({id: this.widgetDef.groups[0].id});
		this.setDescription();//get description from widget wizard
	},
	
	setTableSpecific: function(){
		var i=0;
		//this.setHeader();
		//this.setFooter();
		this.setDatasource(this.widgetDef.datasource.type);
		this.setDataset(this.widgetDef.datasets[0].id);
		this.setSelectionMode();
		this.setColumnReordering();
		for(i=0;i<this.columnIds.length;i++){
			this.addView({id:this.columnIds[i]});
		}
	},
	
	setChartSpecific: function(){
		this.setChartType();
		this.setShowGrid();
		this.setLegend();
		this.setShowTooltips();
		this.setXAxis();
		this.setYAxis();
	},
	
	setChartType: function(param){
		this.chart.type = this.chartType;
		if(param){
			this.chart.type = param;
		}
	},
	
	setShowGrid: function(param){
		this.chart.showGrid = false;
		if(param){
			this.chart.showGrid = param;
		}
	},
	
	setLegend: function(param){
		this.chart.legend = {
			hidden:false,
            location:"right",
            orientation:"vertical",
            cssClass:"legend"
		};
		if(param){
			dojo.mixin(this.chart.legend,param);
		}
	},
	
	setShowTooltips: function(param){
		this.chart.showTooltips = true;
		if(param){
			this.chart.showTooltips = param;
		}
	},
	
	setXAxis: function(param){
		this.chart.xAxis = {
            datasource: this.widgetDef.datasource.type,
            label: this.newLabelDesc({
				key: this.xAxisLabel,
				value: this.xAxisLabel
			}),
            //columnToGroupBy:"",
            dataset:this.widgetDef.datasets[0].id,
            dataColumn: this.xAxisDataAttr,
            id:"X"
        };
	},
	
	getColumnLabelFromWidgetDef: function(id){
		var columns = this.widgetDef.datasets[0].columns;
		var i=0;
		
		for(i=0;i<columns.length;i++){
			if(columns[i].id === id){
				return columns[i].label;
			}
		}
	},
	
	setYAxis: function(){
		var i=0;
		this.chart.yAxis = {
            label: this.newLabelDesc({
				key: this.yAxisLabel,
				value: this.yAxisLabel
			}),
            //triggers: [],
            series:[],
            id: "Y"    
        };		
		for(i=0;i<this.yAxisDataAttrs.length;i++){
			var series = {
                //textColumn:"",
                datasource: this.widgetDef.datasource.type,
                label: this.getColumnLabelFromWidgetDef(this.yAxisDataAttrs[i]),
                dataset:this.widgetDef.datasets[0].id,
                tooltipColumn: this.yAxisTooltipAttrs[i],
                dataColumn: this.yAxisDataAttrs[i]
            };
			this.chart.yAxis.series.push(series);
		}	
	},
	
	setChartDef: function(){		
		this.setCommonAttr();	
		if(this.chartType==="Table"){
			this.setTableSpecific();
		}else{
			this.setChartSpecific();
		}
	},
	
	getJsonDef: function(){
		this.setChartDef();
		if(this.chartType==="Table"){
			return this.tables;
		}else{
			return this.charts;
		}
	}
	
});