/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2009 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
/*******************************************************************************
 * CMVC Location: %W%
 * Version:       %I%
 * Last Modified: %G%
 *******************************************************************************/

dojo.provide("ibm.tivoli.tip.dijit.TIPTableOptionsDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit._Container");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("ibm.tivoli.tip.dijit.TIPTableOptions");

// NLS
dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");


// define the widget class
dojo.declare (
	"ibm.tivoli.tip.dijit.TIPTableOptionsDialog", 
    [ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("ibm.tivoli.tip.dijit","templates/TIPTableOptionsDialog.html"),
	widgetsInTemplate: true,
	table: null,
	optionsWidget_: null,
	global: null,

	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
		console.log ("enter TIPTableOptionsDialog.constructor");
	    this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources");
	},
	postCreate: function() { 
		this.inherited ("postCreate", arguments);
		console.info ("enter TIPTableOptions:postCreate");

		this.optionsWidget_=new ibm.tivoli.tip.dijit.TIPTableOptions (
			{
				table: this.table,
				global: this.global
			}, 
			dojo.byId(this.id + "columnsVisibleDivContainer")
		);
		this.optionsWidget_.startup();
		
	},
	//add 2009/07/07 by chujing for  function select all
	onSelectAll: function(){
		
	this.optionsWidget_.onSelectAll();
	},
	//add 2009/07/07 by chujing for  function deselect all
	onDeselectAll: function(){
		
	this.optionsWidget_.onDeselectAll();
	},
	
	onOK: function () {
		// TODO: persist changes
		console.log ("enter TIPOptionsDialog.onOK");
		this.optionsWidget_.onSave();
		this.hide();
	},
	onCancel: function () {
		console.log ("enter TIPOptionsDialog.onCancel");
		this.hide();
		// TODO: revert changes
	},
	show: function () {
		this.dialog.show();
		dijit.byId (this.id + "tabs").resize();
	},
	hide: function () {
		this.dialog.hide();
		setTimeout (dojo.hitch (this, this.kill), 100);
	},
	kill: function () {
		var id = this.id;
		this.destroyRecursive();
		dijit.registry.remove (id);
	},
	getTableOptions: function () {
		return (this.optionsWidget_);
	}
});


