/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * 5724-C51
 *
 * (C) Copyright IBM Corp. 2007 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Toolbar");

dojo.require("ibm.tivoli.tip.dijit.TIPTableSearchField");

dojo.provide("ibm.tivoli.tip.dijit.TIPTableToolbar");

/******************************************************************************
* A dijit.Toolbar and a TIPTableSearchField combined into one.
*
* Authors: Joseph Firebaugh
******************************************************************************/
dojo.declare("ibm.tivoli.tip.dijit.TIPTableToolbar",
            [ dijit._Widget, dijit._Templated ],
{
  widgetsInTemplate: true,
   shownub : true,
   nubhover :true,
   nub :null,
   stateMinimized:false,
  templatePath: dojo.moduleUrl("ibm.tivoli.tip.dijit","templates/TIPTableToolbar.html"),
  
  getToolbar: function()
  {
    return this.toolbar;
  },
   postCreate : function(){
    if(this.shownub == true) {
	console.warn("postCreate nub");
	var div = document.createElement("div");
		
	this.nub=div;
	div.setAttribute("tabIndex","0");
	dojo.addClass(div,"nubOpen");
	this.resetNubPos();
	dojo.style(div,"position","absolute");
	dojo.style(div,"bottom","-1px");
	dojo.style(div,"height","9px");
	dojo.style(div,"align","center");
	// fix for accessibility, setting aria attributes
	div.setAttribute("role","button");
	div.setAttribute("title","toggle toolbar");
	div.setAttribute("wairole","button");
	div.setAttribute("aria-labelledby","toggle toolbar");
	 if(this.nubhover ==true){
		dojo.style(div,"display","none");
		dojo.connect(this.toolbarDom,'onmouseover',this,this._mouseover);
		dojo.connect(this.toolbarDom,'mouseout',this,this._mouseout);
	  }	
	this.nubArea.appendChild(div);
	}
  },
  resetNubPos : function(){
	if (this.shownub == true) {   
		var coords = dojo.coords(this.toolbarBody);
		//var centerx =  coords.x + (coords.w/2);
		var centerx = coords.w/2;
		dojo.style(this.nub,"left",centerx+"px");
	}
  },
  _mouseover:function() {
   
   if(this.stateMinimized==false){
   dojo.style(this.nub,"display","block");
   }
  },
  _mouseout :function(){
  
   if(this.stateMinimized==false){
   dojo.style(this.nub,"display","none");
  }
  },
  destroy: function()
  {
	this.inherited( "destroy", arguments );
	if(this.searchField){
		this.searchField.destroy();
	}
	if(this.toolbar){
		this.toolbar.destroy();
	}  	
  }    
});
