dojo.provide("ibm.tivoli.tip.dijit.picker.PopupPicker"); 

dojo.require("ibm.tivoli.tip.dijit.picker.Picker"); 

/**
 * A pop-up picker base class. 
 */
dojo.declare(
    "ibm.tivoli.tip.dijit.picker.PopupPicker",
    [ibm.tivoli.tip.dijit.picker.Picker],
    {
        /** true if the picker is opened */
        _pickerOpened: false,
        /** the widget used to place the popup-picker */
        _parent: null,

        /**
         * Constructor.
         * 
         *      @param params: a set of parameters:
         *          - parent: the widget used to place the popup-picker.
         */
        constructor: function(params)
        {
            this._parent = params.parent;
        },
                       
        /**
         * Opens the picker.
         */
        open: function()
        {
		
		   //console.info("PopupPicker open START ");
		   
            // open the picker (if we've a parent and if not opened)
            if ( this._parent && ! this._pickerOpened ) {
                // open a popup containing the picker
				try {

                dijit.popup.open({
                    parent: this.parent,
                    popup: this,
                    around: this._parent.domNode,
                    onCancel: dojo.hitch(this, this.close),
                    onClose: dojo.hitch(this, function(){ this._pickerOpened = false; })
                });
				}
				catch (e) {
				   // need fix this error(p.getDisplayedValue is not a function) but it is coming in dojo code
					//console.warn(e);
				}

				// Following Line of code is Changed by Prashant Sirohi
                //this._pickerOpened = true;
                dojo.marginBox(this.domNode, { w: this.parent.domNode.offsetWidth });
            }
			//console.info("PopupPicker open END ");
        },

        /**
         * Closes the picker.
         */
        close: function()
        {
		    //console.info("close PopupPicker");
			// Following Lines of code is Changed by Prashant Sirohi
			
            /*if ( this._pickerOpened ) {
                dijit.popup.close(this);
                this._pickerOpened = false;
            }  */
			
			
			dijit.popup.close(this);
            			
        },
        
        /**
         * Returns true if the picker is opened.
         */
        isOpen: function()
        {
            return this._pickerOpened;
        }
    }        
);

