dojo.provide("ibm.tivoli.tip.dijit.tests.tivpages.OuterPage1");

dojo.require("ibm.tivoli.tip.dijit.TivPage");
dojo.require("ibm.tivoli.tip.dijit.TivWizard");
dojo.require("ibm.tivoli.tip.dijit.tests.tivpages.Page2");
dojo.require("ibm.tivoli.tip.dijit.tests.tivpages.Page3");
dojo.require("ibm.tivoli.tip.dijit.tests.tivpages.Summary");

dojo.declare("ibm.tivoli.tip.dijit.tests.tivpages.OuterPage1", [ibm.tivoli.tip.dijit.TivPage],
{
  templatePath: dojo.moduleUrl("ibm.tivoli.tip.dijit.tests.tivpages", "templates/OuterPage1.html"),
  title: "Nested Page",
  outerPage2: null,
  
  postCreate: function()
  {
    console.log("OuterPage1 - postCreate");
    this.inherited(arguments);     
    dojo.connect(this.embedNote, "OnOK", function() {alert("OK pressed on nested notebook");});
    dojo.connect(this.embedNote, "OnApply", function() {alert("Apply pressed on nested notebook");});
    dojo.connect(this.embedNote, "OnCancel", function() {alert("Cancel pressed on nested notebook");});
    
    // connect to any changes on the nested notebook pages
    var page2 = dijit.getEnclosingWidget(dojo.query(".page2", this.embedNote.domNode)[0]);
    var page3 = dijit.getEnclosingWidget(dojo.query(".page3", this.embedNote.domNode)[0]);
    dojo.connect(page2, "_onPageContentChange", dojo.hitch(this, this.checkIfAllValid, page2));
    dojo.connect(page3, "_onPageContentChange", dojo.hitch(this, this.checkIfAllValid, page3));    
  },
  
  startup: function()
  {
    if (this._started){ return; }
    console.log("OuterPage1 - startup");
    this.inherited(arguments);     
  },
  
  OnPageSelected: function(myContainer)
  {
    console.log("OuterPage1 - OnPageSelected");
    this.inherited(arguments);     
  },
  
  AfterPageSelected: function(myContainer)
  {
    console.log("OuterPage1 - AfterPageSelected");
  },
  
  checkIfAllValid: function(nestedPage)
  {
    // if all data in nested notebook is valid, then its apply button will be enabled
    // update the ToC item for this outer page accordingly (i.e. remove / add the invalid icon)
    var valid = !nestedPage.notebook._applyButton.disabled;
    this.notebook.updateToCItemIcon(this, valid);
    
    // update the outer page buttons as well...
    if (this.outerPage2 == null)
      this.outerPage2 = dijit.getEnclosingWidget(dojo.query(".outerpage2", this.notebook.domNode)[0]);
    if (this.outerPage2.isValid() && valid) {
      this.notebook.enableApplyButton(true);
      this.notebook.enableOKButton(true);
    }
    else if (!this.notebook._applyButton.disabled) {
      this.notebook.enableApplyButton(false);
      this.notebook.enableOKButton(false);
    }
  }
  
});
