dojo.provide("ibm.tivoli.tip.dijit.tests.tivwizard_pages.TestPage2");

dojo.require("ibm.tivoli.tip.dijit.TivPage");

dojo.declare("ibm.tivoli.tip.dijit.tests.tivwizard_pages.TestPage2", [ibm.tivoli.tip.dijit.TivPage], 
{
  templatePath: dojo.moduleUrl("ibm.tivoli.tip.dijit.tests.tivwizard_pages", "templates/testpage2.html"),
  title: "Page 2",
  page9: null,

  postCreate: function()
  {
    console.log("TestPage2.postCreate");

    dojo.connect(this._testRequired, "onclick", this, this.resetRequired);
    dojo.connect(this._testSkipMain, "onclick", this, this.skipMain);
    dojo.connect(this.resetpage9, "onclick", this, this.handleReset);
    dojo.attr(this.resetpage9, "enabled", false);
    dojo.connect(this.markpages, "onclick", this, this.markPagesIncomplete);    
  },
  
  AfterPageSelected: function()
  {
    if (this.page9 == null)
    {
      var nextToLast = dojo.query(".wiz-summary", this.wizard.domNode);
      this.page9 = dijit.getEnclosingWidget(nextToLast[0]);          
    }
    if (!this.page9.isDisabled())
    {
      // if required action has occurred, enable invalidate data button
      this.markpages.disabled = false;
      this.markpageslabel.style.color = "black";
      
      // disable page 9 button
      this.resetpage9.disabled = true;
    }
    else
    {
      // if required action has not occurred, disable invalidate data button
      this.markpages.disabled = true;
      this.markpageslabel.style.color = "gray";
      
      // enable page 9 button
      this.resetpage9.disabled = false;      
    }
    this.wizard.resetFinishLabel("Finish");
  },

  resetRequired: function(event)
  {
    console.log("TestPage2.resetRequired");

    var aPageNode = dojo.query(".page3", this.wizard.domNode);
    var actualPage = dijit.getEnclosingWidget(aPageNode[0]);
    actualPage.setRequired(this._testRequired.checked);
  },
  
  skipMain: function(event)
  {
    console.log("TestPage2.skipMain");

    var aPageNode = dojo.query(".page3", this.wizard.domNode);
    var actualPage = dijit.getEnclosingWidget(aPageNode[0]);
    actualPage.setTitleOnly(this._testSkipMain.checked);
  },
  
  handleReset: function()
  {
    console.log("TestPage2.handleReset");

    this.page9.setDisabled(false);
    this.page9.enableJumpBack();
  },
  
  markPagesIncomplete: function()
  {
    // user has changed selection; ensure subsequent pages are marked as
    // unvisited.  Note: subsequent pages may need to be reset
    this.wizard.unmarkVisitedPages(this);
    
    // reset required action
    this.page9.setDisabled(true);
    this.page9.disableJumpBack();
    this.resetpage9.disabled = false;
    
    // reset check boxes
    this._testRequired.checked = false;
    this._testSkipMain.checked = false;
    this.skipMain(null);
    this.resetRequired(null);
  },
  
  allowNext: function()
  {
    var allow = false;
    if (!this.page9.isDisabled())
      allow = true;
    else
      alert("page 9 not enabled");    
    return allow;
  },
  
  allowMarkAsComplete: function()
  {
    // if required action not performed, do not mark page as complete
    // when jumping back
    return (!this.page9.isDisabled());
  },
  
  reset: function()
  {
    this.page9 = null;    
    this._testRequired.checked = false;
    this._testSkipMain.checked = false;
    this.skipMain(null);
    this.resetRequired(null);
  }
});
