dojo.provide("ibm.tivoli.tip.dijit.themes.ChartThemeGradient1");
dojo.require("dojox.charting.Theme");

(function(){
	var dxc=dojox.charting;
    var dc = dojox.charting, themes = dc.themes, Theme = dc.Theme, g = Theme.generateGradient,
        defaultFill = {type: "linear", space: "shape", x1: 0, y1: 0, x2: 0, y2: 100};
	
	ibm.tivoli.tip.dijit.themes.ChartThemeGradient1Custom = { 
		piestroke: {
			color: "black"
		},
		xlabels: {
			color: "black",
			fontFamily: "Sans Serif",
			size: "12pt", 
			weight: "normal"
		},
		ylabels: {
			color: "black",
			fontFamily: "Sans Serif",
			size: "14pt", 
			weight: "normal"
		},
		legend: {
			textClass: "dojoxLegendTextStandard"
		}
	};
	
	
	ibm.tivoli.tip.dijit.themes.ChartThemeGradient1=new dxc.Theme({
		chart:{
			stroke:null,
			fill: "transparent"
		},
		plotarea:{
			stroke:{ color:"#EDEDED",width:0 },			
			line:{ color:"#EDEDED",width:0 },
			fill: "transparent"
		},
		axis:{
			stroke:{ color:"black",width:1 },			
			line:{ color:"black",width:1 },
			majorTick:{ color:"#BFBFBF", width:1, length:12 },
			minorTick:{ color:"#BFBFBF", width:1, length:8 },
			font:"normal normal normal 10pt San Serif",
			fontColor:"black"
		},
        series: {
            stroke:  {width: 0, color: "#eaf2cb"},
            outline: {width: 0, color: "#ffffff"},
            font: "normal normal normal 8pt Helvetica, Arial, sans-serif",
            fontColor: "#eaf2cb"
        },
        marker: {
            stroke:  {width: 1.25, color: "#eaf2cb"},
            outline: {width: 1.25, color: "#eaf2cb"},
            font: "normal normal normal 8pt Helvetica, Arial, sans-serif",
            fontColor: "#eaf2cb"
        },
        seriesThemes: [
            {fill: g(defaultFill, "#bf9e0a", "#ecc20c")},
            {fill: g(defaultFill, "#73b086", "#95e5af")},   
            {fill: g(defaultFill, "#c7212d", "#ed2835")},   
            {fill: g(defaultFill, "#87ab41", "#b6e557")},   
            {fill: g(defaultFill, "#b86c25", "#d37d2a")}    
        ],
        markerThemes: [
            {fill: "#bf9e0a", stroke: {color: "#ecc20c"}},  
            {fill: "#73b086", stroke: {color: "#95e5af"}},
            {fill: "#c7212d", stroke: {color: "#ed2835"}},  
            {fill: "#87ab41", stroke: {color: "#b6e557"}},  
            {fill: "#b86c25", stroke: {color: "#d37d2a"}}   
        ]
	});
	//Added fix for IBM Dojo 1.5 Migration
	//ibm.tivoli.tip.dijit.themes.ChartThemeGradient1.defineColors(ibm.tivoli.tip.dijit.themes.ChartThemeGradient1.colors);
	
    ibm.tivoli.tip.dijit.themes.ChartThemeGradient1.next = function(elementType, mixin, doPost){
        var isLine = elementType == "line";
        if(isLine || elementType == "area"){
            // custom processing for lines: substitute colors
            var s = this.seriesThemes[this._current % this.seriesThemes.length];
            s.fill.space = "plot";
            if(isLine){
                s.stroke  = { width: 4, color: s.fill.colors[0].color};
            }
            var theme = Theme.prototype.next.apply(this, arguments);
            // cleanup
            delete s.outline;
            delete s.stroke;
            s.fill.space = "shape";
            return theme;
        }
        return Theme.prototype.next.apply(this, arguments);
    };
    
    ibm.tivoli.tip.dijit.themes.ChartThemeGradient1.post = function(theme, elementType){
        theme = Theme.prototype.post.apply(this, arguments);
        if((elementType == "slice" || elementType == "circle") && theme.series.fill && theme.series.fill.type == "radial"){
            theme.series.fill = dojox.gfx.gradutils.reverse(theme.series.fill);
        }
        return theme;
    };
	
})();
