/******************************************************* {COPYRIGHT-TOP-OCO} ***
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2008 All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication, or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************* {COPYRIGHT-END-OCO} ***/
dojo.provide("ibm.tivoli.tip.dojo.TIPHelper");

dojo.declare("ibm.tivoli.tip.dojo.TIPHelper",
	          null,
{
	constructor: function () {
	},
	// childNode must be a node within your portlet
	// padding is the amount of padding you want around your portlet
	//   e.g., "0px"
	setPortletPadding: function (childNode, padding) {
		var node = this.getAncestorByClass (childNode, "isc-portlet-bkg");
		if (node) {
			dojo.style (node, "padding", padding);
	    var nextnode = dojo.query( 'table[id$="_portlet_content"]', node )[0];
        if (nextnode) {
        	dojo.style( nextnode, "padding", padding );
        }
		}
		
	},
	getAncestorByClass: function (element, className) {
		var node = null;
		for(node = element.parentNode; node!= null; node = node.parentNode) {
			if(dojo.hasClass(node, className)) {
				break;
			}
		}
		return node;
	},	
	getAncestorByName: function (element, name) {
		var result=null;
		try {
			while(result===null && element!==null) {
				element=element.parentNode;
				var elementname = element.getAttribute ("name");
				if (elementname == name) {
					result=element;
				}
			}
		} catch(e) {
			//no node
		}
		//console.log ("Nodename = " + result);
		return(result);
	},
	getAncestorByID: function (element, id) {
		var result=null;
		try {
			while(result===null && element!==null) {
				element=element.parentNode;
				var elementid = element.getAttribute ("id");
				if (elementid == id) {
					result=element;
				}
			}
		} catch(e) {
			//no node
		}
		//console.log ("Nodename = " + result);
		return(result);
		
	},
	getPortletModel: function (element) {
		console.log ("looking for IscPortlet, starting with element: ");
		console.log (element);
		var node = this.getAncestorByName (element, "IscPortlet");
		console.log ("found IscPortlet node: ");
		console.log (node);
		var dataObject = null;
		
		if (node) {
			var data = node.getAttribute ("portletdataobject");
			console.log ("data: ");
			console.log (data);
			dataObject = dojo.fromJson (data);
			console.log ("get portlet data: ");
			console.log (dataObject);
			return (dataObject);
		} else {
			return (undefined);
		}
	},
	getFreeformPageModel: function (element) {
		node = this.getAncestorByClass (element, "tip-freeform-page");
		if (node === null) {
			console.error ("pageModel cannot be found. node is null");
			return (undefined);
		} 

		console.log ("node with tip-freeform-page class: ");
		console.log (node);
			
		var dataObject = node.modelObject.pageData;
		if ((dataObject === null) || (dataObject === undefined)) {
			var data = node.getAttribute ("pagedataobject");
			dataObject = dojo.fromJson (data);
		}
		
		console.log ("get portlet data: ");
		console.log (dataObject);
		return (dataObject);
	},
	getPortletOID: function (element) {
		var dataObject = this.getPortletModel (element);
		if (dataObject) {
			var result = dataObject.oid;
			return (result);
		} else { 
			return (undefined);
		}
	},
	getPortletWindowID: function (element) {
		var dataObject = this.getPortletModel (element);
		if (dataObject) {
			var result = dataObject.portletName;
			return (result);
		} else {
			return (undefined);
		}
	},
	getPortletPageID: function (element) {
		console.log("Enter getPortletPageID");
		var parent = this.getAncestorByName (element, "IscPage");
		var data = parent.getAttribute ("pagedataobject");
		var dataObject = dojo.fromJson (data);
		var result = dataObject.uniquePageName;
		return result;
		/*} else {
			dataObject = this.getFreeformPageModel (element);
			var result = dataObject.uniquePageName;
			return (result);
		}*/
	},
	getPortletPageName: function (element) {
		var parent = this.getAncestorByName (element, "IscPage");
		if (parent) {
		    var pageName = parent.getAttribute("aria-label");
			if(pageName)
				return pageName;
			var node = dojo.query ("td.isc-layout-titletext", parent);
			if (node === undefined) {
				node = dojo.query ("div.tip-portlet-titletext", parent);
			}
			
	//		var node = dojo.query ("td.isc-tab-sel-l", frames["taskbar"].document);
			if (node) {
				if (node.length == 1) {
//					var result = node[0].innerHTML.alt;
					var result = node[0].childNodes[0].nodeValue;
					if (result) {
						// strip leading white space
						result = result.replace(/^\s+/,"");
						// strip trailing white space
						result = result.replace(/\s+$/,"");
					}
					console.log ("portlet page name: ");
					console.log (result);
					return (result);
				} else if (node.length === 0) {
					console.log ("could not find node for portlet page name. array length is 0.");
				} else {
					console.log ("found multiple nodes for portlet page names");
					console.log (node);
				}
			} else {
				console.log ("could not find node for portlet page name");
			}
		} else {
			console.log ("no parent node to get portlet page name");
		}
	},
	getTopPortletNodeFreeform: function (element) {
		var node = this.getAncestorByClass (element, "tip-portlet-frame");
		return (node);
	}, 
	getTopPortletNode: function (element) {
		var node = this.getAncestorByName (element, "IscPortlet");
		if (node) {
		} else {
			console.log ("cannot find TopPortletNode with name IscPortlet... looking for tip-portlet-frame class instead... must be freeform page");
			node = this.getTopPortletNodeFreeform (element);
		}
		
		return (node);		
	},
	getPortletTitle: function (element) {
		console.log ("enter getPortletTitle");
		var oid = this.getPortletOID (element);
		if (oid) {
			var node = dojo.byId ("titleText." + oid);
			if (node) {
				return node.innerHTML;
			} else {
				console.log ("cannot find node for title text: titleText." + oid);
			}
		} else {
			console.log ("freeform title search");
			var z = this.getAncestorByClass (element, "tip-portlet-frame");
			if (z) {
				// OMG... what a hack!
				/*
				z = z.childNodes[1];  // tip-portlet-inner
				z = z.childNodes[1];  // tip-portlet-titlebar
				z = z.childNodes[1];  // tip-portlet-titletext
				z = z.childNodes[1];  // h1
				*/
				for(var i=0; i<4 && z.childNodes[1]; i++){
					z = z.childNodes[1];
				}
				if (z.childNodes[0].getAttribute) {  // getAttribute function must exist for it to be an element
					z = z.childNodes[0];  // span
				}

				return z.innerHTML;
			}
		}
		
		return (undefined);
	},
	_setPortletTitleFreeform: function (element, title) {
		console.log ("enter _setPortletTitleFreeform");
		var z = this.getAncestorByClass (element, "tip-portlet-frame");
		if (z) {
			// OMG... what a hack!
			z = z.childNodes[1];  // tip-portlet-inner
			z = z.childNodes[1];  // tip-portlet-titlebar
			z = z.childNodes[1];  // tip-portlet-titletext
			z = z.childNodes[1];  // h1
			if (z.childNodes[0].getAttribute) {  // getAttribute function must exist for it to be an element
				z = z.childNodes[0];  // span
			}
			
			console.log ("found element for title: ");
			console.log (z);
			z.innerHTML = title;
		}
	},
	setPortletTitle: function (element, title) {
		console.log ("enter setPortletTitle: " + title);

		try{
		
		var oid = this.getPortletOID (element);

		if (oid) {
			var node = dojo.byId ("titleText." + oid);
			if (node) {
				node.innerHTML = title;
			} else {
				console.log ("cannot find node for title text: titleText." + oid);
				this._setPortletTitleFreeform (element, title);
			}
		} else {
				var y = this.getAncestorByClass(element, "tip-portlet-inner");
				y.setAttribute ("id", title);
				dojo.query('h1', y).forEach(function(node, index, arr){						
					node.innerHTML = title;					
				});
				/*
				var z = y.childNodes[1];
				z = z.childNodes[1];
				z = z.childNodes[1];
				//z = z.childNodes[1];
				z.innerHTML = title;
				*/
		}

		}
		catch(e){
			console.info("failure="+e);
		}
	}
});
