/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.demo.DemoExplorer");

dojo.require("dijit.layout.ContentPane");
dojo.require ("dijit.layout.BorderContainer");
dojo.require("ibm.tivoli.navmodel.Selection");
dojo.require ("ibm.tivoli.tip.navwidget.demo.DemoTreeView");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidget");
dojo.require("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebook");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("ibm.tivoli.tip.navwidget.dijit.DefaultMessageHandler");

dojo.requireLocalization("ibm.tivoli.tip.navwidget.demo", "resources");

ibm.tivoli.tip.navwidget.demo.DemoExplorer._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.demo.DemoExplorer");

dojo.declare("ibm.tivoli.tip.navwidget.demo.DemoExplorer",
	[dijit.layout.BorderContainer],
	 {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		// _trace: [private] Trace
		//		Utility for trace and logging
		_trace: ibm.tivoli.tip.navwidget.demo.DemoExplorer._trace, 
		
		_treeView: null,
		_navWidget: null,
	
        constructor: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			this._demoResources = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget.demo", "resources");
	        this.title = "Explorer"; //TODO: MRI this._demoResources.NAV_WIDGET_CUSTOM_VIEW1;
        },
        
        postCreate: function() {		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	
        	//Create a dataset for the tree view
        	try {
				dataset = new ibm.tivoli.navmodel.Dataset({
		            baseUrl: "/ibm/tivoli/rest",
		            provider: "DEMO",                	
		            datasource: "",
		            dataset: "DEMO_TREE"
		        });
			} catch (ex) {
				//There was a problem creating the dataset
				var msgHandler = new ibm.tivoli.tip.navwidget.dijit.DefaultMessageHandler({});
				msgHandler.displayException(ex);
			}
        	
        	//Create tree view
        	this._treeView = new ibm.tivoli.tip.navwidget.demo.DemoTreeView({
				id: "myDemoTreeView",
				dataset: dataset,
				style: "width:10%",
				region: "left",
        		splitter: "true"
			});
        	this.addChild(this._treeView);
        	
        	//Set up selection changed listener
			dojo.connect(this._treeView.selection, "onSelectionChanged", dojo.hitch(this, this._treeViewSelectionChangedHandler));

        	//Create BorderContainer for the content border container
        	var contentBorderContainer = new dijit.layout.BorderContainer({region: "center"});
        	
        	//Dataset for nav widget
        	var dataset = null;
			try {
				dataset = new ibm.tivoli.navmodel.Dataset({
		            baseUrl: "/ibm/tivoli/rest",
		            provider: "DEMO",                	
		            datasource: "",
		            dataset: "DEMO",
					parameters: {
		       			demoNodeCount: 20,
		       			demoTopologyNodeCount: 10,
		       			demoTopologyMaxChildrenPerNode: 4,
		       			demoTopologyRandomRelationshipCount: 0,
		       			demoTopologyFireStatusChanged: 0
		   			},
					defaultProperties: []
		        });
			} catch (ex) {
				//There was a problem creating the dataset
				var msgHandler = new ibm.tivoli.tip.navwidget.dijit.DefaultMessageHandler({});
				msgHandler.displayException(ex);
			}

			//Create the properties view
			this._propertiesView = new ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebook({
                id: "myProperties",
                widgetDefinitionId: "SampleNotebookWithCustomTabsAndHorizontalLayout",
                	
                region: "bottom",
                splitter: "true",
                style: "height:35%"
            });
            this._propertiesView.setDataset(dataset);
            contentBorderContainer.addChild(this._propertiesView);
            
			//Create the nav widget -- NOTE: Weird thing... for table to show data, seem it needs to be added last
			this._navWidget = new ibm.tivoli.tip.navwidget.dijit.NavWidget({
				id: "_navWidget",
				homeDataset: dataset,
				widgetDefinitionId: "SampleNavWidgetWithTableStackedNoGridTopo",
				
				region: "center"
			});
			contentBorderContainer.addChild(this._navWidget);
            
            //Add content container to main border container
            this.addChild(contentBorderContainer);

            //Listen for when the rendered dataset changes
			dojo.connect(this._navWidget, "onSetDataset", dojo.hitch(this, this._navWidgetSetDatasetHandler));

			//Listen for selection changes on nav widget
			dojo.connect(this._navWidget.selection, "onSelectionChanged", dojo.hitch(this, this._navWidgetSelectionChangedHandler));
			
			//Listen for when the rendered objects in properties view changes
			dojo.connect(this._propertiesView, "onSetObjects", dojo.hitch(this, this._propertiesViewSetObjectsHandler));
        	
        	this.inherited(arguments);
        },
       
		//Tree view selection changed handler
		_treeViewSelectionChangedHandler: function(objectContext) {
        	//Need to get tasks from selected Item and execute the default nav hint
        	
        	var getTasksComplete = function(tasks) {
        		//Hide busy pane we made visible before retrieving the set of tasks
				this._navWidget.hideBusyPane();
        		
        		//Want to loop through tasks looking for a nav hint...
        		if (tasks) {
	        		for (var i = 0; i < tasks.length; i++) {
	        			var task = tasks[i];
	        			if (task.isNavigation()) {
	        				//Found nav hint (NOTE: Really want to find the *default* nav hint)

	        				
	        				var _processNavNewDataSet = function(dataset) {
	        					this._navWidget.setHomeDataset(dataset);
	        				};
	        				
	        				var _handleNavNewDataSetError = function(error, request) {
	        					this._navWidget.hideBusyPane();
	        					
	        					//Give the user some feedback
	        			        this.displayException(error);
	        				};
	        				
	        				// listen for event indicating new dataset is loaded and dismiss the busy pane
	        				this._handle = dojo.connect(this._navWidget, "onSetDataset", this, function(dataset) {
	        																					this._navWidget.hideBusyPane();
	        																					dojo.disconnect(this._handle);});
	        				this._navWidget.showBusyPane();
	        				this._treeView.dataset.navigate(
	        		   	         {onComplete: dojo.hitch(this, _processNavNewDataSet),
	        		   	         onError: dojo.hitch(this, _handleNavNewDataSetError),
	        		   	         taskId: task.getId(),
	        		   	         taskCategory: task.getCategory(),
	        		   	         selection: this._buildClientNavModelSelection(objectContext, this._treeView.dataset.getVersion())});
	        				
	        				
	        				break;
	        			}
	        		}
        		}
        	};
        	
        	var getTasksError = function(error, request){
				this._navWidget.hideBusyPane();
				
				//Give the user some feedback
		        this.displayException(error);
			};
        	
        	//Retrieve tasks
			this._navWidget.showBusyPane();
        	var dataset = objectContext.getDataset();
        	dataset.getTasks({
    				onComplete: dojo.hitch(this, getTasksComplete),
    				onError: dojo.hitch(this, getTasksError),
    				taskCategory: "menu", //TODO: Could I specifically request nav hints instead of all tasks?
    				selection: this._buildClientNavModelSelection(objectContext, dataset.getVersion())});
		},
		
		//NOTE: _buildClientNavModelSelection is copied from AsynchContextMenu... could be a utility
		_buildClientNavModelSelection: function(objectContext, /*Float*/ version) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// context:
			//		
			// version:
			//		

			if (objectContext) {
				currentSelection = new ibm.tivoli.navmodel.Selection({version: version});
				currentSelection.addItems(objectContext.getItemIds());
				currentSelection.addLinks(objectContext.getLinkIds());
				currentSelection.addRelationships(objectContext.getRelationshipIds());
			}
			return currentSelection;
		},
		
        //handler for dataset is set
		_navWidgetSetDatasetHandler: function(dataset) {
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	// dataset:
        	//		
			if (this._propertiesView) {
				this._propertiesView.setDataset(dataset);
			}
		},
		
		//handler for selection changes
		_navWidgetSelectionChangedHandler: function(objectContext) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// objectContext:
			//		
			if (this._propertiesView) {
				var items = objectContext.getItems();
				var links = objectContext.getLinks();
				var relationships = objectContext.getRelationships();
				this._navWidget.showBusyPane();
				this._propertiesView.setObjects(items, links, relationships);
			}
		},
		
		_propertiesViewSetObjectsHandler: function() {
			this._navWidget.hideBusyPane();
		}
	 });

