/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.demo.DemoScoreboardView");

dojo.require("dojox.collections.Dictionary");
dojo.require("dijit.layout.ContentPane");
dojo.require ("dijit.layout.BorderContainer");
dojo.require("dijit.form.TextBox");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView");

dojo.requireLocalization("ibm.tivoli.tip.navwidget.demo", "resources");

dojo.declare("ibm.tivoli.tip.navwidget.demo.DemoScoreboardView",
	[dijit.layout.BorderContainer, ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView],
	 {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		// _scoreboardTextBox: 
		//		Coming soon
        _scoreboardTextBox: null,
        
        // _statusCounts: 
        //		Coming soon
        _statusCounts: null,
        
        // _DEFAULT_WIDGET_DEF_INFO: Object
        //		Coming soon
        
        //NOTE: Would want an actual ScorecardWidgetDef, but for now just leverage NavWidgetDef
        _DEFAULT_WIDGET_DEF_INFO: {
			className: "ibm.tivoli.navmodel.NavWidgetDef",
			baseUrl: "/ibm/tivoli/rest",
	    	provider: "any",
	    	datasource: "any",
	    	widget: "navwidget",
	    	definition: "SampleScorecard"
		},
      
        constructor: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			this._demoResources = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget.demo", "resources");
	        this.title = "Scoreboard View"; //TODO: MRI this._demoResources.NAV_WIDGET_CUSTOM_VIEW1;
	        
	        this._statusCounts = new dojox.collections.SortedList();
        },
		
		_getDefaultWidgetDefInfo: function(){
			return this._DEFAULT_WIDGET_DEF_INFO;
		},
        
        _createSupportingWidgets: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
        	this._scoreboardTextBox = new dijit.form.TextBox({
        		id: this.id + "_" + "SCOREBOARD_TEXT_BOX", 
        		region: "top"
        	});
			this._scoreboardTextBox.setValue("");
			
        	this.addChild( this._scoreboardTextBox );
		},
		
		_setDatasetCreatePluggableViewsAugmentViewAttributes: function(view, viewDef) {	
			//NOTE: Just to keep simple, let's just set the region on the view to "center"... see _setDatasetCreatePluggableViewsAugmentViewAttributes in NavWidget.js
			//for an example of how to handle more generically.
			view.attr("region", "center");
		},
		
        _setDatasetLoadData: function(dataset){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Callback to get items and links from child datasets
			var gotItems = function(items){
				if (items) {
					for (var index = 0;  index < items.length;  ++index) {
						var item = items[index];
						
						//Get and process the item's statuses
						var statusesArgs = {
								widgetDef: this.widgetDefinition
							};
						var itemStatuses = item.getStatuses(statusesArgs);
						this._updateStatusCount(itemStatuses);
					}
				}
			};
			
			var gotItemsError = function(error, request){
				//Give the user some feedback
		        this.displayException(error);
			};

			//Fetch the items from the dataset
			var args = {
				onComplete: dojo.hitch(this, gotItems),
				onError: dojo.hitch(this, gotItemsError)
			};
			dataset.getItems(args);

        	//Call superclass
        	this.inherited(arguments);
        },
        
        _updateStatusCount: function(itemStatuses) {		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	
        	//TODO: Only going to look at first status for now
	        if (itemStatuses && itemStatuses.length > 0) {
				var status = itemStatuses[0];
				var statusIdentifier = status.getId() + status.getValue();
				
				//See if already exists. If so, increment. If not, add it.
				var statusCountHolder = this._statusCounts.item(statusIdentifier);
				if (statusCountHolder) {
					//TODO: Not quite right since we're not yet subtracting from the count of another status. So, this is really a CUMULATIVE count.
					statusCountHolder.count++;
				} else {
					var newStatusCountHolder 
						= {status: status,
						   count: 1};
					this._statusCounts.add(statusIdentifier, newStatusCountHolder);
				}
			}
	        
	        this._setStatusString();
        },
        
        _setStatusString: function() {		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	var statusString = "";
        	
        	var statusCountIterator = this._statusCounts.getIterator();
        	while (!statusCountIterator.atEnd()) {
    			var statusCountHolder = statusCountIterator.get().value;
    			statusString += statusCountHolder.status.getLabel() + " = " + statusCountHolder.count + ", ";
    		}
        	
        	this._scoreboardTextBox.setValue("CUMULATIVE Status Value Counts:" + statusString);
        },
        
        //Look for status changes. 
        //TODO: To really be right, we should also be handling itemsAdded and itemsRemoved as well.
        _handleItemStatusChangedEvent: function(event) {		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	// event:
        	//		
        	var items = event.getItems();
			if (items) {
				//Loop through items in event
				for (var i = 0; i < items.length; i++) {
					var item = items[i];
					if (item) {
						//convert statuses for this particular item to bridge statuses
						var statusesArgs = {
								widgetDef: this.widgetDefinition
							};
						var itemStatuses = item.getStatuses(statusesArgs);
						this._updateStatusCount(itemStatuses);
					} else {
						if (this._trace.isError()) {
							this._trace.error("Invalid item in the event's items array; item = " + item, "_handleItemStatusChangedEvent");
						}
					}
				}
			}
			
			//Call super
			this.inherited(arguments);
		},
        
        _handleItemsAddedEvent: function(event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event: 
			//		
			
			//TODO: Should be updating status counts when items added
			
			//Call super
			this.inherited(arguments);
		},

		_handleItemsRemovedEvent: function(event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event: 
			//		
			
			//TODO: Should be updating status counts when items removed
			
			//Call super
			this.inherited(arguments);
		}
    });

