dojo.provide("ibm.tivoli.tip.navwidget.demo.DemoTreeView");

dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.Tree");
dojo.require("dijit.tree.ForestStoreModel");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("ibm.tivoli.navmodel.DatasetTreeStore");
dojo.requireLocalization("ibm.tivoli.tip.navwidget.demo", "resources");

dojo.declare("ibm.tivoli.tip.navwidget.demo.DemoTreeView",
	[dijit.layout.BorderContainer, ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView],
{
	_tree: null,
	_store: null,
      
	constructor: function(kwArgs) {
		this._demoResources = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget.demo", "resources");
	    this.title = "Tree View"; //TODO: MRI this._demoResources.NAV_WIDGET_CUSTOM_VIEW1;

        //We don't have a widget def specific to this view, so let's signal to 
        //super class not to try and load any widget defs on our behalf
		this._usesWidgetDefinition = false;
    },
        
    destroy: function() {
		this._store.close();
		this.inherited(arguments);
    },
	
    _setDatasetLoadData: function(dataset){
    	//Destroy old tree
    	if (this._tree) {
    		this.removeChild(this._tree);
    		this._tree.destroyRecursive();
    		this._tree = null;
    	}
    	
    	//Destroy old store
    	if (this._store) {
    		this._store.close();
    		this._store = null;
    	}
    	
    	//Create a new store based on the dataset
    	var storeArgs = {
				dataset: dataset, 
				defaultProperties: dataset.getDefaultProperties(),
				preventLoops: true
			};
		this._store = new ibm.tivoli.navmodel.DatasetTreeStore(storeArgs);
				
		//Create a new tree model
        var treeModel = new dijit.tree.ForestStoreModel({
            store: this._store,
            query: {origins: true},
            deferItemLoadingUntilExpand: true
        });
	        
        //Create the tree
        this._tree  = new dijit.Tree({
	            model: treeModel,
	            showRoot: false,
	            persist: false,
	            _createTreeNode: function(args) {
	                var tnode = new dijit._TreeNode(args);
	                tnode.labelNode.innerHTML = args.label;
	                return tnode;
	            }
	        });
        this.addChild( this._tree );
        
        //Listen for clicks (selection changes)
        dojo.connect(this._tree, "onClick", dojo.hitch(this, this._onClickHandler));
			
    	//Call superclass
    	this.inherited(arguments);
    },
	
	_onClickHandler: function(item) {
    	this._handlingSelectionChangedCallback = true;
		
		if (!this.selection.isChanging()) {
			this.selection.setSelectedItem(item);
		}
		
		this._handlingSelectionChangedCallback = false;
    }
});

