/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.demo.PropertiesNotebookCustomTab2");

dojo.require("dijit.layout.ContentPane");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetObjectPluggableView");

dojo.requireLocalization("ibm.tivoli.tip.navwidget.demo", "resources");

dojo.declare("ibm.tivoli.tip.navwidget.demo.PropertiesNotebookCustomTab2",
	[dijit.layout.ContentPane, ibm.tivoli.tip.navwidget.dijit.NavWidgetObjectPluggableView],
	 {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon

		// _contentDiv: Object
		//		Coming soon
        _contentDiv: null,
      
        constructor: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			this._demoResources = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget.demo", "resources");
		    this.title = this._demoResources.PROPERTIES_NOTEBOOK_CUSTOM_TAB2;
	        
	        //We don't have a widget def specific to this view, so let's signal to 
	        //super class not to try and load any widget defs on our behalf
			this._usesWidgetDefinition = false;
        },

        _setObjectsLoadData: function(/*ibm.tivoli.navmodel.Item[]*/ items, /*ibm.tivoli.navmodel.Link[]*/ links, /*ibm.tivoli.navmodel.Relationship[]*/ relationships){		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	// items:
        	//		
        	// links:
        	//		
        	// relationships:
        	//		
        	if (!this._contentDiv) {
        		//Create out content div
        		this._contentDiv = dojo.doc.createElement("div");
        		this._contentDiv.id = this.id + "_contentDiv";
    			this.attr("content", this._contentDiv);
        	}
        	
        	//Empty the content div
        	this._cleanUpOldDomTree();
        	
        	if (this.dataset) {
	        	//Create some generic content based on the context this tab has been given...
	        	//Title
	        	var titleParagraph = dojo.doc.createElement("p");
	        	titleParagraph.innerHTML = this.title;
				dojo.place(titleParagraph, this._contentDiv);
	        	
	        	//Dataset ids
				var datasetIdParagraph = dojo.doc.createElement("p");
				datasetIdParagraph.innerHTML = "dataset = " + this.dataset.getId();
				dojo.place(datasetIdParagraph, this._contentDiv);
	
				//Item ids
				var itemIds = "";
				if (items) {
					for (var i = 0; i < items.length; i++) {
						itemIds += items[i].getId() + ", ";
					}
				}
				var itemIdsParagraph = dojo.doc.createElement("p");
				itemIdsParagraph.innerHTML = "itemIds = " + itemIds;
				dojo.place(itemIdsParagraph, this._contentDiv);
				
				//Link ids
				var linkIds = "";
				if (links) {
					for (var i = 0; i < links.length; i++) {
						linkIds += links[i].getId() + ", ";
					}
				}
				var linkIdsParagraph = dojo.doc.createElement("p");
				linkIdsParagraph.innerHTML = "linkIds = " + linkIds;
				dojo.place(linkIdsParagraph, this._contentDiv);
				
				//Relationship ids
				var relationshipIds = "";
				if (relationships) {
					for (var i = 0; i < relationships.length; i++) {
						relationshipIds += relationships[i].getId() + ", ";
					}
				}
				var relationshipIdsParagraph = dojo.doc.createElement("p");
				relationshipIdsParagraph.innerHTML = "relationshipIds = " + relationshipIds;
				dojo.place(relationshipIdsParagraph, this._contentDiv);
        	}
        	
        	//Call superclass
        	this.inherited(arguments);
        },
        
        clearObjects: function(){
        	this._cleanUpOldDomTree();
        	
        	//Call super class
        	this.inherited(arguments);
        },
    	
    	_cleanUpOldDomTree: function() {
    		//Empty the content div
        	if (this._contentDiv) {
        		dojo.empty(this._contentDiv);
        	}
        }
    });

