/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * "Restricted Materials of IBM"
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu");
dojo.provide("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenuProvider");
dojo.provide("ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider");

dojo.require("dijit.Menu");
dojo.require("dijit.MenuItem");
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenu"); 
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenuProvider");
dojo.require("ibm.tivoli.tip.dojo.TIPHelper");
dojo.require("ibm.tivoli.navmodel.Trace");

dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

dojo.declare("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu",
        ibm.tivoli.tip.dijit.TIPContextMenu,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	loadingMenuItemID: "LOADING_ID",
	processingLabel: null,
	
	constructor: function(){
        this.processingLabel = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources").PROCESSING;
    },
    
 	_loadMenuItems: function() {
		// summary:
		//		If the menu is currently empty (i.e., just created), return the placeholder
		//		menu item and tell the asynch provider to get the menu items asynchronously,
		//		otherwise, remove the placeholder and ask the provider for the menu items
		//		now that the asynch request has returned the menu items.
		var items = null;
		var contextMenu = this.getMenu();
		if (contextMenu != null) {
			var childItems = contextMenu.getChildren();
			if (childItems.length == 0) {
				items = [{ 
        				"label": this.processingLabel,
        				"iconClass": "tipMenuIcon loadingIcon", 
        				"actionID": this.loadingMenuItemID,
        				"launchType": "NOOP"
        				}];
				this.cmProvider.getMenuItemsAsynch(this._context, dojo.hitch(this, this._menuItemsLoaded));
			}
			else {
				this._removeLoadingItem();
				items = this.cmProvider.getMenuItems(this._context);
			}
		}
		return items;
 	},
 	
 	_menuItemsLoaded: function(/*Boolean*/ success) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
 		// success:
 		//		
 		
		var menu = this.getMenu();
 		if (success) {
 			// repopulate menu
 			this.populateMenu(menu);
 			// the menu is already marked as started, so populateMenu skips these
 			// steps, so do them again here
 			dojo.forEach(menu.getChildren(), function(child){ child.startup(); });
 			menu.startupKeyNavChildren();
 			// The dijit.Menu still remembers the "Loading..." item as focused so reset
 	        menu.focusedChild = null;
 	        menu.focus();
 		}
 	    else {
 	    	// There were either no tasks returned or an error occurred, so dismiss the context menu
 	    	dijit.popup.close(menu);
 	    }
 	},
 	
 	_removeLoadingItem: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
 		var contextMenu = this.getMenu();
	    var childItems = contextMenu.getChildren();
 	    var loadingItem = childItems[0];
 	 	contextMenu.removeChild(loadingItem);
 	 	loadingItem.destroy();
 	}
	
	
});

dojo.declare("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenuProvider",
        ibm.tivoli.tip.dijit.TIPContextMenuProvider,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	getMenuItemsAsynch: function(context, itemsLoadedCallback, /*String?*/ category) { 
		// summary:
		//		Callback that should be overloaded to make the asynch request for the menu
		//		items and that calls the callback when the asynch request is complete.
		//		The optional category parameter can override the default category of "menu"
		//		for the asynch request.
	
		/*required overload*/ 
	}
	
});

ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider");
dojo.declare("ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider",
        ibm.tivoli.tip.navwidget.dijit.AsynchContextMenuProvider,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon

	// navigateTopic: "NavigateDataset",
	
	// _tasks:
	//		tasks retrieved from REST service
	_tasks: null,
	
	// _serverTasks:
	//		tasks on the menu that need to call back to server when clicked
	_serverTasks: null,
	
	// _tasksLoadedCallback:
	//		notification callback for when tasks are loaded
	_tasksLoadedCallback: null,
	
	 // _NOPORTLETNAMESPACE:
	 //     constant used as a flag for this.iscPortletNamespace if one is not provided and one cannot be found
	 //     Note that this string is not translated
	_NOPORTLETNAMESPACE: "NO_PORTLET_NAMESPACE",

	 // _NOPORTLETINSTANCEID:
	 //     constant used as a flag for this.iscPortletInstanceID if one is not provided and one cannot be found
	 //     Note that this string is not translated
	_NOPORTLETINSTANCEID: "NO_PORTLET_INSTANCE_ID",  // 252065
	
	// view: [public] ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView
	//			The view that owns this provider. Must be passed in as an argument when this provider is created.
	view: null, 

	// _trace: [private] ibm.tivoli.navmodel.Trace
	//			Utility for trace and logging
	_trace: ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider._trace,

	buildClientNavModelSelection: function(context, /*Float*/ version) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// context:
		//		
		// version:
		//		
		var currentSelection = null;
		var selectedThings = ("selection" in context) ? context.selection : null;
		if (selectedThings) {
			currentSelection = new ibm.tivoli.navmodel.Selection({version: version});
			currentSelection.addItems(selectedThings.getItemIds());
			currentSelection.addLinks(selectedThings.getLinkIds());
			currentSelection.addRelationships(selectedThings.getRelationshipIds());
		}
		return currentSelection;
	},
	
	getMenuItemsAsynch: function(context, itemsLoadedCallback, category) {
		if (context.dataset) { //251075
			if (!this.iscPortletNamespace && context.domNode) {
				this.setPortletNamespace(context.domNode);
			}			
			
			var requestCategory = "menu";
			if (itemsLoadedCallback != null) {
				this._tasksLoadedCallback = itemsLoadedCallback;
			}
			if (category && (category != null) && (typeof category == "string" )) {
				requestCategory = category;
			}
			requestCategory = this.augmentRequestCategory(requestCategory);
			
			//if (selectedItemIds.length > 0) {
	    		context.dataset.getTasks(
	    				{onComplete: dojo.hitch(this, this._processMenuItemTasks),
	    				onError: dojo.hitch(this, this._handleMenuItemTasksError),
	    				taskCategory: requestCategory,
	    				selection: this.buildClientNavModelSelection(context, context.dataset.getVersion())});
	    	//}
		} else { 
			//Should still invoke the callback (and for consistency should be on different thread)
			if (itemsLoadedCallback != null) {
				setTimeout(dojo.hitch(this, itemsLoadedCallback), 0);
			}
		}
	},
	
	augmentRequestCategory: function(/*String*/ category) {
		// summary:
		//		Return the category to use for getMenuItemsAsynch( )
		// description:
		//		This implementation does not modify the category that is passed in.
		//      Subclasses may choose to provide additional logic by overriding this function.
		// category:
		//		
		return category;
	},
	
	getMenuItems: function(context) 
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// context:
		//		
		if (this._tasks != null) {
			this.menus_ = this.tasksAsMenuJson(this._tasks);
			this._tasks = null;  // tasks processed for menu, so get rid of them
		} else {
			this.menus_ = "";
		}
		if (this.getMenuItemsCallback !== null) {
			var moreItems = this.getMenuItemsCallback(context);
	         // Check added items and set defaults for isServer and isResolved if not already set
	         dojo.forEach(moreItems, function(item) {
	            if (!("isServer" in item)) {
	               item.isServer = false;
	            }
	            if (!("isResolved" in item)) {
	               item.isResolved = true;
	            }
	         });
			this.menus_ = this.menus_.concat(moreItems);
		}

		return this.menus_;
	},
	
	// override to add selection to the result if it is a navigation or server task
	getMenuCommand: function (commandName, context, menuItem) 
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// commandName:
		//		
		// context:
		//		
		// menuItem:
		//		
	   var result = null;
	   if (this.getMenuCommandCallback !== null) 
	   {
	      result = this.getMenuCommandCallback(commandName, context, menuItem);
	   }
	   else
	   {
	      result = this.getItem(commandName);
	   }
	   if ((result !== null) && ("isServer" in result) && result.isServer) {			   
		   result.selection = context.selection;
	   }
	   else if ((result !== null) && ("isResolved" in result) && !result.isResolved) {
		   result.selection = context.selection;
	   }
 
	   this.handleMenuAction(result);
	},	
	
	// override to handle navigation, server tasks, and 2-phase resolution tasks
	handleMenuAction: function(data, ioArgs) 
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// data:
		//		
		// ioArgs:
		//		
	    if (data.type == "navigation") {
	    	this.handleNavigation(data, ioArgs);
	    }
	    else if (data.isServer) {
	    	this.handleExecuteOnServer(data, ioArgs);
	    }
	    // check if the action has parameters that need to be resolved (e.g., CMS action)
	    else if (("isResolved" in data) && !(data.isResolved)) {  
	    	this.resolveTaskParms(data, ioArgs);
	        this._formatLaunchParms(data); // 251855
	    	this.inherited(arguments);
	    }
	    else {
	    	this._formatLaunchParms(data); // 251855
	    	this.inherited(arguments);
	    }
	}, 
	
	handleNavigation: function(/*Object*/ data, ioArgs) {
		// summary:
		//		Function that should be overloaded to handle a navigation task.  If it
		//		is not overloaded, then this action is a NOOP.
		// data:
		//		Contains the key attributes of the task plus selection (the selection
		//		object from the context containing tagged arrays of IDs for
		//		itemIds, linkIds, relationshipIds)
		// ioArgs:
		//		
	},
	
	handleExecuteOnServer: function(data, ioArgs) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// data:
		//		
		// ioArgs:
		//		
		var id = data.actionID;
		
		// Check if a specific server task has been passed in with the ioArgs, if so, use it
		var matchTasks = [];
		if (ioArgs && ("task" in ioArgs) && (ioArgs.task != null) && (ioArgs.task.getType() != "navigation") && ioArgs.task.isServer()) {
			matchTasks.push(ioArgs.task);
		} else {
			matchTasks = dojo.filter(this._serverTasks, function(x) {return x.getId() == id;});			
		}
		if (matchTasks.length > 0) {
			matchTasks[0].execute({onError: dojo.hitch(this, this._handleExecuteOnServerError),
									selection: this.buildClientNavModelSelection(data, matchTasks[0].getVersion())
				});
		}
	},
	
	resolveTaskParms: function(data, ioArgs) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// data:
		//		
		// ioArgs:
		//		
		var id = data.actionID;
		
		// Check if a specific unresolved task has been passed in with the ioArgs, if so, use it
		var matchTasks = [];
		if (ioArgs && ("task" in ioArgs) && (ioArgs.task != null) && !(ioArgs.task.isResolved())) {
			matchTasks.push(ioArgs.task);
		} else {
			matchTasks = dojo.filter(this._serverTasks, function(x) {return x.getId() == id;});
		}
		if (matchTasks.length > 0) {
			matchTasks[0].resolve({selection: this.buildClientNavModelSelection(data, matchTasks[0].getVersion())});
		}
		data.isResolved = matchTasks[0].isResolved();
		// Fill in values and parameters that have been resolved
		if (matchTasks[0].isUrlLaunch()) {
			data.uri = matchTasks[0].getLaunchUrl();
		} else if (matchTasks[0].isPageLaunch()) {
			data.portletPageID = matchTasks[0].getLaunchPageId();
			data.parameters = matchTasks[0].getLaunchApplicationParms();
		} else if (matchTasks[0].isPortletLaunch()) {
			data.portletName = matchTasks[0].getLaunchPortletName();
			data.portletAppUID = matchTasks[0].getLaunchPortletAppUID();
			data.parameters = matchTasks[0].getLaunchApplicationParms();
		} else if (matchTasks[0].isClientEvent()) {
			data.event = matchTasks[0].getLaunchEvent();
			data.parameters = matchTasks[0].getLaunchApplicationParms();
		} else if (matchTasks[0].isJavascript()) {            // 254268
    		data.uri = matchTasks[0].getLaunchJavascript();
		}
	},
		
	filterTasks: function(/*ibm.tivoli.navmodel.Task[]*/ tasks) {
		// summary:
		//		Return a filtered collection of the tasks passed in
		// description:
		//		This implementation returns the collection of tasks unfiltered.
		//      Subclasses may choose to provide additional filtering.
		// tasks:
		
		return tasks;
	},

	filterNavigationTasks: function(/*ibm.tivoli.navmodel.Task[]*/ tasks) {
		// summary:
		//		Return a filtered collection of tasks (i.e. remove all navigation tasks)
		// description:
		//		This implementation removes all navigation tasks.
		//      	Subclasses may choose to override the removal of navigation tasks
		// tasks:
		
		if (tasks) {
			var length = tasks.length;
			for (var index = 0;  index < length;  ++index) {
				var remove = false;
				var task = tasks[index];

				if (task.isNavigation()) { 					
					remove = true;
				}
				else if (task.isCascade()) {
					var childTasks = task.getChildTasks();
					this.filterNavigationTasks(childTasks);
					childTasks = task.getChildTasks();
					if (!childTasks || childTasks.length === 0) {
						remove = true;
					}
				}

				if (remove) {
					tasks.splice(index, 1);
					--index;
					--length;
				}
			}
		}

		return tasks;
	},
	
	_processMenuItemTasks: function(/*ibm.tivoli.navmodel.Task[]*/ tasks, kwArgs) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// tasks:
		//		
		// kwArgs:
		//		
		
		this._tasks = (tasks.length > 0) ? tasks : [];
		this._tasks = this.filterTasks(this._tasks);
		this._tasks = this.filterNavigationTasks(this._tasks);
		this._serverTasks = this._getServerTasks(this._tasks);
		if (this._tasksLoadedCallback != null) {
			// report success only if any tasks were returned
			this._tasksLoadedCallback(this._tasks !== null);
		}
	},
	
	_handleMenuItemTasksError: function(error, exception, ioArgs) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// error:
		//		
		// exception:
		//		
		// ioArgs:
		//		
		this._tasks = null;
		this._serverTasks = null;
		// log error here
		if (this._trace.isError()) {
			this._trace.error(">>> query menu tasks error = " + error, "_handleMenuItemTasksError");
		}
		if (this._tasksLoadedCallback != null) {
			this._tasksLoadedCallback(false);
		}

		//Give the user some feedback
		if (this.view) {
			this.view.displayException(error);
		}
	},
	
	_handleExecuteOnServerError: function(error, exception, ioArgs) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// error:
		//		
		// exception:
		//		
		// ioArgs:
		//		

		if (this._trace.isError()) {
			this._trace.error(">>> error executing server task = " + error, "_handleExecuteOnServerError");
		}
		
		//Give the user some feedback
		if (this.view) {
			this.view.displayException(error);
		}
	},
	
	// cache tasks that are to execute on server or require parameter resolution
	_getServerTasks: function(tasks) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// tasks:
		//		
		var serverTasks = [];
		var subMenuTasks = null;
		for (var i = 0; i < tasks.length; i++) {
			if (tasks[i].isServer() || !(tasks[i].isResolved())) {
				serverTasks.push(tasks[i]);
			}
			else if (tasks[i].isCascade) {
				subMenuTasks = tasks[i].getChildTasks();
				if (subMenuTasks) {
					var moreTasks = this._getServerTasks(subMenuTasks);
					for (var j = 0; j < moreTasks.length; j++) {
						serverTasks.push(moreTasks[j]);
					}
				}
			}
		}
		return serverTasks;
	},
	
	_formatLaunchParms: function(/* Object or Array */ data) {  // 251855
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// data:
		//
		if (data.parameters && !(data.parameters instanceof Array)) {
			var mappedParms = [];
			var parm;
			for (var key in data.parameters) {
				parm = {};
				parm.name = key;
				parm.value = data.parameters[key];
				mappedParms.push(parm);
			}
			if (mappedParms.length > 0) {
				data.parameters = mappedParms;
			}
		}
	},

	
	setPortletNamespace: function(/* Element */ element) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// tasks:
		//
		
		var tipHelper = new ibm.tivoli.tip.dojo.TIPHelper();
		// Add functions to this TIPHelper instance to lookup the portlet namespace
		// and whether this is an iWidget
		// (These may be contributed back to TIPHelper itself)
		dojo.safeMixin(tipHelper, {
			getPortletNamespace: function (element) {
				var node = this.getAncestorByName (element, "IscPortlet");
				if (!node) {  // 254337
					// Could be on a freeform page in TIP
					node = this.getAncestorByClass(element, "tip-portlet");
				}
				if (node) {
					var result = node.modelObject.portletData.namespace;
					return (result);
				}
			},
			getPortletInstanceID: function (element) {   // 252065
				var node = this.getAncestorByName (element, "IscPortlet");
				if (!node) {  // 254337
					// Could be on a freeform page in TIP
					node = this.getAncestorByClass(element, "tip-portlet");
				}
				if (node) {
					var result = node.modelObject.portletData.oid;
					return (result);
				}				
			},
			isiWidget: function (element) {     // 252065
				var node = this.getAncestorByName (element, "IscPortlet");
				if (!node) {  // 254337
					// Could be on a freeform page in TIP
					node = this.getAncestorByClass(element, "tip-portlet");
				}
				var result = false;
				if (node && ("iwidget" in node.modelObject.portletData)) {
					// Coerce the string value of the iwidget flag to a boolean
					result = (String(node.modelObject.portletData.iwidget) == "true");
				}
				return (result);
			}
		});
		
		// 252065  - various changes below for the rest of this function
		var frameElem = null;
		var namespace = tipHelper.getPortletNamespace(element);
		var portletInstanceID = tipHelper.getPortletInstanceID(element);
		var isiwidget = tipHelper.isiWidget(element);
		// No namespace so we may be inside an IFRAME
		if (!namespace) {
			frameElem = dojo.window.get(dojo.body().ownerDocument).frameElement;			
		}
		// Make sure something is set for namespace
		if (!namespace ) {
			if (frameElem && frameElem.tagName && frameElem.tagName.toLowerCase() == "iframe") {
				namespace = tipHelper.getPortletNamespace(frameElem);
			}
		}
		if (!namespace) {
			namespace = this._NOPORTLETNAMESPACE;
		}
		// Make sure something is set for portlet instance ID
		if (!portletInstanceID) {
			if (frameElem && frameElem.tagName && frameElem.tagName.toLowerCase() == "iframe") {
				porletInstanceID = tipHelper.getPortletInstanceID(frameElem);
			}			
		}
		if (!portletInstanceID) {
			portletInstanceID = this._NOPORTLETINSTANCEID;
		}
		// Check if we had to look in an IFRAME for whether we are an iWidget
		if (frameElem && !isiwidget) {
			if (frameElem.tagName && frameElem.tagName.toLowerCase() == "iframe") {
				isiwidget = tipHelper.isiWidget(frameElem);
			}						
		}
		
		this.is_iWidget = isiwidget;
		this.iscPortletNamespace = namespace;
		this.iscPortletInstanceID = portletInstanceID;
	},
	
	createIconClass: function(/*String*/ id, /*String*/ image) { 
		// summary:
		//		Creates an iconClass on the fly to accommodate provider URLs
		// description:
		//		Creates an iconClass on the fly to accommodate provider URLs
		// id:
		//		Unique identifier for the icon class
		// image:
		//		Image name and path
		var style = dojo.doc.createElement("style");
		dojo.attr(style, "type", "text/css");
		dojo.attr(style, "id", id);

		var iconClassContents = "." + id + " { background-image: url("+image+"); width: 22px; height: 22px; display: block; background-repeat: no-repeat; vertical-align: middle;}";
		// IE handles innerHTML differently
		if (dojo.isIE) {
			style.styleSheet.cssText = iconClassContents;
		} else {
			style.innerHTML = iconClassContents;
		}
		var head = dojo.doc.getElementsByTagName("head")[0];   
            head.appendChild(style);
	},

	tasksAsMenuJson: function(/*ibm.tivoli.navmodel.Task[]*/ tasks) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// tasks:
		//		
		
		// convert tasks to TIPContextMenu Json format
		var menuItems = [];
		var subMenu = null;
		var iconClass = "";
		for (var i = 0; i < tasks.length; i++) {
			if (dojo.doc.getElementById(ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.replaceSpecialChars('_',tasks[i].getId())) && 
				tasks[i].getCategory() != "toolbar") {
				iconClass = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.replaceSpecialChars('_',tasks[i].getId());
			} else if (tasks[i].getCategory() == "menu" && tasks[i].getImage() != undefined) {
				this.createIconClass(ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.replaceSpecialChars('_',tasks[i].getId()), ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.cleanUpImagePath(tasks[i].getImage()));
				iconClass = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.replaceSpecialChars('_',tasks[i].getId());
			} 
		    if (tasks[i].isSeparator()) {
		    	menuItems.push( { "actionID":"_separator_" });
	    	} 
	    	else if (tasks[i].isCascade()) {
	    		subMenu = this._getSubMenuTasksAsMenuJson(tasks[i]);
	    		menuItems.push({
	    						"label":tasks[i].getLabel(),
	    						"iconClass":iconClass,
	    						"submenu_items":subMenu
	    						});
	    	}
	    	else {
	    		menuItems.push({
	    							"label":tasks[i].getLabel(),
	    						      "iconClass":iconClass,
	    							"actionID":tasks[i].getId(),
	    							"disabled":!(tasks[i].isEnabled()),
	    							"category":tasks[i].getCategory(),
	    							"type":tasks[i].getType(),
	    							"isServer":tasks[i].isServer(),
	    							"isResolved":tasks[i].isResolved()
	    						});
	    		var thisItem = menuItems[menuItems.length - 1];
	    		if (tasks[i].isUrlLaunch()) {
	    			thisItem.launchType = "WEB_URL";
	    			thisItem.uri = tasks[i].getLaunchUrl();
	    		} else if (tasks[i].isPageLaunch()) {
	    			thisItem.launchType = "PORTAL_PAGE";
	    			thisItem.portletPageID = tasks[i].getLaunchPageId();
	    			thisItem.parameters = tasks[i].getLaunchApplicationParms();
	    		} else if (tasks[i].isPortletLaunch()) {
	    			thisItem.launchType = "PORTLET";
	    			thisItem.portletName = tasks[i].getLaunchPortletName();
	    			thisItem.portletAppUID = tasks[i].getLaunchPortletAppUID();
	    			thisItem.parameters = tasks[i].getLaunchApplicationParms();
	    		} else if (tasks[i].isClientEvent()) {
	    			thisItem.launchType = "CLIENT_EVENT";
	    			thisItem.event = tasks[i].getLaunchEvent();
	    			thisItem.parameters = tasks[i].getLaunchApplicationParms();
	    		} else if (tasks[i].isJavascript()) {
	    			thisItem.launchType = "JavaScript";
	    			thisItem.uri = tasks[i].getLaunchJavascript();
	    		}
	    	}
	    }
		return menuItems;
	},
	
	_getSubMenuTasksAsMenuJson: function(/*ibm.tivoli.navmodel.Task*/ task) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// task:
		//		
		
		// process submenu tasks
		var menuItems = [];
		var childTasks = task.getChildTasks();
		if (childTasks != null) {
			menuItems = this.tasksAsMenuJson(childTasks);
		}
		return menuItems;
	}

});
