/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip");

dojo.require("dijit.Tooltip");

dojo.declare("ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip",dijit.Tooltip,
{
	// summary:
	//		A tooltip that allows specification of a callback to provide custom
	//      content for the tooltip at the time the tooltip is shown.
	//      This widget extends dijit.Tooltip.
	// description:
	//		Coming soon
	
	// getCustomContentCallback: function(target)
	//		Callback function that is called just before the tooltip is displayed
	//      to supply custom content.  If provided, this callback should return
	//      either 
	//          - a string of valid HTML text
	//          - a DOM node or page fragment
	//          - a dijit._Widget
	getCustomContentCallback: null,
	
	// position: String[]
	//		defaultPosition: ["above"],
	position: ["below","above"],
	
	// _openInProcess: Boolean
	//		
	_openInProcess: false,
	
	// _pendingNewContent:
	//		
	_pendingNewContent: null,
	
	constructor: function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		// Placeholder in case we need something here later
	},

	isOpening: function() {
		// summary:
		//		Answers true while tooltip is in the process of being displayed
		//		and false once the tooltip is visible
		// description:
		//		Coming soon
		return this._openInProcess;	
	},

	isVisible: function() {
		// summary:
		//		Answers true if the tooltip is currently displayed
		// description:
		//		Coming soon
		return (!this._connectNode) ? false : true;
	},
	
	// Tooltip is now visible, so open process is done
	onShow: function(/*DomNode*/ target, position){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// target:
		//		
		// position:
		//		
		this._openInProcess = false;
		if (this._pendingNewContent) {
			this._putContentInLabel(this._pendingNewContent);
			this._pendingNewContent = null;
			this._replaceDisplayedTootipContents();
		}
		this.inherited(arguments);
	},
	
	// Override open(target) to allow the callback to supply custom content
	open: function(/*DomNode*/ target){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this._openInProcess = true;
		if (this.getCustomContentCallback && (typeof this.getCustomContentCallback == "function")) {
			var content = this.getCustomContentCallback(target);
			this._putContentInLabel(content);
		}
		// Now that the content is set, let parent display the tooltip
		this.inherited(arguments);
	},

	updateContent: function(/*DomNode|widget|String*/ content, target) {
		// summary:
		//		Use this function to update the content of this tooltip when it is displayed
		//		or about to be displayed.
		// description:
		//		Coming soon
		
		// Is the tooltip currently showing or waiting on the timer to show?
		if ((this.isVisible() || this._showTimer) && (this.isOpening() == false)) {
			this._putContentInLabel(content);
			this.unHover(target);	
			this.hover(target);
		} else if (this.isOpening()) {
			this._pendingNewContent = content;
		}
	},
	
	_putContentInLabel: function(/*DomNode|widget|String*/ content) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		if (content) {
			if (typeof content == "string") { // string
				this.label = content;
			} else if (content.domNode) { // widget
				this.label = content.domNode.innerHTML;
			} else if (content.innerHTML) { // domNode, page fragment
				this.label = content.innerHTML;
			} else { // not sure, but convert to string to be safe
				this.label = content.toString();
			}
		}
	},
	
	_replaceDisplayedTootipContents: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		dijit._masterTT.containerNode.innerHTML = this.label;
		// Firefox bug. when innerHTML changes to be shorter than previous
		// one, the node size will not be updated until it moves.
		dijit._masterTT.domNode.style.top = (dijit._masterTT.domNode.offsetTop + 1) + "px";		
	}
	
});