/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.dijit.NavWidget");
dojo.provide("ibm.tivoli.tip.navwidget.dijit.NavWidgetMenuProvider");

dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");
dojo.require("dijit.Toolbar");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.StackContainer");
dojo.require("ibm.tivoli.tip.dijit.BreadcrumbBar");
dojo.require("ibm.tivoli.tip.dijit.Breadcrumb");
dojo.require("ibm.tivoli.tip.dijit.BreadcrumbSeparator");

dojo.require("ibm.tivoli.navmodel.NavWidgetDef");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper");
dojo.require("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetState");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("dojox.collections.Dictionary");
dojo.require("ibm.tivoli.tip.navwidget.dojo.Timer");
ibm.tivoli.tip.navwidget.dijit.NavWidget._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.dijit.NavWidget");


dojo.declare ("ibm.tivoli.tip.navwidget.dijit.NavWidget",
	[dijit.layout.BorderContainer, ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView],
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		//***************************
		// "Public"
		//***************************
		
		// homeDataset:
		//		Home dataset
		homeDataset: null, 

		// cmProvider:
		//		Custom context menu provider (must be provided on construction to be used)
		cmProvider: null,	
		
		// daHelper:
		//		
		daHelper: null,
		
		// includeBreadcrumbs: Boolean
		//		
		includeBreadcrumbs: true,
		
		gutters: false,
		
		//***************************
		// "Private"
		//***************************
		
		// _navWidgetStateStack: [private]
		//		A stack of datasets
		_navWidgetStateStack: null,

		// _breadcrumbBar: [private]
		//		
		_breadcrumbBar: null,
		
		// _centerContainer: [private]
		//		
		_centerContainer: null,

		// _trace: [private] Trace
		//		Utility for trace and logging
		_trace: ibm.tivoli.tip.navwidget.dijit.NavWidget._trace, 
				
		// _constants: [private const] Object
		//		
		_constants: 
			{
				DEFAULT_WIDGET_DEF_INFO: {
					className: "ibm.tivoli.navmodel.NavWidgetDef",
					baseUrl: "/ibm/tivoli/rest",
			    	provider: "any",
			    	datasource: "any",
			    	widget: "navwidget",
	            	definition: "DefaultNavWidget"
				}
			},

		constructor: function () {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
								
			this._navWidgetStateStack = [];
		},
		
		destroy: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Destroy all of the dataset's on the dataset stack
			this._clearStateStack(true);

			//Call superclass
			this.inherited(arguments);		
		},
		
		_changeEventListeners: [],
		
		_dispatchChangeEvent: function (viewId) {
			for (var i = 0; i < this._changeEventListeners.length; i++) {
				var listener = this._changeEventListeners[i];
				if (listener.handle) {
					listener.handle(viewId);
				}
			}
		},
		
		addChangeEventListener: function (listener) {
			// listener should be an object with handle(viewId) method
			this._changeEventListeners.push(listener);
		},
		
		_clearStateStack: function(inDestroy){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Destroy all of the state on the state stack
			for (var i = this._navWidgetStateStack.length; i > 0; i--) {
				this._removeLastState(inDestroy);
			}		
		},

		postCreate: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Call superclass
			this.inherited(arguments);
		},
		
		startup: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_createCMProvider: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Create the menu provider that we'll pass off to the pluggable views
			if (!this.cmProvider) {
				var helper = new ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper();
				this.cmProvider = new ibm.tivoli.tip.navwidget.dijit.NavWidgetMenuProvider({
	                				view: this,
	                				getMenuItemsCallback: dojo.hitch(helper, helper.getMenuItems),
	                				getMenuCommandCallback: dojo.hitch(helper, helper.getMenuCommand)
				});
			}
			
			this.inherited(arguments);
		},
		
		_createSupportingWidgets: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		protected
			
			//Create the breadcrumbs
			if (this.includeBreadcrumbs) {
				this._createBreadcrumbBar();
				//Add breadcrumbs to the container
				this.addChild( this._breadcrumbBar );
			}
		},
		
		_setDatasetCreatePluggableViewsAugmentViewAttributes: function(view, viewDef) {	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		protected
			
			if (this.widgetDefinition) {
				var viewsLayout = this.widgetDefinition.getViewsLayout();
				if (!viewsLayout) {  //We'll assume "border" is the default if viewsLayout is undefined
					view.attr("region", "center");
				} else if (viewsLayout == "border") {
					if (viewDef.layoutStyle) {
						//region
						if (viewDef.layoutStyle.region) {
							view.attr("region", viewDef.layoutStyle.region);
						} else {
							view.attr("region", "center");
						}
						//splitter
						if (viewDef.layoutStyle.splitter) {
							view.attr("splitter", viewDef.layoutStyle.splitter);
						}
						//height
						if (viewDef.layoutStyle.height) {
							view._setStyleAttr({height: viewDef.layoutStyle.height});
						}
						//width
						if (viewDef.layoutStyle.width) {
							view._setStyleAttr({width: viewDef.layoutStyle.width});
						}
					};
				} else { //Stack
					view._setStyleAttr({height: "100%", width: "100%"});
				}
			}
		},
		
		_addPluggableViewToContainer: function(view) {
			if (!this._centerContainer) {
				//Create a BorderContainer or StackContainer for the center region, depending on the viewsLayout
				var viewsLayout = this.widgetDefinition ? this.widgetDefinition.getViewsLayout() : "border"; //We'll assume "border" is the default if viewsLayout is undefined
				var centerContainerArgs = {
						id: this.id + "_centerContainer",
						region: "center",
						gutters: false
						//style: "height:100%;width:100%" //Remove per 250692
				};
				if (viewsLayout == "border") {  
					this._centerContainer = new dijit.layout.BorderContainer(centerContainerArgs);
				} else {
					this._centerContainer = new dijit.layout.StackContainer(centerContainerArgs);
				}
				this.addChild(this._centerContainer);	
			}
			this._centerContainer.addChild(view);

		},
		
		_removePluggableViewFromContainer: function(view) {
			if (this._centerContainer) {
				this._centerContainer.removeChild(view);
			}
		},
		
		makePluggableViewVisible: function(viewId) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			
			this._dispatchChangeEvent(viewId);
			
			if (this._centerContainer && this._centerContainer.isInstanceOf(dijit.layout.StackContainer)) {
				var pluggableView = this.getPluggableView(viewId);
				if (pluggableView) { //Make sure pluggable view exists
					var dataset = this.getCurrentDataset();
					if (pluggableView.isApplicable(dataset)) {
						this._centerContainer.selectChild(this.id + "_" + viewId);
					} else {
						if (this._trace.isError()) {
							this._trace.error("View is not applicable for dataset; viewId = " + viewId, "makePluggableViewVisible");
						}
					}
				} else {
					if (this._trace.isError()) {
						this._trace.error("Cannot find pluggable view; viewId = " + viewId, "makePluggableViewVisible");
					}
				}
			} else {
				this.inherited(arguments);
			}
		},
		
		getVisiblePluggableView: function(viewId) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// viewId:
			//		
			
			if (this._centerContainer && this._centerContainer.isInstanceOf(dijit.layout.StackContainer)) {
				this._centerContainer.selectedChildWidget;
			} else {
				return this.inherited(arguments);
			}
		},
		
		_initializeWithDataset: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		protected
			
			//Initialize the home dataset
			if (this.homeDataset || this.initializeWithNullDataset) {
				this.setHomeDataset(this.homeDataset);
			}
			
			//Special case for nav widget, don't call superclass
			//this.inherited(arguments);
		},
		
		//***************************
		// "Public"
		//***************************
		setDataset: function(dataset, datasetWidgetDefinition) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// dataset:
			//		
			
			if (this._navWidgetStateStack.length == 1) {
				this.setHomeDataset(dataset, datasetWidgetDefinition);
			} else { 
				this._addOrNavigateHelper(dataset, datasetWidgetDefinition, true, true);
			}
		},
		
		setHomeDataset: function(dataset, datasetWidgetDefinition) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// dataset:
			//		

			//Clear out the state stack
			this._clearStateStack();
			
			//Store ref to home dataset and add to stack
			this.homeDataset = dataset;
			this.addDataset(this.homeDataset, datasetWidgetDefinition);
		},
		
		addDataset: function(dataset, datasetWidgetDefinition){	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// dataset:
			//

			//Let's do some timing
			if (this._trace.isFinest()) {
				//Start a timer to see how long it takes
				var addDatasetTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
				addDatasetTimer.start();
			
				//Set up callback that will hide the busy pane
		    	this._handle = dojo.connect(this, "onSetDataset", this, function(dataset) {
		    		this._trace.finest("addDataset took ; " + addDatasetTimer.stopAndGetTraceString(), "addDataset");
					dojo.disconnect(this._handle);});
			}
			
			//Kick off the adding of the dataset
			this._addOrNavigateHelper(dataset, datasetWidgetDefinition, false, true);
		},
		
		_addOrNavigateHelper: function(dataset, datasetWidgetDefinition, removeLastState, createNewState){	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// dataset:
			//

			//I want to basically do what setDataset in superclass does, but need to consider a couple of 
			//special cases related to whether we need to remove the last state or create a new state
			this._setDatasetCleanUpAfterLastDataset(removeLastState, createNewState);
			this._setDatasetInit(dataset);
			this._setDatasetSetWidgetDefs(dataset, datasetWidgetDefinition);
			this._setDatasetCreatePluggableViews();
			this._setDatasetProcessWidgetDefs(dataset);
			this._setDatasetLoadData(dataset, removeLastState, createNewState);
		},
		
		_setDatasetCleanUpAfterLastDataset: function(removeLastState, createNewState) {
			if (!removeLastState && createNewState) { //Really only need to save the previous view state if we're going to be creating a new state
				var oldState = this._getCurrentNavWidgetState();
				if (oldState) {
					//Tuck away some information we'll want to restore if we come back to this state
					oldState.selectedItems = this.selection.getItems();
					oldState.selectedLinks = this.selection.getLinks();
					
					//Get states from all the views, so that we can restore them if user comes back
					var iterator = this.getPluggableViewIterator();
					while (!iterator.atEnd()) {
						var view = iterator.get().value;
						
						var viewState = view.getState();
						if (viewState) {
							oldState.addPluggableViewState(view.viewId, viewState);
						}
					}
				}
			}
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_setDatasetInit: function(dataset) {
			//Call superclass
			this.inherited(arguments);
		},
		
		_setDatasetSetWidgetDefs: function(dataset) {
			//Call superclass
			this.inherited(arguments);
		},
		
		_setDatasetProcessWidgetDefs: function(dataset) {
			//Call superclass
			this.inherited(arguments);
		},
		
		
		_setDatasetLoadData: function(dataset, removeLastState, createNewState) {
			//Remove the current state if not doing an addDataset

			if (removeLastState) {
				this._removeLastState();
			}
			
			if (createNewState) {
				//Create a new state to add to the stack based on the dataset
				var navWidgetState = new ibm.tivoli.tip.navwidget.dojo.NavWidgetState({
					dataset: dataset
				});
				
				//Push the new dataset onto the end of the stack
				this._navWidgetStateStack.push(navWidgetState);
				
				//Add new dataset to breadcrumb bar
				if (this._breadcrumbBar) {
					//Add separator before next step
					if (this._navWidgetStateStack.length > 1) {
						this._breadcrumbBar.addChild(new ibm.tivoli.tip.dijit.BreadcrumbSeparator());
					}
					
					//Add new step
					var newStep = new ibm.tivoli.tip.dijit.Breadcrumb({label: this._getBreadcrumbLabel(dataset, true),
																		title: this._getBreadcrumbAltTitle(dataset)});
					navWidgetState.breadcrumbEntry = newStep;
					this._breadcrumbBar.addChild(newStep);
					this._cleanBreadcrumbLabels();
					var currentNavWidgetStateStackIndex = this._navWidgetStateStack.length - 1;
					dojo.connect(newStep, 'onClick', dojo.hitch(this, function() {
															this.navigateToDatasetInStack(currentNavWidgetStateStackIndex);
														}));
				}
			}
			
			//Call superclass
        	this.inherited(arguments);
		},
		
		_getBreadcrumbLabel: function(dataset, isLastEntry) {
			var label = null;
			if (dataset) {
				label = dataset.getLabel();
				if (isLastEntry) {
					var labelQualifier = dataset.getLabelQualifier();
					if (labelQualifier) {
						var messageTemplate = this.commonResources.PARENTHETICAL_ENTRY;
				        label = dojo.string.substitute(messageTemplate,
	                                                   {label:label,
	                                                   	parens:labelQualifier});
					}
				}
			}
			return label;
		},
		
		_getBreadcrumbAltTitle: function(dataset) {
			return this._getBreadcrumbLabel(dataset, true);
		},
		
		_cleanBreadcrumbLabels: function() {
			var navWidgetStateStackSize = this._navWidgetStateStack.length;
			for (var i = 0; i < navWidgetStateStackSize; i++) {
				var state = this._navWidgetStateStack[i];
				var isLast = (i == navWidgetStateStackSize - 1);
				var newLabel = this._getBreadcrumbLabel(state.dataset, isLast);
				var newAltTitle = this._getBreadcrumbAltTitle(state.dataset);
				state.breadcrumbEntry.set("label", newLabel);
				state.breadcrumbEntry.set("title", newAltTitle);
			}
		},
		
		_setDatasetComplete: function(/*ibm.tivoli.navmodel.Dataset*/dataset){
			//Deal with the dataset in the (now) current nav state
			this._applyCurrentNavState();
		},
		
		getCurrentDataset: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			var navState = this._getCurrentNavWidgetState();
			if (navState) {
				return navState.dataset;
			} else {
				return null;
			}
		},
		
		_getCurrentNavWidgetState: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			var navWidgetStateStackSize = this._navWidgetStateStack.length;
			if (navWidgetStateStackSize > 0) {
				return this._navWidgetStateStack[navWidgetStateStackSize - 1];
			} else {
				return null;
			}
		},

		navigateToDatasetInStack: function(datasetIndex) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// datasetIndex: int
			//		
			
			//Do some checking to make sure datasetIndex is "inbounds"
			var stateStackLength = this._navWidgetStateStack.length;
			if (datasetIndex == stateStackLength - 1) {
	            //this would just be navigating to the current dataset, so return
	            return;
	        } else if (datasetIndex < 0) {
	        	if (this._trace.isError()) {
					this._trace.error("trying to go back too far: datasetIndex = " + datasetIndex + ", state stack size = " + this._navWidgetStateStack.length,
							"navigateToDatasetInStack");
				}
	            return;
	        } else if (datasetIndex >= this._navWidgetStateStack.length) {
	        	if (this._trace.isError()) {
					this._trace.error("trying to navigate past last dataset: datasetIndex = " + datasetIndex + ", state stack size = " + this._navWidgetStateStack.length,
							"navigateToDatasetInStack");
				}
	            return;
	        }
			
			// Fix for 250777
			var fixBreadcrumbBarEllipses = false;
			if (datasetIndex == (stateStackLength - 2)) {
				if (this._breadcrumbBar && this._breadcrumbBar.areBreadcrumbsHidden()) {
					fixBreadcrumbBarEllipses = true;
				}
			}
			// End this part of fix for 250777
			
			//Let's do some timing
			if (this._trace.isFinest()) {
				//Start a timer to see how long it takes
				var navigateToDatasetInStackTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
				navigateToDatasetInStackTimer.start();
			}

	    	//Show busy pane
	    	this.showBusyPane();
	    	
	    	//Set up callback that will hide the busy pane
	    	this._handle = dojo.connect(this, "onSetDataset", this, function(dataset) {
				this.hideBusyPane();
				if (this._trace.isFinest()) {
					this._trace.finest("navigateToDatasetInStack took ; " + navigateToDatasetInStackTimer.stopAndGetTraceString(), "navigateToDatasetInStack");
				}
				dojo.disconnect(this._handle);});
			
			//Pop off the relevant number of states
			var navWidgetStateStackSize = this._navWidgetStateStack.length;
			var lastDatasetIndex = navWidgetStateStackSize - 1;
			for (var i = lastDatasetIndex; i > datasetIndex; i--) {
				this._removeLastState();
			}
			
			// Fix for 250777
			// After popping the states, does the breadcrumb bar still show ellipses?
			if (this._breadcrumbBar && this._breadcrumbBar.areBreadcrumbsHidden() && fixBreadcrumbBarEllipses) {
				this._rebuildBreadcrumbTrail();
			}
			// End this part of fix for 250777
			
			//Deal with the dataset in the (now) current nav state
			this._addOrNavigateHelper(this._getCurrentNavWidgetState().dataset, false, false);
		},
		
		_rebuildBreadcrumbTrail: function() {   // 250777
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this._breadcrumbBar) {
				// Clean out and destroy all dijits of the breadcrumb trail
				var trailDijit;
				for (var i = this._breadcrumbBar.getChildren().length - 1; i >= 0; i--) {
					trailDijit = this._breadcrumbBar.getChildren()[i];
					this._breadcrumbBar.removeChild(trailDijit);
					this._breadcrumbBar.breadcrumbWidget.pop(); // remove dijit from the bar's internal array
					trailDijit.destroy();
				}
				// Rebuild the trail now from the state stack				
				for (var j = 0; j < this._navWidgetStateStack.length; j++) {
					// Add separator before next step if this is not the first step
					if ((this._navWidgetStateStack.length > 1) && (j > 0)) {
						this._breadcrumbBar.addChild(new ibm.tivoli.tip.dijit.BreadcrumbSeparator());
					}
					// Have to split this out to separate method since index j needs to be in hitched function
					this._addBreadcrumbTrailStep(j);
				}
				this._cleanBreadcrumbLabels();				
			}
		},
		
		_addBreadcrumbTrailStep: function(stateIndex) {  // 250777
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			// Add next step
			var stateDataset = (this._navWidgetStateStack[stateIndex]).dataset;
			var newStep = new ibm.tivoli.tip.dijit.Breadcrumb({label: this._getBreadcrumbLabel(stateDataset, stateIndex == (this._navWidgetStateStack.length - 1)),
															title: this._getBreadcrumbAltTitle(stateDataset)});
			// Reset the state item in the stack to the new breadcrumb and add breadcrumb to the trail
			(this._navWidgetStateStack[stateIndex]).breadcrumbEntry = newStep;
			this._breadcrumbBar.addChild(newStep);
			var index = Number(stateIndex);  // Copy the value before using in hitch statement
			dojo.connect(newStep, 'onClick', dojo.hitch(this, function() { this.navigateToDatasetInStack(index); }));			
		},
		
		_applyCurrentNavState: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//The current dataset after popping things off stack is what we want to see on view
			var currentNavState = this._getCurrentNavWidgetState();
			if (currentNavState) {
				//Create an "inner class" to help us determine if all of the subviews have called back with onSetDatasetComplete
				var mainOnSetDatasetHandlerInnerClass = {
						navWidget: this,
						callbackCounter: 0,
						
						//Should be invoked in the scope of mainOnSetDatasetHandlerInnerClass, so "this" refers to this inner class rather than the pluggable view
						onSetDatasetHandler: 
							function(dataset) {
								//Increment counter
								this.callbackCounter++;
								
								if (this.callbackCounter >= this.navWidget.getPluggableViewCount(dataset)) {
									var currentNavState = this.navWidget._getCurrentNavWidgetState();
									
									///Start listening for data changes
									if (dataset) {
										dataset.addEventListener(this.navWidget, dojo.hitch(this.navWidget, this.navWidget._datasetEventListenerCallback));
									}
									
									//Set dataset on the selection
									dojo.hitch(this.navWidget.selection, this.navWidget.selection.setDataset, dataset).call();
									
									if (currentNavState.hasStateBeenUsed) {
										//Set selection based on what had been stored in the state... 
										dojo.hitch(this.navWidget.selection, this.navWidget.selection.setSelectedObjects, currentNavState.selectedItems, 
												currentNavState.selectedLinks, currentNavState.selectedRelationships).call();
									} else {
											//This is the first time using this state, so let's also select the origin items...
										
											//Define a callback that fires when all the origin items
											var gotOriginItems = function(items){
												if (items) {
													this.navWidget.selection.setSelectedObjects(items);
												}
											};
							
											var gotOriginItemsError = function(error, request){
												//Give the user some feedback
					        			        this.displayException(error);
											};
							
											//Fetch the origin
											var itemArgs = {
													onComplete: dojo.hitch(this, gotOriginItems),
													onError: dojo.hitch(this, gotOriginItemsError)
											};
											
											if (dataset) {
												dataset.getOriginItems(itemArgs);
											}
									}
									
									//Try to restore previous view state
									var iterator = this.navWidget.getPluggableViewIterator();
									while (!iterator.atEnd()) {
										var view = iterator.get().value;

										var viewState = currentNavState.getPluggableViewState(view.viewId);
										if (viewState) {
											currentNavState.removePluggableViewState(view.viewId);
											view.restoreFromState(viewState);
										} else {
											view.restoreFromState(null); //It's fine to pass null here
										}
									}
									
									//Fire set dataset event
									dojo.hitch(this.navWidget, this.navWidget.onSetDataset, dataset).call();
									
									//Mark state as having previously been used
									currentNavState.hasStateBeenUsed = true;
								}
							}
				};
				var mainDataSetHandlerFunc = dojo.hitch(mainOnSetDatasetHandlerInnerClass, mainOnSetDatasetHandlerInnerClass.onSetDatasetHandler, currentNavState.dataset);
				
				//Pick the desired view to make visible
				var viewsLayout = this.widgetDefinition.getViewsLayout();
				if (viewsLayout && viewsLayout == "stack") { 
					var preferredView = this.getPreferredPluggableView(currentNavState.dataset);
					if (preferredView) {
						this.makePluggableViewVisible(preferredView.viewId);
					}
				} 
				
				//Give dataset to the views
				var iterator = this.getPluggableViewIterator();
				while (!iterator.atEnd()) {
					var view = iterator.get().value;
					
					//Provide an "inner class" to support a handler for the "onSetDataset" event that can remove itself as a listener when done
					var subHandlerInnerClass = {
						mainHandler: mainDataSetHandlerFunc,
						handle: null,
						
						//Should be invoked in the scope of subHandlerInnerClass, so "this" refers to this inner class
						handler: function(dataset){
								this.mainHandler.call();
								
							     //Disconnect the handler
							     dojo.disconnect(this.handle);
							}
					};
					var handle = dojo.connect(view, "onSetDataset", dojo.hitch(subHandlerInnerClass, subHandlerInnerClass.handler));
					subHandlerInnerClass.handle = handle;
						
					if (view.isApplicable(currentNavState.dataset)) {
						try {
							//Since views are pluggable... let's take some care with try/catch, so that a custom one doesn't take us out if it craps
							//out while handling the dataset
							view.setDataset(currentNavState.dataset, null, currentNavState.getPluggableViewState(view.viewId));
						} catch (ex) {
							if (this._trace.isError()) {
								this._trace.error("Cannot set dataset on view = " + view.id + "; ex = " + ex.name + ": " + ex.message, "_applyCurrentNavState");
							}
						}
					} else {
						//View not applicable, so let's clear out the view
						try {
							view.setDataset(null);
						} catch (ex) {
							if (this._trace.isError()) {
								this._trace.error("Unable to clear dataset on view = " + view.id + "; ex = " + ex.name + ": " + ex.message, "_applyCurrentNavState");
							}
						}
					}
				}
			}
		},
		
		_removeLastState: function(inDestroy) {
			if (this._navWidgetStateStack.length > 0) {
				//Remove associated breadcrumb bar entry
				if (this._breadcrumbBar) {
					var lastBreadcrumbBarElementIndex = this._breadcrumbBar.getChildren().length - 1;
					var lastBreadcrumbButton = this._breadcrumbBar.getChildren()[lastBreadcrumbBarElementIndex];
					this._breadcrumbBar.removeChild(lastBreadcrumbButton); // remove breadcrumb entry
					this._breadcrumbBar.breadcrumbWidget.pop(); // remove dijit from the bar's internal array  (250777)
					if (lastBreadcrumbBarElementIndex > 1) {
						//also a separator we need to clean up
						var lastSeparator = this._breadcrumbBar.getChildren()[lastBreadcrumbBarElementIndex - 1];  // 250777
						this._breadcrumbBar.removeChild(lastSeparator);  // 250777
						this._breadcrumbBar.breadcrumbWidget.pop(); // remove dijit from the bar's internal array  (250777)
						lastSeparator.destroy();   // clean up separator dijit  (250777)
					}
				}
				
				//Pop and destroy the state
				var poppedState = this._navWidgetStateStack.pop(); 
            if (poppedState.breadcrumbEntry) {     // breadcrumb bar might be hidden in view so entry may not exist (254914)
               poppedState.breadcrumbEntry.destroy();  // clean up breadcrumb dijit we removed above  (250777)
               poppedState.breadcrumbEntry = null;     // 250777
            }
				this._destroyDataset(poppedState.dataset);
				poppedState.destroy();
				
				//clean up the breadcrumbs
				if (!inDestroy) { //Calling this while we're destorying ourselves causes an exception in Button.js
					this._cleanBreadcrumbLabels();
				}
			}
		},
		
		_destroyDataset: function(dataset) {
			if (dataset) {
				dataset.destroy();
			}
		},
		
		//****************************************************************************
		//* DatasetEventListener stuff
		//****************************************************************************
		_handleChangedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "changed" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "changed" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_handleLabelChangedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "labelChanged" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "labelChanged" event type.
			// tags:
			//		protected
			
			var dataset = event.getDataset();
			var state = this._getCurrentNavWidgetState();
			if (state) {
				var label = this._getBreadcrumbLabel(dataset, true);
				var altTitle = this._getBreadcrumbAltTitle(dataset);
				state.breadcrumbEntry.set("label", label);
				state.breadcrumbEntry.set("title", altTitle);
			}
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_handleStatusChangedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "statusChanged" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Subclass should override to if it wishes to deal with "statusChanged" events.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_handleItemsAddedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "itemsAdded" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "itemsAdded" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},

		_handleItemsRemovedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "itemsRemoved" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "itemsRemoved" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},

		_handleItemStatusChangedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "itemStatusChanged" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "itemStatusChanged" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_handleItemPropertiesChangedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "itemPropertiesChanged" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "itemPropertiesChanged" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},

		_handleLinksAddedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "linksAdded" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "linksAdded" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_handleLinksRemovedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "linksRemoved" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "linksRemoved" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_handleLinkStatusChangedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "linkStatusChanged" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "linkStatusChanged" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_handleLinkPropertiesChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Handle "linkPropertiesChanged" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "linkPropertiesChanged" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);	
		},

		_handleLinkChangedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "linkChanged" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "linkChanged" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);		
		},
		
		_handleRelationshipStatusChangedEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "relationshipStatusChanged" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "relationshipStatusChanged" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_handleRelationshipPropertiesChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Handle "relationshipPropertiesChanged" event type.
			// event:
			//		An object containing information about what changed in the Dataset.
			// description:
			//		Handle "relationshipPropertiesChanged" event type.
			// tags:
			//		protected
			
			//Call superclass
			this.inherited(arguments);	
		},
		
		_handleExceptionEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "exception" event type.
			// event:
			//		An object containing information the "exception" event
			// description:
			//		Subclass should override to if it wishes to deal with "exception" events.
			// tags:
			//		protected

			//Call superclass
			this.inherited(arguments);
		},
		
		_handleEventRouterEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "eventRouter" event type.
			// event:
			//		An object containing information the "eventRouter" event
			// description:
			//		Subclass should override to if it wishes to deal with "eventRouter" events.
			// tags:
			//		protected

			//Call superclass
			this.inherited(arguments);
		},
		
		//*********************************************************************************************
		// "Private"
		//*********************************************************************************************
		_createBreadcrumbBar: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			var breadcrumbBar = new ibm.tivoli.tip.dijit.BreadcrumbBar({
				region: "top"
			});
			this._breadcrumbBar = breadcrumbBar;
		},
		
		_createWidgetDefinition: function(){		
			//Call super class which will load widget def
			this.inherited(arguments);
			
			//Initialize based on widget def
			this._updateNavWidgetParamsFromWidgetDefs();
		},
		
		_getDefaultWidgetDefInfo: function(){
			return this._constants.DEFAULT_WIDGET_DEF_INFO;
		},
		
		_updateNavWidgetParamsFromWidgetDefs: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (this.widgetDefinition){				
				this.includeBreadcrumbs = !this.widgetDefinition.getBreadcrumbs().hidden;
			}
		}		
		
	});

dojo.declare("ibm.tivoli.tip.navwidget.dijit.NavWidgetMenuProvider",
        ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	// _handle:
	//		
	_handle: null,
	
	filterNavigationTasks: function(/*ibm.tivoli.navmodel.Task[]*/ tasks) {
		// summary:
		//	Return a filtered collection of tasks (i.e. remove all navigation tasks)
		//
		// Overriding this method because we do NOT want to filter out navigation tasks
		return tasks;
	},

	handleNavigation: function(data, ioArgs) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// data: 
		//		
		// ioArgs:
		//		
	
		// listen for event indicating new dataset is loaded and dismiss the busy pane
		this._handle = dojo.connect(this.view, "onSetDataset", this, function(dataset) {
																			this.view.hideBusyPane();
																			dojo.disconnect(this._handle);});
		this.view.showBusyPane();
		this.view.getCurrentDataset().navigate(
   	         {onComplete: dojo.hitch(this, this._processNavNewDataSet),
   	         onError: dojo.hitch(this, this._handleNavNewDataSetError),
   	         taskId: data.actionID,
   	         taskCategory: data.category,
   	         selection: this.buildClientNavModelSelection(data, this.view.dataset.getVersion())});
	},
	
	_processNavNewDataSet: function(dataset, kwArgs) {	
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// dataset: 
		//		
		// kwArgs:
		//		
		this.view.addDataset(dataset);
	},

	_handleNavNewDataSetError: function(error, exception, ioArgs) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// error: 
		//		
		// exception:
		//		
		// ioArgs:
		//		
		
		// in case of an error, dismiss the busy pane
		this.view.hideBusyPane();
		dojo.disconnect(this._handle);
		
		//Give the user some feedback
        this.view.displayException(error);
	}
	
});
