/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext");

dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("dojox.collections.SortedList");

dojo.declare(
    "ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext",
    null,
    {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
    	
    	// _items: [private] SortedList
    	//		The list of items that are selected
  		_items: null,
    	
  		// _links: [private] SortedList
    	//		The list of links that are selected
  		_links: null,
  		
  		// _relationships: [private] SortedList
    	//		The list of links that are selected
  		_relationships: null,
    	
    	// _pluggableView: [private] ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView
    	//		The pluggable view for which we're managing selection
  		_pluggableView: null,
  		
    	// dataset: [private] ibm.tivoli.navmodel.Dataset
    	//		The root level dataset for the selection we're managing
  		_dataset: null,
  		
		/*=====
		constructor_kwArgs: function(dataset, pluggableView, itemIds, relationshipIds) {
			// dataset: ibm.tivoli.navmodel.Dataset
			//		
			// pluggableView: ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView
			//		
			// itemIds: String[]
			//		
			// relationshipIds: String[]
			//		
		},
		=====*/
  		
  		constructor: function(/*constructor_kwArgs*/ kwArgs) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
    	
    		//The sorted list can suffer from performance issues if there are a lot of insertions, but in a lot of cases we want to keep the list of selected items
    		//sorted (e.g., so properties view could show last selected item). Since the selection will usually be small, I'm guessing this will be acceptable.
    		this._items = new dojox.collections.SortedList();
    		this._links = new dojox.collections.SortedList();
    		this._relationships = new dojox.collections.SortedList();
    		
    		//Process the args
    		if (kwArgs) {
    			this._dataset = kwArgs.dataset;
    			this._pluggableView = kwArgs.pluggableView;
    			this._setSelectedObjectIds(kwArgs.itemIds, kwArgs.linkIds, kwArgs.relationshipIds);
    		}
	 	},
	 	
	 	_setSelectedObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds){
			// summary:
			//		Coming soon
			// itemsIds:
			//		An array of absolute item ids
			// linkIds:
			//		An array of absolute link ids
	 		// relationshipIds:
			//		An array of absolute relationship ids
			// description:
			//		Coming soon
			// tags:
			//		private

	 		//Clear out current selection
	 		this._items.clear();
	 		this._links.clear();
	 		this._relationships.clear();
	 		
	 		//Look up the objects in the dataset and add to hash tables
	 		//Items
	 		if (itemIds) {
		 		for (var i = 0; i < itemIds.length; i++) {
	 				var absItemId = itemIds[i];
	 				var item = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemByAbsoluteId(this._dataset, absItemId);
	 				this._items.add(absItemId, item);
	 			}
	 		}
	 		
	 		//Links
	 		if (linkIds) {
		 		for (var i = 0; i < linkIds.length; i++) {
	 				var absLinkId = linkIds[i];
	 				var link = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getLinkByAbsoluteId(this._dataset, absLinkId);
	 				this._links.add(absLinkId, link);
	 			}
	 		}
	 		
	 		//Relationships
	 		if (relationshipIds) {
		 		for (var i = 0; i < relationshipIds.length; i++) {
	 				var absRelationshipId = relationshipIds[i];
	 				var relationship = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getRelationshipByAbsoluteId(this._dataset, absRelationshipId);
	 				this._relationships.add(absRelationshipId, relationship);
	 			}
	 		}
		},
		
		_setSelectedObjectsBase: function(/*ibm.tivoli.navmodel.Item[]*/ items, /*ibm.tivoli.navmodel.Link[]*/ links, /*ibm.tivoli.navmodel.Relationship[]*/ relationships){
			// summary:
			//		Coming soon
			// items:
			//		An array of items
			// links:
			//		An array of links
			// relationships:
			//		An array of relationships
			// description:
			//		Coming soon
			// tags:
			//		private
		
			//Clear out current selection
	 		this._items.clear();
	 		this._links.clear();
	 		this._relationships.clear();
	 		
	 		//Look up the objects in the dataset and add to hash tables
	 		//Items
	 		if (items) {
		 		for (var i = 0; i < items.length; i++) {
		 			var item = items[i];
		 			var absId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemAbsoluteId(item);
	 				this._items.add(absId, item);
	 			}
	 		}
	 		
	 		//Links
	 		if (links) {
		 		for (var i = 0; i < links.length; i++) {
		 			var link = links[i];
		 			var absId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getLinkAbsoluteId(link);
	 				this._links.add(absId, link);
	 			}
	 		}
	 		
	 		//Relationships
	 		if (relationships) {
		 		for (var i = 0; i < relationships.length; i++) {
		 			var relationship = relationships[i];
		 			var absId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getRelationshipAbsoluteId(relationship);
	 				this._relationships.add(absId, relationship);
	 			}
	 		}
		},
		
	 	_deselectObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds){
			// summary:
			//		Coming soon
			// itemsIds:
			//		An array of absolute item ids
			// linkIds:
			//		An array of absolute link ids
	 		// relationshipIds:
			//		An array of absolute relationship ids
			// description:
			//		Coming soon
			// tags:
			//		private

	 		//Look up the objects in the dataset and remove from hash tables
	 		//Items
	 		if (itemIds) {
		 		for (var i = 0; i < itemIds.length; i++) {
	 				var absItemId = itemIds[i];	 
					if (this._items.contains(absItemId)) {
		 				this._items.remove(absItemId);
					}
	 			}
	 		}
	 		
	 		//Links
	 		if (linkIds) {
		 		for (var i = 0; i < linkIds.length; i++) {
	 				var absLinkId = linkIds[i];
					if (this._links.contains(absLinkId)) {
		 				this._links.remove(absLinkId);
					}
	 			}
	 		}
	 		
	 		//Relationships
	 		if (relationshipIds) {
		 		for (var i = 0; i < relationshipIds.length; i++) {
					var absRelationshipId = relationshipIds[i];
					if (this._relationships.contains(absRelationshipId)) {
		 				this._relationships.remove(absRelationshipId);
					}
	 			}
	 		} 
		},

		_deselectObjects: function(/*ibm.tivoli.navmodel.Item[]*/ items, /*ibm.tivoli.navmodel.Link[]*/ links, /*ibm.tivoli.navmodel.Relationship[]*/ relationships) {
			// summary:
			//		Coming soon
			// items:
			//		An array of items
			// links:
			//		An array of links
			// relationships:
			//		An array of relationships
			// description:
			//		Coming soon
			// tags:
			//		private

	 		//Look up the objects in the dataset and remove from hash tables
	 		//Items
	 		if (items) {
		 		for (var i = 0; i < items.length; i++) {
		 			var item = items[i];
		 			var absId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemAbsoluteId(item);
					if (this._items.contains(absId)) {
		 				this._items.remove(absId);
					}
	 			}
	 		}
	 		
	 		//Links
	 		if (links) {
		 		for (var i = 0; i < links.length; i++) {
	 				var link = links[i];
		 			var absId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getLinkAbsoluteId(link);
					if (this._links.contains(absId)) {
		 				this._links.remove(absId);
					}
	 			}
	 		}
	 		
	 		//Relationships
	 		if (relationships) {
		 		for (var i = 0; i < relationshipIds.length; i++) {
					var relationship = relationships[i];
		 			var absId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getRelationshipAbsoluteId(relationship);
					if (this._relationships.contains(absId)) {
		 				this._relationships.remove(absId);
					}

	 		
	 			}
	 		} 
		},

		//Dataset
    	getDataset: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._dataset;
	 	},
	 	
		//Items
    	getItems: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._items.getValueList();
	 	},
	 	
	 	getItemIds: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._items.getKeyList();
	 	},
	 	
	 	getItemCount: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._items.count;
	 	},
	 	
	 	//Links
	 	getLinks: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._links.getValueList();
	 	},
	 	
	 	getLinkIds: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._links.getKeyList();
	 	},
	 	
	 	getLinkCount: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._links.count;
	 	},
	 	
	 	//Relationships
	 	getRelationships: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._relationships.getValueList();
	 	},
	 	
	 	getRelationshipIds: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._relationships.getKeyList();
	 	},
	 	
	 	getRelationshipCount: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._relationships.count;
	 	},
	 	
	 	//Misc
	 	getTotalSelected: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this.getItemCount() + this.getLinkCount() + this.getRelationshipCount();
	 	},
	 	
	 	isEmpty: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this.getTotalSelected() == 0;
	 	},
	 	
	 	getPluggableView: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		return this._pluggableView;
	 	}
    }
);