dojo.provide("ibm.tivoli.tip.navwidget.iwidget.Edit");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.NumberTextBox");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dijit.form.CheckBox");
dojo.require("dojox.grid.DataGrid");
dojo.require("dojox.validate.web");
dojo.require("dojo.data.ItemFileReadStore");
dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("dojo.html");
dojo.require("dojo.i18n");
    
dojo.requireLocalization("ibm.tivoli.tip.navwidget.iwidget", "Common");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.Edit", [dijit.layout.ContentPane, dijit._Templated], {
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("ibm.tivoli.tip.navwidget.iwidget", "templates/Edit.html"),
    
    _descriptionText:null,
    _widgetDefTabText:null,
    _widgetdefConfigText:null,
    _baseUrlText:null,
    _dataProviderText:null,
    _datasourceText:null,
    _widgetText:null,
    _widgetdefText:null,
    _saveText:null,
    _saveAndCloseText:null,
    _restoreDefaultsText:null,
    _closeText:null,
    
    widgetDefInfo: null,
    providerInfo: null,
    _defaultBaseUrl: "/ibm/tivoli/rest",
    _defaultDataProvider: "tip",
    _defaultWidget: "",
    _defaultDataSource: "any",
    _defaultWidgetDef: "SampleNavWidgetWithTableOnTop-0.1.0",
    
    constructor: function constructor(){
        var i18nHash = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget.iwidget", "Common");
        this._descriptionText=    i18nHash["Edit Mode's Description"];
        this._widgetDefTabText=   i18nHash["Widget Definition"];
        this._widgetdefConfigText=i18nHash["Widget Definition Configuration"];
        this._baseUrlText=        i18nHash["Base URL"];
        this._dataProviderText=   i18nHash["Provider"];
        this._datasourceText=     i18nHash["Datasource"];
        this._widgetText=         i18nHash["Widget Type"];
        this._widgetdefText=      i18nHash["Widget Id"];
        this._saveText=           i18nHash["Save"];
        this._saveAndCloseText=   i18nHash["Save and Close"];
        this._restoreDefaultsText=i18nHash["Restore Defaults"];
        this._closeText=          i18nHash["Close"];
    },
    startup: function startup(){
        this.updateWidgetDefInfo(this.widgetDefInfo);
    },
    //BUTTON ACTIONS
    onSave: function onSave(/* Event */e){ /* Extension point.*/ },
    _onSave: function _onSave(/* Event */e){
        this.widgetDefInfo = {};
        this.widgetDefInfo.baseUrl = this.baseUrlTextBox.attr('value');
        this.widgetDefInfo.provider = this.dataProviderTextBox.attr('value');
        this.widgetDefInfo.datasource = this.datasourceTextBox.attr('value');
        this.widgetDefInfo.widget = this.widgetTextBox.attr('value');
        this.widgetDefInfo.definition = this.widgetDefTextBox.attr('value');
        e.payload = this.widgetDefInfo;
        return this.onSave(e);
    },
    onSaveAndClose: function onSaveAndClose(/* Event */e){ /* Extension point.*/ },
    _onSaveAndClose: function _onSaveAndClose(/* Event */e){
        return this._onSave(e) || this._onClose(e) || this.onSaveAndClose(e);
    },
    onRestoreDefaults: function onRestoreDefaults(/* Event */e){ /* Extension point.*/ },
    _onRestoreDefaults: function _onRestoreDefaults(/* Event */e){
        this.baseUrlTextBox.reset();
        this.dataProviderTextBox.reset();
        this.datasourceTextBox.reset();
        this.widgetDefTextBox.reset();
        return this.onRestoreDefaults(e);
    },
    onClose: function onClose(/* Event */e){ /* Extension point.*/ },
    _onClose: function _onClose(/* Event */e){
        return this.onClose(e);
    },    
    updateWidgetDefInfo: function updateWidgetDefInfo(/* object */widgetDefInfo){        
        if (widgetDefInfo == null || typeof widgetDefInfo == 'undefined') {
          return;
        }
        this.baseUrlTextBox.attr('value', widgetDefInfo.baseUrl);
        this.dataProviderTextBox.attr('value', widgetDefInfo.provider);
        this.datasourceTextBox.attr('value', widgetDefInfo.datasource);
        this.widgetTextBox.attr('value', widgetDefInfo.widget);
        this.widgetDefTextBox.attr('value', widgetDefInfo.definition);
    }
});
