dojo.provide("ibm.tivoli.tip.navwidget.iwidget.Event");

dojo.require("ibm.tivoli.tip.navwidget.iwidget.Resource");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.Trace");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.Event",null,{
	name:null,
	payload:null,
	constructor: function constructor(args){
		new ibm.tivoli.tip.navwidget.iwidget.Trace(this);
		if(typeof args === 'string'){
			this._createNewEvent(args);
		} else {
			this._populateExistingEvent(args);
		}
	},
	_addResource: function _addResource(resource){
		this.payload.resources.push(resource);
	},
	getResources: function getResources(){
		return this.payload.resources;
	},
	toJson: function toJson(){
		var json={name:this.name,payload:{resources:[]}};
		var addResource=function(resource){
			var resourceJson=resource.toJson();
			json.payload.resources.push(resourceJson);
		};
		dojo.forEach(this.payload.resources,addResource);
		return json;
	},
	_createNewEvent: function _createNewEvent(eventName){
		this.name=eventName;
		this.payload={resources:[]};		
	},
	_populateExistingEvent: function _populateExistingEvent(event){
		this.name=event.name;
		this.payload={resources:[]};
		if(!event.payload.resources){
			this._addResource(new ibm.tivoli.tip.navwidget.iwidget.Resource(event.payload));
		} else {
			var processResource=function(json){
				this._addResource(new ibm.tivoli.tip.navwidget.iwidget.Resource(json));
			};
			dojo.forEach(event.payload.resources,dojo.hitch(this,processResource));
		}
	}
});