dojo.provide("ibm.tivoli.tip.navwidget.iwidget.EventReceiver");

dojo.require("ibm.tivoli.navmodel.ProviderUtils");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.Event");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.Trace");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.LegacyEventUtils");
dojo.require("ibm.tivoli.navmodel.Dataset");
dojo.require("dojox.collections.Dictionary");
dojo.declare("ibm.tivoli.tip.navwidget.iwidget.EventReceiver",[ibm.tivoli.tip.navwidget.iwidget.LegacyEventUtils],{
	providerType:null,
	dataset:null,
	providers:null,
	_iw_er_trace:null,
	constructor: function constructor(){
		this._iw_er_trace=new ibm.tivoli.tip.navwidget.iwidget.Trace(this,["initEventReceiver","_getProvidersByType","processEvent","setDataset",
		                                                             "_processResource","_processResource","onEvent","destroy","_willHandleSiblingProviders"]);
	},
	setDataset: function setDataset(dataset){
		this.inherited(arguments);
		this.initEventReceiver(this.dataset);
	},
	initEventReceiver: function initEventReceiver(dataset){
		this.dataset=dataset;
		var providerId=dataset.getProviderId();
		var provider=ibm.tivoli.navmodel.ProviderUtils.getProviderById({
				baseUrl:dataset.getArg("baseUrl"),
				provider:providerId				
		});
		this.providerType=provider.getType();
		var provs=[];
		if(!this._willHandleSiblingProviders()){
			provs.push(provider);
		}else{
			provs=this._getProvidersByType(this.providerType);
		}
		this.providers={};
		dojo.forEach(provs,dojo.hitch(this,function(provider){
			var mssName=provider.getMSSName();
			if(mssName){
				this.providers[mssName]=provider;
			}
		}));
	},
	_willHandleSiblingProviders: function _willHandleSiblingProviders(){
		return true;
	},
	_getProvidersByType: function _getProvidersByType(type){
		var providers=[];
		var args={
			baseUrl:this.dataset.getArg("baseUrl"),
			sync:true,
			condition:"(type = '"+type+"')",
			onComplete: dojo.hitch(this,function(provs, kwArgs){
				providers=provs;
			})
		};
		ibm.tivoli.navmodel.ProviderUtils.getProviders(args);
		return providers;
	},
	processEvent: function processEvent(json){
		console.log("RECEIVED EVENT:",json);
		var event=new ibm.tivoli.tip.navwidget.iwidget.Event(json.payload);//TODO: Remove hack when TIP fixes PTE SAPMUI1027
		var itemsSet=new dojox.collections.Dictionary();
		var resources=event.getResources();
		if(resources.length>0){
			dojo.forEach(resources,dojo.hitch(this,dojo.partial(this._processResource,itemsSet)));
			if(itemsSet.count===0){
				return false;//toss event if no resources match.
			}			
		}
		this.onEvent(event,itemsSet.getValueList());
	},
	_processResource: function _processResource(itemsSet,resource){
		var eventMSSName=resource.getMSSNameByProviderType(this.providerType);
		var sourceToken=resource.getSourceTokenByProviderType(this.providerType);
		if(this.providers[eventMSSName]){
			var provider=this.providers[eventMSSName];
			var items=null;
			var readItem=function(itemsSet,items,kwArgs){
				dojo.forEach(items,dojo.partial(function(itemsSet,item){
					itemsSet.add(item.id,item);
				},itemsSet));
			};
			var conditionParams=resource.getContextParameters(this.providerType);
			var args={
				sync:true,
				onComplete:dojo.hitch(this,dojo.partial(readItem,itemsSet))
			};
			var customDataset=this.createLikeDataset(this.dataset,provider.getId(),conditionParams);
			customDataset.getItems(args);
		}
	},
	createLikeDataset: function createLikeDataset(dataset,providerId,parameters){
		args={
			baseUrl:dataset.getArg("baseUrl"),
			provider:providerId,
			datasource: dataset.getDatasourceId(),
			dataset:dataset.getId(),
			parameters:parameters,
			version:dataset.getVersion()
		};
		return new ibm.tivoli.navmodel.Dataset(args);
	},
	onEvent: function onEvent(/*ibm.tivoli.tip.navwidget.iwidget.Event*/event,/*[item]*/items){},	
	destroy: function destroy(){
		if(this._iw_er_trace){this._iw_er_trace.destroy();}
		this.inherited(arguments);
	}
});