dojo.provide("ibm.tivoli.tip.navwidget.iwidget.IWTableView");

dojo.require("ibm.tivoli.tip.navwidget.table.dijit.TableView");
dojo.require("ibm.tivoli.tip.navwidget.iwidget._NavView");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.TableLocalWidgetDef");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.IWTableView", [ ibm.tivoli.tip.navwidget.table.dijit.TableView, ibm.tivoli.tip.navwidget.iwidget._NavView ], {
  constructor: function() {
	this._iw_tv_trace=new ibm.tivoli.tip.navwidget.iwidget.Trace(this,["_selectFirstRowOnInit","_doSelectFirstRow"],
			                                                     this._iw_nv_trace,"ibm.tivoli.tip.navwidget.iwidget.IWTableView");
    dojo.connect(this, "onSetDataset", this, "_selectFirstRowOnInit");
    dojo.connect(this, "_selectFirstRowOnInit", this, "startProcessingEvents");
  },

  _selectFirstRowOnInit: function() {
    if ( this.selectedChildWidget && this.selectedChildWidget._table ) {
      // table already init; use grid to select first row
      var table = this.selectedChildWidget._table;
      if ( table.grid && table.grid.selection && table.getRowCount() > 0 ) {
        table.grid.selection.addToSelection(0);
      }
    } else {
      // table not init; get the first item from CURI 
	    var cond = this.widgetDefinition.getDataSet()[0].conditions;
      var kwargs = { count: 1, 
    		  		//sync:true,
                     onComplete: dojo.hitch(this, "_doSelectFirstRow"),
                     onError: function(error) {
                       console.error("Unable to get items from dataset. Not selecting first row.");
                    }
                  };
      if ( cond && cond.filterString && cond.filterString != "" ) {
        kwargs.condition = cond.filterString;
      }
      this.dataset.getItems(kwargs); 
    }
  },

  /**
   * Select first row using the item returned from CURI
   * @items an array of ibm.tivoli.navmodel.Item. Should have 1 item
   */
  _doSelectFirstRow: function(items) {
    if ( this.selectedChildWidget && this.selectedChildWidget._table ) {
      // table already init; use grid to select first row
      var table = this.selectedChildWidget._table;
      if ( table.grid && table.grid.selection && table.getRowCount() > 0 ) {
        table.grid.selection.addToSelection(0);
      }
    } else if ( this.selection && items.length > 0 ) {
      // use PluggableView API to select first row by passing in the item
      // we got from CURI
      this.selection.setSelectedItem(items[0]);
    }
  }
  
  // summary:
	//		The Table View to iWidget bridge
//	selectItems: function(/*array*/itemIds) {
		// summary:
		//		Filters out the table rows to only the ones that have the same condition property value as the last selected item.
		// description:
		//		Fetches the item with the id matching the last id of the array. Extracts the value of the (previously configured) condition property 
		//		for the fetched item, and filters the rows in the table to only include items with matching condition property values.
		//		For example: Say the condition property is preconfigured to be STATUS, and the itemIds passed in is ['23','45','17']. This method will first
		//		fetch the item with id='17', lets refer to it as item17. Then we retrieve the value of item17's STATUS property, say 'OK'. Finally, 
		//		the rows in the table that have a STATUS property of 'OK' are kept, the remaining rows are filtered out.
		// tags:
		//		public
//		var newCondition='';
//		if(itemIds.length>0){
//			var item=this.dataset.getItem( {
//				itemId: itemIds[itemIds.length-1]
//			});
//			newCondition='STATUS = \''+item.getProperty('STATUS').getDisplayValue()+'\'';
//		}
//		if(newCondition!==this.dataset.condition){
//			this.dataset.condition=newCondition;
//			console.log(this.dataset);
//			this.setDataset(this.dataset);
//		}
//	}
});
