dojo.declare("ibm.tivoli.tip.navwidget.iwidget.IWidgetPluggableView", [], {
	_viewClass: null,
	_configClass: null,
	_navView: null,
	_navEdit: null,
	_navConfig: null,
	_initParams: null,
	_connections: null,
	_iwtrace: null,
	dataset: null,
	restVersion: null,
	constructor: function constructor(){
		this._iwtrace=ibm.tivoli.tip.navwidget.iwidget.Trace(this);
	},
	destroy: function destroy(){
		if(this._iwtrace){this._iwtrace.destroy();}
		this.inherited(arguments);
	},
	onLoad: function onLoad() {
		var contextPath = this.iContext.widgetwrapper.widgetBaseUri;
		dojo.registerModulePath("ibm.tivoli.tip.navwidget.iwidget",this.iContext.io.rewriteURI(contextPath));
		this._connections=[];
		var jslib=contextPath+'../../../../../../';
		dojo.registerModulePath("dojox.grid",this.iContext.io.rewriteURI(jslib+'ted/dojox/grid'));
        dojo.registerModulePath("ibm.tivoli.widgetbuilder",this.iContext.io.rewriteURI(contextPath+"../../../../../../ibm/tivoli/widgetbuilder"));
        dojo.registerModulePath("ibm.tivoli.widgetbuilder.nav",this.iContext.io.rewriteURI(contextPath+"../../../../../../../js/ibm/tivoli/widgetbuilder/nav"));
		dojo.registerModulePath("ibm",this.iContext.io.rewriteURI(contextPath+'../../../../'));/* TOPO_WORKAROUND */
		dojo.registerModulePath("dojoe",this.iContext.io.rewriteURI(jslib+'ted/dojoe'));
		dojo.registerModulePath("dojot",this.iContext.io.rewriteURI(jslib+'ted/dojot'));
		dojo.registerModulePath("dojox",this.iContext.io.rewriteURI(jslib+"ted/dojox"));
		dojo.require("ibm.tivoli.tip.navwidget.iwidget.Edit");
		dojo.require("ibm.tivoli.tip.navwidget.iwidget.ConditionDataset");
		dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
		dojo.require("ibm.tivoli.navmodel.WidgetDefUtils");
		this._viewClass=this.iContext.getItemSet("implementation").getItemValue("viewClass");
		dojo["require"](this._viewClass);
		this._configClass=this.iContext.getItemSet("implementation").getItemValue("configClass");
		dojo["require"](this._configClass);
		this._widgetDefClass=this.iContext.getItemSet("implementation").getItemValue("widgetDefClass");
		dojo["require"](this._widgetDefClass);
		dojo.attr(dojo.body(),"class","claro");
        this._initParams = this.iContext.getItemSet("initParams");
	},
	onView: function onView() {
		var viewId="_"+this.iContext.widgetId+"_navView";
		var viewDiv=this.iContext.getElementById(viewId);
		if(!this.navView){
			this._createView(viewDiv);
		}
		this.navView.startup();
		if("undefined"!==(typeof iscPortlet)){
			iscPortlet.sendResizeEvent();
		}/* TIP WORKAROUND */
	},
	onEdit: function onEdit() {
		var editId="_"+this.iContext.widgetId+"_navEdit";
		var editDiv=this.iContext.getElementById(editId);
		if(!this.navEdit){
			this._createEdit(editDiv);
		}
	},
    onConfig: function onConfig() {
		var configId="_"+this.iContext.widgetId+"_navConfig";
		var configDiv=this.iContext.getElementById(configId);
		if(!this.navConfig){
			this._createConfig(configDiv);
		}
		if("undefined"!==(typeof iscPortlet)){
			iscPortlet.sendResizeEvent();
		}/* TIP WORKAROUND */
    },
	onUnload: function onUnload() {
		if(this.navConfig!=null&&typeof this.navConfig!='undefined'){
			this.navConfig.destroyRecursive();
			this.navConfig=null;
		}
		if(this.navEdit!=null&&typeof this.navEdit!='undefined'){
			this.navEdit.destroyRecursive();
			this.navEdit=null;
		}
		if(this.navView!=null&&typeof this.navView!='undefined'){
			this.navView.destroyRecursive(false);
			this.navView=null;
		}
		dojo.forEach(this._connections,dojo.disconnect);
		this._connections= [];
		if(this._iwtrace){this._iwtrace.destroy();}
	},
	onSizeChanged: function onSizeChanged(event) {
		if(event.payload){
			switch(this.iContext.getiDescriptor().getItemValue("mode")){
			case this.iContext.constants.mode.VIEW:
				this.navView.resize( {
					'w': event.payload.newWidth,
					'h': event.payload.newHeight
				});
				break;
			case this.iContext.constants.mode.CONFIG:
				this.navConfig.resize( {
					'w': event.payload.newWidth,
					'h': event.payload.newHeight
				});
				break;
			}
		}
	},
	// PRIVATES
	_createView: function _createView(/* object div */viewDiv) {
		var navClass=dojo.getObject(this._viewClass);
		var widgetDefInfo=this._loadWidgetDefInfo();
		var widgetDefinition=ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.createWidgetDefinition(this._widgetDefClass,widgetDefInfo.definition,widgetDefInfo);
		this.navView=new navClass( {
			id: viewDiv.id,
			dataset: this._getDataset(widgetDefinition),
			widgetDefinition: widgetDefinition
		},viewDiv);
		this.navView.connectListeners(this);
        this._setTitle(this._getWidgetDefLabel());
	},
	_createEdit: function _createEdit(/* object div */editDiv) {
		var defaultsItemSet=this.iContext.getItemSet("defaults");
		this.navEdit=new ibm.tivoli.tip.navwidget.iwidget.Edit( {
			widgetDefInfo: this._loadWidgetDefInfo(),
			defaultWidgetDef: defaultsItemSet.getItemValue("widgetdef"),
			defaultBaseUrl: defaultsItemSet.getItemValue("baseUrl"),
			defaultDataProvider: defaultsItemSet.getItemValue("provider"),
			defaultDataSource: defaultsItemSet.getItemValue("datasource"),
			defaultWidget: "",
			defaultDataSet: defaultsItemSet.getItemValue("dataset")
		},editDiv);
		this.navEdit.startup();
		this._connections.push(dojo.connect(this.navEdit,"onRestoreDefaults",this,"onResetDefaults"));
		this._connections.push(dojo.connect(this.navEdit,"onSave",this,"onSaveEditMode"));
		this._connections.push(dojo.connect(this.navEdit,"onClose",this,"onCloseEdit"));
	},
	_createConfig: function _createConfig(/* object div */configDiv) {
        var widgetDefinition=this.navView.widgetDefinition.getDef();
        widgetDefinition.meta.id=this.iContext.widgetId;
        widgetDefinition.meta.label.key=this._initParams.getItemValue("TIP_newWidgetTitle");
        widgetDefinition.meta.description.key=this._initParams.getItemValue("TIP_newWidgetDescription");
		var configClass=dojo.getObject(this._configClass);
		this.navConfig=new configClass({
			widgetDef: widgetDefinition,
			wizardMode: this._initParams.getItemValue("TIP_WIDGET_WIZARD")
		},configDiv);
		this._connections.push(dojo.connect(this.navConfig,"onFinish",this,"onSaveConfigMode"));
		this._connections.push(dojo.connect(this.navConfig,"onCancel",this,"onCloseConfig"));
		this._connections.push(dojo.connect(this.navConfig,"exitBack",this,"onExitBackConfig"));
		this._connections.push(dojo.connect(this.navConfig,"exitNext",this,"onSaveConfigMode"));
		this.navConfig.startup();
	},
    _getWidgetDefLabel: function _getWidgetDefLabel() {
		if(this.navView&&this.navView.widgetDefinition){
			return this.navView.widgetDefinition.getWidgetLabel();
		}
		return "";
	},
	_getDataset: function _getDataset(/* object */widgetDefinition) {
		if(this.dataset){
			this.dataset.destroy();
		}
		var s= {};
		var defaultsItemSet=this.iContext.getItemSet("defaults");
		s.baseUrl=defaultsItemSet.getItemValue("baseUrl");
		s.provider=defaultsItemSet.getItemValue("provider");
		if(widgetDefinition.getProvider()&&widgetDefinition.getProvider().id){
			s.provider=widgetDefinition.getProvider().id;
		}
		s.datasource=defaultsItemSet.getItemValue("datasource");
		if(widgetDefinition.getDatasource()&&widgetDefinition.getDatasource().id){
			s.datasource=widgetDefinition.getDatasource().id;
		}
		s.dataset=defaultsItemSet.getItemValue("dataset");
		s.parameters={};
		if(widgetDefinition.getDef().datasets){
			s.dataset=widgetDefinition.getDef().datasets[0].id;
			var params=widgetDefinition.getDef().datasets[0].parameters;
			if(params){
				for(var i=0;i<params.length;i++){
					s.parameters[params[i].id]=params[i].value;
				}
			}
		}
		this.dataset=new ibm.tivoli.tip.navwidget.iwidget.ConditionDataset(s);
		this.restVersion=this.dataset.getVersion();
		return this.dataset;
	},
	_loadWidgetDefInfo: function _loadWidgetDefInfo() {
		var widgetDefInfoString=this.iContext.getiWidgetAttributes().getItemValue('widgetDefInfo');
		if(widgetDefInfoString!=null&&widgetDefInfoString!='undefined'){
			return dojo.fromJson(widgetDefInfoString);
		}else{
			var widgetDefInfo= {};
			var defaultsItemSet=this.iContext.getItemSet("defaults");
			widgetDefInfo.widget=defaultsItemSet.getItemValue("widget");/*type*/
			widgetDefInfo.definition=defaultsItemSet.getItemValue("definition");/*id*/
			widgetDefInfo.baseUrl=defaultsItemSet.getItemValue("baseUrl");
			widgetDefInfo.provider=defaultsItemSet.getItemValue("provider");
			widgetDefInfo.datasource=defaultsItemSet.getItemValue("datasource");
			this._storeWidgetDefInfo(widgetDefInfo);
			return widgetDefInfo;
		}
	},
	_storeWidgetDefInfo: function _storeWidgetDefInfo(/* object */widgetDefInfo) {
		var attrs=this.iContext.getiWidgetAttributes();
		attrs.setItemValue('widgetDefInfo',dojo.toJson(widgetDefInfo));
		attrs.save();
	},
	_setTitle: function _setTitle(/* String */title) {/*tip specific*/
		var newTitle=title?title:"";		
        var attrs = this.iContext.getiWidgetAttributes();
        attrs.setItemValue('widgetTitle', newTitle);
        attrs.save();
	},
	_refreshView: function _refreshView(dataset,widgetDefinition) {
		if(this._viewClass&&this._viewClass==="ibm.tivoli.tip.navwidget.iwidget.IWTopologyView"){
			this.navView.disconnectListeners();
			this.navView.destroyRecursive();
			this.navView=null;
			var viewDiv=dojo.doc.createElement("div");
			viewDiv.id="_"+this.iContext.widgetId+"_navView";
			var contentViewDiv=dojo.query(".view",this.iContext.rootElement)[0];
			dojo.place(viewDiv,contentViewDiv,"first");
		}else{
			this.navView.setDataset(dataset,widgetDefinition);
		}
	},
	// SUSCRIBED IWIDGET EVENTS
	onNavItemSelected: function onNavItemSelected(/* object */event) {console.log("NODECLICKEDON:"+dojo.toJson(event));},
	onLaunchPage: function onLaunchPage(/* object */event) {console.log("LAUNCHPAGE:"+dojo.toJson(event));},
	// ACTIONS
	onSaveConfigMode: function onSaveConfigMode(/* object */event) {
		var widgetDef=this.navConfig.fixWidgetDefForSchema21(this.navConfig.widgetDef);
		if(!widgetDef.datasource.type){widgetDef.datasource.type="any";}
		var widgetDefInfo={};
		widgetDefInfo.widget=widgetDef.meta.type;
		widgetDefInfo.definition=widgetDef.meta.id;
		widgetDefInfo.baseUrl='/ibm/tivoli/rest';
		widgetDefInfo.provider=widgetDef.provider.id;
		widgetDefInfo.datasource=widgetDef.datasource.id;
        var wizardMode = this._initParams.getItemValue("TIP_WIDGET_WIZARD");
        if(wizardMode&&wizardMode==="create"){
        	var widgetDefinition=ibm.tivoli.navmodel.WidgetDefUtils.createWidgetDef({
        		baseUrl:widgetDefInfo.baseUrl,
        		provider:widgetDefInfo.provider,
        		datasource:widgetDefInfo.datasource,
        		widgetType:widgetDefInfo.widget,
        		widgetId:widgetDefInfo.definition+"-0.1.0",
        		definitionObj:widgetDef,
        		widgetClass:this._widgetDefClass,
        		overwrite:true
        	});
        }else{
            var widgetDefinition=ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.createWidgetDefinition(this._widgetDefClass,widgetDefInfo.definition,widgetDefInfo);
        	widgetDefinition.setUserDelta(widgetDef);
        }
		var dataset=this._getDataset(widgetDefinition);
		this._storeWidgetDefInfo(widgetDefInfo);
		this._refreshView(dataset,widgetDefinition);
        this.iContext.iEvents.fireEvent("onModeChanged", null, {TIP_WIDGET_WIZARD_ACTION:'next'});
	},
	onSaveEditMode: function onSaveEditMode(/* object */event) {
		var widgetDefInfo=event.payload;
		if(widgetDefInfo==null||typeof widgetDefInfo=='undefined'){
			return;
		}
		this._storeWidgetDefInfo(widgetDefInfo);
		var widgetDefinition=ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.createWidgetDefinition(this._widgetDefClass,widgetDefInfo.definition,widgetDefInfo);
		var dataset=this._getDataset(widgetDefinition);
		this._refreshView(dataset,widgetDefinition);
	},
	onResetDefaults: function onResetDefaults(/* object */event) {
		var attrs=this.iContext.getiWidgetAttributes();
		attrs.removeItem('widgetDef');
		attrs.save();
	},
	onCloseEdit: function onCloseEdit(/* object */event) {
		this.iContext.iEvents.fireEvent("onModeChanged",null,"{newMode: 'view'}");
	},
    onCloseConfig:function onCloseConfig() {
        this.iContext.iEvents.fireEvent("onModeChanged",null,{TIP_WIDGET_WIZARD_ACTION:'cancel'});
    },
    onExitBackConfig:function onExitBackConfig(event) {
        this.iContext.iEvents.fireEvent("onModeChanged",null,{TIP_WIDGET_WIZARD_ACTION:'back'});
    }
});