dojo.provide("ibm.tivoli.tip.navwidget.iwidget.LegacyEventUtils");
// These methods were created for the beta.  The assumption is DIS is not
// involved yet.

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.LegacyEventUtils",null,{
// Simple method to return whether or not a value has a value
	_hasValue:function _hasValue(obj){
	return typeof obj != "undefined" && obj != null;
},

mangle:function mangle(event){
	var resources=event.payload.resources;
	if(resources&&resources.length>0){
		var stub={payload:dojo.clone(resources[0])};
		this.addOldContext(stub);
		delete stub.payload;
		console.log("EVENT PREMANGLE:",event);
		console.log("MANGLING BIT:",stub);
		dojo.mixin(event,stub);
		console.log("MANGLED EVENT",event);
	}
},
// This function takes an event using the new event context and 
// modifies the event by adding the old context to the event by
// interrogating the proper fields of the new event.  Note that
// multiple resources are not supported in the old event context.
addOldContext:function addOldContext(srcEvent){
	if (this._hasValue(srcEvent) && this._hasValue(srcEvent.payload)){
		var productCount=1;
		var increment=false;
		var clazztype=null;
		
		if (this._hasValue(srcEvent.payload.cdm) && 
			this._hasValue(srcEvent.payload.cdm.attributes) &&
			this._hasValue(srcEvent.payload.cdm.attributes.ClassType)){
			clazztype=srcEvent.payload.cdm.attributes.ClassType;
		}
		
		// Enumerate through all of the payload
		for (var attr in srcEvent.payload) {
		   if (srcEvent.payload[attr]!=null){
			   if (attr=="product"){
					for (var name in srcEvent.payload.product) {
						increment=false;
						var product = srcEvent.payload.product[name];
						// Get all product targeted attributes
						for (var prodName in product){
							// If the attribute is the cdm attribute, need to enumerate it.
							if (prodName == "cdm"){
								if (clazztype != null)
								   srcEvent["CDMClass"+productCount]=clazztype;
								for (var prodCdm in product.cdm){
									srcEvent[prodCdm+productCount]=product.cdm[prodCdm];
									increment=true;
								}
							} else {
								srcEvent[prodName+productCount]=product[prodName];
								increment=true;
							}
						}
						if (increment)
							productCount++;
					}
			   }
			   else if (attr=="cdm" && srcEvent.payload.cdm != null &&
				   this._hasValue(srcEvent.payload.cdm.attributes)){
					for (var attr in srcEvent.payload.cdm.attributes) {
						// Add all attributes with their given name; including ClassType
						srcEvent[attr]=srcEvent.payload.cdm.attributes[attr];
					}			
			   }
			   else if (attr != "framework" && attr != "resources"){
					srcEvent[attr]=srcEvent.payload[attr];
			   }
		   }
		}
	}
	return srcEvent;
},

// This method can assist in adding simple attributes to the event context
// This method will place attributes simply by name since it does not know
// anything specific about the application.
// srcEvent - source event you are adding context to
// name - the name of the attribute being added
// value - the value of the attribute being added
// providerType - the provider type of the source provider for the attribute
addToPayload:function addToPayload(srcEvent, name, value, providerType){
   if (this._hasValue(srcEvent) && this._hasValue(name) && this._hasValue(value)){
	   if (name=="ClassType" || name=="Guid"){
		   if (!this._hasValue(srcEvent.payload))
			   srcEvent.payload={};
		   if (!this._hasValue(srcEvent.payload.cdm))
			   srcEvent.payload.cdm={};
		   if (!this._hasValue(srcEvent.payload.cdm.attributes))
			   srcEvent.payload.cdm.attributes={};
		   srcEvent.payload.cdm.attributes[name]=value;
	   } else if (name=="MSSName" || name=="SourceToken" || name=="ProductName"){
		   if (this._hasValue(providerType)){
			  if (!this._hasValue(srcEvent.payload))
				  srcEvent.payload={};
			  if (!this._hasValue(srcEvent.payload.product))
				  srcEvent.payload.product={};
			  if (!this._hasValue(srcEvent.payload.product[providerType]))
				  srcEvent.payload.product[providerType]={};
			  if (!this._hasValue(srcEvent.payload.product[providerType].cdm))
				  srcEvent.payload.product[providerType].cdm={};
		      srcEvent.payload.product[providerType].cdm[name]=value;
		   }
	   } else {
		   if (!this._hasValue(srcEvent.payload))
			   srcEvent.payload={};
		   srcEvent.payload[name]=value;
	   }
   }
   return srcEvent;
},

// This function is a helper to pull all of the parameters out of
// an event to use for calls into CURI
// srcEvent - the event to pull parameters from
// providertType - the provider type for the provider being queried
// output [optional] - an object to add the parameters to.
// returns an object with attributes representing the parameters.  A new object
//         if 'output' was not specified.
getContextParameters:function getContextParameters(srcEvent, providerType, output){
	var result={};
	//var param="param_";//if passed into dataset, the dataset will prepend it for us
	var param="";
	if (this._hasValue(output)){
		result=output;
	}
	if (this._hasValue(srcEvent) && this._hasValue(srcEvent.payload)){
		// Enumerate through all of the payload
		for (var attr in srcEvent.payload) {
		   if (srcEvent.payload[attr]!=null){
			   if (attr=="product" && this._hasValue(srcEvent.payload.product) &&
				   this._hasValue(providerType) && this._hasValue(srcEvent.payload.product[providerType])){
				   
					var product = srcEvent.payload.product[providerType];
					// Get all product targeted attributes
					for (var prodName in product){
						// If the attribute is the cdm attribute, need to enumerate it.
						if (prodName == "cdm"){
							for (var prodCdm in product.cdm){
								result[param+prodCdm]=product.cdm[prodCdm];
							}
						} else {
							result[param+prodName]=product[prodName];
						}
					}
			   }
			   else if (attr=="cdm" && this._hasValue(srcEvent.payload.cdm) &&
				   this._hasValue(srcEvent.payload.cdm.attributes)){
					for (var attr in srcEvent.payload.cdm.attributes) {
						// Add all attributes with their given name; including ClassType
						result[param+attr]=srcEvent.payload.cdm.attributes[attr];
					}			
			   }
			   else if (attr != "framework" && attr != "resources"){
					result[param+attr]=srcEvent.payload[attr];
			   }
		   }
		}
	}
	return result;
}
});