dojo.provide("ibm.tivoli.tip.navwidget.iwidget.Resource");

dojo.require("ibm.tivoli.navmodel.ProviderUtils");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.Trace");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.Resource",null,{
	constructor: function constructor(args){
		new ibm.tivoli.tip.navwidget.iwidget.Trace(this);
		if(dojo.exists("getDataset",args)){
			this._createResourceFromItem(args);
		} else {
			this._createResourceFromJson(args);
		}
	},
	toJson: function toJson(){
		var json=dojo.fromJson(dojo.toJson(this));
		delete json.declaredClass;
		return json;
	},
	getMSSNameByProviderType: function getMSSNameByProviderType(providerType){
		if(providerType&&this.product[providerType]&&this.product[providerType].cdm){
			return this.product[providerType].cdm.MSSName;
		}
		return null;
	},
	getSourceTokenByProviderType: function getSourceTokenByProviderType(providerType){
		if(providerType&&this.product[providerType]&&this.product[providerType].cdm){
			return this.product[providerType].cdm.SourceToken;
		}
		return null;
	},
	_setProvider: function _setProvider(item,provider){
		var providerType=item.getProperty("type");
		providerType=providerType?providerType.getValue():providerType=provider.getType();
		if(providerType){
			this.product={};
			this.product[providerType]={};
			var mssName=item.getProperty("MSSName");
			mssName=mssName?mssName.getValue():provider.getMSSName();
			var prodName=item.getProperty("ProductName");
			prodName=prodName?prodName.getValue():provider.getAttribute("ProductName");
			var sourceToken=item.getProperty("SourceToken");
			if(mssName||prodName||sourceToken){
				this.product[providerType].cdm={};
				if(mssName){
					this.product[providerType].cdm.MSSName=mssName;			
				}
				if(prodName){
					this.product[providerType].cdm.ProductName=prodName;			
				}
				if(sourceToken){
					this.product[providerType].cdm.SourceToken=propValue;
				}
			}
		}
	},
	_processProperty: function _processProperty(item,provider,id){
		var propValue=item.getProperty(id).getValue();
		if(propValue!==null && typeof propValue !== 'undefined'){
			switch(id){
				case "ProviderType":
				case "MSSName":
				case "ProductName":
				case "SourceToken":
				break;
				case "ClassType":
					var cdmAttrs=this._getCdmAttrs();
					cdmAttrs.ClassType=propValue;
				break;
				default:
					if(this._isCdmAttribute(id)){
						var cdmAttrs=this._getCdmAttrs();
						cdmAttrs[id]=propValue;
					} else if(this._isTargettedProductAttribute(id)){
						var providerType=provider.getType();
						if(providerType){
							this._getProviderTypeCdm(providerType)[id]=propValue;
						}
					} else {
						console.log("ADDING ID"+id+" AND VAL:"+propValue);
						this[id]=propValue;
					}
				break;
			}
		}
	},
	_getProviderTypeCdm: function _getProviderTypeCdm(providerType){
		if(!this.product[providerType].cdm){
			this.product[providerType].cdm={};
		}
		return this.product[providerType].cdm;
	},
	_getCdmAttrs: function _getCdmAttrs(){
		if(!this.cdm){
			this.cdm={attributes:{}};
		}
		return this.cdm.attributes;
	},
	_isCdmAttribute: function _isCdmAttribute(attrName){
		return false;
	},
	_isTargettedProductAttribute: function _isTargettedProductAttribute(attrName){
		return false;
	},
	_getItemProperties: function _getItemProperties(item){
		item.getProperties({sync:true});
		console.log("PROP IDS",item.getCachedPropertyIds(true));
		return item.getCachedPropertyIds(true);
	},
	_createResourceFromItem: function _createResourceFromItem(item){
		var dataset=item.getDataset();
		var providerId=dataset.getProviderId();
		var provider=ibm.tivoli.navmodel.ProviderUtils.getProviderById({
			provider:providerId,
			baseUrl:"/ibm/tivoli/rest"
		});
		dojo.forEach(this._getItemProperties(item),dojo.hitch(this,dojo.partial(this._processProperty,item,provider)));
		this._setProvider(item,provider);
	},
	_createResourceFromJson: function _createResourceFromJson(json){
		for(prop in json){
			if(dojo.isString(prop)){
				this[prop]=json[prop];
			}
		}
		if(json.product){this.product=json.product;}
		if(json.cdm){this.cdm=json.cdm;}
	},
	getContextParameters:function getContextParameters(providerType){
		var payload=this.toJson();
		var result={};
		var param="";
		for (var attr in payload) {
		   if (payload[attr]!=null){
			   console.log("LOOKING AT ATTR:",attr);
			   if (attr=="product" && payload.product && providerType && payload.product[providerType]){				   
					var product = payload.product[providerType];
					for (var prodName in product){
						if(prodName == "cdm"){
							for (var prodCdm in product.cdm){
								result[param+prodCdm]=product.cdm[prodCdm];
							}
						} else {
							result[param+prodName]=product[prodName];
						}
					}
			   }
			   else if (attr=="cdm" && payload.cdm && payload.cdm.attributes){
					for (var attr in payload.cdm.attributes) {
						result[param+attr]=payload.cdm.attributes[attr];
					}
			   }
			   else if (attr != "framework" && attr != "resources"){
					result[param+attr]=payload[attr];
			   }
		   }
		}
		console.log("RESsULT :"+param,result);
		return result;
	}
});