dojo.provide("ibm.tivoli.tip.navwidget.iwidget.event.Event");

dojo.require("ibm.tivoli.tip.navwidget.iwidget.event.Resource");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.Trace");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.event.Event",null,{
	name:null,
	payload:null,
	_event_trace:null,
	constructor: function constructor(args){
		this._event_trace=ibm.tivoli.tip.navwidget.iwidget.Trace(this,['_initEvent','_addResource','getResources','getResourcesByProviderType',
		                                                               'toJson','getPayload','_createNewEvent','_createResource','_populateExistingEvent']);
		this._initEvent(args);
	},
	_initEvent: function _initEvent(args){
		if(typeof args === 'string'){
			this._createNewEvent(args);
		} else {
			this._populateExistingEvent(args);
		}
	},
	_addResource: function _addResource(resource){
		this.payload.resources.push(resource);
	},
	getResources: function getResources(){
		return this.payload.resources;
	},
	getResourcesByProviderType: function getResourcesByProviderType(type){
		var resources=[];
		dojo.forEach(this.payload.resources,function(resource){
			if(resource.product&&resource.product[type]){
				resources.push(resource);
			}
		});
		if(resources.length===this.payload.resources.length){
			return resources;
		}
		return [];
	},
	toJson: function toJson(){
		return dojo.toJson({name:this.name,payload:this.getPayload()});
	},
	getPayload: function getPayload(){
		var payload={resources:[]};
		var addResource=function(resource){
			var resourceJson=resource.toJson();
			payload.resources.push(resourceJson);
		};
		dojo.forEach(this.payload.resources,addResource);
		return payload;
	},
	_createNewEvent: function _createNewEvent(eventName){
		this.name=eventName;
		this.payload={resources:[]};		
	},
	_createResource: function _createResource(json){
		return new ibm.tivoli.tip.navwidget.iwidget.event.Resource(json);
	},
	_populateExistingEvent: function _populateExistingEvent(event){
		this.name=event.name;
		this.payload={resources:[]};
		if(!event.payload.resources){
			this._addResource(this._createResource(event.payload));
		} else {
			var processResource=function(json){
				this._addResource(this._createResource(json));
			};
			dojo.forEach(event.payload.resources,dojo.hitch(this,processResource));
		}
	}
});