dojo.provide("ibm.tivoli.tip.navwidget.iwidget.event.EventReceiver");

dojo.require("ibm.tivoli.navmodel.ProviderUtils");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.event.Event");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.Trace");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.event.NameMatchDatasetFactory");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.event.TypeMatchDatasetFactory");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.event.AllMatchDatasetFactory");
dojo.declare("ibm.tivoli.tip.navwidget.iwidget.event.EventReceiver",[],{
	providerType:null,
	dataset:null,
	datasetFactories:null,
	_iw_er_trace:null,
	_eventQueue:null,
	_isReadyToProcess:0,
	constructor: function constructor(){
		this._iw_er_trace=new ibm.tivoli.tip.navwidget.iwidget.Trace(this,["initEventReceiver","_getProvidersByType","processEvent","setDataset",
		                                                             "_getDatasetProviderType","onEvent","destroy","queueEvent","startProcessingEvents"]);
		this._eventQueue=[];
	},
	setDataset: function setDataset(dataset){
		this.inherited(arguments);
		this.initEventReceiver(this.dataset);
	},
	initEventReceiver: function initEventReceiver(dataset){
		this.dataset=dataset;
		this.providerType=this._getDatasetProviderType(dataset);
		var providers=this._getProvidersByType(this.providerType);
		var providersCache={};
		this.datasetFactories=[];		
		dojo.forEach(providers,dojo.hitch(this,function(provider){
			var mssName=provider.getMSSName();
			var typeMatchFound=false;
			var allMatchFound=false;
			if(mssName){
				providersCache[mssName]=provider;
				var matchOn=provider.getAttribute("matchOn");
				if(!typeMatchFound&&matchOn==='type'){
					this.datasetFactories.unshift(new ibm.tivoli.tip.navwidget.iwidget.event.TypeMatchDatasetFactory(dataset,provider));
					typeMatchFound=true;
				}else if(!allMatchFound&&matchOn==='all'){
					this.datasetFactories.push(new ibm.tivoli.tip.navwidget.iwidget.event.AllMatchDatasetFactory(dataset,provider));
					allMatchFound=true;
				}
			}
		}));
		this.datasetFactories.unshift(new ibm.tivoli.tip.navwidget.iwidget.event.NameMatchDatasetFactory(dataset,this.providerType,providersCache));
	},
	_getDatasetProviderType: function _getDatasetProviderType(dataset){
		var providerId=dataset.getProviderId();
		var provider=ibm.tivoli.navmodel.ProviderUtils.getProviderById({
				baseUrl:dataset.getArg("baseUrl"),
				provider:providerId				
		});
		return provider.getType();		
	},
	_getProvidersByType: function _getProvidersByType(type){
		var providers=[];
		var args={
			baseUrl:this.dataset.getArg("baseUrl"),
			sync:true,
			condition:"(type = '"+type+"')",
			onComplete: dojo.hitch(this,function(provs){
				providers=provs;
			})
		};
		ibm.tivoli.navmodel.ProviderUtils.getProviders(args);
		return providers;
	},
	queueEvent: function queueEvent(json){
		if(this._isReadyToProcess<1){
			this._eventQueue.push(json);
		} else {
			this.processEvent(json);
		}
	},
	processEvent: function processEvent(json){
		var id=Math.floor(Math.random()*-1000);
		this.pauseProcessingEvents(id);
		try{
			var event=new ibm.tivoli.tip.navwidget.iwidget.event.Event(json);
			var allResourcesLength=event.getResources().length;
			var resources=event.getResourcesByProviderType(this.providerType);
			if(resources.length===allResourcesLength){
				var correlationDataset=null;
				if(allResourcesLength!==0){
					dojo.some(this.datasetFactories,function(factory){
						correlationDataset=factory.createDataset(resources,event);
						return correlationDataset;
					});
					if(!correlationDataset){return false;}
				}
				this.onEvent(event,correlationDataset);
			}
		}finally{
			this.startProcessingEvents(id)
		}
	},
	pauseProcessingEvents: function pauseProcessingEvents(id){
		console.log("Processing events, all incoming events will be queued.");
		this._isReadyToProcess=id;
	},
	startProcessingEvents: function startProcessingEvents(id){
		console.log("Ready to process events");
		if(id===this._isReadyToProcess || this._isReadyToProcess===0){
			this._isReadyToProcess=1;
			while(this._eventQueue.length>0){
				this.processEvent(this._eventQueue.pop());
			}
		}
	},
	onEvent: function onEvent(/*ibm.tivoli.tip.navwidget.iwidget.event.Event*/event,/*ibm.tivoli.tip.navwidget.iwidget.ConditionDataset*/dataset){},	
	destroy: function destroy(){
		if(this._iw_er_trace){this._iw_er_trace.destroy();}
		this.inherited(arguments);
	}
});