dojo.provide("ibm.tivoli.tip.navwidget.iwidget.event.ItemResource");

dojo.require("ibm.tivoli.tip.navwidget.iwidget.event.Resource");
dojo.require("ibm.tivoli.navmodel.ProviderUtils");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.DatasetUtils");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.event.ItemResource",[ibm.tivoli.tip.navwidget.iwidget.event.Resource],{
	datasetParamTypesCache:{},
	constructor:function constructor(){},
	_createResource: function _createResource(item){
		ibm.tivoli.tip.navwidget.iwidget.Trace(this,["_setProvider","_getDatasetParameterTypes","_getItemProperties","_processProperty"]);
		if(dojo.exists("getDataset",item)){
			var dataset=item.getDataset();
			var providerId=dataset.getProviderId();
			var provider=ibm.tivoli.navmodel.ProviderUtils.getProviderById({
				provider:providerId,
				baseUrl:"/ibm/tivoli/rest"
			});
			dojo.forEach(this._getItemProperties(item),dojo.hitch(this,dojo.partial(this._processProperty,item,provider)));
			this._setProvider(item,provider);
			if(item.getDataset()){
				this.ItemId=item.getId();
				this.DatasetId=item.getDataset().getId();
			}
		} else {
			this.inherited(arguments);
		}
	},
	_cleanToJson: function _cleanToJson(json){
		delete json.datasetParamTypesCache;
		this.inherited(arguments);
	},
	_setProvider: function _setProvider(item,provider){
		var providerType=item.getProperty("type");
		providerType=providerType?providerType.getValue():provider.getType();
		if(providerType){
			this.product={};
			this.product[providerType]={};
			var mssName=item.getProperty("MSSName");
			mssName=mssName?mssName.getValue():provider.getMSSName();
			var prodName=item.getProperty("ProductName");
			prodName=prodName?prodName.getValue():provider.getAttribute("ProductName");
			var sourceToken=item.getProperty("SourceToken");
			if(mssName||prodName||sourceToken){
				this.product[providerType].cdm={};
				if(mssName){
					this.product[providerType].cdm.MSSName=mssName;			
				}
				if(prodName){
					this.product[providerType].cdm.ProductName=prodName;			
				}
				if(sourceToken){
					this.product[providerType].cdm.SourceToken=sourceToken;
				}
			}
		}
	},
	_getDatasetParameterTypes: function _getDatasetParameterTypes(item){
		var dataset=item.getDataset();
		var key=dataset.getProviderId()+"|"+dataset.getDatasourceId()+"|"+dataset.getId();		
		var paramTypes=this.datasetParamTypesCache[key];
		if(!paramTypes){
			var params=ibm.tivoli.tip.navwidget.iwidget.DatasetUtils.getParameters(item.getDataset());
			paramTypes={};
			dojo.forEach(params,function(param){
				paramTypes[param.id]=param.type;
			});
			this.datasetParamTypesCache[key]=paramTypes;
		}
		return paramTypes;
	},
	_getItemProperties: function _getItemProperties(item){		
		item.getProperties({sync:true});
		return item.getCachedPropertyIds(true);
	},
	_processProperty: function _processProperty(item,provider,id){
		var paramTypes=this._getDatasetParameterTypes(item);
		var propType=paramTypes[id];
		if(propType==='long' || propType==='string'){
			var propValue=item.getProperty(id).getValue();
			if(propValue!==null && typeof propValue !== 'undefined'){
				switch(id){
					case "ProviderType":
					case "MSSName":
					case "ProductName":
					case "SourceToken":
					break;
					case "ClassType":
						var cdmAttrs1=this._getCdmAttrs();
						cdmAttrs1.ClassType=propValue;
					break;
					default:
						if(this._isCdmAttribute(id)){
							var cdmAttrs2=this._getCdmAttrs();
							cdmAttrs2[id]=propValue;
						} else if(this._isTargettedProductAttribute(id)){
							var providerType=provider.getType();
							if(providerType){
								this._getProviderTypeCdm(providerType)[id]=propValue;
							}
						} else {
							this[id]=propValue;
						}
					break;
				}
			}
		}
	}
});