dojo.provide("ibm.tivoli.tip.navwidget.iwidget.event.Resource");

dojo.require("ibm.tivoli.navmodel.ProviderUtils");
dojo.require("ibm.tivoli.tip.navwidget.iwidget.Trace");

dojo.declare("ibm.tivoli.tip.navwidget.iwidget.event.Resource",null,{
	_payload:null,
	constructor: function constructor(args){		
		ibm.tivoli.tip.navwidget.iwidget.Trace(this,["_createResource","toJson","getMSSNameByProviderType","getSourceTokenByProviderType",
		                                                                  "_getProviderTypeCdm","_getCdmAttrs","_isCdmAttribute","_isTargettedProductAttribute",
		                                                                  "getAvailableAttributes","getAttrValue"]);
		this._createResource(args);
	},
	_createResource: function _createResource(json){
		var prop=null;
		for(prop in json){
			if(dojo.isString(prop)){
				this[prop]=json[prop];
			}
		}
		if(json.product){this.product=json.product;}
		if(json.cdm){this.cdm=json.cdm;}
	},
	toJson: function toJson(){
		if(this._payload){return this._payload;}
		var json=dojo.fromJson(dojo.toJson(this));
		this._cleanToJson(json);
		this._payload=json;
		return json;
	},
	_cleanToJson: function _cleanToJson(json){
		delete json.declaredClass;
		delete json._payload;
	},
	getMSSNameByProviderType: function getMSSNameByProviderType(providerType){
		if(providerType&&this.product[providerType]&&this.product[providerType].cdm){
			return this.product[providerType].cdm.MSSName;
		}
		return null;
	},
	getSourceTokenByProviderType: function getSourceTokenByProviderType(providerType){
		if(providerType&&this.product[providerType]&&this.product[providerType].cdm){
			return this.product[providerType].cdm.SourceToken;
		}
		return null;
	},
	_getProviderTypeCdm: function _getProviderTypeCdm(providerType){
		if(!this.product[providerType].cdm){
			this.product[providerType].cdm={};
		}
		return this.product[providerType].cdm;
	},
	_getCdmAttrs: function _getCdmAttrs(){
		if(!this.cdm){
			this.cdm={attributes:{}};
		}
		return this.cdm.attributes;
	},
	_isCdmAttribute: function _isCdmAttribute(attrName){
		return false;
	},
	_isTargettedProductAttribute: function _isTargettedProductAttribute(attrName){
		return false;
	},
	getAvailableAttributes: function getAvailableAttributes(providerType){
		var payload=this.toJson();
		var result={};
		var addToResult=function(type,value){
			if(!result[type]){result[type]=[];}
			result[type].push(value);
		};
		var attr=null;
		for(attr in payload) {
		   if(payload[attr]!==null){
			   if(attr==="product" && payload.product){
				    var type=null;
				    for(type in payload.product){
				    	if(payload.product.hasOwnProperty(type) && (!providerType||type===providerType)){
							var product = payload.product[type];
							var prodName=null;
							for (prodName in product){
								if(prodName === "cdm"){
									var prodCdm=null;
									for(prodCdm in product.cdm){
										if(product.cdm.hasOwnProperty(prodCdm)){
											addToResult(type,prodCdm);
										}
									}
								} else {
									addToResult(type,prodName);
								}
							}
				    	}
				    }
			   } else if (attr==="cdm" && payload.cdm && payload.cdm.attributes){
				   var attr1=null;
					for (attr1 in payload.cdm.attributes) {
						if(payload.cdm.attributes.hasOwnProperty(attr1)){
							addToResult('_NONE_',attr1);
						}
					}
			   } else if (attr !== "product" && attr !== "framework" && attr !== "resources"){
				    addToResult('_NONE_',attr);
			   }
		   }
		}
		return result;
	},
	getAttrValue: function getAttrValue(attrName,providerType){
		var resource=this.toJson();
		if(resource.product){
			for(type in resource.product){
				if(resource.product.hasOwnProperty(type)&&(!providerType||type===providerType)){
					if(resource.product[type].cdm&&resource.product[type].cdm[attrName]){
						return resource.product[type].cdm[attrName];
					}
					if(resource.product[type][attrName]){
						return resource.product[type][attrName];
					}					
				}
			}
		}
		if(resource.cdm&&resource.cdm.attributes){
			if(resource.cdm.attributes[attrName]){
				return resource.cdm.attributes[attrName];
			}
		}
		return resource[attrName];
	}
});