/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog");

dojo.require("dijit.dijit");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("dojox.data.dom");
dojo.require("ibm.tivoli.tip.navwidget.properties.PropertyRenderer");
dojo.require("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebook");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");

ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog");

dojo.declare("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog",
		[dijit.Dialog, ibm.tivoli.tip.navwidget.dijit.NavWidgetObjectPluggableView],
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		//***************************
		// "Public"
		//***************************	
  	

		//*************************** 
		// "Private"
		//***************************	
	
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
	    _trace: ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog._trace,
	    
	    // _propNotebook: [private]
	    //		Coming soon
	    _propNotebook: null,

		constructor: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//set title
			this.title =  this.commonResources.PROPERTIES;
			
	        //We don't have a widget def specific to this view, so let's signal to 
	        //super class not to try and load any widget defs on our behalf
			this._usesWidgetDefinition = false;
			
			//tab index
			this._tabIndexValueProperties=ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.tabIndexFunc();
		},
		
        
		postCreate: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Call superclass
			this.inherited(arguments);
		},
	
		_addPluggableViewToContainer: function(view) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		protected
			
			dojo.attr(this, "content", view.domNode);
		},
		
		_removePluggableViewFromContainer: function(view) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		protected
			
	//		this.setContent("nada");
		},
		
		startup: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			this.inherited(arguments);	
		},

		//override the onCancel method to also destroy the whole widget.
		//we always want to destroy the properties notebook when Dialog closed.
		onCancel: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			setTimeout('dijit.byId(\"' + this.id + '\").destroyRecursive();',200); 
			
			// the above line was not deleting the button id and so additional step
			var buttonId=this.id+"_DialogCloseButton";
			if(buttonId) {
			dijit.byId(this.id+"_DialogCloseButton").destroyRecursive();
			}
			this.inherited(arguments);			
		},
	
		destroy: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			if (this._propNotebook) {
				this._propNotebook.destroyRecursive();
				this._propNotebook = null;
			}
            
            this.inherited(arguments);
		},		

		_setDatasetCreatePluggableViews: function(items, links, relationships){	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			if (!this._propNotebook) {
				this._propNotebook = new ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebook({
					id: this.id + "_myProperties",
					parentPluggableView: this,
					widgetDefinitionId: this.widgetDefinitionId
				});
				this.addPluggableView(this._propNotebook);
				
				divHeight = 0.8 * this._getBodyHeight();
				dojo.style(this._propNotebook.domNode, "height", divHeight + "px");
				
				//adding a close button for accessibility purpose
				var closeDiv=dojo.create("div");
				
				var closeButton=new dijit.form.Button({
					id: this.id+"_DialogCloseButton",
					label:this.commonResources.CLOSE, 
					disabled: false
				},closeDiv.appendChild(dojo.create("div")));
			
			    closeDiv.className="dijitDialogPaneActionBar";
				
				dojo.connect(closeButton, "onClick",dojo.hitch(this,"onCancel"));
				dojo.place(closeDiv,this.containerNode,"last");
			
			}	
		},
		
		_getBodyHeight: function() {
			return ((window.innerHeight != undefined) ? window.innerHeight : document.body.offsetHeight);
		}
});