/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookGeneralTab");

dojo.require("dijit.dijit");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("dojox.xml.parser");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetObjectPluggableView");
dojo.require("ibm.tivoli.tip.navwidget.table.dijit.RelationshipTableViewSingleLink");
dojo.require("ibm.tivoli.tip.navwidget.properties.PropertyRenderer");

ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookGeneralTab._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookGeneralTab");

dojo.declare("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookGeneralTab",
		[dijit.layout.BorderContainer, ibm.tivoli.tip.navwidget.dijit.NavWidgetObjectPluggableView],
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
        //***************************
        // "Public"
        //***************************
	
		// maxProperties: [public] Object
		//		set maxProperties to null to display all properties
		maxProperties: null,


        //***************************
        // "Private"
        //***************************
        
       // _propertyTabs: null,
		
		// _generalTabContentDiv: [private] Object
		//		Coming soon
        _generalTabContentDiv: null,
        
        //_outerDivTooltip: [private] Object
        // Coming soon
        _outerDivTooltip: null,
        
		// _generalTabPropGrid: [private] Object
		//		Coming soon
        _generalTabPropGrid: null,
        
		// _generalTabPropGridTable: [private] Object
		//		Coming soon
        _generalTabPropGridTable: null,     
        
        // _generalTabPropGridTooltip: [private] Object
		//		Coming soon
        _generalTabPropGridTooltip: null,
        
		// _generalTabPropGridTableTooltip: [private] Object
		//		Coming soon
        _generalTabPropGridTableTooltip: null, 
        
		// _object: [private] Object
		//		Coming soon
        _object: null,
        
		// _propertyRendererObj: [private] Object
		//		Coming soon
        _propertyRendererObj: null,
        
		// _generalTab: [private] Object
		//		Coming soon
        _generalTab: null,
        
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
        _trace: ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookGeneralTab._trace, 
        
        // _propsRendered: [private] int
        //		Coming soon
        _propsRendered: 0,
        
        // _relTable: [private] Object
        //		Coming soon
        _relTable: null,
        
        // _isTooltipProperties: [protected] Boolean
        //		Coming soon
        _isTooltipProperties: false,
        
        //_tabIndexValueProperties: [private] integer
        _tabIndexValueProperties:0,

        //***************************
        // "Public functions"
        //***************************       
        constructor: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
            this._propertyTabs = new Array();
            this._propertyRendererObj = new ibm.tivoli.tip.navwidget.properties.PropertyRenderer();          
            
	        //We don't have a widget def specific to this view, so let's signal to 
	        //super class not to try and load any widget defs on our behalf
			this._usesWidgetDefinition = false;
			
			//Signal to superclass we'll be firing onSetObjectsLoadComplete manually
			this._setObjectsLoadDataCompletesSynchronously = false;			
        },

        destroy: function() {
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
            this.inherited(arguments);
        },

        postCreate: function() {
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	this._addGeneralTab();
        	this.title = this.commonResources.GENERAL;
        	this.addChild(this._generalTab);
           
        	this.inherited(arguments);
            
        },

        startup: function() {		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
            this.inherited(arguments);
            
            
        },
        
        getContent: function(){		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	
        	//return  this._generalTabPropGrid.innerHTML;
        	
        	//return the content...since tooltip will grab inner HTML...no need to do here.
        	//just return the content pane
        	return this._generalTab;
        },
        
    	handleLinkClickAction: function(viewId, objectId, propId){
    		
    		console.log("handling link click for properties view");
    		var object;
    		var property;
    		
    		
    		if(this._object){
    			property = this._object.getProperty(propId);
    		}
    		
    		if(property){
    			this._propertyRendererObj._handleLinkClick(property, this);
    		}
    	},

        _setObjectsLoadData: function(/*ibm.tivoli.navmodel.Item[]*/ items, /*ibm.tivoli.navmodel.Link[]*/ links, /*ibm.tivoli.navmodel.Relationship[]*/ relationships){		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	// items:
        	//		Coming soon
        	// links:
        	//		Coming soon
        	// relationships:
        	//		Coming soon
        	
        	//Clean up old dom tree
        	this._cleanUpOldDomTree();
            	
        	if (this.isMixedObjects()) {
            	//TODO: For now just log, but need to remove this and do something more useful in the end
        		console.log("Cannot currently deal with mixed content passed to GeneralTab: itemCount = "+ this.getItemCount() + ", linkCount = " + this.getLinkCount() + ", relationshipCount = " + this.getRelationshipCount());
        	
        		// fire _onSetDatasetLoadComplete
				setTimeout(dojo.hitch(this, this._onSetObjectsLoadComplete, items, links, relationships), 0);
        	} else if (this.getItemCount() > 0) {
		        	//Get properties for the new item in order to populate the new properties grid. If more than one item, for now just use the first one.
		        	this._object = items[0];
		        	this._object.getProperties({
		        		onComplete: dojo.hitch(this, this._populateGeneralTab),
		        		onError: dojo.hitch(this, this._populateGeneralTabError),
		        		properties: ["all"],
		        		metadata: true});
        	} else if (this.getLinkCount() > 0) {
        		//treat a link just like an item for now.  the populateGeneralTab will render both item and link properties
        			this._object = links[0];
        	
        		//render the relationships table if not a tooltip (and not only one rel)
        		if( !(this.maxProperties) && (this._object.getRelationshipCount()>1) ){
           	    	this._relTable = new ibm.tivoli.tip.navwidget.table.dijit.RelationshipTableViewSingleLink();
           	    	this._relTable.removeToolbar = true;
           	    	this.addPluggableView(this._relTable);//pjj
        			this._relTable.setDataset(this.dataset);
        			//this._relTable.setObjects([],links);
					
					//254228 FF4, IE9: wrong properties view for double directed links 
					//255025 IE9FF3.6TIPGeneral Properties & double linked propertiesoverlap 
					//Bobby: 11Dec11, adding a new class for relTable - BEGIN					
					//dojo.style(this._relTable.domNode, {position:'relative !important'});
					dojo.addClass(this._relTable.domNode, "relationshipTableView");
        			//Bobby: 11Dec11, adding a new class for relTable - END
					
        			//var vp = dijit.getViewport();
    				//var tablesize = { w: (vp.w*.4)-125, h: (vp.h) };
        			//this._relTable.resize(tablesize);
        		}
				
        			
        			this._object.getProperties({
        				onComplete: dojo.hitch(this, this._populateGeneralTab),
        				onError: dojo.hitch(this, this._populateGeneralTabError),
        				properties: ["all"],
        				metadata: true});
        	}else if (this.getRelationshipCount() > 0) {
	        	//Get properties for the new item in order to populate the new properties grid. If more than one item, for now just use the first one.
	        	this._object = relationships[0];
	        	this._object.getProperties({
	        		onComplete: dojo.hitch(this, this._populateGeneralTab),
	        		onError: dojo.hitch(this, this._populateGeneralTabError),
	        		properties: ["all"],
	        		metadata: true});
        	}else {
        		//For example, when setObjects gets all empty lists...
        		
        		// fire _onSetDatasetLoadComplete
				setTimeout(dojo.hitch(this, this._onSetObjectsLoadComplete, items, links, relationships), 0);
        	}
        	
        	//Call superclass
        	this.inherited(arguments);
        },
        
        clearObjects: function(){
        	this._cleanUpOldDomTree();
        	
        	//Call super class
        	this.inherited(arguments);
    	},
    	
    	_cleanUpOldDomTree: function() {
    		//Remove previously added properties grid //250874 -- changed to remove this._outerDivTooltip instead of this._generalTabPropGridTable
        	if (this._outerDivTooltip) {
        		var domNode = this._generalTab.domNode;
	        	domNode.removeChild(this._outerDivTooltip);
	        	this._outerDivTooltip = null;
        	}

       	if (this._relTable && this._relTable.domNode) {
			  var domNode = this._generalTab.domNode;
		        domNode.removeChild(this._relTable.domNode);
			  this.removePluggableView(this._relTable);
			  this._relTable.destroyRecursive();
		        this._relTable = null;
			}		
    	},

        //***************************
        // "private functions"
        //*************************** 
        _addGeneralTab: function() {
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
            this._generalTabContentDiv = dojo.doc.createElement("div");
            // TODO namespace the div
            this._generalTabContentDiv.id = this.id + "_generalTab_busy_pane_container";

            this._generalTab = new dijit.layout.ContentPane({
                id: this.id + "generalTab",
                title: this.commonResources.GENERAL,
                content: this._generalTabContentDiv,
                //need this style in order to get scroll tab
                style: "height:100%;width:100%;"
            });
            // setting the title for the general tab of properties, screen reader does not read the above title
			dojo.attr(this._generalTab.domNode,"title",this.commonResources.GENERAL);
        },

        _sortProperties: function(/*ibm.tivoli.navmodel.Property*/ a, /*ibm.tivoli.navmodel.Property*/ b) {		
    		// summary:
    		//		Function used to determine how to sort an array of properties.
        	//		This function assumes two Properties objects passed in and
        	//		it will then sort based on the Weight of the item
        	//		if weights are equal it will sort lexigraphically
    		// description:
    		//		Coming soon
        	// a:
        	//		Coming soon
        	// b:
        	//		Coming soon
        	var retval = 0;
        	retval = a.getSortWeight() - b.getSortWeight();
        	
        	if(retval == 0){
        		//sort lexigraphically
			var first = a.getLabel();
			var second = b.getLabel();
        		retval = first - second;
			if( isNaN(retval)  ){
				//compare normal lexigraphically
				if( first === second){
					//they are equal return 0
					retval = 0;
				}else{
					//else let the normal array sort figure this out (since it does lex sort)
					var compares = [first,second];
					var sorted = compares.sort();

					if( first === sorted[0] ){
						//first is bigger than second since it remained first after sort
						retval = -1;
					}else{
						//since first did not stay first, it must be second, and is thus smaller then second
						retval = 1;
					}
				}
				
			}
        		return retval;
        	}else{
        		return retval;
        	}
        },
        
		/*=====
		populateGeneralTab_kwArgs: function() {
		
		},
		=====*/
        _populateGeneralTab: function(/*ibm.tivoli.navmodel.Property[]*/ properties, /*populateGeneralTab_kwArgs*/ kwArgs) {
        	// summary:
        	//		Call back on successfully retrieving the properties of an item
        	// description:
        	//		Coming soon
        	// properties:
        	//		Coming soon
        	// kwArgs:
        	//		Coming soon

        	if (this.isDestroyed()) {
        		//Especially in the tooltip case... it's possible our request for properties is satisfied AFTER we've
        		//been destroyed. So, let's special case that
        		return;
        	}
        	
        	//outer div with the two tables
        	this._outerDivTooltip=dojo.doc.createElement("div");

        	// tooltip table
			this._generalTabPropGridTableTooltip = dojo.doc.createElement("table");
			this._generalTabPropGridTableTooltip.setAttribute('cellSpacing','3'); 
			this._generalTabPropGridTableTooltip.setAttribute('role','presentation');    // 255868
			this._generalTabPropGridTooltip = dojo.doc.createElement("tbody");
			
			
        	this._generalTabPropGridTable = dojo.doc.createElement("table");
        	this._generalTabPropGridTable.setAttribute('cellSpacing','3'); 
        	this._generalTabPropGridTable.setAttribute('role','presentation');    // 255868
        	this._generalTabPropGrid = dojo.doc.createElement("tbody");

        	
        	
        	if (this._isTooltipProperties){
        	// style for the second table
        		this._generalTabPropGridTable.className="tooltipTableGap";
        	}
            else {
                // If this is not a tooltip (i.e., actual notebook) associate the DIV containing
            	// properties content with being labeled by the tab node and if the top content
            	// node of the tabbed page does not have a role already, set it to "document" so
            	// a screen reader will read this text content (content does not have a focussable
            	// field)
                dojo.attr(this._outerDivTooltip, "aria-labelledby", this._generalTab.domNode.id);  
                if (!dojo.hasAttr(this._generalTab.domNode.parentNode, "role")) {      
                   dojo.attr(this._generalTab.domNode.parentNode, "role", "document");   
                }
             }
        	
        	
        	//first Render special properties...name, statuses, and type
        	
        	//first find name only (only one of these should exist)
        	var nameprop = null;
        		
        	nameprop = this._getPropertyType(properties, "itemName");   
        	if(!nameprop){
        		nameprop = this._getPropertyType(properties, "linkName");
        	}	
        	if(!nameprop){
        		nameprop = this._getPropertyType(properties, "relationshipName");       	    	
        	}	
        	//generate the name row and add to table if it exists!
        	if(nameprop){
        		var namerow = this._createPropTableRow(nameprop);
        		// tooltip table specific 
        		if(this._isTooltipProperties) {
        			dojo.place(namerow,this._generalTabPropGridTooltip,"last");
        		} else {
        			dojo.place(namerow, this._generalTabPropGrid, "last");
        		}
        	}
        	
        	//render to and from values for rel and links if supplied as properties
        	var item1Prop = this._getPropertyType(properties, "item1");        	
        	if(item1Prop){
        		var i1row = this._createPropTableRow(item1Prop);
        		//tooltip specific
        		if(this._isTooltipProperties)
    			dojo.place(i1row,this._generalTabPropGridTooltip,"last");
    			else
        		dojo.place(i1row, this._generalTabPropGrid, "last");
        	}
        	
        	var item2Prop = this._getPropertyType(properties, "item2");        	
        	if(item2Prop){
        		var i2row = this._createPropTableRow(item2Prop);
        		//tooltip specific
        		if(this._isTooltipProperties)
    			dojo.place(i2row,this._generalTabPropGridTooltip,"last");
    			else
        		dojo.place(i2row, this._generalTabPropGrid, "last");
        	}
        	
        	var relSourceProp = this._getPropertyType(properties, "sourceItem");        	
        	if(relSourceProp){
        		var sourceRow = this._createPropTableRow(relSourceRow);
        		//tooltip specific
        		if(this._isTooltipProperties)
    			dojo.place(sourcerow,this._generalTabPropGridTooltip,"last");
    			else
        		dojo.place(sourceRow, this._generalTabPropGrid, "last");
        	}
        	
        	var relTargetProp = this._getPropertyType(properties, "targetItem");       	
        	if(relTargetProp){
        		var targetRow = this._createPropTableRow(relTargetRow);
        		//tooltip specific
        		if(this._isTooltipProperties)
    			dojo.place(targetRow,this._generalTabPropGridTooltip,"last");
    			else
        		dojo.place(targetRow, this._generalTabPropGrid, "last");
        	}
        	
	  		//now render status if it exists
    		//find status
    		var statprop = this._getStatuses(properties);
    		for(var i=0; i<statprop.length; i++){    			
    			var statusrow = this._createPropTableRow(statprop[i]);
    			//tooltip specific
    			if(this._isTooltipProperties)
    			dojo.place(statusrow,this._generalTabPropGridTooltip,"last");
    			else
    			dojo.place(statusrow, this._generalTabPropGrid, "last");
    		}
    		
    		//find itemType only 
        	var typeprop = this._getPropertyType(properties, "itemType");	
        	//generate the type row and add to table if exists
        	if(typeprop != null){
        		var typerow = this._createPropTableRow(typeprop);
        		dojo.place(typerow, this._generalTabPropGrid,"last");
        	}
    		
    		//First sort the properties based on weight and label name
    		//
    	    properties.sort(this._sortProperties);	
    		
    		//
        	//Render all other properties except name, type, or statuses
    	    for(var i=0; i < properties.length; ++i) {
				
    	    	if(properties[i].isHidden()){
	        		//skip rendering hidden property and continue rendering the other properties
	        		continue;
    	    	}
    	    	
    	    	var propValType = properties[i].getValueType();
        		//First check to make sure this item is not the Name or Type
        		if( (propValType == "itemName") || ((propValType == "linkName") || (propValType == "relationshipName") || (propValType == "item1") || (propValType == "item2") || (propValType == "sourceItem") || (propValType == "targetItem") || propValType == "itemType") || (propValType == "status") ){
        			//skip rendering this property and continue rendering the other properties
        			continue;
        		}
        	       	
        		if(this.maxProperties != null){
        			//only render maxProperties
        			if(this.maxProperties < ++this._propsRendered){
        				break;
        			}
        		}
        		//create the property table row and add it to the table
        		var row = this._createPropTableRow(properties[i]);
        		dojo.place(row, this._generalTabPropGrid,"last");
        	}
    	    
        	dojo.place(this._generalTabPropGrid, this._generalTabPropGridTable,"last");
        	//tooltip table
        	dojo.place(this._generalTabPropGridTooltip, this._generalTabPropGridTableTooltip,"last");
        	
        	dojo.place(this._generalTabPropGridTableTooltip, this._outerDivTooltip, "last");
			dojo.place(this._generalTabPropGridTable, this._outerDivTooltip, "last");
        	
			
        	dojo.place(this._outerDivTooltip, this._generalTab.domNode, "last");

       	//If links, then render the relationship table
            var type = this._object.declaredClass;
     	    if( !(this.maxProperties) && (type == "ibm.tivoli.navmodel.Link") && (this._object.getRelationshipCount()>1) ){
     	    	//first render table header:
     	    	var tableLabelRow = dojo.doc.createElement("tr"); //row
     	        var tableLabelCell = dojo.doc.createElement("td"); //cell
     	        var tableCellLabel = dojo.doc.createTextNode(this.commonResources.RELATIONSHIP_VIEW + ":");
     	        dojo.place(tableCellLabel, tableLabelCell,"last");
     	        dojo.place(tableLabelCell, tableLabelRow,"last");         	        	
				dojo.place(tableLabelRow, this._generalTabPropGrid ,"last");	
     	        dojo.place(this._relTable.domNode, this._generalTab.domNode, "last");
     	    }
				
            //fire the _onSetObjectsLoadComplete event
            this._onSetObjectsLoadComplete(this._items, this._links, this._relationships);
        },

        _populateGeneralTabError: function(error, exception, ioArgs) {		
    		// summary:
    		//		Call back on errors on getting properties
    		// description:
    		//		Coming soon
        	// error:
        	//		Coming soon
        	// exception:
        	//		Coming soon
        	// ioArgs:
        	//		Coming soon
        	
        	//fire the _onSetObjectsLoadComplete event
            this._onSetObjectsLoadComplete(this.items, this.links, this.relationships);
            
            //Give the user some feedback
            this.displayException(error);
        },
        
        _getStatuses: function(/*ibm.tivoli.navmodel.Property[]*/ props){
        	// summary:
    		//		Simple method to get all status properties
    		// description:
    		//		Coming soon
        	// props:
        	//		Coming soon
        	// type:
        	//		Coming soon
        	var statusesArray = new Array();
        	for(var i=0; i<props.length; ++i){
    			if(props[i].getValueType() == "status"){
    				statusesArray.push(props[i]);  
    			}
    		}
    		return statusesArray;        	
        },
        
        _getPropertyType: function(/*ibm.tivoli.navmodel.Property[]*/ props, /*String*/ type){		
    		// summary:
    		//		Simple method to get a specific 1st property based on value type
    		// description:
    		//		Coming soon
        	// props:
        	//		Coming soon
        	// type:
        	//		Coming soon
        	
        	//for now just loop through array until we find it
        	for(var i=0; i<props.length; ++i){
        		//console.log(properties[i].getValueType() + ":" + properties[i].getId() +":"+ properties[i].getValue());        	          	    
    			if(props[i].getValueType() == type){
    				return props[i];
    			}
    		}    
        	//no item found, so return null
        	return null;
        },

        _createPropTableRow: function(/*ibm.tivoli.navmodel.Property*/ nameprop) { 		
    		// summary:
    		//		Function to create a single table row element for a property
    		// description:
    		//		Coming soon
        	// nameprop:
        	//		Coming soon
        	var namerow = dojo.doc.createElement("tr");

        	var nameCell = dojo.doc.createElement("td");
        	if(nameprop.getLabel()) {
        		var nameCellLabel = dojo.doc.createTextNode(nameprop.getLabel() + ":");
        		//nameCellLabel.id = nameprop.getId()+".label";
			//var labelStr =  nameprop.getId()+"_"+nameprop.getLabel()+".label";
			//dojo.attr(nameCellLabel, "id", labelStr);
        		
        		//spacing for NAME elements
        	if(this._isTooltipProperties && nameprop.getValueType()=="itemName"){	
			nameCell.className="tooltipNameSpace";
			}
        		dojo.place(nameCellLabel, nameCell,"last");
        		
        	} else {
        		var nameCellLabel = dojo.doc.createTextNode(nameprop.getId() + ":");
        		//nameCellLabel.id = nameprop.getId()+"_"+nameprop.getLabel()+".label";
        		dojo.place(nameCellLabel, nameCell, "last");
        	}
        	dojo.place(nameCell, namerow,"last");

			var nameValueCell = dojo.doc.createElement("td");
        	//call the property renderer to get the display output
        	var nameValueCellData = this._propertyRendererObj.getRenderedPropertyNode(this._object, nameprop,this);
        	//set the id of the value node...this lets us reference the value later on for dynamic update
            nameValueCellData.id = this.id + "_" + nameprop.getId()+"_"+nameprop.getLabel()+".value";
            
            // If this is not a tooltip (i.e., actual notebook view) create a labeling 
            // association between the label cell and value cell to assist screen reader software
            if (!this._isTooltipProperties) {
                nameCell.id = nameValueCellData.id + "_id";
                dojo.attr(nameValueCellData, "aria-labelledby", nameCell.id);
             }
        	
            // as per the UI guidelines, the NAME needs to be Bold
        	if(this._isTooltipProperties && nameprop.getValueType()=="itemName")
			{
			nameValueCellData.className="tooltipNameBold";
			}
			
			if(this._isTooltipProperties && nameprop.getValueType()=="status")
			{
			dojo.attr(nameValueCellData,"style","float:left;padding-bottom:2px;");
			}
			
            dojo.place(nameValueCellData, nameValueCell,"last");
            dojo.place(nameValueCell, namerow,"last");

        	return namerow;

        },
      
        _handleItemPropertiesChangedEvent: function(/*Object*/ event) {
        	//OVERWRITING handle properies changed event to update the item value if necessary
        	
    		// summary:
    		//		Handle "itemPropertiesChanged" event type.
    		// event:
    		//		An object containing information about what changed in the Dataset.
    	
             
        	if(!this._object){
        		//return if _object is not defined....maybe if event is somehow generated before rendering complete.
        		//in this case that event will be ignored.  when rendering occurs it should just grab the new value
        		return;
        	}
        	
    		//get the items that were changed from the event 
        	var itemschanged = event.getItems();
        	//get the properties that were changed from the event 
        	//two dimension array of item and the actual props changed. 
        	var propschanged = event.getProperties();
        	
        	//for each item
        	for(var i = 0; i< itemschanged.length; i++){
        		//first make sure that this item matches the correct id of the item that is open in the properties notebook
        		if(this._object.getId() == itemschanged[i].getId()){
        			//render each updated property
        			for(var j = 0; j < propschanged[i].length; j++){
        				//call property renderer to create the new value node
        				var newnode = this._propertyRendererObj.getRenderedPropertyNode(itemschanged[i],propschanged[i][j],this);
        				//actually update the value of each item that was changed
        				var orignode = dojo.byId(this.id + "_" + propschanged[i][j].getId()+"_"+propschanged[i][j].getLabel()+".value"); 
        				if (orignode) {
        					dojox.xml.parser.replaceChildren(orignode, newnode);
        				}
        			}
        		}
        	}
        	      	        	
        },
          
        _handleLinkPropertiesChangedEvent: function(/*Object*/ event) {			
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon	
        	// event:
        	//		Coming soon

           	if(!this._object){
        		//return if _object is not defined....maybe if event is somehow generated before rendering complete.
        		//in this case that event will be ignored.  when rendering occurs it should just grab the new value
        		return;
        	}
        	
           	
    		//get the links that were changed from the event 
        	var linkschanged = event.getLinks();
        	//get the properties that were changed from the event 
        	//two dimension array of item and the actual props changed. 
        	var propschanged = event.getProperties();
        	
        	//for each item
        	for(var i = 0; i< linkschanged.length; i++){
        		//first make sure that this item matches the correct id of the item that is open in the properties notebook        	
        		if(this._object.getId() == linkschanged[i].getId()){
        			//render each updated property
        			for(var j = 0; j < propschanged[i].length; j++){
        		
        				//call property renderer to create the new value node
        				var newnode = this._propertyRendererObj.getRenderedPropertyNode(linkschanged[i],propschanged[i][j],this);
        				//actually update the value of each item that was changed
        				var orignode = dojo.byId(this.id + "_" + propschanged[i][j].getId()+"_"+propschanged[i][j].getLabel()+".value"); 				
        				dojox.xml.parser.replaceChildren(orignode, newnode);
        			}

        		}
        	}
        },
        
        _handleRelationshipPropertiesChangedEvent: function(/*Object*/ event) {			
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon	
        	// event:
        	//		Coming soon

           	if(!this._object){
        		//return if _object is not defined....maybe if event is somehow generated before rendering complete.
        		//in this case that event will be ignored.  when rendering occurs it should just grab the new value
        		return;
        	}
        	
           	
    		//get the relationships that were changed from the event 
        	var relationshipsChanged = event.getRelationships();
        	//get the properties that were changed from the event 
        	//two dimension array of item and the actual props changed. 
        	var propsChanged = event.getProperties();
        	
        	//for each item
        	for(var i = 0; i< relationshipsChanged.length; i++){
        		//first make sure that this item matches the correct id of the item that is open in the properties notebook        	
        		if(this._object.getId() == relationshipsChanged[i].getId()){
        			//render each updated property
        			for(var j = 0; j < propsChanged[i].length; j++){
        		
        				//call property renderer to create the new value node
        				var newnode = this._propertyRendererObj.getRenderedPropertyNode(relationshipsChanged[i],propsChanged[i][j],this);
        				//actually update the value of each item that was changed
        				var orignode = dojo.byId(this.id + "_" + propsChanged[i][j].getId()+"_"+propsChanged[i][j].getLabel()+".value"); 				
        				dojox.xml.parser.replaceChildren(orignode, newnode);
        			}
        		}
        	}
        },
        
        _handleItemsRemovedEvent: function(/*Object*/ event) {		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	// event:
        	//		Coming soon
        	if(!this._object){
        		//return if _object is not defined....maybe if event is somehow generated before rendering complete.
        		//in this case that event will be ignored.  when rendering occurs it should just grab the new value
        		return;
        	}
        	
        	//check if this item is removed...if it is then we need to make a default message
        	//with like a close window button or something
    		//get the items that were changed from the event 
        	var itemschanged = event.getItems();
        	
        	for(var i = 0; i< itemschanged.length; i++){
        		if(this._object.getId() == itemschanged[i].getId()){
        			//display default message
        			var newnode = dojo.doc.createTextNode(this.commonResources.ITEM_REMOVED_MESSAGE);
        			newnode.attr("style");
        			
        			var orignode = this._generalTab.domNode;
        			
        			//replace the old content
        			dojox.xml.parser.replaceChildren(orignode, newnode);
        		}
        	}
        },
        
        _handleLinksRemovedEvent: function(/*Object*/ event) {
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	// event:
        	//		Coming soon
        	if(!this._object){
        		//return if _object is not defined....maybe if event is somehow generated before rendering complete.
        		//in this case that event will be ignored.  when rendering occurs it should just grab the new value
        		return;
        	}
        	
        	//check if this link is removed...if it is then we need to make a default message
        	//with like a close window button or something
    		//get the links that were changed from the event 
        	var linkschanged = event.getLinks();
        	
        	for(var i = 0; i< linkschanged.length; i++){
        		if(this._object.getId() == linkschanged[i].getId()){
        			//display default message
        			var newnode = dojo.doc.createTextNode(this.commonResources.LINK_REMOVED_MESSAGE);
        			newnode.attr("style");
        			
        			var orignode = this._generalTab.domNode;
        			
        			//replace the old content
        			dojox.xml.parser.replaceChildren(orignode, newnode);
        		}
        	}
        }
        
        /*Do NOT need to handle this because this is for adding an item which will never 
         *affect the current item selected
        _handleItemsAddedEvent: function(event) {}*/
        
        //Do NOT need to handle ItemStatusChanged events either..if status is in properties it will fire
        //a property changed event in addition to a status event...the property event contains the actual
        //property object which contains the actual value that needs to be updated.
        
        /* DO NOT need to handle as this is a dataset label, not an item or properties label
        _handleLabelChangedEvent: function(event) {}*/	
        
   
    });

