/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide ("ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView");

dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.ToolbarSeparator");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dijit.MenuItem");
dojo.require("dojox.collections.Dictionary");
dojo.require("dojox.grid.DataGrid");

dojo.require("ibm.tivoli.tip.dijit.TIPContextMenu");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetObjectPluggableView");
dojo.require("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("ibm.tivoli.tip.navwidget.table.dijit.NavModelTableSelection");

dojo.require("ibm.tivoli.tip.navwidget.dojo.ToolbarUtil");

dojo.require("ibm.tivoli.tip.navwidget.properties.PropertyRenderer");
dojo.require("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyLabel");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper");

dojo.require("ibm.tivoli.navmodel.TableWidgetDef");
dojo.require("ibm.tivoli.navmodel.Exception");
dojo.require("ibm.tivoli.navmodel.Trace");

dojo.require("dojoe.table.TableAll");

dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView");

dojo.declare ("ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView",
	[dijit.layout.ContentPane, ibm.tivoli.tip.navwidget.dijit.NavWidgetObjectPluggableView],
	{
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	// cmProvider: Object
	//		Coming soon
	cmProvider: null,
		
	// removeToolbar: Object
	//		Coming soon
	removeToolbar: null,
	// removeContextMenu: Object
	//		Coming soon
	removeContextMenu: false,
	// daHelper: Object
	//		Coming soon
	daHelper: null,
		
	// height: Object
	//		Coming soon
	height: "100%",
	
	// width: Object
	//		Coming soon
	width: "100%",
	
	// enableResize: Object
	//		Coming soon
	enableResize: true,
	
	insertOnTop : false,
	
	// showClearFilterConfirmation: Object
	//		Coming soon
	showClearFilterConfirmation: true,
	
	// title: [private] Object
	//		Coming soon
	title: null,

	//***************************
	// "Private"
	//***************************
		
	// _tableContentPane: [private] Object
	//		Coming soon
	_tableContentPane: null,
	
	// _tableWidgetDefinition: [private] Object
	//		Coming soon
	_tableWidgetDefinition: null,
	
	// _propertyRenderer: [private] Object
	//		Coming soon
	_propertyRenderer: null,
	
	// _grid: [private] Object
	//		Coming soon
    _grid: null,
    	
    // _table: [private] Object
    //		Coming soon
	_table: null,
	
	// _preFilter: Object
	//		Coming soon
	_preFilter: null,
	
	// _state: Object
	//		Coming soon
	_state: null,
	
	// _condition: Object
	//		Coming soon
	_condition: null,
	
	// _tableConnections: Object
	//		Coming soon
	_tableConnections: null,

	// _tableConnections: Object
	//		Coming soon
	_widgetDefColumns: false,

	
	// _dataStore: [private] Object
	//		Coming soon
	_dataStore: null,
	_dataStoreConnects: null,

	_tableDiv: null,
	_outerDiv: null,
	
	//_tabIndexValueTable: [private] integer
	_tabIndexValueTable:0,
	
	// _defaultSelectionClassName: [private] String
	_defaultSelctionClassName: "ibm.tivoli.tip.navwidget.table.dijit.NavModelTableSelection",
	
	_actionMenuDefaultCount: 0,
	
	// _trace: [private] Trace
	//		Utility for trace and logging
	_trace: ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView._trace,

	//********************************************
	// "Protected" - to be overridden by subclasses
	//********************************************
	
	// _pTableDef: [protected] Object
	//		Coming soon
	_pTableDef: null,
	
	// _pTableClassName: [protected] String
	//		Coming soon
	_pTableClassName: null,
	
	// _pSelectionClassName: [protected] String
	//		Coming soon
	_pSelectionClassName: null,	
	
	// _pTableId: [protected] Object
	//		Coming soon
	_pTableID:null,
	
	// _pTableType: [protected] Object
	//		Coming soon
	_pTableType:null,
	
	// _pDefaultColumns: [protected] Object
	//		Coming soon
	_pDefaultColumns:null,
		
	// _DEFAULT_WIDGET_DEF_INFO:[protected] Object
	//      Coming soon
    _pDEFAULT_WIDGET_DEF_INFO: {
		className: "ibm.tivoli.navmodel.TableWidgetDef",
		baseUrl: "/ibm/tivoli/rest",
    	provider: "any",
    	datasource: "any",
    	widget: "tables",
    	definition: "DefaultTable"
	},
	
	_toolbarItemsToDestroy: null,

	// Used to help identify when an asterisk should be applied to the condition statement
	// when using enumerated/possible values.    Only used for simple table model.
	_stringFieldsWithPossibleValues: null,
	
	postCreate: function(){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this.inherited(arguments);
	},

	constructor: function (container, div, cmProvider) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this._tableConnections = [];
		this._dataStoreConnects = [];
		this._toolbarItemsToDestroy = [];
		
		this._propertyRenderer = new ibm.tivoli.tip.navwidget.properties.PropertyRenderer();
		this._propertyRenderer.propThresholdCallback = dojo.hitch(this, this._evaluatePropThreshold);
		
		this.title = this.commonResources.RELATIONSHIP_VIEW;
		this.labelIconClass = "relationshipViewIcon";
		
		//Signal to superclass we'll be firing onSetDataSetLoadComplete manually
		this._setDatasetLoadDataCompletesSynchronously = false;

		// Use the supplied context menu provider if passed in
	        if (cmProvider) {
	        	this.cmProvider = cmProvider;
	        }
	        else {
		        // create a default context menu provider
	            var helper = new ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper();
		        this.cmProvider = new ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider(
		        			{
		        				view: this,
		        				getMenuItemsCallback: dojo.hitch(helper, helper.getMenuItems),
		        				getMenuCommandCallback: dojo.hitch(helper, helper.getMenuCommand)
		        			}
		        		);	        	
	        }
	        //tab index
			this._tabIndexValueTable=ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.tabIndexFunc();

	},
	
	startup: function(){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		this.inherited(arguments);
	},
	
	destroy: function(){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		this._destroyTable();
		
		this._destroyTableStore();

		this.inherited(arguments);
	},
	
	_destroyTable: function() {
		if (this._table){
			try {
				//Hitting a case where the TED destroy processing is dying in their _Toolbar class because of an undefined variable. We will open a defect 
				//against TED. But, working around with a try/catch for now.
				if (this._grid) {
					this._grid = null;
				}				
				this._table.destroyRecursive();
			} catch (ex) {
				if (this._trace.isError()) {
					this._trace.error("problem destroying this._table in AbstractTableView = " + this.id  + "; ex = " + ex.name + ": " + ex.message, "destroy");
				}
			}
			this._table = null;
			
			dojo.forEach(this._tableConnections, dojo.disconnect);
			this._tableConnections = [];
			
			//TED not good about cleaning up custom toolbar entries, so we'll do it here.
			  if (this._toolbarItemsToDestroy) {
				  for(var i = 0; i < this._toolbarItemsToDestroy.length; ++i) {
					  this._toolbarItemsToDestroy[i].destroyRecursive();
				  }
			  }
			  this._toolbarItemsToDestroy = [];
		}
	},
	
	setFilter: function(filter){
		// summary:
		//		Sets the specified filter into the table filter
		// description:
		//		filter to set on the table, the .ruleRelation value contains the relationship
		
		//as long as table exists, call set Filter
		if(this._table){	
			if (filter) {
				this._table.setFilter(filter);
				try {
					this._grid.showFilterBar(true);
				} catch (ex) {
					// Filter bar not supported for all table types
				}
			} else {
				this._table.clearFilter();
			}
		}
	},

	// Allow programmatic hide of filter
	setFilter: function(filter, hideFilterBar){
		// summary:
		//		Sets the specified filter into the table filter
		// description:
		//		filter to set on the table, the .ruleRelation value contains the relationship
		
		//as long as table exists, call set Filter
		if(this._table){	
			if (filter) {
				this._table.setFilter(filter, hideFilterBar);
				try {
					this._grid.showFilterBar(true);
				} catch (ex) {
					// Filter bar not supported for all table types
				}
			} else {
				this._table.clearFilter(hideFilterBar);
			}
		}
	},	

	getFilter: function(){
		// summary:
		//		Return the filter data from what is set in the table filter
		// description:
		//		returns an array of conditions and a .rulRelation value that
		//      contains the relationship between the conditions.
		var retvalue;
		if(this._table ){
			retvalue = this._table.getFilter(true);
		}
		if(retvalue && retvalue.length > 0){
			for(var j = 0; j < retvalue.length; j++){
				//go thru each index and cull out the data we cant use
				var entry = retvalue[j];
				if(entry.value != undefined) {
					// 2/8/12: JCHAN: Modifications needed to date objs to msecs
					if (this.isDateObject(entry.value)){
						// date object. Convert value to msecs
						entry.value = ""+entry.value.getTime();
					} else if (typeof entry.value === "object" ) {
						// might be a range object. Convert to start and end
						if (entry.value.start&&this.isDateObject(entry.value.start)) {
							entry.value.start = ""+entry.value.start.getTime();
						}
						if (entry.value.end&&this.isDateObject(entry.value.end)) {
							entry.value.end = ""+entry.value.end.getTime();
						}
						// else the entry.value should be string value.
						if (!entry.value.end && !entry.value.start){
							entry.value = entry.value.toString();
						}
					}
					// JCHAN - END
				}
				if(entry.formattedVal != undefined){
					entry.formattedVal = entry.formattedVal.toString();
				}
			}
		}
		return retvalue;
	},

	isDateObject: function(obj) {
		return(typeof(obj)==='date')?true:(typeof(obj)==='object')?obj.constructor.toString().match(/date/i)!==null:false;
	},

	refresh: function() {
		this._table.refresh();
	},
	
	getDatasetCondition: function(){
		
		return this._condition;
		
	},
	
	getTooltip: function(){
		if(this._table  && this._table._tooltip){
			return this._table._tooltip;
		}else{
			return null;	
		}
		
	},
	
	getTooltipRolloverTarget: function(){
	
		if(this._table && this._table._rolloverTarget){
			return this._table._rolloverTarget;
		}else{
			return null;
		}
	},
	
	getTooltipRolloverCellTarget: function(){
		if(this._table && this._table._rolloverCellTarget){
			return this._table._rolloverCellTarget;
		}else{
			return null;
		}
			
	},
	
	augmentGridParams: function(gridParams) {
		// summary:
		//		Modify or add to the gridParams before creating the grid
		// description:
		//		The implementation here returns the gridParams unmodified.
		//      Subclasses may override this to add to or modify the gridParams.
		
		return gridParams;
	},
	
	_getDefaultWidgetDefInfo: function(){
		return this._pDEFAULT_WIDGET_DEF_INFO;
	},
	
	_createSelection: function(){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		//Need our own selection object
		if (!this._pSelectionClassName) {
			this._pSelectionClassName = this._defaultSelctionClassName;
		}
		var selectionClass = eval(this._pSelectionClassName);
		var kwArgs = {
				pluggableView: this
			};
		return new selectionClass(kwArgs); 
	},
	

	
	_buildTDLTable: function(){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		if (this.dataset) {			
			var providerId = this.dataset.getProviderId();
			var datasourceId = this.dataset.getDatasourceId();
			if (!datasourceId) {
				datasourceId = "any";
			}
			var datasetId = this.dataset.getId();
			
			// update widget def
			if(datasetId) {
				this._tableWidgetDefinition.setDataSetID(datasetId);
			}
			
			// column ids that we need to fetch for each item
			var columnIds = [];
			
			// Initialize string field array
			this._stringFieldsWithPossibleValues = [];
    
			//Callback to get columns from dataset
			var gotColumns = function(cols){				
				//Process the list of columns 
				var columns = [];				
				var extraColumnData = [];	
				var viewColumns = [];
				if (cols) {
					for (var index = 0;  index < cols.length;  ++index) {
						var col = cols[index];						
						// If the column is a "linkType" ignore it
						var currcol = col.getValueType();
						if (currcol !== "linkType" && currcol !== "relationshipType"){
							var colData = {};
							var extraColData = {};
							colData.id = col.getId();
							colData.label = {};
							colData.label.value = col.getLabel();
							colData.type = col.getValueType();

							// Add key attributes for unsupported operators, keyboard navigation
							extraColData.filterable = col.isFilterable();
							extraColData.unsupportedOperators = (col.getUnsupportedFilterOperators() ? col.getUnsupportedFilterOperators() : []);
							extraColData.cellNavigatable = (col.getAttribute("cellNavigatable") ? col.getAttribute("cellNavigatable") : false);
							extraColData.possibleValues = [];
							if (col.hasInlinedPossibleValues()) {
								extraColData.possibleValues = col._col.filter.possibleValues;		
								if (this.dataset.getDatasetImplementation() == ibm.tivoli.navmodel.AbstractDataset.implementation.SIMPLE
									&& col.getValueType() == "string")
									this._stringFieldsWithPossibleValues.push(colData.id);
							}
							
							// get column IDs to pass to store
							columnIds.push(colData.id);
							columns.push(colData);
							extraColumnData.push(extraColData);
							viewColumns.push(col);
						}
					}
					
					// default columns added on the front
					if(this._pDefaultColumns){
						for (var j = 0;  j < this._pDefaultColumns.length;  ++j) {
							var defColumn = this._pDefaultColumns[j];
							this._createDefaultColumnObject(columnIds,columns,viewColumns, defColumn);
						}
					}					
					
					// update the datasets.columns in the widget def
					this._tableWidgetDefinition.setDataSetColumns(columns);
					
					// update the tables.view in the widget def
					this._setTableView(viewColumns);
					
					this._widgetDefColumns = false;
					
					// init table builder	
					this._initTableBuilder(providerId, datasourceId, columnIds, this._tableWidgetDefinition.getDataSetColumns(), extraColumnData);
				}							       
			};

			// Callback to get columns from dataset for supplementing with globalized label, unsupportedOperator, 
			// cellNavigatable (keyboard/accessibility) params
			var gotColumnsForMixin = function(cols){				
				//Process the list of columns 
				var columns = [];	
				columnIds = [];
				var extraColumnData = [];				
				if (cols) {
					// widget def already has columns			
					var dsCols = this._tableWidgetDefinition.getDataSetColumns();
					for( var i = 0; i < dsCols.length; ++i) {	
						for (var j=0; j < cols.length; j++) {
							var extraColData = {};
							if (dsCols[i].id == cols[j].getId()) {
								// When label.value is empty string, replace with translated value from dataset
				  				if (dsCols[i].label.value == "") {
									dsCols[i].label.runtimeValue = cols[j].getLabel();		
								}
								// Add key attributes for unsupported operators, keyboard navigation
								extraColData.filterable = cols[j].isFilterable();
								extraColData.unsupportedOperators = (cols[j].getUnsupportedFilterOperators() ? cols[j].getUnsupportedFilterOperators() : []);
								extraColData.cellNavigatable = (cols[j].getAttribute("cellNavigatable") ? cols[j].getAttribute("cellNavigatable") : false);
								extraColData.possibleValues = [];
								if (cols[j].hasInlinedPossibleValues()) {
									extraColData.possibleValues = cols[j]._col.filter.possibleValues;
									if (this.dataset.getDatasetImplementation() == ibm.tivoli.navmodel.AbstractDataset.implementation.SIMPLE
												&& cols[j].getValueType() == "string")
										this._stringFieldsWithPossibleValues.push(cols[j].id);
								}
							
								break;
							}
						}
						// get column IDs to pass to store
						columnIds.push(dsCols[i].id);
						extraColumnData.push(extraColData);
					}				
					
					// update the datasets.columns in the widget def
					this._tableWidgetDefinition.setDataSetColumns(dsCols);
									
					// init table builder	
					this._initTableBuilder(providerId, datasourceId, columnIds, this._tableWidgetDefinition.getDataSetColumns(), extraColumnData);
				}							       
			};

			var gotColumnsError = function(error, request){
				//Give the user some feedback
		            this.displayException(error);
			};
			
			// see if columns are specified in the widget definition
			var tableView = this._tableWidgetDefinition.getTableView();
			if (tableView && tableView.length > 0) {							
				var viewLength = tableView.length;
				for (var viewIndex = 0;  viewIndex < viewLength;  ++ viewIndex) {
					columnIds.push(tableView[viewIndex].id);
				}	
				this._widgetDefColumns = true;
			}		    

			// KDM 12/6/2011:   No longer bypassing getting column information from dataset, necessary for key attributes 
			// such as translated label, unsupported operators (advanced filter), cellNavigatable (keyboard/accessibility)
			// if (columnIds.length > 0 && translated) {		
				//setTimeout(dojo.hitch(this, this._initTableBuilder, providerId, datasourceId, columnIds, this._tableWidgetDefinition.getDataSetColumns()), 0);
			// Widget def columns set, supplement including possible translate of column names
			if (columnIds.length > 0) {
				var columnArgsForMixin = {
				    type: this._pTableType,		
					onComplete: dojo.hitch(this, gotColumnsForMixin),
					onError: dojo.hitch(this, gotColumnsError),
					properties: ["all"]
				};
				this.dataset.getColumns(columnArgsForMixin);
			}
			// get columns from the dataset
			else {
				
				var columnArgs = {
				    type: this._pTableType,		
					onComplete: dojo.hitch(this, gotColumns),
					onError: dojo.hitch(this, gotColumnsError)
				};
				this.dataset.getColumns(columnArgs);
			}			
		} else {
			//Dataset is null, but we can still render an empty table
			setTimeout(dojo.hitch(this, this._initTableBuilder, null, null, [], this._tableWidgetDefinition.getDataSetColumns(), null), 0);
		}
	},
	
	_initTableBuilder: function(/*String*/ providerId, /*String*/ datasourceId, columnIds, datasetColumns, extraColData) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// providerId:
		//		
		// datasourceId:
		//		
		// columnIds:
		//		
		
		//We're going to be making a new table... let's destroy the current one
		this._destroyTable();
		
		//Destroy the old container div
		if (this._outerDiv) {
			var domNode = this.domNode;
			if(domNode){
	        		domNode.removeChild(this._outerDiv);
			}
			this._outerDiv = null;
		}
		
		//Destroy the old store; and create new one
		this._destroyTableStore();		
		this._createTableStore(columnIds);

			
		//var layout = [
		//  			{ field: "NAME", name: "Name", Width: "auto"},
		//  			{ field: "DESCRIPTION", name: "Description", Width: "auto" }					
		//  		];
		var tableDef = this._tableWidgetDefinition.getTableView();
		var sortFieldsForTable = null;
		var layout = [];
		
	
			//generate column layouts

			var regularColumns = [];
			var lockedColumns = [];
			var columnIdsSorted = [];
			
			if(this._state){
				//only process the column orders if returning from a previous state
				for( var k = 0; k < columnIds.length; ++k){		
					var order = 0;
					//first check if the state contains column orders
					if(this._state.stateData && this._state.stateData.layoutData){
						var weightEntry  = this._state.stateData.layoutData.item(columnIds[k]);
						if(weightEntry){
							var weight = weightEntry.stateColumnWeight;
							if(weight){
								//save the weight if it exists in the state for this item
								order = weight;
							}
						}
					}
					var entry = null;
					if (datasetColumns[k].label.value == "" && datasetColumns[k].label.runtimeValue) {
						entry = { id: columnIds[k], sortOrder: order, label: datasetColumns[k].label.runtimeValue, type: weightEntry.datatype };
					} else {
						entry = { id: columnIds[k], sortOrder: order, label: datasetColumns[k].label.value, type: weightEntry.datatype };
					}
					columnIdsSorted.push(entry);
				}	
				//actually sort the array now based on the weights in state
				columnIdsSorted = columnIdsSorted.sort(this._customSort);

			
			}else{
				//make a sorted object directly from each column, since already in proper order, no need to sort
				for( var k = 0; k < columnIds.length; ++k){
					var entry = null;
					if (datasetColumns[k].label.value == "" && datasetColumns[k].label.runtimeValue) {
						entry = { id: columnIds[k], sortOrder: 0, label: datasetColumns[k].label.runtimeValue, type: this._mapDataType(datasetColumns[k].type)};
					} else {
						entry = { id: columnIds[k], sortOrder: 0, label: datasetColumns[k].label.value, type: this._mapDataType(datasetColumns[k].type)};
					}
					columnIdsSorted.push(entry);
				}
			}
			
			for (var i = 0;  i < columnIdsSorted.length;  ++i) {
				//get this particular column and set into colView
				// (which either comes from widgetDef or mapped widgetDef object from dataset)
				var colView = null;
				for(var j = 0; j< tableDef.length; ++j){
					if( tableDef[j].id === columnIdsSorted[i].id){
						colView = tableDef[j];
						break;
					}
				}
				
				//defaults come from colView object 
				var hiddenFlag = colView.hidden;
				var lockedFlag = colView.lockColumn;
				
				//if we have a state with layout data, we need to check if
				//hidden flag or locked flag need to be overwritten with state value
				if(this._state && this._state.stateData && this._state.stateData.layoutData){
					var layoutEntry = this._state.stateData.layoutData.item(columnIdsSorted[i].id);
					var stateHiddenFlag = layoutEntry.hidden;
					//ensure the state value is valid
					if((stateHiddenFlag != null) && (stateHiddenFlag != undefined)){
						hiddenFlag = stateHiddenFlag;
					}	
					
					var stateLockedFlag = layoutEntry.isLocked;
					if((stateLockedFlag != null) && (stateLockedFlag != undefined)){
						lockedFlag = stateLockedFlag;
					}
				}
				
				//logic is reversed from TED flag and widgetDef
				var noResizeFlag = false;
				//only if defined as not resizeable change flag
				//this means it will be resizable if not specified
				if(!colView.resizeable && (colView.resizeable != undefined)){
					noResizeFlag = true;
				}
			
				var unsupportedArr = new Array();
				//the column descriptor that is sent to TED table
				//First, check to see if any unsupported operators to exclude
                if (extraColData[i]) {
					if (extraColData[i].unsupportedOperators) {
						var arrIdx = 0;
						for (var j = 0; j < extraColData[i].unsupportedOperators.length; j++) {
    						if (this._translateOperatorInverse(extraColData[i].unsupportedOperators[j])) {
     							unsupportedArr[arrIdx++] = this._translateOperatorInverse(extraColData[i].unsupportedOperators[j]);
            				}
						}
						// 255892: KDM 2/8/12:   Due to widget def schema issues, range operator currently unsupported
						if (this._mapDataType(datasetColumns[i].type) == "date" || this._mapDataType(datasetColumns[i].type) == "time") {
							unsupportedArr[arrIdx++] = "range";
						}
						//255236: Cannot invoke table cell task using the keyboard  
						//Bobby: 08Dec11, adding navigatable attribute to column definition - BEGIN
						//255562/KDM: Filterable dataset flag not recognized when filtering table columns
						//Due to use of searchable in widget def, the table filterable flag used it and ignored filterable from the dataset
						//Cannot remove searchable, so instead recognize and check both values in determining if column is filterable
						var columnDescriptor = { field: columnIdsSorted[i].id, width: colView.width , name: columnIdsSorted[i].label, filterable: (this._isColumnFilterSupported(datasetColumns[i].type) && colView.searchable && extraColData[i].filterable), hidden: hiddenFlag,  noresize: noResizeFlag, formatter: dojo.hitch(this, this._formatter, colView), datatype: this._mapDataType(datasetColumns[i].type), disabledConditions: unsupportedArr, navigatable: extraColData[i].cellNavigatable, dataTypeArgs:{ enumConst:extraColData[i].possibleValues}};
					} else {				
						var columnDescriptor = { field: columnIdsSorted[i].id, width: colView.width , name: columnIdsSorted[i].label, filterable: (this._isColumnFilterSupported(datasetColumns[i].type) && colView.searchable && extraColData[i].filterable), hidden: hiddenFlag,  noresize: noResizeFlag, formatter: dojo.hitch(this, this._formatter, colView), datatype: this._mapDataType(datasetColumns[i].type), navigatable: extraColData[i].cellNavigatable, dataTypeArgs:{ enumConst:extraColData[i].possibleValues}};
						//Bobby: 08Dec11, adding navigatable attribute to column definition - END
					}
				} else {
					// 255892: KDM 2/8/12:   Due to widget def schema issues, range operator currently unsupported
					if (this._mapDataType(datasetColumns[i].type) == "date" || this._mapDataType(datasetColumns[i].type) == "time") {
						unsupportedArr[0] = "range";
					}
					var columnDescriptor = { field: columnIdsSorted[i].id, width: colView.width , name: columnIdsSorted[i].label, filterable: (this._isColumnFilterSupported(datasetColumns[i].type) && colView.searchable), hidden: hiddenFlag,  noresize: noResizeFlag, formatter: dojo.hitch(this, this._formatter, colView), datatype: this._mapDataType(datasetColumns[i].type), disabledConditions: unsupportedArr};
				}
			
				//check if the lockedFlag is set for any of these columns...if so put in proper layout
				if(lockedFlag){
					//locked column, add to that array instead
					lockedColumns.push(columnDescriptor);
				}else{
					//normal column that is not locked
					regularColumns.push(columnDescriptor);
				}
				
					
				//do not allow initial sort if the column is hidden
				if(!hiddenFlag){

					//first check if we are coming from a previous state to return to
					if(this._state){
						if(this._state.stateData && this._state.stateData.sortData){
							//use the state sort data instead of the normal sort data from the widgetDef
							sortFieldsForTable = this._state.stateData.sortData;
						}
					}else{
						//check if sorted in widgetDef
						if(colView.sorted && (colView.sorted !== "none") && colView.sortOrder != -1){

							//init the array if it is not already done
							//to work around TED bug if we pass an empty array object
							if(!sortFieldsForTable){
								sortFieldsForTable = [];
							}
							//setup the flag based on sorted type
							var sortFlag = true;  //descending unless specified
							if(colView.sorted === "ascending"){
								sortFlag = false;
							}

							var sortParam = { attribute: columnIdsSorted[i].id, descending: sortFlag, ascending: !sortFlag, sortOrder: colView.sortOrder};
							sortFieldsForTable.push(sortParam);
						}
					}
				}
				
			}
			
			//now make sure we sort the presort fields before setting them in TED
			if(sortFieldsForTable && (sortFieldsForTable.length > 0) ){
				sortFieldsForTable.sort(this._customSort);
			}
			
			//check if we have any locked columns, if so put them in the locked column part of the layout
			//we are hardcoding layout to only allow two sections, one for locked columns if any, and one for
			//the normal set of columns. This means we are hardcoding the structure and locked will always
			//appear before the normal columns in the table.
			if(lockedColumns.length > 0){
				layout = [{noscroll: true, defaultCell:{ width: 8, editable: false, type: dojox.grid.cells._Widget },rows: lockedColumns}, {defaultCell:{ width: 8, editable: false, type: dojox.grid.cells._Widget },rows: regularColumns}];
			}else{
				layout = [{defaultCell:{ width: 8, editable: false, type: dojox.grid.cells._Widget },rows: regularColumns}];
			}
			
		menuOptions = {rowMenu: dojo.hitch(this, this.cmProvider)};
		
		// Check if removeToolbar is passed on constructor, if not use widgetDef
		// Need a separate hideToolbar var should a reset on the widget def occur
		var hideToolbar;
		if(this.removeToolbar == undefined){
			this.hideToolbar = this._tableWidgetDefinition.isToolbarHidden();	
		} else {
			this.hideToolbar = this.removeToolbar;
		}

		this._outerDiv = document.createElement("div");
		this._outerDiv.id = this.id + "_" + this._pTableType + "OuterContentDiv";
		dojo.style(this._outerDiv, {height: this.height, width:this.width});
		dojo.place(this._outerDiv, this.domNode, "first");

		this._tableDiv = document.createElement("div");
		this._tableDiv.id = this.id + "_" + this._pTableType + "ContentDiv";
		dojo.style(this._tableDiv, {height: this.height, width:this.width});

		dojo.place(this._tableDiv, this._outerDiv,"first");
		
		//Setting tab index for table
		dojo.attr(this._tableDiv,"tabIndex",this._tabIndexValueTable+1);
		
		var widgetDef = this._tableWidgetDefinition.getDef();
		
		//if there is state filter data, then use this
		if(this._state && this._state.stateData && this._state.stateData.filterData){
			
			this._preFilter = this._state.stateData.filterData.ruleArray;
			this._preFilter.ruleRelation = this._state.stateData.filterData.ruleRelation;

		}else{
			//check to see if a preFilter is defined in the widgetDef
			var filterDefValue = this._tableWidgetDefinition.getTableFilter();			
			if(filterDefValue) {				
				this._preFilter = filterDefValue.ruleArray;
				// 2/8/12: JCHAN: Modifications needed to convert strings to date objects
				for ( var i = 0; i < this._preFilter.length; i++ ) {
					if ( this._preFilter[i].type.match(/date|time/gi) !== null ) {
						// convert string value to Date object for date/time type
						if ( typeof this._preFilter[i].value === "object" ) {
							// start and end is for range operator
							if ( this._preFilter[i].value.start ) {
								this._preFilter[i].value.start = new Date(parseInt(this._preFilter[i].value.start));
							}
							if ( this._preFilter[i].value.end ) {
								this._preFilter[i].value.end = new Date(parseInt(this._preFilter[i].value.end));
							}
						} else {
							// for is, after and before operator
							this._preFilter[i].value = new Date(parseInt(this._preFilter[i].value));
						}
					}
				}
				// JCHAN - END
				this._preFilter.ruleRelation = filterDefValue.ruleRelation;
				// get dataset condition string
				var dataset = this._tableWidgetDefinition.getDataSet()[0];
				if (dataset.conditions) {
					this._condition = dataset.conditions.filterString;
				}
			}else{
				this._preFilter = null;
			}
		}
		
		
		var filterObj;
		var toolbarOptions;

		filterObj = {					
				advancedFilter: this._tableWidgetDefinition.getTableShowAdvancedFilter(), 
				quickFilter: this._tableWidgetDefinition.getTableShowQuickFilter(),
				isServerSide: true,				
				setupFilterQuery: dojo.hitch(this, this._translateQuery)												
		};
		
		//set filter confirmation flag if specified in widgetDef
		var cfFlag = this._tableWidgetDefinition.getTableShowClearFilterConfirmation();
		
		if( (cfFlag != undefined || cfFlag != null) && (cfFlag == false)){
			this.showClearFilterConfirmation = false;
		}

		if(!this.hideToolbar){
			this.toolbarRows = this._tableWidgetDefinition.getToolbarRows();		
			toolbarOptions = {
					refreshIcon:true,
					actionMenu:true,
					configTableIcon:true, configTableMenu: true,
					configureTreeTableIcon:true, configureTreeTableMenu:true,
					exporterIcon: true, exporterMenu: true,
					printerIcon:true, printerMenu: true											
				};
			if(this.toolbarRows){
				//check which toolbar options are disabled via widget defs
				var widgetDefsToolbarOptions = {
					refreshIcon:false,
					actionMenu:false,
					configTableIcon:false, configTableMenu: false,
					configureTreeTableIcon:false, configureTreeTableMenu:false,
					exporterIcon: false, exporterMenu: false,
					printerIcon:false, printerMenu: false											
				};
				for(var i=0;i<this.toolbarRows.length && i<2;i++){ //i<2 because TED table allows having only 2 rows (TED_1000_src_20101119_2326)
					if(!this.toolbarRows[i].hidden){
						var toolbarContents = this.toolbarRows[i].contents;
						for (var j=0; j<toolbarContents.length; j++){
							switch(toolbarContents[j].type){
								case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.PRINT_BUTTON:
									widgetDefsToolbarOptions.printerIcon = true;
									widgetDefsToolbarOptions.printerMenu = true;
									break;
								case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.CONFIG_TABLE:
									widgetDefsToolbarOptions.configTableIcon = true;
									widgetDefsToolbarOptions.configTableMenu = true;
									widgetDefsToolbarOptions.configureTreeTableIcon = true;
									widgetDefsToolbarOptions.configureTreeTableMenu = true;
									break;
								case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.EXPORT_BUTTON:
									widgetDefsToolbarOptions.exporterIcon = true;
									widgetDefsToolbarOptions.exporterMenu = true;
									break;
								case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.REFRESH_BUTTON:
									widgetDefsToolbarOptions.refreshIcon = true;
									break;
								case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.ACTION_MENU:
									widgetDefsToolbarOptions.actionMenu = true;
									break;	
								default:
									break;			
							}									
						}	
					}
				}	
				toolbarOptions = widgetDefsToolbarOptions;	
			}			
		}
		var indirectSelectFlag;
		//check if we need to disable the inderct selectoin (ie if selection type is "none")
		if(this._tableWidgetDefinition.getSelectionMode() === "none"){
			indirectSelectFlag = false;
		}else{
			indirectSelectFlag = true;
		}
		
		var gridParams = {
			columnReordering: this._tableWidgetDefinition.getTableColumnReordering(),
			rowsPerPage: this._tableWidgetDefinition.getTableCommonPagingSize(),	
			pagination: this._tableWidgetDefinition.getTableCommonPaging(),
			store: this._dataStore,
			toolbarVisible: !this.hideToolbar,
			toolbarOptions: toolbarOptions,
			footerVisible: true,
			sortFields: sortFieldsForTable,
			selectionMode: this._tableWidgetDefinition.getSelectionMode(),
			plugins: {
				nestedSorting: true, 
				exporter: true, 
				printer: true, 
				filter:  filterObj,
				indirectSelection: indirectSelectFlag,
				selector: {row: this._tableWidgetDefinition.getSelectionMode(), cell: "disabled"},            
				dnd: this._tableWidgetDefinition.getTableColumnReordering(),
				pagination: this._tableWidgetDefinition.getTableCommonPaging()
			}, 

			structure:layout,		
			parentPluggableView: this
		};

		gridParams = this.augmentGridParams(gridParams);

		var tableClass = eval (this._pTableClassName);
		var tivTable = new tableClass (
			{
				gridParams: gridParams,
				toolbarOptions: gridParams.toolbarOptions,
				toolbarVisible: gridParams.toolbarVisible,
				plugins: gridParams.plugins,
				Pagination: gridParams.pagination,
				widgetID: tableDef.id,
				height: this.height,
				width: this.width,
				tableView: this,
				cmProvider: this.cmProvider,
				div: this._tableDiv,
				enableResize: this.enableResize,
				insertOnTop : this.insertOnTop

			}, this._tableDiv);
		
		// Set filter only when dataset (and columns) configured
		// Do not set on empty dataset	
		if (this.dataset) {
			// set filter when table is done loading
			var handle = dojo.connect(tivTable, "onTableLoad", this, dojo.hitch(this, function() {
				tivTable.setFilter(this._preFilter);
        	    dojo.disconnect(handle);
        	}));
		}

		//Store away the grid for use in dblclick, selection, etc.
		this._grid = tivTable.grid;
		this._table = tivTable;
		
		if (this._grid.pluginMgr) {
			var testFilterVal = this._grid.pluginMgr.getPlugin('filter').ruleCountToConfirmClearFilter;
		
			//disable the clear filter confirmation if needed:
			if(!this.showClearFilterConfirmation){
				this._grid.pluginMgr.getPlugin('filter').ruleCountToConfirmClearFilter = Infinity;
			}
		}				
		
		//if we have toolbar rows, render them
		if(this.toolbarRows){
			this._fillToolbar(this.toolbarRows);
		}		

		//make sure to remove the filter bar if toolbar is not shown at all
		if(this.hideToolbar){
			try {
				this._grid.showFilterBar(false);
			} catch (ex) {
				// Filter bar not supported for all table types
			}				
		}
		
		
		//add our cm menus?
        cmadapter = new ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu({cmProvider: this._cmProvider});

		//Set our content to be the tableDiv       
	//	dojo.place(tivTable.domNode, this._tableDiv, "first");
				
	
		if (this._trace.isFinest()) {
			this._trace.finest ("created tableBuilder", "_initTableBuilder");
		}
				
		tivTable.startup();
	
			

		//register double click event
		var dblConn = dojo.connect (this._grid, "onRowDblClick", this, "_processDoubleClick");
		this._tableConnections.push(dblConn);
		//register menu event
		var menuConn = dojo.connect( this._grid, "onRowContextMenu", this, "_onRowContextMenu" );
		this._tableConnections.push(menuConn);
		//Register for user-initiated selection changes to the grid
		var selectConn = dojo.connect(this._grid.selection, "onChanged", this, this._gridSelectionChangedCallback);
		this._tableConnections.push(selectConn);
		
		//check that the actions menu is there
		if(this._table._toolbar && this._table._toolbar.actionListWidget && this._table._toolbar.actionListWidget.dropDown){
			//if so, connect to the open/close events
			this._actionMenuDefaultCount = this._table._toolbar.actionListWidget.dropDown.getChildren().length;
			var openActMenuConn = dojo.connect(this._table._toolbar.actionListWidget, "openDropDown", this, this._openActionMenu);
			this._tableConnections.push(openActMenuConn);
		
			var closeActMenuConn = dojo.connect(this._table._toolbar.actionListWidget, "closeDropDown", this, this._closeActionMenu);
			this._tableConnections.push(closeActMenuConn);
		}
		
	//  	this.viewLoaded = true;
	  	
	  	//Send notification we're done loading the dataset/prepping the view
	//  	this._onSetDatasetLoadComplete(this.dataset);
	
		
		//Custom exporter stuff.
		if (tivTable._toolbar) {
			tivTable.defaultExportFormatter = false;
			if (tivTable.grid.setExportFormatter) { //Check for existence of setExportFormatter function as doesn't currently exist in tree table
				tivTable.grid.setExportFormatter(dojo.hitch(this, this._exportFormatter));
			}
		}
	},
	
	_fillToolbar: function(/*Object[]*/ toolbars) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon		
		// toolbars:
		//		Coming soon
		
		for(var i=0;i<toolbars.length && i<2;i++){ //i<2 because TED table allows having only 2 rows (TED_1000_src_20101119_2326)
			if(!toolbars[i].hidden){
				var item = null;
				var toolbarContents = toolbars[i].contents;
				for (var j = 0; j < toolbarContents.length; j++){ // KDM:6/24/2011 Reversed order of input from previous due to TED 1.1.0.1 mods
					this._addItemToTheToolbar(toolbarContents[j], j, i+1); //i+1 because TED starts row enumeration from 1 :/ (TED_1000_src_20101119_2326)
				}
			}
		}
	},
	
	_addDefaultToolbarButton: function(/*String*/ buttonType, /*Number*/ position, /*Number*/ rowNumber) {
		var button = null;
		if(this._table._toolbar && this._table._toolbar.id){
			button = dijit.byId(buttonType + this._table._toolbar.id);
		}
		else if(this._table.toolbar && this._table.toolbar.id){
			button = dijit.byId(buttonType + this._table.toolbar.id);
		}
				
		if(button){
			this._table.addToToolbar(button, position, rowNumber);	
		}
		else {
			console.log("No toolbar object defined...skipping adding this button" + buttonType);
		}

		return button;				
	},

	_addItemToTheToolbar: function(/*Object*/ item,/*Number*/ position, /*Number*/ rowNumber) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon		
		// item:
		//		Coming soon
		// position:
		//      Coming soon
		// rowNumber:
		//		Coming soon
		switch(item.type){
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.PRINT_BUTTON:
				this._addDefaultToolbarButton("printIcon", position, rowNumber);				
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.CONFIG_TABLE:
				this._addDefaultToolbarButton("configureColIcon", position, rowNumber);
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.EXPORT_BUTTON:
				this._addDefaultToolbarButton("exportDataIcon", position, rowNumber);
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.REFRESH_BUTTON:
				// Do not add refresh bar explicitly, will be handled in toolbarOptions, refreshIcon: true
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.ACTION_MENU:
				this._addDefaultToolbarButton("actionListMenu", position, rowNumber);
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.SEPARATOR:
				var separator = new dijit.ToolbarSeparator();
				this._table.addToToolbar(separator, position, rowNumber);
				this._toolbarItemsToDestroy.push(separator); //Hack, but TED Toolbar not good about cleaning up custom toolbar entries
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.CUSTOM_BUTTON:
				var button = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customButton({id: this.id, item: item});
				if (button) {
					this._table.addToToolbar(button, position, rowNumber);
					this._toolbarItemsToDestroy.push(button); //Hack, but TED Toolbar not good about cleaning up custom toolbar entries
				}
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.CUSTOM_COMBO:
				var combo = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customComboButton({id: this.id, item: item});
				if (combo) {
					this._table.addToToolbar(combo, position, rowNumber);
					this._toolbarItemsToDestroy.push(combo); //Hack, but TED Toolbar not good about cleaning up custom toolbar entries
				}

				var label = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customLabel({id: this.id, item: item});
				if (label) {
					this._table.addToToolbar(label, position, rowNumber);
					this._toolbarItemsToDestroy.push(label); //Hack, but TED Toolbar not good about cleaning up custom toolbar entries
				};				
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.CUSTOM_TEXTBOX:
				var text = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customText({id: this.id, item: item});
				if (text) {
					this._table.addToToolbar(text, position, rowNumber);
					this._toolbarItemsToDestroy.push(text); //Hack, but TED Toolbar not good about cleaning up custom toolbar entries
				}

				var label = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customLabel({id: this.id, item: item});
				if (label) {
					this._table.addToToolbar(label, position, rowNumber);
					this._toolbarItemsToDestroy.push(label); //Hack, but TED Toolbar not good about cleaning up custom toolbar entries
				};
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.CUSTOM_DROPDOWN_BUTTON:
				var dropDown = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customDropButton({id: this.id, item: item});
				if (dropDown) {
					this._table.addToToolbar(dropDown, position, rowNumber);
					this._toolbarItemsToDestroy.push(dropDown); //Hack, but TED Toolbar not good about cleaning up custom toolbar entries
					
					//Further hack, but in IE we also need to keep track of menu items within dropDown so we can destroy later
					if (dojo.ieIE && dropDown.dropDown) {
						var childMenuItems = dropDown.dropDown.getChildren();
						for (var i = 0; i < childMenuItems.length; i++) {
							this._toolbarItemsToDestroy.push(childMenuItems[i]);
						}
					}
				}	
				break;
			case ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes.VIEW_TOGGLER:
				var viewToggler = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.viewToggler({view: this, item: item});
				if (viewToggler) {
					this._table.addToToolbar(viewToggler, position, rowNumber);
					this._toolbarItemsToDestroy.push(viewToggler); //Hack, but TED Toolbar not good about cleaning up custom toolbar entries
					
					//Further hack, but in IE we also need to keep track of menu items within dropDown so we can destroy later
					if (dojo.ieIE && viewToggler.dropDown) {
						var childMenuItems = viewToggler.dropDown.getChildren();
						for (var i = 0; i < childMenuItems.length; i++) {
							this._toolbarItemsToDestroy.push(childMenuItems[i]);
						}
					}
				}
				break;
	
			default:
				this._trace.warn("Invalid toolbar item type provided", "_addItemToTheToolbar");
		}
	},	

    	_customSort: function( a, b ) {		
		// summary:
		//		Function used to determine how to sort an array of properties.
    	//		This function assumes two Properties objects passed in and
    	//		it will then sort based on the Weight of the item
    	//		if weights are equal it will sort lexigraphically
		// description:
		//		Coming soon
    		// a:
    		//		Coming soon
    		// b:
    		//		Coming soon
    		var retval = 0;    	
    		retval = a.sortOrder - b.sortOrder;    	
    		return retval;
	},
	
	
	//To be implemented by subclass in order to create the datastore
	_createTableStore:function(columnIds){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// columnIds:
		//

		// connect to datastore onRefresh event
		if (this._dataStore) {						
			this._dataStoreConnects.push(dojo.connect(this._dataStore, "onRefresh", this, "_onDatastoreRefresh"));
		}	
	},

	_destroyTableStore: function() {
		if (this._dataStore) {
			dojo.forEach(this._dataStoreConnects, dojo.disconnect);
			this._dataStoreConnects = [];
			this._dataStore.close();
			this._dataStore = null;
		}
	},

	//dataset refresh
	_onDatastoreRefresh:function() {
		this._table.refresh();
	},


	resize: function(newSize){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// newSize:
		//		
		if (newSize && this._table) {
			this._table.resize (newSize);
		}
		
		//Call super
		this.inherited(arguments);
		
	},
	getContentPane:function(){
		return this;
	},

	//Override of NavWidgetPluggableView
	_setDatasetSetWidgetDefs: function(/*ibm.tivoli.navmodel.Dataset*/ dataset, /*ibm.tivoli.navmodel.AbstractWidgetDef?*/datasetWidgetDefinition, /*ibm.tivoli.tip.navwidget.dojo.NavWidgetBaseViewState?*/state){
		// summary:
		//		Called during the setDataset lifecycle for setting widget defs specified in the dataset to the view
		//		Subclasses will probably NOT need to override.
		// dataset:
		//		The Client Nav Model Dataset that the pluggable view should render.
		// description:
		//		Sets widget defs specified in the dataset to the view
		// tags:
		//		protected

		this.inherited(arguments);
		this._tableWidgetDefinition = this.widgetDefinition;
		//save the state that was passed in
		this._state = state;
	},
	
	//Override of NavWidgetPluggableView
	_setDatasetLoadData: function(dataset){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// dataset:
		//		
		if (this._trace.isFinest()) {
			this._trace.entering("setting dataset for " + this.id, "_setDatasetLoadData");
		}
		
		this.dataset = dataset;
		
		if(!this._tableWidgetDefinition) {
			this._createTableDef();
		}
		
		this._buildTDLTable();
		
		if (!this.dataset) {
			//No dataset, so fire _onSetDatasetLoadComplete
			setTimeout(dojo.hitch(this, this._onSetDatasetLoadComplete, dataset), 0);
		}
		
		if (this._trace.isFinest()) {
			this._trace.exiting("setting dataset for " + this.id, "_setDatasetLoadData");
		}
	},
	
	_createTableDef: function() {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		if(!this.widgetDefinitionId){
			this.widgetDefinitionId = this._pDEFAULT_WIDGET_DEF_INFO.definition;
		}
		
		this._tableWidgetDefinition
			= ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.createWidgetDefinition(this._pDEFAULT_WIDGET_DEF_INFO.className, 
					this.widgetDefinitionId, this._pDEFAULT_WIDGET_DEF_INFO, this.dataset, this.getParentPluggableViewWidgetDefinition());
		
		//Call superclass
		this.inherited(arguments);

	},  

	_formatter: function(/*String*/ columnDefObj, object, rowId, cellOrDepth, treeCell){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// propId:
		//		
		// object:
		//		
		var cellData = null;
		//console.log("formatting "+propId + "_"+rowId);
		var propId = columnDefObj.id;
		
		switch(propId) {
		
			case "label":
        			cellData = this._propertyRenderer.getRenderedValueNode(object.getLabel());
        			break;
        		
        		case "sourceItem":
				if (object.getObjectType() === "relationship") {
					var sourceItem = object.getSourceItem();
					if (sourceItem) {
						cellData = this._propertyRenderer.getRenderedItemNode(sourceItem, this);
					}
				}				
        			break;
        		
        		case "targetItem":
				if (object.getObjectType() === "relationship") {
					var targetItem = object.getTargetItem();
					if (targetItem) {
						cellData = this._propertyRenderer.getRenderedItemNode(targetItem, this);
					}
				}        			
        			break;

        		case "item1":
				if (object.getObjectType() === "link") {
					var item1 = object.getItem1();
					if (item1) {
						cellData = this._propertyRenderer.getRenderedItemNode(item1, this);
					}
				}	
        			break;
        		
        		case "item2":
				if (object.getObjectType() === "link") {
					var item2 = object.getItem2();
					if (item2) {
						cellData = this._propertyRenderer.getRenderedItemNode(item2, this);
					}
				}			
        			break;
        		
        		case "dataset1":
				if (object.getObjectType() === "link") {
					var d1 = object.getDataset1();
					var value = (d1 ? d1.getLabel() : "");
					cellData = this._propertyRenderer.getRenderedValueNode(value, this);
				}
        			break;

        		case "dataset2":
				if (object.getObjectType() === "link") {
					var d2 = object.getDataset2();
					var value = (d2 ? d2.getLabel() : "");
					cellData = this._propertyRenderer.getRenderedValueNode(value, this);
				}				
				break;

			default:
				var prop = object.getProperty(propId);
				if(prop){
					if(typeof(cellOrDepth) == "number"){
						//passed a depth so nee to use treeCell param
						cellData = this._propertyRenderer.getRenderedPropertyNode(object, prop, this, rowId, treeCell);		
					}else{
						//normal cell passed in so use it
						cellData = this._propertyRenderer.getRenderedPropertyNode(object, prop, this, rowId, cellOrDepth);		
					}
				}
		}
		

		//Wrapping enabled in TED by default, so turn off if disabled in widgetDef or provider
		if(!columnDefObj.lineWrap){
			
			if(typeof(cellOrDepth) == "number"){
				if (treeCell && (treeCell.customStyles)) { 
					//passed a depth so nee to use treeCell param
					treeCell.customStyles.push("white-space: nowrap");
					treeCell.customStyles.push("word-wrap: normal");
				}
			}else{
				//normal cell passed in so use it
				if (cellOrDepth && (cellOrDepth.customStyles)) {  
					cellOrDepth.customStyles.push("white-space: nowrap");
					cellOrDepth.customStyles.push("word-wrap: normal");
				}
			}
		}

		if (!cellData) {
			cellData = this._propertyRenderer.getRenderedValueNode("", this);
		}
		
		return cellData.innerHTML;

	},

	_evaluatePropThreshold: function(prop, object){
		var thresholds = null;
		var retThreshold = null;
		var threshold = null;
		
		var propId = prop.getId();
		
		//get the thresholds for this property
		thresholds = this._getPropThresholds(propId);
		
		//process them if thresholds for this property are returned
		if(thresholds && prop){
			var propType = prop.getValueType();
			//make a "mock" threshold obj for prop value so we can reuse compare method
			var propValue = {"start": prop.getValue()};
			
			//find highest threshold that matches this property value
			for(var i = 0; i < thresholds.length; i++){
				//Check to see if the property matches the current threshold
				if(this._compareThresholds(propValue, thresholds[i], propType, true)){
				//if(true){
					//we know this property meets the current threshold, so now see if it is the highest of this thresh type
					
					//first check if retThreshold is defined.  If not, then this is the first match, so dont need to compare
					if(!retThreshold){
						retThreshold = thresholds[i];
					}
					//one match already, so we need to get the highest threshold value
					else if(this._compareThresholds(thresholds[i],retThreshold, propType)){
						retThreshold = thresholds[i];
					}
				}
			}
			
		}	
		
		return retThreshold;
	},
	
	//returns true if thresh 1 is >= thresh 2
	_compareThresholds: function(thresh1, thresh2, type, propComp){
		//  FROM Property.getValueType():
		//		|	values:	"itemName", "itemType", "linkName", "linkType", "relationshipName", "relationshipType"
		//		|		"string", "string[]",
		//		|		"byte", "short", "int", "long", "byte[]", "short[]", "int[]", "long[]",
		//		|	x->	"ubyte, "ushort", "uint", "ulong", "ubyte[]", "ushort[]", "uint[]", "ulong[]",	
		//		|		"boolean", "boolean[]"	
		//		|	x->	"enum", "map", "json"
		//		|	x->	"status",
		//		|		"date", "datetime", "time", "date[]", "datetime[]", "time[]"
		//		|		"isodate", isodatetime", "isotime", "isodate[]", "isodatetime[], "isotime[]", "isointerval", "isoduration"
		//		|		"float", "double", "percentage", "float[]", "double[]"
		//  x-> means we dont support it...also we dont support array types for thresholding
	
		var retVal = false;
		
		switch(type) {
			case "int": case "short": case "byte": case "long": case "float": case "double": case "percentage":
				//parseFloat handles floats and non floats and returns Numbers
				var val1 = parseFloat(thresh1.start);
				var val2 = parseFloat(thresh2.start);
				if(!(isNaN(val1)) && !(isNaN(val2))){
					retVal = val1 >= val2;				
				}
				break;
	/*		case "status":
				//retVal = (thresh1.start === thresh2.start);
				var statusVal = thresh1.start;
				
				//If we get a status object (prop) then get the status objects value
				//otherwise its a normal comparison of two thresholds
				try{
					statusVal = thresh1.start.getValue();
				}catch(e){
					statusVal = thresh1.start;
				}
				retVal = (statusVal == thresh2.start);
				break;
	*/     case "string": case "itemName": case "itemType": case "linkName": case "linkType": case "relationshipName": case "relationshipType":				//if we 
				//if comparing property to threshold then check if it matches

				if(propComp){
					//retVal = (thresh1.start.match(thresh2.start));
					var val1 = thresh1.start;
					var val2 = thresh2.start;
					if(val1 && val2){
						var strContains = thresh1.start.indexOf(thresh2.start);
						if(strContains == -1){
							retVal = false;
						}else{
							retVal = true;
						}
					}else{
						//no value for one of the thresholds, so we say it doesnt match
						retVal = false;
					}
				}else{
					//else we are just comparing thresholds so whichever is last
					retVal = true;
				}
				break;			
			case "date": case "datetime": case "time":
				//we are comparing js Date objects
				var val1 = null;
				if(propComp){
					val1 = thresh1.start;
				}else{
					val1 = new Date(thresh1.start);
				}
				var val2 = new Date(thresh2.start);
				
				if(val1 && val2){
					retVal = val1 >= val2;
				}
				break;
			case "isodate": case "isodatetime": case "isotime":
				//we get iso string date formats, so first need to get the date objects
				var val1 = dojo.date.stamp.fromISOString(thresh1.start);
				var val2 = dojo.date.stamp.fromISOString(thresh2.start);
				
				if(val1 && val2){
					retVal = val1 >= val2;
				}else{
					retVale = false;
				}
				
				break;
			//default: basically what we dont support, always return false
			default:
				retVal = false;
		}

		return retVal;
	},
	
	
	//gets the threshold for a particular property
	_getPropThresholds: function(propId){
		var threshArray = this._tableWidgetDefinition.getDataSetThresholds();
		var thresholds = null;
		if(threshArray){
			thresholds = [];
			for(var i = 0; i< threshArray.length; i++){
				if(threshArray[i].attribute === propId){
					thresholds.push(threshArray[i]);
				}
			}
		}
		return thresholds;
	},
	
	//override pluggable view getState in order for pluggable view be able to return
	//the state of the table
	_getStateData: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		//Create data structure to hold state data like the visible view rect, etc.
		var stateData = {};
		if (this._grid) {
			var gLayout = this._grid.layout;
			var layoutData = new dojox.collections.Dictionary();
			
			if(gLayout.structure && (gLayout.structure.length > 1)){
	
				if(gLayout.structure[0] && gLayout.structure[1]){
					
					if(gLayout.structure[0].cells[0] && gLayout.structure[0].cells[0].length){
						//first column is selection column
						for(var i = 1; i < gLayout.structure[0].cells[0].length; i++){
							//for each column, get the field and add it to the sorted list
							//the columns are in order from the current table, so their index becomes our sort weight for the columns
							var k = gLayout.structure[0].cells[0][i].field;
							var val = gLayout.structure[0].cells[0][i];
							val.stateColumnWeight = i;
							val.isLocked = true;
							layoutData.add(k,val);
						}
					}
					
					if(gLayout.structure[1].cells[0] && gLayout.structure[1].cells[0].length){
						//first column is NOT selection column on second layout
						for(var j = 0; j < gLayout.structure[1].cells[0].length; j++){
							//for each column, get the field and add it to the sorted list
							//the columns are in order from the current table, so their index becomes our sort weight for the columns
							var k = gLayout.structure[1].cells[0][j].field;
							var val = gLayout.structure[1].cells[0][j];
							val.stateColumnWeight = j;
							val.isLocked = false;
							layoutData.add(k,val);
						}
					}
				}
	
			}else{
				if(gLayout.structure[0] && gLayout.structure[0].cells[0] && gLayout.structure[0].cells[0].length){
					//first column is selection column
					for(var i = 1; i < gLayout.structure[0].cells[0].length; i++){
						//for each column, get the field and add it to the sorted list
						//the columns are in order from the current table, so their index becomes our sort weight for the columns
						var k = gLayout.structure[0].cells[0][i].field;
						var val = gLayout.structure[0].cells[0][i];
						val.stateColumnWeight = i;
						val.isLocked = false;
						layoutData.add(k,val);
					}
				}
				
			}
			
			
			stateData.layoutData = layoutData;
			
			var filterData = this.getFilter();
			//create filter data with only valid schema data
			//since the TED object contains additional values
			var cullFilterData = null;
			if(filterData && filterData.length > 0){
				cullFilterData = {};
				cullFilterData.ruleArray = [];
				for(var j = 0; j < filterData.length; j++){
					//go thru each index and cull out the data we cant use
					var entry = filterData[j];
					var cullEntry = {};
					if(entry.column){
						cullEntry.column = entry.column;
					}
					if(entry.condition){
						cullEntry.condition = entry.condition;
					}
					if(entry.value){
						cullEntry.value = entry.value;
					}
					if(entry.type){
						cullEntry.type = entry.type;
					}
					//overwrite the current entry with the culled entry
					cullFilterData.ruleArray.push(cullEntry);
				}
				
				cullFilterData.ruleRelation = filterData.ruleRelation;
				
			}
			
			stateData.filterData = cullFilterData;
			
			var nestPlug = this._grid.plugin("NestedSorting");
			if(nestPlug){
				stateData.sortData = nestPlug.getSortProps();
			}
		}
			
		//Return state
		return stateData;
	},
	
	//public method to allow writing to widgetDef
	saveWidgetDelta: function(){
		

		
		if(this._widgetDefColumns){

			var stateData = this._getStateData();
			var tableWidgetDef = this._tableWidgetDefinition;

			//parse the data into the widgetDef reference if one exists
			if(this._tableWidgetDefinition && stateData){
				//id to use to find correct tables entry
				var delta = this._tableWidgetDefinition.getWidgetDelta("user");

				if(stateData.filterData && stateData.filterData.ruleArray && (stateData.filterData.ruleArray.length > 0 ) && delta){
					//set the filter in the delta
					var filterDefData = stateData.filterData;
					delta.setSectionAttribute({sectionKey: "table", attrKey: "filter", attrValue: filterDefData});
				}else{
					//remove this from the delta since there is no longer a filter
					delta.removeSectionAttribute({sectionKey: "table", attrKey: "filter"});
				}

				//always start with an empty array since we are providing a delta for each column
				//view in order to maintain the order of the columns
				var viewDelta = [];

				//for each column, check if we need to update any layout properties
				if(stateData.layoutData){
	
					//iterate on the layoutData
					var layouts = stateData.layoutData.getIterator();

					while(!layouts.atEnd()){
						var entry = layouts.get();
						
						//first get the existing widget def values for this view column
						var currEntry = tableWidgetDef.getTableViewElement(entry.key);
						//this will consolidate any previous merged delta data and allow for reordering
						
						if(currEntry){
							currEntry.hidden = entry.value.hidden;
							currEntry.width = entry.value.unitWidth;
							currEntry.lockColumn = entry.value.isLocked;
						
							//add the new merged entry, this resolves the order as well and is the reason we 
							//need to fully generate the each delta view each time
							viewDelta.push(currEntry);
						}
					}
			
					
					//now overwrite those into the view delta
					delta.setSectionAttribute({sectionKey: "table", attrKey: "view", attrValue: viewDelta});				
				}	

				//now handle the sort data and place into the delta
				if(stateData.sortData && (stateData.sortData.length > 0)){
					
					if(viewDelta && (viewDelta.length > 0)){
						//for each column in delta (note all columns)
						dojo.forEach(viewDelta, function(entryDelta, m){
					
							var matchFound = false;
							//find if there is a matching sort data
							dojo.forEach(stateData.sortData, function(entry, l){
								//first check for sort order
								if(entry.attribute === entryDelta.id){
									matchFound = true;
									//we found a matching entry, so update it
									if(entry.descending){
										viewDelta[m].sorted = "descending";
									}else{
										viewDelta[m].sorted = "ascending";
									}
									viewDelta[m].sortOrder = l;
								
								}
							});
							//check for no match...if no match then we need to remove the sorted data
							if(!matchFound){
								delete viewDelta[m].sorted;
								delete viewDelta[m].sortOrder;
							}
			
						});		
					}
					//now overwrite those into the view delta
					delta.setSectionAttribute({sectionKey: "table", attrKey: "view", attrValue: viewDelta});				

				}else{
					//NO sort data defined, so we need to remove the sort attributes from each of the view entries
					dojo.forEach(viewDelta, function(entry, n){
						if(entry.sorted){
							delete viewDelta[n].sorted;
						}
					});
				}

				//Call super class to actually do the save
				this.inherited(arguments);			
			}
		}else{
			console.log("Columns are not based on the widget definition.  Save is unecessary.");
		}
		
	},
	
	_exportFormatter: function(data, cell, rowIndex, object) {
		// NOTE: It would be nice to delegate the formatting to our property renderer like so:
		//
		//		return this._formatter(cell.field, item);
		//
		// But, unfortunately, we don't really know what Exporter is active (e.g., the CSV exporter might be calling us, and
		// we don't really want to spit out HTML tags to go into CSV.
		
		var propId = cell.field;
		var cellData = null;
		switch(propId) {
			case "label":
        		cellData = object.getLabel();
        		break;
        		
        		case "sourceItem":
					if (object.getObjectType() === "relationship") {
						var sourceItem = object.getSourceItem();
						if (sourceItem) {
							cellData = sourceItem.getLabel();
						}
					}				
        			break;
        		
        		case "targetItem":
				if (object.getObjectType() === "relationship") {
					var targetItem = object.getTargetItem();
					if (targetItem) {
						cellData = targetItem.getLabel();
					}
				}        			
        			break;

        		case "item1":
					if (object.getObjectType() === "link") {
						var item1 = object.getItem1();
						if (item1) {
							cellData = item1.getLabel();
						}
					}	
        			break;
        		
        		case "item2":
					if (object.getObjectType() === "link") {
						var item2 = object.getItem2();
						if (item2) {
							cellData = item2.getLabel();
						}
					}			
        			break;
        		
        		case "dataset1":
					if (object.getObjectType() === "link") {
						var d1 = object.getDataset1();
						var value = (d1 ? d1.getLabel() : "");
						cellData = value;
					}
        			break;

        		case "dataset2":
					if (object.getObjectType() === "link") {
						var d2 = object.getDataset2();
						var value = (d2 ? d2.getLabel() : "");
						cellData = value;
					}				
					break;

				default:
					var prop = object.getProperty(cell.field);
					if(prop){
						cellData = this._propertyRenderer.getPropertyDisplayValue(cell, prop, this);;			
					}
					break;
		}
		
		if (!cellData) {
			cellData = "";
		}
		
		return cellData;
	},
	
	handleLinkClickAction: function(viewId, objectId, propId, objectType){
		
		console.log("handling link click for table view");
		var object;
		var property;
		
		//ask the dataset for the correct object based on the objects id.
		//since we have already rendered these items, the value should be
		//cached and should be quick.
		switch(objectType) {
			case "ibm.tivoli.navmodel.Item":
				object = this.dataset.getItem({itemId:objectId});
				break;
			case "ibm.tivoli.navmodel.Link":
				object = this.dataset.getLink({itemId:objectId});
				break;
			case "ibm.tivoli.navmodel.Relationship":
				object = this.dataset.getRelationship({itemId:objectId});
				break;
			default:
				console.log("unrecognized object type!");
		}	

		//object = this._grid.getItem(objectId);
		if(object){
			property = object.getProperty(propId);
		}
		
		
		if(object && property){
			this._propertyRenderer._handleLinkClick(property, this);
		}
	},

	_setTableView: function(columns) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// columns:
		//		
		
		//Process the columns to set the table view
		var view = [];

		//Process the list of view 
		if (columns) {
			for (var index = 0;  index < columns.length;  ++index) {
				var col = columns[index];
				
					//Deal with columns...
					var vData = {};
					if(col.isSortable()){		
						vData.sorted = (col.isSortAscending() ? "ascending" : "descending");
						vData.sortOrder =  col.getSortOrder();
					}else{
						vData.sorted = "none";
					}
					
					vData.searchable = col.isSearchable();
					vData.hidden = col.isHidden();
					vData.id = col.getId();
					vData.resizeable = col.isResizeable();
					vData.lineWrap = col.isLineWrap();
					
					if(!col.getWidth()) {
						vData.width = "10em";
					} else {
						vData.width = col.getWidth();
						//just in case the with still comes back with -1
						if(vData.width == -1){
							vData.width = "10em";
						}
					}
					vData.lockColumn = col.isLocked();
	
					//Store the object to pass to the bridge later
					view.push(vData);
			} 
			
			this._tableWidgetDefinition.setTableView(view);
		}
	},

	
	_processDoubleClick: function(evt) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		
		if (this._trace.isFinest()) {
			this._trace.finest("*** row was double clicked");
		}
		
	      var row = evt.grid.getItem( evt.rowIndex );       
	      console.log ("row is: " + row);
	      console.log ("evt.rowIndex: " + evt.rowIndex);

	      if ( row )
	      {
	        //select the row that the context menu was initiated on (unless already selected)
	   	 if (!evt.grid.selection.isSelected(evt.rowIndex)) {
		         evt.grid.selection.deselectAll( evt.rowIndex );
		         evt.grid.selection.setSelected( evt.rowIndex, true );
	   	 }
		
	     }
		//need to set the selection on the row
		var selection = null;
		
		   //Use the DefaultActionHelper to create the launch the default double click action
			if(!this.daHelper){
				//Create DefaultActionHelper
				//By default creates the properties Dialog and launches it (via callback)
				this.daHelper = new ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper( 
					{
						defaultActionCallback: dojo.hitch(this, "_launchPropertiesDialog", this)
					}
			);

		}
		//actually execute the default action/task (defined in constuctor)
		this.daHelper.executeDefaultAction(this);
	},
	
	_launchPropertiesDialog: function(pluggableView){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// pluggableView:
		//		
		
		//NOTE: Reusing Anthony's MenuProviderHelper to launch the dialog to avoid duplicate logic. This is a temporary solution. 
		var menuProviderHelper = new ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper();
		menuProviderHelper.getMenuCommand("nwmi_PropertiesNotebookDialog", pluggableView, null);

	},

	_translateQuery: function(commands, request) {
		var filter = commands.filter;
		if (commands.enable && filter) {
			request.query = {ids: {}, expression: ""};	
			this._translate(request.query, filter.data, filter.op, "");	
			this._condition = request.query.expression;
		}
		else {
			this._condition = null;
		}

		//fire onFilterChange event in NavWidgetPluggableView
		this.onFilterChange();
	},

	_translate: function(query, data, op, prevOp) {		
		if (dojo.isArray(data)) {			
			var length = data.length;

			if (length > 1) {
				query.expression += "(";
			}

			for (var index = 0;  index < length;  ++index) {
				if (!this._translate(query, data[index].data, data[index].op, op)) {
					if (data[index].isCol) {
						query.ids[data[index].data] = true;
						// If field is enumerated string, prepend condition with *	
						for (var i = 0; i < this._stringFieldsWithPossibleValues.length; i++) {
							if (this._stringFieldsWithPossibleValues[i] === data[index].data) {
								data[index].data = "*"+data[index].data;
								break;
							}
						}					
						query.expression += data[index].data;
						query.expression += " ";
						query.expression += this._translateOperator(op, prevOp);
					}
					else {
						if (data[index].op == "string") {
							// replace single quotes with 2 consecutive single quotes
							query.expression += " '" + data[index].data.replace(/'/g, "''") + "'";
						}
						else {
							if (data[index].data) {
								query.expression += " " + data[index].data;
							} else {
								query.expression += " " + data[index];
							}
						}						
					}
				}
				// and/or operator in between
				else if (index + 1 < length) {
					query.expression += " " + (op === "any" ? "or" : "and") + " ";					
				}
			}

			if (length > 1) {
				query.expression += ")";
			}

			return true;
		}		
		else {
			return false;	
		}
	},

	_translateOperator: function(op1, op2) {
		var newOp = "";		
		switch(op1) {
			case "equal":
				newOp = (op2 === "not" ? "!=" : "=");
				break;
			case "less":
				newOp = (op2 === "not" ? ">=" : "<");
				break;
			case "lessEqual":
				newOp = (op2 === "not" ? ">" : "<=");
				break;
			case "larger":
				newOp = (op2 === "not" ? "<=" : ">");
				break;
			case "largerEqual":
				newOp = (op2 === "not" ? "<" : ">=");
				break;
			case "contains":
			case "containsignorecase":
				newOp = (op2 === "not" ? "!contains" : "contains");
				break;
			case "startsWith":
				newOp = (op2 === "not" ? "!starts" : "starts");
				break;
			case "endsWith":
				newOp = (op2 === "not" ? "!ends" : "ends");
				break;
			case "isEmpty":
				newOp = (op2 === "not" ? "!isnull" : "isnull");
				break;
			default:
				alert('unrecognized operator=' + op1);
		}

		return newOp;
	},

	_translateOperatorInverse: function(op1) {
		var newOp = "";		
		switch(op1) {
			case "contains":
				newOp = "contains";
				break;
			case "!contains":
				newOp = "notContains";
				break;
			case "starts":
				newOp = "startsWith";
				break;
			case "!starts":
				newOp = "notStartsWith";
				break;
			case "ends":
				newOp = "endsWith";
				break;
			case "!ends":
				newOp = "notEndsWith";
				break;
			case "isnull":
				newOp = "isEmpty";
				break;
			case "!isnull":
				console.log('Operator is not supported in filter dialog: ' + op1);
				break;
			case "=":
				newOp = "equalTo";
				break;
			case "!=":
				newOp = "notEqualTo";
				break;
			case "<":
				newOp = "lessThan";
				break;
			case ">":
				newOp = "largerThan";
				break;
			case ">=":
				newOp = "largerThanOrEqualTo";
				break;
			case "<=":
				newOp = "lessThanOrEqualTo";
				break;
			default:
				alert('unrecognized operator=' + op1);
		}

		return newOp;
	},

	_createDefaultColumnObject: function(columnIds, columns, cols, defColumn) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// columnIds:
		//		
		// columns:
		//		
		// cols:
		//		
		// defColumn:		
		//		
		var targetColData = {};							
		targetColData.id = defColumn.id;
		targetColData.label = {};
		targetColData.label.value = defColumn.label; 
		targetColData.type = "java.lang.String";						
		// get column IDs to pass to store
		columnIds.unshift(targetColData.id);
		columns.unshift(targetColData);

		// Create a column object and add it to the returned cols
		var newTargetColumnArgs = {
				version: 0.1
		};
		var newColumn = new ibm.tivoli.navmodel.Column(newTargetColumnArgs);

		newColumn.setId(defColumn.id);
		newColumn.setLabel(defColumn.label);
		newColumn.setValueType(defColumn.type);
		newColumn.setSortOrder(defColumn.sortOrder !== undefined ? defColumn.sortOrder : -1);
		newColumn.setSortable(true);
		newColumn.setSearchable(true);							
		newColumn.setFilterable(true);
		newColumn.isFiltered(false);
		newColumn.setSortAscending(true);							
		newColumn.setWidth(-1);

		cols.unshift(newColumn);							

	},
	
	isMenuOpen: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		if(this._contextMenuAdapter){
			return (this._contextMenuAdapter.getMenu()) ? true : false;
		}else{
			return false;
		}
	},
	
	_openActionMenu: function(e){
		var childItems = this._table._toolbar.actionListWidget.dropDown.getChildren();
	
		if (childItems.length === this._actionMenuDefaultCount) {
			var processingLabel = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources").PROCESSING;
			items = [
						//new dijit.MenuSeparator(),
						{ 
	        				"label": processingLabel,
	        				"iconClass": "tipMenuIcon loadingIcon", 
	        				"actionID": "LOADING_ID",
	        				"launchType": "NOOP"
	        			}
        			];
			this.cmProvider.getMenuItemsAsynch(this, dojo.hitch(this, this._menuItemsLoaded), "menu,toolbar");
		}
		else {
			this._removeLoadingItem();
			items = this.cmProvider.getMenuItems(this);
		}
		
		this._addItemsToMenu(this._table, items);
		
	},
	
	_addItemsToMenu:function(parent, items) {		
		// summary:
		//		Recursive function to construct menu from array of items
		//		(adapted from ibm.tivoli.tip.dijit.ContextMenuAdapter)
		// description:
		//		Coming soon
		// parent:
		//		Coming soon
		// items:
		//		Coming soon
		var params;
	    var subMenuIndex;
	    var menuItemIndex;
	      
	    for (var i = items.length-1; i >= 0; --i) {
	    	if (items[i].submenu_items) {
	    		//subMenuIndex = this._subMenus.length;
	    		//this._subMenus[subMenuIndex] = new dijit.Menu();
	    		var subMenuItem = new dijit.Menu();
	            params = 
	            {
	            	popup: subMenuItem
	            };

	            dojo.mixin( params, items[i] );
	            var popMenu = new dijit.PopupMenuItem(params);
	            this._table.addToActionList(popMenu);  
	           
	            this._addItemsToMenu(subMenuItem, items[i].submenu_items);           
	        }
	        else {
	        	// The following if clause added for backward compatibility
	            // with the previous version of TIPContextMenu
	            if (items[i].id && items[i].id.toLowerCase() === "separator") {
	            	// Previous TIPContextMenu users indicated separators via the id
	            	items[i].actionID = "_separator_";
	            } 
	            else if (items[i].id && !items[i].actionID) {
	            	// Previous TIPContextMenu users didn't use actionID
	            	items[i].actionID = items[i].id;
	            }

	            if (items[i].actionID === "_separator_") {
	            	//menuItemIndex = this._menuItems.length;
	            	//this._menuItems[menuItemIndex]  = new dijit.MenuSeparator();
	            	this._table.addToActionList(new dijit.MenuSeparator());
	            } 
	            else {
	            	params = {
	            		adapter: this,
	            		onClick: function() {this.adapter._onMenuItemClick(this); }
	                };	             
	                dojo.mixin(params, items[i]);
	               // menuItemIndex = this._menuItems.length;
	               // this._menuItems[menuItemIndex] = new dijit.MenuItem(params);
	        /*       if((parent instanceof ibm.tivoli.tip.navwidget.table.dijit.NavModelTable) || (parent instanceof ibm.tivoli.tip.navwidget.tree.dijit.NavModelTreeTable)){          
	                	this._table.addToActionList(new dijit.MenuItem(params));
	                }else{
	                	//passed a recursive menu item, so add it to that directly
	                	parent.addChild(new dijit.MenuItem(params));  
	                }
	               */
	 	               if((parent instanceof dijit.Menu)){  
	 	                	//passed a recursive menu item, so add it to that directly
	 	                	parent.addChild(new dijit.MenuItem(params)); 
		                	
		                }else{
		                	//need to add to the table toolbar
		                	this._table.addToActionList(new dijit.MenuItem(params));
		                }
		             
	            }
	        }         
	    }
	},	
	
	_onMenuItemClick: function(menuItem) { 		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// menuItem:
		//		Coming soon
	   this.cmProvider.getMenuCommand(menuItem.actionID, this, menuItem);
	},
	
 	_removeLoadingItem: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	    var childItems = this._table._toolbar.actionListWidget.dropDown.getChildren();
 	    var loadingItem = childItems[0];
 	    this._table._toolbar.actionListWidget.dropDown.removeChild(loadingItem);
 	 	loadingItem.destroy();
 	},
 	_menuItemsLoaded: function(/*Boolean*/ success) {		

 		if (success) {
 			// repopulate menu
 			this._openActionMenu();
 			// the menu is already marked as started and open, so loadDropDown skips these
 			// steps, so do them again here
 			dojo.forEach(this._table._toolbar.actionListWidget.dropDown.getChildren(), function(child){ child.startup(); });
 			this._table._toolbar.actionListWidget.dropDown.startupKeyNavChildren();
 			// The dijit.Menu still remembers the "Loading..." item as focused so reset
 			this._table._toolbar.actionListWidget.dropDown.focusedChild = null;
 			this._table._toolbar.actionListWidget.dropDown.focus();
 		}
 	    else {
 	    	// There were either no tasks returned or an error occurred, so dismiss the dropDown
 	    	//this.closeDropDown(true);
 	    }
 	},
	
	_closeActionMenu: function(e){

		var childItems = this._table._toolbar.actionListWidget.dropDown.getChildren();
		
		while(childItems.length > this._actionMenuDefaultCount) {
			this._table.removeFromActionList(childItems[0]);
			childItems = this._table._toolbar.actionListWidget.dropDown.getChildren();
		}
	},
	
    _onRowContextMenu: function( e )
    { 
		// summary:
		//		This method is called each time a context menu is required on a row
		// description:
		//		Coming soon
		// e: 
		//		
      var row = e.grid.getItem( e.rowIndex );       
      console.log ("row is: " + row);
      console.log ("e.rowIndex: " + e.rowIndex);

      if ( row )
      {
        //select the row that the context menu was initiated on (unless already selected)
   	 if (!e.grid.selection.isSelected(e.rowIndex)) {
	         e.grid.selection.deselectAll( e.rowIndex );
	         e.grid.selection.setSelected( e.rowIndex, true );
   	 }

   	 if(!this.removeContextMenu){
   		//dismiss tooltip if there is one 
   		this._table.closeTooltip();
   		
   		this.getContextMenuAdapter().contextMenuOpen( e, this); 
   	 }
   	 
  /*      // Get the parentPluggableView if it has not been initialized before 
   	 var parentPluggableView = this.tableBuilder.params.gridParms.parentPluggableView;
   	 if(!parentPluggableView.removeContextMenu){
   		 //only open the menu if we are not told to remove it
   		 this.getContextMenuAdapter().contextMenuOpen( e, parentPluggableView);        
   	 }
   	 
   */
      }
    },      getContextMenuAdapter: function() {	  		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
      if (!this._contextMenuAdapter) {
         // Create the contextMenuAdapter.
         this._contextMenuAdapter =         	 
             new ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu({cmProvider: this.cmProvider});
      }
      return this._contextMenuAdapter;
    },


	_mapDataType: function(dataType){
		switch( dataType ){
			case "byte": case "short":  case "int": case "long": case "ushort": case "ubyte": case "uint": case "ulong": case "float": case "double": case "percentage" : case "java.lang.Integer": case "java.lang.Double": case "java.lang.Long": case "java.lang.Decimal":
				return "number";
			case "status":
				return "number";
			case "boolean": case "java.lang.Boolean": 
				return "boolean";
			case "date": case "datetime": case "isodate": case "isodatetime": case "java.lang.Date": case "java.util.Date": 
				return "date";
			case "time": case "isotime" :
				return "time";
			default :
				return "string";
			


		}
	},

	_isColumnFilterSupported: function(dataType) {
		switch( dataType ){
			case "isoduration": case "isointerval":
				return false;
			default:
				return true;
		}
	},
	
	/////////////////////////////////////////////////
	// Selection change handling
	/////////////////////////////////////////////////
	_handlingSelectOrDeselectAll: false,
	_handlingSelectionChangedCallback: false,
	
	_gridSelectionChangedCallback: function() {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this._handlingSelectionChangedCallback = true;
		
		if (!this.selection.isChanging() && ! this._handlingSelectOrDeselectAll) {
			//Get the selected rows... will be an array of Client Dataset Items
			var selectedRows = this._grid.selection.getSelected();

			//Set the selection on the view's selection object
//ADM TODO: maybe add a case statement here based on type? where we can decide where to set what type of objects selected here...not sure
			this.selection.setSelectedObjects(selectedRows, null, null, null);
		}
		
		this._handlingSelectionChangedCallback = false;
	}
});


ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView.toolbarItemTypes = {		
		// summary:
		//		definitions for common toolbar item types values
		// description:
		//		Coming soon		
		PRINT_BUTTON:		"PRINT_BUTTON",
		REFRESH_BUTTON:		"REFRESH_BUTTON",
		SEPARATOR:			"SEPARATOR",
		CUSTOM_BUTTON:		"CUSTOM_BUTTON",
		CUSTOM_TEXTBOX:		"CUSTOM_TEXTBOX",
		CUSTOM_COMBO: 		"CUSTOM_COMBO",
		CUSTOM_DROPDOWN_BUTTON: "CUSTOM_DROPDOWN_BUTTON",
		ACTION_MENU:		"ACTION_MENU",		
		VIEW_TOGGLER:		"VIEW_TOGGLER",
		CONFIG_TABLE:		"CONFIG_TABLE",
		EXPORT_BUTTON: 		"EXPORT_BUTTON"
	  };