/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide ("ibm.tivoli.tip.navwidget.table.dijit.LinksTableView");

dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper");
dojo.require("ibm.tivoli.navmodel.DatasetLinksStore");
dojo.require ("ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView");
dojo.require("ibm.tivoli.tip.navwidget.table.dijit.NavModelTable");

ibm.tivoli.tip.navwidget.table.dijit.LinksTableView._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.table.dijit.LinksTableView");

dojo.declare ("ibm.tivoli.tip.navwidget.table.dijit.LinksTableView",
	ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView,
	{
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	//***************************
	// "Private"
	//***************************
	// _trace: [private] Trace
	//		Utility for trace and logging
	_trace: ibm.tivoli.tip.navwidget.table.dijit.LinksTableView._trace,
	
	constructor: function () {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this._global = ibm.tivoli.tip.dojo.Global.setSingleton( "867", " ");
		this.title = this.commonResources.LINK_VIEW;
		this.labelIconClass = "linkViewIcon";
	    this._pDEFAULT_WIDGET_DEF_INFO = {
				className: "ibm.tivoli.navmodel.TableWidgetDef",
				baseUrl: "/ibm/tivoli/rest",
		    	provider: "any",
		    	datasource: "any",
		    	widget: "table",
		    	definition: "DefaultLinksTable"
			},
		this._pTableType = "link";
		this._pTableClassName = "ibm.tivoli.tip.navwidget.table.dijit.NavModelTable";
		this._pDefaultColumns = [
				{id: "item2", label: this.commonResources.ITEM2, type: "string"},
				{id: "label", label: this.commonResources.TYPE,  type: "string"},
				{id: "item1", label:this.commonResources.ITEM1,  type: "string", sortOrder: 0} ];
	},

	isApplicable: function(/*ibm.tivoli.navmodel.Dataset*/dataset){
		// Primarily interested in the following view types: 
		//	viewType == "graph" || viewType == "tree" || viewType == "tree:reverse" || viewType == "table_relationship";
		return this.inherited(arguments);
	},
	
	_createTableStore: function(columnIds){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// columnIds:
		//		
		if(!columnIds) {
			columnIds = ["all"];
		}
		// create or update store

		if(!this._dataStore && this.dataset) {
			this._dataStore = new ibm.tivoli.navmodel.DatasetLinksStore({dataset:this.dataset, returnItem:true, defaultProperties:columnIds});
			this.inherited(arguments);
		}
	},	
	
	
	
	/////////////////////////////////////////////////
	// Selection change handling
	/////////////////////////////////////////////////
	_handlingSelectOrDeselectAll: false,
	_handlingSelectionChangedCallback: false,
	_gridSelectionChangedCallback: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this._handlingSelectionChangedCallback = true;
		
		if (!this.selection.isChanging()&& ! this._handlingSelectOrDeselectAll) {
			//Get the grid's selection... will be an array of Client Dataset Relationships
			var selectedRows = this._grid.selection.getSelected(); 

			//Set the selected links on the view's selection object
			this.selection.setSelectedObjects(null, selectedRows, null, null);
		}
		
		this._handlingSelectionChangedCallback = false;
	}	
});
