/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.table.dijit.NavModelTableSelection");

dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("dojox.collections.SortedList");

dojo.declare(
    "ibm.tivoli.tip.navwidget.table.dijit.NavModelTableSelection",
    ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection,
    {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
    	
    	setMode: function(mode){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
    		// mode:
    		//		
    	
	    	//We know the pluggableView is a Item or Links Table View, so we can set the selection mode on the grid's selection object
			this._pluggableView._grid.selection.setMode(mode);
	    	
			//Call superclass
    		this.inherited(arguments);
		},
    	
	 	setSelectedObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		
			// linkIds:
			//		
			// relationshipIds:
			//			
			
	    	//Mark we're changing
			this._changing = true;
			
			//We know the pluggableView is a Item or Links Table View
			if (!this._pluggableView._handlingSelectionChangedCallback) { //Don't do anything if pluggable view is currently dealing with user-initiated selection
				//Clear selection
				this._pluggableView._grid.selection.clear();
				
				//Deal with items
				if (itemIds) {
					for (var i = 0; i < itemIds.length; i++) {
						var item = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemByAbsoluteId(this._dataset, itemIds[i]);
						var idx = this._pluggableView._grid.getItemIndex(item);
						if (idx >= 0) {
							this._pluggableView._grid.selection.addToSelection(idx);
						}
					}
				}
				
				//Deal with links
				if (linkIds) {
					for (var i = 0; i < linkIds.length; i++) {
						var link = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getLinkByAbsoluteId(this._dataset, linkIds[i]);
						var idx = this._pluggableView._grid.getItemIndex(link);
						if (idx >= 0) {
							this._pluggableView._grid.selection.addToSelection(idx);
						}
					}
				}
				
				//Deal with relationships
				if (relationshipIds) {
					for (var i = 0; i < relationshipIds.length; i++) {
						var relationship = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getRelationshipByAbsoluteId(this._dataset, relationshipIds[i]);
						var idx = this._pluggableView._grid.getItemIndex(relationship);
						if (idx >= 0) {
							this._pluggableView._grid.selection.addToSelection(idx);
						}
					}
				}
			}
			
			//Call superclass
			this.inherited(arguments);
			
			//Mark we're done changing
			this._changing = false;
		},
		
	 	setSelectedObjects: function(/*ibm.tivoli.navmodel.Item[]*/ items, /*ibm.tivoli.navmodel.Link[]*/ links, /*ibm.tivoli.navmodel.Relationship[]*/ relationships){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// items:
			// 		
			// links:
			//		
			// relationships:
			//		
			
			//Mark we're changing
			this._changing = true;
			
			//We know the pluggableView is a Item or Links Table View
			if (this._pluggableView._grid && !this._pluggableView._handlingSelectionChangedCallback) { //Don't do anything if pluggable view is currently dealing with user-initiated selection
				//Clear selection
				this._pluggableView._grid.selection.clear();
				
				if (this._pluggableView.dataset) {
					//Deal with items
					if (items) {
						for (var i = 0; i < items.length; i++) {
							var idx = this._pluggableView._grid.getItemIndex(items[i]);
							if (idx >= 0) {
								this._pluggableView._grid.selection.addToSelection(idx);
							}
						}
					}
					
					//Deal with links
					if (links) {
						for (var i = 0; i < links.length; i++) {
							var idx = this._pluggableView._grid.getItemIndex(links[i]);
							if (idx >= 0) {
								this._pluggableView._grid.selection.addToSelection(idx);
							}
						}
					}
					
					//Deal with relationships
					if (relationships) {
						for (var i = 0; i < relationships.length; i++) {
							var idx = this._pluggableView._grid.getItemIndex(relationships[i]);
							if (idx >= 0) {
								this._pluggableView._grid.selection.addToSelection(idx);
							}
						}
					}
				}
			}
			
    		//Call superclass
			this.inherited(arguments);
			
			//Mark we're done changing
			this._changing = false;
		}
    }
);