/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.ActionsMenu");

dojo.require("dijit.Menu");
dojo.require("dijit.form.Button");

dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.ActionsMenu",dijit.form.DropDownButton,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	// cmProvider: [public] ibm.tivoli.tip.navwidget.topology.dijit.AsynchContextMenuProvider
	//		Coming soon
	cmProvider: null,
	
	// context: [public] Object
	//		object with datasource
	context: null,
	
	// loadingMenuID: [public] String
	//		Coming soon
	loadingMenuItemID: "LOADING_ID",
	
	// processingLabel: [public] Object
	//		Coming soon
	processingLabel:null,
	
	constructor: function( args ) {		
		// summary:
		//		The constructor of the adapter.  Mixes in parameters.
		// description:
		//		Coming soon
		// args:
		//		Coming soon
      this.processingLabel = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources").PROCESSING;
	  dojo.mixin( this, args );
	  
	  // this.dropDown = new dijit.Menu({style: "display: none;"});
	  this._subMenus = [];
	  this._menuItems = [];
	  this._waitingForItems = false;
	},
	
	// override to always force the menu contents to update each time
	isLoaded: function() {
	   return false;
	},

	loadDropDown: function() {		
		// summary:
		//		If the menu is currently empty (i.e., asked to load), return the placeholder
		//		menu item and tell the asynch provider to get the menu items asynchronously, 
		//		otherwise, remove the placeholder and ask the provider for the menu items
		//		now that the asynch request has returned the menu items.
		// description:
		//		Coming soon
		var items = null;
		var childItems = this.dropDown.getChildren();
		if (childItems.length == 0) {
			items = [{ 
        				"label": this.processingLabel,
        				"iconClass": "tipMenuIcon loadingIcon", 
        				"actionID": this.loadingMenuItemID,
        				"launchType": "NOOP"
        			}];
			this.cmProvider.getMenuItemsAsynch(this.context, dojo.hitch(this, this._menuItemsLoaded), "menu,toolbar");
		}
		else {
			this._removeLoadingItem();
			items = this.cmProvider.getMenuItems(this.context);
		}
		this._addItemsToMenu(this.dropDown, items);
		// Only open the dropDown on a true load, not a reload as it is already open
		if (!this._opened) {
			this.openDropDown();			
		}
	},
	
	onMenuItemClick: function(menuItem) { 		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// menuItem:
		//		Coming soon
	   this.cmProvider.getMenuCommand(menuItem.actionID, this.context, menuItem);
	},
	
	closeDropDown: function(/*Boolean*/ focus) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// focus:
		//		Coming soon
		this.inherited(arguments);
		// empty out the menu
		if (this.dropDown) {
			// Destroy the drop down, unless it's already been destroyed.  This can happen because
			// the drop down is a direct child of <body> even though it's logically my child.
			if(!this.dropDown._destroyed){
				this.dropDown.destroyDescendants(false);
			}
			this._menuItems = [];
			this._subMenus = [];
		}
	},

	_addItemsToMenu:function(parent, items) {		
		// summary:
		//		Recursive function to construct menu from array of items
		//		(adapted from ibm.tivoli.tip.dijit.ContextMenuAdapter)
		// description:
		//		Coming soon
		// parent:
		//		Coming soon
		// items:
		//		Coming soon
		var params;
	    var subMenuIndex;
	    var menuItemIndex;
	      
	    for (var i = 0; i < items.length; i++) {
	    	if (items[i].submenu_items) {
	    		subMenuIndex = this._subMenus.length;
	    		this._subMenus[subMenuIndex] = new dijit.Menu();
	 
	            params = 
	            {
	            	popup: this._subMenus[subMenuIndex]
	            };

	            dojo.mixin( params, items[i] );
	            parent.addChild(new dijit.PopupMenuItem(params));  
	           
	            this._addItemsToMenu(this._subMenus[subMenuIndex], items[i].submenu_items);           
	        }
	        else {
	        	// The following if clause added for backward compatibility
	            // with the previous version of TIPContextMenu
	            if (items[i].id && items[i].id.toLowerCase() === "separator") {
	            	// Previous TIPContextMenu users indicated separators via the id
	            	items[i].actionID = "_separator_";
	            } 
	            else if (items[i].id && !items[i].actionID) {
	            	// Previous TIPContextMenu users didn't use actionID
	            	items[i].actionID = items[i].id;
	            }

	            if (items[i].actionID === "_separator_") {
	            	menuItemIndex = this._menuItems.length;
	            	this._menuItems[menuItemIndex]  = new dijit.MenuSeparator();
	            	parent.addChild(this._menuItems[menuItemIndex]);
	            } 
	            else {
	            	params = {
	            		adapter: this,
	            		onClick: function() {this.adapter.onMenuItemClick(this); }
	                };	             
	                dojo.mixin(params, items[i]);
	                menuItemIndex = this._menuItems.length;
	                this._menuItems[menuItemIndex] = new dijit.MenuItem(params);
	                parent.addChild(this._menuItems[menuItemIndex]);  
	            }
	        }         
	    }
	},	
	
 	_menuItemsLoaded: function(/*Boolean*/ success) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// success:
		//		Coming soon
 		if (success) {
 			// repopulate menu
 			this.loadDropDown();
 			// the menu is already marked as started and open, so loadDropDown skips these
 			// steps, so do them again here
 			dojo.forEach(this.dropDown.getChildren(), function(child){ child.startup(); });
 			this.dropDown.startupKeyNavChildren();
 			// The dijit.Menu still remembers the "Loading..." item as focused so reset
 	        this.dropDown.focusedChild = null;
 	        this.dropDown.focus();
 		}
 	    else {
 	    	// There were either no tasks returned or an error occurred, so dismiss the dropDown
 	    	this.closeDropDown(true);
 	    }
 	},	

 	_removeLoadingItem: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	    var childItems = this.dropDown.getChildren();
 	    var loadingItem = childItems[0];
 	 	this.dropDown.removeChild(loadingItem);
 	 	loadingItem.destroy();
 	}
});