/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas");

dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dijit._Templated");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer");

//Dataset-related requires
dojo.require("ibm.tivoli.navmodel.Dataset");
dojo.require("ibm.tivoli.navmodel.Item");
dojo.require("ibm.tivoli.navmodel.Link");
dojo.require("ibm.tivoli.navmodel.Task");
dojo.require("ibm.tivoli.navmodel.TopoWidgetDef");

dojo.require("ibm.tivoli.tip.navwidget.dojo.Timer");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidget");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetBaseViewState");
ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas",
	[ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView],
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		//***************************
		// "Private"
		//***************************
	
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
		_trace: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas._trace,

		constructor: function () {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	
			//Signal to superclass we'll be firing onSetDataSetLoadComplete manually
			this._setDatasetLoadDataCompletesSynchronously = false;
			
			//We don't have a widget def specific to this view, so let's signal to 
	        //super class not to try and load any widget defs on our behalf
			this._usesWidgetDefinition = false;
		},


		// This should probably come from widget def
		getViewSpecificTasks: function() {		
			// summary:
			//		Get tasks / actions specific to the pluggable view.
			// description:
			//		Get tasks / actions specific to the pluggable view.
			//		Subclasses should override this function.
			var taskArray = new Array(10);

			taskArray[0] = new Array(3);
			taskArray[0][0] = "exportAsImage";
			taskArray[0][1] = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.commonResources.EXPORT_IMAGE_DIALOG_TITLE);
			taskArray[0][2] = "VIEW_COMMAND";

			taskArray[1] = new Array(3);
			taskArray[1][0] = "exportAsCSV";
			taskArray[1][1] = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.commonResources.EXPORT);
			taskArray[1][2] = "VIEW_COMMAND";

			taskArray[2] = new Array(3);
			taskArray[2][0] = "_separator_";
			taskArray[2][2] = "VIEW_COMMAND";

			taskArray[3] = new Array(3);
			taskArray[3][0] = "save";
			taskArray[3][1] = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.commonResources.SAVE_TEXT);
			taskArray[3][2] = "VIEW_COMMAND";

			taskArray[4] = new Array(3);
			taskArray[4][0] = "print";
			taskArray[4][1] = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.commonResources.PRINT_TEXT);
			taskArray[4][2] = "VIEW_COMMAND";

			taskArray[5] = new Array(3);
			taskArray[5][0] = "select";
			taskArray[5][1] = this.commonResources.SELECT_TEXT;
			taskArray[5][2] = "VIEW_COMMAND";	

			taskArray[6] = new Array(3);
			taskArray[6][0] = "zoomSelect";
			taskArray[6][1] = this.commonResources.ZOOM_SELECT_TEXT;
			taskArray[6][2] = "VIEW_COMMAND";	

			taskArray[7] = new Array(3);
			taskArray[7][0] = "zoomIn";
			taskArray[7][1] = this.commonResources.ZOOM_IN_TEXT;
			taskArray[7][2] = "VIEW_COMMAND";	

			taskArray[8] = new Array(3);
			taskArray[8][0] = "zoomOut";
			taskArray[8][1] = this.commonResources.ZOOM_OUT_TEXT;
			taskArray[8][2] = "VIEW_COMMAND";

			taskArray[9] = new Array(3);
			taskArray[9][0] = "fitContents";
			taskArray[9][1] = this.commonResources.FIT_CONTENTS_TEXT;
			taskArray[9][2] = "VIEW_COMMAND";

			return taskArray;
		},
		
		executeViewSpecificTask: function(commandName) {		
			// summary:
			//		Executes the commandName in the pluggable view.
			// description:
			//		Executes the commandName in the pluggable view.
			//		Subclasses should override this function.
			switch (commandName) {
				case "save":
					this.parentPluggableView._toolbar.saveCanvas();
					break;				
				case "print":
					this.parentPluggableView._toolbar.openPrintDialog();
					break;
				case "select":
					dijit.byId(this.parentPluggableView._toolbar.id+"_"+ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SELECT_BUTTON).setChecked(true);        	
					dijit.byId(this.parentPluggableView._toolbar.id+"_"+ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_SELECT_BUTTON).setChecked(false);   
					this.setMouseMode("select");
					break;
				case "zoomSelect":
					dijit.byId(this.parentPluggableView._toolbar.id+"_"+ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_SELECT_BUTTON).setChecked(true);        	
					dijit.byId(this.parentPluggableView._toolbar.id+"_"+ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SELECT_BUTTON).setChecked(false);
					this.setMouseMode("zoomSelect");
					break;
				case "zoomIn":
					this.zoomIn();
					break;
				case "zoomOut":
					this.zoomOut();
					break;
				case "fitContents":
					this.fitContents();
					break;
				case "exportAsImage":
					this.exportAsImage(this.commonResources.EXPORT_IMAGE_DIALOG_TITLE, //dialogTitle
						this.commonResources.EXPORT_IMAGE_DIALOG_QUESTION, //questionText
						dojo.string.substitute(this.commonResources.EXPORT_IMAGE_PNG_OPTION_LABEL, {fileExtension:"PNG"}), //pngOptionLabel
						dojo.string.substitute(this.commonResources.EXPORT_IMAGE_JPG_OPTION_LABEL, {fileExtension:"JPG"}), //jpgOptionLabel
						this.commonResources.EXPORT, //exportButtonLabel
						this.commonResources.CANCEL, //cancelButtonLabel
						"exportedDiagramImage"); //baseDefaultFileName
					break;
				case "exportAsCSV":
					this.exportTo("csv", dojo.hitch(this,this._csvDataReady));
					break;
				default:
					break;
			}
		},
		
		//***************************
		// "Public"
		//***************************		
		print: function(/*int*/ pageCount, /*Object*/ pageMargin, /*Object*/ printAsBitmap){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// pageCount:
			//		Coming soon
			// pageMargin:
			//		Coming soon
			// printAsBitmap:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.print');
		},

		zoomIn: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.zoomIn');
		},
		
		zoomOut: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.zoomOut');
		},		

		setZoomLevel: function(/*float*/ zoomLevel){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.setZoomLevel');
		},

		setMouseMode: function(/*Object*/ mouseMode){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// mouseMode: 
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.setMouseMode');
		},
		
		fitContents: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.fitContents');
		},
		
		performLayout: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.performLayout');
		},
		
		exportAsImage: function(/*Object*/dialogTitle, /*Object*/questionText, /*Object*/pngOptionLabel, /*Object*/jpgOptionLabel, /*Object*/exportButtonLabel, /*Object*/cancelButtonLabel, /*Object*/baseDefaultFileName){	
			// summary:
			//		Causes diagram contents to be exported as an image. 
			// description:
			//		Causes diagram contents to be exported as an image. 
			// tags:
			//		public
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.exportAsImage');
		},

		setBackgroundColor: function(/*Object*/ backgroundColor) {
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.setBackgroundColor');
		},

		getAvailableLayoutAlgorithms: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.getAvailableLayoutAlgorithms');
			return null;
		},

		getAvailableLayoutParams: function(/*Object*/ alg){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// alg:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.getAvailableLayoutParms');
			return null;
		},
		
		setLayoutAlgorithm: function(/*Object*/ alg, /*Object*/ subgraphId, /*Object*/ performLayout){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.setLayoutAlgorithm');
		},
		
		getLayoutAlgorithm: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.getLayoutAlgorithm');
			return null;
		},

		setLayoutParams: function(/*Object*/ layoutParams, /*Object*/ subgraphId, /*Object*/ performLayout){			
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// layoutParams:
			//		Coming soon
			// subgraphId:
			//		Coming soon
			// performLayout:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.setLayoutParams');
		},

		setLayoutToCanvasBasedOnWidgetDef: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.setLayoutToCanvasBasedOnWidgetDef');
		},

		getRelatedItems: function(/*Object*/ item) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// item:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.getRelatedItems');
			return null;
		},

	    getRolloverTarget: function() {
			// summary:
			//		Returns the graph entity under the mouse cursor in the canvas
			// description:
			//		This accessor returns the item (node), link, or relationship under the mouse
			//      cursor in the topology graph.  This can be used when overriding what is
			//      displayed in the tooltip for the entity.
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas.getRolloverTarget');
			return null;
		},

	    getTooltip: function() {
			// summary:
			//		Returns the tooltip instance used for the canvas.
			// description:
			//		This accessor returns the ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip instance
			//      used to display tooltips for all entities in the topology graph.
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.getTooltip');
			return null;
		},
		
		setEnabledObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Boolean*/enabled){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.setEnabledObjectIds');
		},

		setAllEnabled: function(/*Boolean*/enabled){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.setAllEnabled');
		},

		setZoomTo: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			throw new Error('Unimplemented API: ibm.tivoli.tip.navwidget.topology.dijit.setZoomTo');
		},

		//******************************************************************************************
		//AWE TODO: Some potentially missing signatures here include: key press management for shortcuts, ??
		//******************************************************************************************

		//******************************************************************************************
		// Events BaseCanvas Fires
		//******************************************************************************************
		onObjectDoubleClick: function (/*Object*/ objectContext) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// objectContext:
			//		Coming soon
		},

		onObjectExpand: function (/*Object*/ objectContext) {
			// summary:
			//		Handles loading of items that are lazy loaded.
			// description:
			//		Handles loading of items that are lazy loaded.
			// objectContext:
			//		Provides the context surrounding the current event, in this case the current item
			// 		or child subgraph to be expanded.
			
		},

		onObjectCollapse: function (objectContext) {
			// summary:
			//		Handles removal of items that have previously been lazy loaded and alerts Flex bridge.
			// description:
			//		Handles removal of items that have previously been lazy loaded and alerts Flex bridge.
			// objectContext:
			//		Provides the context surrounding the current event, in this case the current item
			// 		to be collapsed.
			
		},

		onObjectRollOver: function (objectContext) {
		},
		
		onObjectRollOut: function (/*Object*/ objectContext) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// objectContext:
			//		Coming soon
		}
		
	});
