/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * "Restricted Materials of IBM"
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.Canvas");

dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dijit._Templated");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer");

// CSV Export requires
dojo.require("ibm.tivoli.tip.navwidget.topology.dojo.Exporter");
dojo.require("ibm.tivoli.tip.navwidget.topology.dojo.CSVWriter");
dojo.require("dojo.io.iframe");

//Dataset-related requires
dojo.require("ibm.tivoli.navmodel.Dataset");
dojo.require("ibm.tivoli.navmodel.Item");
dojo.require("ibm.tivoli.navmodel.Link");
dojo.require("ibm.tivoli.navmodel.Task");
dojo.require("ibm.tivoli.navmodel.TopoWidgetDef");

dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas");
dojo.require("ibm.tivoli.tip.navwidget.topology.dojo.CanvasBridgeDatasetUtil");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.SWFContainer");
dojo.require("ibm.tivoli.tip.navwidget.dojo.Timer");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("ibm.tivoli.tip.navwidget.topology.dojo.CanvasSelection");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidget");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetBaseViewState");
ibm.tivoli.tip.navwidget.topology.dijit.Canvas._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dijit.Canvas");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.Canvas",
	[ibm.tivoli.tip.navwidget.topology.dijit.SWFContainer, ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas],
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		//***************************
		// "Private"
		//***************************
	
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
		_trace: ibm.tivoli.tip.navwidget.topology.dijit.Canvas._trace,
		
		// _menuLayer: [private] Object
		//		Reference to transparent DIV context menu layer
		_menuLayer: null,  
		
		// _connectionHandles: [private] Object
		//		Collection of event handles we create
		_connectionHandles: null,
		
		// _CANVAS_BASE: [private const] String
		_CANVAS_BASE: "Canvas/",
		
		// _SWF_DEBUG_DIR: [private const] String
		_SWF_DEBUG_DIR: "swf-debug/",
		
		// _SWF_RELEASE_DIR: [private const] String
		_SWF_RELEASE_DIR: "swf-release/",
		
		// _RESOURCES_DIR: [private const] String
		_RESOURCES_DIR: "resources/",
		
		// _SWF_FILE_NAME: [private const] String
		_SWF_FILE_NAME: "topologyCanvas.swf",
		
		// _EMPTY_DATASET_STRING: [private const] String
		_EMPTY_DATASET_STRING: "",
		
		// _dojoCanvasBase: [private] Object
		//		Coming soon
		_dojoCanvasBase: null,
		
		// _dojoSWFBase: [private] Object
		//		Coming soon
		_dojoSWFBase: null,
		
		// _pendingBridgetDataset: [private] Object
		//		Place to store the bridge dataset if Flex not initialized yet
		_pendingBridgeDataset: null,
		
		// _pendingEventQueue: [private] Queue
		//		Place to store store any pending events (e.g., events that come in before Flex bridge is ready, etc.)
		_pendingEventQueue: null,
		
		// _layoutAlgorithm: [private] Object
		//		Last layout arg
		_layoutAlgorithm: null,
		
		// _layoutParams: [private] Object
		//		Last set of layout parms
		_layoutParams: null,

		// _objectsAdded: [private] Object
		//		Last set of objects added
		_objectsAdded: null,

		constructor: function () {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	
			//Create data structure to hold connection handles to clean up later
			this._connectionHandles = [];
			
			//Signal to superclass we'll be firing onSetDataSetLoadComplete manually
			this._setDatasetLoadDataCompletesSynchronously = false;
			
			//We don't have a widget def specific to this view, so let's signal to 
	        //super class not to try and load any widget defs on our behalf
			this._usesWidgetDefinition = false;
			
			//Create the queue to store any pending events (e.g., events that come
			//in before Flex bridge is ready, etc.)
			this._pendingEventQueue = new dojox.collections.Queue();
		},

		destroy: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//clean up the context menu layer first
			if (this._menuLayer) {
				this._menuLayer.destroy();
			}
			dojo.forEach(this._connectionHandles, function(h) {dojo.disconnect(h);});
			this._connectionHandles = [];

			this._pendingBridgeDataset = null;
			
			//Clean pending event queue
			if (this._pendingEventQueue) {
				this._pendingEventQueue.clear();
				this._pendingEventQueue = null;
			}

			this.inherited(arguments);
		},	

		postCreate: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Use the Dojo module URL to calculate where this class is located. We originally used dojo.config.baseUrl, but that doesn't work for
			//products like Role Manager who want to package the Common Topology JS in a custom location. This assumes they have a registerModule for "ibm"
			//in the main HTML/JSP.
			this._dojoCanvasBase = dojo.moduleUrl("ibm.tivoli.tip.navwidget.topology.dijit", this._CANVAS_BASE).uri;

			//Determine whether to use release or debug version of the SWF
			if (dojo.config.flex && dojo.config.flex.useDebugVersion) {
				this._dojoSWFBase = this._dojoCanvasBase + this._SWF_DEBUG_DIR;
				
			} else {
				this._dojoSWFBase = this._dojoCanvasBase + this._SWF_RELEASE_DIR;
			}	
			
			//Calculate the full SWF file name and the base path to where "widget-relative" image resources might be found
			this.swfFileName = this._dojoSWFBase + this._SWF_FILE_NAME;
			
			//Register a callback so we know when the Flex AJAX Bridge has been initialized
			this.addInitializationCallback(this._flexBridgeInitializationCallback);
	
			// Register mousewheel events so that can pass to Flex bridge for proper rendering
			dojo.connect(this.domNode, (dojo.isMozilla ? "DOMMouseScroll" : "onmousewheel"), this, 
				function(event) {
					var wheelEvent;
					if (dojo.isMozilla) {
						wheelEvent = {x: event.layerX, y: event.layerY, 
								  delta: event.detail,
								  ctrlKey: event.ctrlKey, altKey: event.altKey, 
								  shiftKey: event.shiftKey};
					} else {					
						wheelEvent = {x: event.layerX, y: event.layerY, 
							delta: event.wheelDelta * -1,
							ctrlKey: event.ctrlKey, altKey: event.altKey, 
							shiftKey: event.shiftKey};
						this._preventMouseWheel(event);
					}

					if (this.isFlexBridgeInitialized()) {					
						var topologyFlexBridge = this.getFlexBridge();
						if (topologyFlexBridge) {				
							topologyFlexBridge.handleWheelEvent(wheelEvent);
						}
					} else {
						if (this._trace.isFinest()) {
							this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "onObjectCollapse");
						}
					}									
			});

			// Mixin the Exporter object to provide export to CSV support
	        new ibm.tivoli.tip.navwidget.topology.dojo.Exporter(this);

			//Call superclass
			this.inherited(arguments);
		},
		
		_setDatasetLoadData: function(/*ibm.tivoli.navmodel.Dataset*/ dataset){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// dataset:
			//		Coming soon
			if (this._trace.isFinest()) {
				this._trace.entering("setting dataset for " + this.id, "_setDatasetLoadData");
			}
			
			//It's possible a dataset had been set previously, but the Flex bridge was never
			//initialized (most likely, when Topology View is in a stack container and the Flash
			//plugin was not made visible yet).
			if (!this.isFlexBridgeInitialized() && this._pendingBridgeDataset) {
				this._pendingBridgeDataset = null;
			}
			
			//Let's wipe out the dataset on the Flex side so that old topology is gone from display while
			//we're loading the new one.
			if (!(dojo.isIE)) { //251167 -- add check to avoid timing problem (and subsequent Flash player crash) that occurs in IE
				this._clearDatasetOnFlexBridge();
			}

			//Let's load in the data set and pass on to Flex bridge
			if (this.dataset) {
				this._canvasBridgeDatasetUtil = new ibm.tivoli.tip.navwidget.topology.dojo.CanvasBridgeDatasetUtil(this.dataset, this.widgetDefinition, this);
				//Define a callback that fires when the canvasBridgeDataset is populated.
				var gotCanvasBridgeDataset = function(bridgeDataset, args){
					if (this._trace.isFinest()) {
						this._trace.entering("bridgeDataset populated for " + this.id, "gotCanvasBridgeDataset");
						
						//Stop the timer to see how long it took to be called back
						var datasetPopulationTimer = args.datasetPopulationTimer;
						if (datasetPopulationTimer) {
							this._trace.finest("bridgeDataset population completed; " + datasetPopulationTimer.stopAndGetTraceString(), "gotCanvasBridgeDataset");
						}
					}

					//Pass data across the bridge now that we have it
					this._setDatasetOnFlexBridge(bridgeDataset);	

					//Exiting
					if (this._trace.isFinest()) {
						this._trace.entering("bridgeDataset populated  for " + this.id, "gotCanvasBridgeDataset");
					}
				};
	
				var gotCanvasBridgeDatasetError = function(error, request){
					//Give the user some feedback
		            this.displayException(error);
				};
	
				//Populate the bridge dataset
				var bridgeDatasetArgs = {
					onComplete: dojo.hitch(this,gotCanvasBridgeDataset),
					onError: dojo.hitch(this, gotCanvasBridgeDatasetError)
				};
				if (this._trace.isFinest()) {
					//Start a timer to see how long it takes
					var datasetPopulationTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
					bridgeDatasetArgs.datasetPopulationTimer = datasetPopulationTimer;
					datasetPopulationTimer.start();
				}
				this._canvasBridgeDatasetUtil.getBridgeDataset(bridgeDatasetArgs);
			} else {
				//No dataset, so fire _onSetDatasetLoadComplete
				setTimeout(dojo.hitch(this, this._onSetDatasetLoadComplete, dataset), 0);
			}
			
			//Call superclass
			this.inherited(arguments);
			
			if (this._trace.isFinest()) {
				this._trace.exiting("setting dataset for " + this.id, "_setDatasetLoadData");
			}
		},
		
		onSetDataset: function(dataset) {
			//Call superclass
			this.inherited(arguments);
			
			//Process all the enqueued events
			if (this._trace.isFinest()) {
				this._trace.exiting("about to process " + this._pendingEventQueue.count + " pending events for canvas = "+ this.id, "onSetDataset");
			}
			var queuedEvent = this._pendingEventQueue.dequeue();
			while (queuedEvent) {
				this._datasetEventListenerCallback(this, queuedEvent, true);
				queuedEvent = this._pendingEventQueue.dequeue();
			}
		},
		
		_getStateData: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Create data structure to hold state data like the visible view rect, etc.
			var stateData = {};
			var rect = this._getGraphVisibleAreaFromFlexBridge();
			stateData.graphVisibleArea = rect;
			stateData.layoutAlgorithm = this._layoutAlgorithm;
			stateData.layoutParams = this._layoutParams;
			
			return stateData;
		},
		
		restoreFromState: function(/*Object*/ state) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// state:
			//		Coming soon
			if (state) {
				this._fitRectangleOnFlexBridge(state.stateData.graphVisibleArea);
			} else {
				this._fitOrZoomBasedOnWidgetDef();
			}
			
			this.inherited(arguments);
		},
		
		//***************************
		// "Public"
		//***************************		
		print: function(/*int*/ pageCount, /*Object*/ pageMargin, /*Object*/ printAsBitmap){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// pageCount:
			//		Coming soon
			// pageMargin:
			//		Coming soon
			// printAsBitmap:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.print(pageCount, pageMargin, printAsBitmap);
				} 
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "print");
				}
			}
		},

		zoomIn: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.zoomIn();
				} 
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "zoomIn");
				}
			}
		},
		
		zoomOut: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.zoomOut();
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "zoomOut");
				}
			}
		},		

		setZoomLevel: function(/*float*/ zoomLevel, /*boolean*/ useOriginNodes){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setZoomLevel(zoomLevel, useOriginNodes);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "zoomLevel");
				}
			}
		},

		setMouseMode: function(/*Object*/ mouseMode){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// mouseMode: 
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setMouseMode(mouseMode);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "setMouseMode");
				}
			}
		},
		
		//Valid values are "none", "single", "multiple", "extended". 
		_setSelectionModeOnFlexBridge: function(/*Object*/ selectionMode){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// selectionMode:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setSelectionMode(selectionMode);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setSelectionModeOnFlexBridge");
				}
			}
		},
		
		fitContents: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.fitContents();
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "fitContents");
				}
			}
		},
		
		performLayout: function(fitContentsAfterLayout){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.performGraphLayout(fitContentsAfterLayout);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "fitContents");
				}
			}
		},

		setBackgroundColor: function(/*Object*/ backgroundColor) {
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setBackgroundColor(backgroundColor);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "zoomOut");
				}
			}
		},

		getAvailableLayoutAlgorithms: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					return topologyFlexBridge.getAvailableLayoutAlgorithms();
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "getAvailableLayoutAlgorithms");
				}
			}
			return null;
		},

		getAvailableLayoutParams: function(/*Object*/ alg){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// alg:
			//		Coming soon
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					return topologyFlexBridge.getAvailableLayoutParams(alg);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "getAvailableLayoutParams");
				}
			}
			return null;
		},
		
		setLayoutAlgorithm: function(/*Object*/ alg, /*Object*/ subgraphId, /*Object*/ performLayout){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					if (!subgraphId) {
						this._layoutAlgorithm = alg;
					}
					topologyFlexBridge.setLayoutAlgorithm(alg, subgraphId, performLayout);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "setLayoutAlgorithm");
				}
			}
		},
		
		getLayoutAlgorithm: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					return topologyFlexBridge.getLayoutAlgorithm();
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "getLayoutAlgorithm");
				}
			}
			return null;
		},

		setLayoutParams: function(/*Object*/ layoutParams, /*Object*/ subgraphId, /*Object*/ performLayout){			
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// layoutParams:
			//		Coming soon
			// subgraphId:
			//		Coming soon
			// performLayout:
			//		Coming soon
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					if (!subgraphId) {
						this._layoutParams = layoutParams;
					}
					topologyFlexBridge.setLayoutParams(layoutParams, subgraphId, performLayout);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "setlayoutParams");
				}
			}
		},
	
		setUseNodeLevelAndPosition: function() {
			if (this.dataset) {
				var useNodeLevelAndPosition = null;
				if (this.dataset.getAttribute("useNodeLevelAndPosition") != undefined)
					useNodeLevelAndPosition = this.dataset.getAttribute("useNodeLevelAndPosition");	
				if (this.widgetDefinition && this.widgetDefinition.useNodeLevelAndPosition() != undefined)
					useNodeLevelAndPosition = this.widgetDefinition.useNodeLevelAndPosition();
	
				// Set the value in Flex
				if ((useNodeLevelAndPosition != null) && (this.isFlexBridgeInitialized())) {
					var topologyFlexBridge = this.getFlexBridge();
					if (topologyFlexBridge) {
						if (useNodeLevelAndPosition == true) {
							topologyFlexBridge.useNodeLevelAndPosition(true);
						} else { 
							topologyFlexBridge.useNodeLevelAndPosition(false);
						}
					}
				} else {
					if (this._trace.isFinest()) {
						this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "useNodeLevelAndPosition");	
					}
				}
			}
		},
		
		setNodeOrderDirection: function() {
			if (this.dataset) {
				var nodeOrderDirection = null;
				if (this.dataset.getAttribute("nodeOrderDirection") != undefined)
					nodeOrderDirection = this.dataset.getAttribute("nodeOrderDirection");
				if (this.widgetDefinition && this.widgetDefinition.getNodeOrderDirection() != undefined)
					nodeOrderDirection = this.widgetDefinition.getNodeOrderDirection();
	
				// Set the value in Flex
				if (nodeOrderDirection != null && this.isFlexBridgeInitialized()) {
					var topologyFlexBridge = this.getFlexBridge();
					if (topologyFlexBridge) {
						topologyFlexBridge.setNodeOrderDirection(nodeOrderDirection);
					}
				} else {
					if (this._trace.isFinest()) {
						this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "setNodeOrderDirection");	
					}
				}
			}
		},
		
		setNodeOrderProperty: function() {
			var nodeOrderProperty;
			if (this.dataset.getAttribute("nodeOrderProperty") != undefined)
				nodeOrderProperty = this.dataset.getAttribute("nodeOrderProperty");
			if (this.widgetDefinition && this.widgetDefinition.getNodeOrderProperty() != undefined)
				nodeOrderProperty = this.widgetDefinition.getNodeOrderProperty();

			// Set the value in Flex
			if (nodeOrderProperty != null && this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setNodeOrderProperty(nodeOrderProperty);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "setNodeOrderProperty");	
				}
			}
		},

		setLayoutToCanvasBasedOnWidgetDef: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			var state = this.getSetDatasetState();
			if(this.widgetDefinition){
				var layoutAlgorithm = null;
				var layoutParamsArray = null;
				if (state) {
					layoutAlgorithm = state.stateData.layoutAlgorithm;
				    layoutParamsArray = state.stateData.layoutParams;
				} else {					
					var layout = this.widgetDefinition.getDefaultLayout();
					layoutAlgorithm = layout.algorithm;
					var layoutParams = this.getAvailableLayoutParams(layoutAlgorithm);
					layoutParamsArray = new Array(layoutParams.length);
					for (var i=0;i<layoutParams.length;i++) {
						layoutParamsArray[i] = new Array(3);
						if(layout[layoutParams[i][0]]){
							layoutParamsArray[i][0] = layoutAlgorithm; 
							layoutParamsArray[i][1] = layoutParams[i][0];
							layoutParamsArray[i][2] = layout[layoutParams[i][0]];
						} else {
							//Fill-in the default
							layoutParamsArray[i][0] = layoutAlgorithm;
								
							var params = layoutParams[i][1].split("|");		  
							layoutParamsArray[i][1] = layoutParams[i][0];
							layoutParamsArray[i][2] = params[0];
							layout[layoutParams[i][0]] = params[0];
						}
					}
				}
				this.setLayoutAlgorithm(layoutAlgorithm, null, false);
				this.setLayoutParams(layoutParamsArray, null, false); //Pass in true on the last one so we only do the lay out once
				
				this._setRenderRelationshipsInsteadOfLinksOnFlexBridge(this.widgetDefinition.getRenderRelationshipsInsteadOfLinks());
				var labelStyle = this.widgetDefinition.getLabelStyle();
				if (!labelStyle) {
					labelStyle = "endEllipsis";
				}
				this._setItemLabelStyleOnFlexBridge(labelStyle);
				
				//NOTE: We could eventually choose to make this configurable by widget def
				var keyboardNavigationPolicy = "nodesByHierarchy"; //nodesByConnection, nodesByHierarchy, none
				this._setKeyboardNavigationPolicyOnFlexBridge(keyboardNavigationPolicy);
				
				//NOTE: Mainly used for some performance benchmarking, but could potentially be made part of widget def. The "basic" 
				//renderers are the default ones provided by ILOG as opposed to the "fancy" one we've made with icons, etc.
				this._setUseBasicNodeRendererOnFlexBridge(false); //Default should be false
				this._setUseBasicLinkRendererOnFlexBridge(false); //Default should be false
				this._setUseBasicSubgraphRendererOnFlexBridge(false); //Default should be false
			}
		},

        _setLayoutToCanvasBasedOnDataset: function(bridgeDataset) {
			// summary:
			//		Set layout parameters based on dataset attributes for datasets and child datasets
			// description:
			//		Set layout parameters based on dataset attributes for datasets and child datasets
			if (this.dataset) {
				// Override widget def layout with specific dataset parameters
				var layoutAlgorithm = this.dataset.getAttribute("layoutAlgorithm");			
				if (layoutAlgorithm) {
					this.setLayoutAlgorithm(layoutAlgorithm, null, false);	
					var layout = this.parentPluggableView.getLayoutByName(layoutAlgorithm);
					if (layout) { //251593
						var layoutParams = this.getAvailableLayoutParams(layoutAlgorithm);
						var layoutParamsArray = new Array(layoutParams.length);
						var datasetLayoutParams = this.dataset.getAttribute("layoutParameters");					
						if (datasetLayoutParams){
							datasetLayoutParams = eval('('+datasetLayoutParams+')');
							for (var i=0;i<layoutParams.length;i++) {
								layoutParamsArray[i] = new Array(3);
								if (datasetLayoutParams[layoutParams[i][0]]) {
									layoutParamsArray[i][0] = layoutAlgorithm; 
									layoutParamsArray[i][1] = layoutParams[i][0];
									layoutParamsArray[i][2] = datasetLayoutParams[layoutParams[i][0]];
									layout[layoutParams[i][0]] = datasetLayoutParams[layoutParams[i][0]];
								} else {
									//Fill-in the default
									layoutParamsArray[i][0] = layoutAlgorithm;													
									var params = layoutParams[i][1].split("|");		  
									layoutParamsArray[i][1] = layoutParams[i][0];
									layoutParamsArray[i][2] = params[0];
									layout[layoutParams[i][0]] = params[0];
								}
							}						
							this.setLayoutParams(layoutParamsArray, null, false);
						}
					} else { 
						//251593 -- let's warn the deployer
						if (this._trace.isWarn()) {
							this._trace.warn("Dataset specifying layout algorithm (layoutAlgorithm = '" + layoutAlgorithm + "') not specified in original widget def. So, specified layout will be ignored.", "_setLayoutToCanvasBasedOnDataset");
						}
					}					
				}		
	
				// Set the appropriate layout algorithm and layout params to the subgraphs
				if (bridgeDataset.subgraphItemIds) {
					for(var i=0;i<bridgeDataset.subgraphItemIds.length;i++){
						var item = this.dataset.getItem({itemId: bridgeDataset.subgraphItemIds[i]});
						if (item && item.isSubgraph()) {
							var alg = item.getAttribute("layoutAlgorithm");
							var datasetLayoutParams = item.getAttribute("layoutParameters");
							if(alg) {
								this.setLayoutAlgorithm(alg, item.getId(), false);						
								if(datasetLayoutParams){
									datasetLayoutParams = eval('('+datasetLayoutParams+')');
									var params = [];
									for(paramName in datasetLayoutParams){
										params.push([alg,paramName,datasetLayoutParams[paramName]]);
									}								
									this.setLayoutParams(params, item.getId(), false);						
								}						
							}
						}
					}
				}
			}
		},	
		
		_setRenderRelationshipsInsteadOfLinksOnFlexBridge: function(/*Object*/ renderRelationships){		
			// summary:
			//		Determines whether links or relationships should be drawn between the nodes in the graph. 
			// renderRelationships:
			//		Whether links or relationships should be drawn between the nodes in the graph.
			// description:
			//		Determines whether links or relationships should be drawn between the nodes in the graph. When links are 
			//		rendered, any relationships contained in a link are combined into a single line between the two nodes. When 
			//		relationship are rendered, any relationships in a link between two nodes will be drawn as individual lines.
			//
			//		NOTE: Due to the nature of the TREE layout, setting render relationships to true will not show multiple
			//		lines between two nodes even if multiple relationships between the two nodes exist.
			// tags:
			//		private
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setRenderRelationshipsInsteadOfLinks(renderRelationships);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setRenderRelationshipsInsteadOfLinksOnFlexBridge");
				}
			}
		},
		
		_setItemLabelStyleOnFlexBridge: function(/*Object*/ labelStyle){		
			// summary:
			//		Determines how item labels are rendered. 
			// labelStyle:
			//		Valid values are "noEllipsis", "endEllipsis", "pathEllipsis"
			// description:
			//		Determines how item labels are rendered.
			// tags:
			//		private
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setItemLabelStyle(labelStyle);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setItemLabelStyleOnFlexBridge");
				}
			}
		},
		
		// Need this for disabling IE mouse wheel events
		_preventMouseWheel : function (e) {
		      if (!e) e = window.event;
		      if (e.preventDefault)
        			e.preventDefault();
		      e.returnValue = false;
		      return false;
		},

		_setKeyboardNavigationPolicyOnFlexBridge: function(/*Object*/ keyboardNavigationPolicy){		
			// summary:
			//		Determines how keyboard navigation behaves in the topology when the Flash plugin has focus. 
			// keyboardNavigationPolicy:
			//		Can be one of nodesByConnection, nodesByHierarchy, none
			// description:
			//		Determines how keyboard navigation behaves in the topology when the Flash plugin has focus. 
			// tags:
			//		private
			
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setKeyboardNavigationPolicy(keyboardNavigationPolicy);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setKeyboardNavigationPolicyOnFlexBridge");
				}
			}
		},
		
		_setUseBasicNodeRendererOnFlexBridge: function(/*Boolean*/ useBasicRenderer){		
			// summary:
			//		Determines whether or not to use the most basic, built-in ILOG renderer. 
			// useBasicRenderer:
			//		
			// description:
			//		Determines whether or not to use the most basic, built-in ILOG renderer. 
			// tags:
			//		private
			
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setUseBasicNodeRenderer(useBasicRenderer);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setUseBasicNodeRendererOnFlexBridge");
				}
			}
		},
		
		_setUseBasicLinkRendererOnFlexBridge: function(/*Boolean*/ useBasicRenderer){		
			// summary:
			//		Determines whether or not to use the most basic, built-in ILOG renderer. 
			// useBasicRenderer:
			//		
			// description:
			//		Determines whether or not to use the most basic, built-in ILOG renderer. 
			// tags:
			//		private
			
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setUseBasicLinkRenderer(useBasicRenderer);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setUseBasicNodeRendererOnFlexBridge");
				}
			}
		},

		_setUseBasicSubgraphRendererOnFlexBridge: function(/*Boolean*/ useBasicRenderer){		
			// summary:
			//		Determines whether or not to use the most basic, built-in ILOG renderer. 
			// useBasicRenderer:
			//		
			// description:
			//		Determines whether or not to use the most basic, built-in ILOG renderer. 
			// tags:
			//		private
			
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setUseBasicSubgraphRenderer(useBasicRenderer);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setUseBasicNodeRendererOnFlexBridge");
				}
			}
		},
		
		exportAsImage: function(/*Object*/dialogTitle, /*Object*/questionText, /*Object*/pngOptionLabel, /*Object*/jpgOptionLabel, /*Object*/exportButtonLabel, /*Object*/cancelButtonLabel, /*Object*/baseDefaultFileName){		
			// summary:
			//		Causes diagram contents to be exported as an image. 
			// description:
			//		Causes diagram contents to be exported as an image. 
			// tags:
			//		public
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.exportAsImage(dialogTitle, questionText, pngOptionLabel, jpgOptionLabel, exportButtonLabel, cancelButtonLabel, baseDefaultFileName);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setRenderRelationshipsInsteadOfLinksOnFlexBridge");
				}
			}
		},
		
		_populateChangedDataset: function(/*Object*/ changedDataset) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// changedDataset
			//		Coming soon
			// isNew:
			//		Coming soon

			//Let's load in the data set and pass on to Flex bridge			
			var bridgeDatasetUtil = new ibm.tivoli.tip.navwidget.topology.dojo.CanvasBridgeDatasetUtil(changedDataset, this.widgetDefinition, this);

			//Define a callback that fires when the canvasBridgeDataset is populated.
			var gotChangedDataset = function(bridgeDataset, args){
				if (this._trace.isFinest()) {
					this._trace.entering("changedDataset populated for " + this.id, "gotChangedDataset");
					
					//Stop the timer to see how long it took to be called back
					var datasetPopulationTimer = args.datasetPopulationTimer;
					if (datasetPopulationTimer) {
						this._trace.finest("changedDataset population completed; " + datasetPopulationTimer.stopAndGetTraceString(), "gotChangedDataset");
					}
				}
	
				if (this.isFlexBridgeInitialized()) {
					var topologyFlexBridge = this.getFlexBridge();
					if (topologyFlexBridge) {	
						//Already exists, so tell Flex side to modify
						topologyFlexBridge.handleChangedEvent(bridgeDataset);
					}
				} else {
					if (this._trace.isFinest()) {
						this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_populateChangedDataset");
					}
				}
			
				//Exiting
				if (this._trace.isFinest()) {
					this._trace.entering("newOrChangedDataset populated  for " + this.id, "gotNewOrChangedDataset");
				}
			};
	
			var gotChangedDatasetError = function(error, request){
				//Give the user some feedback
	            this.displayException(error);
			};
	
			//Populate the bridge dataset
			var bridgeDatasetArgs = {
				onComplete: dojo.hitch(this,gotChangedDataset),
				onError: dojo.hitch(this, gotChangedDatasetError)
			};
			if (this._trace.isFinest()) {
				//Start a timer to see how long it takes
				var datasetPopulationTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
				bridgeDatasetArgs.datasetPopulationTimer = datasetPopulationTimer;
				datasetPopulationTimer.start();
			}
			bridgeDatasetUtil.getBridgeDataset(bridgeDatasetArgs);
		},

		getRelatedItems: function(/*Object*/ item) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// item:
			//		Coming soon
			
			//Define a callback that fires when all the items are returned.
			var gotRelatedItems = function(items, links){
				var bridgeItems = new Array(items.length);
				var bridgeItemIds = new Array (items.length);
				for (var i = 0; i < items.length; i++) {
					bridgeItems[i] = this._canvasBridgeDatasetUtil._toAjaxBridgeItem(items[i]);				
					bridgeItemIds[i] = bridgeItems[i].id;
				}

				var bridgeLinks = new Array(links.length);
				var bridgeLinkIds = new Array (links.length);
				for (var i = 0; i < links.length; i++) {
					bridgeLinks[i] = this._canvasBridgeDatasetUtil._toAjaxBridgeLink(links[i]);
					bridgeLinkIds[i] = bridgeLinks[i].id;
				}

				if (this.isFlexBridgeInitialized()) {
					var topologyFlexBridge = this.getFlexBridge();
					if (topologyFlexBridge) {	
						// Do not use incremental mode in lazy load			
						topologyFlexBridge.setIncrementalMode(false);				
						this._setObjectsAdded({itemIds: bridgeItemIds,
						                       linkIds: bridgeLinkIds});						
						topologyFlexBridge.handleItemsLinksAddedEvent(bridgeItems, bridgeLinks);
						topologyFlexBridge.setIncrementalMode(true);
					}	
				} else {
					if (this._trace.isFinest()) {
						this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "getRelatedItems");
					}
				}
			};	
	
			var gotRelatedItemsError = function(error, request){
				//Give the user some feedback
	            this.displayException(error);
			};
	
			//Fetch the items and links
			var itemArgs = {
					onComplete: dojo.hitch(this,gotRelatedItems),
					onError: dojo.hitch(this, gotRelatedItemsError)
				};
			item.getRelatedItems(itemArgs);
		},

	    getRolloverTarget: function() {
			// summary:
			//		Returns the graph entity under the mouse cursor in the canvas
			// description:
			//		This accessor returns the item (node), link, or relationship under the mouse
			//      cursor in the topology graph.  This can be used when overriding what is
			//      displayed in the tooltip for the entity.
			return this._menuLayer ? this._menuLayer.getRolloverTarget() : null;
		},

	    getTooltip: function() {
			// summary:
			//		Returns the tooltip instance used for the canvas.
			// description:
			//		This accessor returns the ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip instance
			//      used to display tooltips for all entities in the topology graph.
			return this._menuLayer ? this._menuLayer.getTooltip() : null;
		},
		
		setEnabledObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Boolean*/enabled){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			if (enabled == undefined) {
				enabled = true;
			}
			this._setEnabledObjectIdsOnFlexBridge(itemIds, linkIds, relationshipIds, enabled);
		},

		setAllEnabled: function(/*Boolean*/enabled){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (enabled == undefined) {
				enabled = true;
			}
			this._setAllEnabledOnFlexBridge(enabled);
		},

		setZoomTo: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Number*/ zoomLevel){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon

			this._setZoomToOnFlexBridge(itemIds, linkIds, relationshipIds, zoomLevel);
		},

		//******************************************************************************************
		// Events Canvas Fires
		//******************************************************************************************
		
		onObjectDoubleClick: function (/*Object*/ objectContext) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// objectContext:
			//		Coming soon
		},

		onObjectExpand: function (/*Object*/ objectContext) {
			// summary:
			//		Handles loading of items that are lazy loaded.
			// description:
			//		Handles loading of items that are lazy loaded.
			// objectContext:
			//		Provides the context surrounding the current event, in this case the current item
			// 		or child subgraph to be expanded.
			if (objectContext.getItems().length > 0) {
				var items = objectContext.getItems();

				for (var i=0;i<items.length;i++) {
					if (items[i].isLazyLoad()) {
						this.getRelatedItems(items[i]);			
						items[i].setLazyLoad(false);
					} else {
						var bridgeItemIds = new Array(items.length);
						bridgeItemIds[0] = items[i].getId();
						
						if (this.isFlexBridgeInitialized()) {
							var topologyFlexBridge = this.getFlexBridge();
							if (topologyFlexBridge) {				
								topologyFlexBridge.handleSubtreeExpandEvent(bridgeItemIds);
							}
						} else {
							if (this._trace.isFinest()) {
								this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "onObjectCollapse");
							}
						}		
					} 
				}				
			} 
		},

		onObjectCollapse: function (objectContext) {
			// summary:
			//		Handles removal of items that have previously been lazy loaded and alerts Flex bridge.
			// description:
			//		Handles removal of items that have previously been lazy loaded and alerts Flex bridge.
			// objectContext:
			//		Provides the context surrounding the current event, in this case the current item
			// 		to be collapsed.
			
			// Handled on Flex side
		},

		onObjectRollOver: function (objectContext) {
		},
		
		onObjectRollOut: function (/*Object*/ objectContext) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// objectContext:
			//		Coming soon
		},
		
		_csvDataReady: function(/*String*/csvData) {
			// summary:
			//		Callback for the CSV export (data is ready)
			// description:
			//		Coming soon
			// csvData:
			//		A string of the exported CSV data for the topology graph
			
			// Send the data to the temporary holding area on the server
			dojo.xhrPost({
				url: "/ibm/tivoli/rest/reflect/exportdata.csv",
				headers: {
					'Content-Type': 'text/plain',
					'Content-Length': csvData.length
				},
				handleAs: "json",
				postData: csvData,
				sync: true,
				load: dojo.hitch(this, function(result, ioArgs){
					var a = 0;
				}),
				error: dojo.hitch(this, function(error, ioArgs){
					var b = 0;
				})
			});

			// Hide the busy pane now before the Save dialog comes up
		    this.hideBusyPane();
		    
		    // Retrieve the data from the temporary holding area on the server
		    // using the browser Save dialog to allo the user to save the CSV file
		    dojo.io.iframe.send({
		    	url: "/ibm/tivoli/rest/reflect/exportdata.csv",
		    	method: "GET",
		    	content: {contentType: "text/csv"},
		    	timeout: 3000,
		    	load: dojo.hitch(this, function(result, ioArgs) {
		    		var x = 0;
		    	}),
		    	error: dojo.hitch(this, function(error, ioArgs){
		    		var y = 0;
		    	})
		    });
		},

		//******************************************************************************************
		_createSelection: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Need our own selection object
			var kwArgs = {
					pluggableView: this
				};
			return new ibm.tivoli.tip.navwidget.topology.dojo.CanvasSelection(kwArgs); 
		},
		
		_getSelectedObjectIdsFromFlexBridge: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					return topologyFlexBridge.getSelectedObjectIds();
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_getSelectedObjectIdsFromFlexBridge");
				}
			}
			return {};
		},
		
		_setSelectedObjectIdsOnFlexBridge: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					var selectedObjectIds = {
							itemIds: itemIds,
							linkIds: linkIds,
							relationshipIds: relationshipIds
					};
					topologyFlexBridge.setSelectedObjectIds(selectedObjectIds);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setSelectedObjectIdsOnFlexBridge");
				}
			}
		},

		_setEnabledObjectIdsOnFlexBridge: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Boolean*/enabled){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					var objectIds = {
							itemIds: itemIds,
							linkIds: linkIds,
							relationshipIds: relationshipIds
					};
					topologyFlexBridge.setEnabledObjectIds(objectIds, enabled);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setEnabledObjectIdsOnFlexBridge");
				}
			}
		},

		_setAllEnabledOnFlexBridge: function(/*Boolean*/enabled){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.dataset && this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setAllEnabled(enabled);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setAllEnabledOnFlexBridge");
				}
			}
		},

		_setZoomToOnFlexBridge: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Number*/ zoomLevel){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					var zoomToObjectIds = {
							itemIds: itemIds,
							linkIds: linkIds,
							relationshipIds: relationshipIds
					};
					topologyFlexBridge.zoomTo(zoomToObjectIds, zoomLevel);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_setZoomToOnFlexBridge");
				}
			}
		},

		_getLastDoubleClickEventOnFlexBridge: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					return topologyFlexBridge.getLastDoubleClickEvent();
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_getLastDoubleClickEventOnFlexBridge");
				}
			}
			return null;
		},
		
		_getLastRollOverEventOnFlexBridge: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					return topologyFlexBridge.getLastRollOverEvent();
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_getLastRollOverEventOnFlexBridge");
				}
			}
			return null;
		},
		
		_getLastRollOutEventOnFlexBridge: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					return topologyFlexBridge.getLastRollOutEvent();
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_getLastRollOutEventOnFlexBridge");
				}
			}
			return null;
		},
		
		_getGraphVisibleAreaFromFlexBridge: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					var graphVisibleArea = topologyFlexBridge.getGraphVisibleArea();
					
					var rect = {
							x: graphVisibleArea.getX(),
							y: graphVisibleArea.getY(),
							width: graphVisibleArea.getWidth(),
							height: graphVisibleArea.getHeight()
					};
					return rect;
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_getGraphVisibleAreaFromFlexBridge");
				}
			}
			return null;
		},

		_fitRectangleOnFlexBridge: function(/*Object*/ rect) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// rect:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.fitRectangle(rect);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_fitRectangleOnFlexBridge");
				}
			}
		},

		//**************************************************************
		// "Protected" methods for menu layer to communicate 
		// events back to us
		//**************************************************************

		/*=====
		divLayerOnContextMenu_kwArgs: function(onComplete, evt) {
			// onComplete: function(objectContext)
			//		callback with the selection after processing in Flex app
			// evt: Object
			//		the JS mouse event
		},
		=====*/

		_divLayerOnContextMenu: function(/*divLayerOnContextMenu_kwArgs*/ kwArgs) {
			// summary:
			//		Asynchronously handles context menu event passed from menu layer
			// description:
			//		Coming soon
			// tags:
			//		protected
			
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.divLayerOnContextMenu(this._toAjaxBridgeEvent(kwArgs.evt));
				
				if (kwArgs.onComplete) {
					//Get selection from the bridge, and build up an object context. Doing this with a special
					//call back because this.selection won't be correct immediately after the call to this method (since the
					//selection changed processing is deferred to avoid recursion in the Flex bridge)
					var objectIds = this._getSelectedObjectIdsFromFlexBridge();
					
					//create selection object
					var objectContextArgs = {
							itemIds: objectIds.itemIds,
			    	    	linkIds: objectIds.linkIds,
			    	    	relationshipIds: objectIds.relationshipIds,
			    			dataset: this.dataset,
			    			pluggableView: this
						};

					var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(objectContextArgs);
					
					//Notify the callback
					setTimeout(dojo.hitch(this, kwArgs.onComplete, objectContext), 0);
				}
			}
		},

		_divLayerOnMouseDown: function(/*Object*/ evt) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// evt:
			//		Coming soon
			// tags:
			//		protected
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.divLayerOnMouseDown(this._toAjaxBridgeEvent(evt));
			}
		},
		
		_divLayerOnDoubleClick: function(/*Object*/ evt) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// evt:
			//		Coming soon
			// tags:
			//		protected
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.divLayerOnDoubleClick(this._toAjaxBridgeEvent(evt));
			}
		},
		
		_divLayerOnMouseMove: function(/*Object*/ evt) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// evt:
			//		Coming soon
			// tags:
			//		protected
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				var bridgeEvent = this._toAjaxBridgeEvent(evt);
				topologyFlexBridge.divLayerOnMouseMove(bridgeEvent);
			}
		},
		
		_divLayerOnMouseOut: function(/*Object*/ evt) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// evt:
			//		Coming soon
			// tags:
			//		protected
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.divLayerOnMouseOut(this._toAjaxBridgeEvent(evt));
			}
		},
		
		_divLayerOnMouseWheel: function(/*Object*/ evt) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// evt:
			//		Coming soon
			// tags:
			//		protected
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.divLayerOnMouseWheel(this._toAjaxBridgeEvent(evt));
			}
		},

		_processKey: function(/*Object*/ evt) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// evt:
			//		Coming soon
			// tags:
			//		protected

			var handled = false;
			switch (evt.charOrCode) {
				case 's':
				case 'S':
					if (evt.ctrlKey) {
						this._onKeyboardSave();
						handled = true;
					}
					break;
				case 'p':
				case 'P':
					if (evt.ctrlKey) {
						this._onKeyboardPrint();
						handled = true;
					}
					break;
				case '0':  /* zero */
					if (evt.ctrlKey) {
						this.fitContents();
						handled = true;
					}
					break;
				case '+':
				case '=':  /* capture both char values of this key, like browser does */
					if (evt.ctrlKey) {
						this.zoomIn();
						handled = true;
					}
					break;
				case '-':
					if (evt.ctrlKey) {
						this.zoomOut();
						handled = true;
					}
					break;
				default:
					// ignore it and let it go
			}
			if (handled) {
				dojo.stopEvent(evt);
			}
		},

		//***************************
		// "Private"
		//***************************
		_addMenuLayer: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		private
			this._menuLayer = new ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer(this, this.cmProvider, this.daHelper);
		},
		
		_setupEventCallbacks: function () {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		private
			
			this._connectionHandles.push(dojo.connect(this.domNode, "onkeypress", this, function(evt) {this._processKey(evt);}));
		},
		
		_enableFlexBIDI: function(){		
			// summary:
			//		Set a parameter so items in the Flex canvas use BIDI right-to-left directionality
			// description:
			//		Set a parameter so items in the Flex canvas use BIDI right-to-left directionality
			
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.enableBIDI();
			}
		},

		_setLocale: function(/*String*/ locale){		
			// summary:
			//		Set locale on Flex canvas
			// description:
			//		Set locale on Flex canvas
			
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.setLocale(locale);
			}
		},

		_setBaseURL: function(/*String*/ baseURL){		
			// summary:
			//		Set baseURL for SWF files
			// description:
			//		Set baseURL for SWF files
			
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.setBaseURL(baseURL);
			}
		},

		_setEmptyDatasetString: function(/*String*/ emptyDatasetString){			
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// emptyDatasetString:
			//		Coming soon
			// tags:
			//		private
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.setEmptyDatasetString(emptyDatasetString);
			}
		},

		_flexBridgeInitializationCallback: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		private
			
			//Enter the function
			if (this._trace.isFinest()) {
				this._trace.entering("callback for " + this.id, "_flexBridgeInitializationCallback");
			}
			
			//Mark us as having our Flex bridge set up and ready to use
			this._flexBridgeInitialized = true;
						
			// The Flex Ajax Bridge has initialized, so add the context menu layer DIV
			this._addMenuLayer();
			
			// Set up the Dojo events we are listening for
			this._setupEventCallbacks();
			
			//Let's register some listeners for events we care about from the Flash side
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.addEventListener("selectionChange", dojo.hitch(this, this._flexSelectionChangedCallback));
				topologyFlexBridge.addEventListener("objectDoubleClick", dojo.hitch(this, this._flexDoubleClickCallback));
				topologyFlexBridge.addEventListener("objectExpand", dojo.hitch(this, this._flexExpandCallback));
				topologyFlexBridge.addEventListener("objectCollapse", dojo.hitch(this, this._flexCollapseCallback));
				topologyFlexBridge.addEventListener("objectRollOut", dojo.hitch(this, this._flexRollOutCallback));
				topologyFlexBridge.addEventListener("objectRollOver", dojo.hitch(this, this._flexRollOverCallback));
				topologyFlexBridge.addEventListener("setDatasetComplete", dojo.hitch(this, this._flexSetDatasetComplete));
				topologyFlexBridge.addEventListener("panStart", dojo.hitch(this, this._flexPanStartCallback));
				topologyFlexBridge.addEventListener("panEnd", dojo.hitch(this, this._flexPanEndCallback));
				topologyFlexBridge.addEventListener("keyboardPrint", dojo.hitch(this, this._flexKeyboardPrintCallback));
				topologyFlexBridge.addEventListener("keyboardRefresh", dojo.hitch(this, this._flexKeyboardRefreshCallback));
				topologyFlexBridge.addEventListener("keyboardSave", dojo.hitch(this, this._flexKeyboardSaveCallback));
			}
			
			// Set locale and base SWF URL on Flex canvas
			var locale = dojo.config.locale;
			this._setBaseURL(this._dojoSWFBase);
			this._setLocale(dojo.config.locale);

			// Enable Flex canvas to use BIDI if set in body of container
			var dir = dojo.attr(dojo.body(), "dir");
      		if (dir != null && dojo.attr(dojo.body(), "dir").toLowerCase() == "rtl") {
	             	this._enableFlexBIDI();
	      	}

         // 255817  Back out this change from 255810 as it seems to cause Flash plugin reload issue from
         //         modifying DOM after Flash plugin is loaded
         // Set inner text of <object> tag for Flash plugin with the name of the view
         // as alt text for WCAG 2.0 technique H27
         // dojo.attr(this._embeddedSWFObjectId , "innerHTML", this.commonResources.TOPOLOGY_VIEW);    // 255810, 255817

			if (this.widgetDefinition && this.widgetDefinition.getBackgroundColor()) {
				this.setBackgroundColor(this.widgetDefinition.getBackgroundColor());
			}

			this.setUseNodeLevelAndPosition();

			this.setNodeOrderProperty();

			this.setNodeOrderDirection();

			// Set the translated emptyDatasetString
			this._setEmptyDatasetString(this._EMPTY_DATASET_STRING);
			
			// If we have data ready to pass across the bridge, let's go ahead and do it. Otherwise, it
			// will happen later when all of the callbacks to retrieve the Dataset data are finished.
			if (this._pendingBridgeDataset) {
				this._setDatasetOnFlexBridge(this._pendingBridgeDataset);	
				this._pendingBridgeDataset = null;
			}

			//Exit the function
			if (this._trace.isFinest()) {
				this._trace.exiting("callback for " + this.id, "_flexBridgeInitializationCallback");
			}
		},
		
		_setDatasetOnFlexBridge: function (/*Object*/ bridgeDataset) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// bridgeDataset:
			//		Coming soon
			// tags:
			//		private
			
			//Check to see if we're in a position to use Flex bridge yet
			if (!this._flexBridgeInitialized) {
				if (this._trace.isFinest()) {
					this._trace.exiting("Flex bridge not yet initialized for " + this.id + ", so deferring setting of dataset on the bridge", "_setDatasetOnFlexBridge");
				}
				this._pendingBridgeDataset = bridgeDataset;
				return;
			}
			
			if (!bridgeDataset) {
				//No data to pass to flex side
				return;
			}
			
			// Handle settings determined by current widget def
			this.setLayoutToCanvasBasedOnWidgetDef();
			
			// Handle settings determined by current dataset / subgraph
			this._setLayoutToCanvasBasedOnDataset(bridgeDataset);

			this.selection.setMode(this.widgetDefinition.getSelectionMode());

			//Send the data across the bridge
			var datasetPopulationTimer = null;
			if (this._trace.isFinest()) {
				this._trace.entering("passing dataset across Flex AJAX Bridge for" + this.id, "_setDatasetOnFlexBridge");
				
				//Stop the timer to see how long it took to be called back
				var datasetPopulationTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
				datasetPopulationTimer.start();
				
				//NOTE: Uncomment this to see JSON representation of what we're going to pass across the bridge
				//this._trace.object(bridgeDataset, "_setDatasetOnFlexBridge");
			}
			
			var topologyFlexBridge = this.getFlexBridge();
			if (topologyFlexBridge) {
				topologyFlexBridge.setDataset(bridgeDataset, false); //Pass false so doesn't automatically do fit contents for us
				this._canvasBridgeDatasetUtil.clearBridgeDataset(); //Tell the bridge dataset utility to release it's resources

				if (this._trace.isFinest()) {
					//Stop the timer to see how long it took to be called back
					if (datasetPopulationTimer) {
						this._trace.finest("passed dataset across Flex AJAX Bridge for " + this.id + ";" + datasetPopulationTimer.stopAndGetTraceString(), "_setDatasetOnFlexBridge");
					}
				}
			} else {
				if (this._trace.isError()) {
					this._trace.error("failed to set data on bridge; cannot find Flex AJAX Bridge for" + this.id, "_setDatasetOnFlexBridge");
				}
			}
			
			//NOTE: Had originally tried firing _onSetDatasetLoadComplete here, but we need to wait until we get the model update complete from the Flex side

			if (datasetPopulationTimer) {
				this._trace.exiting("exiting... canvas = " + this.id, "_setDatasetOnFlexBridge");
			}
		},
		
		_clearDatasetOnFlexBridge: function() {
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					topologyFlexBridge.setDataset(null);
				}
			}
		},
		
		_flexSetDatasetComplete: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			// tags:
			//		private
			
			//Now, we can finally send notification we're done loading the dataset. We use setTimeout to get on
			//different thread so it doesn't interfere with any work Flash might still be doing to update display.
			if (this.isSetDatasetLoadDataActive()) {
				setTimeout(dojo.hitch(this, this._onSetDatasetLoadComplete, this.dataset), 0);
			}
			
			//NOTE: Hack for now so that standalone TopologyView continues to fit contents when new dataset is set. I don't really want to 
			//hardcode any knowledge of Nav Widget in here
			var topLevelView = this.getTopLevelPluggableView();
			if (!topLevelView.isInstanceOf(ibm.tivoli.tip.navwidget.dijit.NavWidget)) {
				if (this._getObjectsAdded() == null) {
					this._fitOrZoomBasedOnWidgetDef();
				} else {
					this._zoomTo();
				}
			}
		},
		
		_fitOrZoomBasedOnWidgetDef: function() {
			var initialZoomLevel = (this.widgetDefinition ? this.widgetDefinition.getInitialZoomLevel() : -1);
			if (initialZoomLevel > 0) {
				setTimeout(dojo.hitch(this, this.setZoomLevel, this.widgetDefinition.getInitialZoomLevel(),true), 0);
			} else {
				setTimeout(dojo.hitch(this, this.fitContents), 0); //Do the fitContents on different thread
			}
		},
		
		_zoomTo: function() {
			var doZoom = (this.widgetDefinition ? this.widgetDefinition.zoomOnObjectAdded() : false);
			if (!doZoom)
				return;
			var zoomLevel = (this.widgetDefinition ? this.widgetDefinition.zoomLevelOnObjectAdded() : 1.7);
			if (this._getObjectsAdded() != null) {
				if (zoomLevel > 0) {				
					this.setZoomTo(this._getObjectsAdded().itemIds, 
							   this._getObjectsAdded().linkIds, 
							   this._getObjectsAdded().relationshipIds, 
							   zoomLevel); 
					this._setObjectsAdded(null);
				}
			}
		},

		_setObjectsAdded: function(/*Object*/ objects) {
			this._objectsAdded = objects;
		},

		_getObjectsAdded: function() {
			return this._objectsAdded;			
		},

		//***************************************************************************************
		_flexSelectionChangedCallback: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			// tags:
			//		private
			var doSomethingLater = function(objectIds){
				if (!objectIds) {
					//Case when called when FABridge.refCount > 0
					objectIds = this._getSelectedObjectIdsFromFlexBridge();
				}
				
				this.selection.setSelectedObjectIds(objectIds.itemIds, objectIds.linkIds, objectIds.relationshipIds);

				if (this._trace.isFinest()) {
			    	this._trace.finest("****** SELECTION_CHANGE for canvas = " + this.id + "; objects = " + dojo.toJson(objectIds));
				}
			};
			
			if (FABridge.refCount == 0) { //Make sure there's not someone else calling methods on the bridge (such as when we're in middle of handling an event from TopologyMenuLayer)
				var objectIds = event.getTargetObjectIds();
				doSomethingLater.call(this, objectIds);
			} else {
				/* Prone to getting this exception if try to use bridge while event being dispatched: 
				 
				 		"You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround."
				 
				 	So, let's use a set timeout and get the new selection directly from the bridge (rather than through the event)
				*/
				setTimeout(dojo.hitch(this, doSomethingLater, null), 0);
			}
		},

		//
		//
		_flexDoubleClickCallback: function(/*Object*/ event) {			
			// summary:
			//		Coming soon
			// description:
			//		This can only occur when Flash is handling events natively, so no need for stuff 
			//		in the other handlers for deferring the work.
			// event:
			//		Coming soon
			// tags:
			//		private	
			var doSomethingLater = function(objectIds){
				if (!objectIds) {
					//Case when called when FABridge.refCount > 0
					var event = this._getLastDoubleClickEventOnFlexBridge();
					if (event) {
						objectIds = event.getTargetObjectIds();
					}
				}
				
				var kwArgs = {
						itemIds: objectIds.itemIds,
		    	    	linkIds: objectIds.linkIds,
		    	    	relationshipIds: objectIds.relationshipIds,
		    			dataset: this.dataset,
		    			pluggableView: this
					};

				var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);
				
				//Fire the event
				this.onObjectDoubleClick(objectContext);
			};
			
			if (FABridge.refCount == 0) { //Make sure there's not someone else calling methods on the bridge (such as when we're in middle of handling an event from TopologyMenuLayer)
				var objectIds = event.getTargetObjectIds();
				doSomethingLater.call(this, objectIds);
			} else {
				/* Prone to getting this exception if try to use bridge while event being dispatched: 
				 
				 		"You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround."
				 
				 	So, let's use a set timeout and get the new selection directly from the bridge (rather than through the event)
				*/
				setTimeout(dojo.hitch(this, doSomethingLater, null), 0);
			}
		},

		_flexExpandCallback: function(event) {
			// summary:
			//		This will handle both subgraph expand and single item expand event from Flex bridge.
			// description:
			//		This will handle both subgraph expand and single item expand event from Flex bridge.
			// event:
			//		Event information on the subgraph or item expanded, comes from Flex bridge.
			// tags:
			//		private
			var doSomethingLater = function(objectIds){
				if (!objectIds) {
					objectIds = this._getSelectedObjectIdsFromFlexBridge();	
				}
				
				var kwArgs = {
						itemIds: objectIds.itemIds,
    	    					linkIds: objectIds.linkIds,
    	    					relationshipIds: objectIds.relationshipIds,
	    					dataset: this.dataset,
	    					pluggableView: this
					};

				var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);

				//Fire the event
				this.onObjectExpand(objectContext);
			};
			
			if (FABridge.refCount == 0) { //Make sure there's not someone else calling methods on the bridge (such as when we're in middle of handling an event from TopologyMenuLayer)
				var objectIds = event.getTargetObjectIds();
				doSomethingLater.call(this, objectIds);
			} else {
				/* Prone to getting this exception if try to use bridge while event being dispatched: 
				 
				 		"You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround."
				 
				 	So, let's use a set timeout and get the new selection directly from the bridge (rather than through the event)
				*/
				setTimeout(dojo.hitch(this, doSomethingLater, null), 0);
			}
		},

		// This will handle both subgraph expand and single item expand
		_flexCollapseCallback: function(event) {
			// summary:
			//		This will handle collapse of single item collapse event from Flex bridge.
			// description:
			//		This will handle collapse of single item collapse event from Flex bridge.
			// event:
			//		Event information on the item collapsed, comes from Flex bridge.
			// tags:
			//		private
			var doSomethingLater = function(objectIds){
				if (!objectIds) {
					objectIds = this._getSelectedObjectIdsFromFlexBridge();	
				}
				
				var kwArgs = {
						itemIds: objectIds.itemIds,
		    	    			linkIds: objectIds.linkIds,
		    	    			relationshipIds: objectIds.relationshipIds,
		    				dataset: this.dataset,
		    				pluggableView: this
					};

				var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);
				
				//Fire the event
				this.onObjectCollapse(objectContext);
			};
			
			if (FABridge.refCount == 0) { //Make sure there's not someone else calling methods on the bridge (such as when we're in middle of handling an event from TopologyMenuLayer)
				var objectIds = event.getTargetObjectIds();
				doSomethingLater.call(this, objectIds);
			} else {
				/* Prone to getting this exception if try to use bridge while event being dispatched: 
				 
				 		"You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround."
				 
				 	So, let's use a set timeout and get the new selection directly from the bridge (rather than through the event)
				*/
				setTimeout(dojo.hitch(this, doSomethingLater, null), 0);
			}
		},

		_flexRollOverCallback: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			// tags:
			//		private
			var doSomethingLater = function(objectIds, boundingInfo){
				if (!objectIds) {
					//Case when called when FABridge.refCount > 0

					var event = this._getLastRollOverEventOnFlexBridge();
					if (event) {
						objectIds = event.getTargetObjectIds();
						boundingInfo = {
							mouseX: event.getMouseX(),
							mouseY: event.getMouseY(),
							objectX: event.getObjectX(), 
							objectY: event.getObjectY(), 
							objectWidth: event.getObjectWidth(),
							objectHeight: event.getObjectHeight()
						};  
					}
				}
				
				var kwArgs = {
						itemIds: objectIds.itemIds,
		    	    	linkIds: objectIds.linkIds,
		    	    	relationshipIds: objectIds.relationshipIds,
		    			dataset: this.dataset,
		    			pluggableView: this
					};

				var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);
				
				//Let's fire the event
				this.onObjectRollOver(objectContext, boundingInfo);
			};
			
			if (FABridge.refCount == 0) { //Make sure there's not someone else calling methods on the bridge (such as when we're in middle of handling an event from TopologyMenuLayer)
				var objectIds = event.getTargetObjectIds();
				var boundingInfo = {
						mouseX: event.getMouseX(),
						mouseY: event.getMouseY(),
						objectX: event.getObjectX(), 
						objectY: event.getObjectY(), 
						objectWidth: event.getObjectWidth(),
						objectHeight: event.getObjectHeight()
					}; 
				
				doSomethingLater.call(this, objectIds, boundingInfo);
			} else {
				/* Prone to getting this exception if try to use bridge while event being dispatched: 
				 
				 		"You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround."
				 
				 	So, let's use a set timeout and get the new selection directly from the bridge (rather than through the event)
				*/
				setTimeout(dojo.hitch(this, doSomethingLater, null), 0);
			}
		},
		
		_flexRollOutCallback: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			// tags:
			//		private
			var doSomethingLater = function(objectIds){
				if (!objectIds) {
					//Case when called when FABridge.refCount > 0
					var event = this._getLastRollOutEventOnFlexBridge();
					if (event) {
						objectIds = event.getTargetObjectIds();
					}
				}
				
				var kwArgs = {
						itemIds: objectIds.itemIds,
		    	    	linkIds: objectIds.linkIds,
		    	    	relationshipIds: objectIds.relationshipIds,
		    			dataset: this.dataset,
		    			pluggableView: this
					};

				var objectContext = new ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewObjectContext(kwArgs);
				
				//Let's fire the event
				this.onObjectRollOut(objectContext);
			};
			
			if (FABridge.refCount == 0) { //Make sure there's not someone else calling methods on the bridge (such as when we're in middle of handling an event from TopologyMenuLayer)
				var objectIds = event.getTargetObjectIds();
				doSomethingLater.call(this, objectIds);
			} else {
				/* Prone to getting this exception if try to use bridge while event being dispatched: 
				 
				 		"You are trying to call recursively into the Flash Player which is not allowed. In most cases the JavaScript setTimeout function, can be used as a workaround."
				 
				 	So, let's use a set timeout and get the new selection directly from the bridge (rather than through the event)
				*/
				setTimeout(dojo.hitch(this, doSomethingLater, null), 0);
			}
		},
		
		_flexPanStartCallback: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		private
			
			//Fire the event
			this._onPanStart();
		},
		
		_flexPanEndCallback: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Fire the event
			this._onPanEnd();
		},
		
		_flexKeyboardPrintCallback: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Fire the event
			this._onKeyboardPrint();
		},
		
		_flexKeyboardRefreshCallback: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Fire the event
			this._onKeyboardRefresh();
		},
		
		_flexKeyboardSaveCallback: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Fire the event
			this._onKeyboardSave();
		},

		_onPanStart: function() {
			// summary:
			//		Event fired when the user initiates a pan on the canvas. It is recommended to 
			//		use dojo.connect rather than overriding this method.
			// tags:
			//		protected callback

		},
		
		_onPanEnd: function() {
			// summary:
			//		Event fired when the user ends a pan on the canvas. It is recommended to use 
			//		dojo.connect rather than overriding this method.
			// description:
			//		On the Flex side, there is not actually a PAN_END event to listen for. So, we 
			//		try to figure out when pan starts and pan ends by using info about whether the 
			//		viewport is changing while the mouse is moving with the button pressed. As a side 
			//		effect of this approach, we can't actually fire the pan end until the user MOVES 
			//		the mouse with the button up.
			// tags:
			//		protected callback
			
		},
		
		_onKeyboardPrint: function() {		
			// summary:
			//		Event fired when user hits Ctrl-p while Flash plug-in has keyboard focus. It is recommended to use 
			//		dojo.connect rather than overriding this method.
			// description:
			//		Event fired when user hits Ctrl-p while Flash plug-in has keyboard focus. It is recommended to use 
			//		dojo.connect rather than overriding this method.
			// tags:
			//		protected callback
		},
		
		_onKeyboardRefresh: function() {		
			// summary:
			//		Event fired when user hits Ctrl-r while Flash plug-in has keyboard focus. It is recommended to use 
			//		dojo.connect rather than overriding this method.
			// description:
			//		Event fired when user hits Ctrl-r while Flash plug-in has keyboard focus. It is recommended to use 
			//		dojo.connect rather than overriding this method.
			// tags:
			//		protected callback
		},
		
		_onKeyboardSave: function() {		
			// summary:
			//		Event fired when user hits Ctrl-s while Flash plug-in has keyboard focus. It is recommended to use 
			//		dojo.connect rather than overriding this method.
			// description:
			//		Event fired when user hits Ctrl-s while Flash plug-in has keyboard focus. It is recommended to use 
			//		dojo.connect rather than overriding this method.
			// tags:
			//		protected callback
		},
		
		//***************************************************************************************
		// Handle all the dataset events
		//***************************************************************************************
		//View instances normally wouldn't override this, but there can be pretty good delay between when our setDataset is called and when we've
		//finally loaded in the whole dataset, put in that data in a form suitable to pass across Flex bridge, actually pass the data across bridge, etc. So,
		//let's intercept and enqueue any events we're not ready for.
		_datasetEventListenerCallback: function (/*Object*/ listenerObj, /*Object*/ event, /*Object*/isPendingEvent) {			
			if (this.isSetDatasetActive()) {
				//Let's queue this event up until we're ready for it
				if (this._trace.isFinest()) {
					this._trace.finest("Dataset not yet set on flex bridge, enqueueing event of type " + event.getType() + " for canvas = " + this.id, "_datasetEventListenerCallback");
				}
				
				this._pendingEventQueue.enqueue(event);
			} else {
				if (isPendingEvent || !this._pendingEventQueue.peek()) { //2nd test to see if we're actively processing enqueue events
					this.inherited(arguments);
				} else {
					if (this._trace.isFinest()) {
						this._trace.finest("Actively processing pending events, enqueueing event of type " + event.getType() + " for canvas = " + this.id, "_datasetEventListenerCallback");
					}
					this._pendingEventQueue.enqueue(event);
				}
			}
		},
		
		_handleChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					var dataset = event.getDataset();
					this._populateChangedDataset(dataset);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleChangedEvent");
				}
			}
			
			this.inherited(arguments);
		},
		
		_handleLabelChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					var newLabel = event.getNewLabel();
					
					//Notify bridge
					topologyFlexBridge.handleLabelChangedEvent(newLabel);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleLabelChangedEvent");
				}
			}
			
			this.inherited(arguments);
		},
		
		_handleStatusChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			//NOTE: For now, we will leave this unimplemented since the Flex Canvas doesn't render status on child datasets anyways.
			
			this.inherited(arguments);
		},
		
		_handleItemsAddedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					
					//Get item info
					var items = event.getItems();
					var bridgeItems = new Array(items.length);
					var bridgeItemIds = new Array(items.length);
					for (var i = 0; i < items.length; i++) {
						bridgeItems[i] = this._canvasBridgeDatasetUtil._toAjaxBridgeItem(items[i]);
						bridgeItemIds[i] = bridgeItems[i].id;
					}

					if (this._getObjectsAdded() != null) {
						this._setObjectsAdded({itemIds: bridgeItemIds,
						                       linkIds: this._getObjectsAdded().linkIds,
						                       relationshipIds: this._getObjectsAdded().relationshipIds});						
					} else {
						this._setObjectsAdded({itemIds: bridgeItemIds,
						                       linkIds: null,
								       relationshipIds: null});
					}
					
					//Let the bridge know
					topologyFlexBridge.handleItemsAddedEvent(bridgeItems);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleItemsAddedEvent");
				}
			}
			
			this.inherited(arguments);
		},

		_handleItemsRemovedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					
					//Get item info
					var items = event.getItems();
					var bridgeItemIds = new Array(items.length);
					for (var i = 0; i < items.length; i++) {
						bridgeItemIds[i] = items[i].getId();
					}
					
					//Let the bridge know
					topologyFlexBridge.handleItemsRemovedEvent(bridgeItemIds);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleItemsRemovedEvent");
				}
			}
			this.inherited(arguments);
		},
		
		_handleItemStatusChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					
					var items = event.getItems();
					if (items) {
						//We will be filling two arrays
						var bridgeItemIds = new Array(items.length);
						var bridgeItemStatuses = new Array(items.length);
						
						//Loop through info in event to fill in the array
						for (var i = 0; i < items.length; i++) {
							var item = items[i];
							if (item) {
								//convert item to bridge item
								bridgeItemIds[i] = item.getId();
								
								//convert statuses for this particular item to bridge statuses
								var statusesArgs = {
										widgetDef: this.widgetDefinition
									};
								var itemStatuses = item.getStatuses(statusesArgs);
								if (itemStatuses) {
									var bridgeStatuses = new Array(itemStatuses.length);
									for (var j = 0; j < itemStatuses.length; j++) {
										var status = itemStatuses[j];
										bridgeStatuses[j] = this._canvasBridgeDatasetUtil._toAjaxBridgeStatus(status);
									}
									
									//Add the statuses array for this item to the top-level statuses array
									bridgeItemStatuses[i] = bridgeStatuses;
								}
							} else {
								if (this._trace.isError()) {
									this._trace.error("Invalid item in the event's items array; item = " + item, "_handleItemStatusChangedEvent");
								}
							}
						}
						
						//Notify Flex side
						if (bridgeItemStatuses.length > 0 && bridgeItemStatuses[0].length > 0) {
							topologyFlexBridge.handleItemStatusChangedEvent(bridgeItemIds, bridgeItemStatuses);
						} else {
							if (this._trace.isWarn()) {
								this._trace.warn("Item status likely changed to value not in original list of item statuses. The client nav model has likely logged errors looking up status", "_handleItemStatusChangedEvent");
							}
						}
					}
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleItemStatusChangedEvent");
				}
			}
			
			this.inherited(arguments);
		},
		
		_handleItemPropertiesChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					
					var items = event.getItems();
					var properties = event.getProperties(); //Array of arrays
					if (items && properties) {
						//We will be filling two arrays
						var bridgeItemIds = [];
						var bridgeItemLabels = [];
						
						//Loop through info in event to fill in the array
						for (var i = 0; i < items.length; i++) {
							var item = items[i];
							if (item) {
								//get the item properties and look for the label (since on the Flex side we really only care about label changes)
								var itemProperties = properties[i];
								if (itemProperties) {
									for (var j = 0; j < itemProperties.length; j++) {
										var property = itemProperties[j];
										if (property.getValueType() == "itemName") { //Only care about label (or item names)
											//We've found an item with a label change, so let's store to pass across bridge
											bridgeItemIds.push(item.getId());
											bridgeItemLabels.push(property.getDisplayValue());
											
											//No need to keep iterating through properties
											break; 
										}
									}
								}
							} else {
								if (this._trace.isError()) {
									this._trace.error("Invalid item in the event's items array; item = " + item, "_handleItemPropertiesChangedEvent");
								}
							}
						}
						
						//Notify Flex side
						if (bridgeItemIds.length > 0) {
							topologyFlexBridge.handleItemLabelChangedEvent(bridgeItemIds, bridgeItemLabels);
						}
					}
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleItemPropertiesChangedEvent");
				}
			}
			this.inherited(arguments);
		},
		
		_handleLinksAddedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					
					//Get item info
					var links = event.getLinks();
					var bridgeLinks = new Array(links.length);
					var bridgeLinkIds = new Array(links.length);
					for (var i = 0; i < links.length; i++) {
						bridgeLinks[i] = this._canvasBridgeDatasetUtil._toAjaxBridgeLink(links[i]);
						bridgeLinkIds[i] = bridgeLinks[i].id;
					}
					
					if (this._getObjectsAdded() != null) {
						this._setObjectsAdded({itemIds: this._getObjectsAdded().itemIds,
									     linkIds: bridgeLinkIds,
									     relationshipIds: this._getObjectsAdded().relationshipIds});
					} else {
						this._setObjectsAdded({itemIds: null,
									     linkIds: bridgeLinkIds,
									     relationshipIds: null});
					}

					//Let the bridge know
					topologyFlexBridge.handleLinksAddedEvent(bridgeLinks);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleLinksAddedEvent");
				}
			}
			
			this.inherited(arguments);
		},
		
		_handleLinksRemovedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					
					//Get item info
					var links = event.getLinks();
					var bridgeLinkIds = new Array(links.length);
					for (var i = 0; i < links.length; i++) {
						bridgeLinkIds[i] = links[i].getId();
					}
					
					//Let the bridge know
					topologyFlexBridge.handleLinksRemovedEvent(bridgeLinkIds);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleLinksRemovedEvent");
				}
			}
			this.inherited(arguments);
		},
		
		_handleLinkStatusChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					
					var links = event.getLinks();
					if (links) {
						//We will be filling two arrays
						var bridgeLinkIds = new Array(links.length);
						var bridgeLinkStatuses = new Array(links.length);
						
						//Loop through info in event to fill in the array
						for (var i = 0; i < links.length; i++) {
							var link = links[i];
							if (link) {
								//get link id
								bridgeLinkIds[i] = link.getId();
								
								//convert statuses for this particular link to bridge statuses
								var statusesArgs = {
										widgetDef: this.widgetDefinition
									};
								var linkStatuses = link.getStatuses(statusesArgs);
								if (linkStatuses) {
									var bridgeStatuses = new Array(linkStatuses.length);
									for (var j = 0; j < linkStatuses.length; j++) {
										var status = linkStatuses[j];
										bridgeStatuses[j] = this._canvasBridgeDatasetUtil._toAjaxBridgeStatus(status);
									}
									
									//Add the statuses array for this link to the top-level statuses array
									bridgeLinkStatuses[i] = bridgeStatuses;
								}
							} else {
								if (this._trace.isError()) {
									this._trace.error("Invalid link in the event's links array; link = " + link, "_handleLinkStatusChangedEvent");
								}
							}
						}
						
						if (bridgeLinkStatuses.length > 0 && bridgeLinkStatuses[0].length > 0) {
							//Notify Flex side
							topologyFlexBridge.handleLinkStatusChangedEvent(bridgeLinkIds, bridgeLinkStatuses);
						} else {
							if (this._trace.isWarn()) {
								this._trace.warn("Link status likely changed to value not in original list of link statuses. The client nav model has likely logged errors looking up status", "_handleLinkStatusChangedEvent");
							}
						}
					}
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleLinkStatusChangedEvent");
				}
			}
			
			this.inherited(arguments);
		},
		
		_handleLinkPropertiesChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			//NOTE: We don't do any special rendering on Flex side based on link properties. So, not really any need to
			//pass event info across the bridge.
			
			this.inherited(arguments);
		},
		
		_handleLinkChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					
					//Get link info
					var bridgeLinkId = event.getLinkChanged().getId();
					
					//Get reason
					var bridgeReason = event.getLinkChangedReason();
					
					//Get relationshipIds
					var relationships = event.getLinkChangedRelationships();
					var bridgeRelationships = new Array(relationships.length);
					for (var i = 0; i < relationships.length; i++) {
						bridgeRelationships[i] = this._canvasBridgeDatasetUtil._toAjaxBridgeRelationship(relationships[i]);
					}
					
					//Let the bridge know
					topologyFlexBridge.handleLinkChangedEvent(bridgeLinkId, bridgeReason, bridgeRelationships);
				}
			} else {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleLinkChangedEvent");
				}
			}

			this.inherited(arguments);
		},
		
		_handleRelationshipStatusChangedEvent: function(/*Object*/ event) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			//There's no real reason to pass across relationship data if not rendering the relationships. So, let's make the optimization.
			if (this.widgetDefinition && !this.widgetDefinition.getRenderRelationshipsInsteadOfLinks()) {
				return;
			}
			
			if (this.isFlexBridgeInitialized()) {
				var topologyFlexBridge = this.getFlexBridge();
				if (topologyFlexBridge) {
					//Get dataset info
					var dataset = event.getDataset();
					var bridgeDatasetId = dataset.getId();
					
					var relationships = event.getRelationships();
					if (relationships) {
						//We will be filling two arrays
						var bridgeRelationshipIds = new Array(relationships.length);
						var bridgeRelationshipStatuses = new Array(relationships.length);
						
						//Loop through info in event to fill in the array
						for (var i = 0; i < relationships.length; i++) {
							var relationship = relationships[i];
							if (relationship) {
								//get link id
								bridgeRelationshipIds[i] = relationship.getId();
								
								//convert statuses for this particular link to bridge statuses
								var statusesArgs = {
										widgetDef: this.widgetDefinition
									};
								var relationshipStatuses = relationship.getStatuses(statusesArgs);
								if (relationshipStatuses) {
									var bridgeStatuses = new Array(relationshipStatuses.length);
									for (var j = 0; j < relationshipStatuses.length; j++) {
										var status = relationshipStatuses[j];
										bridgeStatuses[j] = this._canvasBridgeDatasetUtil._toAjaxBridgeStatus(status);
									}
									
									//Add the statuses array for this link to the top-level statuses array
									bridgeRelationshipStatuses[i] = bridgeStatuses;
								}
							} else {
								if (this._trace.isError()) {
									this._trace.error("Invalid relationship in the event's relationships array; relationship = " + relationship, "_handleRelationshipStatusChangedEvent");
								}
							}
						}
						
						if (bridgeRelationshipStatuses.length > 0 && bridgeRelationshipStatuses[0].length > 0) {
							//Notify Flex side
							topologyFlexBridge.handleRelationshipStatusChangedEvent(bridgeRelationshipIds, bridgeRelationshipStatuses);
						} else {
							if (this._trace.isWarn()) {
								this._trace.warn("Relationship status likely changed to value not in original list of relationship statuses. The client nav model has likely logged errors looking up status", "_handleRelationshipStatusChangedEvent");
							}
						}
					}
				} else {
					if (this._trace.isFinest()) {
						this._trace.finest("Flex bridge not yet initialized; potentially part of TopoView in stack layout not yet made visible; id = " + this.id, "_handleRelationshipStatusChangedEvent");
					}
				}
			}
			
			//Call superclass
			this.inherited(arguments);
		},
		
		_handleRelationshipPropertiesChangedEvent: function(/*Object*/ event) {				
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			
			//NOTE: The props on the relationship don't impact how Flex Canvas renders the
			//relationship, so let's not bother passing anything across.
			
			//Call superclass
			this.inherited(arguments);	
		},
		
		_handleExceptionEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "exception" event type.
			// event:
			//		An object containing information the "exception" event
			// description:
			//		Subclass should override to if it wishes to deal with "exception" events.
			// tags:
			//		protected

			//Call superclass
			this.inherited(arguments);
		},
		
		_handleEventRouterEvent: function(/*Object*/ event) {
			// summary:
			//		Handle "eventRouter" event type.
			// event:
			//		An object containing information the "eventRouter" event
			// description:
			//		Subclass should override to if it wishes to deal with "eventRouter" events.
			// tags:
			//		protected

			//Call superclass
			this.inherited(arguments);
		},
		
		//***********************************************************************************
		
		_toAjaxBridgeEvent: function(/*Object*/ evt) {		
			// summary:
			//		Coming soon
			// description:
			//		The list below shows the different MouseEvent properties in ActionScript that are 
			//		settable (other read-only properties exist that are not included). We want to try 
			//		and create a data structure to pass across the bridge so that an appropriate 
			//		ActionScript MouseEvent can be created on the other side.
		    //		    
			//		|	altKey : Boolean
			//		|		Indicates whether the Alt key is active (true) or inactive (false). MouseEvent 
			//    	|	buttonDown : Boolean
			//		|		Indicates whether the primary mouse button is pressed (true) or not (false). MouseEvent 
			//     	|	commandKey : Boolean
			//		|		Indicates whether the command key is activated (Mac only.) The value of property
			//		|		commandKey will have the same value as property ctrlKey on the Mac. MouseEvent  
			//     	|	controlKey : Boolean
			//		|		Indicates whether the Control key is activated on Mac and whether the Ctrl key is 
			//		|		activated on Windows or Linux. MouseEvent 
			//    	|	ctrlKey : Boolean
			//		|		On Windows or Linux, indicates whether the Ctrl key is active (true) or inactive 
			//		|		(false). MouseEvent 
			//    	|	delta : int
			//		|		Indicates how many lines should be scrolled for each unit the user rotates the 
			//		|		mouse wheel. MouseEvent 
			//    	|	localX : Number
			//		|		The horizontal coordinate at which the event occurred relative to the containing
			//		|		sprite. MouseEvent 
			//    	|	localY : Number
			//		|		The vertical coordinate at which the event occurred relative to the containing 
			//		|		sprite. MouseEvent 
			//    	|	shiftKey : Boolean
			//		|		Indicates whether the Shift key is active (true) or inactive (false). MouseEvent 
			// evt:
			//		Coming soon
			var ajaxBridgeEvent = {};
			ajaxBridgeEvent["altKey"] = evt.altKey;
			ajaxBridgeEvent.buttonDown = dojo.mouseButtons.isLeft(evt); 
			ajaxBridgeEvent.commandKey = false; //NOTE: Not sure this is really right for a Mac, but we don't support Safari anyway
			ajaxBridgeEvent.controlKey = evt.ctrlKey; //NOTE: Not sure this is really right for a Mac, but we don't support Safari anyway
			ajaxBridgeEvent.ctrlKey = evt.ctrlKey; 
			ajaxBridgeEvent.delta = evt.detail;
			ajaxBridgeEvent.localX = evt.layerX; 
			ajaxBridgeEvent.localY = evt.layerY; 
			ajaxBridgeEvent.shiftKey = evt.shiftKey;

			return ajaxBridgeEvent;
		}
	});
