/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper");

dojo.require("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog");
dojo.require("ibm.tivoli.navmodel.NavWidgetDef");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.requireLocalization("ibm.tivoli.tip.navwidget", "resources");


dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper",
	      null,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon

	// defaultActionCallback: function
	//		callback method for the default action
	defaultActionCallback: null,
	
	constructor: function( /*Object*/ args ){
		// summary:
		//		The base class for all providers that populate the TIPContextMenu
		// args:
		//		Coming soon
		
	      dojo.mixin( this, args );
	},

	executeDefaultAction: function(/*Object*/ objectContext, /*Property*/ property){
		// summary:
		//		Method which checks context for default server task and executes if needed
		//		else executes the callback method
		// description:
		//		Coming soon
		// objectContext:
		//		Coming soon
		var object = null;
		
		if(property){
			
			object = property;
			
		}else{
			//First check to ensure a server side task is not defined.
			//if so execute it
			var selectedObjects = objectContext.selection;
			if(( selectedObjects.getRelationshipCount() + selectedObjects.getLinkCount() + selectedObjects.getItemCount() ) != 1){
				//if there is more than one item then just return and do nothing for now

				//TODO: ADM - add case for additional objects.  It may be possible some
				//default action is needed on multiple items/links/relationships
				//not sure what the use case is at this moment tho
				return;
			}


			if(selectedObjects.getItemCount() == 1){
				object = selectedObjects.getItems()[0];            
			}else if(selectedObjects.getRelationshipCount() == 1){
				object = selectedObjects.getRelationships()[0];
			}else if(selectedObjects.getLinkCount() == 1){
				object = selectedObjects.getLinks()[0];
			}else{
				console.log("Cannot handle non link, rel, or item objects. No action preformed.");
			}
			
			
			if(!object.supportsProperties()){
				//if the object doesnt support properties, we shouldnt render the prop notebook
				console.log("object doesnt support properties, preforming no action");
				return;
			}

		}
        

		
        // if a default task is defined for the item or property, execute it
		// 251346
		var defaultTask = property ? object.getTask() : object.getDefaultTask();
		if (defaultTask) {
			var menuProvider = this._getCMProvider(objectContext);
			if (menuProvider) {
				// 251771
				// portlet namespace might not be initialized yet for the menu provider
				// if no context menu has yet been displayed, so check
				if (!menuProvider.iscPortletNamespace && objectContext.domNode) {
					menuProvider.setPortletNamespace(objectContext.domNode);
				}
				// Menu provider's method to map tasks to JSON expects an array
				// var tasks = [defaultTask];
				var jsonMenuItem = (menuProvider.tasksAsMenuJson([defaultTask]))[0];
				jsonMenuItem.selection = objectContext.selection;
				menuProvider.handleMenuAction(jsonMenuItem, {task: defaultTask});
				return;
			}			
		}
	
		//If the default action callback is set, then execute it
		if(this.defaultActionCallback){
			return this.defaultActionCallback(objectContext, property);
		}
		
	},
	
	_getCMProvider: function(objectContext){
		var cmProvider = null;
		var topView = objectContext.getTopLevelPluggableView();
		
		if(objectContext){
			if(objectContext.cmProvider){
				cmProvider = objectContext.cmProvider;
			
			}else if(topView && topView.cmProvider){
			
				cmProvider = topView.cmProvider;
	
			}else if(topView && topView.managingPluggableView && topView.managingPluggableView.cmProvider){
			
				cmProvider = topView.managingPluggableView.cmProvider;
			}
			else{
				console.log("unable to find an appropriate cmProvider");
			}
		}
		return cmProvider;
	
	}

});