if(!dojo._hasResource["ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas"] = true;
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * "Restricted Materials of IBM"
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas");

dojo.require("dijit.layout.ContentPane");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("ibm.tivoli.navmodel.DatasetItemsStore");
dojo.require("ibm.tivoli.navmodel.DatasetLinksStore");
dojo.require("ibm.tivoli.tip.navwidget.dojo.Timer");
//AWE TODO: Temporarily using dojo["require"] to get around custom build issues until we officially move to Dojo Diagrammer
dojo["require"]("ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas");
dojo["require"]("ibm_diagram.widget.Diagram");
dojo["require"]("ibm_diagram.graphlayout.ServerSideLayout");
dojo["require"]("ibm_diagram.templating");
dojo["require"]('ibm_graphlayout.shortlink.ShortLinkLayout');
dojo["require"]('ibm_diagram.gfxlayout.GridLayout');

dojo.require("dojo.data.ItemFileReadStore");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas",
	[dijit.layout.ContentPane, ibm.tivoli.tip.navwidget.topology.dijit.BaseCanvas],
	 {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		_ilogDiagrammer: null,
	
        // _DEFAULT_WIDGET_DEF_INFO: [const] String[]
		//		Coming soon
		_DEFAULT_WIDGET_DEF_INFO: {
			className: "ibm.tivoli.navmodel.TopoWidgetDef",
			baseUrl: "/ibm/tivoli/rest",
	    	provider: "any",
	    	datasource: "any",
	    	widget: "topology",
	    	definition: "DefaultTopology"
		},
      
        constructor: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//AWE TODO
			ibm_diagram.templating.declareBindableProperty(ibm_diagram.Node, "status", "Unknown");
			ibm_diagram.templating.declareBindableProperty(ibm_diagram.Node, "statusColor", "#FF0000");
			ibm_diagram.templating.declareBindableProperty(ibm_diagram.Node, "statusImage", "./zoom_in.gif");
			ibm_diagram.templating.declareBindableProperty(ibm_diagram.Node, "largeImage", "./zoom_in.gif");
			ibm_diagram.templating.declareBindableProperty(ibm_diagram.Link, "arrowColor", "#FF0000");
			
			//AWE TODO: dojo.experimental doesn't seem to write out anything, so doing it manually
			//dojo.experimental("ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas", "Prototyping use of ILOG Dojo Diagrammer"); 
			var message = "EXPERIMENTAL: ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas -- APIs subject to change without notice. Prototyping use of ILOG Dojo Diagrammer";
			console.warn(message);
        },
		
		_getDefaultWidgetDefInfo: function(){
			return this._DEFAULT_WIDGET_DEF_INFO;
		},
		
        _onLoadedTimer: null, //AWE TODO
        _makeNavWidgetTimer: null,
		_setDatasetLoadData: function(dataset){		
    		// summary:
    		//		Coming soon
    		// description:
    		//		Coming soon
        	// dataset:
        	//		
			
        	this._makeNavWidgetTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
        	this._makeNavWidgetTimer.start();
			
        	if (!this._ilogDiagrammer) {                
                /* AWE TODO
                 * <div dojoType="ibm_diagram.widget.Diagram" id="graph" style="width: 900px; height: 400px;"
                automaticNodeLayout= "true" automaticLinkLayout= "true" 
                startNodeBinding="identity1" endNodeBinding="identity2"
                createLinksForHierarchy= "false">
                <!-- 
                 onNodeCreated="onNodeCreated" onLinkCreated="onLinkCreated"
                nodeTemplateFunction="getNodeTemplate" linkTemplateFunction="getLinkTemplate"
                 -->
             </div>
                 */
                var widgetProperties = {
                    nodesQuery: {},
                    linksQuery: {},
                    createLinksForHierarchy: true,
                    automaticNodeLayout: true,
                    automaticLinkLayout: true,
                    startNodeBinding: "identity1",
                    endNodeBinding: "identity2",
                    onNodeCreated: dojo.hitch(this, this._onNodeCreated),
                    onLinkCreated: dojo.hitch(this, this._onLinkCreated),
                    nodeTemplateFunction: dojo.hitch(this, this._getNodeTemplate),
                    linkTemplateFunction: dojo.hitch(this, this._getLinkTemplate)
                };
                
    			this._ilogDiagrammer = new ibm_diagram.widget.Diagram(widgetProperties);
    			
   			 	this.attr("content", this._ilogDiagrammer);
        	}
        	
        	//Populate the diagrammer based on the dataset
        	var useFileReadStore = false;
            var itemStore = null;
            var linkStore = null;
            if (useFileReadStore) {
            	var nodeCount = 200;
            	var linkPerNodeCount = 4;
            	var nodeData = this._buildSampleNodesJson(nodeCount);
            	var linkData = this._buildSampleLinksJson(nodeCount, linkPerNodeCount);
            	itemStore = new dojo.data.ItemFileReadStore({
                    //url: "./nodesLarge.json"
            		data: nodeData
                });
                linkStore = new dojo.data.ItemFileReadStore({
                    //url: "./linksLarge.json"
                	data: linkData
                });
            } else {
            	itemStore = new ibm.tivoli.navmodel.DatasetItemsStore({
                    dataset: dataset 
            	});
                linkStore = new ibm.tivoli.navmodel.DatasetLinksStore({
                	dataset: dataset
                });
            }

            var onLoadedCallback = function() {
            	if (this._onLoadedTimer) {
					console.debug("ON LOADED!!!!!! time:; " + this._onLoadedTimer.stopAndGetTraceString());
				}
            };
        	dojo.connect(this._ilogDiagrammer, "onLoaded", dojo.hitch(this, onLoadedCallback));

            this._ilogDiagrammer.set("nodesStore", itemStore);
            this._ilogDiagrammer.set("nodesQuery", {});
            this._ilogDiagrammer.set("linksStore", linkStore);
            this._ilogDiagrammer.set("linksQuery", {});
            this._doTree();
            this._ilogDiagrammer.reset();
            
            this._onLoadedTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
            this._onLoadedTimer.start();
            this._ilogDiagrammer.load();
			 
        	//Call superclass
        	this.inherited(arguments);
        },
        
        //***************************
        //***************************
		// "Public" -- functions from BaseCanvas
		//***************************
        //***************************
		print: function(/*int*/ pageCount, /*Object*/ pageMargin, /*Object*/ printAsBitmap){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// pageCount:
			//		Coming soon
			// pageMargin:
			//		Coming soon
			// printAsBitmap:
			//		Coming soon
			
        	this.inherited(arguments);
		},

		zoomIn: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
        	 var viewport = this._ilogDiagrammer.getViewport();
        	 viewport.setZoom(viewport.getZoom() * 2);
		},
		
		zoomOut: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			var viewport = this._ilogDiagrammer.getViewport();
			viewport.setZoom(viewport.getZoom() / 2);
		},		

		setZoomLevel: function(/*float*/ zoomLevel){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			this._ilogDiagrammer.setZoom(zoomLevel);
		},

		setMouseMode: function(/*Object*/ mouseMode){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// mouseMode: 
			//		Coming soon
			
			this.inherited(arguments);
		},
		
		fitContents: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			try {
        		var transform = this._ilogDiagrammer.getGraph().getFitToContentsTransform();
        		this._ilogDiagrammer.getGraph().setTransform(transform);
        	} catch (ex) {
        		//There was a problem - ignore that
            }
		},
		
		exportAsImage: function(/*Object*/dialogTitle, /*Object*/questionText, /*Object*/pngOptionLabel, /*Object*/jpgOptionLabel, /*Object*/exportButtonLabel, /*Object*/cancelButtonLabel, /*Object*/baseDefaultFileName){	
			// summary:
			//		Causes diagram contents to be exported as an image. 
			// description:
			//		Causes diagram contents to be exported as an image. 
			// tags:
			//		public
			
			this.inherited(arguments);
		},

		setBackgroundColor: function(/*Object*/ backgroundColor) {
			this.inherited(arguments);
		},

		getAvailableLayoutAlgorithms: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			return this.inherited(arguments);;
		},

		getAvailableLayoutParams: function(/*Object*/ alg){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// alg:
			//		Coming soon
			
			return this.inherited(arguments);;
		},
		
		setLayoutAlgorithm: function(/*Object*/ alg, /*Object*/ subgraphId, /*Object*/ performLayout){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			this.inherited(arguments);
		},
		
		getLayoutAlgorithm: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			return this.inherited(arguments);;
		},

		setLayoutParams: function(/*Object*/ layoutParams, /*Object*/ subgraphId, /*Object*/ performLayout){			
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// layoutParams:
			//		Coming soon
			// subgraphId:
			//		Coming soon
			// performLayout:
			//		Coming soon
			
			this.inherited(arguments);
		},

		setLayoutToCanvasBasedOnWidgetDef: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			this.inherited(arguments);
		},

		getRelatedItems: function(/*Object*/ item) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// item:
			//		Coming soon
			
			return this.inherited(arguments);
		},

	    getRolloverTarget: function() {
			// summary:
			//		Returns the graph entity under the mouse cursor in the canvas
			// description:
			//		This accessor returns the item (node), link, or relationship under the mouse
			//      cursor in the topology graph.  This can be used when overriding what is
			//      displayed in the tooltip for the entity.
			
			return this.inherited(arguments);
		},

	    getTooltip: function() {
			// summary:
			//		Returns the tooltip instance used for the canvas.
			// description:
			//		This accessor returns the ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip instance
			//      used to display tooltips for all entities in the topology graph.
			
			return this.inherited(arguments);
		},
		
		setEnabledObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Boolean*/enabled){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			this.inherited(arguments);
		},

		setAllEnabled: function(/*Boolean*/enabled){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			this.inherited(arguments);
		},

		setZoomTo: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			this.inherited(arguments);
		},
		//**********************************************************************************
		//**********************************************************************************
		//**********************************************************************************
		//**********************************************************************************

        _doHierarchical: function() {
        	dojo["require"]('ibm_graphlayout.hierarchical.HierarchicalLayout');
        	var layout = new ibm_graphlayout.hierarchical.HierarchicalLayout();
               
        	var onLayoutStepPerformedCallback = function(layoutStarted, layoutFinished) {
        		if (layoutFinished) {
        			var report = layout.getLayoutReport();
	                console.debug("onLayoutStepPerformedCallback!!!!!! layoutStarted = " + layoutStarted + ", layoutFinished = " + layoutFinished + ", time = " + report.getLayoutTime());
	                if (this._makeNavWidgetTimer) {
						console.debug("totalTime for makeNavWidget; " + this._makeNavWidgetTimer.stopAndGetTraceString());
					}
	                	
	                //AWE TODO
	                this.fitContents();
        		}
        	};
           	dojo.connect(layout, "onLayoutStepPerformed", dojo.hitch(this, onLayoutStepPerformedCallback));
               
           layout.setFlowDirection(8);
           layout.setGlobalLinkStyle(2);
           this._ilogDiagrammer.set("nodeLayout", layout);
       },
           
       _doTree: function() {
           dojo["require"]('ibm_graphlayout.tree.TreeLayout');
           var layout = new ibm_graphlayout.tree.TreeLayout();
           
           var onLayoutStepPerformedCallback = function(layoutStarted, layoutFinished) {
        	   if (layoutFinished) {
        		   var report = layout.getLayoutReport();
        		   console.debug("onLayoutStepPerformedCallback!!!!!! layoutStarted = " + layoutStarted + ", layoutFinished = " + layoutFinished + ", time = " + report.getLayoutTime());
        		   if (this._makeNavWidgetTimer) {
        			   console.debug("totalTime for makeNavWidget; " + this._makeNavWidgetTimer.stopAndGetTraceString());
        		   }
            	
        		   //AWE TODO
        		   this.fitContents();
        	   }
           };
           dojo.connect(layout, "onLayoutStepPerformed", dojo.hitch(this, onLayoutStepPerformedCallback));
               
           layout.setLayoutMode(ibm_graphlayout.tree.TreeLayout.ALTERNATING_RADIAL);
           layout.setGlobalLinkStyle(2);
               
           //AWE TODO
           this._ilogDiagrammer.set("nodeLayout", layout);
           //AWE TODO //this._serverLayout(this._ilogDiagrammer.getGraph(), layout);
       },
           
       //AWE TODO
       /**
        * Performs a layout on the server.
        */
       _serverLayout: function(graph, nodeLayout, linkLayout) {
           	//setStatus("");
           	graph.setNodeLayout(nodeLayout);
           	graph.setLinkLayout(linkLayout);
           	var url = "/sample-graphlayout/graphlayout"; //AWE TODO dijit.byId("serverUrl").value;
           	var serverLayout = new ibm_diagram.graphlayout.ServerSideLayout(graph,url);
           	var start = new Date().getTime();
           	var deferred = serverLayout.layout();
           	deferred.addErrback(function(value) {
           		if (value.status == 404) {
           			//setStatusError("Unable to find server-side layout code at URL: " + url);
           		}
           		else {
           			//setStatusError(value);
           		}
           	});
           	deferred.addCallback(function(value){
           		var end = new Date().getTime();
           		var duration = end-start;
           		//("Layout on server completed in " + duration + " ms");
               });
       },
           
       doForceDirected: function() {
           dojo["require"]('ibm_graphlayout.forcedirected.ForceDirectedLayout');
           var layout = new ibm_graphlayout.forcedirected.ForceDirectedLayout();
           layout.setLayoutMode(ibm_graphlayout.forcedirected.ForceDirectedLayout.FAST_MULTILEVEL_MODE);
           layout.setMaxRepeatForConvergence(3);
           this._ilogDiagrammer.set("nodeLayout", layout);
           this.fitContents();
       },
		
       //AWE TODO
       _buildSampleNodesJson: function(nodeCount) {
    	   var nodes = {};
    	   nodes.identifier = "id";
    	   nodes.label = "id";
    	   nodes.items = [];
    	   for (var i = 0; i < nodeCount; i++) {
    		   var node = {};
    		   node.id = i.toString();
    		   nodes.items.push(node);
    	   }
    	   return nodes;
       },
       
       _buildSampleLinksJson: function (nodeCount, linkPerNodeCount) {
    	   var links = {};
    	   links.identifier = "id";
    	   links.label = "id";
    	   links.items = [];

    	   var currentLevel = 0;
    	   var processedNodeCount = 1;
    	   while (processedNodeCount < nodeCount) {
    		   for (var i = 0; i < linkPerNodeCount; i++) {
    			   var link = {};
    			   link.id = currentLevel + "_" + processedNodeCount;
    			   link.identity1 = currentLevel.toString();
    			   link.identity2 = processedNodeCount.toString();
    			   links.items.push(link);
            		
    			   processedNodeCount++;
    		   }
    		   currentLevel++;
    	   }
    	   return links;
       },
       
       _myLinkTemplate: 
	          "[{"+
	          "    dojoAttachPoint: '_path',"+
	          "    shape: {"+
	          "        type: 'polyline',"+
	          "        points: [{x: 0,y: 0}, {x: 100,y: 0}]"+
	          "    },"+
	          "    stroke: {"+
	          "        width: {{strokeWidth}}," +
	          "        color: '{{strokeColor}}'" +
	          "    }"+
	          "}, {"+
	          "    dojoAttachPoint: '_endArrow',"+
	          "    shape: {"+
	          "        type: 'polyline',"+
	          "        points: [{x: -8,y: 4}, {x: 0,y: 0}, {x: -8,y: -4}]"+
	          "    },"+
	          "    fill: '{{arrowColor}}',"+
	          "}]",
	          
	          /* AWE TODO: From Francois prototype
       _myNodeTemplate:
		   "{   children:["+
		   "     {  clientSize:{width:-1, height:-1}, "+
		   "        layout: {"+
		   "           type:'ibm_diagram.gfxlayout.GridLayout', "+
		   "           rows:[{ height:30},{ height:-1}]"+
		   "        }, "+
		   "        children:["+
		   "          { rowspan:2, "+
		   "            dojoAttachPoint: 'baseShape',"+            
		   "            shape: {type:'rect', r: 5, width: 40,height: 40,r: 5}, "+
		   "            filler:true, "+
		   "            fill: {type:'linear', colors:[{offset: 0, color: 'white'}, {offset: 1, color: '{{backgroundColor}}'}] } , "+
		   "            stroke: {'color': '{{borderColor}}', 'width': 2 }"+
		   "          } ,"+
		   "          { row:0, margins:[40,10],"+
		   "            shape: {type:'text', text:'{{label}}', align:'middle'},"+
		   "            fill: '{{textColor}}',"+
		   "            font: {type:'font', size:'12pt', family:'sans-serif'} "+
		   "          } ,"+
		   "          { row:1, "+
		   "            shape: {type:'text', text:'{{status}}', align:'middle'},"+
		   "            fill: '{{textColor}}',"+
		   "            font: {type:'font', size:'8pt', family:'sans-serif'} "+
		   "          }"+
		   "        ]"+
		   "    }," +
		   "    {shape: { type:'image', src:'{{statusImage}}', x:-16, y:-16, width:16, height:16}}," +
		   "    {shape: { type:'image', src:'{{largeImage}}' , x:0,   y:0,   width:32, height:32}}" +
		   "  ]}",
		   */
		   
	     //Template From iLog docs
	     _myNodeTemplate:
	    	 "{"+
		     "	 layout: { type:'ibm_diagram.gfxlayout.GridLayout' },"+
		     "	 children: ["+
		     "	     { "+
		     "	         dojoAttachPoint: 'baseShape',"+
		     "	         minimumSize:{width:80, height:40},"+
		     "	         shape: { width:1, height:1, r: 5, type:'rect'}, "+
		     "	         fill: '{{backgroundColor}}', "+
		     "	         stroke: {'color': '{{borderColor}}', "+
		     "	         'width': 2 }"+
		     "	     },"+
		     "	     {"+
		    "	         dojoAttachPoint: 'textShape', "+
		    "	         margins:[5,5,5,-2],"+
		    "	         shape: {type:'text', text:'{{label}}', align:'middle'}, "+
		    "	         fill:'{{textColor}}', "+
		    "	         font:{type:'font', size:'10pt', family:'sans-serif'}"+
		    "	     }"+
		    "	  ]"+
		    "	 }",

                
	       /* AWE TODO
		   _myNodeTemplate:
			   "[{"+
			   "    dojoAttachPoint: 'baseShape',"+
			   "    shape: {"+
			   "        x: 0,"+
			   "        y: 0,"+
			   "        width: 141,"+
			   "        height: 117,"+
			   "        r: 5,"+
			   "        type: 'rect'"+
			   "    },"+
			   "    fill: '{{backgroundColor}}',"+
			   "    stroke: {"+
			   "        'color': '{{borderColor}}',"+
			   "        'width': 2"+
			   "    },"+
			   "    selectedStyle: {"+
			   "        fill: '{{selectedBackgroundColor}}'"+
			   "    }"+
			   "}, {"+
			   "    dojoAttachPoint: 'textShape',"+
			   "    shape: {"+
			   "        type: 'text',"+
			   "        text: '{{label}}',"+
			   "        x: 50,"+
			   "        y: 24,"+
			   "        align: 'middle'"+
			   "    },"+
			   "    fill: '{{textColor}}',"+
			   "    font: {"+
			   "        type: 'font',"+
			   "        size: '10pt',"+
			   "        family: 'sans-serif'"+
			   "    },"+
			   "    selectedStyle: {"+
			   "        fill: '{{selectedTextColor}}'"+
			   "    }"+
			   "}, {"+
			   "   shape: { " +
			   "       type:'image', " +
			   "       src:'{{statusImage}}', " +
			   "       x:123, " +
			   "       y:3, " +
			   "       width:16, " +
			   "       height:16" +
			   "    }"+
			   "}, {"+
			   "     shape: { " +
			   "       type:'image', " +
			   "       src:'{{largeImage}}' , " +
			   "       x:0,   " +
			   "       y:0,   " +
			   "       width:32, " +
			   "       height:32" +
			   "    }" + 
			   "}]",
			   */

         _getNodeTemplate: function(item, store, diagram) {
           return this._myNodeTemplate;
         },
         
         _getLinkTemplate: function(){
             return this._myLinkTemplate;
         },
         
		 _onLinkCreated: function(link, start, end, diag){
        	 var storeItem = diag.getBoundItem(link);
        	 var style = storeItem.getLinkStyle();
        	 link.setStrokeWidth(style.getLineWidth());
        	 link.setStrokeColor(style.getLineColor());
        	 link.setArrowColor(style.getArrowColor());
         },
         
         _onNodeCreated: function(node, diag){
        	 var storeItem = diag.getBoundItem(node);
        	 var statuses = storeItem.getStatuses({mergeWidgetDef: false});
        	 if (statuses && statuses.length > 0) {
        		 var status = statuses[0];
        		 //Get background image info
        		 var image = this._cleanUpImagePath(status.getImage());
        		 var label =  status.getLabel();
        		 var tooltip =  status.getTooltip();
        		 node.setStatus(label);
        		 node.setStatusColor("#FFFFFF");
        		 node.setStatusImage(image);
        	 }
        	 var style = storeItem.getItemStyle();
        	 var image2 = this._cleanUpImagePath(style.getSmallImage());
        	 node.setLargeImage(image2);     
         }
	 });


}
