/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog");

dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.Select");
dojo.require("dijit.form.HorizontalSlider");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyDropDownSelect");

dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog",dijit.Dialog,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	// topology: [public] Object
	//		Coming soon
	topology: null,
	algorithmModified: false,
	
	postCreate: function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this.inherited(arguments);
		var layoutParamPane = new dijit.layout.ContentPane({
			id:this.topology.id + "_layoutParamContainer"
		},this.containerNode.appendChild(dojo.create("div")));
		layoutParamPane.containerNode.appendChild(this.createLayoutParamDivContent(this.topology.getLayout().algorithm));
	},

    show: function() {
		// summary:
		//		Override of dijit._DialogBase show() to check saved focus setting
		// description:
		//		Coming soon
		
		/*
		 * 254135
		 * This override of the dijit._DialogBase function is a temporary workaround to
		 * ensure that the focus is not returned to the <object> node that contains the
		 * Flash plugin for the canvas (as that cannot be done with javascript).  Instead
		 * return the focus to the DIV container for the canvas.
		 */
        this.inherited(arguments);
		//Kris 4Jan12, adding an if check for _savedFocus, since it is not there in dojo 1.6 Dialog
		if(this._savedFocus){ 
			if (this._savedFocus.node.id && this._savedFocus.node.id.indexOf("SWFObject") > 0) {
				this._savedFocus.node = this.topology._canvas.domNode;
			}
		}
    },
    
	createLayoutAlgorithmParamTable: function(/*Object*/ alg, /*Object*/ change) 
	{
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// alg:
		//		Coming soon
		// change: 
		//		Coming soon
		var allParams = (change ? [] : null);
		var layout = this.topology.getLayoutByName(alg);
		var layoutParams = this.topology.getAvailableLayoutParams(alg);
		var table = dojo.create("table", 
		{	"style":"border: 1px solid #dfdfdf; margin: 0px 10px 10px 10px",
			cellspacing:"10",
         role: "presentation"    // 255868
		});
		var tbody = dojo.create("tbody");//for IE
		table.appendChild(tbody);
						
		for (var i=0; i < layoutParams.length; ++i) {
			var row = dojo.create("tr");
			var cell = dojo.create("td");
			tbody.appendChild(row);			
			row.appendChild(cell);

			var labelNode = dojo.create("label", 
			{	"for" : this.topology.id+"_"+alg+"_"+layoutParams[i][0],   // 254600
				id: this.topology.id+"_"+alg+"_"+layoutParams[i][0]+"_id",   // 254600
			 	innerHTML: this.topology.commonResources[ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog.layoutParamsToNLSKeyMapping[layoutParams[i][0]]],
			 	"style" : "font-size:11px; font-family: Verdana" 
			}, cell);
			
			cell = dojo.create("td");
			row.appendChild(cell);	  	  
			
			var tmpDiv = dojo.create("div");
			cell.appendChild(tmpDiv);
			
			var params = layoutParams[i][1].split("|");
			var layoutParamValue=layout[layoutParams[i][0]];			
			if(!layoutParamValue){
				layoutParamValue = params[0];
			}

			if (change) {
				allParams.push([alg, layoutParams[i][0], layoutParamValue]);
			}
			
			if (isNaN(params[0])) {								
				var layoutParamValue=layout[layoutParams[i][0]];
				
				var options = [];		
				for (var j=0;j<params.length;j++) {
					var option = {};
					option.label = this.topology.commonResources[ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog.layoutParamsOptionsToNLSKeyMapping[params[j]]];
					option.value = params[j];							
					if(layoutParamValue && layoutParamValue === params[j]) {
						option.selected = true;
					}
					options.push(option);					
				}			
				
				var id = this.topology.id+"_"+alg+"_"+layoutParams[i][0];
				var combo = new dijit.form.Select({
						id: id,					
						name: id,
						attrKey: layoutParams[i][0],						
						options: options,						
						topology: this.topology							
				}, tmpDiv);

				dojo.connect(combo,"onChange",combo, function(cmbx) { 
					var layoutAlgSelect = dijit.byId(this.topology.id+"_layoutAlgSelect");					
					var params = [[layoutAlgSelect.value, this.attrKey, this.value]];
					this.topology.setLayoutParams(params, null, true); 
				});				
			} 
			else {
				// Simple check to see if float (look for decimal place) 
				// KDM: Clean this up
				if (params[0].indexOf(".")==-1) {
					var slider = new dijit.form.HorizontalSlider({
						id: this.topology.id+"_"+alg+"_"+layoutParams[i][0],
						name: layoutParams[i][0],
						value: layoutParamValue,
						minimum: parseInt(params[0]),
						maximum: parseInt(params[1]),
						discreteValues: 10,
						intermediateChanges: false,
						dragRestriction: true,
						clickSelect: true,
						showButtons: false,
						style: "width: 150px;"
					}, tmpDiv);	
					// Currently screen readers do not read label tags that are associated with Dojo slider
					// widgets via the label "for" attribute, so we have to also assign the label text to
					// the slider "title" attribute so the screen reader will read that text when the slider
					// gets the focus.  (Also setting the aria-labelledby attribute to reference back to the
					// actual label tag just in case the screen readers start being able to use that for slider widgets.)
					dojo.attr(slider.domNode, "title", this.topology.commonResources[ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog.layoutParamsToNLSKeyMapping[layoutParams[i][0]]]);  // 254600
					dojo.attr(slider.domNode, "aria-labelledby", this.topology.id+"_"+alg+"_"+layoutParams[i][0]+"_id");  // 254600
					
					var topo = this.topology.id;
					var topoToolbar = this.id;
					dojo.connect(dijit.byId(this.topology.id+"_"+alg+"_"+layoutParams[i][0]), "onChange", slider, function(sldr) { 
						this.value = Math.round(this.value);
						var layoutAlgSelect = dijit.byId(topo+"_layoutAlgSelect"); 
						dijit.byId(topoToolbar).topology.setLayoutParams([[layoutAlgSelect.value,this.name,this.value]], null, true);
					}); 					
				} 
				else {
					var slider = new dijit.form.HorizontalSlider({
						id: this.topology.id+"_"+alg+"_"+layoutParams[i][0],
						name: layoutParams[i][0],
						value: layoutParamValue,
						minimum: parseFloat(params[0]),
						maximum: parseFloat(params[1]),
						discreteValues: 10,
						intermediateChanges: false,
						dragRestriction: true,
			            	clickSelect: true,
			            	showButtons: false,
						style: "width: 150px;"
					}, tmpDiv);
					// Currently screen readers do not read label tags that are associated with Dojo slider
					// widgets via the label "for" attribute, so we have to also assign the label text to
					// the slider "title" attribute so the screen reader will read that text when the slider
					// gets the focus.  (Also setting the aria-labelledby attribute to reference back to the
					// actual label tag just in case the screen readers start being able to use that for slider widgets.)
					dojo.attr(slider.domNode, "title", this.topology.commonResources[ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog.layoutParamsToNLSKeyMapping[layoutParams[i][0]]]);  // 254600
					dojo.attr(slider.domNode, "aria-labelledby", this.topology.id+"_"+alg+"_"+layoutParams[i][0]+"_id");  // 254600
					var topo = this.topology.id;
					var topoToolbar = this.id;
					
					dojo.connect(dijit.byId(this.topology.id+"_"+alg+"_"+layoutParams[i][0]), "onChange", slider, function(sldr) { 
						var layoutAlgSelect = dijit.byId(topo+"_layoutAlgSelect"); 
						dijit.byId(topoToolbar).topology.setLayoutParams([[layoutAlgSelect.value,this.name,this.value]], null, true);          	
					});					
				}	     
			}
		}	
		
		if (change && allParams) {
			this.topology.setLayoutParams(allParams, null, true); 
		}

		return table;
	  },
	  
	  createLayoutParamDivContent: function(/*Object*/ alg) 
	  {
		  // summary:
		  //		Coming soon
		  // description:
		  //		Coming soon
		  // alg:
		  //		Coming soon
		  	var layoutParamDiv = dojo.create("div");	  	
		  	var table = dojo.create("table", 
									{
										"style":"margin: 5px 0px 5px 10px",
										cellspacing:"0",
                              role: "presentation"    // 255868
									});	
			var tbody = dojo.create("tbody");//for IE
			table.appendChild(tbody);
			var row = dojo.create("tr");
			tbody.appendChild(row);	  	  
			var cell = dojo.create("td");
			var labelNode = dojo.create("label", 
							{
								"for" : this.topology.id+"_layoutAlgSelect",
								innerHTML: this.topology.commonResources.ALGORITHM,
								"style" : "font-size:11px; font-family: Verdana"
							}, cell); 
			row.appendChild(cell);	  	  	  	  
			cell = dojo.create("td");
			var tmpDiv = dojo.create("div");
			cell.appendChild(tmpDiv);
			var layoutAlgSelect = dijit.byId(this.topology.id+"_layoutAlgSelect");
			if (layoutAlgSelect == null) {
				layoutAlgSelect = new ibm.tivoli.tip.navwidget.topology.dijit.TopologyDropDownSelect({
					id: this.topology.id+"_layoutAlgSelect",
					name:"layoutAlgSelect"
				},tmpDiv);	
				row.appendChild(cell);	

				var layouts = this.topology.getLayouts();
				var length = layouts.length;
				for (var index = 0; index < length;  ++index) {
					switch(layouts[index].algorithm) {
						case "tree":
							layoutAlgSelect.addOption({iconClass: this.topology.getLayoutIconClass("tree"),value:"tree",label:this.topology.commonResources.TREE_LAYOUT});
							break;
						case "hierarchical":
							layoutAlgSelect.addOption({iconClass: this.topology.getLayoutIconClass("hierarchical"),value:"hierarchical",label:this.topology.commonResources.HIERARCHICAL_LAYOUT});
							break;
						case "forceDirected":
							layoutAlgSelect.addOption({iconClass: this.topology.getLayoutIconClass("forceDirected"),value:"forceDirected",label:this.topology.commonResources.FORCE_DIRECTED_LAYOUT});
							break;
						case "grid":
							layoutAlgSelect.addOption({iconClass: this.topology.getLayoutIconClass("grid"),value:"grid",label:this.topology.commonResources.GRID_LAYOUT});
							break;
						case "shortLink":
							layoutAlgSelect.addOption({iconClass: this.topology.getLayoutIconClass("shortLink"),value:"shortLink",label:this.topology.commonResources.SHORT_LINK_LAYOUT});
							break;
						case "longLink":
							layoutAlgSelect.addOption({iconClass: this.topology.getLayoutIconClass("longLink"),value:"longLink",label:this.topology.commonResources.LONG_LINK_LAYOUT}); 
					}
				}				
				layoutParamDiv.appendChild(table);	
			} 
		
			layoutAlgSelect.setValue(alg);
		
			dojo.connect(layoutAlgSelect, "onChange", this, function(){
				var currAlg = this.topology.getLayout().algorithm;
				var alg = dijit.byId(this.topology.id+"_layoutAlgSelect").value;	
				if (this.algorithmModified || alg != currAlg) {
					this.algorithmModified = true;
					this.topology.setLayoutAlgorithm(alg, null, true);
					var layoutAlgorithmParamPane = dijit.byId(this.topology.id + "_layoutAlgorithmParamPane");
					layoutAlgorithmParamPane.destroyDescendants(false);
					layoutAlgorithmParamPane.containerNode.appendChild(this.createLayoutAlgorithmParamTable(alg, true));
				}
			});
		  	  	
			var layoutAlgorithmParamPane = new dijit.layout.ContentPane({id:this.topology.id + "_layoutAlgorithmParamPane"},layoutParamDiv.appendChild(dojo.create("div")));		
			layoutAlgorithmParamPane.containerNode.appendChild(this.createLayoutAlgorithmParamTable(alg, false));
			
			var bottomButtonsDiv = dojo.create("div");

			dojo.style(bottomButtonsDiv,{
								backgroundColor: "#F7F7F7",			
								borderTopColor: "#DEDEDE",
								borderTopStyle: "solid",
								borderTopWidth: "1px",
								padding: "5px 5px 5px 10px"
			});
			//TODO KRK Consider creating style class for that - it will be used in all the dialogs. 
			//TODO KRK Also consider creating Generic dialog widget 
			//so that all the dialogs will be using it and be consistent
			
			layoutParamDiv.appendChild(bottomButtonsDiv);
			
			var saveLayoutButton = new dijit.form.Button({
				id: this.topology.id+"_saveLayoutButton",
				label:this.topology.commonResources.OK
			},bottomButtonsDiv.appendChild(dojo.create("div")));

			var cancelLayoutButton = new dijit.form.Button({ 
				id: this.topology.id+"_cancelLayoutButton",
				label:this.topology.commonResources.CANCEL
			},bottomButtonsDiv.appendChild(dojo.create("div")));
			
			dojo.connect(saveLayoutButton, "onClick", this, "_layoutCustomizationOkAction");			
			dojo.connect(cancelLayoutButton, "onClick", this, "_layoutCustomizationCancelAction");

			return layoutParamDiv;
	  	},

	  	_layoutCustomizationCancelAction : function(){
			// revert back to previous layout
	  		this.topology.restoreCurrentLayout();

			// pop down dialog
	  		dijit.byId(this.topology.id + "_customLayoutDialog").hide();
	  	},
	  	
	  	_layoutCustomizationOkAction : function(){
			// set all attributes back to the selected layout
			var alg = dijit.byId(this.topology.id+"_layoutAlgSelect").value;			
			var layout = this.topology.getLayoutByName(alg);			
			var layoutParams = this.topology.getAvailableLayoutParams(alg); 			
			for (var i=0;i<layoutParams.length;i++) {
				var paramId = this.topology.id+"_"+alg+"_"+layoutParams[i][0];				
				layout[layoutParams[i][0]] = dijit.byId(paramId).value.toString();
			};

			// simulate menu selection with the topology view
			this.topology.setLayoutEventHandler({layoutId: layout.id});
			
			// pop down dialog		
			dijit.byId(this.topology.id + "_customLayoutDialog").hide();
	  	}
});

ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog.layoutParamsOptionsToNLSKeyMapping = {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		"alternating radial":"ALTERNATING_RADIAL",
		"automatic":"AUTOMATIC",
		"border center":"BORDER_CENTER",
		"bottom":"BOTTOM",
		"center":"CENTER",
		"centered":"CENTERED",
		"direct":"DIRECT",
		"east":"EAST",
		"evenly spaced":"EVENLY_SPACED",
		"fast multilevel":"FAST_MULTILEVEL",
		"fixed offset":"FIXED_OFFSET",
		"free":"FREE",
		"higher levels":"HIGHER_LEVELS",
		"incremental":"INCREMENTAL",
		"left":"LEFT",
		"level":"LEVEL",
		"lower levels":"LOWER_LEVELS",
		"mixed":"MIXED",
		"no reshape":"NO_RESHAPE",
		"non incremental":"NON_INCREMENTAL",
		"north":"NORTH",
		"optimal":"OPTIMAL",
		"orthogonal":"ORTHOGONAL",
		"polyline":"POLYLINE",
		"radial":"RADIAL",
		"right":"RIGHT",
		"semi optimal":"SEMI_OPTIMAL",
		"south":"SOUTH",
		"spread out":"SPREAD_OUT",
		"straight":"STRAIGHT",
		"three bends orthogonal":"THREE_BENDS_ORTHOGONAL",
		"tile to columns":"TILE_TO_COLUMNS",
		"tile to grid fixed height":"TILE_TO_GRID_FIXED_HEIGHT",
		"tile to grid fixed width":"TILE_TO_GRID_FIXED_WIDTH",
		"tile to rows":"TILE_TO_ROWS",
		"tip leaves over":"TIP_LEAVES_OVER",
		"tip over both sides":"TIP_OVER_BOTH_SIDES",
		"tip over east west":"TIP_OVER_EAST_WEST",
		"tip over west":"TIP_OVER_WEST",
		"tip over":"TIP_OVER",
		"tip roots and leaves over":"TIP_ROOTS_AND_LEAVES_OVER",
		"tip roots over":"TIP_ROOTS_OVER",
		"top":"TOP",
		"two bends orthogonal":"TWO_BENDS_ORTHOGONAL",
		"west":"WEST"		
};

ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog.layoutParamsToNLSKeyMapping = {		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
		
	"layoutMode"				:"LAYOUT_MODE",
	"flowDirection"				:"FLOW_DIRECTION",
	"globalLinkStyle"				:"LINK_STYLE",
	"connectorStyle"				:"CONNECTOR_STYLE",
	"globalAlignment"				:"GLOBAL_ALIGNMENT",
	"levelAlignment"				:"LEVEL_ALIGNMENT",	
	"levelJustification"			:"LEVEL_JUSTIFICATION",
	"levelingStrategy"			:"LEVELING_STRATEGY",
	"globalHorizontalAlignment"		:"GLOBAL_HORIZONTAL_ALIGNMENT",
 	"globalVerticalAlignment"		:"GLOBAL_VERTICAL_ALIGNMENT",
 	"maxNumberOfNodesPerRowOrColumn"	:"MAX_NUM_NODES_PER_ROW_COLUMN",
 	"preferredLinksLength"			:"PREFERRED_LINKS_LENGTH",
 	"linkStyle"					:"LINK_STYLE",
	"maxAllowedMovePerIteration"		:"MAX_ALLOWED_MOVE_PER_ITERATION",
 	"allowedNumberOfIterations"		:"ALLOWED_NUMBER_OF_ITERATIONS",
	"convergenceThreshold"			:"CONVERGENCE_THRESHOLD",
 	"globalLinkStyle"				:"GLOBAL_LINK_STYLE",
	"globalSelfLinkStyle"			:"GLOBAL_SELF_LINK_STYLE",
 	"globalConnectorStyle"			:"GLOBAL_CONNECTOR_STYLE",
 	"linkOffset"				:"LINK_OFFSET",
 	"minFinalSegmentLength"			:"MIN_FINAL_SEGMENT_LENGTH",
 	"verticalMinOffset"			:"VERTICAL_MIN_OFFSET",
 	"horizontalMinOffset"			:"HORIZONTAL_MIN_OFFSET",
 	"aspectRatio"				:"ASPECT_RATIO"
};
