/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelperBase");
dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper");

dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog");
dojo.require("ibm.tivoli.navmodel.NavWidgetDef");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.requireLocalization("ibm.tivoli.tip.navwidget", "resources");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelperBase",null,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	constructor: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this._resources = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget", "resources");    
	},

	getMenuItems: function(/*Object*/ context) {		
		// summary:
		//		Coming soon
		// description:
		//		required, as it is used as the getMenuItemsCallback with the menu provider
		// context:
		//		Coming soon
		return [];		// by default, return empty collection of menu items
	},
	
	// required, as it is used as the getMenuCommandCallback with the menu provider
	getMenuCommand: function(commandName, context, menuItem) {
		return menuItem;	// by default, return the menuItem, i.e., no processing
	}
});


dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper",
	      ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelperBase,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	//_propDialog: [private] Object
	//		Coming soon
	_propDialog: null,
	
	getMenuItems: function(/*Object*/ context) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// context:
		//		Coming soon
		var items = this.inherited(arguments);
		
		// Note: Add code here to add JSON menu item objects (for our built-in actions) to items
		// Example: 
		//    items.push( { "actionID":"someUniqueID",
		//                  "label":"someLabelForTheItem",
		//                  "launchType":"NOOP" } );
		// Note: For globalization, the label will need to be loaded from a resource bundle.
		//       Also, setting launchType to NOOP is optional, but may simplify code in
		//       getMenuCommand (see below)
		
		
		//The PropertiesNotebook should not be displayed unless only a single item is selected
		//first check the context to make sure multiple items are not selected
		//checks if only one item or link
		var selectedObjects = context.selection;
		if(( selectedObjects.getItemCount() + selectedObjects.getLinkCount() + selectedObjects.getRelationshipCount()) == 1){
				
			var object = null;
			
			if(selectedObjects.getItemCount() == 1){
				object = selectedObjects.getItems()[0];            
			}else if(selectedObjects.getRelationshipCount() == 1){
				object = selectedObjects.getRelationships()[0];
			}else if(selectedObjects.getLinkCount() == 1){
				object = selectedObjects.getLinks()[0];
			}else{
				console.log("Cannot handle non link, rel, or item objects. No action preformed.");
			}
			
			//if the object doesnt support properties, dont add prop menu item.
			if(object && object.supportsProperties() ){
				//Add the PropertiesNotebook to the Menu list of items
				items.push(
					{ 
					  "actionID": "_separator_" 
					},
					{ "actionID": "nwmi_PropertiesNotebookDialog",
					  "label": ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this._resources.PROPERTIES),
					  "launchType":"NOOP"
					}			
				  );	
			}
			
		} else {

			//Get Default Actions for this specific view
			var tasks = context.getViewSpecificTasks();
			if (tasks) {
				items.push(
						{ 
						  "actionID": "_separator_",
						  "launchType":"VIEW_COMMAND"
						});		
				for (var i=0;i<tasks.length;i++) {			
					items.push(
							{ "actionID": tasks[i][0],
							  "label": tasks[i][1],
						 	 "launchType":tasks[i][2]
							}			
				  		);
				}
			}		
		}	

		return items;
	},
	
	getMenuCommand: function(/*Object*/ commandName, /*Object*/ context, /*Object*/ menuItem) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// commandName:
		//		Coming soon
		// context:
		//		Coming soon
		// menuItem:
		//		Coming soon
		var result = null;
		
		// Note: add code here to check the commandName (which is also the actionID from 
		// menuItem) and if it is one of our actions, do or call whatever is needed to do 
		// the work and then set the result to a no-op command so the TIPContextMenu will 
		// take no action on the returned result
		// Ex:
		//     result = {"launchType":"NOOP"};
		//  or
		//     result = menuItem;  (if the launchType="NOOP" was already an attribute in the menu item)
		//
		
		//command name is = to actionID...so if one of the special menu items added above, do special processing
		
		// make sure we have a menu item (default action/task processing can call with just a 
		// command and no menuItem)
		if (menuItem && (menuItem.launchType == "VIEW_COMMAND")) {
			context.executeViewSpecificTask(commandName);
			result = {"launchType":"NOOP"}; 
			return result;
		}

		switch (commandName) {
			case "nwmi_PropertiesNotebookDialog":			
				//The PropertiesNotebook should not be displayed unless only a single item is selected
				//first check the context to make sure multiple items are not selected
				//checks if only one item or link
				var selectedObjects = context.selection;
				if(( selectedObjects.getRelationshipCount() + selectedObjects.getLinkCount() + selectedObjects.getItemCount() ) != 1){
					//if there is more than one item then just return and do nothing
					result = menuItem;
					return result;
				}
				
				//Try to look up nav widget def and get widget definition for props notebook
				var dialogWidgetDefinitionId = null;
				var topLevelPluggableViewWidgetDefinition = context.getTopLevelPluggableViewWidgetDefinition();
				if (topLevelPluggableViewWidgetDefinition != null && topLevelPluggableViewWidgetDefinition.isInstanceOf(ibm.tivoli.navmodel.NavWidgetDef)) {
					var notebook = topLevelPluggableViewWidgetDefinition.getNotebook();
					if (notebook) {
						dialogWidgetDefinitionId = notebook.definition;
					}
				}
			
				// if there is one item then create the PropertiesNotebookDialog
                this._propDialog = new ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookDialog({
                    id: context.id + "_PropertiesDialog",
                    className: "tundra",
                    style: "width:40%",
                    managingPluggableView: context,
                    widgetDefinitionId: dialogWidgetDefinitionId
                });
              
                this._propDialog.setDataset(context.dataset);
                
                if(selectedObjects.getItemCount() == 1){
                	var item = selectedObjects.getItems()[0];
                	//set the object on the dialog (hardcoded to 0 since we checked there is only one item
                    this._propDialog.setObjects([item]);
                    
                }else if(selectedObjects.getRelationshipCount() == 1){
                	var rel = selectedObjects.getRelationships()[0];
                	//set the object on the dialog (hardcoded to 0 since we checked there is only one item
                    this._propDialog.setObjects([],[],[rel]);
                }else if(selectedObjects.getLinkCount() == 1) {
                	var link = selectedObjects.getLinks()[0];
                	//set the object on the dialog (hardcoded to 0 since we checked there is only one item
                    this._propDialog.setObjects([],[link]);
                }else{
                	console.log("Properties dialog does not render anything other than links, items, or relationships.");
                }
                              
                //display the dialog
                this._propDialog.startup();		
                this._propDialog.show();	
               // dojo.connect(this._propDialog,"onCancel" ,dojo.hitch(this, this._cleanupDialog));
				
                //done return
				result = menuItem;
				return result;
			
			default:
				// Note: If this is NOT one of our client-side actions, DO NOT set result and let
				// the parent class command be returned
				return (result) ? result : this.inherited(arguments);
			
		}
	}
	
});