/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.PrintDialog");

dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.NumberSpinner");
dojo.require("dijit.form.NumberTextBox");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.ComboBox");

dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.PrintDialog",dijit.Dialog,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	// topology: [public] Object
	//		Coming soon
	topology: null,
	
	// pageCount: [public] int
	//		Coming soon
	pageCount: null,

	postCreate: function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this.inherited(arguments);
		var printDialogPane = new dijit.layout.ContentPane({
			id: this.id + "_container"
		},this.containerNode.appendChild(dojo.create("div")));
		printDialogPane.containerNode.appendChild(this._createPrintDivContent());
		this.containerNode.style.cssText = this.containerNode.style.cssText + "border:none";
	},
	
    show: function() {
		// summary:
		//		Override of dijit._DialogBase show() to check saved focus setting
		// description:
		//		Coming soon
		
		/*
		 * 254135
		 * This override of the dijit._DialogBase function is a temporary workaround to
		 * ensure that the focus is not returned to the <object> node that contains the
		 * Flash plugin for the canvas (as that cannot be done with javascript).  Instead
		 * return the focus to the DIV container for the canvas.
		 */
        this.inherited(arguments);
		//Kris 4Jan12, adding an if check for _savedFocus, since it is not there in dojo 1.6 Dialog
		if(this._savedFocus){ 
			if (this._savedFocus.node.id && this._savedFocus.node.id.indexOf("SWFObject") > 0) {
				this._savedFocus.node = this.topology._canvas.domNode;
			}
		}
    },

	_createPrintDivContent: function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		var printDiv = dojo.create("div");	  	
	 	var table = dojo.create("table", 
					{
						cellspacing:"0",
                  role: "presentation"    // 255868
					});	

		tbody = dojo.create("tbody");//for IE
		table.appendChild(tbody);

		row = dojo.create("tr");
		tbody.appendChild(row);	  	  
		cell = dojo.create("td", {"style":"padding: 5px 5px 5px 10px;"});
		row.appendChild(cell);	
		var printBitmapCheckboxID = this.topology.id + "_printAsBitmap";  // 254600
		var printBitmap = dojo.create("label", 
			  	 			{
			    				"for" : printBitmapCheckboxID,    // 254600
							innerHTML: this.topology.commonResources.PRINT_AS_BITMAP,
		    					"style" : "font-size:11px; font-family: Verdana" 
							}, cell);
		cell = dojo.create("td", {"style":"padding: 5px 10px 5px 5px;"});	
		var tmpDiv = dojo.create("div");
		cell.appendChild(tmpDiv);
		var checkBox = new dijit.form.CheckBox({
			id: printBitmapCheckboxID,     // 254600
            	checked: false
	      },tmpDiv);
		row.appendChild(cell);	

		row = dojo.create("tr");
		tbody.appendChild(row);	  	  
		cell = dojo.create("td", {"style":"padding: 5px 5px 5px 10px;"});
		row.appendChild(cell);	
		var pageMarginTextBoxID = this.topology.id + "_pageMarginNumber";   // 254600
		var pageMargin = dojo.create("label", 
			  	 			{
			    				"for" : pageMarginTextBoxID,    // 254600
							innerHTML: this.topology.commonResources.PAGE_MARGIN,
		    					"style" : "font-size:11px; font-family: Verdana" 
							}, cell);
		cell = dojo.create("td", {"style":"padding: 5px 10px 5px 5px;"});
		var tmpDiv = dojo.create("div");
		cell.appendChild(tmpDiv);			
		// Page Margin
		var pageMarginNumber = new dijit.form.NumberTextBox({
			id: pageMarginTextBoxID,    // 254600
			constraints: {
				pattern: "#.##",
				min: 0.5,
				max: 2.5
			},
			value: 1.0,
			style: "width:50px"
		},tmpDiv);
		row.appendChild(cell);	


		var row = dojo.create("tr");
		tbody.appendChild(row);	  	  
		var cell = dojo.create("td", {"style":"padding: 5px 5px 5px 10px;"});
		row.appendChild(cell);		
		var pageCountNumberSpinnerID = this.topology.id + "_pageCountNumber";   // 254600
		pageCount = dojo.create("label", 
			  	 			{
							"id"  : "pageCount",
			    				"for" : pageCountNumberSpinnerID,	// 254600		
							"innerHTML" : "Test",			
		    					"style" : "font-size:11px; font-family: Verdana" 
							}, cell);
		cell = dojo.create("td", {"style":"padding: 5px 10px 5px 5px;"});
		var tmpDiv = dojo.create("div");
		cell.appendChild(tmpDiv);			
		// Page Count
		var pageCountNumber = new dijit.form.NumberSpinner({
			id: pageCountNumberSpinnerID,   // 254600
			value: 1,
			smallDelta: 1,
			intermediateChanges: true,
			constraints: {
				min:1,
				max:5
			},
			style: "width:50px"
		},tmpDiv);
		pageCount.innerHTML = this.topology.commonResources.PAGE_COUNT+"<br>"+this.topology.commonResources.PAGE_COUNT_MAX + " " + Math.pow(dijit.byId(this.topology.id+"_pageCountNumber").value,2);
		row.appendChild(cell);

		printDiv.appendChild(table);

		var bottomButtonsDiv = dojo.create("div");

		dojo.style(bottomButtonsDiv,{
							backgroundColor: "#F7F7F7",			
							borderTopColor: "#DEDEDE",
							borderTopStyle: "solid",
							borderTopWidth: "1px",
							padding: "5px 5px 5px 10px"
		});
		
		printDiv.appendChild(bottomButtonsDiv);
		
		var printButton = new dijit.form.Button({
			id: this.topology.id+"_printButton",
			label:this.topology.commonResources.OK
		},bottomButtonsDiv.appendChild(dojo.create("div")));

		var cancelPrintButton = new dijit.form.Button({ 
			id: this.topology.id+"_cancelPrintButton",
			label:this.topology.commonResources.CANCEL
		},bottomButtonsDiv.appendChild(dojo.create("div")));
	
		dojo.connect(pageCountNumber, "onChange", this, "_refreshPageNumberAction");
		
		dojo.connect(printButton, "onClick", this, "_printAction");
			
		dojo.connect(cancelPrintButton, "onClick", this, "_printCancelAction");
		
		return printDiv;
	},

	_refreshPageNumberAction : function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		pageCount.innerHTML = this.topology.commonResources.PAGE_COUNT+"<br>"+this.topology.commonResources.PAGE_COUNT_MAX + " " + Math.pow(dijit.byId(this.topology.id+"_pageCountNumber").value,2);
	},

	_printCancelAction : function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	  	dijit.byId(this.topology.id + "_printDialog").hide();
	},	  	
		
	_printAction: function(){			
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		var pageCount = dijit.byId(this.topology.id+"_pageCountNumber").value;
		var pageMargin = dijit.byId(this.topology.id+"_pageMarginNumber").value;
		var printAsBitmap = dijit.byId(this.topology.id+"_printAsBitmap").checked;
		this.topology.print(pageCount, pageMargin, printAsBitmap);
		dijit.byId(this.topology.id + "_printDialog").hide();
	}
		
});
