/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide ("ibm.tivoli.tip.navwidget.topology.dijit.SWFContainer");

dojo.require ("dijit.layout.ContentPane");

dojo.require("ibm.tivoli.navmodel.Trace");
ibm.tivoli.tip.navwidget.topology.dijit.SWFContainer._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dijit.SWFContainer");

//NLS
dojo.requireLocalization("ibm.tivoli.tip.navwidget", "resources");

dojo.declare ("ibm.tivoli.tip.navwidget.topology.dijit.SWFContainer",
	[dijit.layout.ContentPane],
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		//*******************************************************************************
		// "Public" Attributes
		//********************************************************************************
	
		// swfFileName: [public attribute] String
		//		Coming soon
		swfFileName: "",
		
		// flashvars: [public attribute] Object
		//		Coming soon
		flashvars: null,
		
		//*******************************************************************************
		// "Constants"
		//********************************************************************************

		// _SWF_MIN_VERSION: [const] String
		//		Specific to SWFObject API
		_SWF_MIN_VERSION: "10.1.0",
		
		// _SWF_INCLUDE_QUICK_INSTALL: [const] Boolean
		//		Coming soon
		_SWF_INCLUDE_QUICK_INSTALL: false,
		
		/* 
		 * For width and height... taking strategy here that we'll completely fill our container. Up to deployer to make sure divs, etc. in ancestor tree are
		 * sized appropriately. If desire is to fill up page, then all ancestor containers should be set to 100% (including body and html to make FF work).
		 */
		
		// _SWF_WIDTH: [const] String
		//		Coming soon
		_SWF_WIDTH: "100%",
		
		// _SWF_HEIGHT: [const] String
		//		Coming soon
		_SWF_HEIGHT: "100%", 

		// _SWF_INCLUDE_QUICK_INSTALL: [const] String
		//		Custom to add to flashvars passed to SWF
		_SWF_JAVASCRIPT_DEBUG_ON: "FALSE",
		
		//*******************************************************************************
		// "Private"
		//********************************************************************************
		
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
		_trace: ibm.tivoli.tip.navwidget.topology.dijit.SWFContainer._trace, 
		
		// _replacementDivId: [private] String
		//		Coming soon
		_replacementDivId: null,
		
		// _embeddedSWFObjectId: [private] String
		//		Coming soon
		_embeddedSWFObjectId: null,
		
		// _embeddedSWFObject: [private] Object
		//		Coming soon
		_embeddedSWFObject: null,
		
		// _flexBridge: [private] String
		//		Coming soon
		_flexBridge: null,
		
		// _flexBridgeInitialized: [private] Boolean
		//		Coming soon
		_flexBridgeInitialized: false,
		
		// _faBrideInitCallbacks: [private] Object
		//		Coming soon
		_faBridgeInitCallbacks: null,

		//*******************************************************************************
		// Overridden functions
		//********************************************************************************
		//Base constructor
		constructor: function () {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Determine whether Flex should log to JavaScript console
			if (dojo.config.flex && dojo.config.flex.javaScriptTraceOn) {
				this._SWF_JAVASCRIPT_DEBUG_ON = "TRUE";
			}
			
			//NLS
			this._resources = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget", "resources");
		},
		
		postCreate: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			this._replacementDivId = this.id + "_alternativeToSWFContent";
			this._embeddedSWFObjectId = this.id + "_embeddedSWFObjectId";
			
			//Let's remove all the padding from ourself but be greedy on available size
			this._setStyleAttr({margin: "0",
			                padding: "0",
							height: "100%",
							width: "100%",
			                overflow: "hidden"});
			
			//Create the content div which will hold the replacementDiv (if plugin gets embedded correctly,
			//then it will replace the replacement DIV, but we want the immediate "content" of this ContentPane
			//to stay unchanged for layout purposes).
			contentDiv = dojo.doc.createElement("div");
			contentDiv.id = this.id + "_contentDiv";
			dojo.style(contentDiv, {height: "100%", width: "100%"}); // Style the DIV to participate in initial sizing //250690 -- added this and removed resize function
			
			//Create the replacement div where SWFObject will embed itself
			var replacementDiv = dojo.doc.createElement("div");
			dojo.style(replacementDiv, {height: "100%", width: "100%"}); // Style the DIV to participate in initial sizing
			replacementDiv.id = this._replacementDivId;

			//Add replacement div to the content div
			dojo.place(replacementDiv, contentDiv);

			//Set our content to be the replacementDiv
			this.attr("content", contentDiv);
			
			//Call super
			this.inherited(arguments);
		},
		
		startup: function() { 		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (this._trace.isInfo()) {
				this._trace.info("swfFileName = " + this.swfFileName, "startup");
			}
			if (this.swfFileName) {
				//***************************
				//Set up Flash vars
				if (!this.flashvars) {
					this.flashvars = {};
				}
				
				//This will be used by Flex Ajax Bridge to identify the SWF we want to talk to 
				this.flashvars.bridgeName = this._embeddedSWFObjectId;
				
				//This is a custom flashvar to indicate to the SWF to trace out to console.debug
				this.flashvars.javaScriptTraceOn = this._SWF_JAVASCRIPT_DEBUG_ON;
				
				//Setup parms and attributes
				var params = {};
				params.wmode = "opaque"; //249441 -- changed from "transparent" to "opaque" to solve label rendering problem in nested subgraphs
				
				var attributes = {};
				attributes.id = this._embeddedSWFObjectId;
				/* NOTE: If we're ever allowed to use the SWFFocus class on the Flex side, this is where we'd configure it.
				attributes["class"] = "focus1 focus2"; //Needed for SWFFocus class to work on the Flex side to allow tabbing into/out of Flash plugin. Doesn't seem to require real element id's.
				 */
				
				//Register call back with Flex Ajax Bridge
				var initCallback = dojo.hitch(this, this._faBridgeCallback); //Use hitch so get callback with right scope
				FABridge.addInitializationCallback(this._embeddedSWFObjectId, initCallback);
				
 				//Embed the SWF
				if (this._trace.isFinest()) {
					this._trace.finest("Attempting to embedding SWF for dojo widget = " + this.id + " into replacement DIV = " + this._replacementDivId);
					this._trace.object(this.flashvars);
				}
				
				var swfCallback = dojo.hitch(this, this._swfObjectCallback); //Use hitch so get callback with right scope
				swfobject.embedSWF(this.swfFileName, 
									this._replacementDivId, 
									this._SWF_WIDTH, 
									this._SWF_HEIGHT, 
									this._SWF_MIN_VERSION, 
									this._SWF_INCLUDE_QUICK_INSTALL, 
									this.flashvars, 
									params, 
									attributes, 
									swfCallback);
			} else {
				if (this._trace.isError()) {
					this._trace.error("No swfFileName specified!!", "startup");
				}
			}
			// All ContentPanes must call super on startup( ) so that sizing/layout work
			this.inherited(arguments);
		},
		
		resize: function(/*Object*/ changeSize, /*Object*/ resultSize){
			// summary:
			//		Overridden to ensure we get sized appropriately in FF. 
			// changeSize:
			//		Coming soon
			// resultSize:
			//		Coming soon
			// description:
			//		Overridden to ensure we get sized appropriately. Otherwise, we can end up slightly too
			//		big and get partially cut-off (particularly in FF). (See defect 250945)
			// tags:
			//		protected
			if (resultSize) {
				this.domNode.style.width = resultSize.w + "px";
			}

			//Call super
			this.inherited(arguments);
		},
		
		destroy: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (this._trace.isFinest()) {
				this._trace.entering("destroying " + this.id, "destroy");
			}

			if (this._embeddedSWFObjectId) {
				//Let's try and clean up after ourselves by removing the SWF
				if (this._trace.isFinest()) {
					this._trace.finest("Removing SWF = " + this._embeddedSWFObjectId);
				}
				swfobject.removeSWF(this._embeddedSWFObjectId);
				
				//Let's also try to remove ourselves from FABridge
				delete FABridge.instances[this._embeddedSWFObjectId];
			}

			//Call super
			this.inherited(arguments);
			if (this._trace.isFinest()) {
				this._trace.exiting("destroying for " + this.id, "destroy");
			}
		},
		
		//*******************************************************************************
		// "Public" functions
		//********************************************************************************
		isFlexBridgeInitialized: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			return this._flexBridgeInitialized;
		},
		
		getFlexBridge: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (!this._flexBridge) {
				var bridgeInstance = FABridge.instances[this._embeddedSWFObjectId];
				if (bridgeInstance) {
					this._flexBridge = FABridge.instances[this._embeddedSWFObjectId].root();
				} else {
					if (this._trace.isError()) {
						this._trace.error("Cannot retrieve Flex bridge with id = " + this._embeddedSWFObjectId);
					}
				}
			}
			return this._flexBridge;
		},

		addInitializationCallback: function(/*function*/ callback) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// callback:
			// 		Coming soon
			if (this._flexBridgeInitialized) {
			    callback.call(this);
			    return;
			}

		    if(!this._faBridgeInitCallbacks) {
		        this._faBridgeInitCallbacks = [];
		    }
		    this._faBridgeInitCallbacks.push(callback);
		},
		
		//*******************************************************************************
		// "Private" functions
		//********************************************************************************
		_swfObjectCallback: function(/*Object*/ evt) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// evt:
			//		Coming soon
			// tags:
			//		private
			if (this._trace.isFinest()) {
				this._trace.entering("SWF callback for evt = " + evt.id, "_swfObjectCallback");
			}
			
			if (evt.success) {
				//Need to check this because evt.success seems to be true sometimes even if the ref is undefined (meaning couldn't do the DOM replacement)
				this._trace.finest("SUCCESSFULLY LOADED SWF = " + evt.id, "_swfObjectCallback");
			} else {
				if (this._trace.isError()) {
					this._trace.error("Could not load SWF for " + evt.id, "_swfObjectCallback");
				}
				
				//Display the alternative content div since we couldn't embed the Flash player
				this._fillInReplacementDivOnSWFFailure();
			}
				
			if (this._trace.isFinest()) {
				this._trace.exiting("SWF callback for evt = " + evt.id, "_swfObjectCallback");
			}
		},
		
		_fillInReplacementDivOnSWFFailure: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		private
			var replacementDiv = dojo.byId(this._replacementDivId);
			if (replacementDiv) {
				dojo.style(replacementDiv, {display: "block",
											textAlign: "left"});

				//Create the message for alternative content if embedding SWF fails
				var paragraph = dojo.doc.createElement("p");
				var messageTemplate = this._resources.ADOBE_FLASH_PLAYER_ENSURE_VERSION;
				var minFlashSystemRequirements = this._resources.ADOBE_FLASH_PLAYER_MIN_SYSTEM_REQUIREMENTS;
			    var minFlashVersion = this._resources.ADOBE_FLASH_PLAYER_MIN_VERSION;
				var versionMessage = dojo.string.substitute(messageTemplate,
                        {sysReqLink: "http://www.adobe.com/products/flashplayer/systemreqs/", 
						version:minFlashVersion});
				paragraph.innerHTML = versionMessage;
				
				//Create the link and image for alternative content if embedding the SWF fails 
				var link = dojo.doc.createElement("a");
				link.href = "http://www.adobe.com/go/getflashplayer";
				link.target = "FLASH_DOWNLOAD";
				var image = dojo.doc.createElement("img");
				var pageHost = ((document.location.protocol == "https:") ? "https://" :	"http://"); 
				image.src = pageHost + "www.adobe.com/images/shared/download_buttons/get_flash_player.gif";
				image.alt = this._resources.GET_ADOBE_FLASH_PLAYER;
				image.width = "112";
				image.height = "33";

				//Add paragraph to the replacementDiv
				dojo.place(paragraph, replacementDiv);
				
				//Add image to link and link to the replacementDiv
				dojo.place(image, link);
				dojo.place(link, replacementDiv);
			}
		},
		
		 _faBridgeCallback: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		private
			if (this._trace.isFinest()) {
				this._trace.entering("bridge callback for " + this.id, "_faBridgeCallback");
			}
			
			var flexApp = this.getFlexBridge();
			if (flexApp) {
				if (this._trace.isFinest()) {
					this._trace.finest("Flex Ajax Bridge SUCCESSFULLY initialized for " + this.id, "_faBridgeCallback");
				}
			}
			else {
				if (this._trace.isFinest()) {
					this._trace.error("Flex Ajax Bridge FAILED to initialize for " + this.id, "_faBridgeCallback");
				}
			}
			
			if (this._trace.isFinest()) {
				this._trace.finest("calling initialization call backs for " + this.id, "_faBridgeCallback");
			}
			this._flexBridgeInitialized = true;
			if (this._faBridgeInitCallbacks && this._faBridgeInitCallbacks.length > 0) {
				for (var i = 0; i < this._faBridgeInitCallbacks.length; i++) {
					this._faBridgeInitCallbacks[i].call(this);
				}
				//Clear out the callback data structure
				this._faBridgeInitCallbacks.splice(0, this._faBridgeInitCallbacks.length);
			}
			if (this._trace.isFinest()) {
				this._trace.finest("done calling initialization call backs for " + this.id, "_faBridgeCallback");
				this._trace.exiting("bridge callback for " + this.id, "_faBridgeCallback");
			}
 		}
	});
