/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog");

dojo.require("dijit.dijit");
dojo.require("dijit.Dialog");
dojo.require("dijit.layout.BorderContainer");     // 255183
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("dojox.data.dom");
dojo.require("ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");

ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog");

// 255183
dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit._SearchDialogPluggableView",     
	[dijit.layout.BorderContainer, ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView],
{
    // summary:
    //		An internal class to hold the search results table and the button panel for the search dialog
    // description:
    //		This class is used only to create a border layout pluggable view for the seach dialog contents

    constructor: function() {		
       // summary:
       //		Coming soon
       // description:
       //		Coming soon

       // We don't have a widget def specific to this pluggable view, so let's signal to 
       // super class not to try and load any widget defs on our behalf
       this._usesWidgetDefinition = false;
    },

    setDataset: function(dataset) {
        // summary:
        //		Coming soon
        // description:
        //		Coming soon

        // console.log("!!!!! setDataset called in layoutContainer !!!!!");
        //Call superclass
        this.inherited(arguments);
    },

	 _setDatasetCreatePluggableViews: function() {
        // summary:
        //		Coming soon
        // description:
        //		Coming soon

        // console.log("    !!!!! _setDatasetCreatePluggableViews called in layoutContainer !!!!!");

        // Do not call superclass as this is just a layout container view and does not create its own contents
    }
});

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog",
		[dijit.Dialog, ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView],
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		//***************************
		// "Public"
		//***************************	
		// isCenterInViewEnabled: [public] Boolean
		//		Coming soon
		isCenterInViewEnabled: true,
		
		// isClearSearchEnabled: [public] Boolean
		//		Coming soon
		isClearSearchEnabled: true,
		
		// isCloseSearchEnabled: [public] Boolean
		//		Coming soon
		isCloseSearchEnabled: true,
		
		// hideOnCenterOrHighlight: [public] Boolean
		//		Coming soon
		hideOnCenterOrHighlight: true,
		
		//_dataChangedWhileHidden: [private] Boolean
		//		Coming soon
		_dataChangedWhileHidden: false,
		
		//_isClosed: [private] Boolean
		//		Coming soon
		_isClosed: true,

		//*************************** 
		// "Private"
		//***************************	
	
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
	    _trace: ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog._trace,
	    
       // _layoutContainer: [private]
	    //		Coming soon
       _layoutContainer: null,      // 255183
	    
	    // _itemsTableView: [private]
	    //		Coming soon
	    _itemsTableView: null,

	    // _centerInViewButton: [private]
	    //		Coming soon
	    _centerInViewButton: null,
	    
	    // _highlightButton: [private]
	    //		Coming soon
	    _highlightButton: null,
	    
	    // _centerInViewButton: [private]
	    //		Coming soon
	    _clearSearchButton: null,
	    
	    // _closeSearchButton: [private]
	    //		Coming soon
	    _closeSearchButton: null,
	    
		constructor: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//set title
			this.title =  this.commonResources.SEARCH_TEXT;
			
	        //We don't have a widget def specific to this view, so let's signal to 
	        //super class not to try and load any widget defs on our behalf
			this._usesWidgetDefinition = false;
		},
		
        
		postCreate: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Call superclass
			this.inherited(arguments);
		},

		startup: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			 // 255183
			 // this._itemsTableView.startup();
			 this._layoutContainer.startup();
			 // end 255183
		 
			//254235    IE9,FF4,Safari:Impossible to use the search button                 
			//Bobby, 15Dec11
			//this show causes infinite loop - SearchDialog.startup -> SearchDialog.show -> Dijit.Dialog.show -> SearchDialog.startup			
			//this.show(); 
			
			this.inherited(arguments);	
		},
		
		show: function() {
			//Call superclass
			this.inherited(arguments);
			
			//Refresh the table if data had changed while we were hidden
			if (this._dataChangedWhileHidden && this._itemsTableView) {
				this._itemsTableView.refresh();
			}

			 // 255183 ensure resize on each show
			if (this._itemsTableView) {    
				this._layoutContainer.resize();
				this._itemsTableView.resize();
			}
			 // end 255183
			
			this._isClosed = false;
			this._dataChangedWhileHidden = false;
			
			/*
			 * 254135
			 * The code below is a temporary workaround to
			 * ensure that the focus is not returned to the <object> node that contains the
			 * Flash plugin for the canvas (as that cannot be done with javascript).  Instead
			 * return the focus to the DIV container for the canvas.
			 */
			//Bobby 15Dec11, adding an if check for _savedFocus, since it is not there in dojo 1.6 Dialog
			if(this._savedFocus){ 
				if (this._savedFocus.node.id && this._savedFocus.node.id.indexOf("SWFObject") > 0) {
					this._savedFocus.node = this.managingPluggableView._canvas.domNode;
				}
			}
		},
		
		hide: function() {
			//Remember we're closed
			this._isClosed = true;
			
			//Call super class
			this.inherited(arguments);
		},
	
		destroy: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

            this.inherited(arguments);
		},		
		
		_setDatasetCleanUpAfterLastDataset: function() {
			//Call super
			this.inherited(arguments);
			
			//Forget about any data changes in previous dataset
			this._dataChangedWhileHidden = false;
		},
		
		_setDatasetCreatePluggableViews: function() {
			//See if we've been called before
			if (this._setDatasetCreatePluggableViewsPreviouslyCalled) {
				return;
			}
			
			 // 255183  - create layout container to hold search table
			 this._layoutContainer = new ibm.tivoli.tip.navwidget.topology.dijit._SearchDialogPluggableView({
					id: this.id + "_mySearchDialogView",
					gutters: false,
					parentPluggableView: this
			 }); 
			dojo.style(this._layoutContainer, {width: "100%", height: "100%"});
			 // end 255183
			
			//Do some of our own work
			this._itemsTableView = new ibm.tivoli.tip.navwidget.table.dijit.ItemsTableView({
				id: this.id + "_myTableView",
				parentPluggableView: this._layoutContainer,      // 255183
				region: "center",
				widgetDefinitionId: "DefaultTopologySearchTable"
			});
			dojo.style(this._itemsTableView, {width: "100%", height: "100%"});   // 255183
				
			// 255183
			// Add the table view to the layout container
			this._layoutContainer.addPluggableView(this._itemsTableView);
			// end 255183

			//Register for selection changes
			dojo.connect(this._itemsTableView.selection, "onSelectionChanged", dojo.hitch(this, this._itemsTableViewSelectionHasChanged));
			
			//Make adjustment to dialog size        255183
			//dojo.attr(this._itemsTableView, "style", "height:" + "380px"); 
			dojo.attr(this._layoutContainer, "style", "height:" + "416px");
			//dojo.attr(this, "style", "width:" + "450px");//Bobby:15Dec11, let the dialog resize according to resolution
			dojo.attr(this, "style", "width:" + "450px");
			
			//*********************************
			//Add the buttons div to the dialog
			//*********************************
         // 255183
			var bottomButtonsDiv = dojo.create("div");   
			var bottomPane = new dijit.layout.ContentPane({id:this.id+"_bottomPane", region: "bottom"}, bottomButtonsDiv);		
			dojo.style(bottomPane.domNode,{
						backgroundColor: "#F7F7F7",			
						borderTopColor: "#DEDEDE",
						borderTopStyle: "solid",
						borderTopWidth: "1px",
						padding: "5px 5px 5px 10px"
			});
			// this.containerNode.appendChild(bottomButtonsDiv);
			 // dojo.attr(bottomButtonsDiv, "region", "bottom");
			 this._layoutContainer.addChild(bottomPane); 

			 // Add the border layout with search results table and button panel to the dialog
			 this.addPluggableView(this._layoutContainer); 
			 // end 255183

			//Center button
			if(this.isCenterInViewEnabled){
				this._centerInViewButton = new dijit.form.Button({
					id: this.id+"_centerInViewButton",
					label:this.commonResources.CENTER_IN_VIEW,
					disabled: true
            },bottomPane.domNode.appendChild(dojo.create("div")));    // 255183
				dojo.connect(this._centerInViewButton, "onClick", this, dojo.hitch(this,"_doCenterInView"));
			}

			//Highlight button
			this._highlightButton = new dijit.form.Button({
				id: this.id+"_highlightButton",
				label:this.commonResources.HIGHLIGHT, 
				disabled: true
			 },bottomPane.domNode.appendChild(dojo.create("div")));    // 255183
				dojo.connect(this._highlightButton, "onClick", this, dojo.hitch(this,"_doHighlight"));

			//Clear search button
			if(this.isClearSearchEnabled){
				this._clearSearchButton = new dijit.form.Button({
					id: this.id+"_clearSearchButton",
					label:this.commonResources.CLEAR_SEARCH
            },bottomPane.domNode.appendChild(dojo.create("div")));    // 255183
				dojo.connect(this._clearSearchButton, "onClick", this, dojo.hitch(this,"_doClearSearch"));
			}	
			
			//Close search button
			if(this.isCloseSearchEnabled){
				this._closeSearchButton = new dijit.form.Button({
					id: this.id+"_closeSearchButton",
					label:this.commonResources.CLOSE
            },bottomPane.domNode.appendChild(dojo.create("div")));    // 255183
				dojo.connect(this._closeSearchButton, "onClick", this, dojo.hitch(this,"_doCloseSearch"));
			}
			
			 // 255183
			 this._layoutContainer.startup(); 
			 // end 255183

			//Remember we've been called
			this._setDatasetCreatePluggableViewsPreviouslyCalled = true;
			
			//Let's NOT call superclass
			//this.inherited(arguments);
		},
		
		_addPluggableViewToContainer: function(view) {
			this.containerNode.appendChild(view.domNode);
		},
		
		_removePluggableViewFromContainer: function(view) {
			this.containerNode.removeChild(view.domNode);
		},
		
		_datasetEventListenerCallback: function (/*Object*/ listenerObj, /*Object*/ event) {			
			//call super to do the rest of the event dispatching
			this.inherited(arguments);
			
			//Remember data changed while we were hidden
			if (this._isClosed) {
				this._dataChangedWhileHidden = true;
			}
		},
		
		//selection changed callback
		_itemsTableViewSelectionHasChanged: function(selection) {
			if (selection.getItemCount() > 0) {
				if (this._centerInViewButton) {
					this._centerInViewButton.setDisabled(false);
				}
				
				if (this._highlightButton) {
					this._highlightButton.setDisabled(false);
				}
			} else {
				if (this._centerInViewButton) {
					this._centerInViewButton.setDisabled(true);
				}
				
				if (this._highlightButton) {
					this._highlightButton.setDisabled(true);
				}
			}
		},
		
		_doClearSearch: function(){	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Tell topo view to remove hightlights
			this.managingPluggableView.clearAllHighlights();		

			//Want clear out search on the ItemsTableView as well
			this._itemsTableView.setFilter(null);
		},
		
		_doHighlight: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// grid:
			//		Coming soon

			//Highlight objects
			this.managingPluggableView.setHighlightedObjectIds(this._itemsTableView.selection.getItemIds(), this._itemsTableView.selection.getLinkIds(), 
					this._itemsTableView.selection.getRelationshipIds());			

			if (this.hideOnCenterOrHighlight) {
				this.hide();
			}
		},
		
		_doCenterInView: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//Center
			this.managingPluggableView.setZoomTo(this._itemsTableView.selection.getItemIds(), this._itemsTableView.selection.getLinkIds(), 
					this._itemsTableView.selection.getRelationshipIds(), 1.5); 
			
			//Highlight too
			this.managingPluggableView.setHighlightedObjectIds(this._itemsTableView.selection.getItemIds(), this._itemsTableView.selection.getLinkIds(), 
					this._itemsTableView.selection.getRelationshipIds());	
			
			if (this.hideOnCenterOrHighlight) {
				this.hide();
			}
		},
		
		_doCloseSearch: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			this.hide();
		}
});