/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.TopologyDateLabel");

// author: Karol Romanowski
dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.TopologyDateLabel",
            [ dijit._Widget, dijit._Templated ],
{		
	// summary:
	//		A Label for adding labels to the toolbar.
	// description:
	//		Coming soon
	
	// labelFor: [public] String
	labelFor: "",
	
	// labelText: [public] String
	labelText: "",
	
	
	// templateString: [public] String 
	// added float:right for the date to appear right side
	templateString:"<label for=\"${labelFor}\" dojoAttachPoint=\"containerNode\" >${labelText} </label>\n",

   postCreate: function() {          // 255810
      // If labelFor was not specified on the constructor, then this label is not labeling some other
      // form control, so remove the "for" attribute to not leave a dangling reference.  For WCAG rules
      if (this.labelFor.length == 0) {
         dojo.removeAttr(this.domNode, "for");
      }
   },
	
	setLabelText: function(/*String*/ content){
        		// summary:
        		//		Deprecated.  Use attr('labelText', ...) instead.
        		this.attr("labelText", content);
   },

   _setLabelTextAttr: function(/*String*/ content){
        		// summary:
        		//		Hook for attr('labelText', ...) to work.
        		// description:
        		//		Set the label (text) of the label; takes an HTML string.
        		this.containerNode.innerHTML = this.labelText = content;
    }		
});
