/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.require("dijit.Toolbar");
dojo.require("dijit.form.ToggleButton");
dojo.require("dijit.ToolbarSeparator");
dojo.require("dojo.date.locale");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyLabel");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyDateLabel");

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.TopologyFilterRow");

ibm.tivoli.tip.navwidget.topology.dijit.TopologyFilterRow._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dijit.TopologyFilterRow");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.TopologyFilterRow",
            [ dijit._Widget, dijit._Templated ],
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	// widgetsInTemplate: [public] Boolean
	//		Coming soon
	widgetsInTemplate: true,
	
	// topology: [public] Object
	//		Coming soon
	topology: null,
	
	// createStatusFilters: [public] Boolean
	//		Coming soon
	createStatusFilters: true,
	
	// region: [public] String
	//		Coming soon
	region: "bottom",
	
	
	/* added for the filter footer */ 

	// filteredItemCount: [public] Integer
	// 	The filtered items count
	filteredItemCount: 0,
	
	// _filterCursor: [private] Integer
	//		Coming soon	
	_filterCursor: 0,

	// _trace: [private] ibm.tivoli.navmodel.Trace
	//		Utility for trace and logging
	_trace: ibm.tivoli.tip.navwidget.topology.dijit.TopologyFilterRow._trace,
	
	_filterButtons: null,
	_footerComponents: null,
	
	// templateString: [public] String
	//		Coming soon
	templateString: "<div class=\"topologyToolbar dijitToolbar\" width=\"100%\">" +
					"	<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" height=\"40px\" role=\"presentation\">" +
					"		<tbody>" +
					"			<tr valign=\"center\">" +
					"				<td width=\"100%\" height=\"22px\">" +
					"					<span dojoAttachPoint=\"filterBar\"></span>" +
					"				</td>" +
					"			</tr>" +
					"			<tr valign=\"center\">" +
					"				<td width=\"100%\" style=\"background-color:#F6F6F6;border-top:1px solid #E6E6E6\">" +
					"					<span dojoAttachPoint=\"footerBar\" ></span>" +
					"				</td>" +
					"			</tr>" +
					"		</tbody>" +
					"</table></div>",
	
	//Base constructor
	constructor: function () {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		this._filterButtons = [];
		this._footerComponents = [];
	},		
	
	postCreate: function()
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
	    //NLS
		this._resources = dojo.i18n.getLocalization("ibm.tivoli.tip.navwidget", "resources");
		this._filters=[];
		this._statusFilters=[];
		if(this.createStatusFilters){
			this.rebuildStatusFilters();
		} else {
			this._addCustomFilters();
		}
		// fill the footer with the various count values
		this.fillTheFooter();
	},

	_fillTheBarWithFiltersError: function(/*Object*/ error, /*Object*/ exception, /*Object*/ ioArgs){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// error:
		//		Coming soon
		// exception:
		//		Coming soon
		// ioArgs:
		//		Coming soon

		//Give the user some feedback
        	this.topology.displayException(error);
		
		this._addCustomFilters();
	},
	
	/*=====
	fillTheBarWithFilters_kwArgs: function() {
	
	},
	=====*/
	
	_fillTheBarWithFilters: function(/*Object[]*/ itemStatuses, /*fillTheBarWithFilters_kwArgs*/ kwArgs){				
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		for(i in itemStatuses){
			this._statusFilters.push({
				filterOn: "status",
				value: itemStatuses[i].getValue(),
				label: {
					value: itemStatuses[i].getLabel()
				},
				isSet: false,
				image: itemStatuses[i].getImage()
			});
			
		}

		// fill the filter bar with the standard filters
		for(i in this._statusFilters){
			this.addFilter(this._statusFilters[i]);
		}
		
		this._addCustomFilters();
		
		//deal with anything that was pending while we were building the filters
		if (this._rebuildingFilters) {
			this._rebuildingFilters = false;
			
			if (this._rebuildingFiltersPendingFiltersToCheck) {
				for (var i = 0; i < this._rebuildingFiltersPendingFiltersToCheck.length; i++) {
					this.setCheckedFilter(this._rebuildingFiltersPendingFiltersToCheck[i]);
				}
				this._rebuildingFiltersPendingFiltersToCheck = null;
			}
		}
	},
	
	_addCustomFilters: function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		if(this.topology){
			if(this.topology.widgetDefinition){
				var customFilters = this.topology.widgetDefinition.getFilters();
				if(customFilters){
					for(i in customFilters){
						this.addFilter(customFilters[i]);
					}
				}
			}
		}						
	},
	
	addFilter: function(/*Filter*/ filter){		
		// summary:
		//		Adds a filter to the filter row.
		// description:
		//		Coming soon
		// filter:
		//		Coming soon
		this._filters.push(filter);
		var filterIndex = this._filters.length-1;
		if(filterIndex == this._statusFilters.length && this._statusFilters.length!=0){
			this._addToFilterBar(new dijit.ToolbarSeparator() ,this._filterCursor++);
		}
		
		var button = new dijit.form.ToggleButton({
			id: this.id + "_filter_" + filterIndex,
			iconClass: filter.iconClass ? filter.iconClass : "topoFilterIcon",
			label: filter.label.value,
			checked: filter.isSet,
			showLabel: false,
			filter: filter
		});
					
		if(filter.image){
			button.iconNode.style.backgroundImage = "url('"+this.topology._cleanUpImagePath(filter.image)+"')";			
		}
		
		if(filter.isSet){
			this.topology.applyFilter(this._filters[filterIndex]);
		}
		
		dojo.connect(button,"onClick", this, dojo.hitch(this, function(button) {
 			if(button.checked){
				this.topology.applyFilter(this._filters[filterIndex]);
			} else {
				this.topology.clearFilter(this._filters[filterIndex]);
			}
		},button));
		
		this._addToFilterBar(button,this._filterCursor++);
	},
	
	rebuildStatusFilters: function() {
		//Remove any previously added filters
		dojo.empty(this.filterBar);
		for (var j = 0; j < this._filterButtons.length; j++) {
			this._filterButtons[j].destroyRecursive();
		}
		this._filters = [];
		this._filterButtons = [];
		this._statusFilters = [];
		
		//Fill in the filters
		if (this.topology.dataset) {
			this._rebuildingFilters = true;
			this.topology.dataset.getStatuses({
				type: "item",
				widgetDef: this.topology.widgetDefinition,
				onComplete: dojo.hitch(this, this._fillTheBarWithFilters),
				onError: dojo.hitch(this, this._fillTheBarWithFiltersError)
			});
		} else {
			this._addCustomFilters();
		}
	},
	
	uncheckAllFilters: function() {
		for (i = 0; i < this._filterButtons.length; i++) {
			element = this._filterButtons[i];
			element.attr("checked", false);
		}
	},
	
	setCheckedFilter: function(filter) {
		if (filter) {
			if (this._rebuildingFilters) {
				if (!this._rebuildingFiltersPendingFiltersToCheck) {
					this._rebuildingFiltersPendingFiltersToCheck = [];
				}
				this._rebuildingFiltersPendingFiltersToCheck.push(filter);
			}
			
			for (i = 0; i < this._filterButtons.length; i++) {
				var button = this._filterButtons[i];
				if (button.filter && (button.filter.value === filter.value)) {
					button.attr("checked", true);
					break;
				}
			}
		}
	},
	
	fillTheFooter: function(selectedCount) {
		// summary:
		//	Fills the footer bar with the counts
		// description:
		//	Fills the footer bar with the counts			
			var counts = {items: 0, links: 0, relationships: 0};
			this._getCounts(this.topology.dataset, counts);
			var itemCount = counts.items;
			var linkCount = (this.topology.widgetDefinition.getRenderRelationshipsInsteadOfLinks() ? counts.relationships : counts.links);
			var selectedCount = this.topology.selection.getTotalSelected();			
			this.addFooterRow(itemCount, linkCount, selectedCount);
	},

	_getCounts: function(dataset, counts) {
		counts.items = 0;
		counts.links = 0;
		counts.relationships = 0;
		
		if (dataset) {
			counts.items += dataset.getItemCount();
			counts.links += dataset.getLinkCount();
			counts.relationships += dataset.getRelationshipCount();
		}
	},
	
	_isRightToLeft: function() {
		var dir = dojo.query("body").attr("dir");
		if (dir) return dir == "rtl";
		return false;
	},
		
		
		
		addFooterRow: function(resCount, relCount, selCount){
			// summary:
			//		Adds a footer count to the footer row.
			// description:
			//		Coming soon
			// resCount, relCount, selCount:
			//		Different count values to be updated on the footer bar
					
			// the total items or links selected
			
				// substitution 
				var selectedCountLabel=this._resources.SELECTED_COUNT;
				var selectedCountValue=selCount;
				var selectedCount=dojo.string.substitute(selectedCountLabel, {value1:selectedCountValue});
			
				var resourcesCountLabel=this._resources.RESOURCES_COUNT;
				var resourcesCountValue=resCount;
				var resourcesCount=dojo.string.substitute(resourcesCountLabel,{value2:resourcesCountValue});
				
				var relationshipsCountLabel=this._resources.RELATIONSHIP_COUNT;
				var relationshipsCountValue=relCount;
				var relationshipsCount=dojo.string.substitute(relationshipsCountLabel,{value3:relationshipsCountValue});
				
				var filteredCountLabel=this._resources.FILTERED_COUNT;
				var filteredCountValue=this.filteredItemCount;
				var filteredCount=dojo.string.substitute(filteredCountLabel,{value4:filteredCountValue});
				
				// the date , changed to take care of the localization
				var date=dojo.date.locale.format( new Date(),{selector:['date'],formatLength:'short'});
			
				// the time, changed to take care of the localization
				var time=dojo.date.locale.format( new Date(),{selector:['time'],formatLength:'medium'});
				
				var dir = this._isRightToLeft();
				
				// adds the label to the footer
				var footerLabel = new ibm.tivoli.tip.navwidget.topology.dijit.TopologyLabel ( {
						id: this.topology.id + "_footer"+"_label",
						labelText: dir ? filteredCount+" "+relationshipsCount+" "+resourcesCount+" "+selectedCount
								: selectedCount+" "+resourcesCount+" "+relationshipsCount+" "+filteredCount			
				}); 
				footerLabel._setStyleAttr({"float": dir ? "right" : "left"});

				// order needs to be maintained to keep both the labels aligned on the same line
				this._addToFooterBar(footerLabel,0);
				
				var hideDateTime = false; 
				if(this.topology){
					if(this.topology.widgetDefinition){
						hideDateTime = this.topology.widgetDefinition.getHideFooterDateTime();
					}
				}				
				if(!hideDateTime){
					// adds the date label to the extreme right
					var dateLabel= new ibm.tivoli.tip.navwidget.topology.dijit.TopologyDateLabel ( {
						    id: this.topology.id + "_footer"+"_dateLabel",
							labelText: date+" "+time
						});
					dateLabel._setStyleAttr({"float": dir ? "left" : "right"});
					this._addToFooterBar(dateLabel);  // force to be the last child
				}				
				
		},
		
	_addToFilterBar: function(item, position){
		var itemTD = dojo.doc.createElement("span"); 
		dojo.style(itemTD, "width", "1px"); 
		dojo.place(itemTD, this.filterBar, parseInt(position));
		itemTD.appendChild(item.domNode);
		this._filterButtons.push(item);
	},						
			
	_addToFooterBar: function(item, position){
		var itemTD = dojo.doc.createElement("span"); 
		dojo.style(itemTD, "width", "1px"); 
		if (position == null) {
			dojo.place(itemTD, this.footerBar);			
		}
		else {
			dojo.place(itemTD, this.footerBar, parseInt(position));			
		}
		itemTD.appendChild(item.domNode);
		this._footerComponents.push(item);
	},	
	
	destroyRecursive: function()
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		//Destroy filter elements
		if (this._filterButtons) {
			for (i = 0; i < this._filterButtons.length; i++) {
				element = this._filterButtons[i];
				element.destroyRecursive();
			}
			this._filterButtons = null;
		}
		
		//Destroy footer statistics elements
		if (this._footerComponents) {
			for (i = 0; i < this._footerComponents.length; i++) {
				element = this._footerComponents[i];
				element.destroyRecursive();
			}
			this._footerComponents = null;
		}
		
		this._filters = null;
		this._filterButtons = null;
		this._statusFilters = null;
		
		this.inherited( arguments );
	},
  
	destroy: function()
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this.inherited( arguments );
	},
	
	addChild: function(/*Object*/ element)
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// element:
		//		Coming soon
		this.footer.addChild(element);
	},
	
	resize: function(/*Object*/ changeSize, /*Object*/ resultSize){
		// summary:
		//		Overridden to ensure we get sized appropriately in FF. 
		// changeSize:
		//		Coming soon
		// resultSize:
		//		Coming soon
		// description:
		//		Overridden to ensure we get sized appropriately. Otherwise, we can end up slightly too
		//		big and get partially cut-off (particularly in FF). (See defect 250945)
		// tags:
		//		protected
		if (resultSize) {
			this.domNode.style.width = resultSize.w + "px";
		}

		//Call super
		this.inherited(arguments);
	}
});
