/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer");

dojo.require("ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip");
dojo.require("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu");
dojo.require("ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper");
dojo.require("ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookGeneralTab");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("ibm.tivoli.navmodel.Selection");
dojo.require("ibm.tivoli.navmodel.Trace");

ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer",null,
	{
	
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	// contextMenu: [public] Object
	//		Coming soon
	contextMenu: null,

	//*******************************************************************************
	// "Private"
	//********************************************************************************
	
	// _trace: [private] ibm.tivoli.navmodel.Trace
	//		Utility for trace and logging
	_trace: ibm.tivoli.tip.navwidget.topology.dijit.TopologyMenuLayer._trace,
	
	// _topologyContainer: [private] Object
	//		Coming soon
	_topologyContainer: null,
	
	// _flexBridge: [private] Object
	//		Coming soon
	_flexBridge: null,
	
	// _layerDiv: [private] Object
	//		Coming soon
	_layerDiv: null,
	
	// _cmProvider: [private] Object
	//		Coming soon
	_cmProvider: null,
	
	// _daHelper: [private] Object
	//		Coming soon
	_daHelper: null,
	
	// _cMenu: [private] Object
	//		Coming soon
	_cMenu: null,
	
	// _mouseConnectionHandles: [private] Object[]
	//		Coming soon
	_mouseConnectionHandles: null,
	
	// _rightButtonTargetCache: [private] Object
	//		Coming soon
	_rightButtonTargetCache: null,
	
	// _rolloverTarget: [private] Object
	//		Coming soon
	_rolloverTarget: null,
	
	// _tooltip: [private] Object
	//		Coming soon
	_tooltip: null,
	
	// _tooltipProperties: [private] Object
	//		Coming soon
	_tooltipProperties: null,
	
	// _propOnSetObjectsConnection: [private] Object
	//		Coming soon
	_propOnSetObjectsConnection: null,
	
	// _propOnSetDatasetConnection: [private] Object
	//		Coming soon
	_propOnSetDatasetConnection: null,
	
	// _activatedForMenu: [private] Boolean
	//		Coming soon
	_activatedForMenu: false,
	
	// _forceMenuOnMouseUp: [private] Boolean
	//		Coming soon
	_forceMenuOnMouseUp: false,
	
	// _menuCloseHandle: [private] Object
	//		Coming soon
	_menuCloseHandle: null,
	
	// _openingNewMenu: [private] Boolean
	//		Coming soon
	_openingNewMenu: false,
	
	// _cxtMenuEvt: [private] Object
	//		Coming soon
	_cxtMenuEvt: null,
	
	// _loadingMenuId: [private] String
	//		Coming soon
	_loadingMenuID: "LOADING_ID",
	
	// _layerIDSuffix: [private] String
	//		Coming soon
	_layerIDSuffix: "_menuLayer",
	
	constructor: function (/*Object*/ container, /*Object*/ cmProvider, /*Object*/ daHelper) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// container:
		//		Coming soon
		// cmProvider:
		//		Coming soon
		// daHelper:
		//		Coming soon
		if (this._trace.isFinest()) {
			this._trace.entering(">> In layer constructor", "constructor");
		}
		
		//Initialize data structure for handles
		this._mouseConnectionHandles = [];
		
		if (container) {
			this._topologyContainer = container;
			
	        // add layered div above the topology container
	        var containerBox = dojo.marginBox(container.domNode);
	        if (this._trace.isFinest()) {
				this._trace.finest("   container size w=" + containerBox.w + " h=" + containerBox.h, "constructor");
	        }
	        this._layerDiv = dojo.doc.createElement("div");
	        this._layerDiv.id = container.id + this._layerIDSuffix;
	        this._layerDiv.rolloverTargetRect = null;
	        // initially create the DIV with "visibility: hidden" so it acts as if it is not there
	        dojo.style(this._layerDiv, {position: "absolute",
	        						top: "0px",
	        	                    left: "0px",
	        	                    width: "100%",
	        	                    height: "100%",
	        	                    padding: "0",
	        	                    border: "0",
	        	                    zIndex: "5",
	        	                    visibility: "hidden",
	        	                    //In IE, the div doesn't seem to actually sit over top of Flash unless the background color is set. So, set background
	        	                    //to white and set the opacity to 0 to make transparent.
	        	                    background: "#ffffff",
	        	                    opacity: "0"});
	        container.domNode.appendChild(this._layerDiv);
	        this._flexBridge = container.getFlexBridge();

	        // Use the supplied context menu provider if passed in
	        if (cmProvider) {
	        	this._cmProvider = cmProvider;
	        }
	        else {
		        // create a default context menu provider
	            var helper = new ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper();
		        this._cmProvider = new ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider(
		        			{
		        				view: this,
		        				getMenuItemsCallback: dojo.hitch(helper, helper.getMenuItems),
		        				getMenuCommandCallback: dojo.hitch(helper, helper.getMenuCommand)
		        			}
		        		);	        	
	        }

	        // create the context menu using the provider
	        this._cMenu = new ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu({cmProvider: this._cmProvider});
	        
	        //create the defaultActionHandler if defined
	        // Use the supplied default action handler if passed in
	        if (daHelper) {
	        	this._daHelper = daHelper;
	        }
	        	        
	        // create tooltip
	        this._tooltip = new ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip({connectId: [ this._layerDiv.id ],
	                                                                                 getCustomContentCallback: dojo.hitch(this, this._customTooltip)
											//position : ["after", "below"]

										});
	        
	        // Override the tooltip behavior specifically for topology
	        dojo.safeMixin(this._tooltip, {
	        	
	           // Override open to set tooltip position over the menu layer DIV near the node or link
	           open: function(target) {
	        	  // (temporary coordinates until flex bridge can supply mouse position)
	        	  // Create a rectangle for positioning the tooltip, otherwise default
	        	  // position is outside the DOM node of the menu layer DIV
	              var aroundRect = target.rolloverTargetRect;
	              
	              // make sure the rolloverTargetRect has been set to actally display the tooltip
	              // (it may not be if we got a rollover while the context menu is displayed)
	              if (aroundRect != null) {
		              // replace the target node, the menu layer DIV, with this rectangle
		              arguments[0] = aroundRect;
		              this.inherited(arguments);
	              }
	           },
	           _onTargetMouseEnter: function(e) {
	        	   // ignore since menu layer div is not the real target (we handle the tooltip)
	           },
	           _onTargetMouseLeave: function(e) {
	        	   // ignore since menu layer div is not the real target (we handle the tooltip)
	           },
	           _onTargetBlur: function(e) {
	        	   // ignore since menu layer div is not the real target (we handle the tooltip)
	           },
	           _onTargetFocus: function(e) {
	        	   // ignore since menu layer div is not the real target (we handle the tooltip)
	           },
	           // added helper method to trigger the timer to display the tooltip
	           hover: function(target) {
	               this._onHover({target: target});
	           },
	           // added helper method to dismiss the tooltip
	           unHover: function(target) {
	               this._onUnHover({target: target});
	           }	           
	        });
	        this._tooltip.startup();
          
	        // Register window-level mousedown handler to catch potential right-clicks before
	        // they get to the DOM
	        this._rightButtonTargetCache = container.id;
	        if (dojo.isIE) {
	        	// set up mouse handlers on mouse up and mouse down to check for right click events
	        	// and a handler on the document for oncontextmenu so it can be stopped if on the Flash canvas
				this._mouseConnectionHandles.push(dojo.connect(this._topologyContainer.domNode, "onmousedown", this, function(evt) {this._menuLayerHandlerIE(evt);}));
				this._mouseConnectionHandles.push(dojo.connect(this._topologyContainer.domNode, "onmouseup", this, function(evt) {this._topologyContainer.domNode.releaseCapture();}));
				this._mouseConnectionHandles.push(dojo.connect(dojo.doc, "oncontextmenu", 
															   this, function(evt) {
																			var swfSuffixPos = evt.srcElement.id.indexOf("_embeddedSWFObjectId");
																			if ( swfSuffixPos > 0) {
																				// since this event is caught at the document level, find
																				// the actual canvas related to the Flash canvas
																				var actualCanvas = dijit.byId(evt.srcElement.id.substring(0, swfSuffixPos));
																				actualCanvas._menuLayer._activateLayerDiv(true);
																				actualCanvas._menuLayer._processContextMenu(evt);
																				return false;
																			} else {
																				this._rightButtonTargetCache = "nan";
																			}					
																}));
	        }
	        else {  // Firefox and other browsers
	        	// add mousedown listener to window to filter all right mousedown events
		        dojo.global.addEventListener("mousedown", dojo.hitch(this, this._menuLayerHandler), true);	        	
	        }
	        
	        //Register for object doubleClick/rollOver/rollOut events
	        dojo.connect(this._topologyContainer, "onObjectDoubleClick", this, this._objectDoubleClickHandler);
	        dojo.connect(this._topologyContainer, "onObjectRollOver", this, this._objectRollOverHandler);
	        dojo.connect(this._topologyContainer, "onObjectRollOut", this, this._objectRollOutHandler);
	        dojo.connect(this._topologyContainer, "_onPanStart", this, this._canvasPanStartHandler);
	        dojo.connect(this._topologyContainer, "_onPanEnd", this, this._canvasPanEndHandler);
		        
	        /* These are the different MouseEvent types in ActionScript (the ones currently sending on from div are marked)
		        
			**CLICK : String = "click"
				[static] Defines the value of the type property of a click event object. MouseEvent 
     		**CONTEXT_MENU : String = "contextMenu"
				[static] The MouseEvent.CONTEXT_MENU constant defines the value of the type property of a contextMenu event object. MouseEvent 
    		**DOUBLE_CLICK : String = "doubleClick"
				[static] Defines the value of the type property of a doubleClick event object. MouseEvent 
     		MIDDLE_CLICK : String = "middleClick"
				[static] Defines the value of the type property of a middleClick event object. MouseEvent 
     		MIDDLE_MOUSE_DOWN : String = "middleMouseDown"
				[static] Defines the value of the type property of a middleMouseDown event object. MouseEvent 
     		MIDDLE_MOUSE_UP : String = "middleMouseUp"
				[static] Defines the value of the type property of a middleMouseUp event object. MouseEvent 
	    	**MOUSE_DOWN : String = "mouseDown"
				[static] Defines the value of the type property of a mouseDown event object. MouseEvent 
	    	**MOUSE_MOVE : String = "mouseMove"
				[static] Defines the value of the type property of a mouseMove event object. MouseEvent 
	    	**MOUSE_OUT : String = "mouseOut"
				[static] Defines the value of the type property of a mouseOut event object. MouseEvent 
	    	**MOUSE_OVER : String = "mouseOver"
				[static] Defines the value of the type property of a mouseOver event object. MouseEvent 
	    	**MOUSE_UP : String = "mouseUp"
				[static] Defines the value of the type property of a mouseUp event object. MouseEvent 
	    	**MOUSE_WHEEL : String = "mouseWheel"
				[static] Defines the value of the type property of a mouseWheel event object. MouseEvent 
	     	RIGHT_CLICK : String = "rightClick"
				[static] Defines the value of the type property of a rightClick event object. MouseEvent 
	     	RIGHT_MOUSE_DOWN : String = "rightMouseDown"
				[static] Defines the value of the type property of a rightMouseDown event object. MouseEvent 
	     	RIGHT_MOUSE_UP : String = "rightMouseUp"
				[static] Defines the value of the type property of a rightMouseUp event object. MouseEvent 
	    	ROLL_OUT : String = "rollOut"
				[static] Defines the value of the type property of a rollOut event object. MouseEvent 
	    	ROLL_OVER : String = "rollOver"
				[static] Defines the value of the type property of a rollOver event object. MouseEvent 
	        */
	        
	        // Register to listen for the different mouse events of importance
			this._mouseConnectionHandles.push(dojo.connect(this._layerDiv, "onclick", this, function(evt) {this._processClick(evt);}));
			this._mouseConnectionHandles.push(dojo.connect(this._layerDiv, "oncontextmenu", this, function(evt) {this._processContextMenu(evt);}));
			this._mouseConnectionHandles.push(dojo.connect(this._layerDiv, "ondblclick", this, function(evt) {this._processDoubleClick(evt);}));
			this._mouseConnectionHandles.push(dojo.connect(this._layerDiv, "onmousedown", this, function(evt) {this._processMouseDown(evt);}));
			this._mouseConnectionHandles.push(dojo.connect(this._layerDiv, "onmousemove", this, function(evt) {this._processMouseMove(evt);}));
			this._mouseConnectionHandles.push(dojo.connect(this._layerDiv, "onmouseout", this, function(evt) {this._processMouseOut(evt);}));
			this._mouseConnectionHandles.push(dojo.connect(this._layerDiv, "onmouseover", this, function(evt) {this._processMouseOver(evt);}));
			this._mouseConnectionHandles.push(dojo.connect(this._layerDiv, "onmouseup", this, function(evt) {this._processMouseUp(evt);}));
			this._mouseConnectionHandles.push(dojo.connect(this._layerDiv, "onmousewheel", this, function(evt) {this._processMouseWheel(evt);}));
			
			if (this._trace.isFinest()) {
				this._trace.exiting(">> In layer constructor", "constructor");
			}
		}
	},
	
	destroy: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		dojo.forEach(this._mouseConnectionHandles, function(h) {dojo.disconnect(h);});
		this._mouseConnectionHandles = [];
		
		if (this._tooltip) {
			this._tooltip.removeTarget(this._layerDiv.id);
			this._tooltip.destroyRecursive();
		}
		
		// Remove window level listener (IE specific ones were removed above from 
		// _mouseConnectionHandles
		if (!(dojo.isIE)) {
			/*
			try {
				dojo.global.addEventListener("mousedown", null, true); //MAA TODO: This seems to die so added try/catch for now.
			} catch (ex) {
				if (this._trace.isError()) {
					var methodName = "destroy";
					this._trace.error("problem destroying " + this._layerDiv.id + "; " + ex, methodName);
				}
			}
			*/
			dojo.global.removeEventListener("mousedown", dojo.hitch(this, this._menuLayerHandler), true);			
		}
	},
	
	getRolloverTarget: function() {
		// summary:
		//		Returns the graph entity under the mouse cursor in the topology container
		// description:
		//		This accessor returns the item (node), link, or relationship under the mouse
		//      cursor in the topology graph.  This can be used when overriding what is
		//      displayed in the tooltip for the entity.
		return this._rolloverTarget;
	},

	getTooltip: function() {
		// summary:
		//		Returns the tooltip instance used for the topology container.
		// description:
		//		This accessor returns the ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip instance
		//      used to display tooltips for all entities in the topology graph.
		return this._tooltip;
	},
	
	_menuLayerHandler: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		
		// Is this a mouse button 2 down event?
		if (dojo.mouseButtons.isRight(evt)) {
			if(this._cmProvider.viewWithToolbar){
				this._cmProvider.viewWithToolbar.setPostponeToolbarTasksRefresh(true);
			}
			var nodeId = evt.target.id;
			var swfSuffixPos = nodeId.indexOf("_embeddedSWFObjectId");
			var layerSuffixPos = nodeId.indexOf(this._layerIDSuffix);
			var actualCanvas = null;

			if (swfSuffixPos > 0) { // Is it over the Flex canvas?
				// console.log("### right click is over Flex canvas");
				// console.dir(evt);
				actualCanvas = dijit.byId(nodeId.substring(0, swfSuffixPos));
	            actualCanvas._menuLayer._forceMenuOnMouseUp = true;  // flag it as caught by window event handler
				actualCanvas._menuLayer._activateLayerDiv(true);  // flag it as being activated for the menu
				actualCanvas._menuLayer._processMouseDown(evt);
				dojo.stopEvent(evt);
	        } else if (layerSuffixPos > 0) { // Is it over the "visible" menu layer DIV?
	        	// let it go through
	        	// console.log("### right click is over menu layer");
	        	actualCanvas = dijit.byId(nodeId.substring(0, layerSuffixPos));
	        	if (actualCanvas._menuLayer._cMenu.getMenu()) {
	                // If we currently have a menu displayed, it will be dismissed, but
	                // set flag so we do not deactivate the DIV layer
	                actualCanvas._menuLayer._openingNewMenu = true;
	            }
	         	// console.dir(evt);	         	
	        } else { // It is over some other element, ignore it
	        	// let it go through
	         	// console.log("### right click is NOT over topology");
	         	// console.dir(evt);
	        }
	    } else {
	    	if(this._cmProvider.viewWithToolbar){
	    		this._cmProvider.viewWithToolbar.setPostponeToolbarTasksRefresh(false);
	    	}
	    }
	 },
	 
	 _menuLayerHandlerIE: function(/*Object*/ evt) {
		 // summary:
		 //		Coming soon
		 // description:
		 //		Coming soon
		 // evt:
		 //		Coming soon
		 if (dojo.mouseButtons.isRight(evt)) {
			 if(this._cmProvider.viewWithToolbar){
				 this._cmProvider.viewWithToolbar.setPostponeToolbarTasksRefresh(true);
			 }
			 var flashCanvasId = this._topologyContainer.id + "_embeddedSWFObjectId";
			 if (evt.srcElement.id && evt.srcElement.id == flashCanvasId && this._rightButtonTargetCache == flashCanvasId) {
				 this._processMouseDown(evt); 
			 }
			 this._topologyContainer.domNode.setCapture();
			 if (evt.srcElement.id) {
				 this._rightButtonTargetCache = evt.srcElement.id;
			 }
		 } else {
			 if(this._cmProvider.viewWithToolbar){
				 this._cmProvider.viewWithToolbar.setPostponeToolbarTasksRefresh(false);
			 }
		 }
	 },

	
    _closeMenu: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		 
		// close a context menu if it is open
		var menu = this._cMenu.getMenu();
		if (menu) {
			// Clear the focus, otherwise IE has problems on _onBlur
			menu.focusedChild = null;
			dijit.popup.close(menu);			
	    }
	},
	
	_isMenuOpen: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		return (this._cMenu.getMenu()) ? true : false;
	},
	
	_activateLayerDiv: function(/*Object*/ isRightClick) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// isRightClick:
		//		Coming soon
		this._activatedForMenu = isRightClick;
		if (dojo.style(this._layerDiv, "visibility") == "hidden") {
	        //console.log("   >>> activating layer");
			dojo.style(this._layerDiv, "visibility", "visible");
		}
	},
	
	_deactivateLayerDiv: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		if (dojo.style(this._layerDiv, "visibility") == "visible") {
			this._activatedForMenu = false;
	        this._forceMenuOnMouseUp = false;
			//console.log(">>> deactivating layer");
			dojo.style(this._layerDiv, "visibility", "hidden");
		}		
	},
		
	_processClick: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		
		// just for debug to see (x,y) before passing to flex bridge
		if (this._trace.isFinest()) {
			this._trace.finest("*** layer detected CLICK: x=" + evt.layerX + " y=" + evt.layerY);
		}
		
		// NOTE: *no* need pass event on to canvas flex bridge here

		//Close the menu 
		//  (not needed here as we handle now on mousedown)
		// this._closeMenu();
		// this._closeTooltip();
		// this._deactivateLayerDiv();
		
		//Stop propagation of the event
		dojo.stopEvent(evt);
	},
	
	_processContextMenu: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		
		// just for debug to see (x,y) before passing to flex bridge
		if (this._trace.isFinest()) {
			this._trace.finest("*** layer detected CONTEXT_MENU: x=" + evt.layerX + " y=" + evt.layerY);
		}
		
	    this._activatedForMenu = true;
	    this._closeTooltip();
	    if (this._forceMenuOnMouseUp) { // if initiated by window event handler, clear it here
	    	this._forceMenuOnMouseUp = false;
	    }
		
	    // Copy (only on IE versions less than IE9 or if using quirks mode) and cache the event
	    this._cxtMenuEvt = (dojo.isIE < 9 || (dojo.isIE && dojo.isQuirks)) ? dojo.mixin({}, evt): evt;   // 254234
	    
		var flexBridgeCallback = function(objectContext) {
			//Get the selected items for menu context
			if (this._trace.isFinest()) {
				this._trace.finest("****** after right-click the selection for canvas = " + this._topologyContainer.id + "; itemIds = " +
						dojo.toJson(objectContext.getItemIds()) + 
							", linkIds = " + dojo.toJson(objectContext.getLinkIds()) +
							", relationshipIds = " + dojo.toJson(objectContext.getRelationshipIds()));
			}
			
		    // If a context menu is already open, close it because the selected context is likely different
			if (this._cMenu.getMenu()) {
				this._openingNewMenu = true;
				this._closeMenu();
		    }
	
			//Open up the Dojo dijit.Menu
			this._cMenu.contextMenuOpen(this._cxtMenuEvt, this._topologyContainer);
			
			// Listen for the onClose event to know when to hide the menu layer DIV
			this._menuCloseHandle = dojo.connect(this._cMenu.getMenu(), "onClose", this,
													function() {
														dojo.disconnect(this._menuCloseHandle);
														if (this._openingNewMenu) {
															this._openingNewMenu = false;
														} else {
															this._deactivateLayerDiv();
														}
													});
			this._cxtMenuEvt = null;
		};
		
		// Pass (x,y) along to canvas flex bridge here
		var kwArgs = {
				onComplete: dojo.hitch(this, flexBridgeCallback),
				evt: evt
		};
		this._topologyContainer._divLayerOnContextMenu(kwArgs);
		
		//Stop propagation of the event
		dojo.stopEvent(evt);
	},
	
	_processDoubleClick: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		
		// just for debug to see (x,y) before passing to flex bridge
		if (this._trace.isFinest()) {
			this._trace.finest("*** layer detected DOUBLE_CLICK: x=" + evt.layerX + " y=" + evt.layerY);
		}
		
		// pass event on to canvas flex bridge here
		this._topologyContainer._divLayerOnDoubleClick(evt);

		//Close the menu
		this._closeMenu();
		this._closeTooltip();
		this._deactivateLayerDiv();
		
		//Stop propagation of the event
		dojo.stopEvent(evt);
	},
	
	_processMouseDown: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		
		// just for debug to see (x,y) before passing to flex bridge
		if (this._trace.isFinest()) {
			this._trace.finest("*** layer detected MOUSE_DOWN: x=" + evt.layerX + " y=" + evt.layerY);
		}
		
		// pass event on to canvas flex bridge here
		this._topologyContainer._divLayerOnMouseDown(evt);
		
		if (dojo.mouseButtons.isLeft(evt)) {
	         this._closeMenu();
	         this._closeTooltip();
	         this._deactivateLayerDiv();
		}
		
		//Get the selected items
		if (this._trace.isFinest()) {
			var selection = this._topologyContainer.selection;
			this._trace.finest("******after mouse down the selection for canvas = " + this._topologyContainer.id + "; itemIds = " +
					dojo.toJson(selection.getItemIds()) + 
							", linkIds = " + dojo.toJson(selection.getLinkIds()) + 
							", relationshipIds = " + dojo.toJson(selection.getRelationshipIds()));
		}
				
		//Stop propagation of the event
		dojo.stopEvent(evt);
	},
	
	_processMouseMove: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		
		// just for debug to see (x,y) before passing to flex bridge
		//Commenting out trace to see if performance is improved...
		//if (this._trace.isFinest()) {
		//	this._trace.finest("*** layer detected MOUSE_MOVE: x=" + evt.layerX + " y=" + evt.layerY);
		//}
		
		// only pass the event on if the menu layer DIV is visible/active
	    if (dojo.style(this._layerDiv, "visibility") == "visible") {
			// pass event on to canvas flex bridge here
			this._topologyContainer._divLayerOnMouseMove(evt);
	    }
		
		//Stop propagation of the event
		dojo.stopEvent(evt);
	},
	
	_processMouseOut: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		if (this._trace.isFinest()) {
			this._trace.finest("*** layer detected MOUSE_OUT");  // just for debug for now
		}

		// only pass the event on if the menu layer DIV is visible/active
	    if (dojo.style(this._layerDiv, "visibility") == "visible") {
	    	// Can get mouseout events when mouse is over the menu, so
	    	// ignore these if the menu is currently displayed
	    	var menu = this._cMenu.getMenu();
	    	if (!menu) {
	    		//Passing along allows Flash side to determine if we have a rollOut event for the current
	    		//rollOver object
			    this._topologyContainer._divLayerOnMouseOut(evt);
			}
	    }

		//Stop propagation of the event
		dojo.stopEvent(evt);
	},
	
	_processMouseOver: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		
		if (this._trace.isFinest()) {
			this._trace.finest("*** layer detected MOUSE_OVER");  // just for debug for now
		}

		// Can get mouseover events when mouse is over the menu and leaves it, so
		// ignore these if the menu is currently displayed
		var menu = this._cMenu.getMenu();
		if (!menu) {
			// NOTE: *no* need pass event on to canvas flex bridge here
		}
		
		//Stop propagation of the event
		dojo.stopEvent(evt);
	},
	
	_processMouseUp: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		
		// just for debug to see (x,y) before passing to flex bridge
		if (this._trace.isFinest()) {
			this._trace.finest("*** layer detected MOUSE_UP: x=" + evt.layerX + " y=" + evt.layerY);
		}
		
		// check for first time since we will not get oncontextmenu since we did not get the
		// mousedown
		if (this._forceMenuOnMouseUp && dojo.mouseButtons.isRight(evt)) {
			// coerce this into oncontextmenu processing for the first time only
			this._processContextMenu(evt);
		} else {
			// NOTE: *no* need pass event on to canvas flex bridge here
		}
		
		//Stop propagation of the event
		dojo.stopEvent(evt);
	},
	
	_processMouseWheel: function(/*Object*/ evt) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// evt:
		//		Coming soon
		
		// just for debug to see (x,y) before passing to flex bridge
		if (this._trace.isFinest()) {
			this._trace.finest("*** layer detected MOUSE_WHEEL: x=" + evt.layerX + " y=" + evt.layerY);
		}
		
		// pass event on to canvas flex bridge here
		this._topologyContainer._divLayerOnMouseWheel(evt);
		
		//Stop propagation of the event
		dojo.stopEvent(evt);
	},
	
	//***********************************************************************************
	//Called by Canvas as Flash determines object that's roller over or rolled out of
	//***********************************************************************************
	
	_objectRollOverHandler: function(/*Object*/ objectContext, /*Object*/ boundingInfo) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// objectContext:
		//		Coming soon
		// boundingInfo:
		//		Coming soon
		if (this._trace.isFinest()) {
			this._trace.finest("****** ROLL_OVER!!! itemIds = " + dojo.toJson(objectContext.getItemIds()) + 
					", linkIds = " + dojo.toJson(objectContext.getLinkIds()) + 
					", relationshipIds = " + dojo.toJson(objectContext.getRelationshipIds()) +
					"; boundingInfo = " + dojo.toJson(boundingInfo));
		}
		
		// ignore if the menu is open or if we already havea rollover target
	    if (!this._isMenuOpen() && !this._rolloverTarget) {
	    	var aroundRect = {type: "rect"};
	    	if (objectContext.getItemCount() == 1) {
	    		this._rolloverTarget = objectContext.getItems()[0];
	    		aroundRect.x = boundingInfo.objectX;
	    		aroundRect.y = boundingInfo.objectY;
	    		aroundRect.width = boundingInfo.objectWidth;
	    		aroundRect.height = boundingInfo.objectHeight;
	    	} else if (objectContext.getLinkCount() == 1) {
	    		this._rolloverTarget = objectContext.getLinks()[0];
	    		aroundRect.x = boundingInfo.mouseX;
	    		aroundRect.y = boundingInfo.mouseY;
	    		aroundRect.width = aroundRect.height = 2;
	    	} else if (objectContext.getRelationshipCount() == 1) {
	    		this._rolloverTarget = objectContext.getRelationships()[0];
	    		aroundRect.x = boundingInfo.mouseX;
	    		aroundRect.y = boundingInfo.mouseY;
	    		aroundRect.width = aroundRect.height = 2;
	    	} else {
	    		this._rolloverTarget = "Unknown node or link";
	    		aroundRect.x = boundingInfo.mouseX;
	    		aroundRect.y = boundingInfo.mouseY;
	    		aroundRect.width = aroundRect.height = 1;
	    	}
	    	// adjust relative coordinates to absolute, and remove fractions
	    	var lt = dojo.coords(this._layerDiv, true);
	    	aroundRect.x += lt.x;
	    	aroundRect.y += lt.y;
	    	aroundRect.x = Math.round(aroundRect.x);
	    	aroundRect.y = Math.round(aroundRect.y);
	    	aroundRect.width = Math.ceil(aroundRect.width);
	    	aroundRect.height = Math.ceil(aroundRect.height);
			
	    	this._layerDiv.rolloverTargetRect = aroundRect;
	    	this._activateLayerDiv(false);
	    	this._tooltip.hover(this._layerDiv);
	    }
	},
	
	_objectRollOutHandler: function(/*Object*/ objectContext) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// objectContext:
		//		Coming soon
		if (this._trace.isFinest()) {
			this._trace.finest("****** ROLL_OUT!!! itemIds = " + dojo.toJson(objectContext.getItemIds()) + 
					", linkIds = " + dojo.toJson(objectContext.getLinkIds()) + 
					", relationshipIds = " + dojo.toJson(objectContext.getRelationshipIds()));
		}
		
		this._closeTooltip();
	},
	
	_canvasPanStartHandler: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		//TODO: Mark needs to do work here
		if (this._trace.isFinest()) {
			this._trace.finest("PAN START!!!!");
		}
	},
	
	_canvasPanEndHandler: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		//TODO: Mark needs to do work here
		if (this._trace.isFinest()) {
			this._trace.finest("PAN END!!!!");
		}
	},
	
	_closeTooltip: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		if (this._rolloverTarget) {
			dojo.disconnect(this._propOnSetDatasetConnection);
			dojo.disconnect(this._propOnSetObjectsConnection);
			
			// Clear out the reference in the tooltip to the content
			this._tooltip.updateContent(""); 
			if (this._tooltipProperties){
				this._tooltipProperties.destroyRecursive();
				this._tooltipProperties = null;
			}
			
			// this._tooltip.close();
			this._tooltip.unHover(this._layerDiv);
			this._rolloverTarget = null;
			this._layerDiv.rolloverTargetRect = null;
			if (!this._activatedForMenu) {
				this._deactivateLayerDiv();
			}
	    }
	},
	
	_objectDoubleClickHandler: function(/*Object*/ objectContext) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// objectContext:
		//		Coming soon
		if (this._trace.isFinest()) {
			this._trace.finest("****** DOUBLE-CLICK!!! itemIds = " + dojo.toJson(objectContext.getItemIds()) + 
					", linkIds = " + dojo.toJson(objectContext.getLinkIds()) + 
					", relationshipIds = " + dojo.toJson(objectContext.getRelationshipIds()));
		}


		if(!this._daHelper){
			//Create DefaultActionHelper
			//By default creates the properties Dialog and launches it (via callback)
			this._daHelper = new ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper( 
					{
						defaultActionCallback: dojo.hitch(this, "_launchPropertiesDialog",objectContext)
					}
			);
		}
		//actually execute the default action/task (defined in constuctor)
		this._daHelper.executeDefaultAction(objectContext.getPluggableView());
	},
	
	_launchPropertiesDialog: function(/*Object*/ objectContext){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// objectContext:
		//		Coming soon
		
		//NOTE: Reusing Anthony's MenuProviderHelper to launch the dialog to avoid duplicate logic. This is a temporary solution. 
		var menuProviderHelper = new ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper();
		menuProviderHelper.getMenuCommand("nwmi_PropertiesNotebookDialog", objectContext.getPluggableView(), null);
	},
	
	_customTooltip: function(/*Object*/ target) {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// target:
		//		Coming soon

		if (this._rolloverTarget) {
			// target is this._layerDiv, so we use this._rolloverTarget
			var content = "";
			if (typeof this._rolloverTarget == "string") {
				content = content + this._rolloverTarget;
			} else {
				content = content + this._rolloverTarget.getLabel();
			}

			//if the server side tooltip content is set, use this instead of defaults.
			if(this._rolloverTarget.getTooltip) { //Need first test because getTooltip is not a function on child datasets right now
				var tooltip = this._rolloverTarget.getTooltip();
				if (tooltip){ 
					content = tooltip;
					return content;
				}
			}

			if(this._tooltipProperties){
				return this._tooltipProperties.getContent();
			}

			//create properties content object
			this._tooltipProperties = new ibm.tivoli.tip.navwidget.properties.dijit.PropertiesNotebookGeneralTab({
				id: this._topologyContainer.id + "_tooltipProperties",
				managingPluggableView: this._topologyContainer, 
				maxProperties: 3,  //TODO: ADM should probably be something a widgetDef sets.
				_isTooltipProperties: true
			});

			//Call back for when the dataset it set
			var objectType = (this._rolloverTarget.getObjectType) ? this._rolloverTarget.getObjectType() : null;
			var setDatasetComplete = function(dataset) {
				//connect to the onSetObjects Event
				this._propOnSetObjectsConnection = dojo.connect(this._tooltipProperties, "onSetObjects", dojo.hitch(this, this._updateTooltipContent));

				if (objectType === "item"){
					this._tooltipProperties.setObjects([this._rolloverTarget], null, null, null);
				} else if(objectType === "link"){
					this._tooltipProperties.setObjects(null, [this._rolloverTarget], null, null);
				} else if(objectType === "relationship"){
					this._tooltipProperties.setObjects(null, null, [this._rolloverTarget], null);
				} 
			};
			this._propOnSetDatasetConnection = dojo.connect(this._tooltipProperties, "onSetDataset", dojo.hitch(this, setDatasetComplete));
			this._tooltipProperties.setDataset(this._topologyContainer.dataset);

			//return content;
			return this._createTemporaryContentDiv(content, objectType);
		}
	   },
	   
	   //Event callback method to handle updating the tooltip content with updated content
	   _updateTooltipContent: function(){
		   this._tooltip.updateContent(this._tooltipProperties.getContent(), this._layerDiv);
	   },
	   
	   _createTemporaryContentDiv: function(content, objectType) {		   
		   //Background div
		   var backgroundDiv = dojo.create("div",{
		   });
		   var processingPane = new dijit.layout.ContentPane({
			   content: backgroundDiv
		   });
			
			// text div		
		   var textDiv = dojo.create("div",{
			   "innerHTML": content
		   });
		   backgroundDiv.appendChild(textDiv);
		
		   if (objectType) {
			   // processing image div		
			   var processDiv = dojo.create("div",{
					"class": "processingImage"
			   });
			   backgroundDiv.appendChild(processDiv);
		   }

		   //Return
		   return processingPane;
	   }
});
