/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.ComboButton");
dojo.require("dijit.Menu");
dojo.require("dijit.MenuItem");
dojo.require("dijit.form.ComboBox");
dojo.require("dijit.form.Select");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.ToolbarSeparator");
dojo.require("dijit.PopupMenuItem");
dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("ibm.tivoli.tip.navwidget.dojo.ToolbarUtil");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyRadioMenuItem");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyLabel");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.ActionsMenu");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.PrintDialog");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");

dojo.extend(dijit.form.ComboBox, {    	//extends ComboBox to modify and add below methods.
	// summary:
	//		Coming soon
	// description:
	//		Coming soon

	onChange:function(/*Object*/ value){  	
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// value:
		// 		Coming soon
    	var valueObj = this;    		
        this.onValueChange(valueObj); 		
	},
    onValueChange:function(valueObj){  //empty method, can connect to this.
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	}
});  

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar");

/******************************************************************************
* Authors: Karol Romanowski
******************************************************************************/
dojo.declare("ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar",
            [ dijit._Widget, dijit._Templated ],
{
  // summary:
  //		A Topology Toolbar.
  // description:
  //		Coming soon
	
  // widgetsInTemplate: [public] Boolean
  //		Coming soon
  widgetsInTemplate: true,
  
  // templatePath: [public] Object
  //		Coming soon
  templatePath: dojo.moduleUrl("ibm.tivoli.tip.navwidget.topology.dijit","templates/TopologyToolbar.html"),
  
  // topology: [public] Object
  //		Coming soon
  topology: null,
  
  // topology: [public] String
  //		Coming soon
  region: "top",
  
  //_searchDialog: [private] Object
  //		Coming soon
  _searchDialog: null,
  
  //_menuItemsToDestroy [private] Object
  //		Coming soon
  _menuItemsToDestroy: null,
  
  constructor: function( /*Object*/ parms ) 
  {
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	// parms:
	//		Coming soon
	
	this._menuItemsToDestroy = [];
  },
  
  postCreate: function()
  {
	  // summary:
	  //		Coming soon
	  // description:
	  //		Coming soon
	  this.toolbar.region=this.region;
  },
    
  getToolbar: function()
  {
	  // summary:
	  //		Coming soon
	  // description:
	  //		Coming soon
	  return this.toolbar;
  },
  
  destroy: function()
  {
	  // summary:
	  //		Coming soon
	  // description:
	  //		Coming soon
	  
	  if (this._searchDialog) {
		  this._searchDialog.destroyRecursive();
	  }
	  
	  //For some reason IE doesn't end up destroying child menu items which latter leads to id conflicts if
	  //toolbar get recreated. We're manually keeping track of the menu items to destroy in this._menuItemsToDestroy
	  //because at this point menu.getChildren returns an empty list.
	  if (dojo.isIE && this._menuItemsToDestroy) {
		  for(var i = 0; i < this._menuItemsToDestroy.length; ++i) {
			  this._menuItemsToDestroy[i].destroyRecursive();
		  }
	  }
	  this._menuItemsToDestroy = null;

	  this.inherited( arguments );
  },
  
  addChild: function(/*Object*/ element, index)
  {
	  // summary:
	  //		Coming soon
	  // description:
	  //		Coming soon
	  // element:
	  //		Coming soon
	  this.toolbar.addChild(element, index);

  },
  
  removeChild: function(/*Object*/ element)
  {
	  // summary:
	  //		Coming soon
	  // description:
	  //		Coming soon
	  // element:
	  //		Coming soon
	  this.toolbar.removeChild(element);
  },
  
  createDefault: function()
  {
	  // summary:
	  //		Coming soon
	  // description:
	  //		Coming soon
	  for(var i=0;i<ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.defaultToolbar.length;i++){
		  this.addItem(ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.defaultToolbar[i]);
	  }
  },

	addItem: function(/*Object*/ item){
	  // summary:
	  //		Adds 'item' to the toolbar
	  // description:
	  //		Coming soon
	  // item:
	  //		item to be added to the toolbar
		var button = null;
		switch(item.type){
			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SAVE_BUTTON:
				button = new dijit.form.Button({
					id: this.id + "_" + item.type,
					iconClass: "saveIcon",
					label: ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.topology.commonResources.SAVE_TEXT),
					showLabel: false,
					title: ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.topology.commonResources.SAVE_TEXT, true)
				});
				this.addChild(button);
				
				this._connectHandler(button, "onClick", this, "saveCanvas");
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.PRINT_BUTTON:
				button = new dijit.form.Button({
					id: this.id + "_" + item.type,
					iconClass: "printIcon",
					label: ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.topology.commonResources.PRINT_TEXT),
					showLabel: false,
					title: ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.topology.commonResources.PRINT_TEXT, true)
				});	
				this.addChild(button);
				this._connectHandler(button, "onClick", this, "openPrintDialog");
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SELECT_BUTTON:
				button = new dijit.form.ToggleButton({
					id: this.id + "_" + item.type,
					iconClass: "selectIcon",
					label: this.topology.commonResources.SELECT_TEXT,
					checked: true,
					showLabel: false,
					title: this.topology.commonResources.SELECT_TEXT
				});
				this._connectHandler(button, "onClick", this, function() {    					
					dijit.byId(this.id+"_"+ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SELECT_BUTTON).setChecked(true);        	
					dijit.byId(this.id+"_"+ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_SELECT_BUTTON).setChecked(false);   
					dijit.byId(this.id).topology.setMouseMode("select");
				});  
				this.addChild(button);
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.PAN_BUTTON:
				button = new dijit.form.Button({
					id: this.id + "_" + item.type,
					iconClass: "panIcon",
					label: this.topology.commonResources.PAN_TEXT,
					showLabel: false,
					title: this.topology.commonResources.PAN_TEXT
				});	
				this.addChild(button);
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_SELECT_BUTTON:
				button = new dijit.form.ToggleButton({
					id: this.id + "_" + item.type,
					iconClass: "zoomSelectIcon",
					label: this.topology.commonResources.ZOOM_SELECT_TEXT,
					checked: false,
					showLabel: false,
					title: this.topology.commonResources.ZOOM_SELECT_TEXT
				});	
				this._connectHandler(button,"onClick",this, function() {    					
					dijit.byId(this.id+"_"+ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_SELECT_BUTTON).setChecked(true);        	
					dijit.byId(this.id+"_"+ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SELECT_BUTTON).setChecked(false);   
					dijit.byId(this.id).topology.setMouseMode("zoomSelect");
				});   
				this.addChild(button);
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_IN_BUTTON:
				button = new dijit.form.Button({
					id: this.id + "_" + item.type,
					iconClass: "zoomInIcon",
					label: this.topology.commonResources.ZOOM_IN_TEXT,
					showLabel: false,
					title: this.topology.commonResources.ZOOM_IN_TEXT
				});	
				//Wire the controls
				this._connectHandler(button, "onClick", this.topology, "zoomIn");
				this.addChild(button);
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_OUT_BUTTON:
				button = new dijit.form.Button({
					id: this.id + "_" + item.type,
					iconClass: "zoomOutIcon",
					label: this.topology.commonResources.ZOOM_OUT_TEXT,
					showLabel: false,
					title: this.topology.commonResources.ZOOM_OUT_TEXT
				});
				//Wire the controls
				this._connectHandler(button, "onClick", this.topology, "zoomOut");
				this.addChild(button);
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.FIT_CONTENTS_BUTTON:
				button = new dijit.form.Button({
					id: this.id + "_" + item.type,
					iconClass: "fitToViewIcon",
					label: this.topology.commonResources.FIT_CONTENTS_TEXT,
					showLabel: false,
					title: this.topology.commonResources.FIT_CONTENTS_TEXT
				});								
				this._connectHandler(button, "onClick", this.topology, "fitContents");
				this.addChild(button);
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.REFRESH_BUTTON:
				button = new dijit.form.Button({
					id: this.id + "_" + item.type,
					iconClass: "topoRefreshIcon",
					label: this.topology.commonResources.REFRESH_TEXT,
					showLabel: false,
					title: this.topology.commonResources.REFRESH_TEXT
				});		
				this.addChild(button);
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SEARCH_BUTTON:
				button = new dijit.form.Button({
					id: this.id + "_" + item.type,
					label: ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.topology.commonResources.SEARCH_TEXT),
					showLabel: true,
					title: ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.topology.commonResources.SEARCH_TEXT, true)
				});		
				this.addChild(button);
				this._connectHandler(button, "onClick", this, "openSearchDialog");
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SET_DEPTH:
				var labelForComboBox = new ibm.tivoli.tip.navwidget.topology.dijit.TopologyLabel( 
					{
						labelFor : this.id + "_" + item.type,
						labelText: this.topology.commonResources.DEPTH 
					});
				this.addChild(labelForComboBox);
				var options = new dojo.data.ItemFileWriteStore({data: {identifier: 'name', items:[]}});				
				for(var i=1;i<=this.topology.getMaxDepth();i++){
					options.newItem({name: i, value: i});
				}
				var comboBox = new dijit.form.ComboBox({
					id: this.id + "_" + item.type,
					name: this.id + "_" + item.type,
					store: options,
					"style":"width: 50px;",
					searchAttr: "name",
					value: this.topology.getDepth()
				});
				// KDM: This likely needs to happen at nav widget level
				this._connectHandler(comboBox,"onValueChange",this, function(cmbx) {    
					dijit.byId(this.id).topology.setDepth(cmbx.value);          	
				});   
				this.addChild(comboBox);
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.LAYOUT_MENU:				
				var layoutPulldown = new dijit.Menu({
					id: this.topology.id + "_layoutMenu",
					style: "display: none;",
					autoSize: true
	    			});

				var layouts = this.topology.getLayouts();
				var defaultLabel = null;
				var defaultIconClass = null;
				if (layouts){
					var defaultLayoutId = this.topology.getDefaultLayoutId();
					for(var i = 0; i < layouts.length; ++i) {
						var label = layouts[i].label.value;
						var iconClass = this.topology.getLayoutIconClass(layouts[i].algorithm);
						var layoutMenuItem = new dijit.MenuItem({
 							id: this.topology.id + "_LayoutMenuItem_" + layouts[i].id,
 							label: label,    		
       						iconClass: iconClass
    						});
						if(layouts[i].id === defaultLayoutId){
							defaultLabel = label;
							defaultIconClass = iconClass;
						}
						this._connectHandler(layoutMenuItem, "onClick", this.topology, "setLayoutEventHandler");    						
						layoutPulldown.addChild(layoutMenuItem);	
						
						//Need to keep track of menu items so we can manually destroy in IE
						this._menuItemsToDestroy.push(layoutMenuItem);
					}
				};

				var layoutToolbarButton = new dijit.form.ComboButton({
					id: this.topology.id + "_layoutComboButton",
					label: defaultLabel,
					iconClass: defaultIconClass,
					dropDown: layoutPulldown,
					dynamic: true,
					showLabel: false //OID requests we don't show the label in the toolbar
				});

	    			this.addChild(layoutToolbarButton);
	    			this.enableLayoutCustomization();	    		
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ACTION_MENU:
				var actionsPulldown = new dijit.Menu({
					id: this.topology.id + "_actionMenu",
					style: "display: none;",
					autoSize: true
				});

	    			var actionsToolbarButton = new ibm.tivoli.tip.navwidget.topology.dijit.ActionsMenu({
	        			label: this.topology.commonResources.ACTIONS,		
	        			dropDown: actionsPulldown,
	        			cmProvider: this.topology.cmProvider,
	        			context: this.topology._canvas,
	        			title: this.topology.commonResources.ACTIONS
	    			});

	    			dojo.style(actionsToolbarButton.containerNode, "color", "#000000");
	    			this.addChild(actionsToolbarButton);
				break;
			
			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SEPARATOR:
				button = new dijit.ToolbarSeparator();
				this.addChild(button);
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.CUSTOM_BUTTON:
				button = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customButton({id: this.id, item: item});				
				if (button) {
					this.addChild(button);
				}							
				break;

			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.CUSTOM_COMBO:
				var label = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customLabel({id: this.id, item: item}); 				
				if (label) {
					this.addChild(label);
				};
				
				var combo = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customComboButton({id: this.id, item: item});	
				if (combo) {
					this.addChild(combo);
				}
				break;
			
			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.CUSTOM_TEXTBOX:
				var label = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customLabel({id: this.id, item: item}); 				
				if (label) {
					this.addChild(label);
				};

				var text = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customText({id: this.id, item: item});	
				if (text) {
					this.addChild(text);
				}
				break;
			
			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.CUSTOM_DROPDOWN_BUTTON:
				var dropDown = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.customDropDown({id: this.id, item: item});	
				if (dropDown) {
					this.addChild(dropDown);
					
					//Bit of a hack, but also need to keep track of menu items within dropDown so we can destroy later
					if (dropDown.dropDown) {
						var childMenuItems = dropDown.dropDown.getChildren();
						for (var i = 0; i < childMenuItems.length; i++) {
							this._menuItemsToDestroy.push(childMenuItems[i]);
						}
					}
				}
				break;
			
			case ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.VIEW_TOGGLER:
				var viewToggler = ibm.tivoli.tip.navwidget.dojo.ToolbarUtil.viewToggler({view: this.topology, item: item});	
				if (viewToggler) {
					this.addChild(viewToggler);
					
					//Bit of a hack, but also need to keep track of menu items within dropDown so we can destroy later
					if (viewToggler.dropDown) {
						var childMenuItems = viewToggler.dropDown.getChildren();
						for (var i = 0; i < childMenuItems.length; i++) {
							this._menuItemsToDestroy.push(childMenuItems[i]);
						}
					}
				}
				break;	
	
			default:
				this.topology._trace.warn("Invalid toolbar item type provided", "addItem");
		}		
	},
	
	openSearchDialog: function(){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		//Let's create the search dialog
		if(!this._searchDialog){
			var searchDialogId = this.topology.id + "_searchDialog";
			this._searchDialog = new ibm.tivoli.tip.navwidget.topology.dijit.SearchDialog({
	            id: searchDialogId,
	            style: "width:40%",
	            managingPluggableView: this.topology
	        });
		}
		
		//Set dataset
		if (this.topology.dataset != this._searchDialog.dataset) {
			//Really only want to do this the first time and then if we have a new dataset
			this._searchDialog.setDataset(this.topology.dataset);
		}
		
		//Show the dialog
		this._searchDialog.show();
	},

	openPrintDialog: function(){
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		var printDialog = dijit.byId(this.topology.id + "_printDialog"); 
		if(!printDialog){
			//creating canvas print dialog and its content
			var printDialogId = this.topology.id + "_printDialog";
			printDialog = new ibm.tivoli.tip.navwidget.topology.dijit.PrintDialog({
				id: printDialogId,
				title: this.topology.commonResources.PRINT_TEXT,
				topology: this.topology
			});
		}
		printDialog.show();
	},
		
	saveCanvas: function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		var saveCanvasDialog = dijit.byId(this.topology.id + "_saveCanvasDialog"); 
		if(!saveCanvasDialog){
			//creating canvas save dialog and its content
			var saveDialogId = this.topology.id + "_saveCanvasDialog";
			saveCanvasDialog = new dijit.Dialog({
				id:saveDialogId,
				title: this.topology.commonResources.SAVE_CANVAS_CONTEXT,
				"style":"width:400px;font-size:11px; font-family: Verdana;",
				content:"<div>" + 
							"<div style=\"padding: 5px 10px 5px 10px;\">" +
								this.topology.commonResources.SAVE_CUSTOMIZATION_QUESTION +
								"<br/>" +
							"</div>"+							
							"<div style=\"background-color: #F7F7F7; border-top: 1px solid #DEDEDE; padding: 5px 5px 5px 10px\">" +
							"<form>" +
								"<button id=\""+ saveDialogId+"_saveButton\" dojoType=\"dijit.form.Button\" type=\"button\">"+
									this.topology.commonResources.SAVE +
								"</button>"+
								"<button id=\""+ saveDialogId+"_restoreButton\" dojoType=\"dijit.form.Button\" type=\"button\">"+
								this.topology.commonResources.RESTORE_DEFAULTS +
								"</button>"+								
								"<button dojoType=\"dijit.form.Button\" type=\"button\">"+
								this.topology.commonResources.CANCEL + 
								"<script type=\"dojo/method\" event=\"onClick\" args=\"evt\">"+
									"dijit.byId(\""+saveDialogId+"\").hide();"+                
								"</script>"+
								"</button>"+
							"</form>" +
							"</div>" +
						"</div>"
			});
			var saveButton = dijit.byId(saveDialogId+"_saveButton");
			this._connectHandler(saveButton, "onClick", this, "_saveCanvasAction");		
			var restoreButton = dijit.byId(saveDialogId+"_restoreButton");
			this._connectHandler(restoreButton, "onClick", this, "_restoreCanvasAction");
		};
		
		saveCanvasDialog.show();
		
		/*
		 * 254135
		 * This is a temporary workaround to
		 * ensure that the focus is not returned to the <object> node that contains the
		 * Flash plugin for the canvas (as that cannot be done with javascript).  Instead
		 * return the focus to the DIV container for the canvas.
		 */
		//Kris 4DJan12, adding an if check for _savedFocus, since it is not there in dojo 1.6 Dialog
		if(saveCanvasDialog._savedFocus){ 
			if (saveCanvasDialog._savedFocus.node.id && saveCanvasDialog._savedFocus.node.id.indexOf("SWFObject") > 0) {
				saveCanvasDialog._savedFocus.node = this.topology._canvas.domNode;
			}
		}
	},
	
	_restoreCanvasAction: function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		this.topology.clearWidgetDelta();
		dijit.byId(this.topology.id + "_saveCanvasDialog").hide();	
	},
	
	_saveCanvasAction: function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		
		//Save delta
		this.topology.saveWidgetDelta();
		
		//Hide dialog
		dijit.byId(this.topology.id + "_saveCanvasDialog").hide();
	},
	
	enableLayoutCustomization: function(){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		var customLayoutMenuItemId = this.topology.id + "_layoutMenu_customLayoutMenuItem";
		if(!dijit.byId(customLayoutMenuItemId)){

			var customLayoutMenuItem = new dijit.MenuItem({
					id: customLayoutMenuItemId,
					label: ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getStringWithEllipsis(this.topology.commonResources.CUSTOM),         		
					iconClass: this.topology.getLayoutIconClass("custom")
			});
			
			this._connectHandler(customLayoutMenuItem, "onClick", this, function(){
				// Dialog for Layout customization
				var customLayoutDialog = dijit.byId(this.topology.id + "_customLayoutDialog"); 
				if(customLayoutDialog){
					customLayoutDialog.destroyRecursive(false);
				};
				var currentLayout = this.topology.getLayout();
				
				var dialogResTitle = this.topology.commonResources.CUSTOMIZE_LAYOUT;
				var dialogTitle = dojo.string.substitute(dialogResTitle,{value5: currentLayout.label.value /*currentLayout.algorithm*/ });
				
				customLayoutDialog = new ibm.tivoli.tip.navwidget.topology.dijit.LayoutDialog({
					id:this.topology.id + "_customLayoutDialog",
					title: dialogTitle,	    			
					topology: this.topology
				});
				
				dijit.byId(this.topology.id + "_customLayoutDialog").show();
			});
			dijit.byId(this.topology.id + "_layoutMenu").addChild(customLayoutMenuItem);	
		}
	},
	
	setLayoutSelection: function(layout) {
		var layoutComboButton = dijit.byId(this.topology.id + "_layoutComboButton");
		if(layoutComboButton){
			var label = layout.label.value;
			var iconClass = this.topology.getLayoutIconClass(layout.algorithm);
			layoutComboButton.attr("iconClass", iconClass);
			layoutComboButton.attr("label", label);
		}
	},
	
	resize: function(/*Object*/ changeSize, /*Object*/ resultSize){
		// summary:
		//		Overridden to ensure we get sized appropriately in FF. 
		// changeSize:
		//		Coming soon
		// resultSize:
		//		Coming soon
		// description:
		//		Overridden to ensure we get sized appropriately. Otherwise, we can end up slightly too
		//		big and get partially cut-off (particularly in FF). (See defect 250945)
		// tags:
		//		protected
		if (resultSize) {
			this.domNode.style.width = resultSize.w + "px";
		}

		//Call super
		this.inherited(arguments);
	},

	updateToolbar: function() {				
		var depthCombo = dijit.byId(this.id+"_"+ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SET_DEPTH);  			
		if (depthCombo) {
			var options = new dojo.data.ItemFileWriteStore({data: {identifier: 'name', items:[]}});				
			for(var i=1;i<=this.topology.getMaxDepth();i++){
				options.newItem({name: i, value: i});
			}			
			depthCombo.store = options;
			depthCombo.setValue(this.topology.getDepth());
		}
	},

	_connectHandler: function(object, event, context, handler) {
		try {
			dojo.connect(object, event, context, handler);
		} catch (error) {
			console.error("Failed to dojo.connect(" + object + ", " + event + ", " + context + ", " + handler + ")");
		}
	}
});

ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes = {		
	// summary:
	//		definitions for common toolbar item types values
	// description:
	//		Coming soon
	SAVE_BUTTON:		"SAVE_BUTTON",
	PRINT_BUTTON:		"PRINT_BUTTON",
	SELECT_BUTTON:		"SELECT_BUTTON",
	PAN_BUTTON:			"PAN_BUTTON",
	ZOOM_SELECT_BUTTON:	"ZOOM_SELECT_BUTTON",
	ZOOM_IN_BUTTON:		"ZOOM_IN_BUTTON",
	ZOOM_OUT_BUTTON:	"ZOOM_OUT_BUTTON",
	FIT_CONTENTS_BUTTON:"FIT_CONTENTS_BUTTON",
	REFRESH_BUTTON:		"REFRESH_BUTTON",
	SEARCH_BUTTON:		"SEARCH_BUTTON",
	SEPARATOR:			"SEPARATOR",	
	LAYOUT_MENU:		"LAYOUT_MENU",
	ACTION_MENU:		"ACTION_MENU",
	CUSTOM_BUTTON:		"CUSTOM_BUTTON",
	CUSTOM_TEXTBOX:		"CUSTOM_TEXTBOX",
	CUSTOM_COMBO: 		"CUSTOM_COMBO",
	CUSTOM_DROPDOWN_BUTTON: "CUSTOM_DROPDOWN_BUTTON",
	SET_DEPTH: 			"SET_DEPTH",
	VIEW_TOGGLER:		"VIEW_TOGGLER"
  };

ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.defaultToolbar = [		
        // summary:
 		//		Coming soon
        // description:
        //		Coming soon
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SAVE_BUTTON},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SEPARATOR},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.PRINT_BUTTON},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SEPARATOR},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SELECT_BUTTON},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_SELECT_BUTTON},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SEPARATOR},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_IN_BUTTON},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_OUT_BUTTON},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.FIT_CONTENTS_BUTTON},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SEPARATOR},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.LAYOUT_MENU},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SEPARATOR},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ACTION_MENU},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SEPARATOR},
    	{"type" : ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.SEARCH_BUTTON}
];
