/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dijit.TopologyView");

dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.BorderContainer");
dojo.require("ibm.tivoli.navmodel.TopoWidgetDef");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyLineBreak");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.Canvas");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper");
dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyFilterRow");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider");
dojo.require("dojox.collections.Queue");
dojo.require("dojox.collections.Dictionary");
ibm.tivoli.tip.navwidget.topology.dijit.TopologyView._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dijit.TopologyView");

dojo.declare ("ibm.tivoli.tip.navwidget.topology.dijit.TopologyView",
	[dijit.layout.BorderContainer, ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView],
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		//***************************
		// "Private"
		//***************************

		// _canvas: [private] Object
		//		Coming soon
		_canvas: null, 
		
		// _toolbar: [private] Object
		//		Coming soon
		_toolbar: null,
		
		// _toolbar: [private] Object
		//		Coming soon
		_toolbarProviderEntries: null,
		
		// _layout: [private] Object
		//		Coming soon
		_layout: null,
		
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
		_trace: ibm.tivoli.tip.navwidget.topology.dijit.TopologyView._trace,
		
		// _activeFiltersCount: [private] int
		//		Coming soon
		_activeFiltersCount: 0,
		
		// _activeFiltersCount: [private] int
		//		Coming soon
		_highlightedItems: null,
		
		// _DEFAULT_WIDGET_DEF_INFO: [const] String[]
		//		Coming soon
		_DEFAULT_WIDGET_DEF_INFO: {
			className: "ibm.tivoli.navmodel.TopoWidgetDef",
			baseUrl: "/ibm/tivoli/rest",
	    	provider: "any",
	    	datasource: "any",
	    	widget: "topology",
	    	definition: "DefaultTopology"
		},
		
		// _refreshToolbar: Boolean
		//		flag indicating if topology toolbar tasks need to be refreshed after building the menu
		_refreshToolbar: false,
		
		/* For footer */
		// itemCount:[public] int
		// to update the item count
		itemCount:0,
		
		// linkCount: [public] int
		// to dynamically update link count
		linkCount:0,
		
		//tabIndexValue:[public] int
		tabIndexValue:0,
		
		// _canvasOverrides:[private]
		//		NOTE: This is a non-public temporary attribute so we can more easily prototype with the Dojo Diagrammer
		_canvasOverrides: null,
		
		constructor: function () {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			this._canvasOverrides = {};
			this.gutters = false;
			this.title = this.commonResources.TOPOLOGY_VIEW;
			this.labelIconClass = "topologyViewIcon";
			
			//Create internal data structure for maintaining list of filtered items
    		this._highlightedItems = new dojox.collections.Dictionary();
		},

		//******************************************
		// Overridden functions from dijit._Widget
		//******************************************
		postCreate: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			
			//Call superclass
			this.inherited(arguments);
		},

		destroy: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			
			if (this._highlightedItems) {
				this._highlightedItems.clear();
				this._highlightedItems = null;
			}
			
			//Call superclass			
			this.inherited(arguments);	
		},
		
		//***********************************************************
		// "Private" functions
		//***********************************************************
		_getDefaultWidgetDefInfo: function(){
			return this._DEFAULT_WIDGET_DEF_INFO;
		},

		_refreshProviderToolbarTasks: function(/*Boolean*/ success){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// success:
			//		Coming soon
			// tags:
			//		private
	 		if (!success) {
	 	    	this._trace.warn("Toolbar tasks not loaded", "_refreshProviderToolbarTasks");
	 		} else {
		 		if(this._toolbar){
		 			var toolbarTasks = this.getToolbarItems(this._canvas);
		 			var currentToolbarTasks = this._toolbar.toolbar.getChildren();
		 			this._syncToolbarWithProviderTasks(currentToolbarTasks, toolbarTasks);
		 		}
	 		}
	 		
	 		//Mark we're done loading toolbar tasks and make another request if necessary
	 		this._dealWithLoadingToolbarTasksNextCallback();
		},
		
		_syncToolbarWithProviderTasks: function(/*Object[]*/ toolbarVector, /*Object[]*/ tasksVector){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// toolbarVector:
			//		Coming soon
			// tasksVector:
			//		Coming soon
			// tags:
			//		private
			for(var i=0; i<tasksVector.length && i<toolbarVector.length; i++){
				if(tasksVector[i].submenu_items){
					if(toolbarVector[i].dropDown){
						this._syncToolbarWithProviderTasks(toolbarVector[i].dropDown.getChildren(),tasksVector[i].submenu_items);
					} else if(toolbarVector[i].popup){
						this._syncToolbarWithProviderTasks(toolbarVector[i].popup.getChildren(),tasksVector[i].submenu_items);
					}
				} else {
					for (var j=0; j<tasksVector.length;j++) {
						if (toolbarVector[i].actionID == tasksVector[j].actionID) {
							toolbarVector[i].attr("disabled", tasksVector[j].disabled);
						}
					}
				}
			}
		},
		
		_toolbarTasksLoaded: function(/*Boolean*/ success) {			
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// success:
			//		Coming soon
			// tags:
			//		private		
	 		if (!success) {
	 	    	this._trace.warn("Toolbar tasks not loaded", "_toolbarTasksLoaded");
	 		}
	 		//Create the "toolbar"
	 	    this._createToolbar(success);
			if(this._toolbar){
				this.addChild(this._toolbar, 0);   // make the toolbar the first child
			}
	 	},
	 	
		_createToolbar: function(/*Object*/ providerTasksReceived){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// providerTasksReceived:
			//		Coming soon
			// tags:
			//		private
	 		
	 		this._createProviderPortionOfToolbar(providerTasksReceived);
	 		this._createWidgetDefPortionOfToolbar();
		},
		
		
		_createProviderPortionOfToolbar: function(/*Object*/ providerTasksReceived){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// providerTasksReceived:
			//		Coming soon
			// tags:
			//		private
	 		if(providerTasksReceived){
	 			//adding provider tasks
				var toolbarTasks = this.cmProvider.getMenuItems(this._canvas);
				//adding provider tasks to the custom toolbar
				var addChildCount = 0;
				for (var i=0; i<toolbarTasks.length; i++) {
					// Do not add view specific tasks to custom toolbar
					if (toolbarTasks[i].launchType == "VIEW_COMMAND")
						break;
					if(!this._toolbar){
						this._toolbar=new ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar({
							id: this.id + "_Toolbar",
							region: "top",
							topology: this
						});
					}	
					if (!this._toolbarProviderEntries) {
						//Create toolbar entries data struct
						this._toolbarProviderEntries = [];
					} else {
						//Remove all of the previously added provider entries from the toolbar and clear array
						for (var j = 0; j < this._toolbarProviderEntries.length; j++) {
							this._toolbar.removeChild(this._toolbarProviderEntries[j]);
							this._toolbarProviderEntries[j].destroyRecursive();
						}
						this._toolbarProviderEntries.splice(0); //Clear out the array
					}
					if (toolbarTasks[i].actionID == "_separator_") {
						var separator = new dijit.ToolbarSeparator();
						this._toolbar.addChild(separator, addChildCount++);
						this._toolbarProviderEntries.push(separator); //Keep track of separator
			    	} else {
			    		var button = null;
			    		if(toolbarTasks[i].submenu_items){
			    			var dropdownMenu = new dijit.Menu();
			    			var params = {
			    	        		provider: this.cmProvider,
			    					dropDown: dropdownMenu					
			    			};
			    			dojo.mixin( params, toolbarTasks[i] );
			    			button = new dijit.form.DropDownButton(params);
			    			this._addItemsToMenu(dropdownMenu,toolbarTasks[i].submenu_items);
			    		} else {
			    	        var params = {
			    	        		adapter: this,
			    	        		onClick: function() {
			    	        			this.adapter.cmProvider.getMenuCommand(this.actionID,this.adapter._canvas,this);
			    	        		}
			    	        };
			    	        dojo.mixin( params, toolbarTasks[i] );
			    	        button = new dijit.form.Button(params);
			    		}
			    		this._toolbar.addChild(button, addChildCount++);
			    		this._toolbarProviderEntries.push(button); //Keep track of button
			    	}
				}
	 		}
	 		
	 		//Mark we're done loading toolbar tasks and make another request if necessary
	 		this._dealWithLoadingToolbarTasksNextCallback();
		},
		
		_createWidgetDefPortionOfToolbar: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		private
			
			if(this.widgetDefinition){
				//adding widget definition toolbar contents
				var toolbars = this.widgetDefinition.getToolbarRows();
				if(toolbars){
					if(!this.widgetDefinition.isToolbarHidden()){
						for(var i=0;i<toolbars.length;i++){							
							if(!this._toolbar){
								this._toolbar=new ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar({
									id: this.id + "_Toolbar",
									region: "top",
									topology: this
								});
							} else if(toolbars.length==1) {
								//There is only default toolbar in widget defs and custom toolbar with provider tasks exists
								this._toolbar.addChild(new ibm.tivoli.tip.navwidget.topology.dijit.TopologyLineBreak());
							}
							if(i>0){
								this._toolbar.addChild(new ibm.tivoli.tip.navwidget.topology.dijit.TopologyLineBreak());
							};
							var item = null;
							var toolbarContents = toolbars[i].contents;
							for (var j = 0; j < toolbarContents.length; j++){
								this._toolbar.addItem(toolbarContents[j]);
							}
						}
					}
				}
			} else {
				//Widget definitions not available. Creating default toolbar.
				if(!this._toolbar){
					this._toolbar = new ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar({
						id: this.id + "_Toolbar",
						region: "top",
						topology: this
					});
				} else {
					//Custom toolbar containing provider tasks already exists so let's break the line
					this._toolbar.addChild(new ibm.tivoli.tip.navwidget.topology.dijit.TopologyLineBreak());
				}
				this._toolbar.createDefault();
			}
		},

		_createCMProvider: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		private
			if (!this.cmProvider) {
                var helper = new ibm.tivoli.tip.navwidget.topology.dijit.MenuProviderHelper();
				this.cmProvider = new ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider({
		                                     view: this,
		                                     getMenuItemsCallback: dojo.hitch(helper, helper.getMenuItems),
		                                     getMenuCommandCallback: dojo.hitch(helper, helper.getMenuCommand)
		                });
			}
			this.cmProvider.viewWithToolbar = this;	
			dojo.safeMixin(this.cmProvider, {
	        	// Override base functions
				augmentRequestCategory: function(category) {
					if(category.indexOf("toolbar")>=0){
						this.viewWithToolbar.setRefreshToolbar(false);
					} else {
						if(this.viewWithToolbar.isRefreshToolbar()){
							// If toolbar tasks need to be refreshed (selection changed event)
							// retrieve also toolbar tasks from provider and cache them
							category = category + ",toolbar";
						}
					}						
					return category;
				},
				filterTasks: function(tasks) {						
					var filteredTasks = [];
			  		if(this.viewWithToolbar.isRefreshToolbar()){				  			
			  			//Create toolbar cache task... prior to fixing 252893, _cachedToolbarTasks was created only if a toolbar task was found. So, if
			  			//no toolbar tasks, other code looking to see if _cachedToolbarTasks was not null incorrectly assumed all menu items were toolbar tasks.
						if(!this.viewWithToolbar._cachedToolbarTasks) { 
							this.viewWithToolbar._cachedToolbarTasks = [];
						}
						for (i=0;i<tasks.length;i++) {
							var category = tasks[i].getCategory();
							if(category=="toolbar" || category=="toolbar:button" || category=="toolbar:menu"){
								// add toolbar tasks to cache
								this.viewWithToolbar._cachedToolbarTasks.push(tasks[i]);									
							} else {
								filteredTasks.push(tasks[i]);
							}
						}
					} else {
						filteredTasks = tasks;
					}

		 	        // Perform refreshing toolbar tasks if needed
					if(this.viewWithToolbar.isRefreshToolbar()){
						this.viewWithToolbar._refreshProviderToolbarTasks(true);
						this.viewWithToolbar.setRefreshToolbar(false);
					}

					return filteredTasks;
				}					
			});			
		},

		_setDatasetCreatePluggableViewsPreviouslyCalled: false, //Flag to keep track of whether we've create pluggable views at least once
		_setDatasetCreatePluggableViews: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		private
			
			//See if we've been called before
			if (this._setDatasetCreatePluggableViewsPreviouslyCalled) {
				return;
			}
			
			var id = this.id + "_Canvas";

			var canvasCreationArgs = {
					id: id,
					viewId: "CANVAS_VIEW",
					parentPluggableView: this,
					region: "center",
					dataset: this.dataset,
					cmProvider: this.cmProvider,
					daHelper: this.daHelper,
					widgetDefinition: this.widgetDefinition,
					_EMPTY_DATASET_STRING: this.commonResources.EMPTY_DATASET
			};
			dojo.mixin( canvasCreationArgs, this._canvasOverrides );
			if (!this._canvasOverrides || !this._canvasOverrides.useDojoDiagrammer) {
				this._canvas = new ibm.tivoli.tip.navwidget.topology.dijit.Canvas(canvasCreationArgs);
			} else {
				dojo["require"]('ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas'); //253309
				this._canvas = new ibm.tivoli.tip.navwidget.topology.dijit.DiagrammerCanvas(canvasCreationArgs);
			}
			
			// Set the tab index for canvas so it will take the focus on keyboard navigation
			// and assign it a label for the screen reader and the role application to tell
			// the screen reader that this area contains an embedded "application", in this case, Flash
			dojo.attr(this._canvas.domNode,"tabIndex",0);  
	        dojo.attr(this._canvas.domNode, "aria-label", this.commonResources.TOPOLOGY_VIEW);  
	        dojo.attr(this._canvas.domNode, "role", "application");   
			
			// Style the canvas to take up as much space as it can since it is in the center of our border container
			if(this.widgetDefinition && this.widgetDefinition.getIncludeFooter() || !this.widgetDefinition){
				// The footer exists - canvas cannot take 100% of height
				dojo.style(this._canvas.domNode, {height: "", width: "100%"});				
			} else {
				// The footer does not exist - let's grab all the space for the canvas
				dojo.style(this._canvas.domNode, {height: "100%", width: "100%"});
			}
			
			//Set up some listeners, etc.
			var chainSelectionChanged = function (objectContext) {
				if (!this.selection.isChanging()) {
					//Forward the selection event on
					this.selection.chainSelectionChanged(objectContext);
				}
				
				// to update the footer counts
				this.updateFooterCount();
				
				//update toolbar tasks
				if(this.cmProvider && this._toolbar){	
					if(this.getPostponeToolbarTasksRefresh()){
						this.setRefreshToolbar(true);
					} else {
						this._loadToolbarTasks(dojo.hitch(this, this._refreshProviderToolbarTasks));
					}
				}
			};
			dojo.connect(this._canvas.selection, "onSelectionChanged", this, chainSelectionChanged);
			
			//Listen for user clicking Ctrl-p while Flash plugin has keyboard focus
			var keyboardPrintHandler = function() {
				if (this._toolbar) {
					this._toolbar.openPrintDialog();
				}
			};
			dojo.connect(this._canvas, "_onKeyboardPrint", this, keyboardPrintHandler);
			
			//Listen for user clicking Ctrl-s while Flash plugin has keyboard focus
			var keyboardSaveHandler = function() {
				if (this._toolbar) {
					this._toolbar.saveCanvas();
				}
			};
			dojo.connect(this._canvas, "_onKeyboardSave", this, keyboardSaveHandler);

			//Track canvas as a pluggable view so it gets notified of everything that's going on
			this.addPluggableView(this._canvas);
			
			//Remember we've been called
			this._setDatasetCreatePluggableViewsPreviouslyCalled = true;
			
			//Let's NOT call superclass
			//this.inherited(arguments);
		},
		
		isApplicable: function(/*ibm.tivoli.navmodel.Dataset*/dataset){
			// Primarily interested in the following view types:
	        //	return viewType == "graph" || viewType == "tree" || viewType == "tree:reverse";
			return this.inherited(arguments);
		},
		
		saveWidgetDelta: function(){
			// summary:
			//		Save any changes to the user delta of the current widget def's for the view.
			// description:
			//		Save any changes to the user delta of the current widget def's for the view.
			// tags:
			//		public
			
			//Update the layouts in the widget def
			if(this.widgetDefinition){
				this.widgetDefinition.updateLayouts(this.getLayouts());

				// reset so we can re-get from widgetdef on next usage
				this._layout = null;
			}
			
			//Call super class to actually do the save
			this.inherited(arguments);
		},

		clearWidgetDelta: function(){
			// summary:
			//		Clear information from user delta of the current widget def's for the view.
			// description:
			//		Clear information from user delta of the current widget def's for the view.
			// tags:
			//		public
			if(this.widgetDefinition){
				this.widgetDefinition.clearLayouts();								
			}
			
			//Call super class to actually do the save
			this.inherited(arguments);

			this._resetLayout();
		},

		//*************************************************************
		// "Protected" functions overridden from NavWidgetPluggableView
		//*************************************************************	
		_setDatasetLoadData: function(/*ibm.tivoli.navmodel.Dataset*/ dataset){		
			// summary:
			//		Coming soon
			// description:
			//		Added since its needed to update the footer count 
			// 	for every refresh
			// dataset:
			//		Coming soon
			// tags:
			//		protected
			this.inherited(arguments);
			
			// updating the footer counts	
			this.updateFooterCount();
			
			// update the date and time 
			this.updateDateFooter();
			
			//The canvas will automatically get it's dataset set by superclass
			//this._canvas.setDataset(dataset);
			
			// Recreate toolbar when new dataset so that toolbar params get updated
			this.updateToolbar();
		},
		
		_setDatasetProcessWidgetDefs: function(/*ibm.tivoli.navmodel.Dataset*/ dataset){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// dataset:
			//		Coming soon
			// tags:
			//		protected

			// Pass the new widget def to the canvas
			if (this.isSetDatasetNewWidgetDef()){
				this._canvas.widgetDefinition = this.widgetDefinition;
			}

			//If we have no toolbar or we have a new widget def, let's create
			if (!this._toolbar || this.isSetDatasetNewWidgetDef()){
				this.recreateToolbar();
			} else {
				this.recreateProviderPortionOfToolbar();
			}
			
			//If we have no filterRow or we have a new widget def, let's create
			if (!this._filterRow || this._setDatasetNewWidgetDef) {
				this.recreateFooter();
			} else {
				this._filterRow.rebuildStatusFilters();
	    		this.clearAllFilters();
	    		this.updateFooterCount();
			}
		},
		
		getToolbarItems: function(context)
		{		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// context:
			//		
			
			// Return Toolbar tasks (check in cache first)
			var toolbarTasks = this._cachedToolbarTasks;
			if(toolbarTasks){
				this._cachedToolbarTasks = null;
				return this.cmProvider.tasksAsMenuJson(toolbarTasks);
			} else {
				return this.cmProvider.getMenuItems(context);
			}
		},		

		setRefreshToolbar: function(newValue){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// newValue:
			//		
			this._refreshToolbar = newValue;
		},
		
		isRefreshToolbar: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			return this._refreshToolbar;
		},
		
		setPostponeToolbarTasksRefresh: function(postpone){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// postpone:
			//		
			this._postponeTasksRefresh = postpone;
		},
		
		getPostponeToolbarTasksRefresh: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			return this._postponeTasksRefresh;
		},

		_getStateData: function() {
			// summary:
			//		Returns an object of the implementer's choosing which will be put in the 
			//		NavWidgetBaseViewState returned by getState.
			// description:
			//		Coming soon
			// tags:
			//		protected
			
			//Create data structure to hold state data like the visible view rect, etc.
			var stateData = {};

			//Make copy of the active filters so we can reapply if we come back to view this dataset again
			var savedFilters = [];
			for(i in this._activeFilters){
				savedFilters.push(dojo.clone(this._activeFilters[i]));
			}
			stateData.savedFilters = savedFilters;
		
			//Return state data
			return stateData;
		},
		
		restoreFromState: function(/*Object*/ viewState) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// viewState:
			//		Coming soon
			// tags:
			//		protected
	
			//Reapply the saved filters
			if (viewState) {
				var stateData = viewState.stateData;
				if (stateData && stateData.savedFilters) {
					//Apply filters individually
					for(i in stateData.savedFilters){
						this.applyFilter(stateData.savedFilters[i]);
					}
				}
			}
			
			//Call super
			this.inherited(arguments);
		},

	    getRolloverTarget: function() {
			// summary:
			//		Returns the graph entity under the mouse cursor in the topology canvas
			// description:
			//		This accessor returns the item (node), link, or relationship under the mouse
			//      cursor in the topology graph.  This can be used when overriding what is
			//      displayed in the tooltip for the entity.
			return this._canvas ? this._canvas.getRolloverTarget() : null;
		},
			
	    getTooltip: function() {
			// summary:
			//		Returns the tooltip instance used for the topology view canvas.
			// description:
			//		This accessor returns the ibm.tivoli.tip.navwidget.dijit.CustomContentTooltip instance
			//      used to display tooltips for all entities in the topology graph.
			return this._canvas ? this._canvas.getTooltip() : null;
		},
		
		//***************************
		// "Public" functions
		//***************************
		createFilterRow: function (footerCount){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			
			if(footerCount==null || footerCount<0)
				footerCount=0;
			
			if(this.widgetDefinition && this.widgetDefinition.getIncludeFooter() || !this.widgetDefinition){
				this._filterRow = new ibm.tivoli.tip.navwidget.topology.dijit.TopologyFilterRow({
					topology: this,
					region: "bottom",
					id: this.id + "_footer",
					filteredItemCount: footerCount // filtered item count
				});
				
				if(this._canvas){
					// The footer exists so update canvas height (this will happen only during navigation)
					this._canvas._setStyleAttr({width: "100%", height:""});
				}
				if(this._filterRow){
					this.addChild(this._filterRow, this.getChildren().length);  // make the filter row the last child
				}								
			} else {
				if(this._canvas){
					// There is no footer so update canvas height to grab all the available space (this will happen only during navigation)
					this._canvas._setStyleAttr({width: "100%", height:"100%"});
				}
			}
		},
		
		recreateFooter: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			if(this._filterRow){
				this.removeChild(this._filterRow);
				this._filterRow.destroyRecursive();
				this._filterRow=null;
			} 
			this.createFilterRow();
		},
		
	 	recreateToolbar: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			if(this._toolbar){
				this.removeChild(this._toolbar);
				this._toolbar.destroyRecursive();
				this._toolbar=null;
			}
			this._loadToolbarTasks(dojo.hitch(this, this._toolbarTasksLoaded));
	 	},

	 	updateToolbar: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			if(this._toolbar){
				this._toolbar.updateToolbar();
			}
	 	},
	 	
	 	_loadToolbarTasks: function(callback) {
	 		if (!this._loadingToolbarTasks) {
	 			this.cmProvider.getMenuItemsAsynch(this, callback, "toolbar");
	 			this._loadingToolbarTasks = true;
	 		} else {
	 			this._loadingToolbarTasksNextCallback = callback;
	 		}
	 	},
	 	
	 	//Mark we're done loading toolbar tasks and make another request if necessary
 		_dealWithLoadingToolbarTasksNextCallback: function() {
	 		if (this._loadingToolbarTasks) {
	 			this._loadingToolbarTasks = false;
	 			//Selection may have changed while we were loading provider tasks and building up toolbar, and someone
	 			//else may have wanted to make the request
	 			if (this._loadingToolbarTasksNextCallback) {
		 			var nextCallback = this._loadingToolbarTasksNextCallback;
		 			this._loadingToolbarTasksNextCallback = null;
		 			this._loadToolbarTasks(dojo.hitch(this, nextCallback));
	 			}
	 		}
 		},
	 	
	 	recreateProviderPortionOfToolbar: function() {
			//Don't need to totally recreate the toolbar, but do need to update the provider tasks (which are determined by the new dataset)
			this._loadToolbarTasks(dojo.hitch(this, this._createProviderPortionOfToolbar));
	 	},

		print: function(/*int*/ pageCount, /*Object*/ pageMargin, /*Object*/ printAsBitmap){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	 		// pageCount:
	 		//		Coming soon
	 		// pageMargin:
	 		//		Coming soon
	 		// printAsBitmap:
	 		//		Coming soon
			// tags:
			//		public
			this._canvas.print(pageCount, pageMargin, printAsBitmap);
		},
	 			
		zoomIn: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			this._canvas.zoomIn();
		},
		
		zoomOut: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			this._canvas.zoomOut();
		},

		setZoomLevel: function(/*float*/ zoomLevel){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			this._canvas.setZoomLevel(zoomLevel);
		},

		setZoomTo: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Number*/ zoomLevel){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public						   
			this._canvas.setZoomTo(itemIds, linkIds, relationshipIds, zoomLevel);
		},

		setMouseMode: function(/*Object*/ mode){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// mode:
			//		Coming soon
			// tags:
			//		public
			this._canvas.setMouseMode(mode);
		},
		
		fitContents: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			this._canvas.fitContents();
		},
		
		performLayout: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			this._canvas.performLayout();
		},
		
		exportAsImage: function(/*Object*/dialogTitle, /*Object*/questionText, /*Object*/pngOptionLabel, /*Object*/jpgOptionLabel, /*Object*/exportButtonLabel, /*Object*/cancelButtonLabel, /*Object*/baseDefaultFileName){		
			// summary:
			//		Causes diagram contents to be exported as an image. 
			// description:
			//		Causes diagram contents to be exported as an image. 
			// tags:
			//		public
			
			this._canvas.exportAsImage(dialogTitle, questionText, pngOptionLabel, jpgOptionLabel, exportButtonLabel, cancelButtonLabel, baseDefaultFileName);
		},
		
	  	getLayoutIconClass: function(/*String*/ alg){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// alg:
			//		Coming soon
			// tags:
			//		public
	  		if(alg == "tree"){
	  			return "symmetricalLayoutIcon";
	  		} else if (alg == "hierarchical"){
	  			return "hierarchicalLayoutIcon";
	  		} else if (alg == "shortLink"){
	  			return "shortLinkLayoutIcon";
	  		} else if (alg == "longLink"){
	  			return "longLinkLayoutIcon";
	  		} else if (alg == "forceDirected") {
	  			return "radialLayoutIcon";
	  		} else if (alg == "grid") {
				return "orthogonalLayoutIcon";
	  		} else if (alg == "custom") {
	  			return "customLayoutIcon";
			} else {
				return "hierarchicalLayoutIcon";
			}
	  	},

		setLayoutAlgorithm: function(/*String*/ alg, /*String*/ subgraphId, /*Object*/ performLayout) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	  		// alg:
	  		//		Coming soon
	  		// subgraphId:
	  		//		Coming soon
	  		// performLayout:
	  		//		Coming soon
			// tags:
			//		public
			this._canvas.setLayoutAlgorithm(alg, subgraphId, performLayout);
		},

		setLayoutParams: function(/*Object*/ params, /*String*/ subgraphId, /*Object*/ performLayout) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
	  		// params:
	  		//		Coming soon
	  		// subgraphId:
	  		//		Coming soon
	  		// performLayout:
	  		//		Coming soon
			// tags:
			//		public
			this._canvas.setLayoutParams(params, subgraphId, performLayout);
		},
		
		getAvailableLayoutParams: function(/*String*/ alg) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// alg:
			//		Coming soon
			// tags:
			//		public
			return this._canvas.getAvailableLayoutParams(alg);
		},
		
		getLayouts: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			if(this.widgetDefinition){
				return this.widgetDefinition.getLayouts();
			} else {
				return null;
			}
		},

		getLayoutById: function(/*String*/ id){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			var layout = null;
			var layouts = this.getLayouts();
			if (layouts) {
				for(var i=0;i<layouts.length;i++) {
					if (layouts[i].id === id) {
						layout = layouts[i];
						break;
					}
				}
			}
			
			return layout;
		},
		
		getLayoutByName: function(/*String*/ name){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			var layouts = this.getLayouts();
			var layout = null;
			if (layouts) {
				for (var i=0;i<layouts.length;i++) {
					if (layouts[i].algorithm == name) {
						layout = layouts[i];
						break;
					}
				}
			}	
			return layout;
		},

		getDefaultLayoutId: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			var defaultLayoutId = null;

			// get from widget definition
			if(this.widgetDefinition){
				defaultLayoutId = this.widgetDefinition.getDefaultLayoutId();
			};

			// dataset can override
			if (this.dataset) {
				var alg = this.dataset.getAttribute("layoutAlgorithm");		
				if (alg){
					// make sure we have this layout
					var layoutId = this.getLayoutId(alg);
					if (layoutId){
						defaultLayoutId = layoutId;
					}
				}	
			}

			// default to first layout if no information located
			if (!defaultLayoutId) {
				var layouts = this.getLayouts();
				if (layouts && layouts.length > 0) {
					defaultLayoutId = layouts[0].id;
				}
			}

			return defaultLayoutId;
		},

		getDefaultLayoutIndex: function(){			
			var layouts = this.getLayouts();
			if (layouts) {
				var defaultLayoutId = this.getDefaultLayoutId();
				for (var i=0;i<layouts.length;i++) {
					if (layouts[i].id === defaultLayoutId){
						return i;
					}
				}
			}

			return -1;
		},
			
		getLayoutId: function(/*String*/ layoutAlg) {
			var layouts = this.getLayouts();
			var layoutId = null;
			if (layouts != null) {
				for(var i=0;i<layouts.length;i++){
					if (layouts[i].algorithm == layoutAlg)
						layoutId = layouts[i].id;
				}		
			}
			return layoutId;
		},

		getLayout: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			if (this._layout == null) {	
				this._layout = this.getLayoutById(this.getDefaultLayoutId());
			}

			return this._layout;
		},
				
		_resetLayout: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			var menu = dijit.byId(this.id + "_layoutMenu");
			var defaultLayoutIndex = this.getDefaultLayoutIndex();
			var defaultLayout = this.getLayouts()[defaultLayoutIndex];
			
			//Set layout in toolbar
			this._toolbar.setLayoutSelection(defaultLayout);
			
			//Set layout on canvas
			this._setLayout(defaultLayout);
		},
		
		restoreCurrentLayout: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			var layout = this.getLayout();
			
			//Set layout in toolbar
			this._toolbar.setLayoutSelection(layout);
			
			//Set the layout on canvas
			this._setLayoutToCanvas(layout);
		},
  		
		_setLayoutToCanvas: function(/*Object*/ layout){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// layout:
			//		Coming soon
			// tags:
			//		public
			var layoutParams = this.getAvailableLayoutParams(layout.algorithm);
			var layoutParamsArray = new Array(layoutParams.length);
			for (var i=0;i<layoutParams.length;i++) {
				layoutParamsArray[i] = new Array(3);
				if(layout[layoutParams[i][0]]){
					layoutParamsArray[i][0] = layout.algorithm; 
					layoutParamsArray[i][1] = layoutParams[i][0];
					layoutParamsArray[i][2] = layout[layoutParams[i][0]];
				} else {
					layoutParamsArray[i][0] = layout.algorithm;
					
					var params = layoutParams[i][1].split("|");		  
					layoutParamsArray[i][1] = layoutParams[i][0];
					layoutParamsArray[i][2] = params[0];
					layout[layoutParams[i][0]] = params[0];
				}
			}
			this._canvas.setLayoutAlgorithm(layout.algorithm, null, false);
			this._canvas.setLayoutParams(layoutParamsArray, null, true); //Pass true on the last one so we only perform the layout once
		},
		
		_setLayout: function(/*Object*/ layout){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// layout:
			//		Coming soon
			// tags:
			//		public
			this._setLayoutToCanvas(layout);
			this._layout = layout;
		},
		
		setLayoutEventHandler: function(/*Object*/ event){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			// tags:
			//		public
			var layoutId = event.layoutId;
			var layoutMenuId = (layoutId ? this.id + "_LayoutMenuItem_" + layoutId : null);
			if (!layoutId) {
				var layoutMenuItem = event.target;				
				while(!layoutMenuItem.parentNode.parentNode.id || layoutMenuItem.parentNode.parentNode.id!=this.id + "_layoutMenu"){
					layoutMenuItem=layoutMenuItem.parentNode;
				};
				layoutId = layoutMenuItem.id.substring(layoutMenuItem.id.lastIndexOf('_')+1);
				layoutMenuId = layoutMenuItem.id;
			}

			var layouts = this.getLayouts();
			for(var i=0;i<layouts.length;i++){
				if(layouts[i].id==layoutId){
					//set layout on canvas
					this._setLayout(layouts[i]);	
					layouts[i].isDefault = true; //Change this one to be the default
					
					//Set layout in combo button
					this._toolbar.setLayoutSelection(layouts[i]);
				} else {
					//If any others were marked as the default, we want to make sure we clear them out
					layouts[i].isDefault = false;
				}
			};
			
			//update layout menu view
			this._toolbar.enableLayoutCustomization();
		},

		getMaxDepth: function() {
			// summary:
			//		Coming soon
			// description:
			//		Get from dataset; widgetDef should set depth, maxDepth on init
			// tags:
			//		public
			
			var maxDepth = -1;
			if (this.dataset) {
				maxDepth = this.dataset.getMaxDepth();	
			}
			return maxDepth;
		},

		getDepth: function() {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			
			var depth = -1;
			if (this.dataset) {
				depth = this.dataset.getDepth();
			}
			return depth;
		},

		setDepth: function(/*int*/ depth) {	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// depth:
			//		Coming soon
			// tags:
			//		public	
			this.dataset.setDepth(depth);
		},

		applyFilter: function(/*Object*/ filter){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// filter:
			//		Coming soon
			// tags:
			//		public
			
			if (!filter) {
				return;
			}
			
			if(!this._activeFilters){
				this._activeFilters = [];
			}
			if(this._activeFiltersCount == 0){
				//If we have done a search, we want to make sure it gets cleared out...
				
				//Clear out the list of highlighted items
				this._highlightedItems.clear(); 
				
				//Re-enable everything
				this._setAllEnabled();
			}
			
			// if cache expires then we have to fetch the items; since we can't
			// be sure that all the items are currently in the cache
			if (this.dataset.cacheExpires()) {
				//Define a callback that fires when all the items are returned.
				var gotItems = function(items, links){
					this._applyFilter(filter, items, links);
				};

				var gotItemsError = function(error, request){
					//Give the user some feedback
	            		this.displayException(error);
				};			
			
				//Fetch the items and links to then later filter them
				var itemArgs = {
					onComplete: dojo.hitch(this,gotItems),
					onError: dojo.hitch(this, gotItemsError),
					recursive: true
				};
				this.dataset.getItemsAndLinks(itemArgs);
			}
			// no need to re-request items from server;  just get them from the cache
			else {
				this._applyFilter(filter, this.dataset.getCachedItems(true), this.dataset.getCachedLinks(true));
			}
		},

		_applyFilter: function(/*Object*/ filter, /*ibm.tivoli.navmodel.Item[]*/ items, /*ibm.tivoli.navmodel.Link[]*/ links) {
			var itemIdsToEnable  = [];
			var itemIdsToDisable = [];
			var linkIdsToEnable  = [];
			var linkIdsToDisable = [];
			var relIdsToEnable   = [];
			var relIdsToDisable  = [];
			var useRelationships = this.widgetDefinition.getRenderRelationshipsInsteadOfLinks();
			var relationships = [];

			// pull relationships out of links
			if (useRelationships) {
				for(l in links){
					var link = links[l];
					relationships = relationships.concat(link.getRelationships());					
				}
			}

			// items
			for(i in items){								
				var attr = items[i].getAttribute(filter.filterOn);
				if (attr) {
					if(filter.filterOn == "status"){
						attr = attr[0].value;
					}
					var item = items[i];
					var absItemId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemAbsoluteId(item);
					if(attr==filter.value){
						this._highlightedItems.add(absItemId, item); //Keep track of the actual set of filtered items
						itemIdsToEnable.push(absItemId);
					} else {
						if (!this._highlightedItems.item(absItemId, item)) {
							itemIdsToDisable.push(absItemId); //Only disable if not part of another active filter
						}
					}
				}
			}

			// relationships
			if (useRelationships) {
				for (r in relationships) {
					var relationship = relationships[r];
					var attr = relationship.getAttribute(filter.filterOn);
					if (attr) {
						if(filter.filterOn == "status"){
							attr = attr[0].value;
						}
					
						var absRelId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getRelationshipAbsoluteId(relationship);
						if(attr==filter.value){
							this._highlightedItems.add(absRelId, relationship); 
							relIdsToEnable.push(absRelId);
						} 	
						else if (!this._highlightedItems.item(absRelId, relationship)) {
							relIdsToDisable.push(absRelId); 
						}						
					}
				}
			}
			// links
			else {
				for(l in links){
					var link = links[l];											
					var attr = link.getAttribute(filter.filterOn);
					if (attr) {
						if(filter.filterOn == "status"){
							attr = attr[0].value;
						}
				
						var absLinkId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getLinkAbsoluteId(link);
						if(attr==filter.value){
							this._highlightedItems.add(absLinkId, link); 
							linkIdsToEnable.push(absLinkId);
						} 
						else if (!this._highlightedItems.item(absLinkId, link)) {
							linkIdsToDisable.push(absLinkId); 					
						}
					}			
				}
			}
			
			if(this._activeFilters.length==0){
				// Disable all the rest if it's the first filter applied
				this._setEnabledObjectIds(itemIdsToDisable, /*linksIds*/ linkIdsToDisable, /*relsIds*/ relIdsToDisable, false);
			}			

			// Enable filtered element
			this._setEnabledObjectIds(itemIdsToEnable, /*linksIds*/ linkIdsToEnable, /*relsIds*/ relIdsToEnable);
			
			// Add filter to the active filters
			this._activeFilters[filter.filterOn + "_" + filter.value]=filter;		
			this._activeFiltersCount = this._activeFiltersCount + 1; 
			
			//Press button that should be pressed
			this._filterRow.setCheckedFilter(filter);
			
			//Deselect everything on a filter change
			this.selection.deselectAll();
				
			// update footer with the filter count
			this.updateFooterCount();
		},
		
		clearFilter: function(/*Object*/ filter){	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// filter:
			//		Coming soon
			// tags:
			//		public		

			// Remove filter from active filters
			this._activeFilters[filter.filterOn + "_" + filter.value] = null;
			this._activeFiltersCount = this._activeFiltersCount - 1; 
			
			//Clear out the list of filtered items
			this._highlightedItems.clear(); 
			
			if(this._activeFiltersCount == 0){					
				// Enable all since no filters applied
				this._setAllEnabled();
				
				// update footer with the filter count
				this.updateFooterCount();
			} 
			else {
				// if cache expires then we have to fetch the items; since we can't
				// be sure that all the items are currently in the cache
				if (this.dataset.cacheExpires()) {		
					//Define a callback that fires when all the items are returned.
					var gotItems = function(items, links){
						this._clearFilter(filter, items, links);	
					};

					var gotItemsError = function(error, request){
						//Give the user some feedback
		            		this.displayException(error);
					};
				
					//Fetch the items and links to then later filter them
					var itemArgs = {
						onComplete: dojo.hitch(this,gotItems),
						onError: dojo.hitch(this, gotItemsError),
						recursive: true
					};
					this.dataset.getItemsAndLinks(itemArgs);
				}
				// no need to re-request items from server;  just get them from the cache
				else {
					this._clearFilter(filter, this.dataset.getCachedItems(true), this.dataset.getCachedLinks(true));
				}
			}
		},

		_clearFilter: function(/*Object*/ filter, /*ibm.tivoli.navmodel.Item[]*/ items, /*ibm.tivoli.navmodel.Link[]*/ links) {
			var itemIdsToEnable = [];
			var itemIdsToDisable = [];
			var linkIdsToEnable  = [];
			var linkIdsToDisable = [];
			var relIdsToEnable   = [];
			var relIdsToDisable  = [];			
			var useRelationships = this.widgetDefinition.getRenderRelationshipsInsteadOfLinks();
			var relationships = [];

			// pull relationships out of links
			if (useRelationships) {
				for(l in links){
					var link = links[l];
					relationships = relationships.concat(link.getRelationships());					
				}
			}
			
			for(i in this._activeFilters){
				if(this._activeFilters[i]!=null){
					// items
					for(j in items){
						var item = items[j];
						var absItemId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemAbsoluteId(item);
						var attr = item.getAttribute(this._activeFilters[i].filterOn);
						if(this._activeFilters[i].filterOn == "status"){
                     if (attr && attr[0] && attr[0].value) {     // 255172
                        attr = attr[0].value;
                     }
						}
						if(attr==this._activeFilters[i].value){
							this._highlightedItems.add(absItemId, item); //Keep track of the actual set of filtered items
							itemIdsToEnable.push(absItemId);
						} else {
							if (!this._highlightedItems.item(absItemId, item)) { 
								itemIdsToDisable.push(absItemId); //Only disable if not part of another active filter
							}
						}
					}

					// relationships
					if (useRelationships) {
						for (r in relationships) {
							var relationship = relationships[r];
							var absRelId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getRelationshipAbsoluteId(relationship);
							var attr = relationship.getAttribute(this._activeFilters[i].filterOn);
							if(this._activeFilters[i].filterOn == "status"){
                        if (attr && attr[0] && attr[0].value) {     // 255172
								   attr = attr[0].value;
                        }
							}
							if(attr==this._activeFilters[i].value){
								this._highlightedItems.add(absRelId, relationship); 
								relIdsToEnable.push(absRelId);
							} 
							else if (!this._highlightedItems.item(absRelId, relationship)) { 
								relIdsToDisable.push(absRelId); 
							}
						}
					}
					// links
					else {					
						for(l in links){
							var link = links[l];						
							var absLinkId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getLinkAbsoluteId(link);
							var attr = link.getAttribute(this._activeFilters[i].filterOn);
							if(this._activeFilters[i].filterOn == "status"){
                        if (attr && attr[0] && attr[0].value) {     // 255172
								   attr = attr[0].value;
                        }
							}
							if(attr==this._activeFilters[i].value){
								this._highlightedItems.add(absLinkId, link); 
								linkIdsToEnable.push(absLinkId);
							} 
							else if (!this._highlightedItems.item(absLinkId, link)) { 
								linkIdsToDisable.push(absLinkId); 
							}					
						}
					}
				}
			}
		
			this._setEnabledObjectIds(itemIdsToDisable, /*linksIds*/ linkIdsToDisable, /*relsIds*/ relIdsToDisable, false);
			this._setEnabledObjectIds(itemIdsToEnable,  /*linksIds*/ linkIdsToEnable,  /*relsIds*/ relIdsToEnable);
					
			// update footer with the filter count
			this.updateFooterCount();
		},
		
		clearAllFilters: function(){	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public	
			
			//Do bookkeeping and clear out the data structure for active filters
			this._activeFilters = [];
			this._activeFiltersCount = 0;
			
			//Remove all of the filtered items from data structure
			this._highlightedItems.clear();
				
			//Re-enable all objects in the graph
			this._setAllEnabled();
		
			//Unpress all of the filter buttons
			if (this._filterRow) {
				this._filterRow.uncheckAllFilters();
			}
			
			// update footer with the filter count
			this.updateFooterCount();
		},
		
		setHighlightedObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//Clear all filters
			this.clearAllFilters();
			
			//Disable everything
			this._setAllEnabled(false);
			
			//Keep track of the highlighted items, links, and relationships
			if (itemIds) {
				for (var i = 0; i < itemIds.length; i++) {
					var absItemId = itemIds[i];
					this._highlightedItems.add(absItemId, ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemByAbsoluteId(this.dataset, absItemId));
				}
			}
			if (linkIds) {
				for (var i = 0; i < linkIds.length; i++) {
					var absLinkId = linkIds[i];
					this._highlightedItems.add(absLinkId, ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getLinkByAbsoluteId(this.dataset, absLinkId));
				}
			}
			if (relationshipIds) {
				for (var i = 0; i < relationshipIds.length; i++) {
					var absRelationshipId = relationshipIds[i];
					this._highlightedItems.add(absRelationshipId, ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getRelationshipByAbsoluteId(this.dataset, absRelationshipId));
				}
			}
			
			//Re-enable based on args
			this._setEnabledObjectIds(itemIds, linkIds, relationshipIds);
			
			//Clear the selection with a change in what's highlighted
			this.selection.deselectAll();
			
			//Update footer
			this.updateFooterCount();
		},		
		
		clearAllHighlights: function() {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Clear all filters
			this.clearAllFilters();
		},
		
		reapplyFilters: function(){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			// tags:
			//		public
			
			//Remember the active filters
			var savedFilters = [];
			for(i in this._activeFilters){
				savedFilters.push(this._activeFilters[i]);
			}

			//Clear any existing highlights/filters
			this.clearAllFilters(true); //Pass in true because we want to keep the buttons pressed (if any were pressed) 
			
			//Reapply the saved filters
			for(i in savedFilters){
				this.applyFilter(savedFilters[i]);
			}
			
			//Update the footer count
			this.updateFooterCount();
		},
		
		_setEnabledObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds, /*Boolean*/enabled){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			// tags
			//		private
			
			if (enabled == undefined) {
				enabled = true;
			}
			this._canvas.setEnabledObjectIds(itemIds, linkIds, relationshipIds, enabled);
		},

		_setAllEnabled: function(/*Boolean*/enabled){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags
			//		private
			
			if (enabled == undefined) {
				enabled = true;
			}
			this._canvas.setAllEnabled(enabled);
		},
		
		_handleItemsAddedEvent: function(/*Object*/ event){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			// tags:
			//		public
			
			//Call super
			this.inherited(arguments);
			
			//Re-apply any filters
			setTimeout(dojo.hitch(this, this.reapplyFilters), 0); //Kind of a hack, but put on different thread to ensure new items are actually available on the flex side
		},
		
		_handleItemsRemovedEvent: function( event) {
			// summary:
			//		Coming soon
			// description:
			//		Added to handle the footer update 
			// when nodes are removed
			// event:
			//		Coming soon
			// tags:
			//		public
	
			//Call super
			this.inherited(arguments);
			
			//Reapply any filters
			this.reapplyFilters();
		},
		
		_handleLinksRemovedEvent: function( event) {
			// summary:
			//		Coming soon
			// description:
			//		Added to handle the footer update 
			// when nodes are removed
			// event:
			//		Coming soon
			// tags:
			//		public
	
			// update footer after removing items
			this.updateFooterCount();
			this.inherited(arguments);
		
		},
		
		_handleLinksAddedEvent: function( event) {
			// summary:
			//		Coming soon
			// description:
			//		Added to handle the footer update 
			// when nodes are added
			// event:
			//		Coming soon
			// tags:
			//		public
	
			// update footer after removing items
			this.updateFooterCount();
			//this.createFilterRow(this.dataset.getItemCount()-count.length);
			this.inherited(arguments);
		
		},
		
		_handleChangedEvent: function(event) {
			// summary:
			//		Coming soon
			// description:
			//		Added to handle the footer update
			// for Force change event
			// event:
			//		Coming soon
			// tags:
			//		public
		
		    // update footer after force changed event
			this.updateFooterCount();
			this.inherited(arguments);
		},

		updateFooterCount:function()
		{
			// summary:
			//		Coming soon
			// description:
			//		Added to handle the footer update
			// event:
			//		Coming soon
			// tags:
			//		public
				
			var labelToChange = dijit.byId(this.id + "_footer" + "_label");
		
			//Updating the footer counts
			if(labelToChange){
				var linkCount = 0;
				var itemCount = 0;
				var selectedCount = 0;
				
				if (this.dataset) { //251075
					var counts = {items: 0, links: 0, relationships: 0};
					this._getCounts(this.dataset, counts);
					itemCount = counts.items;
					linkCount = (this.widgetDefinition.getRenderRelationshipsInsteadOfLinks() ? counts.relationships : counts.links);
					
					//not same as above, obtained from the events counts for selected nodes/links
					selectedCount = this.selection.getTotalSelected(); 
				}

				var selectedCountLabel=this.commonResources.SELECTED_COUNT;
				var selectedCountValue=selectedCount;
				var selectedCountMsg=dojo.string.substitute(selectedCountLabel, {value1:selectedCountValue});
			
				var resourcesCountLabel=this.commonResources.RESOURCES_COUNT;
				var resourcesCountValue=itemCount;
				var resourcesCountMsg=dojo.string.substitute(resourcesCountLabel,{value2:resourcesCountValue});
				
				var relationshipsCountLabel=this.commonResources.RELATIONSHIP_COUNT;
				var relationshipsCountValue=linkCount;
				var relationshipsCountMsg=dojo.string.substitute(relationshipsCountLabel,{value3:relationshipsCountValue});
				
				var filteredCountLabel=this.commonResources.FILTERED_COUNT;
				var filteredCountValue=this._highlightedItems.count;
				var filteredCountMsg=dojo.string.substitute(filteredCountLabel,{value4:filteredCountValue});  
				
				var dir = this._isRightToLeft();
				
				var newText = dir ? filteredCountMsg + " " + relationshipsCountMsg + " " + resourcesCountMsg + " " + selectedCountMsg
						: selectedCountMsg+" "+resourcesCountMsg+" "+relationshipsCountMsg+" "+filteredCountMsg;
				labelToChange.setLabelText(newText); 
			}
		},
	
		_getCounts: function(dataset, counts) {
			counts.items += dataset.getItemCount();
			counts.links += dataset.getLinkCount();
			counts.relationships += dataset.getRelationshipCount();		
		},			
		
		_isRightToLeft: function() {
			var dir = dojo.query("body").attr("dir");
			if (dir) return dir == "rtl";
			return false;
		},
		
		updateDateFooter: function()
		{
		// summary:
			//		Coming soon
			// description:
			//		Added to handle the date update for change in dataset
			// event:
			//		Coming soon
			// tags:
			//		public
				
			var dateLabel=dijit.byId(this.id+ "_footer" + "_dateLabel");
			
			// refresh date/ time only when the dataset changes
			var date=dojo.date.locale.format( new Date(),{selector:['date'],formatLength:'short'});
			var time=dojo.date.locale.format( new Date(),{selector:['time'],formatLength:'medium'});
			var finalLabel=date+" "+time;
			
			if(dateLabel)
				dateLabel.setLabelText(finalLabel);
			
			},
			
			
		_datasetEventListenerCallback: function (/*Object*/ listenerObj, /*Object*/ event) {
				// summary:
				//		Callback for when there are changes within the Dataset we've registered to listen for updates to.
				// listenerObj:
				//		An object representing the listener registered with the Dataset.
				// event:
				//		An object containing information about what changed in the Dataset.
				// description:
				//		Callback for when there are changes within the Dataset currently being rendered. It will call one of the 
				//		specific handlers based on the change type in the Event. Overiding this function to update the date and time
				//      when the dataset changes for the various events
				// tags:
				//		private
				
				// update the date
				this.updateDateFooter();
				
				//call super to do the rest of the event dispatching
				this.inherited(arguments);
			},

			
		_handleItemStatusChangedEvent: function(/*Object*/ event){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// event:
			//		Coming soon
			// tags:
			//		public
			
			//Call super
			this.inherited(arguments);
				
			//Reapply any filters
			this.reapplyFilters();
			
		}

	});
