/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dojo.CanvasBridgeDatasetUtil");

dojo.require("dojox.collections.Dictionary");

//Dataset-related requires
dojo.require("ibm.tivoli.navmodel.Dataset");
dojo.require("ibm.tivoli.navmodel.Item");
dojo.require("ibm.tivoli.navmodel.Link");
dojo.require("ibm.tivoli.navmodel.Task");
dojo.require("ibm.tivoli.navmodel.TopoWidgetDef");
dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
ibm.tivoli.tip.navwidget.topology.dojo.CanvasBridgeDatasetUtil._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.topology.dojo.CanvasBridgeDatasetUtil");

dojo.declare("ibm.tivoli.tip.navwidget.topology.dojo.CanvasBridgeDatasetUtil", null,
	{		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
	
		//***************************
		// "Public"
		//***************************
		
		// dataset: [public] ibm.tivoli.navmodel.Dataset
		//		Coming soon
		dataset: null,	
	
		// _widgetDefinition: [public] Object
		//		the widget definition
		_widgetDefinition:null,
		
		//***************************
		// "Private"
		//***************************
		
		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
		_trace: ibm.tivoli.tip.navwidget.topology.dojo.CanvasBridgeDatasetUtil._trace,
		
		// _args: [private] Object
		//		Coming soon
		_args: null,
		
		// _bridgeDataset: [private] Object
		//		Coming soon
		_bridgeDataset: null,
		
		// _honorFirstStatusOnly: [private] Boolean
		//		Since the Flex side really only looks at first status on any particular object,
		//		let's try to minimize the size of what we pass across the bridge.
		_honorFirstStatusOnly: true,
		
		// canvas: [public] Object
		//		Coming soon
		canvas: null,
		
		constructor: function (/*ibm.tivoli.navmodel.Dataset*/ dataset, /*Object*/ widgetDefinition, /*Object*/ canvas) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// dataset:
			//		Coming soon
			// widgetDefinition:
			//		Coming soon
			this.dataset = dataset;
			this._widgetDefinition = widgetDefinition;
			this.canvas = canvas;
		},
		
		//***************************
		// "Public"
		//***************************
		
		_useNodeLevelAndPosition: function() {
			var useNodeLevelAndPosition = this._widgetDefinition.useNodeLevelAndPosition();
			if (useNodeLevelAndPosition) {
				return true;
			} else {
				useNodeLevelAndPosition = this.dataset.getAttribute("useNodeLevelAndPosition");			
				if (useNodeLevelAndPosition) {
					return true;
				}
			}
			return false;
		},

		/*=====
		getBridgetDataset_kwArgs: function() {
		
		},
		=====*/
		getBridgeDataset: function(/*getBridgetDataset_kwArgs*/ kwArgs) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			var args = {                
				onComplete: function(bridgeDataset, kwArgs){
				},
				onError: function(error, exception, ioArgs){				
				}
			};   
			dojo.mixin(args, kwArgs);
			this._args = args;
			
			if (this._bridgeDataset) {	
				//Let's call onComplete
				this._args.onComplete(this._bridgeDataset, this._args);
			}
			// build up the bridge dataset
			else {
				this._bridgeDataset = {};
				if (this.dataset) {
					//Define a callback that fires when all the items are returned.
					var gotItemsAndLinks = function(items, links){
						//Stop the timer to see how long it took to be called back
						var datasetPopulationTimer = args.datasetPopulationTimer;
						if (datasetPopulationTimer) {
							this._trace.finest("dataset.getItemsAndLinks returned in ; " + datasetPopulationTimer.stopAndGetTraceString(), "gotItemsAndLinks");
						}
						
						this._populateBridgeDataset(this._bridgeDataset, this.dataset, items, links);	
					};
	
					var gotItemsAndLinksError = function(error, request){
						//Give the user some feedback
			            this.canvas.displayException(error);
			            
			            //Probably need to try and give control back to caller
			            this._args.onComplete(this._bridgeDataset, this._args);
					};
	
					//Fetch the items and links
					var itemArgs = {
							onComplete: dojo.hitch(this,gotItemsAndLinks),
							onError: dojo.hitch(this, gotItemsAndLinksError)
					};
					if (this._trace.isFinest()) {
						//Start a timer to see how long it takes
						var datasetPopulationTimer = new ibm.tivoli.tip.navwidget.dojo.Timer();
						itemArgs.datasetPopulationTimer = datasetPopulationTimer;
						datasetPopulationTimer.start();
					}
					this.dataset.getItemsAndLinks(itemArgs);
				}
			}
		},
		
		clearBridgeDataset: function() {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// tags:
			//		public
			
			if (this._bridgeDataset) {
				this._bridgeDataset.id = null;
				this._bridgeDataset.label = null;
				this._bridgeDataset.items = null;
				this._bridgeDataset.links = null;
			}
			this._bridgeDataset = null;
		},
		
		_populateBridgeDataset: function(/*Object*/ bridgeDatasetToPopulate, /*ibm.tivoli.navmodel.Dataset*/ dataset, /*ibm.tivoli.navmodel.Item[]*/ items, /*ibm.tivoli.navmodel.Link[]*/ links) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// bridgeDatasetToPopulate:
			//		Coming soon
			// dataset:
			//		Coming soon
			// items:
			//		Coming soon
			// links:
			//		Coming soon
			// tags:
			//		public
			var bridgeItemsArray = null;
			var bridgeLinksArray = null;

			//Process the list of items 
			if (items) {
				bridgeItemsArray = new Array(items.length);
				for (var index = 0;  index < items.length;  ++index) {
					var item = items[index];
					
					//Deal with items... for each item, create an object to pass across the bridge that represents this item
					var bridgeItem = this._toAjaxBridgeItem(item);
					
					//To help Canvas deal with layout algorithms that might be set on subgraphs, let's note any subgraphs we need to worry about
					if (item.isSubgraph()) {
						if (!bridgeDatasetToPopulate.subgraphItemIds) {
							bridgeDatasetToPopulate.subgraphItemIds = [];
						}
						bridgeDatasetToPopulate.subgraphItemIds.push(item.getId());
					}
					
					//Store the object to pass to the bridge later
					bridgeItemsArray[index] = bridgeItem;
				}
			}

			//Process the list of links
			if (links) {
				bridgeLinksArray = new Array(links.length);
				for (var index = 0;  index < links.length;  ++index) {
					var link = links[index];
					
					//Create an object to pass across the bridge that represents this item
					var bridgeLink = this._toAjaxBridgeLink(link);
					
					//Store the object to pass to the bridge later
					bridgeLinksArray[index] = bridgeLink;
				}
			}
			
			//Fill in simple fields
			bridgeDatasetToPopulate.id = dataset.getId();
			bridgeDatasetToPopulate.lazyLoad = dataset.isLazyLoad();
			bridgeDatasetToPopulate.label = dataset.getLabel();
			bridgeDatasetToPopulate.items = (bridgeItemsArray) ? bridgeItemsArray : [];
			bridgeDatasetToPopulate.links = (bridgeLinksArray) ? bridgeLinksArray : [];
			
			//Let's call onComplete
			this._args.onComplete(this._bridgeDataset, this._args);
		},
		
		//*******************************************************************************
		// Utilites to convert entities in the Client Nav Model to objects suitable to
		// pass across the Flex AJAX Bridge
		//*******************************************************************************		
		_toAjaxBridgeItem: function(/*ibm.tivoli.navmodel.Item*/ item) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// item:
			//		Coming soon
			var bridgeItem = {};
			
			var id = item.getId();
			bridgeItem.id = id;
			bridgeItem.type = item.getType();
			bridgeItem.label = item.getLabel();
			bridgeItem.origin = item.isOrigin();
			bridgeItem.lazyLoad = item.isLazyLoad();				

			if (item.getAttribute("nodeLevel") != undefined) {
				bridgeItem.level = item.getAttribute("nodeLevel");
			} else { 
				bridgeItem.level = -1; 
			}
			if (item.getAttribute("nodePosition") != undefined) {		
				bridgeItem.position = item.getAttribute("nodePosition"); 
			} else { 
				bridgeItem.position = -1; 
			}

			//Deal with status
			var statusesArgs = {
				widgetDef: this._widgetDefinition
			};
			var statuses = item.getStatuses(statusesArgs);
			if (statuses) {
				var bridgeStatuses = [];
				for (var statusIndex = 0;  statusIndex < statuses.length;  ++statusIndex) {
					var status = statuses[statusIndex];
					var bridgeStatus = this._toAjaxBridgeStatus(status);
					bridgeStatuses.push(bridgeStatus);
					
					if (this._honorFirstStatusOnly) {
						break;
					}
				}
				bridgeItem.statuses = bridgeStatuses;
			} else {
				//No statuses on node, but fill in a default status
				var bridgeStatuses = [];
				var defaultItemStatus = this._widgetDefinition.getDefaultItemStatus();
				defaultItemStatus.backgroundScalarImage = this._cleanUpImagePath(defaultItemStatus.backgroundScalarImage);
				defaultItemStatus.scalarImage = this._cleanUpImagePath(defaultItemStatus.scalarImage);
				bridgeStatuses.push(defaultItemStatus);
				bridgeItem.statuses = bridgeStatuses;
			}
			
			//Deal with item style
			var kwArgs = {
					widgetDef: this._widgetDefinition
				};
			var itemStyle = item.getItemStyle(kwArgs);
			if (itemStyle) {
				var bridgeItemStyle = this._toAjaxBridgeItemStyle(itemStyle);
				bridgeItem.style = bridgeItemStyle;
			}
			
			//Deal with subgraph stuff
			bridgeItem.isSubgraph = item.isSubgraph();
			bridgeItem.subgraphId = item.getSubgraphId();
			bridgeItem.isSubgraphOrigin = item.isSubgraphOrigin();

			//Send back the result
			return bridgeItem;
		},
		
		_toAjaxBridgeStatus: function(/*ibm.tivoli.navmodel.Status*/ status) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// status:
			//		Coming soon
			var bridgeStatus = {};
			if (status) {
				bridgeStatus.id = status.getId();
				bridgeStatus.value = status.getValue();
				
				//bridgeStatus.image = status.getImage();
				//bridgeStatus.label = status.getLabel();
				//bridgeStatus.message = status.getMessage();
				//bridgeStatus.tooltip = status.getTooltip();
				bridgeStatus.scalarImage = this._cleanUpImagePath(status.getScalarImage());
				bridgeStatus.scalarImageWidth = status.getScalarImageWidth();
				bridgeStatus.scalarImageHeight = status.getScalarImageHeight();
				bridgeStatus.scalarImageVisible = status.isScalarImageVisible();

				//Get background image info
				bridgeStatus.backgroundScalarImage = this._cleanUpImagePath(status.getBackgroundScalarImage());
				bridgeStatus.backgroundScalarImageWidth = status.getBackgroundScalarImageWidth();
				bridgeStatus.backgroundScalarImageHeight = status.getBackgroundScalarImageHeight();
				bridgeStatus.backgroundScalarImageVisible =  status.isBackgroundScalarImageVisible();
				bridgeStatus.color =  status.getColor();
			}

			return bridgeStatus;
		},
		
		_toAjaxBridgeLink: function(/*ibm.tivoli.navmodel.Link*/ link) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// link:
			//		Coming soon
			var bridgeLink = {};
			bridgeLink.id = link.getId();
			bridgeLink.type = link.getType();
			bridgeLink.item1 = link.getItem1Id();
			bridgeLink.item2 = link.getItem2Id();
			bridgeLink.label = link.getLabel();
			bridgeLink.direction = link.getDirection();
			
			//Deal with statuses
			var statusesArgs = {
					widgetDef: this._widgetDefinition
				};
			var statuses = link.getStatuses(statusesArgs);
			if (statuses) {
				var bridgeStatuses = [];
				for (var statusIndex = 0;  statusIndex < statuses.length;  ++statusIndex) {
					var status = statuses[statusIndex];
					var bridgeStatus = this._toAjaxBridgeStatus(status);
					bridgeStatuses.push(bridgeStatus);
					
					if (this._honorFirstStatusOnly) {
						break;
					}
				}
				bridgeLink.statuses = bridgeStatuses;
			} else {
				//No statuses on link, but fill in a default one
				var bridgeStatuses = [];
				var defaultLinkStatus = this._widgetDefinition.getDefaultLinkStatus();
				defaultLinkStatus.scalarImage = this._cleanUpImagePath(defaultLinkStatus.scalarImage);
				bridgeStatuses.push(defaultLinkStatus);
				bridgeLink.statuses = bridgeStatuses;
			}
			
			//Deal with relationships the link might contain. There's no real reason to pass across
			//relationship data if not rendering the relationships. So, let's make the optimization.
			if (this._widgetDefinition.getRenderRelationshipsInsteadOfLinks()) {
				var relationships = link.getRelationships();
				if (relationships) {
					var bridgeRelationships = [];
					for (var relationshipIndex = 0;  relationshipIndex < relationships.length;  ++relationshipIndex) {
						var relationship = relationships[relationshipIndex];
						var bridgeRelationship = this._toAjaxBridgeRelationship(relationship);
						bridgeRelationships.push(bridgeRelationship);
					}
					bridgeLink.relationships = bridgeRelationships;
				}
			}
			
			//Deal with link style
			var kwArgs = {
					widgetDef: this._widgetDefinition
				};
			var linkStyle = link.getLinkStyle(kwArgs);
			if (linkStyle) {
				var bridgeLinkStyle = this._toAjaxBridgeLinkStyle(linkStyle);
				bridgeLink.style = bridgeLinkStyle;
			}
			
			//Store the object to pass to the bridge later
			return bridgeLink;
		},
		
		_toAjaxBridgeRelationship: function(/*ibm.tivoli.navmodel.Relationship*/ relationship) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// relationship:
			//		Coming soon
			var bridgeRelationship = {};
			bridgeRelationship.id = relationship.getId();
			bridgeRelationship.type = relationship.getType();
			bridgeRelationship.linkId = relationship.getLinkId();
			bridgeRelationship.item1 = relationship.getSourceItemId();
			bridgeRelationship.item2 = relationship.getTargetItemId();
			bridgeRelationship.label = relationship.getLabel();
			//bridgeRelationship.direction = relationship.getDirection(); //There's no notion of direction in the relationship.
			
			//Deal with statuses
			var statusesArgs = {
					widgetDef: this._widgetDefinition
				};
			var statuses = relationship.getStatuses(statusesArgs);
			if (statuses) {
				var bridgeStatuses = [];
				for (var statusIndex = 0;  statusIndex < statuses.length;  ++statusIndex) {
					var status = statuses[statusIndex];
					var bridgeStatus = this._toAjaxBridgeStatus(status);
					bridgeStatuses.push(bridgeStatus);
					
					if (this._honorFirstStatusOnly) {
						break;
					}
				}
				bridgeRelationship.statuses = bridgeStatuses;
			} else {
				//No statuses on relationship, but fill in a default one
				var bridgeStatuses = [];
				var defaultRelationshipStatus = this._widgetDefinition.getDefaultRelationshipStatus();
				defaultRelationshipStatus.scalarImage = this._cleanUpImagePath(defaultRelationshipStatus.scalarImage);
				bridgeStatuses.push(defaultRelationshipStatus);
				bridgeRelationship.statuses = bridgeStatuses;
			}
			
			//Deal with link style
			var kwArgs = {
					widgetDef: this._widgetDefinition
				};
			var relationshipStyle = relationship.getRelationshipStyle(kwArgs);
			if (relationshipStyle) {
				var bridgeRelationshipStyle = this._toAjaxBridgeLinkStyle(relationshipStyle);
				bridgeRelationship.style = bridgeRelationshipStyle;
			}
			
			//Store the object to pass to the bridge later
			return bridgeRelationship;
		},
		
		_toAjaxBridgeItemStyle: function(/*ibm.tivoli.navmodel.ItemStyle*/ itemStyle) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemStyle:
			//		Coming soon
			var bridgeItemStyle = {};
			if (itemStyle) {
				bridgeItemStyle.id = itemStyle.getId();
				bridgeItemStyle.type = itemStyle.getType();
				bridgeItemStyle.scalarImage = this._cleanUpImagePath(itemStyle.getScalarImage());
				bridgeItemStyle.scalarImageWidth = itemStyle.getScalarImageWidth();
				bridgeItemStyle.scalarImageHeight = itemStyle.getScalarImageHeight();
			}

			//Return the object to pass to the bridge later
			return bridgeItemStyle;
		},
		
		_toAjaxBridgeLinkStyle: function(/*ibm.tivoli.navmodel.LinkStyle*/ linkStyle) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// linkStyle:
			//		Coming soon
			var bridgeLinkStyle = {};
			bridgeLinkStyle.id = linkStyle.getId();
			bridgeLinkStyle.type = linkStyle.getType();
			bridgeLinkStyle.lineStyle = linkStyle.getLineStyle();
			bridgeLinkStyle.lineWidth = linkStyle.getLineWidth();
			bridgeLinkStyle.lineColor = linkStyle.getLineColor();
			bridgeLinkStyle.arrowColor = linkStyle.getArrowColor();
			bridgeLinkStyle.labelVisible = linkStyle.isLabelVisible();
			if (bridgeLinkStyle.labelVisible) {
				bridgeLinkStyle.labelAutoRotate = linkStyle.isLabelAutoRotate();
				bridgeLinkStyle.labelParallelAlignment = linkStyle.getLabelParallelAlignment();
				bridgeLinkStyle.labelOrthogonalAlignment = linkStyle.getLabelOrthogonalAlignment();
				bridgeLinkStyle.labelDistance = linkStyle.getLabelDistance();
				bridgeLinkStyle.labelPositionType = linkStyle.getLabelPositionType();
				bridgeLinkStyle.labelPosition = linkStyle.getLabelPosition();
			}
			
			//Store the object to pass to the bridge later
			return bridgeLinkStyle;
		},
		
		_cleanUpImagePath: function(/*String*/ imagePath) {		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// imagePath:
			//		Coming soon
			return ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.cleanUpImagePath(imagePath);
		}
	});
