/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.topology.dojo.CanvasSelection");

dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("dojox.collections.SortedList");

dojo.declare(
    "ibm.tivoli.tip.navwidget.topology.dojo.CanvasSelection",
    ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection,
    {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
    	
    	setMode: function(/*Object*/ mode){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
    		// mode:
    		//		Coming soon
    	
	    	//We know the pluggableView is a canvas, so we can set the selection mode on the Flex bridge
			this._pluggableView._setSelectionModeOnFlexBridge(mode);
	    	
			//Call superclass
    		this.inherited(arguments);
		},
    	
	 	setSelectedObjectIds: function(/*String[]*/itemIds, /*String[]*/linkIds, /*String[]*/relationshipIds){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		Coming soon
			// linkIds:
			//		Coming soon
			// relationshipIds:
			//		Coming soon
			
			//Mark we're changing
			this._changing = true;
			
			//We know the pluggableView is a canvas, so we can set the selection on the Flex bridge
			if (this._pluggableView.dataset) {
				this._pluggableView._setSelectedObjectIdsOnFlexBridge(itemIds, linkIds, relationshipIds);
			}
			
			//Call superclass
			this.inherited(arguments);
			
			//Mark we're done changing
			this._changing = false;
		},
		
	 	setSelectedObjects: function(/*ibm.tivoli.navmodel.Item[]*/items, /*ibm.tivoli.navmodel.Link[]*/links, /*ibm.tivoli.navmodel.Relationship[]*/relationships){
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// items:
			//		Coming soon
			// links:
			//		Coming soon
			// relationships:
			//		Coming soon

			var itemIds = [];
			var linkIds = [];
			var relationshipIds = [];
			
			//Get item ids
			if (items) {
				for (var i = 0; i < items.length; i++) {
					var absId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemAbsoluteId(items[i]);
					itemIds.push(absId);
				}
			}
			
			//Get link ids
			if (links) {
				for (var i = 0; i < links.length; i++) {
					var absId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getLinkAbsoluteId(links[i]);
					linkIds.push(absId);
				}
			}
			
			//Get relation ids
			if (relationships) {
				for (var i = 0; i < relationships.length; i++) {
					var absId = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getRelationshipAbsoluteId(relationships[i]);
					relationshipIds.push(absId);
				}
			}
			
			//Mark we're changing
			this._changing = true;
			
			//We know the pluggableView is a canvas, so we can set the selection on the Flex bridge
			if (this._pluggableView.dataset) {
				this._pluggableView._setSelectedObjectIdsOnFlexBridge(itemIds, linkIds, relationshipIds);
			}
			
    		//Call superclass
			this.inherited(arguments);
			
			//Mark we're done changing
			this._changing = false;
		}
    }
);