/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.tree.dijit.TreeTableSelection");

dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");

dojo.declare("ibm.tivoli.tip.navwidget.tree.dijit.TreeTableSelection", ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection, {
	// data members
	_ignore: false,
	
	setMode: function(mode){
		this._pluggableView._table.grid.selection.setMode(mode);
		
		// Call superclass
		this.inherited(arguments);
	},
	
	setSelectedObjectIds: function(/*String[]*/itemIds, /*String[]*/linkIds, /*String[]*/relationshipIds) {
		// Mark we're changing
		this._changing = true;
		
		if (!this._ignore) {			
			// Clear selection
			var grid = this._pluggableView._table.grid;
			grid.selection.clear();
				
			// Deal with items
			if (itemIds) {
				var length = itemIds.length;
				for (var i = 0; i < length; i++) {
					var item = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemByAbsoluteId(this._dataset, itemIds[i]);
					var idx = grid.getItemIndex(item);
					if (idx >= 0) {
						grid.selection.addToSelection(idx);
					}
				}
			}					
		}
			
		//Call superclass
		this.inherited(arguments);
			
		//Mark we're done changing
		this._changing = false;
	},

	setSelectedObjects: function(/*ibm.tivoli.navmodel.Item[]*/items, /*ibm.tivoli.navmodel.Link[]*/links, /*ibm.tivoli.navmodel.Relationship[]*/relationships) {		
		// Mark we're changing
		this._changing = true;
			
		if (!this._ignore) {			
			// Clear selection
			var grid = this._pluggableView._table.grid;
			grid.selection.clear();
				
			// Deal with items
			if (items) {
				for (var i = 0; i < items.length; i++) {
					var idx = grid.getItemIndex(items[i]);
					if (idx >= 0) {
						grid.selection.addToSelection(idx);
					}
				}
			}					
		}
		
    	//Call superclass
		this.inherited(arguments);
			
		//Mark we're done changing
		this._changing = false;		
	},
    
	updateSelectedObjects: function(/*ibm.tivoli.navmodel.Item[]*/items) {	
		this._ignore = true;
   		this.setSelectedObjects(items, null, null);
   		this._ignore = false;
   	}	
});