/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide ("ibm.tivoli.tip.navwidget.tree.dijit.TreeTableView");

dojo.require("dojo.data.ItemFileReadStore");
dojo.require("dojox.grid.LazyTreeGridStoreModel");
dojo.require("ibm.tivoli.navmodel.DatasetLazyTreeStore");

dojo.require ("ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView");
dojo.require("ibm.tivoli.tip.navwidget.tree.dijit.NavModelTreeTable");
dojo.require("ibm.tivoli.tip.navwidget.tree.dijit.TreeTableSelection");

dojo.require("dojoe.treetable.TreeTableAll");

dojo.requireLocalization("ibm.tivoli.tip.navwidget", "resources");

ibm.tivoli.tip.navwidget.tree.dijit.TreeTableView._trace = new ibm.tivoli.navmodel.Trace("ibm.tivoli.tip.navwidget.table.dijit.TreeTableView");

dojo.declare ("ibm.tivoli.tip.navwidget.tree.dijit.TreeTableView",
	ibm.tivoli.tip.navwidget.table.dijit.AbstractTableView,
{
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	//***************************
	// "Private"
	//***************************
	
	// _trace: [private] Trace
	//		Utility for trace and logging
	_trace: ibm.tivoli.tip.navwidget.tree.dijit.TreeTableView._trace,
	
	constructor: function () {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		//this._global = ibm.tivoli.tip.dojo.Global.setSingleton( "123", " ");
		//this.title = this.commonResources.RESOURCE_VIEW;
	    this._pDEFAULT_WIDGET_DEF_INFO = {
			className: "ibm.tivoli.navmodel.TreeTableWidgetDef",
			baseUrl: "/ibm/tivoli/rest",
	    	provider: "any",
	    	datasource: "any",
	    	widget: "treetable-0.1.0",
	    	definition: "DefaultTreeTable-0.1.0"
		},
		
		this._pTableType = "item";
		this._pTableClassName = "ibm.tivoli.tip.navwidget.tree.dijit.NavModelTreeTable";
		this._pSelectionClassName = "ibm.tivoli.tip.navwidget.tree.dijit.TreeTableSelection";
		
		// make sure dataset gets destroyed  (TODO: Is this needed? Parent class has _destroyTableStore()...ask Steve)
		// this.destroyDatasetWhenDone = true;
	},
	
	// overrides AbstractTableView
	augmentGridParams: function(gridParams) {
		// summary:
		//		Add a tree model to the gridParams
		// description:
		//		Create a LazyTreeGridStoreModel and add it to the gridParams.
		
		var treeGridModel = new dojox.grid.LazyTreeGridStoreModel({
			rootId: 'root',
			deferItemLoadingUntilExpand: true,
			serverStore: true,
			store: gridParams.store,
			query: {origins: true},
			queryOptions: null,
			childrenAttrs: ['hasChildren']		
		});
		gridParams.treeModel = treeGridModel;
		gridParams.lazyModel = true;   // TODO: Is this still needed? Can't find in TED code
		gridParams.storeType = false;  // TODO: Is this still needed? Can't find in TED code
		gridParams.filter = {isServerSide : true};
		gridParams.keepSelection = true;
		
		// Reset the structure value to only the array of column descriptors and not the defaultCell info
		// TED does not support multiple or complicated nested layouts or locked columns
 		if ((gridParams.structure.length == 1) && (gridParams.store instanceof dojo.data.ItemFileReadStore)) {						
			gridParams.structure = [{}];
		} else if ((gridParams.structure.length == 1) && ("rows" in gridParams.structure[0]) && (gridParams.structure[0].rows instanceof Array)) {
	     		gridParams.structure = gridParams.structure[0].rows;	    		
	    	} else if((gridParams.structure.length == 2) && ("rows" in gridParams.structure[0]) && (gridParams.structure[0].rows instanceof Array) && ("rows" in 
gridParams.structure[1]) && (gridParams.structure[1].rows instanceof Array)  ) {
	    		//if there are some defined locked columns, merge them into one array since
	    		//tree table does not support true column locking, they will however appear
	    		//at the beginning of the table
	    		var layout1 = gridParams.structure[0].rows;
	    		var layout2 = gridParams.structure[1].rows;
	    		var layoutMerged = [];
    	
	    	layoutMerged = layout1.concat(layout2);

	    	gridParams.structure = layoutMerged;
	    	
	    	
	    }
	    
		return gridParams;
	},	
	
	_createTableStore: function(columnIds){		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// columnIds:
		//		
		
		// create or update store
		if(!this._dataStore) {
			if (this.dataset) {
				this._dataStore = new ibm.tivoli.navmodel.DatasetLazyTreeStore({dataset:this.dataset, defaultProperties:columnIds, returnItem:true});
			} else {
				//No dataset, so just create an empty store
				var emptyStore = 	new dojo.data.ItemFileReadStore({
            						data: { items: []}
	                				});
				this._dataStore = emptyStore;
			}
			this.inherited(arguments);
		}
	}	
	
});
