
dojo.require("dijit.form.Button");
dojo.require("dijit.Tooltip");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");
dojo.provide("ibm.tivoli.tip.richhover.RichHover");

dojo.declare("ibm.tivoli.tip.richhover.RichHover",
             dijit.layout.TabContainer,
{
  tabindex : 1,
  
  _changeListener: null,
  _numtabs: 0,

  /* Just a simple function to add any content to a new tab */
  addSimpleContentOLD: function(tabtitle, panecontent, resourceUrl)
  {
    var cp = new dijit.layout.ContentPane({
      title: tabtitle,
      content: panecontent,
      resourceUrl: resourceUrl
    });
    
    this.tabindex++;
    
    this.addChild(cp);
  },


  /* Just a simple function to add a new tab with the given URL and title */
  addIframeUrlOLD: function(tabtitle, url, resourceUrl)
  {
    var myIframe= '<iframe id="cont'+this.tabindex+'" style="border:0px; width:100%; height:100%" src="'+url+'">pane'+this.tabindex+'</iframe>';
    this.addSimpleContent(tabtitle,myIframe, resourceUrl);
  },
  
  /* Just a simple function to add any content to a new tab */
  addSimpleContent: function(tabtitle, panecontent, resourceUrl)
  {
	var contentStr = "<b>No content</b>";
	var precontentStr = null;
	
	/* If this is the first tab, go ahead and load the iframe, otherwise, we do not */
	/* load the iframe until the tab is clicked                                     */
	if (this._numtabs == 1)
		contentStr=panecontent;
	else
		precontentStr=panecontent;
	
    var cp = new dijit.layout.ContentPane({
      title: tabtitle,
      content: contentStr,
      resourceUrl: resourceUrl,
      precontent: precontentStr
    });
    
    this.tabindex++;
	console.debug("this .........", this);
    dojo.style(cp, "padding", "0px");
    this.addChild(cp);
  },
  
  /**
   * This method is called when we change tabs.  It will load the iframe with the URL
   * so that URLs are loaded only on demand.
   */
  _onChangeTab: function(tab)
  {
	  if (tab.precontent != null)
	  {
		  tab.set("content",tab.precontent);
		  tab.set("precontent",null);
	  }
  },

  /* Just a simple function to add a new tab with the given URL and title */
  addIframeUrl: function(tabtitle, url, resourceUrl)
  {
	this._numtabs++;
	if (this._changeListener == null)
	   this._changeListener = dojo.connect(this,"selectChild",this,this._onChangeTab);	  
	
    var myIframe= '<iframe id="cont'+this.tabindex+'" style="border:0px; width:100%; height:100%" src="'+url+'">pane'+this.tabindex+'</iframe>';
    this.addSimpleContent(tabtitle,myIframe, resourceUrl);
  },
  
  destroy: function()
  {
	  if (this._changeListener!=null)
	  {
		  dojo.disconnect(this._changeListener);
		  this._changeListener=null;
	  }
	  this.inherited(arguments);
  }
  
});
