
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("ibm.tivoli.tip.richhover.RichHover");
dojo.require("ibm.tivoli.tip.richhover.RichHoverDataset");
dojo.require("ibm.tivoli.tip.richhover.RichHoverUrlInfo")
dojo.provide("ibm.tivoli.tip.richhover.RichHoverDialog");

dojo.declare("ibm.tivoli.tip.richhover.RichHoverDialog",
             dijit.Dialog,
{
  urlInfo : null,
  hoverHeight : 0,  /* height of the hover iframe, not the entire dialog */
  hoverWidth : 0,   /* width of the hover iframe, not the entire dialog */
  dlgAddlHeight : {"px": 50, "em": 5, "ex": 5, "default": 10}, /* how much higher to make the actual dlg than iframe height */
  dlgAddlWidth : {"px": 30, "em": 4, "ex": 4, "default": 10},  /* how much wider to make actual dlg than iframe width */
  dimensionUnit : null,
  
  _resourceUrl : null,
  _shownAlready : false,
  _tabSwitchListener : null,

  constructor: function(args)
  {
    var oldWidget = dijit.byId("dlgtab");
    if (oldWidget)
      oldWidget.destroy();
  },

  onClickMore: function()
  {
	console.log("Inside onClickMore fn");
	console.debug(this);
	console.debug(this._resourceUrl);
    window.open(this._resourceUrl);
  },

  onClickClose: function()
  {
    this.hide();
    this.destroy(); 
  },
  
  destroy: function()
  {
	if (this._tabSwitchListener!=null)
	{
		dojo.disconnect(this._tabSwitchListener);
		this._tabSwitchListener=null;
	}
	this.inherited(arguments);
  },

  _addButtons: function()
  {
    if (dijit.byId("morebutton") != null)
       dijit.byId("morebutton").destroy();

    var moreInfoButton = new dijit.form.Button({
      label: "More Info",
      onClick: dojo.hitch(this, this.onClickMore)
    }, "morebutton");

    if (dijit.byId("closebutton") != null)
       dijit.byId("closebutton").destroy();

    var closeButton = new dijit.form.Button({
      label: "Close",
      onClick: dojo.hitch(this, this.onClickClose)
    }, "closebutton");

  },

  _dojoHack: function()
  {
    // Dojo hackery... need to get rid of the annoying tab strip
    // should contact IDT about this
    var tab = dojo.byId("dlgtab_tablist_menuBtn");
    tab.style.display="none";
    tab.parentNode.style.display="none";

    tab = dojo.byId("dlgtab_tablist_leftBtn");
    tab.style.display="none";
    tab.parentNode.style.display="none";

    tab = dojo.byId("dlgtab_tablist_rightBtn");
    tab.style.display="none";
    tab.parentNode.style.display="none";
  },
 
  _onTabSwitch: function(tab)
  {
    this._resourceUrl = tab.resourceUrl;
  },
  
  _parseDim: function(dimension)
  {
	  /* Remove whitespace if any */
	  var ds = dimension.replace(/^\s+|\s+$/g, '');

	  var num = parseInt(ds);
	  var numstr = ""+num;
	  var unit = "px";
	  if (ds.length>numstr.length)
	  {
	     var units = ds.substring(numstr.length);
	     unit = units.replace(/^\s+|\s+$/g, '');
	  }
	  
	  return {num: num, unit: unit};
  },
  
  _calculateDimensions: function()
  {
     if (typeof this.urlInfo != "undefined" && this.urlInfo != null && this.urlInfo.getPreviews() != null)
     {
	    var previews = this.urlInfo.getPreviews();
	    for (var i=0; i<previews.length; i++)
	    {
	        var preview = previews[i];
			console.log("RichHoverDialog");
			console.debug(preview);
	    	// TODO: not a great way of dealing with hints, but ok for now
	    	var height = preview.heighthint;
	    	var width = preview.widthhint;
	    	if (height != null)
	    	{
	    		var ds = this._parseDim(height);
	    		if (this.hoverHeight < ds.num)
	    			this.hoverHeight = ds.num;
	    		if (this.dimensionUnit == null)
	    			this.dimensionUnit = ds.unit;
	    		else if (ds.unit == "px")
	    			this.dimensionUnit = ds.unit;
	    	}
	    	if (width != null)
	    	{
	    		var ds = this._parseDim(width);
	    		if (this.hoverWidth < ds.num)
	    			this.hoverWidth = ds.num;
	    		if (this.dimensionUnit == null)
	    			this.dimensionUnit = ds.unit;
	    		else if (ds.unit == "px")
	    			this.dimensionUnit = ds.unit;
	    	}
	    }
     }
     if (this.hoverHeight==0)
     	this.hoverHeight=350;
     if (this.hoverWidth==0)
     	this.hoverWidth=800;
     if (this.dimensionUnit==null)
     	this.dimensionUnit="px";
     
     /* Once dimensions are calculated for the previews, we want to set the size of the dialog as a whole */
     var addlWidth = (typeof this.dlgAddlWidth[this.dimensionUnit]=="undefined"?this.dlgAddlWidth["default"]:this.dlgAddlWidth[this.dimensionUnit]);
     var addlHeight = (typeof this.dlgAddlHeight[this.dimensionUnit]=="undefined"?this.dlgAddlHeight["default"]:this.dlgAddlHeight[this.dimensionUnit]);
     var dlgStyle = "display:none; height: "+(this.hoverHeight+addlHeight)+this.dimensionUnit+"; width: "+(this.hoverWidth+addlWidth)+this.dimensionUnit+";"
     this.set("style",dlgStyle);
     console.log("Dialog style: "+dlgStyle);
  },

  showHover: function()
  {

	  if (this._shownAlready)
	  {
		  this.show();
		  return;
	  }
	  
	  if (this.urlInfo == null || this.urlInfo.isLoaded() == false || this.urlInfo.hasError() == true)
	  {
		/* The dataset is not ready, don't show until we are ready. */
		console.error("show was called on RichHoverDialog, but urlInfo is not ready.");
		console.log(" urlinfo is "+(this.urlInfo==null?"null":"not null"));
		console.log(" urlinfo.isLoaded is "+(this.urlInfo.isLoaded()?"true":"false"));
		console.log(" urlinfo.hasError is "+(this.urlInfo.hasError()?"true":"false"));
		return;
	  }
	  
	if (this.urlInfo.getPreviews() == null || this.urlInfo.getPreviews().length == 0)
	{
	    console.log("No previews exist for this dialog.  Will not show dialog.");
	    return;
	}

    this.attr("content","<div id='dlgtab'></div><div id='morebutton'></div><div id='closebutton'></div>");
    this.startup();

    this._addButtons();

    this._calculateDimensions();
    
    var myStyle = "height: "+this.hoverHeight+this.dimensionUnit+"; width: "+this.hoverWidth+this.dimensionUnit+";"
    console.log("Tab style: "+myStyle);
    var tc = new ibm.tivoli.tip.richhover.RichHover({
        style: myStyle
    },
    "dlgtab");
    
    this._tabSwitchListener = dojo.connect(tc,"selectChild",this,this._onTabSwitch);

    var previews = this.urlInfo.getPreviews();
    for (var i=0; i<previews.length; i++)
    {
      var preview = previews[i];
	  console.debug("RichHoverDialog preview : " + preview);
      var resourceurl = preview.resourceUrl;

      tc.addIframeUrl(preview.shortTitle, preview.smallPreview.url, resourceurl);
      if (this._resourceUrl == null)
        this._resourceUrl = resourceurl;
    }

    tc.startup();

    this._dojoHack();
    
    this._shownAlready = true;
    this.show();
  },
  
  setHoverUrlInfo: function(urlInfo)
  {
	  console.log("set Hover URIL inof");
	  console.debug(urlInfo);
	  this.urlInfo = urlInfo;
  },
  
  getHoverUrlInfo: function(urlInfo)
  {
	  return this.urlInfo;
  }

});
