
dojo.require("dijit.TooltipDialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.Dialog");
dojo.require("ibm.tivoli.tip.richhover.RichHover");
dojo.require("ibm.tivoli.tip.richhover.RichHoverDataset");
dojo.require("ibm.tivoli.tip.richhover.RichHoverUrlInfo");
dojo.require("ibm.tivoli.tip.richhover.MessageDialog");
dojo.provide("ibm.tivoli.tip.richhover.RichHoverTooltip");


dojo.declare("ibm.tivoli.tip.richhover.RichHoverTooltip",
             dijit.TooltipDialog,
{
  urlInfo : null,
  aroundNode : null, /* The dom node for which this tooltip will be shown around */
  hoverHeight : 0,  /* height of the hover iframe, not the entire dialog */
  hoverWidth : 0,   /* width of the hover iframe, not the entire dialog */
  dlgAddlHeight : {"px": 50, "em": 5, "ex": 5, "default": 10}, /* how much higher to make the actual dlg than iframe height */
  dlgAddlWidth : {"px": 30, "em": 4, "ex": 4, "default": 10},  /* how much wider to make actual dlg than iframe width */
  dimensionUnit : null,
  largeLeft: 0,
  largeTop:0,
  isLargeHoverPresent : null,
  contentIsolation : false,
  namespace:"",
  hoverTitle : null,
  _largeHtmlUrl : null,
   //resources:object
   //Reference to the resources
   resources_:null,
  _largePreview : null,
  _resourceUrl : null,
  _largeHoverHeight : 0,
  _largeHoverWidth : 0,
  _shownAlready : false,
  _tabSwitchListener : null,
  _anchorList : null,
  _blurListener : null,
  _focusListener : null,
  _hoverNodeLeaveListener : null,
  _hoverNodeEnterListener : null,
  _mouseEnterListener : null,
  _mouseExitListener : null,
  
  _dismissNodeLeaveTime : 500,
  _dismissDlgLeaveTime : 250,
  _hoveringNode : false,
  _hoveringDlg : false,
  
  _terminationTimer : null,

  constructor: function(args)
  {
	this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.richhover", "RichHover",this.lang);
    var oldWidget = dijit.byId("dlgtab");
    if (oldWidget)
      oldWidget.destroy();
  },

  onClickMore: function()
  {
    window.open(this._resourceUrl);
  },

  onClickClose: function()
  {
	this._dismissDlg();
	//this.destroy();
  },
  
  onClickChevron: function()
  {
	console.log("onClickChevron : " + this._largeHtmlUrl);
	this._onMouseExitDlg();
	//this._mouseExitListener = this._disconnectListener(this._mouseExitListener);
    var lHoverIframe= '<iframe id="largeHover" style="border:0px; width:100%; height:100%" src="'+this._largeHtmlUrl+'">pane</iframe>';
	 var cp = new dijit.layout.ContentPane({
	  content:lHoverIframe,
      resourceUrl: this._largeHtmlUrl
    });
			
	var dialogStyle = "width:" + this.largeHoverWidth + "px; height:" + this.largeHoverHeight + "px";
	largeHover = new dijit.Dialog({
            title: this.hoverTitle,
			style : dialogStyle
        });
		
	// has hardcoded dim and theme, change later.	
	var msgDlg = new ibm.tivoli.tip.richhover.MessageDialog(
							{
							title: this.hoverTitle,
							theme:"tundra",
							content:cp,
							//callback:this.onCloseCallback,
							height:this._largeHoverHeight,
							_resourceUrl:this._resourceUrl,
							width:this._largeHoverWidth});
							
	msgDlg.startup();
	msgDlg.show();
  },
  
  onCloseCallback : function(buttonPressedId, messageId, checked) {
		this._mouseExitListener = dojo.connect(this.domNode,"onmouseleave",this,this._onMouseExitDlg);
		console.log ("in callback... button: " + buttonPressedId + " , messageId: " + messageId + " , checked: " + checked);
  },
			
  destroy: function()
  {
	if (this._tabSwitchListener!=null)
	{
		dojo.disconnect(this._tabSwitchListener);
		this._tabSwitchListener=null;
	}
	this.inherited(arguments);
  },

  _addButtons: function(mdiv)
  {
    if (dijit.byId("morebutton") != null)
       dijit.byId("morebutton").destroy();

    var moreInfoButton = dojo.create("a", {href: "javascript:void(0)", align:"left", title: this.resources_.MORE_INFO, id: "moreInfo", onclick: dojo.hitch(this, this.onClickMore), innerHTML: this.resources_.MORE_INFO})
    var moreInfodiv = dojo.create("span", {align:"left", innerHTML: "&nbsp;&nbsp;"})

    //var closeButton = dojo.create("a", {href: "javascript:void(0)", align:"left", id: "closeLink", onclick: dojo.hitch(this, this.onClickClose), title: "closehover", innerHTML: this.resources_.CLOSE})
	var buttonDiv = dojo.create("div", {title: "buttons", id:"buttonDiv", style:"width:50%; float: left;"});
	buttonDiv.appendChild(moreInfoButton);
	buttonDiv.appendChild(moreInfodiv);
	//buttonDiv.appendChild(closeButton);
	var footerDiv = dojo.create("div", {title: "footer", id:"footer_div", style:"width:100%;"});
	//footerDiv.appendChild(buttonDiv);
	var chevronDiv = dojo.create("div", {align: "right",  "float":"right",title: "LargePreview", id:"chevronDiv", style:"width:50%; float: right;"});
	var chevron = dojo.create("a", {href: "javascript:void(0)", align:"right", onclick: dojo.hitch(this, this.onClickChevron), title: this.resources_.LARGE_PREVIEW, innerHTML: ">>"})
	chevronDiv.appendChild(chevron);

	//footerDiv.appendChild(chevronDiv);
	var chevHidden = false;
	if((this.isLargeHoverPresent.join(" ")).indexOf(this._resourceUrl) == -1)
	{
		chevHidden="true";
	}
	var footerContent = this.getFooter(buttonDiv, chevronDiv, chevHidden);
	console.debug(footerContent);
	footerDiv.innerHTML = footerContent;
	mdiv.appendChild(footerDiv);
  },

  _ieTabFix : function(tc) {
	console.log("Inside _ieTabFix");
    var noWrapTabParent;	
	var tabListContainer = dojo.query('> .dijitTabListContainer-top',tc);
	if (tabListContainer.length == 1)
	  {
		  noWrapTabParent = tabListContainer[0];
	  }
	if(dojo.isIE && noWrapTabParent !="undefined"  &&  noWrapTabParent != null) {
		  console.log("its IE and all conditions satisfied");
		  for (var i=0; i<noWrapTabParent.children.length; i++)
			  {
				  var classes = noWrapTabParent.children[i].className;
				  if(classes.indexOf('dijitTabListWrapper') > -1)
				  {
					var noWrapTabStrip = dojo.query("> .nowrapTabStrip", noWrapTabParent.children[i]);
					if(noWrapTabStrip != null &&  noWrapTabStrip != "undefined" &&  noWrapTabStrip.length>0) {
						dojo.style(noWrapTabStrip[0], "width", "50000px"); // dojo sets 50000 as default, which is not reflecting in IE
					}
				  }
			  }
		}
	  return ;
  },
  
  _dojoHack: function(tc)
  {
	  var tabListContainer = dojo.query('> .dijitTabListContainer-top',tc);
	  var tooltipContainer = dojo.query('> .dijitTooltipContainer', this.domNode);
	  
	  var closeIcon = dojo.create("span", {id:"closeIcon", align:"right", innerHTML: "x", style:{right:"5px"}});
	  if (tabListContainer.length == 1)
	  {
		  var tabs = dojo.query('> .tabStripButton-top',tabListContainer[0]);
		  for (var i=0; i<tabs.length; i++)
		  {
			  tabs[i].style.display="none";
		  }
	  }

	  return;
	  // not needed as of now.
	  var toolTipContainer = dojo.query('> .dijitTooltipContainer',this.domNode);
	  console.debug("toolTipContainer 1111", toolTipContainer );
	  if (toolTipContainer.length==1)
	  {
		  var toolTipContents = dojo.query('> .dijitTooltipContents',toolTipContainer[0]);
		  if (toolTipContents.length == 1)
		  {
			  var tabContainer = toolTipContents[0].childNodes[0];
			  var tabListContainer = dojo.query('> .dijitTabListContainer-top',tabContainer);
			  if (tabListContainer.length == 1)
			  {
				  var tabs = dojo.query('> .tabStripButton-top',tabListContainer[0]);
				  for (var i=0; i<tabs.length; i++)
				  {
					  tabs[i].style.display="none";
				  }
			  }
		  }
	  }
	  
	return; // below this line is what the old code for the dialog looked like.  
    // Dojo hackery... need to get rid of the annoying tab strip
    // should contact IDT about this
    var tab = dojo.byId("dlgtab_tablist_menuBtn");
    tab.style.display="none";
    tab.parentNode.style.display="none";

    tab = dojo.byId("dlgtab_tablist_leftBtn");
    tab.style.display="none";
    tab.parentNode.style.display="none";

    tab = dojo.byId("dlgtab_tablist_rightBtn");
    tab.style.display="none";
    tab.parentNode.style.display="none";
  },
  
    getFooter: function(buttonDiv, chevronDiv, chevHidden)
  {
	var innerHtml = "";
	innerHtml = innerHtml + "<table>";
	innerHtml = innerHtml + "<tr valign=\"top\">";
	innerHtml = innerHtml + "<td width=\"100%\">" + buttonDiv.innerHTML;
	innerHtml = innerHtml + "</td>";
	if(chevHidden)
		innerHtml = innerHtml + "<td align=\"right\" width=\"100%\" id=\"chevTd\" style=\"visibility:hidden\">" + chevronDiv.innerHTML;
	else
		innerHtml = innerHtml + "<td align=\"right\" width=\"100%\" id=\"chevTd\">" + chevronDiv.innerHTML;
	innerHtml = innerHtml + "</td>";
	innerHtml = innerHtml + "</tr>";
	innerHtml = innerHtml + "</table>";
	return innerHtml;
  },
  
  
  _onTabSwitch: function(tab)
  {

        this._resourceUrl = tab.resourceUrl;
	console.log("tab.resourceUrl : " + tab.resourceUrl)
	console.debug("this.isLargeHoverPresent : ", this.isLargeHoverPresent);
	for (var i=0; i<this._largePreview.length; i++)
	{
		if(this._largePreview[i].resourceUrl == this._resourceUrl)
		{
			this._resourceUrl=this._largePreview[i].resourceUrl
			this._largeHtmlUrl = this._largePreview[i].url;
			this._largeHoverHeight =this._largePreview[i].heighthint;
			this._largeHoverWidth = this._largePreview[i].widthhint;
			this.hoverTitle = this._largePreview[i].shortTitle;
		}
	}
	
	var chevDiv = dojo.byId("chevTd");
	console.debug(this.isLargeHoverPresent);
	if((this.isLargeHoverPresent.join(" ")).indexOf(tab.resourceUrl)==-1)
	{
		console.log("should hve been here");
		chevDiv.style.visibility="hidden";
	}
	else {
		chevDiv.style.visibility="";
	}
  },
  
  _parseDim: function(dimension)
  {
	  /* Remove whitespace if any */
	  var ds = dimension.replace(/^\s+|\s+$/g, '');

	  var num = parseInt(ds);
	  var numstr = ""+num;
	  var unit = "em";
	  if (ds.length>numstr.length)
	  {
	     var units = ds.substring(numstr.length);
	     unit = units.replace(/^\s+|\s+$/g, '');
	  }
	  
	  return {num: num, unit: unit};
  },
  
  _calculateDimensions: function()
  {
     if (typeof this.urlInfo != "undefined" && this.urlInfo != null && this.urlInfo.getPreviews() != null)
     {
	    var previews = this.urlInfo.getPreviews();
	    for (var i=0; i<previews.length; i++)
	    {
	        var preview = previews[i];
			console.log("check previews---- : " + previews.length);
			console.debug(preview);
			if(preview.smallPreview == undefined || preview.smallPreview == null)
			  {
				// set props for Large Hover.
				continue;
			  }
	    	// TODO: not a great way of dealing with hints, but ok for now
	    	var height = preview.smallPreview.heighthint;
	    	var width = preview.smallPreview.widthhint;
	    	if (height != null)
	    	{
	    		var ds = this._parseDim(height);
				console.log("debug ds : ");
				console.debug(ds);
	    		if (this.hoverHeight < ds.num)
	    			this.hoverHeight = ds.num;
	    		if (this.dimensionUnit == null)
	    			this.dimensionUnit = ds.unit;
	    		else if (ds.unit == "px")
	    			this.dimensionUnit = ds.unit;
	    	}
	    	if (width != null)
	    	{
	    		var ds = this._parseDim(width);
	    		if (this.hoverWidth < ds.num)
	    			this.hoverWidth = ds.num;
	    		if (this.dimensionUnit == null)
	    			this.dimensionUnit = ds.unit;
	    		else if (ds.unit == "px")
	    			this.dimensionUnit = ds.unit;
	    	}
	    }
     }
     if (this.hoverHeight==0)
     	this.hoverHeight=13;
     if (this.hoverWidth==0)
     	this.hoverWidth=20;
     if (this.dimensionUnit==null)
     	this.dimensionUnit="em";
     
     /* Once dimensions are calculated for the previews, we want to set the size of the dialog as a whole */
     var addlWidth = (typeof this.dlgAddlWidth[this.dimensionUnit]=="undefined"?this.dlgAddlWidth["default"]:this.dlgAddlWidth[this.dimensionUnit]);
     var addlHeight = (typeof this.dlgAddlHeight[this.dimensionUnit]=="undefined"?this.dlgAddlHeight["default"]:this.dlgAddlHeight[this.dimensionUnit]);
     var dlgStyle = "display:none; height: "+(this.hoverHeight+addlHeight)+this.dimensionUnit+"; width: "+(this.hoverWidth+addlWidth)+this.dimensionUnit+";"
     
     this.set("style",dlgStyle);
  },
  
  _disconnectListener: function(listener)
  {
	 if (listener != null)
	 {
		dojo.disconnect(listener);
	 }
	 return null;
  },
  
  _dismissDlg: function()
  {
  	  this._clearTerminationTimer();
	  console.log("dismissing dlg");
	  dijit.popup.close(this);
	  
	  // Disconnect all the listeners
	  this._blurListener = this._disconnectListener(this._blurListener);
	  this._focusListener = this._disconnectListener(this._focusListener);
	  this._hoverNodeLeaveListener = this._disconnectListener(this._hoverNodeLeaveListener);
	  this._hoverNodeEnterListener = this._disconnectListener(this._hoverNodeEnterListener);
	  this._mouseEnterListener = this._disconnectListener(this._mouseEnterListener);
	  this._mouseExitListener = this._disconnectListener(this._mouseExitListener);
	  this._anchorList = this._disconnectListener(this._anchorList);
  },
  
  _onMouseEnterDlg: function()
  {
	this._clearTerminationTimer();
	console.log("mouse enter");  
  },
  
  _onMouseExitDlg: function()
  {
	var parentNode  = this.domNode.parentNode;
	var tabPopup = parentNode.nextSibling;
	if(tabPopup != null && tabPopup != "undefined")
		return;
	this._clearTerminationTimer();
	console.log("mouse exit");
	this._terminationTimer = setTimeout(dojo.hitch(this,this._dismissDlg), this._dismissDlgLeaveTime);

  },
  
  _onNodeLeave: function()
  {
	this._clearTerminationTimer();
	console.log("node leave");  
	this._terminationTimer = setTimeout(dojo.hitch(this,this._dismissDlg), this._dismissNodeLeaveTime);
  },
  
  _onNodeEnter: function()
  {
	this._clearTerminationTimer();
	console.log("node leave");  
  },
  
  _onDlgFocus: function()
  {
    this._clearTerminationTimer();
	console.log("dlg focus");  
  },
  
  _clearTerminationTimer: function()
  {
	 if (this._terminationTimer != null)
     {
		 clearTimeout(this._terminationTimer);
		 this._terminationTimer = null;
	 }
  },
  
  /**
   * Internal function that should be called to show the dialog.  It will connect a listener
   * to dismiss the popup dialog.
   */
  _internalShow: function()
  {
      this._hoverNodeLeaveListener= dojo.connect(this.aroundNode,"onmouseleave",this,this._onNodeLeave);
      this._hoverNodeEnterListener= dojo.connect(this.aroundNode,"onmouseenter",this,this._onNodeEnter);
	  dijit.popup.open({popup:this, around: this.aroundNode});
      this._focusListener= dojo.connect(this,"onFocus",this,this._onDlgFocus);
      this._mouseEnterListener = dojo.connect(this.domNode,"onmouseenter",this,this._onMouseEnterDlg);
      this._mouseExitListener = dojo.connect(this.domNode,"onmouseleave",this,this._onMouseExitDlg);
      
      // Remove the blur listener because when working in the google map, I got a blur that caused it to close.
      //this._blurListener= dojo.connect(this,"onBlur",this,this._dismissDlg);
  },

  showHover: function()
  {
	  if (this._shownAlready)
	  {
		  //this.show();
		  this._internalShow();
		  return;
	  }
	  if (this.urlInfo == null || this.urlInfo.isLoaded() == false || this.urlInfo.hasError() == true)
	  {
		/* The dataset is not ready, don't show until we are ready. */
		console.error("show was called on RichHoverTooltip, but urlInfo is not ready.");
		console.log(" urlinfo is "+(this.urlInfo==null?"null":"not null"));
		console.log(" urlinfo.isLoaded is "+(this.urlInfo.isLoaded()?"true":"false"));
		console.log(" urlinfo.hasError is "+(this.urlInfo.hasError()?"true":"false"));
		return;
	  }
	  
	if (this.urlInfo.getPreviews() == null || this.urlInfo.getPreviews().length == 0)
	{
	    console.log("No previews exist for this dialog.  Will not show dialog.");
	    return;
	}

    //this.set("content","<div id='dlgtab'></div><div id='morebutton'></div><div id='closebutton'></div>");
    this.startup();

    //this._addButtons();

    this._calculateDimensions();
    
    var myStyle = "height: "+this.hoverHeight+this.dimensionUnit+"; width: "+this.hoverWidth+this.dimensionUnit+";";
    console.log("Tab style: "+myStyle);
	
	if( this.contentIsolation == true ){
			console.log("content Isolation is true");
			// Get the namespace identifying the content that launched the context menu
			console.info("Inside Show if PopupUtil Undefined");
			var namespace="";
			if(this.namespace != null)
			 namespace = this.namespace;
			
			//Close (just in case) and then open the popup covering the whole page
			console.info("Opening Popup namespace "+namespace);
			var xcord=100;
			var ycord=100;
			var dialogNamespace=namespace+'ibm.tivoli.tip.richhover.RichHoverTooltip';
			var old_popup_iframe = PopupUtil.ClosePopup( namespace+'ibm.tivoli.tip.richhover.RichHoverTooltip' );
			//Changes for fixing Content Isolation issue with Claro theme
			//var theme = dojo.body().className;
			var theme=this.theme;
			this.baseUrl=dojo.baseUrl;
			
			var index = this.baseUrl.lastIndexOf("dojo/dojo/");
			
				if (index != -1) {
				
			this.baseUrl=this.baseUrl.substring(0,index);
			
			}
			console.log("this.baseUrl : " + this.baseUrl);
			var popupUrl =this.baseUrl+'dojo/ibm/tivoli/tip/richhover/RichHover.html?PopupID='+dialogNamespace+'&eLeft='+xcord+'&eTop='+ycord+'&locale='+djConfig.locale+"&theme="+theme;
			console.info("url :"+popupUrl);
			var popup_iframe = PopupUtil.OpenPopup( 
				namespace, 
				namespace+'ibm.tivoli.tip.richhover.RichHover', 
				true, 
				null, 
				null, 
				null, 
				null, 
				popupUrl, 
				null
			);
			console.debug("after popup opening code - popup_iframe", popup_iframe);
			//Initialize the contextMenu when the iframe popup is finished loading
			var tThis = this;
			if( popup_iframe.addEventListener ){
				popup_iframe.addEventListener(
					"load", 
					function(){
						popup_iframe.contentWindow.makeTooltip( tThis, myStyle );
					}, 
					false
				);
			}
			else if (popup_iframe.attachEvent){
				popup_iframe.attachEvent(
					"onload", 
					function(){ 
						popup_iframe.contentWindow.makeTooltip( tThis, myStyle);
					}
				);
			}
		}
	else {
		var tc = new ibm.tivoli.tip.richhover.RichHover({
			style: myStyle
		});
		this._ieTabFix(tc.domNode);
		this._tabSwitchListener = dojo.connect(tc,"selectChild",this,this._onTabSwitch);
		var previews = this.urlInfo.getPreviews();
		this.isLargeHoverPresent=[];
		for (var i=0; i<previews.length; i++)
		{
		  var preview = previews[i];
		  console.debug("short tile : ", preview.shortTitle);
		  console.debug("preview.largePreview.url : ",preview);
		  if(i==0)
		  {
			this._resourceUrl = preview.resourceUrl;
			this._largeHtmlUrl = preview.largePreview.url;
			this._largeHoverHeight = preview.largePreview.heighthint;
			this._largeHoverWidth = preview.largePreview.widthhint;
			this.hoverTitle = preview.shortTitle;
			this._largePreview=[];
		  }
		// We will need something to map small previews with their corresponding largePreview details. using resourceUrl
		var temp = {};
		temp.resourceUrl=preview.resourceUrl;
		temp.url=preview.largePreview.url;
		temp.heighthint=preview.largePreview.heighthint;
		temp.widthhint=preview.largePreview.widthhint;
		temp.shortTitle=preview.shortTitle;
		this._largePreview.push(temp);
		if(preview.largePreview.url != null && preview.largePreview.url != "undefined" && (this.isLargeHoverPresent.join(" ")).indexOf(preview.resourceUrl)==-1) {
			this.isLargeHoverPresent.push(preview.resourceUrl);
			console.debug("pushing : ", preview.resourceUrl);
		}
		
		  tc.addIframeUrl(preview.shortTitle, preview.smallPreview.url, preview.resourceUrl);  
		}
		this._dojoHack(tc.domNode);
		//tc.startup();
		var mdiv = dojo.create("div", {style:"padding-bottom:1%"});
		mdiv.appendChild(tc.domNode);
		this._addButtons(mdiv);
		this.set("content",mdiv);
		this._shownAlready = true;
		//this.show();
		this._internalShow();
		var par = mdiv.offsetParent;
		this.largeLeft = par.offsetLeft;
		this.largeTop = par.offsetTop;
		this._anchorList=dojo.connect(dojo.byId("chevTd"), 'onclick', this, dojo.hitch(this, this.onClickChevron), true);
		//dojo.connect(dojo.byId("closeLink"), 'onclick', this, dojo.hitch(this, this.onClickClose), true);
		dojo.connect(dojo.byId("moreInfo"), 'onclick', this, dojo.hitch(this, this.onClickMore), true);
	}
  },
  
  setHoverUrlInfo: function(urlInfo)
  {
	  this.urlInfo = urlInfo;
  },
  
  getHoverUrlInfo: function(urlInfo)
  {
	  return this.urlInfo;
  }

});
