dojo.provide("com.ibm.security.modeling.analysis.PotentialRoleMembersIdentityPermissionTable");

dojo.require("com.ibm.security.modeling.util.CommonUtilities");
dojo.requireLocalization("com.ibm.security.modeling.analysis", "PotentialRoleMembersIdentityPermissionTableText");
dojo.requireLocalization("com.ibm.security.modeling.analysis", "AnalysisCatalogDefaultsText");


dojo.declare("com.ibm.security.modeling.analysis.PotentialRoleMembersIdentityPermissionTable",[com.ibm.security.modeling.analysis.RoleMembersIdentityPermissionTable],{
	
	//TODO: Need to specify the appropriate help file name
	helpFile: "RoleAnalysisUserPermissionHelp.html",
	querySet: "potentialRoleMembers",
	
	constructor: function(){
		this.inherited(arguments);
		this.localResourcesForPotentialMembers = dojo.i18n.getLocalization("com.ibm.security.modeling.analysis","PotentialRoleMembersIdentityPermissionTableText");
	},
	
	postMixInProperties: function(){
		this.inherited(arguments);
		//TODO: Need to specify the appropriate help file name
		if(this.isUserPermissionAnalysis == true){
			this.helpFile = "ui_search_users_by_permissions.html";
		}else{
			this.helpFile = "ui_search_permissions_by_users.html";
		}
	},
	
	getTitle: function() {
		// Summary:
		//		Gets the translated title of the panel.  
		//		The Analysis pane will use this method 
		//		to updated the title on the Analysis pane when the panel is displayed.
	
		// returns: string
		//		title
		var titleText = this.isUserPermissionAnalysis === true ? this.localResourcesForPotentialMembers.IDENTITY_ANALYSIS_PANE : this.localResourcesForPotentialMembers.PERMISSION_ANALYSIS_PANE;
		if(this.roleUri){
			this._loadRoleItem();
			if (this.roleItem) {
				var roleName = this.roleItem.name;
				roleName = com.ibm.security.modeling.util.HtmlEscapingUtils.parseHTMLTag(roleName);
				titleText = dojo.string.substitute(titleText, {
					"roleName": roleName? roleName:""
					//,"attributeName": attributeName? attributeName:""		
				});
			}
		}else{
			this.analysisDefaultCatalogResource = dojo.i18n.getLocalization("com.ibm.security.modeling.analysis","AnalysisCatalogDefaultsText");
			titleText = this.isUserPermissionAnalysis === true ? this.analysisDefaultCatalogResource.COMPARE_POTENTIAL_MEMBER_PERMISSION_TO_ROLE_SHORT_DESCRIPTION : this.analysisDefaultCatalogResource.COMPARE_PERMISSION_POTENTIAL_MEMBER_TO_ROLE_SHORT_DESCRIPTION;
		}			
		return titleText;
	}
});