/*
Licensed Materials - Property of IBM

Role and Policy Modeler

 Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

dojo.provide("com.ibm.security.modeling.api.AttributeScopeRestManager");

dojo.require("com.ibm.security.modeling.api.RestManager");

dojo.declare("com.ibm.security.modeling.api.AttributeScopeRestManager", com.ibm.security.modeling.api.RestManager, 
{
	// entityType: String
	//		Possible Values are users and permissions
	scopeType:"",
	availScopeTypes:{
						ROLE: "role",
						USER: "user",
						PERMISSION: "permission"
					},
	_roleAttributeScopeResourceUri:"/isrm/rest/rolescope/attributes",
	_userAttributeScopeResourceUri:"/isrm/rest/userscope/attributes",
	_permissionAttributeScopeResourceUri:"/isrm/rest/permissionscope/attributes",
	constructor: function(args) {
		if(args.scopeType == this.availScopeTypes.ROLE ){
			this.resourceUri=this._roleAttributeScopeResourceUri;
		}else if(args.scopeType == this.availScopeTypes.USER ){
			this.resourceUri=this._userAttributeScopeResourceUri;
		}else if(args.scopeType == this.availScopeTypes.PERMISSION ){
			this.resourceUri=this._permissionAttributeScopeResourceUri;
		}
	}
});