/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

 Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.api.UndoRestManager");

dojo.require("com.ibm.security.modeling.api.RestManager");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.api.UndoRestManager", 
	com.ibm.security.modeling.api.RestManager, 
	{
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.api.UndoRestManager"),
	constructor: function(args) {
		this._trace.entering("", "constructor");
		this._trace.object(arguments, "constructor", "Constructor args");
		dojo.mixin(this, args);
		this._resourceSchema = {
			"description": "An Undo",
			"type": "object",
			"properties": {
				"id": {"type": "string"},
				"label": {
					"description": "A Label",
					"type": "object",
					"properties": {
						"inserts": {
							"description": "Label Inserts",
							"items": {
								"type": "string"
							}
						},
						"key": {"type": "string"},
						"text": {"type": "string"}
					}
				},
				"uri": {"type": "string", "format": "url"}
			}
		};
		this._trace.exiting("", "constructor");
	},

	undo: function(
			/*string*/ resourceId,
			/*function*/ successCallBack, 
			/*function*/ errorCallBack) {
		this._trace.entering(this.id, "undo");
		// summary:	makes rest call to undo the specified resource
		// resourceId: string
		//	 	id of the resource that is to be undone. 
		//		If it is null then it is considered that rest api is pointing to that resource.
		// successCallBack: function
		//			Success callback handler function.
		// errorCallBack: function
		//			Error callback function.
		this.doHttpDelete(
			resourceId,
			successCallBack,
			errorCallBack
		);
		this._trace.exiting(this.id, "undo");
	}

});
