/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

 Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.api.UserRestManager");

dojo.require("com.ibm.security.modeling.api.RestManager");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.api.UserRestManager", 
	com.ibm.security.modeling.api.RestManager, 
	{
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.api.UserRestManager"),
	constructor: function(args) {
		this._trace.entering("", "constructor");
		this._trace.object(arguments, "constructor", "Constructor args");
		
		if (this.resourceUri == null) {
			this.resourceUri = "/isrm/rest/users/";
		}
		
		this._resourceSchema = {
			"description":"A User",
			"type":"object",
			
			"properties": {
				"uri":{"type":"string","format":"url"},
		        "id":{"type":"string"},
		        "uiColumn1":{"type":"string"},
		        "uiColumn2":{"type":"string"},
		        "uiColumn3":{"type":"string"},
		        "uiColumn4":{"type":"string"},
		        "uiColumn5":{"type":"string"},
		        "uid":{"type":"string"}
			}
		};
		this._trace.exiting("", "constructor");
	}
});