/*
 * BreadCrum manager manages the breadCrum . Instantiation take place at the root node , every othe node publish 
 * when come on viewport . 
 * On Publish each panel gives it hiding function .
 * Manager internally connect to that function , so that breadcrum get updated when that action take place from some where else .
 * NOTE : do not pass this hiding function as a hitched function to any event management 
 *        like : button.onClick = dojo.hitch(this, this.hide)
 *  Connection fails on such hide function , because your onclick is hitched function and not actual hide .
 *  
 *  Whenever click on any breadcrum , manager start calling hide function in reverser order , i.e keep hiding all the pages 
 *  so that currect get visible . 
 *  
 *  By Default : It add a special case here home panel and manage this special case . 
 */
dojo.provide("com.ibm.security.modeling.breadcrumbs.BreadCrumInterface");

dojo.declare("com.ibm.security.modeling.breadcrumbs.BreadCrumInterface", null, {
	
	constructor:function(){
		//summary: 
		//		Provides convenience methods for managing breadcrumbs.  panel widgets should inherit this
		//		for support of breadcrumbs.
		// pollTimeForHide: Integer
		//		Time in milliseconds (not sure why needed)
	   this.pollTimeForHide=100;
    },  
	addBreadCrum:function(label,hideFunction,context){
	 if(hideFunction) this.setHideMethod(hideFunction);
		dojo.publish("AddBreadCrum",[{
			context : context||this,
			hideFunction : hideFunction||"hidePage",
			label:label,
			canHide:dojo.hitch(this,function(){return this.canHide();}),
			pollForHide : this.getHidePollTime()
			
		}]);
	},
	updateBreadCrum:function(newLabel){
		dojo.publish("UpdateBreadCrum",[{
			label:newLabel,
			panelId:this.globalpanelId
		}]);  
	},
	setHideMethod:function(fn){
		this.hidePage = fn;
	},
	hidePage:function(){
		
	},
	//by deFault this will always return true;
	canHide:function(){
		return true;
	},
	getHidePollTime : function(){
		return  this.pollTimeForHide;
	}

	
});