dojo.provide("com.ibm.security.modeling.breadcrumbs.BreadcrumbBuilder");

dojo.require("dijit._KeyNavContainer");
dojo.require("ibm.tivoli.tip.dijit.BreadcrumbBar");
dojo.require("ibm.tivoli.tip.dijit.Breadcrumb");
dojo.require("ibm.tivoli.tip.dijit.BreadcrumbSeparator");
dojo.require("com.ibm.security.modeling.breadcrumbs.BreadcrumbBar");
dojo.require("com.ibm.security.modeling.breadcrumbs.BreadcrumbData");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.breadcrumbs.BreadcrumbBuilder", null, {
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.breadcrumbs.BreadcrumbBuilder"),
	// isAccessible: boolean
	//		if true exposes breadcrumbs to tab order, if false hides it so screen readers cannot navigate.
	isAccessible: true,
	constructor: function(args) {
		this.breadcrumbs = [];
		this.thebreadcrumbBar = null;
	},
	withId:function(id) {
		this.id = id;
		return this;
	},
	withBreadcrumb:function(breadcrumb) {
		var length = this.breadcrumbs.length;
		this.breadcrumbs[length] = breadcrumb;
		return this;
	},
	withoutAccessibility: function(){
		this.isAccessible = false;
		return this;
	},
	build: function() {
		this._trace.entering("id:"+this.id+",isAccessible:"+this.isAccessible, "build");
		var lastIndex = this.breadcrumbs.length - 1;
		if(this.thebreadcrumbBar) {
		     this.thebreadcrumbBar.destroy();
		}
		var breadcrumbArgs = this.isAccessible?{}:{tabIndex:-1};
		var breadcrumbBar = new com.ibm.security.modeling.breadcrumbs.BreadcrumbBar(breadcrumbArgs,this.id);
		this.thebreadcrumbBar = this._addBreadcrumbs(breadcrumbBar, lastIndex);
		this._trace.exiting("", "build");
		return new com.ibm.security.modeling.breadcrumbs.BreadcrumbData(this.thebreadcrumbBar, this.breadcrumbs);
	},
	_addBreadcrumbs:function(breadcrumbBar, lastIndex) {
		this._trace.entering("", "_addBreadcrumbs");
		dojo.forEach(this.breadcrumbs, dojo.hitch(this, function(breadcrumb, i){
			breadcrumbBar.addChild(breadcrumb);
			this._trace.finest("loop index:" + i + ", last index: " + lastIndex, "_addBreadcrumbs");
			if (i !== lastIndex) {
				breadcrumbBar.addChild(new ibm.tivoli.tip.dijit.BreadcrumbSeparator({}));
			}
		}));
		this._trace.exiting(breadcrumbBar, "_addBreadcrumbs");
		return breadcrumbBar;
	},
	
	
	/////////////////The following calls should be deprecated.  Use BreadcrumbData instead.///////////////////

	getLength:function() {
		// tags: deprecated
		return this.breadcrumbs.length;
	},
	getBreadCrumbBar: function(){
		// tags: deprecated
		return this.thebreadcrumbBar;
	},
	addBreadCrumb: function(breadcrumb){
		// tags: deprecated
		var length = this.breadcrumbs.length;
		this.breadcrumbs[length] = breadcrumb;
		if(length > 0) {
			this.thebreadcrumbBar.addChild(new ibm.tivoli.tip.dijit.BreadcrumbSeparator({}));
		}
		this.thebreadcrumbBar.addChild(breadcrumb);
	},

	removeStackBottomBreadCrumb: function() {
		// tags: deprecated
		breadCrumb_0 = this.thebreadcrumbBar.getChildren()[0];

		if(breadCrumb_0){
			var node = breadCrumb_0.domNode;
			if(node && node.parentNode){
				node.parentNode.removeChild(node); // detach but don't destroy
			}
			this.thebreadcrumbBar.breadcrumbWidget.pop();
		}
	},

	removeLastBreadCrumb: function(){
		// tags: deprecated
		var noofbreadcrumbs = this.breadcrumbs.length;
		this.thebreadcrumbBar.removeChild(noofbreadcrumbs*2-2);
		this.thebreadcrumbBar.breadcrumbWidget.pop();
		this.thebreadcrumbBar.removeChild(noofbreadcrumbs*2-3);
		this.thebreadcrumbBar.breadcrumbWidget.pop();

		if(noofbreadcrumbs == 1) {
			this.removeStackBottomBreadCrumb();
		}

		this.breadcrumbs.pop();
	},

	flushBreadCrumbStack: function() {
		// tags: deprecated
		while (this.breadcrumbs.length > 0) {
			this.removeLastBreadCrumb();
		}
		/* Remove the bottom of the stack element. */
		this.removeLastBreadCrumb();
	}


});
