dojo.provide("com.ibm.security.modeling.breadcrumbs.BreadcrumbData");

dojo.declare("com.ibm.security.modeling.breadcrumbs.BreadcrumbData", null, {
	
	breadcrumbBar: null,
	breadcrumbs: null,
	
	constructor: function(breadcrumbBar, breadcrumbs) {
		this.breadcrumbBar = breadcrumbBar;
		this.breadcrumbs = breadcrumbs;
	},
	
	getLength:function() {
		return this.breadcrumbs.length;
	},
	
	getBreadCrumbBar: function(){
		return this.breadcrumbBar;
	},
	
	isInBreadcrumbBar: function(/*String*/panelId) {
		// summary:
		//		Determines if there is a panel matching the given id in the breadcrumb bar.
		var isInBar = false;
		for (var i=0;i<this.breadcrumbs.length;i++) {
			if (panelId === this.breadcrumbs[i].panelId) {
				isInBar = true;
				break;
			}
		}
		return isInBar;
	},
	getBreadCrumbForPanelID: function(/*String*/panelId) {
		// summary:
		//		Determines if there is a panel matching the given id in the breadcrumb bar.
		var isInBar = false;
		for (var i=0;i<this.breadcrumbs.length;i++) {
			if (panelId === this.breadcrumbs[i].panelId) {
				isInBar = true;
				break;
			}
		}
		if(isInBar) return this.breadcrumbs[i];
		return null;
	},
		
	addBreadCrumb: function(breadcrumb){
		var length = this.breadcrumbs.length;
		this.breadcrumbs[length] = breadcrumb;
		if(length > 0) {
			this.breadcrumbBar.addChild(new ibm.tivoli.tip.dijit.BreadcrumbSeparator({}));
		}
		this.breadcrumbBar.addChild(breadcrumb);
	},
	
	removeStackBottomBreadCrumb: function() {
		breadCrumb_0 = this.breadcrumbBar.getChildren()[0];

		if(breadCrumb_0){
			var node = breadCrumb_0.domNode;
			if(node && node.parentNode){
				node.parentNode.removeChild(node); // detach but don't destroy
			}
			this.breadcrumbBar.breadcrumbWidget.pop();
		}
	},

	removeLastBreadCrumb: function(){
		var noofbreadcrumbs = this.breadcrumbs.length;
		this.breadcrumbBar.removeChild(noofbreadcrumbs*2-2);
		this.breadcrumbBar.breadcrumbWidget.pop();
		this.breadcrumbBar.removeChild(noofbreadcrumbs*2-3);
		this.breadcrumbBar.breadcrumbWidget.pop();

		if(noofbreadcrumbs == 1) {
			this.removeStackBottomBreadCrumb();
		}

		this.breadcrumbs.pop();
	},

	flushBreadCrumbStack: function() {
		while (this.breadcrumbs.length > 0) {
			this.removeLastBreadCrumb();
		}
		/* Remove the bottom of the stack element. */
		this.removeLastBreadCrumb();
	},
	
	addClass: function(/*String*/className) {
		// summary: 
		//		Adds the given class to the breadcrumb bar.
		// className: String
		dojo.addClass(this.breadcrumbBar.domNode, className);
	}

});