dojo.provide("com.ibm.security.modeling.dijit.layout.StackContainer");

dojo.require("dijit.layout.StackContainer");
dojo.require("com.ibm.security.modeling.util.Trace");



dojo.declare("com.ibm.security.modeling.dijit.layout.StackContainer", [dijit.layout.StackContainer], {
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.dijit.layout.StackContainer"),
	postCreate: function() {
		this.inherited(arguments);
		this._makeAccessible();
	},
	_makeAccessible:function() {
		this._trace.entering(this._getTraceId(), "_makeAccessible");
		//remove the tabpanel role that gets put on stackcontainer, since we are using that role for its children.
		dijit.removeWaiRole(this.containerNode, "tabpanel");
		dojo.subscribe(this.id + "-selectChild", function(pane){	
			//Let the widget set its focus once loaded
			console.info("***StackContainer setting focus on select child");
			dijit.focus(pane.domNode);
		});	
		/*this.transitionConnection = dojo.connect(this, "_transition", function(newPane, oldPane) {
			console.info("***StackContatiner setting hidden state on transition");
			dijit.setWaiState(oldPane.domNode, "hidden", true);
			dijit.setWaiState(newPane.domNode, "hidden", false);
		});*/
		this._trace.exiting(this._getTraceId(), "_makeAccessible");
	},
	startup : function() {
		if (this._trace.isFinest()) {
			this._trace.entering(this._getTraceId(), "startup");
		}
		this.inherited("startup",arguments);
		if (this._trace.isFinest()) {
			this._trace.exiting(this._getTraceId(), "startup");
		}
	},
	/*destroy: function () {
		this.inherited(arguments);
		dojo.disconnect(this.transitionConnection);
	},*/

	resize : function() {
		if (this._trace.isFinest()) {
			this._trace.entering(this._getTraceId(),"resize");
		}
		this.inherited("resize",arguments);
		if (this._trace.isFinest()) {
			this._trace.exiting(this._getTraceId(),"resize");
		}
	},

	_show : function() {
		if (this._trace.isFinest()) {
			this._trace.entering(this._getTraceId(),"_show");
		}
		this.inherited("_show",arguments);
		if (this._trace.isFinest()) {
			this._trace.exiting(this._getTraceId(),"_show");
		}
	},
	_getTraceId : function() {
		return this.id + (this.getParent() ? "-" + this.getParent().id:"");
	}
	
});