dojo.provide("com.ibm.security.modeling.dijit.layout.ToggleSplitter"); 

dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("dijit.form.Button");

dojo.requireLocalization("com.ibm.security.modeling.dijit.layout", "ToggleSplitterText");
dojo.require("com.ibm.security.modeling.util.WidgetUtilities");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.dijit.layout.ToggleSplitter", [ dijit.layout._Splitter ], {
	
	// _widgetUtilities: com.ibm.security.modeling.util.WidgetUtilities
	//		Utilities for widgets.
	// _widgetUtilities: null,
	
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.dijit.layout.ToggleSplitter"),
	
	templateString: null,
	templatePath: dojo.moduleUrl("com.ibm.security.modeling.dijit.layout","templates/ToggleSplitter.html"),	
	widgetsInTemplate: true,
	
	state: "minimize",	
	_splitSize: -1,
	constructor : function() {
		this.inherited(arguments);
	},
	postMixInProperties: function() {
		// Summary:
		//		Widget life-cycle method.
		
		this._trace.entering(this.id, "postMixInProperties");
		
		this.inherited(arguments);
		if (!this.localResources) {
			this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.dijit.layout", "ToggleSplitterText");
		}
		this._widgetUtilities = new com.ibm.security.modeling.util.WidgetUtilities();
		this._trace.exiting(this.id, "postMixInProperties");
	},
	postCreate : function() {
		this.inherited(arguments);
	},
	startup : function() {
		this.inherited("startup",arguments);
		this._updateSplitValue();
		this._toggle(this.state);
	},
	
	_maximize : function(event) {
		this._trace.entering(this.id, "_maximize");
		this._toggle("maximize");
		if (event) {
			dojo.stopEvent(event);
		}
		this._trace.exiting(this.id, "_maximize");
	}, 
	_minimize : function(event) {
		this._trace.entering(this.id, "_minimize");
		this._toggle("minimize");
		if (event) {
			dojo.stopEvent(event);
		}
		this._trace.exiting(this.id, "_minimize");
	},
	_split : function(event) {
		this._trace.entering(this.id, "_split");
		
		if (!this._canSplit()) {
			this._minimize(event);
			return;
		}
		
		this._toggle("split");
		if (event) {
			dojo.stopEvent(event);
		}
		
		//record of last split value
		if (this.state == "split") {
			this._updateSplitValue(); // Record to use when splitting from maximize/minimize states.
		}
		
		this._trace.exiting(this.id, "_split");
	},
	
	_isFirstToggle: true,
	_toggle : function(action) {
		this._trace.entering(this.id, "_toggle");
		
		if (action == "maximize") {
			this._openAndCloseRegions(this.region,"center");	
			this.state = "maximize";
		} else if (action == "minimize") {
			this._openAndCloseRegions("center",this.region);	
			this.state = "minimize";
		} else if (action == "split" ) {
			
			this._splitRegions();
			this.state = "split";
		} 
		
		this._updateButtonState();
		if (this._isFirstToggle && action != "minimize") {
			this._isFirstToggle = false;
			this.layout();
		}
		this._trace.exiting(this.id, "_toggle");
	},
	_updateButtonState : function() {
		this._trace.entering(this.id, "_updateButtonState");
		if (this.state == "split") {
			this._widgetUtilities.disableButton(this.splitButton);
			this._widgetUtilities.enableButton(this.upButton);
			this._widgetUtilities.enableButton(this.downButton);
		} else if (this.state == "maximize") {
			this._widgetUtilities.enableButton(this.splitButton);
			this._widgetUtilities.disableButton(this.upButton);
			this._widgetUtilities.enableButton(this.downButton);
		} else if (this.state == "minimize") {
			this._widgetUtilities.enableButton(this.splitButton);
			this._widgetUtilities.enableButton(this.upButton);
			this._widgetUtilities.disableButton(this.downButton);
		}
		this._trace.exiting(this.id, "_updateButtonState");
	},
	_openAndCloseRegions : function(regionToOpen, regionToClose) {
		this._trace.entering(this.id, "_openAndCloseRegions");
		
		/*
		var widgetToOpen =  this.container["_" + regionToOpen + "Widget"];
		var widgetToClose = this.container["_" + regionToClose + "Widget"];
		*/
		var widgetToOpen = null;
		var widgetToClose = null;
		var children = this.container.getChildren();
		for (var i=0; i<children.length; i++) {
			if (!widgetToOpen && children[i].region == regionToOpen) {
				widgetToOpen = children[i];
			} else if (!widgetToClose && children[i].region == regionToClose) {
				widgetToClose = children[i];
			}
			
			if (widgetToOpen && widgetToClose) {
				break;
			}
		}
		
		// Notify only if needed.
		var onHideNotification = ! dojo.hasClass(widgetToClose.domNode, "dijitHidden");
		var onShowNotification = dojo.hasClass(widgetToOpen.domNode, "dijitHidden");
		
		//special handling for center layout 
		//since the border container performs layout based on the 
		//size of the top/bottom/leading/trailing widgets
		var sideRegionWidget = widgetToOpen;
		var sideRegionSize = this._getChildMaxSize();
		if (regionToOpen == "center") {
			// Center is adjusted to take up the size per the change in other regions.
			sideRegionWidget = widgetToClose;
			sideRegionSize = 0;
		} 
		this.showNode(widgetToOpen.domNode);
		this.hideNode(widgetToClose.domNode);
		
		this.container._layoutChildren(sideRegionWidget.id, sideRegionSize);
		if (onHideNotification) {
			widgetToClose.onHide();
		}
		if (onShowNotification) {
			widgetToOpen.onShow();
		}
		
		this._trace.exiting(this.id, "_openAndCloseRegions");
	},
	_splitRegions: function() {
		this._trace.entering(this.id, "_splitRegions");
		
		//var centerWidget = this.container["_centerWidget"];
		var centerWidget = dojo.filter(this.container.getChildren(), function (child) { 
			return child.region == "center"; 
		})[0];
		var childWidget = this.child;
		
		if (this.state == "maximize") {
			this.showNode(centerWidget.domNode);
			centerWidget.onShow();
		} else if (this.state == "minimize") {
			this.showNode(childWidget.domNode);
			childWidget.onShow();
		}
		
		// adjust the child, and widget in center will get size automatically.
		this.container._layoutChildren(childWidget.id, this._getSplitSize());
		
		this._trace.exiting(this.id, "_splitRegions");
	},
				
	hideNode:function(node) {
		dojo.removeClass(node, "dijitVisible");
		dojo.addClass(node, "dijitHidden");
	},
	showNode:function(node) {
		dojo.removeClass(node, "dijitHidden");
		dojo.addClass(node, "dijitVisible");
	},
	
	_updateSplitValue: function() {
		var splitSize = 0; // insufficient space, can not split.
		
		var minSplitSize = 20;
		var maxSize  = this._getChildMaxSize();
		var maxSplitSize = maxSize - minSplitSize; // for center widget.
		if (maxSplitSize >= minSplitSize) {
			var childNode = this.child.domNode;
			if (dojo.hasClass(childNode, "dijitVisible")) { // Child is visible, child's size is split size.
				splitSize = dojo.marginBox(childNode)[this.horizontal? "h" : "w"];
			} else {
				splitSize = 50; // default size
			}
			
			if (splitSize > maxSplitSize) {
				splitSize = maxSplitSize;
			}
		} else {
			splitSize = -1; // try later
		}
		
		this._splitSize = splitSize;
	},
	
	_canSplit: function() {
		if (this._needUpdateOfSplitSize()) {
			this._updateSplitValue();
		}
		return this._splitSize != 0;
	},
	
	_needUpdateOfSplitSize: function() {
		return this._splitSize == -1;
	},
	
	_getSplitSize: function() {
		return this._splitSize;
	},
	
	_getChildMaxSize: function() {
		
		var containerSize = dojo.marginBox(this.container.domNode)[this.horizontal? "h" : "w"];
		if (!containerSize || isNaN(containerSize) || containerSize < 0) {
			containerSize = 0;
		}
		
		var opposite = {left:'right', right:'left', top:'bottom', bottom:'top', leading:'trailing', trailing:'leading'};
		var oppositeChildSize = 0;
		var oppositeChildSpliterSize = 0;
		var oppositeChildren = dojo.filter(this.container.getChildren(), function(child){ return child.region == opposite[this.region];});
		
		if (oppositeChildren && oppositeChildren.length > 0) {
			
			var oppositeChild = oppositeChildren[0];
			
			oppositeChildSize = dojo.marginBox(oppositeChild.domNode)[this.horizontal? "h" : "w"];
			if (!oppositeChildSize || isNaN(oppositeChildSize) || oppositeChildSize < 0) {
				oppositeChildSize = 0;
			}
			
			if(oppositeChild._splitterWidget) {
				oppositeChildSpliterSize = oppositeChild._splitterWidget[this.horizontal? "h" : "w"];
				if (!oppositeChildSpliterSize || isNaN(oppositeChildSpliterSize) || oppositeChildSpliterSize < 0) {
					oppositeChildSpliterSize = 0;
				}
			}
		}
		var calculatedSize = containerSize - (oppositeChildSize+oppositeChildSpliterSize);
		
		return calculatedSize < 0 ? 0 : calculatedSize;
		
		/*var maxChildSize = this._computeMaxSize();
		var opposite = {left:'right', right:'left', top:'bottom', bottom:'top', leading:'trailing', trailing:'leading'};
		var oppositeRegionSplitterthickness = this.container._splitterThickness[opposite[this.region]];
		var splitterThikness = this.container._splitterThickness[this.region];
		
		if (!maxChildSize  || isNaN(maxChildSize) || maxChildSize < 0) {
			maxChildSize = 0;
		}
		if (!oppositeRegionSplitterthickness || isNaN(oppositeRegionSplitterthickness) || oppositeRegionSplitterthickness < 0) {
			oppositeRegionSplitterthickness = 0;
		}
		if (!splitterThikness || isNaN(splitterThikness) || splitterThikness < 0) {
			splitterThikness = 0;
		}
		
		var maximizedRegionSize = maxChildSize 
			+ (splitterThikness - oppositeRegionSplitterthickness) 
			+ 20 ;
		return maximizedRegionSize;*/
	},
	
	_onButtonKeyPress: function(event) {
		event.stopPropagation();
	},
	_onButtonMouseDown: function(event) {
		event.stopPropagation();
	},
	_onButtonMouse: function(event) {
		event.stopPropagation();
	},
	
	_beforeDrag: function(e) {
		this._trace.entering(this.id, "_beforeDrag");
		
		var hiddenRegion = null;
		if (this.state == "minimize") {
			hiddenRegion = this.region;
		} else if (this.state == "maximize") {
			hiddenRegion = "center";
		}
		if (hiddenRegion) {
			// var hiddenNode = this.container["_"+hiddenRegion];
			var hiddenChild = dojo.filter(this.container.getChildren(), function (child) { 
					return child.region == hiddenRegion; 
				})[0];
			var hiddenNode = hiddenChild.domNode;
			var invisible = dojo.hasClass(hiddenNode, "dijitHidden") || (dojo.marginBox(hiddenNode)[this.horizontal? "h" : "w"] <= 0);
			this._trace.finest(this.id+" - :region"+hiddenRegion+", invisible: "+invisible, "_beforeDrag");
			if (invisible) {
				this.showNode(hiddenNode);
			}
		}
		this._trace.exiting(this.id, "_beforeDrag");
	},
	
	_startDrag: function(e) {
		this._trace.entering(this.id, "_startDrag");
		this._beforeDrag(e);
		this.inherited(arguments);
		this._trace.exiting(this.id, "_startDrag");
	},
	
	_stopDrag: function(e) {
		this._trace.entering(this.id, "_stopDrag");
		this.inherited(arguments);
		this._afterDrag();
		this._trace.exiting(this.id, "_stopDrag");
	},
	
	_afterDrag: function() {
		this._trace.entering(this.id, "_afterDrag");
		var childNode = this.child.domNode;
		// var centerNode = this.container["_center"];
		var centerChild = dojo.filter(this.container.getChildren(), function (child) { 
				return child.region == "center"; 
			})[0];
		var centerNode = centerChild.domNode;
		var invisibleChild = dojo.marginBox(childNode)[this.horizontal? "h" : "w"] <= 20; // Considering that 20 is the min size
		var invisibleCenter = dojo.marginBox(centerNode)[this.horizontal? "h" : "w"] <= 20; // Considering that 20 is the min size
		
		this._trace.finest(this.id+" - invisibleChild: "+invisibleChild+", invisibleCenter: "+invisibleCenter, "_afterDrag");
		
		if (invisibleChild) {
			this._minimize();
		} else if (invisibleCenter) {
			this._maximize();
		} else if (!invisibleChild && !invisibleCenter) {
			this._updateSplitValue();
			if (this.state != "split") {
				this._split();
			}
		}
		this._trace.exiting(this.id, "_afterDrag");
	},
	
	_layoutTimerOn: false,
	layout: function() {
		try {
			this._trace.entering(this.id, "layout");
			// Optimize while doing setTimeOut and then byPassing the multiple invocations it timer is not done yet.
			if (!this._started || this.state == "minimize" || this._layoutTimerOn) {
				return;
			}
			
			setTimeout(dojo.hitch(this, function () {
				this._layoutTimerOn = false; 
				this._adjustLayOut();
			}), 500);
			this._layoutTimerOn = true;
			
		} finally {
			this._trace.exiting(this.id, "layout");
		}
	},
	
	_adjustLayOut: function() {
		if (this.state == "maximize") {
			var maxSize = this._getChildMaxSize();
			// In maximize state, child should take all available space.
			// Need to consider the size of spliter i.e. 20.
			maxSize = maxSize - 20;
			
			this.container._layoutChildren(this.child.id, maxSize);
		} else if (this.state == "split") {
			this._updateSplitValue();
			this._split();
		}
	}
});