/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

� Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.security.modeling.help.Help");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.security.modeling.util.Trace");
// NLS
dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");

// define the widget class
dojo.declare (
	"com.ibm.security.modeling.help.Help", 
    [ dijit._Widget, dijit._Templated ],
{
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.help.Help"),
	templatePath: dojo.moduleUrl("com.ibm.security.modeling.help","templates/Help.html"),
	widgetsInTemplate: true,
	
	// globalResources: Object
	//			Reference to the global shared resource bundle
	globalResources: null,
	
	containerDialog: null,
	
	
	helpFile: "",
	jumpPoint: "",
	
	constructor: function() {
		this._trace.entering("", "constructor");
		this._trace.object(arguments, "constructor", "Constructor args");
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
		this._trace.exiting("", "constructor");
	},

	postCreate: function() {
		this._trace.entering(this.id, "postCreate");
		this.inherited ("postCreate", arguments);
		if (this.containerDialog) {
			// Place this Help widget beside Dialog's close icon.
			dojo.place(this.domNode, this.containerDialog.closeButtonNode, "before");
		}
		this._trace.exiting(this.id, "postCreate");
	},

	destroy: function() {
		this._trace.enteringWithStack(this.id, "destroy", true);
		try {
			this.inherited(arguments);
			this._trace.exiting(this.id, "destroy");
		} catch(e) {
			this._trace.exception(e, "destroy");
			throw e;
		}
	},
	
	onHelp: function() {
		this._trace.entering(this.id, "onHelp");
		window.open(this._getHref(), 'PortletHelpWindow', 'resizable=yes,scrollbars=yes,menubar=no,toolbar=no,status=no,width=800,height=600,top=40,left=40').focus();
		this._trace.exiting(this.id, "onHelp");
	},
	
	_onHelpEnter: function() {
		this._trace.entering(this.id, "_onHelpEnter");
		dojo.addClass(this.domNode, "dijitHelpIcon-hover");
		this._trace.exiting(this.id, "_onHelpEnter");
	},
	
	_onHelpLeave: function() {
		this._trace.entering(this.id, "_onHelpLeave");
		dojo.removeClass(this.domNode, "dijitHelpIcon-hover");
		this._trace.exiting(this.id, "_onHelpLeave");
	},
	
	_getHref: function() {
		this._trace.entering(this.id, "_getHref");
		try {
			return dojo.config.serverProperties.helpContextRoot + "/com.ibm.security.modeling.console.help/ui/" + this.helpFile +"?noframes=true" +"#" + this.jumpPoint;
		} finally {
			this._trace.exiting(this.id, "_getHref");
		}
	},
	
	setHelpFile: function(/*String*/ helpFile) {
		this.helpFile = helpFile;
	}
});