dojo.provide("com.ibm.security.modeling.hierarchy.RoleCopyDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.security.modeling.widgets.IsrmDialogBase");
dojo.require("dijit.Dialog");
dojo.require("dojox.widget.Wizard");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("dijit._Container");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("com.ibm.security.modeling.util.NlsUtilities");
dojo.require("com.ibm.security.modeling.util.ErrorUtilities");
dojo.require("com.ibm.security.modeling.hierarchy.RoleScopingPanel");
dojo.require("com.ibm.security.modeling.hierarchy.RoleCopyOptionPanel");
dojo.require("com.ibm.security.modeling.breadcrumbs.BreadcrumbBuilder");
dojo.require("com.ibm.security.modeling.projects.BreadCrumb");
dojo.require("com.ibm.security.modeling.widgets.ProgressBar");
dojo.require("com.ibm.security.modeling.mining.polling");

dojo.require("com.ibm.security.modeling.widgets.MultiMessageArea");

// NLS
dojo.requireLocalization("com.ibm.security.modeling.hierarchy", "RoleCopyDialogText");
dojo.requireLocalization("com.ibm.security.modeling", "LogMessages");
dojo.requireLocalization("com.ibm.security.modeling", "PluginMessages");




dojo.declare("com.ibm.security.modeling.hierarchy.RoleCopyDialog", com.ibm.security.modeling.widgets.IsrmDialogBase, {
	 //
	 // Implements the session details dialog for viewing / managing files in the session. 
	 // 
	 //
	 
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.hierarchy.RoleCopyDialog"),	
	templatePath : dojo.moduleUrl("com.ibm.security.modeling.hierarchy", "templates/RoleCopyDialog.html"),
	widgetsInTemplate : true,
	// hostname: String
	//		Hostname for server requests
	hostname: "",
	// port: String
	//		Port for server requests
	port: "16311",
	// parentWidget: domNode
	//		Widget which created this widget
	parentWidget : null,
	// heightFactor: number
	//		Gives the hight factor for widget
	heightFactor:1.1,
	// widthFactor: number
	//		Gives the width factor for widget
	widthFactor:1.1,
	// minHeight: number
	//		minimum height of widget
	minHeight:350,
	killOnHide:false,
	isInitialized:false,
	

		
	constructor : function() {
		// tags:
		//		protected
		this.inherited(arguments);
		this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.hierarchy", "RoleCopyDialogText");
		this._errorUtil = new com.ibm.security.modeling.util.ErrorUtilities();
		this.helpFile="ui_copy_roles_overview.html";
	},
	postMixInProperties: function() {
		this._trace.entering(this.id, "postMixInProperties");
		this.inherited(arguments);
		this.dialogTitle=this.localResources.COPY_ROLES_PROJECT_DIALOG;
		this._trace.exiting(this.id, "postMixInProperties");
	},
	postCreate : function() {
		// tags:
		//		protected
		this.inherited(arguments);
		//temp code
		this.disconnect(this._connects[0]);//dont need the startup resize
		this.progressBar = new com.ibm.security.modeling.widgets.ProgressBar();
		this._overrideContainerLtrFunction();
		this._createBreadcrumbBar();
		this._createAttributeScopingPanel();
		this._createRoleCopyOptionPanel();
		this._defineWizardButtonBehaviors();
		
	},
	_overrideContainerLtrFunction: function() {
		// summary:
		// 			Setups the direction for the widget.
		this._IsrmDialog.isLeftToRight = NlsUtilities.isLtr;
	},
	_defineWizardButtonBehaviors: function() {
		// summary:
		//			connects methods in this widget with wizard button clicks
		// tags:
		//			private
		this.overviewPanel.passFunction = dojo.hitch(this,function(){
			if(!this.isInitialized){
				this._initAttributePanel();
				this.isInitialized= true;
			}
		return true;});
		this.overviewPanel.doneFunction = function(){return true;};
		
		this.shoppingCartPanel.doneFunction=dojo.hitch(this, this.onFinish);
		this.shoppingCartPanel.passFunction = dojo.hitch(this._roleScopingPanel, this._roleScopingPanel.validateSelection);
		
		this.optionPanel.doneFunction=dojo.hitch(this, this.onFinish);
		this.wizard.cancelFunction=dojo.hitch(this, this.onCancel);
		// Updating the breadCrumbs of wizard on Panel selection.
		dojo.connect(this.wizard, "selectChild", this, this._updateBreadCrumbAndHelp);
	},
	_updateBreadCrumbAndHelp:function(){
		//This is for keeping Next button visible on the last panel(otherwise its hidden on the last panel as per the implementation from dojox.widget.Wizard
		var activeCrumb="";
		var inActiveCrumb="";
		var inActiveCrumb1="";
		if (this.wizard.selectedChildWidget.title==="overviewPanel"){
			this.wizard.previousButton.set("disabled", true);
			this.wizard.doneButton.set("disabled", true);
			activeCrumb=this.overViewBreadCrumb;
			inActiveCrumb=this.shoppingCartBreadCrumb;
			inActiveCrumb1=this.optionsBreadCrumb;
			this.helpSpan.helpFile="ui_copy_roles_overview.html";
		}
		
		if (this.wizard.selectedChildWidget.title==="shoppingCartPanel"){
			this.wizard.doneButton.set("disabled", false);
			activeCrumb=this.shoppingCartBreadCrumb;
			inActiveCrumb=this.overViewBreadCrumb;
			inActiveCrumb1=this.optionsBreadCrumb;
			this.helpSpan.helpFile="ui_select_roles.html";
		}
		
		//This is for keeping Back button disabled on the first panel(otherwise its enabled on the first panel as per the implementation from dojox.widget.Wizard
		if (this.wizard.selectedChildWidget.title==="optionPanel"){
			this.wizard.nextButton.domNode.style.display = "";
			this.wizard.nextButton.set("disabled", true);
			inActiveCrumb=this.shoppingCartBreadCrumb;
			inActiveCrumb1=this.overViewBreadCrumb;
			activeCrumb=this.optionsBreadCrumb;
			this.helpSpan.helpFile="ui_copy_options.html";
		}
		try{
			dojo.addClass(activeCrumb.domNode, "wizardpaneactive");
			dojo.removeClass(inActiveCrumb.domNode, "wizardpaneactive");
			dojo.removeClass(inActiveCrumb1.domNode, "wizardpaneactive");
		}catch(e){
			console.log("Error updating the breadCrumb");
		}
		
	},
	startup : function() {
		// tags:
		//		protected
	    this.inherited(arguments);
	    this._roleScopingPanel.startup();
		this._roleCopyOptionPanel.startup();
		dojo.addClass(this._IsrmDialog.domNode,"roleCopy");
		this.wizard.previousButton.set("disabled", true);
		this.wizard.nextButton.domNode.tabIndex=0;
		this.connect(this.wizard.nextButton.domNode,"onkeydown",dojo.hitch(this,this._wizardNextButtonProcess));
	 },
	 _wizardNextButtonProcess:function(e){
		if(e.keyCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER){
			this.wizard._forward();
		}
	 },
   	onFinish : function() {
		// summary:
		// 			Gets called when copy button is clicked.
		if(this._roleScopingPanel.validateSelection()== true){
			this._hideMessages();
			var currentScope=this._roleScopingPanel._getSelectedScope();
			var copyOptions=this._roleCopyOptionPanel.getCopyOptions();
			var scope={"roleScoping":currentScope,"roleCopyFor":copyOptions.roleCopyFor,"roleCopyInclude":copyOptions.roleCopyInclude};//need to send as an object  
			scope=dojo.toJson(scope);
			this.progressBar.show(this.localResources.COPING_ROLES_PROJECT_DIALOG);
			this.projectRestManager.copyRolesToProject(this.projectId,scope,dojo.hitch(this,this.roleCopyToProjectSuccess),dojo.hitch(this,this._errorHandler));
		 }
	},
	roleCopyToProjectSuccess:function(e,ioargs){
		try{
			var checkSuccessStatus = function(item) {
				//if the project status in "role copy queued" or "role coping" wait 
				//else role has completed
				if((item.status == 'm'|| item.status == 'n')){
					return false ; 
				}else{
					return true;
				}
			};
			var poller = new com.ibm.security.modeling.mining.polling( {
					url : this.projectUrl,
					messageArea : this.messageArea,
					errBack : dojo.hitch(this, this.onPollError),
					sucBack : dojo.hitch(this, this.onPollSuccess),
					checkSuccessStatus : checkSuccessStatus
			});
			poller.poll();
		}catch(err){
				console.log("problems with hide");
		}
	},
	_errorHandler:function(e,ioargs){
		try{
			this.progressBar.hide();
			this.hideDialogIfStateEnforcementError(e);
		}catch(err){
			console.log("problems with hide");
		}
		this._errorUtil.handleRESTError(e, this.messageArea);
		
	},
	onPollSuccess : function(item) {
		dojo.publish("ROLE_EDIT_EVENT");
		this.progressBar.hide();
		this.hide();
		dojo.publish("PROJECTSUPDATED","");
	},
	onPollError : function(error, isError) {
		if (isError && (error.dojoType != "timeout")) {
			// show the error message and let the use to decide
			// what to do
			// a real error has occured
			this._errorHandler(error,isError);
	  } else {
			this.progressBar.hide();
			this.hide();
			this.callback({activity:"copy"});
		}
	},
	show : function() {
		// summary:
		// 			Launches and initializes the dialog.
	   this.inherited(arguments);
	   this._hideMessages();
	   this.wizard.selectChild(this.overviewPanel);
	    
	},
	hide:function(){
		this.isInitialized= false;
		this.inherited(arguments);
	},
	_initAttributePanel:function(){
		// summary:
		// 			Initializes the attribute dialog.
		
		this._roleScopingPanel.initPanel();
		this._roleCopyOptionPanel.initPanel();
	},
	_createBreadcrumbBar: function() {
		
		this.overViewBreadCrumb = new com.ibm.security.modeling.projects.BreadCrumb(
				{
					label:this.globalResources.OVERVIEW,
					title:this.globalResources.OVERVIEW
				});

		this.shoppingCartBreadCrumb = new com.ibm.security.modeling.projects.BreadCrumb(
				{
					label:this.localResources.SELECT_ROLES,
					title:this.localResources.SELECT_ROLES
				});
		
		this.optionsBreadCrumb = new com.ibm.security.modeling.projects.BreadCrumb(
				{
					label:this.localResources.COPY_OPTIONS,
					title:this.localResources.COPY_OPTIONS
				});
		this.breadCrumBuilder = new com.ibm.security.modeling.breadcrumbs.BreadcrumbBuilder()
			.withId(this.id + "_BreadCrumbPlaceHolder")
			.withBreadcrumb(this.overViewBreadCrumb)
			.withBreadcrumb(this.shoppingCartBreadCrumb)
			.withBreadcrumb(this.optionsBreadCrumb);

		this.breadCrumbBar= this.breadCrumBuilder.build().getBreadCrumbBar();
		this.breadCrumbBar.startup();
		
		dojo.addClass(this.breadCrumbBar.containerNode,"wizardBreadcrumb");
	},
	_createAttributeScopingPanel : function() {
		// summary:
		// 			Creates the role attribute shopping card panel
 	    this._trace.entering("", "_createAttributeScopingPanel");
		this._roleScopingPanel = new com.ibm.security.modeling.hierarchy.RoleScopingPanel( {
			id : this.id + "_attribScopingContainer",
			hostname:this.hostname,
			port:this.port,
			ENTITYTYPE: "ROLE",
			messageArea:this.messageArea,
			globalResources:this.globalResources
		}, this.id + "_attribScopingContainer");
		 
		dojo.addClass(this._roleScopingPanel.domNode,"contentArea");
		this._trace.exiting("", "_createAttributeScopingPanel");
   },
   _createRoleCopyOptionPanel:function(){
		// summary:
		// 			Creates the role copy option panel
 	    this._trace.entering("", "_createRoleCopyOptionPanel");
		this._roleCopyOptionPanel = new com.ibm.security.modeling.hierarchy.RoleCopyOptionPanel( {
			id : this.id + "_attribOptions",
			hostname:this.hostname,
			port:this.port,
			messageArea:this.messageArea,
			globalResources:this.globalResources,
			localResources:this.localResources
		}, this.id + "_attribOptions");
		 
		dojo.addClass(this._roleCopyOptionPanel.domNode,"contentArea");
		this._trace.exiting("", "_createRoleCopyOptionPanel");
	},
	_showMessage: function(/*String*/type, /*String*/message) {
		// summary:
		//			shows the given message and type in the local message area
		// tags:
		//			private
		
		//this._hideMessages();
		
		if (type === "critical") {
			this.messageArea.showErrorMessage(message);
		}else if (type === "info") {
			this.messageArea.showInfoMessage(message);
		}else if (type === "warning") {
			this.messageArea.showWarningMessage(message);
		}

	},
	_hideMessages:function() {
		// summary:
		//			hide the given message and type in the local message area
		// tags:
		//			private
		
		this.messageArea.hideMessages();
	}
			
});
