/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

© Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.hierarchy.RoleCopyOptionPanel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("com.ibm.security.modeling.dijit.layout.ContentPane");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.form.RadioButton");


dojo.require("com.ibm.security.modeling.util.Trace");


dojo.declare("com.ibm.security.modeling.hierarchy.RoleCopyOptionPanel",[ dijit._Widget, dijit._Templated ],{
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.hierarchy.RoleCopyOptionPanel"),
	templatePath : dojo.moduleUrl("com.ibm.security.modeling.hierarchy", "templates/RoleCopyOptionPanel.html"),
	widgetsInTemplate : true,
	constructor : function() {
		// tags:
		//		protected
		this.inherited(arguments);
	},
	postCreate : function() {
		// tags:
		//		protected
		this.inherited(arguments);
	},
	startup : function() {
		// tags:
		//		protected
	    this.inherited(arguments);

	 },
	 initPanel:function(){
		this.modelingUsage.set("checked",true);
		this.memberOption.set("checked",true);
		this.permOption.set("checked",true);
		this.sodOption.set("checked",true);

	 },
	 getCopyOptions:function(){
		var roleCopyOptions={};
		roleCopyOptions.roleCopyFor=this._getUsageOption();
		roleCopyOptions.roleCopyInclude=this._getInclusionOption();
		return roleCopyOptions
	 },
	 _getUsageOption:function(){
		var roleCopyFor="";
		if(this.modelingUsage.get("checked") == true){
			roleCopyFor=this.modelingUsage.get("value");
		}else{
			roleCopyFor=this.newRoleUsage.get("value");
		}
		return roleCopyFor;
	 },
	 _getInclusionOption:function(){
		var includeOption=[];
		if(this.memberOption.get("checked") ==  true){
			includeOption.push(this.memberOption.get("value"));
		}
		if(this.permOption.get("checked") ==  true){
			includeOption.push(this.permOption.get("value"));
		}
		if(this.sodOption.get("checked") ==  true){
			includeOption.push(this.sodOption.get("value"));
		}
		return includeOption;
	 },
	 destroy:function(){
		this.inherited(arguments);
	 }
		
});
