/* 
Licensed Materials - Property of IBM

5724-Z11??
Copyright IBM Corp. 2009 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.hierarchy.RoleHierarchyPanel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("ibm.tivoli.navmodel.Exception");

dojo.require("com.ibm.security.modeling.help.HelpLink");
dojo.require("com.ibm.security.modeling.projects.ProjectsRestStore");
dojo.require("com.ibm.security.modeling.hierarchy.SummaryContentPane");
dojo.require("com.ibm.security.modeling.hierarchy.UndoHandler");
dojo.require("com.ibm.security.modeling.topology.TopologyDataSets");
dojo.require("com.ibm.security.modeling.layouts.TemplatedPanelWithLayout");

dojo.require("com.ibm.security.modeling.util.NlsUtilities");
dojo.require("com.ibm.security.modeling.util.ErrorUtilities");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.require("com.ibm.security.modeling.widgets.CoverageContainer");

dojo.require("com.ibm.security.modeling.api.RoleRestManager");
dojo.require("com.ibm.security.modeling.api.ProjectRestManager");
dojo.require("com.ibm.security.modeling.projects.ProjectUtil");

dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("dijit.layout.StackController");
dojo.require("com.ibm.security.modeling.dijit.layout.StackContainer");
dojo.require("com.ibm.security.modeling.dijit.layout.ContentPane");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dijit.Dialog");
dojo.require("dojox.collections.ArrayList");
dojo.require("com.ibm.security.modeling.widgets.ProgressBar");
dojo.require("com.ibm.security.modeling.util.CommonUtilities");
dojo.require("com.ibm.security.modeling.lifecycle.LifecycleMenuHelper");
dojo.require("com.ibm.security.modeling.util.TransformerUtility");

dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling.hierarchy", "RoleHierarchyText");
dojo.requireLocalization("com.ibm.security.modeling", "LogMessages");
dojo.requireLocalization("com.ibm.security.modeling", "PluginMessages");

dojo["requireLocalization"]("customizations", "LifecycleText");

dojo.declare("com.ibm.security.modeling.hierarchy.RoleHierarchyPanel",
            [ com.ibm.security.modeling.layouts.TemplatedPanelWithLayout ],
{
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.hierarchy.RoleHierarchyPanel"),
	templatePath: dojo.moduleUrl("com.ibm.security.modeling.hierarchy","templates/RoleHierarchyPanel.html"),	
	widgetsInTemplate: true,
	// globalResources: Object
	//			Reference to the global shared resource bundle
	globalResources: null,
	// localResources: Object
	//			Reference to the resource bundle unique to this widget
	localResources: null,
	// logMessages: Object
	//			Reference to the TMS Log messages resource bundle
	logMessages: null,
	// namespace: String
	//		The identifier for the current portlet
	namespace: "",
	// dataSetFactory: com.ibm.security.modeling.topology.TopologyDataSets
	//		Factory for creating datasets
	dataSetFactory: new com.ibm.security.modeling.topology.TopologyDataSets(),
	// messageArea: ibm.tivoli.tip.dijit.TIPMessageArea
	//		Message area for error display
	messageArea: null,
	// hostname: String
	//		Hostname for server requests
	hostname: "",
	// port: String
	//		Port for server requests
	port: "16311",
	// contextRoot: String
	//			The context root of the server from which Content is being served.
	contextRoot: "",
	// navWidget: ibm.tivoli.tip.navwidget.topology.dijit.TopologyView
	//		Reference to the topology
	navWidget: null,
	// tableWidget: com.ibm.security.modeling.tables.Table
	//		Reference to the table
	tableWidget:null,
	// _parent: com.ibm.security.modeling.hierarchy.RoleHierarchyView
	//		Reference to parent container
	_parent:null,
	// roleRestStore: com.ibm.security.modeling.tables.JsonRestStore
	//		Reference to Common Table store
	roleRestStore:null,
	// roleRestManager: com.ibm.security.modeling.api.RoleRestManager
	//		An instance of com.ibm.security.modeling.api.RoleRestManager. 
	//		It is an interface for HTTP REST communication using dojo stores api. 
	roleRestManager: null,
	// rolesUri: string
	//		String containing 'roles' resources uri which contains Role resource with roleId.
	rolesUri: null,
	// _projectId: String
	//		Reference to current project Id
	_projectId:null,
	// projectUrl: String
	//		Reference to current project URL
	projectUrl:null,
	// _projectItem: Object
	// Reference to the project rest store
	_projectItem:null,
	// _modelId: String
	//		Reference to current model Id
	_modelId:null,
	// dataset: com.ibm.security.modeling.topology.TopologyDataSets
	//		Reference to the dataset of topology view
	dataset:null,
	// closePageUrl: String
	//			The url tp call the process action of the portlet.
	closePageUrl:"",
	// _updateOtherView: boolean
	//			Check whether table or topology needs to be reloaded.
	_updateOtherView:false,
	//roleLifecycleProvider: com.ibm.security.modeling.lifecycle.LifecycleProvider 
	//			REference to the lifecycle Provider
	roleLifecycleProvider : null,
	//lifecycleMenuHelper: com.ibm.security.modeling.lifecycle.LifecycleMenuHelper 
	//			REference to the lifecycle menu helper
	lifecycleMenuHelper : null,
	//transformerUtility: com.ibm.security.modeling.util.TransformerUtility 
	//			Reference to the Transformer Utility
	transformerUtility : null,
	
	lifecycleRoleStausKeyPrefix : "LIFECYCLE_ROLE_STATUS_",
	
	TOPOLOGY_DEFAULT_ZOOM_LEVEL: 1,
	// _undoHandler: com.ibm.security.modeling.hierarchy.UndoHandler
	//			Reference to the handler for undo processing.
	_undoHandler: null,
	calledFrom: {
		NONE: 0,
		TOPOLOGY: 1,
		TABLE: 2
	},
	// Stores event connections for summary update
	summaryUpdateConnections:[],
	
	constructor: function (args) {

		// _updateCalledFromTopoOrTable: number
		//			track whether table or topology initiated the call.0-none,1-topology,2-table
		this._trace.entering(this.namespace, "constructor");
		this.projectUrl = args.projectUrl;
		this._updateCalledFromTopoOrTable = this.calledFrom.NONE;
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
		this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.hierarchy", "RoleHierarchyText");
		this.logMessages = dojo.i18n.getLocalization("com.ibm.security.modeling", "LogMessages");
		this.pluginMessages = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
		
		if (!this.customText) {
				this.customText = dojo.i18n.getLocalization("customizations", "LifecycleText");
		}
		this.progressBar = new com.ibm.security.modeling.widgets.ProgressBar();
		
		this._errorUtil = new com.ibm.security.modeling.util.ErrorUtilities();
		this._trace.exiting(this.namespace, "constructor");
    	},
	
	postCreate: function() {
		this._trace.entering(this.namespace, "postCreate");
		this.inherited(arguments);
		this._addCssClassesToWidgetTopNode();
		this._overrideContainerLtrFunction();
		this.summaryContainerNode.setMsgAreaFromParent(this.messageArea);
		this._undoHandler = new com.ibm.security.modeling.hierarchy.UndoHandler({
			roleHierarchyPanel: this,
			messageArea: this.messageArea});
		
		
		this.isBPMEnabled=this.roleLifecycleProvider.isBPMEnabled();
		if(this.isBPMEnabled){
			this.lifecycleMenuHelper = new com.ibm.security.modeling.lifecycle.LifecycleMenuHelper({
				globalResources : this.globalResources,
				requestTypes : this.roleLifecycleProvider.getRequestTypes()
			});
			
			// To create single object of TransformerUtility
			if( ! this.transformerUtility){
				this.transformerUtility = new com.ibm.security.modeling.util.TransformerUtility();
			}
		}
		
		// Subscribe to role edit changes
		dojo.subscribe("ROLE_EDIT_EVENT", dojo.hitch(this, function() { this.roleEditComplete(); }));
		
		dojo.subscribe("PROJECT_EDIT_SCOPE_UPDATE_EVENT", dojo.hitch(this, this.projectScopeEditComplete));
		
		dojo.subscribe("UPDATE_VIEW_FOR_SUBMIT_REQUEST", dojo.hitch(this, this.updateViewForSubmitRequest));
		
		this._trace.exiting(this.namespace, "postCreate");
	},
	
	getRoleLifecycleProvider : function(){
		return this.roleLifecycleProvider;
	},
	
	_addCssClassesToWidgetTopNode: function() {
		dojo.addClass(this.domNode,"contentArea");		
	},
	_overrideContainerLtrFunction: function() {
		this.container.isLeftToRight = NlsUtilities.isLtr;
	},
	
	startup:function(){
		this._trace.entering(this.namespace, "startup");
		this.inherited(arguments);
		this.summaryContainerNode.hostname = this.hostname;
		this.summaryContainerNode.port = this.port;
		this._trace.entering(this.namespace, "startup");	
	},
	destroy: function()
	{
		this.inherited(arguments);
		dojo.forEach(this.summaryUpdateConnections, dojo.disconnect);
		
		// UnSubscribe to role edit changes
		dojo.unsubscribe("ROLE_EDIT_EVENT");
		
		// UnSubscribe to project edit scope changes
		dojo.unsubscribe("PROJECT_EDIT_SCOPE_UPDATE_EVENT");
	},
	
	closePanel: function(){
		this._parent.launchProjectTablePanel(false);
	},
	showWorkingDialog:function(msg){
		this.progressBar.show(msg);
	},
	hideWorkingDialog:function(){
		this.progressBar.hide();
	},
	_errorHandler:function(e,ioargs){
		this._trace.entering("", "_errorHandler");
		try{
				this.hideWorkingDialog();
			}catch(err){
				this._trace.error("problems with hide");
			}
		this._errorUtil.handleRESTError(e, this.messageArea);
		this._trace.exiting("", "_errorHandler");
		
	},
	_showMessage: function(/*String*/type, /*String*/message) {
		// summary:
		//			shows the given message and type in the local message area
		// tags:
		//			private
		this._trace.entering("", "_showMessage");
		if (type === "critical") {
			this.messageArea.showErrorMessage(message);
		}else if (type === "info") {
			this.messageArea.showInfoMessage(message);
		}
		this._trace.exiting("", "_showMessage");
	},

	loadInitialData:function(projectUrl,modelId){
		// summary:
		//			Does the initial load of the role data for the panel (needs a method rename)
		this._trace.entering("", "loadInitialData");
		this.projectUrl = projectUrl;
		if (this._updateCalledFromTopoOrTable == this.calledFrom.TOPOLOGY || this._updateCalledFromTopoOrTable == this.calledFrom.NONE) {
			this.switchToTableView(modelId);//loading table view first
		}
		this._showTableView(modelId);//always showing table in this method 
		this._updateOtherView=true;
		this._trace.exiting("", "loadInitialData");
	},
	
	
	
	switchToTableView:function(modelId){
		this._trace.entering("", "switchToTableView");
		this._updateCalledFromTopoOrTable = this.calledFrom.TABLE;
		//this._trace.object(this._listPage, "_switchToTableView", "Selecting page in stack");
		this.hierarchyContainer.selectChild(this._listPage);//pick the table part of the stack container
		this._showTableView(modelId);
		this._unsubscribeTopologyEvents();

		//this.resize();
		this._trace.exiting("", "switchToTableView");
	},
	_roleCountAllowed: 1000,
	_switchToTopoView:function(){
		this.messageArea.hideMessages();
		if(this._validateTopologyCountLimit()){
			this._updateCalledFromTopoOrTable = this.calledFrom.TOPOLOGY;
			this.hierarchyContainer.selectChild(this._hierarchyPage);
			if(this._updateOtherView){
				this._updateOtherView=false;
				//this._reloadTopologyData(this._modelId);
				this._refreshTopology(this._modelId);
				this._subscribeToTopologyEvents();
			}
			this.resize();
		}
	},
	
	_validateTopologyCountLimit:function(){
		var targeturl = '/isrm/rest/models/'+this._modelId+'/roles/?countOnly=true';
		var projUtil = new com.ibm.security.modeling.projects.ProjectUtil();
		var roleCount = projUtil.getCountOnlyInfo(targeturl);
		var isValid=true;
		
		if(projUtil.getCountOnlyErrorMessage() === null){
			if(roleCount > this._roleCountAllowed){
				this.messageArea.showInfoMessage(this.logMessages.COUNT_EXCEEDED_FOR_TOPOLOGY);	
				return false;
			}
		}else{
			this._showMessage("critical", projUtil.getCountOnlyErrorMessage());
		}
		return isValid;
	
	},
	_subscribeToTopologyEvents: function(){
		this._trace.entering("", "_subscribeToTopologyEvents");
		dojo.subscribe("REFRESHTOPOLOGY", dojo.hitch(this, this._onClickRefresh));
		this._trace.exiting("", "_subscribeToTopologyEvents");
	},
	
	_unsubscribeTopologyEvents: function(){
		this._trace.entering("", "_unsubscribeTopologyEvents");
		dojo.unsubscribe("REFRESHTOPOLOGY");
		this._trace.exiting("", "_unsubscribeTopologyEvents");
	},
	
	/*============================Topology methods ===========*/
	
	_loadTopology: function(item,projectUrl,modelId) {
		try {
			this._trace.entering("", "_loadTopology");
			this._modelId = this._determineModelId(item, modelId);
			dojo.require("com.ibm.security.modeling.topology.TopologyBuilder");
			dojo.require("com.ibm.security.modeling.topology.RoleModelingTopologyFactory");
			dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper");
			this.navWidget = new com.ibm.security.modeling.topology.TopologyBuilder(
					new com.ibm.security.modeling.topology.RoleModelingTopologyFactory())
				.withId(this.namespace + "navigatorWidgetContainer")
				.withDataSet(this._modelId)
				.onDiv(this.namespace + "navigatorWidgetContainer")
				.onPageWidget(this)
				.build();
				
			//Since Topology does not support localization of button labels, we want to update the localized lables.
			this.connect(this.navWidget,"_createToolbar", dojo.hitch(this, this._updateTopologyButtonLabels) );
			
			this.connect(this.navWidget.selection,"onSelectionChanged", dojo.hitch(this, this._setButtons) );
			
			//Setting zoom when loading is complete. But this is not working. Need to check another way.
			this.connect(this.navWidget._canvas, "_onSetDatasetLoadComplete", dojo.hitch(this, this._onSetDatasetLoadComplete));
			
			this._undoHandler.setTopology(this.navWidget, this._modelId);
			this.navWidget.mySetDatasetListener = dojo.connect(this.navWidget, "onSetDataset", this, function(dataset){
               	 dijit.byId("roleTopology").getTooltip().getCustomContentCallback = dojo.hitch(this,this.displayRoleDetails);
               	 dojo.hitch(this,this._transformerDataset,dataset)();
            	});
			this.navWidget.startup();
			//this.navWidget.setZoomLevel(10);
			this.resize();
			if (this.messageArea.isShowing) {
				this.messageArea.hide();
			}
			this._trace.exiting("", "_loadTopology");
		} catch (e) {
			if (e instanceof ibm.tivoli.navmodel.Exception) {
				this._trace.error("An internal error occured loading data from the system: " + e.getMsgText(), "_loadTopology");
				this._showMessage("critical", e.getMsgText());
			} else {
				this._errorHandler(e);
				this._trace.exception(e, "_loadTopology");
			}
		}
	},
	_transformerDataset : function(dataset){
		if(this.isBPMEnabled && this.transformerUtility){
			var fetchItems = dataset._fetchItems;
			dataset._fetchItems = dojo.hitch(this,
					function(/*fetchItems_kwArgs*/ kwArgs){
						var onComplete = kwArgs.onComplete;
						kwArgs.onComplete = dojo.hitch(this,
								function(items, kwArgs){
									items = this.transformerUtility.topologyItemsTransformer(this.customText,items);
									onComplete(items, kwArgs);
								});
						dojo.hitch(dataset,fetchItems,kwArgs)();
					});	
		}
	},
	_onSetDatasetLoadComplete: function(){
		//this._roleToFocus = "1304667912797574397";
		setTimeout(dojo.hitch(this,this._setZoomAfterSomeTime),200);
	},
	
	_setZoomAfterSomeTime: function(){
		if(this._roleToFocus){
			this._setTopologyZoomTo(this._roleToFocus);
		}else{
			// Want to get the first node on the Topology. Hence all this stuff.
			// If something better can be done, it would be good.
			
			var level = [];
			var toplevel = [];
			var item;
			for(item in this.navWidget.dataset._linksById){
				var itema = this.navWidget.dataset._linksById[item].getItem1().getId();
				var itemb = this.navWidget.dataset._linksById[item].getItem2().getId();
				if(!level[itema]){
					level[itema] = 0;
					toplevel.push(itema);
				}
				
				if(!level[itemb]){
					level[itemb] = 1;
				}else{
					if(level[itemb] == 0){
						//remove from toplevel.
						var i;
						for(i=0; i<toplevel.length; i++){
							if(toplevel[i] == itemb){
								toplevel.splice(i,1);
								break;
							}
						}
					}
					level[itemb] = 1;
				}
				
			}
			// Now we got toplevel items from lined items
			var itemtofocus = null;
			var item1;
			for(item1 in this.navWidget.dataset._itemsById){
				itemid = this.navWidget.dataset._itemsById[item1].getId();
				if(!itemtofocus){
					if( (!level[itemid]) || level[itemid] == 0){
						itemtofocus = itemid;
					}
				}else{				
					// The label comparision is plain javascript comparision.
					// Ideally It should be locale specific comparision.
					if(this.navWidget.dataset._itemsById[itemid]._item.label < this.navWidget.dataset._itemsById[itemtofocus]._item.label){
						if( (!level[itemid]) || level[itemid] == 0){
							itemtofocus = itemid;
						}
					}
				}
			}
			
			// Now we got the itemtofocus.
			
			if(itemtofocus){
				this._setTopologyZoomTo(itemtofocus);
			}
		}
	},
	
	_setTopologyZoomTo: function(roleId){
		this._trace.entering("", "_setTopologyZoomTo");
		if(roleId){
			this.navWidget.setZoomTo([roleId], null, null, this.TOPOLOGY_DEFAULT_ZOOM_LEVEL);
			this._roleToFocus = null;
		}
		this._trace.exiting("", "_setTopologyZoomTo");
	},
		
	_getIdFromUri: function(itemUri){
		if(itemUri){
			//Need better way to get roleId. Currently assuming the uri ending with /<roleid>
			var arr = itemUri.split("/", 100);
			return(arr[arr.length-1]);
		}else{
			return null;
		}
	},

	_onClickRefresh: function(uri, nodeId){
		this._trace.entering("", "_onClickRefresh");

		var selectedItemIds=this.navWidget._canvas.selection.getItemIds();
		var roleId = null;
		if( (!this._roleToFocus) ) {
			if(selectedItemIds && selectedItemIds.length>=1){
				roleId = selectedItemIds[0];
			}else{
				//roleId = <set the roleId of root role.
			}
		}
		this._refreshTopology(this._modelId, roleId);

		this._trace.exiting("", "_onClickRefresh");
	},

	_refreshTopology:function(modelId, nodeId){
		this._trace.entering("", "_refreshTopology");

		// Zoom need to happen only after topology gets refreshed. Need an event which 
		// will tell topology is loaded so that we can focus on the right node.
		// For now, temporarily am zooming to the appropriate node after 200ms.

		if(nodeId){
			this._roleToFocus = nodeId;
		}else{
			//Get the first node to focus on. For now just refresh.
			this._roleToFocus = null;
		}
		this._reloadTopologyData(this._modelId);

		this._trace.exiting("", "_refreshTopology");
	},
	
	/*
	* Enable/Disable the buttons on Topology Toolbar appropriately.
	* We catch hold of the references to these buttons in _updateTopologyButtonLabels().
	*/
	_setButtons: function(){
		this._trace.entering("", "_setButtons");
		
		var selectedItemIds=this.navWidget._canvas.selection.getItemIds();
        if(selectedItemIds && selectedItemIds.length == 0){
            this._deleteRoleButton.set("disabled", true);
			dojo.addClass(this._deleteRoleButton.domNode, "inactiveImage");
			this._editRoleButton.set("disabled", true);
			dojo.addClass(this._editRoleButton.domNode, "inactiveImage");
			this._copyRoleButton.set("disabled", true);
			dojo.addClass(this._copyRoleButton.domNode, "inactiveImage");
			if(this.submitMenu){
				this.submitMenu.set("disabled", true);
				dojo.addClass(this.submitMenu.domNode, "inactiveImage");
			}
        }
		else if(selectedItemIds && selectedItemIds.length == 1){
			//Enable the topology buttons.
			this._editRoleButton.set("disabled", false);
			dojo.removeClass(this._editRoleButton.domNode, "inactiveImage");
			this._deleteRoleButton.set("disabled", false);
			dojo.removeClass(this._deleteRoleButton.domNode, "inactiveImage");
			this._copyRoleButton.set("disabled", false);
			dojo.removeClass(this._copyRoleButton.domNode, "inactiveImage");
			if(this.submitMenu){
				this.submitMenu.set("disabled", false);
				dojo.removeClass(this.submitMenu.domNode, "inactiveImage");	
			}
			this._selectedRole = selectedItemIds[0];
		}else{
			//Disable the topology buttons
			this._editRoleButton.set("disabled", true);
			dojo.addClass(this._editRoleButton.domNode, "inactiveImage");
			//this._deleteRoleButton.set("disabled", true);
			//dojo.addClass(this._deleteRoleButton.domNode, "inactiveImage");
			this._copyRoleButton.set("disabled", true);
			dojo.addClass(this._copyRoleButton.domNode, "inactiveImage");
			this._selectedRole = null;
		}
		
		this._trace.exiting("", "_setButtons");
	},
	_setTopologySubmitRequest:function(topologyActionMenu){
		// summary:
		//     To add submit request menu in action menu.
		// topologyActionMenu: Action menu object
		//     Object contains object reference of dropdown Action menu 
		
		//Get menu item from lifecycle helper, 
		//with passing launcher function reference as parameter
		if(this.lifecycleMenuHelper){
			this.submitMenu = this.lifecycleMenuHelper.getMenuItem(
					dojo.hitch(this, this._launchLifecycleSubmitRequest));
			
			topologyActionMenu.addChild(this.submitMenu);
		}
		
	},
	
	_launchLifecycleSubmitRequest: function(requestType){
		// summary:
		//     To get selected role items from topology and will pass as argument 
		// to the actual lifecycle submit request launcher
		// requestType: RequestType object
		//     Object contains object reference of requestType 
		
		//To get the list of selected role items from topology
		var selectedItems=this.navWidget._canvas.selection.getItems();
		
		this._updateCalledFromTopoOrTable = this.calledFrom.TOPOLOGY;
		
		this.launchLifecycleSubmitRequest(selectedItems,requestType);		
	},
	/*
	* Since Topology does not support localization of button labels, we want to update the localized lables.
	*/
	_updateTopologyButtonLabels: function(){
		this._trace.entering("", "_updateTopologyButtonLabels");
		var items = this.navWidget._toolbar.getToolbar().getChildren();
		var i;
		for(i=0;i<items.length;i++){
			var item = items[i];
			if(item.declaredClass === "dijit.form.Button"){
				if(item.label.indexOf("RAPM_LABEL") === 0){
					if(item.label === "RAPM_LABEL_EDIT_ROLE"){
						this._editRoleButton = item;
					}else if(item.label === "RAPM_LABEL_DELETE_ROLE"){
						this._deleteRoleButton = item;
					} if(item.label === "RAPM_LABEL_COPY_ROLE"){
						this._copyRoleButton = item;
					}
					item.set("label", this._getLocalizedLabel(item.label));
					
				}else if(item.id.indexOf(ibm.tivoli.tip.navwidget.topology.dijit.TopologyToolbar.itemTypes.ZOOM_IN_BUTTON) != -1){
					this._zoomInButton = item;
				}
			}else if(item.declaredClass === "dijit.form.DropDownButton"){
				if(item.label.indexOf("RAPM_LABEL") == 0){
					item.set("label", this._getLocalizedLabel(item.label));
					item.set("title", this._getLocalizedLabel(item.label));
					//TODO Need to set localized labels for options of this dropdown.
					var menuItems = item.dropDown.getChildren();
					for(i=0;i<menuItems.length;i++){
						var menuItem = menuItems[i];
						menuItem.set("label", this._getLocalizedLabel(menuItem.label));
					}
					// Pass the refernec of Action menu dropdown object
					//to add dynamic submit request menu.  
					this._setTopologySubmitRequest(item.dropDown);
				}
			}
		}
		this._setButtons();
		//this._updateZoomIn();
		this._trace.exiting("", "_updateTopologyButtonLabels");
	},
	
	_getLocalizedLabel: function(key){
		this._trace.entering("", "_getLocalizedLabel");
		var label = key;
		switch(key){
			case "RAPM_LABEL_CREATE_ROLE":
				label = this.localResources.CREATE_ROLE;
				break;
			case "RAPM_LABEL_EDIT_ROLE":
				label = this.localResources.EDIT_ROLE;
				break;
			case "RAPM_LABEL_COPY_ROLE":
				label = this.localResources.COPY_ROLE;
				break;
			case "RAPM_LABEL_DELETE_ROLE":
				label = this.localResources.DELETE_ROLE;
				break;
			case "RAPM_LABEL_UNDO":
				label = this.localResources.UNDO;
				break;
			case "RAPM_LABEL_TABLE_VIEW":
				label = this.localResources.TABLE_VIEW;
				break;
			case "RAPM_LABEL_REFRESH":
				label = this.globalResources.REFRESH;
				break;
			case "RAPM_LABEL_ACTIONS":
				label = this.localResources.ACTIONS;
				break;
			case "RAPM_LABEL_EXPORT_PROJECT":
				label = this.localResources.EXPORT_PROJECT;
				break;
			case "RAPM_LABEL_COPY_ROLES_PROJECT":
				label = this.localResources.COPY_ROLES_PROJECT;
				break;
			case "RAPM_LABEL_GENERATE_ROLES":
				label = this.localResources.GENERATE_ROLES;
				break;

		}
		this._trace.exiting("", "_getLocalizedLabel");
		return label;
	},
	
	displayRoleDetails:function(target){
	
	    var listTemplate = dojo.cache("com.ibm.security.modeling.hierarchy","templates/RoleDetailsTemplate.html", {sanitize:true});
		if(!this.isBPMEnabled){
			listTemplate=listTemplate.replace("<li><label>${lifeCycleStatus_label}</label> : <label>${lifeCycleStatus_Value}</label></li>","");
		}
	    var _stringUtils = new com.ibm.security.modeling.util.StringUtils();
		var nameString = "NAME";
		var descriptionString = "DESCRIPTION";
		var noUsersString = "NUMBER_OF_USERS";
		var noPermissionsString = "NUMBER_OF_PERMISSIONS";
		var noInheritedPermssionsString = "INHERITED_PERMISSIONS";
		var noInheritedUsersString = "INHERITED_USERS";
		var lifcycleStatus = "LIFECYCLE_STATUS";

	           var topology = dijit.byId("roleTopology");		
           // Find out what the mouse cursor is over
        var realTarget = topology.getRolloverTarget();
        if (realTarget) {
		    var items = realTarget.getTooltip();
			var kwArgs = {sync:true};
			realTarget.getProperties(kwArgs);
			
			if(realTarget._propsById){				
				var Role_Name = null;
				var Role_Value = null;
				var Role_Desc = null;
				var Role_Desc_Value = null;
				var Users =null;
				var User_Value=null;
				var Number_of_Users = null;	
				var User_label = null;
				var Permissions =null;
				var Permissions_Value=null;
				var Number_of_Permissions=null;
				var Permissions_label=null;
				var lifeCycleStatus_Value=null;
				var lifeCycleStatus_label=null;
				for(prop in realTarget._propsById){
					
					var obj = realTarget._propsById[prop];					
					
					if(prop === nameString){					
						Role_Name = obj.getLabel();
						Role_Value = _stringUtils.breakString(com.ibm.security.modeling.util.HtmlEscapingUtils.parseHTMLTag(obj.getDisplayValue()));
					}	
					if(prop === descriptionString){	
						Role_Desc = obj.getLabel()
						Role_Desc_Value = _stringUtils.breakString(com.ibm.security.modeling.util.HtmlEscapingUtils.parseHTMLTag(obj.getDisplayValue()));
					}
					if(prop === noUsersString)	{
					   var inheritedUser = realTarget._propsById[noInheritedUsersString];
					   Users =obj.getLabel();
					   User_Value = obj.getDisplayValue();
					   Number_of_Users = inheritedUser.getDisplayValue();
					   User_label =inheritedUser.getLabel();
					   
					}					
					if(prop === noPermissionsString){
					   var inheritedPerm = realTarget._propsById[noInheritedPermssionsString];
					   Permissions =obj.getLabel();
					   Permissions_Value =obj.getDisplayValue();
					   Number_of_Permissions=inheritedPerm.getDisplayValue();
					   Permissions_label = inheritedPerm.getLabel();					   
					}
					
					if( this.isBPMEnabled && prop === lifcycleStatus){
					   lifeCycleStatus_label =obj.getLabel();
					   lifeCycleStatus_Value = this._getLifecycleStatusPerLocale(this.lifecycleRoleStausKeyPrefix, obj.getDisplayValue());
					   lifeCycleStatus_Value = com.ibm.security.modeling.util.HtmlEscapingUtils.parseHTMLTag(lifeCycleStatus_Value);
					}
					
				}
			   var descSpan = dojo.doc.createElement("span");
			  
               // If we are over a node, get the node type label and set it in the span
               if (realTarget.getObjectType() == "item") {
			     				   
					var message = dojo.string.substitute(listTemplate, {
					 Role_Name:Role_Name,
					 Role_Value:Role_Value,
					 Role_Desc:Role_Desc,
					 Role_Desc_Value: Role_Desc_Value,
					 lifeCycleStatus_label:lifeCycleStatus_label,
					 lifeCycleStatus_Value:lifeCycleStatus_Value,
					 Users: Users,
					 User_Value:User_Value,
					 Number_of_Users :Number_of_Users,	
					 User_label: User_label,
					 Permissions: Permissions,
					 Permissions_Value: Permissions_Value,
					 Number_of_Permissions: Number_of_Permissions,
					 Permissions_label: Permissions_label			
					});						
				   
                   descSpan.innerHTML = message; 
				}
                 else {
                  descSpan.innerHTML = "";
               }
               dojo.addClass(descSpan, "topotooltip");
               
               var holder = dojo.doc.createElement('div');
			   dojo.place(descSpan, holder, "only");
               return holder;			
			
			}
			
		}	   
	},
	_getLifecycleStatusPerLocale: function(/*prefix key*/ keyPrefix,/*status enum key*/ key) {
		var text = null;
		if (keyPrefix && key) {
			text = this.customText[keyPrefix+key.toUpperCase()];
		}
		return text ? text : key;
	},
	_determineModelId:function(item, modelId) {
		if(item){
			var models = this.projectList.store.getValue(item, "models");
			this._trace.object(models, "_loadTopology", "Model for the current project");
			return models[0].id;
		}else{
			return modelId;
		}		
	}, 
	_reloadTopologyData:function(modelId){
		this._trace.entering("", "_reloadTopologyData");
		try {
			if(this.navWidget && this._modelId==modelId){
				if(this._validateTopologyCountLimit()){
					var dataset = this.navWidget.dataset;
					dataset._deleteDataset();
					dataset= this.dataSetFactory.createRoleDataSet(this._modelId, false);
					setTimeout(dojo.hitch(this, function(){
						this.navWidget.setDataset(dataset);
					}), 100);
				}else{
					this._updateOtherView=true;
					this.switchToTableView(this._modelId);
				}
			}else{
				this._modelId=modelId;
				this._loadTopology(null,null,this._modelId);
			}
			this._undoHandler.refresh();
			
			// Update summary information
			this._refreshSummaryInfo(this.projectUrl);
		} catch (e) {
			if (e instanceof ibm.tivoli.navmodel.Exception) {
				this._trace.error("An internal error occured loading data from the system: " + e.getMsgText(), "_loadTopologyData");
				this._showMessage("critical", e.getMsgText());
			}else{
				this._errorHandler(e);
				this._trace.exception(e, "_reloadTopologyData");
			}
		}
		this._trace.exiting("", "_reloadTopologyData");
	},
	
	
	/*================================Table methods =================*/
	
	_showTableView:function(modelId){
		this._trace.entering(modelId, "_showTableView");
		if(!this.tableWidget){
			this._trace.finest("no table exists, creating", "_showTableView");
			this._createTable(modelId);
		}else if(this._updateOtherView || (modelId && this._modelId!=modelId)){
			this._trace.finest("reloading table", "_showTableView");
			if(modelId && this._modelId!=modelId){
				this._trace.finest("new modelid: " + modelId, "_showTableView");
				this._reloadTable(null,null,modelId);
			}else{
				this._trace.finest("same or no modelid, using: " + this._modelId, "_showTableView");
				this._reloadTable(null,null,this._modelId);
				this._updateOtherView=false;
			}
		} else {
			this._trace.finest("no table creation or reload needed", "_showTableView");
		}
		this._trace.exiting("", "_showTableView");
		
	},
	_reloadTable:function(item,projectUrl,modelId){
		this._trace.entering("", "_reloadTable");
		if(this.tableWidget && this._modelId==modelId){//case where u need to do a refresh
			this._trace.finest("same model id: " + modelId, "_reloadTable");
			this.tableWidget.refresh();
			this._undoHandler.refresh();
		}else{ //Still need to recreate the table as model Id has changed
			this._trace.finest("no table exists or new model id.  recreating table", "_reloadTable");
			this._modelId=modelId;
			this._updateOtherView=true;
			if (this.tableWidget){//destory table and recreate
				this._destroyTable();
			}
			this._createTable(this._modelId);
		}
		
		// Update summary information
		this._refreshSummaryInfo(this.projectUrl);
		this._trace.exiting("", "_reloadTable");
	},
	_destroyTable:function(){
		this.tableWidget.destroy();
		this.roleRestStore=null;
		if(this.hierarchyContainer){
			//creating a div so that table can be recreated at same div location
			this._listPage.attr("content", "");
			 var newdiv = document.createElement('div');
			  newdiv.setAttribute('id',this.namespace+"tableWidgetContainer");
			  newdiv.setAttribute('class',"hierarchySelectionArea");
			  this._listPage.domNode.appendChild(newdiv);
			  
		}else{
			this._trace.error("An internal error occured while destroying table - container no longer exists");
		}
	},
	_setupRestStore: function () {
		this._trace.entering("", "_setupRestStore");
		this.roleRestManager = new com.ibm.security.modeling.api.RoleRestManager({
			resourceUri: this.rolesUri,
			syncMode: false,
			_identifier:"storeId",
			messageArea: this.messageArea
		});
		
		this._trace.exiting("", "_setupRestStore");
	},
	_createTable:function(modelId){
		this._trace.entering("modelId: " + modelId, "_createTable");
		try {
			this._modelId=modelId;
			this.rolesUri="/isrm/rest/models/"+this._modelId+"/roles/";
			this._setupRestStore();
			dojo.require("com.ibm.security.modeling.tables.RoleModelingTable");
			this.roleRestStore = this.roleRestManager.getIsrmTableRestStore();	
			
			var launcher = {
				launchRolePropertiesDialog: dojo.hitch(this,this.launchRolePropertiesDialog),
				launchDeleteRoleDialog: dojo.hitch(this,this.launchDeleteRoleDialog),
				launchMultiRoleDelete : dojo.hitch(this,this.launchMultiRoleDelete),
				launchTopology:dojo.hitch(this,this._switchToTopoView),
				launchRoleErrorWarning:dojo.hitch(this,this.launchRoleErrorWarning),
				launchExportProjectDialog:dojo.hitch(this,this.launchExportProjectDialog),
				launchCopyRolesDialog:dojo.hitch(this,this.launchCopyRolesDialog),
				launchGenerateRoles:dojo.hitch(this,this.launchGenerateRoles),
				roleCreate:dojo.hitch(this,this.createRole),
				roleCopy:dojo.hitch(this,this.copyRole),
				roleCreationSuccess: dojo.hitch(this,this.roleCreationSuccess),
				roleCreationFailed: dojo.hitch(this,this.roleCreationFailed),
				roleCopySuccess: dojo.hitch(this,this.roleCopySuccess),
				roleCopyFailed: dojo.hitch(this,this.roleCopyFailed),
				launchRoleAnalysisPane: dojo.hitch(this, this.launchRoleAnalysisPane),
				launchLifecycleSubmitRequest : dojo.hitch(this, this.launchLifecycleSubmitRequestForTable)
				
			};
			
			var showLifecycleStatusColumn = false;;
			if (this.roleLifecycleProvider) {
				showLifecycleStatusColumn = this.roleLifecycleProvider.isBPMEnabled();
			}
			if (showLifecycleStatusColumn) {
				// Update only when the Lifecycle Status column exists on Roles Table.
				this._setupStoreMatchesQuery(this.roleRestStore);
			}
			this.tableWidget = new com.ibm.security.modeling.tables.RoleModelingTable({dataStore: this.roleRestStore, 
					id:this.namespace+"tableWidgetContainer",
        			globalResources:this.globalResources,
        			localResources:this.localResources,
        			parentContainer:this.container,
        			messageArea:this.messageArea,
        			isSearchMultiSelect: false,
        			launcher: launcher,
        			lifecycleMenuHelper : this.lifecycleMenuHelper,
        			_modelId: this._modelId,
        			_undoHandler: this._undoHandler,
        			showLifecycleStatusColumn: showLifecycleStatusColumn
        		},this.namespace+"tableWidgetContainer");									
			this.tableWidget.startup();
			
			//this.summaryUpdateConnections.push(dojo.connect(this.tableWidget.grid, "_onFetchComplete", this, this._refreshSummaryInfo(this.projectUrl)));
			
			if (this.messageArea.isShowing) {
				this.messageArea.hide();
			}
		} catch (e) {
			this._trace.exception(e, "_createTable");
			if (typeof e.getMsgText != 'undefined'){
				this._showMessage("critical", e.getMsgText());
			}
		}
		this._trace.exiting("", "_createTable");
	},
	
	_setupStoreMatchesQuery: function(/*Store*/ roleRestStore) {
		// Refer: 
		//	com.ibm.security.modeling.tables.JsonRestStore::matchesQuery().
		
		roleRestStore.matchesQuery = dojo.hitch(roleRestStore, function(item,request){
			// summary: 
			//		overrides the same method in ClientFilter so that client side filtering
			//		works when searching over all columns
			//		And when the query contains Array as well.
			// item: Object
			//		The cell of the table
			// request: Object
			//		The filter request
			// returns: boolean
			//		true - if item matches query
			// 		false - otherwise.
			
			// Fix for defect: 23991 and 21802
			// For newly added items, matchesQuery results onto false when table is server side and have query parameters which are not item's (being queried) attribute.
			// Hence these items do not appear in result on screen.
			
			// Removing the ignore query parameter from query
			var query = dojo.clone(request.query);
			if(this.ignoreMatchQuery) {
				query = this.processQuery(query);
			}
			
			// var ignoreCase = request.queryOptions && request.queryOptions.ignoreCase;
			var ignoreCase = true;
			var performMatch = function(match, value) {
				var isWildcard = match.match(/[\*\.]/);
				var isIgnoreCase = ignoreCase;
				var isMatching = false;
				if (isWildcard || isIgnoreCase) {
					match = match.replace(/\?/g, "\\?");
					isMatching = dojo.data.util.filter.patternToRegExp(match, ignoreCase).test(value);
				} else {
					isMatching = (value == match);
				}
				return isMatching;
			};
			
			var isQueryEmpty = true;
			for(var i in query){
				isQueryEmpty = false;
				// if anything doesn't match, than this should be in the query
				var match = query[i];
				//	if(i in item ) var value = this.getValue(item,i);
				//	else return true;
				var value = this.getValue(item,i);
				var isString = typeof match == 'string';
				
				var isMatching = false;
				if (isString) {
					isMatching = performMatch(match, value);
				} else if (dojo.isArray(match) && match.length > 0) {
					for (var j=0; j<match.length; j++) {
						isString = typeof match[j] == 'string';
						if (isString) {
							isMatching = performMatch(match[j], value);
						} else {
							isMatching = (value == match);
						}
						
						if (isMatching) {
							break;
						}
					}
				} else {
					isMatching = (value == match);
				}
				
				//Break the loop on the first cell that matches the filter
				if (isMatching) {
					break;
				}
			}
			
			if (isQueryEmpty) { // for loop did not execute. query does not have anything.
				/*
				 * In a scenario where 'query' is an empty object: {}
				 * 	- hence item should be considered a match
				 * loop does not execute, 'isMatching' remains undefined, and returned.
				 * 
				 * This results into the 'item' being treated as 'not match'
				 * Hence undesired results are produced. 
				 */
				return true;
			}
			
			return isMatching;
		});
	},
	
	_tableFail:function(){
		this._trace.error("could not get project now?", "_tableFail");
	},
	
	getFullRoleUri:function(modelId,roleId){
		return "/isrm/rest/models/"+modelId+"/roles/"+roleId;
		
	},
	getRoleUriFromId:function(roleId) {
		return this.getFullRoleUri(this._modelId, roleId);
	},
	
	/*=================Role Dialog Launching Methods======================*/
	createRole:function(roleUri, parentRoleId, isToolBar){
		// summary:
		//			Creates an empty role object with generated auto Role Name.
		// roleUri: String
		//          Role uri value
		// parentRoleId: String
		//          Parent role id 
		this._trace.entering("", "createRole");
		
		// if invoked from toolbar, ignore the role selections
		if (isToolBar || typeof (isToolBar) == "undefined"){
			parentRoleId = null;
		}
		
		this.showWorkingDialog(this.localResources.CREATING_ROLE);
		
      	this.roleRestManager.createRoleResource(
      					this.localResources.NEW_ROLE_NAME,
		                parentRoleId,
			            dojo.hitch(this,this.roleCreationSuccess),
			            dojo.hitch(this,this._errorHandler));
        
		this._trace.exiting("", "createRole");
	},
	
	roleCreationSuccess: function (item) {
		// summary:
		//			Callback called on role creation success. Adds the new role to the view and launches role properties dialog. 
		// item: String
		//          Newly created role item
		this._trace.entering("", "roleCreationSuccess");
		
		if (!item){
			return;
		}
		
		switch(this._updateCalledFromTopoOrTable){
		    case this.calledFrom.TOPOLOGY:
			    //this._reloadTopologyData(this._modelId);
			    this._refreshTopology(this._modelId,item.id);
			    break;
		    case this.calledFrom.TABLE:
		    	// Refresh summary accordion information
				this._reloadTable(null,null,this._modelId);
			    break;
		    default:
			    this._trace.error("invalid update source: " + this._updateCalledFromTopoOrTable, "roleCreationSuccess");
			    this._showMessage("critical", "Internal Error");
		}
		this.hideWorkingDialog();

		// Launch the role edit dialog
		this.launchRolePropertiesDialog(item.uri, null);
		
		this._updateOtherView = true;
		
		this._trace.exiting("", "roleCreationSuccess");
	},
	// Copy the selected role
	copyRole:function(roleUri, selectedRoleId, selectedRoleName){
		// summary:
		// 		Copy the incoming role and create new role.
		// roleUri: String
		//		role uri
		// selectedRoleId: String
		//      selected role id to be copied
		// selectedRoleName: String
		//		selected role name to be copied
		this._trace.entering("", "copyRole");
		
		//this.showWorkingDialog(this.localResources.COPYING_ROLE);
		// Toolbar button action on topology
		if (typeof(selectedRoleId)=="undefined" || typeof(selectedRoleName)=="undefined"){
			var roleInfo = this._handleTopologyToolbarUpdateCall("");
			if (roleInfo !== null && roleInfo.roleUri !== null){
				selectedRoleName = roleInfo.roleName;
				
				if (roleInfo.roleUri !== null && typeof roleInfo.roleUri =='string'){
					selectedRoleId = roleInfo.roleUri.substring(roleInfo.roleUri.lastIndexOf("/")+1, roleInfo.roleUri.length);
				}
			}else{
				this._trace.error("No node selected", "copyRole");
				return;
			}
		}
		
		// Generate the new name
		var copyPrefix = this.localResources.COPY_NAME_PREFIX;
		var newName = copyPrefix + " " + selectedRoleName;
		
      	this.roleRestManager.copyRoleResource(
    			              newName,
                              selectedRoleId,
	                          dojo.hitch(this,this.roleCopySuccess),
	                          dojo.hitch(this,this._errorHandler));
	   
		this._trace.exiting("", "copyRole");
	},

	roleCopySuccess: function (item, request) {
		// summary:
		// 		Role copy success handler 
		// item: String
		//		copied role item
		
		this._trace.entering("", "roleCopySuccess");
		
		switch(this._updateCalledFromTopoOrTable){
	    case this.calledFrom.TOPOLOGY:
		    //this._reloadTopologyData(this._modelId);
		    this._refreshTopology(this._modelId, item.id);
		    break;
	    case this.calledFrom.TABLE:
			this._reloadTable(null,null,this._modelId);
		    break;
	    default:
		    this._trace.error("invalid update source: " + this._updateCalledFromTopoOrTable, "roleCreationSuccess");
		    this._showMessage("critical", "Internal Error");
	    }

		//this.hideWorkingDialog();
		this._updateOtherView = true;
		this._displaySODReviewMessage(item);
		
		
		
		this._trace.exiting("", "roleCopySuccess");
	},
	launchRolePropertiesDialog:function(roleUri,roleId){
		this.launchEditRoleDialog(roleUri);
	},
	launchRoleErrorWarning:function(roleUri){
		this.launchEditRoleDialog(roleUri,"errorWarning");//actual launch Point
	},
	
	launchEditRoleDialog:function(roleUri,initialPanel){
		this._trace.entering("roleUri: " + roleUri, "launchEditRoleDialog");
		dojo.publish(dojo.config.panels.ROLE.launchEventAddress,[roleUri, initialPanel, this.projectUrl, this._modelId]);
		this._trace.exiting("roleUri: " + roleUri, "launchEditRoleDialog");
	},
	
	launchRoleAnalysisPane: function (roleId) {
		this._trace.entering("roleId: " + roleId, "launchRoleAnalysisPane");
		dojo.publish(dojo.config.panels.ANALYSIS.launchEventAddress,[roleId]);
		this._trace.exiting("roleUri: " + roleId, "launchRoleAnalysisPane");
	},
	
	launchExportProjectDialog:function() {
		this._trace.entering(this.id, "launchExportProjectDialog");
		
		this.setProjectItem();
		if(!this.exportHelper){
			this.exportHelper = this.createExportHelper();
		}
		this.exportHelper.exportProject(this._projectId);
		
		this._trace.exiting(this.id, "launchExportProjectDialog");
	},
	/**
	 *  To create export helper object
	 */
	createExportHelper : function (){
		this._trace.entering(this.id, "createExportHelper");
		
		dojo.require("com.ibm.security.modeling.exporter.ExportHelper");
		var exportHelper = new com.ibm.security.modeling.exporter.ExportHelper({
					id : this.id,
					globalResources : this.globalResources,
					messageArea:this.messageArea
					},
				null);
		this._trace.exiting(this.id, "createExportHelper");
		
		return exportHelper;
	},
	//To fetch and set the project object in this._projectItem
	setProjectItem : function (projectUrl){
		this._trace.entering(this.id, "setProjectItem");
		// Construct the project rest manager 
		this.projectRestManager = new com.ibm.security.modeling.api.ProjectRestManager({
			resourceUri: "/isrm/rest/projects/",
			syncMode: false
		});

		this.projectUrl=projectUrl||this.projectUrl;
		this._projectId = this.projectUrl.substring(this.projectUrl.lastIndexOf("projects")+9);
		
		this._trace.exiting(this.id, "setProjectItem");
	},
	launchCopyRolesDialog:function(){
		// summary:
		//			Launch the Copy role dialog. 
		this._trace.entering("", "_launchCopyRolesDialog");
		this.setProjectItem();
		dojo.require("com.ibm.security.modeling.hierarchy.RoleCopyDialog");
		if(!this.roleCopyDialog){
			this.roleCopyDialog= new com.ibm.security.modeling.hierarchy.RoleCopyDialog({
										id:this.id+"_roleCopyDialog",
										parentWidget:this,
										hostname:this.hostname,
										port:this.port,
										contextRoot:this.contextRoot,
										projectId:this._projectId,
										projectRestManager:this.projectRestManager,
										callback:dojo.hitch(this,this._onCopyDialogClose),
										globalResources:this.globalResources});
			this.roleCopyDialog.startup();
		}
		this.roleCopyDialog.projectId=this._projectId;
		this.roleCopyDialog.projectUrl=this.projectUrl;
		this.roleCopyDialog.show();
		this._trace.exiting("", "_launchCopyRolesDialog");
	},
	launchGenerateRoles:function(){
		// summary:
		//			Launch the launchGenerateRoles. 
		
		
		dojo.require("com.ibm.security.modeling.mining.RoleMiningDialog");
	    try{
	    	this.setProjectItem();
	    	this.roleMiningDialog=new com.ibm.security.modeling.mining.RoleMiningDialog({
	    		projectUrl:this.projectUrl,
	    		closePanel:dojo.hitch(this,this.closePanel),
	    		parentShowMessage:dojo.hitch(this,this._showMessage),
	    		projectsTable:this._parent.projectsTablePanel._projectsTable
		    },null); 
		    this.roleMiningDialog.startup();
		    this.roleMiningDialog.show();
	    }catch(e){
	        this._trace.exception((e), "Error while creating Role Mining Dialog");
	    }
           
	},
	_onCopyDialogClose:function(param){
		// summary:
		//			Launch the Copy role to project dialog. 
		this._trace.entering("", "_onCopyDialogClose");
		if(param.activity && param.activity=="copy"){
			try{
				//setTimeout(dojo.hitch(this,this._showCopyRoleIntoProjectProgressBar),200);
				//setTimeout(dojo.hitch(this,this.closePanel),300);
				setTimeout(dojo.hitch(this,function(){ //need timeout coz when close panel gets called it clears the messages and hence the callback needs to be called after the panel is closed
					this.closePanel();
					this._showMessage("info",this.logMessages.ROLE_COPY_REQUEST_SUBMITTED);	
					dojo.publish("PROJECTSUPDATED","");
					}),400);
				
	
			}catch(e){
				this._trace.error("problems with hide");
			}
		}
		
		this._trace.exiting("", "_onCopyDialogClose");
	},
	/*===========================Delete Dialog=====================================*/
	launchTableDeleteRoleDialog:function(roleUri,roleName) {
		this._updateCalledFromTopoOrTable=this.calledFrom.TABLE;
		this.launchDeleteRoleDialog(roleUri, null, roleName);
	},
         launchMultiRoleDeleteFromTopology:function(uri,nodeIds){
      
		if(nodeIds){
                        var items=this.createItemsFromList(nodeIds);
                        this.launchMultiRoleDelete(items);
                }
                  
         },
        createItemsFromList : function(list){
                        var temp = new Array();
		        temp = list.split(',');
                        var items = new Array();
                        for(var i=0;i<temp.length;i++){
                           items[i]={};
                           items[i].uri=this.rolesUri+""+temp[i];
                            
                        }
                        return items;
        },
	launchMultiRoleDelete : function(items){
            dojo.require("com.ibm.security.modeling.widgets.ConfirmMessageDialog");
		var confirmRoleDeleteDialog = dijit.byId(this.id+"confirmMultiDelete");
		    if(!confirmRoleDeleteDialog){
			    var confirmRoleDeleteDialog=new com.ibm.security.modeling.widgets.ConfirmMessageDialog({
						   id:this.id+"confirmMultiDelete",						   
						   submitButtonText:this.globalResources.DELETE,
						   cancelButtonText:this.globalResources.CANCEL,
						   completeMessage:dojo.string.substitute(this.pluginMessages.PLUGIN_ROLE_CONFIRM_ROLES_DELETE,{"noOfRoles":items.length}),
						   title:this.localResources.DELETE_ROLES,
						   onSubmit: dojo.hitch(this,this.submitToServer,items)
			});
			confirmRoleDeleteDialog.show();
			confirmRoleDeleteDialog.startup();
	     }else{
             
	    	 confirmRoleDeleteDialog.setMessage(dojo.string.substitute(this.pluginMessages.PLUGIN_ROLE_CONFIRM_ROLES_DELETE,{"noOfRoles":items.length}));
		     confirmRoleDeleteDialog. onSubmit=dojo.hitch(this,this.submitToServer,items);
	    	 confirmRoleDeleteDialog.show();
			 confirmRoleDeleteDialog.startup();
	     }
	},
	submitToServer:function(items){
		
	 var xhrObj=[];
		
		 
		 for(var i=0;i<items.length;i++){
		   var roleObj={};
		   roleObj['method']='DELETE';
		   roleObj['uri']=items[i].uri;
		   roleObj['statusCode']=200;
		   xhrObj[i]=roleObj;
		 }

	       var xhrArgs = {
		    url:this.rolesUri,
		    headers: { 'Content-Type':'application/json' ,'Accept':'application/json','X-HTTP-Method-Override':'BATCH'},
		    postData:(dojo.toJson(xhrObj)).toString(),
		    load: dojo.hitch(this,this.deleteRoleRestCallback),
		    error:dojo.hitch(this, function(error) {
		    	                this.hideWorkingDialog();
		                        if(error.status==406){
		                             this.launchThresholdConfirmDialog(items);
		                        }else{
		                        	this._errorUtil.handleRESTError(error, this.messageArea);
		                        }
				}),
		    handleAs:"json"
		   
		};
               this.showWorkingDialog(this.localResources.DELETING_ROLES);
	       dojo.xhrPost(xhrArgs);
       },
      
    submitToServerOveride:function(items){

    	      var xhrObj=[];
    			
    			 
    			 for(var i=0;i<items.length;i++){
    			   var roleObj={};
    			   roleObj['method']='DELETE';
    			   roleObj['uri']=items[i].uri;
    			   roleObj['statusCode']=200;
    			   xhrObj[i]=roleObj;
    			 }

    		       var xhrArgs = {
    			    url:this.rolesUri+"?override=true",
    			    headers: { 'Content-Type':'application/json' ,'Accept':'application/json','X-HTTP-Method-Override':'BATCH'},
    			    postData:(dojo.toJson(xhrObj)).toString(),
    			    load: dojo.hitch(this,this.deleteRoleRestCallback),
    			    error:dojo.hitch(this, function(error) {
    			    	                    this.hideWorkingDialog();
    			                        	this._errorUtil.handleRESTError(error, this.messageArea);
    			                        }
    					),
    			    handleAs:"json"
    			   
    			};
    	        this.showWorkingDialog(this.localResources.DELETING_ROLES);
    		    dojo.xhrPost(xhrArgs);
         
	},
    launchThresholdConfirmDialog:function(items){
              dojo.require("com.ibm.security.modeling.widgets.ConfirmMessageDialog");
			  var confirmRoleDeleteDialog = dijit.byId(this.id+"confirmThresholdMultiDelete");
			  if(!confirmRoleDeleteDialog){
				var confirmRoleDeleteDialog=new com.ibm.security.modeling.widgets.ConfirmMessageDialog({
							   id:this.id+"confirmThresholdMultiDelete",
							   
							   submitButtonText:this.globalResources.DELETE,
							   cancelButtonText:this.globalResources.CANCEL,
							   completeMessage:this.pluginMessages.PLUGIN_REST_ROLE_CONFIRM_DELETE_OVERIDE,
							   title:this.localResources.DELETE_ROLES,
							   onSubmit: dojo.hitch(this,this.submitToServerOveride,items)
				});
				confirmRoleDeleteDialog.show();
				confirmRoleDeleteDialog.startup();
             }else{
        	    confirmRoleDeleteDialog.completeMessage=this.pluginMessages.PLUGIN_REST_ROLE_CONFIRM_DELETE_OVERIDE;
                confirmRoleDeleteDialog.onSubmit= dojo.hitch(this,this.submitToServerOveride,items);
    	        confirmRoleDeleteDialog.show();
	            confirmRoleDeleteDialog.startup();
              }
     },

	launchDeleteRoleDialog: function(roleUri,roleId,roleName){
		// summary:
		// 		Launches the role delete dialog that allows to choose delete options.
		// roleUri: String
		//		role uri
		// roleId: String
		//		role id
		// roleName: String
		//		role name
		this._trace.entering(this.namespace, "launchDeleteRoleDialog");
		
		if(typeof roleUri=="string" && typeof roleName=="string"){			
			dojo.require("com.ibm.security.modeling.widgets.DeleteRoleDialog");
			var roleDeleteDialog = dijit.byId("deleteRoleDialog");
			if (!roleDeleteDialog) {
				roleDeleteDialog=	new com.ibm.security.modeling.widgets.DeleteRoleDialog({
					callbackParms:{"roleUri":roleUri,"roleName":roleName},
					roleName: roleName,	
					globalResources: this.globalResources,
					localResources: this.localResources,
					logMessages:this.logMessages,
					hostname: this.hostname,
					port: this.port,
					messageArea: this.messageArea,
					deleteCallback: dojo.hitch(this, this.deleteRoleRestCallback),
					showWorkingDialog: dojo.hitch(this, this.showWorkingDialog),
					hideWorkingDialog: dojo.hitch(this, this.hideWorkingDialog),
					id: "deleteRoleDialog"
				});
			} else {//the dialog exists
				roleDeleteDialog.replaceRole(roleName, roleUri);
			}
			roleDeleteDialog.show();
			
		}else{
			this._determineRoleUri(roleId, roleName);
		}
		
		this._trace.exiting(this.namespace, "launchDeleteRoleDialog");
	},
	launchLifecycleSubmitRequestForTable : function(items,requestType) {
		// summary:
		//     To call request type specific handler.
		// items: Role Items
		//     Object contains array of role items
		// requestType: RequestType object
		//     Object contains object reference of requestType 
		
		this._updateCalledFromTopoOrTable = this.calledFrom.TABLE;
		
		this.launchLifecycleSubmitRequest(items,requestType);
		
	},
	launchLifecycleSubmitRequest : function(items,requestType) {
		// summary:
		//     To call request type specific handler.
		// items: Role Items
		//     Object contains array of role items
		// requestType: RequestType object
		//     Object contains object reference of requestType 
		
		//Request handler knows only specific type of data, so transformed data,
		//which can be used  by request handler
		requestType.requestHandler(
				this.transformerUtility.roleItemsTransformer(items),
				requestType,
				this._modelId
			);
	},
	updateViewForSubmitRequest : function(){
		switch(this._updateCalledFromTopoOrTable){
	    	case this.calledFrom.TOPOLOGY:
			    this._refreshTopology(this._modelId);
			    break;
		    case this.calledFrom.TABLE:
				this._reloadTable(null,null,this._modelId);
			    break;
		    default:
			    this._trace.error("invalid update source: " + this._updateCalledFromTopoOrTable, "roleCreationSuccess");
			    this._showMessage("critical", "Internal Error");
		}
	
		this._updateOtherView = true;
	},
	_determineRoleUri:function(roleId, roleName) {
		var roleInfo = {};
		if(this._isRightClickMenuCall(roleId)){//right click options
			roleInfo.roleUri=this.getFullRoleUri(this._modelId,roleId);
			this._updateCalledFromTopoOrTable=this.calledFrom.TOPOLOGY;
		}else{//case where need to get the canvas and get selection -for toolbar buttons
			roleInfo = this._handleTopologyToolbarUpdateCall(roleName);
		}
		if (roleInfo) {this.launchDeleteRoleDialog(roleInfo.roleUri,null,roleInfo.roleName);}
	},
	
	_isRightClickMenuCall:function(roleId) {
		return roleId && typeof roleId=="string";
	},
	
	_handleTopologyToolbarUpdateCall:function(roleName) {
		var selectedItems=this.navWidget._canvas.selection.getItems();
		var roleInfo = {roleName:roleName, roleUri:""};
		if(this._isOneItemSelected(selectedItems)){
			roleInfo.roleUri=this.getFullRoleUri(this._modelId,selectedItems[0]._item.id);
			roleInfo.roleName=selectedItems[0]._item.label;
			this._updateCalledFromTopoOrTable=this.calledFrom.TOPOLOGY;
		}else if(this._isMoreThanOneItemSelected(selectedItems)) {
			//this._trace.error("More than one node selected can't delete", "launchDeleteRoleDialog");
                          console.log("Here we are");
                          console.log(selectedItems.length);
                        var itemsList='';
		               for(var i=0;i<selectedItems.length;i++){
		                     itemsList=itemsList+selectedItems[i]._item.id+",";
		                 }
		                 itemsList=itemsList.substring(0,itemsList.length-1);
		                 console.log("The items list");
		                 console.log(itemsList);
                                 var items=this.createItemsFromList(itemsList);
		                 this._updateCalledFromTopoOrTable=this.calledFrom.TOPOLOGY;
                                 this.launchMultiRoleDelete(items);
                               return;
		}else{//if no items are selected
			this._trace.error("No node selected can't delete", "launchDeleteRoleDialog");
			return;
		}
		return roleInfo;
	},
	
	_isOneItemSelected:function(selectedItems) {
		return selectedItems && selectedItems.length===1;
	},
	
	_isMoreThanOneItemSelected:function(selectedItems) {
		return selectedItems && selectedItems.length>1;
	},
	
	deleteRoleRestCallback:function(){
		// summary:
		// 		Rest callback on successful role deletion
		this._trace.entering(this.namespace, "deleteRoleRestCallback");
		
		this.hideWorkingDialog();
		this._updateOtherView=true;
		switch(this._updateCalledFromTopoOrTable){
			case this.calledFrom.TOPOLOGY:
				//this._reloadTopologyData(this._modelId);
				this._refreshTopology(this._modelId);
				break;
			case this.calledFrom.TABLE:
				this.tableWidget.deselectAll();
				this._reloadTable(null,null,this._modelId);
				//BAD FIX : Though doing this , so that after delete this callback is called to update the pagination .
				//adding try-catch so that it do not break UI , even if something bad happens to private method _onDelete
				try{
						this.tableWidget.grid._onDelete();
				}catch(e){}

				break;
			default:
				this._trace.error("invalid update source: " + this._updateCalledFromTopoOrTable, "_deleteRoleRestCallback");
				this._showMessage("critical", "Internal Error");
		
		}
		this._updateOtherView = true;
		
		this._trace.exiting(this.namespace, "deleteRoleRestCallback");
	},


	_refreshSummaryInfo:function(projectUrl){
		// summary:
		// 		Refresh summary information for the given project url 
		// item: projectUrl
		//		project url
		this._trace.entering(this.namespace, "_refreshSummaryInfo");
		projectUrl =projectUrl|| this.projectUrl;
		this.summaryContainerNode.refreshSummaryInfo(projectUrl);
		this._trace.exiting(this.namespace, "_refreshSummaryInfo");
	},
	
	_incrementSummaryRoleCount:function(){
		// summary:
		// 		Increment the role count on role creation
		this._trace.entering(this.namespace, "_updateSummaryRoleCount");

		this.summaryContainerNode.incrementSummaryRoleCount();
		
		this._trace.exiting(this.namespace, "_updateSummaryRoleCount");
	},
	
	projectScopeEditComplete: function()
	{
		// summary:
		// 		Notification handler after project edit scope information has been successfully completed.
		this._trace.entering(this.namespace, "projectScopeEditComplete");
		
		this.closePanel();
		this._parent.projectsTablePanel.messageArea.showInfoMessage(this.pluginMessages.PROJECT_SCOPE_EVALUATION_SUBMITTED);
	},
	
	roleEditComplete: function(){
		// summary:
		// 		Notification handler after a role edit has been successfully completed. 
		this._trace.entering("", "roleEditComplete");
		this.messageArea.hideMessages();
		switch(this._updateCalledFromTopoOrTable){
		case this.calledFrom.TOPOLOGY:
			//this._reloadTopologyData(this._modelId);
			if(this._selectedRole){
				this._refreshTopology(this._modelId, this._getIdFromUri(this._selectedRole));
			}else{
				this._refreshTopology(this._modelId, null);
			}
			break;
		case this.calledFrom.TABLE:
			this._reloadTable(null,null,this._modelId);
			break;
		default:
			this._trace.error("invalid update source: " + this._updateCalledFromTopoOrTable, "roleEditComplete");
			this._showMessage("critical", "Internal Error");
		
		}

		this._updateOtherView = true;
		this._trace.exiting("", "roleEditComplete");
	},
	
	_displaySODReviewMessage: function(item){
		// summary:
		// 		If SoD constraints are copied a message should be shown prompting the user to review
		// item: String
		//		item reference
		this._trace.entering("", "_displaySODReviewMessage");
		
		if (!item){
			return;
		}
		
		var roleName = item.name;
    	var sodUri = item.uri.replace(/role.*/i,"sodconstraints");
		sodUri = sodUri + "?roleId="+item.id;
		
		dojo.xhrGet({
			url: sodUri,
			handleAs: "json",
			sync: true,
			load: dojo.hitch(this, function(item, ioArgs) {
				console.info(item.length);
				if (item !== null && item.length>0){
					var msg = this.logMessages.PLUGIN_REST_ROLE_COPY_SOD_REVIEW.replace("{0}", com.ibm.security.modeling.util.HtmlEscapingUtils.parseHTMLTag(roleName));
					this._showMessage("info", msg);
				}
			}),
			error: dojo.hitch(this, this._errorHandler)
		});
		
		this._trace.exiting("", "_displaySODReviewMessage");
	}

});