
dojo.provide("com.ibm.security.modeling.home.HomePanel");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("com.ibm.security.modeling.widgets.InfoMessageDialog");
dojo.require("com.ibm.security.modeling.dijit.layout.ContentPane");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageArea");
dojo.require("dijit.form.Form");
dojo.require("com.ibm.security.modeling.home.HomePageHelper");
dojo.require("com.ibm.security.modeling.util.TitleUtilities");


dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling", "PluginMessages");
dojo.requireLocalization("com.ibm.security.modeling.home", "HomePanelText");

dojo.declare("com.ibm.security.modeling.home.HomePanel",
				[ dijit._Widget, dijit._Templated],{


	widgetsInTemplate : true,
	contextRoot:null,
	reportSet:null,
	templatePath : dojo.moduleUrl("com.ibm.security.modeling.home","templates/HomePanel.html"),	
	titleUtils: new com.ibm.security.modeling.util.TitleUtilities(),
	constructor : function(args) {	
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
		this.localResources=dojo.i18n.getLocalization("com.ibm.security.modeling.home", "HomePanelText");
		this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
		this.portletTitle = this.titleUtils.getHomeTitle() || "Home";
	},
	postCreate : function() {
		
		this.inherited(arguments);
		if (!this.authorizedSections) {
			this.authorizedSections = ["design", "import", "report"];
		}
		
		this.sections = {
			"design": new dojo.NodeList(this.designSection),
			"import": new dojo.NodeList(this.importSection),
			"report": new dojo.NodeList(this.reportSection)
		};
		this._filterUIElements();
	},
	
    startup :function(){
		this.inherited(arguments);
		if(ConsoleUtilities.isToggleButton()===false){
			dojo.style(dojo.byId("link"),"display","none");
		}
	    dijit.focus(this.designSection);
	},
	
	_filterUIElements: function() {
		var filter = true;
		for (var section in this.sections) {
			filter = true;
			for (var i=0; i<this.authorizedSections.length && filter; i++) {
				if (this.authorizedSections[i] == section) {
					filter = false;
				}
			}
			if (filter) {
				this.sections[section].orphan();
			}
		}
	},
	
    onClickImport:function(){
		 var link=dojo.byId('importLink');
        
         ConsoleUtilities.clickLink(link);
    
     },
    
    
    onClickDesign:function(){
    	  var link=dojo.byId('designLink');
          ConsoleUtilities.clickLink(link);
           
     },
    onClickReport:function(){
    	 if(this.reportSet==="false"){
             if(!this.noReports){
				this.noReports = new com.ibm.security.modeling.widgets.InfoMessageDialog( {
					id : this.id + "InfoMessageDialog",
					globalResources : this.globalResources,
					title : this.localResources.TCR_NOT_INSTALLED,
					//should move to plugin messages
					infoMessages : this.pluginResources.NO_REPORTS_INSTALLED
				         }, null);
				 this.noReports.startup();
                 this.noReports.show();
              
            }else{
               
               this.noReports.show();
            }
		}else{
			  var link=dojo.byId('reportLink');
		      ConsoleUtilities.clickLink(link);
		}
            
    }
  
						
});