dojo.provide("com.ibm.security.modeling.importer.FilesDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");

dojo.require("dijit.form.Button");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("dijit._Container");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("com.ibm.security.modeling.widgets.IsrmDialogBase");
dojo.require("com.ibm.security.modeling.util.CommonUtilities");
dojo.require("com.ibm.security.modeling.widgets.MultiMessageArea");
dojo.require("com.ibm.security.modeling.importer.UploadFilesDialog");
dojo.requireLocalization("com.ibm.security.modeling", "PluginMessages");
dojo.require("com.ibm.security.modeling.importer.editTable");
dojo.require("com.ibm.security.modeling.util.ErrorUtilities");

dojo.require("dojox.form.FileInput");

dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling.importer", "EditSessionDialogText");
dojo.requireLocalization("com.ibm.security.modeling", "PluginMessages");


dojo.declare("com.ibm.security.modeling.importer.FilesDialog",com.ibm.security.modeling.widgets.IsrmDialogBase, {
	 //
	 // Implements the session details dialog for viewing / managing files in the session. 
	 // 
	 //
	 
	
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.importer.FilesDialog"),	
	templatePath : dojo.moduleUrl("com.ibm.security.modeling.importer", "templates/FilesDialog.html"),
	
	widgetsInTemplate : true,
	parentWidget : null,
	heightFactor:1.4,
	widthFactor:1.1,
	minHeight:450,
	killOnHide:false,
	//name of the session this dialog is related to 
	sessionName : "",
	//type of session this dialog is related to
	sessionType : "",
	//rest which hosts files for this session
	filesURI : "",
	//dialog to display for adding additional files
	//reused from parent
	uploadFilesDialog : null,
	//data store for listing / modifying files
	store : null,
	//experimental approach for making panel read Only
	readOnly:false,
	//Attribute map tying sessionName / type to
	//the relevant ui nodes to ensure when these
	//values are updated the ui reflects the new 
	//values properly 
	attributeMap : {
		sessionName : {node : "sessionNameNode", type : "innerText"},
		sessionType : {node : "sessionTypeNode", type : "innerText"}
	},

	constructor : function() {
		this._messageUtil = new com.ibm.security.modeling.util.MessageUtilities();
		 this._errorUtil = new com.ibm.security.modeling.util.ErrorUtilities();
		this._widgetUtilities = new com.ibm.security.modeling.util.WidgetUtilities();
		this.statusImages = com.ibm.security.modeling.importer.ImportStatusImages;
		this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.importer", "EditSessionDialogText");
		this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
		this.helpFile="ui_session_edit.html";
		

	},
    postMixInProperties:function(){
		
		this.inherited(arguments);
		this.dialogTitle= this.localResources.DIALOG_TITLE;
		this.dialogInstruction=this.localResources.DIALOG_INSTRUCTION;
		
	},
	postCreate : function() {
		this.inherited(arguments);
		dojo.style(this.bottomContentPane.domNode,"margin-top","0px");
		this._setupStore();
		this._createTable();
		this._setUpToolbar();
		this.connect(this.uploadTracker,"onComplete", "_displayUploadComplete");
		this.connect(this.uploadTracker,"onUpload", "_addFileinTable");
		this.connect(this.uploadTracker,"onError", "_displayUploadError");
		this.okButton = this.addCommonButton({
			onClick:dojo.hitch(this, this.onClose),
			type:"CLOSE"
		});
	},
	startup : function() {
	    this.inherited(arguments);
	    this._sessionFileTable.startup();
	    this.uploadStatusDialog.startup();
	    
	   },
	
	 onClose : function() {
		   this.hide();	
	},
	show : function(args) {
		
		// Summary:
		// 	Initializes the dialog to point to a new session
		//	if passed in and displayes the dialog.  
		//
		//   @param args Object 
		//	 sessionName : String indicates the name of the session
		//	 sessionType : String indicates the type of the session
		//	 filesURI 	: String uri referring to the rest api hosting files for the specified session
		//
		
		//if arguments are present then this is a 'relaunch'
		//of the dialog,  initialize it with the new session
		//and prepare it for display
		this.message=0;
			if (args) {
				this.set("sessionName",args.sessionName);
				this.set("sessionType",args.sessionType);
				this.set("filesURI",args.filesURI);
				this.readOnly=args.readOnly;
				this._setupStore();
				this._sessionFileTable.setStore(this.store);
				this.messageArea.hideMessages();
			}
		
	    this.inherited(arguments);
	    //this._sessionFileTable.startup();
	    //if the panel is read only disabling the toolbar , else is effective when a panel in launch
	    //after readOnly mode 
	    if(this.readOnly) this.disableToolBar();
	    else this.enableToolBar();
	},
	_createTable : function() {
 	    this._trace.entering("", "_createTable");
		var tableStructure = [
								{field : 'fileName',name : this.localResources.HEADER_COLUMN_0,width : '20%'},//formatter : dojo.hitch(this,this.formatSession)},
								{field : '_item',name : this.localResources.HEADER_COLUMN_1,width : '10%',isSearchable : false,formatter : dojo.hitch(this,this.formatStatus)},					
								{field : 'messageCount',name : this.localResources.HEADER_COLUMN_2,width : '5%',isSearchable : false,get:function(rowIndex,item){return item},formatter : dojo.hitch(this,this.formatmsgCount)},
								{field : 'userCount',name : this.localResources.HEADER_COLUMN_3,width : '5%',isSearchable : false},
								{field : 'roleCount',name : this.localResources.HEADER_COLUMN_4,width : '5%',isSearchable : false },
								{field : 'permissionCount',name : this.localResources.HEADER_COLUMN_5,width : '10%',isSearchable : false},
								{field : 'sodCount',name : this.localResources.HEADER_COLUMN_6,width : '11%',isSearchable : false},
								{field : 'userToPermissionCount',name : this.localResources.HEADER_COLUMN_7,width : '13%',isSearchable : false},
								{field : 'userToRoleCount',name : this.localResources.HEADER_COLUMN_8,width : '12%',isSearchable : false},
								{field : 'roleToPermissionCount',name : this.localResources.HEADER_COLUMN_9,width : '11%',isSearchable : false}
						];
	
		this._sessionFileTable = new com.ibm.security.modeling.tables.Table( {
			id : this.id + "_CommonTable",
			dataStore : this.store,
			structure : tableStructure,
			isClientSide : true,
			isFilterRendered : false,
			isRefreshRendered : true,
			isDynamic : true,
			autoHeight:false
			//isTotalsFooterRendered:true
		}, dojo.byId(this.id + "_TableContainer"));
		 
		dojo.addClass(this._sessionFileTable.domNode,"fullSizeTable");
		this._trace.exiting("", "_createTable");
	   },
//	   formatmsgCount : function(item) {
//			this._trace.entering("", "formatmsgCount");			
//			var temp_String;
//			var anchor='';	
//			if(item){
//				var value=item.messageCount;
//	     		if (value>0) {
//					temp_String= "<img src=/securitymodeling/js/src/com/ibm/security/modeling/importer/themes/images/violation_warning.png />";
//					 anchor=new com.ibm.security.modeling.util.Anchor({
//							add:temp_String,
//							input:value,
//							callback:dojo.hitch(this,this.showAllErrors,item)
//						});				
//				} else {
//					temp_String="<img src=/securitymodeling/js/src/com/ibm/security/modeling/importer/themes/images/no_violation.png />";
//					anchor=temp_String+" "+"0";			
//				}		
//	         }
//	        this._trace.exiting("", "formatmsgCount");	
//			return anchor;				
//		},
		formatmsgCount : function(item) {
						
						var temp_String;
						var anchor='';	
						if(item){
							//Level : 3 means error , 2 means warning , 1 means info
							var imageLevel = 1;
							var warningCount = this.store.getValue(item,"warningCount")||0;
							if(warningCount > 0) imageLevel = 2;
							var errorsCount = this.store.getValue(item,"errorCount")||0;
							if(errorsCount > 0) imageLevel = 3;
							
							
							 var totalCount = this.store.getValue(item,"messageCount");
							 var imagePath = "/securitymodeling/js/src/com/ibm/security/modeling/importer/themes/images/";
				
							
							if (item.messageCount != undefined && item.messageCount > 0) {
						 		 switch(imageLevel){
						 		 case 1: imagePath=imagePath+"info.png";
						 		        break;
						 		 case 2: imagePath=imagePath+"violation_warning.png";
						 		    	break;
						 		 case 3:imagePath=imagePath+"error.png";
						 		        break;
						 		 default:
						 			imagePath=imagePath+"info.png";
						 		         break;
						 		 }
						 		 
						 		temp_String= "<img class='imageHeight' src="+imagePath+" />";
								 anchor=new com.ibm.security.modeling.util.Anchor({
										add:temp_String,
										input:totalCount,
										callback:dojo.hitch(this,this.showAllErrors,item)
									});				
							} else {
								temp_String="<img class='imageHeight' src=/securitymodeling/js/src/com/ibm/security/modeling/importer/themes/images/no_violation.png />";
								anchor=temp_String+" "+"0";			
							}		
	         	}
						return anchor;				
		},
		formatStatus:function(item){
			this._trace.entering("", "formatStatus");
		     	var statusString='';			
			var statusTextKey = "importStatus_" + item.status;
			var statusImageKey = "importStatusImage_" + item.status;
			 
			var formattedStatus;
			var statusText = this.localResources.importStatus_IMPORT_FILE_QUEUED;
			 var statusImage = this.statusImages.importStatusImage_IN_PROGRESS;

			 if(this.localResources[statusTextKey]) {
				 statusText = this.localResources[statusTextKey];
			 } 

			 if (this.statusImages[statusImageKey]) {
				 statusImage = this.statusImages[statusImageKey];
			 }
			
			 var imageUtils = new com.ibm.security.modeling.util.Image();
			 formattedStatus=imageUtils.getImageHTML(statusImage,statusText,null,"imageHeight",statusText);
			
			return formattedStatus;
	 },
	 //added extra properties to item , so that closeandshow edit button works properly
	 showAllErrors:function(item){
	     //error dialogue need sessionName , but item dont have it 
	     try{
		     item.sessionType=this.sessionType;
		     item.filesURI= this.filesURI;
		     item.sessionName=this.sessionName;
				dojo.require("com.ibm.security.modeling.importer.ErrorDialog");
				var errorPanel=new com.ibm.security.modeling.importer.ErrorDialog({
					contextRoot:this.contextRoot,
					sessionItem:item,
					isSesssion:false
				},null);
				this.hide();
				errorPanel.show();
				errorPanel.startup();
	     }catch(e){
	     	console.log(e);
	     }
			
		},
	 _setupStore:function(){
			this._trace.entering("", "_setupStore");
						
			this.store = new com.ibm.security.modeling.tables.JsonRestStore({
				target:this.filesURI,
	            idAttribute: "id"
			});
			
			var putRequest = this.store.service["put"];
			this.store.service["put"]=dojo.hitch(this,function(id,content){
			     return this.store.service["delete"](id,content);
			});
			
			this._trace.exiting("", "_setupStore");
		},
		
		_setUpToolbar:function(){	
			this._trace.entering("", "_setUpToolbar");
			this._sessionFileTable.addToolbarSeparator();
	    	this._deleteButton = this._sessionFileTable.addToolbarButton(this.localResources.DELETE_FILE, false, "removeIcon", dojo.hitch(this, this._deleteSelected), this._sessionFileTable.id+ "_removeFile",true, true, false);
	    	this._sessionFileTable.addToolbarSeparator();
	    	this.createUploadStatusDialog();
	    	this._sessionFileTable.addToolbarButton(this.localResources.ADD_FILE, false, "attachIcon", dojo.hitch(this, this._addFiles), this._sessionFileTable.id+ "_addFile",false,false,false);
			var button = dijit.byId(this._sessionFileTable.id+"_addFile");
	        this._sessionFileTable.toggleButtonActivation([button],false);
	    	this._trace.exiting("", "_setUpToolbar");
		},
		disableToolBar:function(){
		    this._sessionFileTable.readOnlyMode=true;
	    var addButton=dijit.byId(this._sessionFileTable.id+ "_addFile");
	  //  var removeButton=dijit.byId(this._sessionFileTable.id+ "_removeFile");
	    this._sessionFileTable.toggleButtonActivation([addButton],true);
	    
	},
	enableToolBar:function(){
	     this._sessionFileTable.readOnlyMode=false;
	   var addButton=dijit.byId(this._sessionFileTable.id+ "_addFile");
	//    var removeButton=dijit.byId(this._sessionFileTable.id+ "_removeFile");
	    this._sessionFileTable.toggleButtonActivation([addButton],false);
	},
		createUploadStatusDialog:function() {
		//
		// Summary:
		// 		Creates the upload status tooltip dialog and ties it to a new drop down button. 
		// 		***Note we are setting visibility instead of display because we want the space 
		//      on the toolbar to be allocated.  
		// 
		//This must refer to the common upload tracker
	    this.uploadStatusDialog = new com.ibm.security.modeling.importer.UploadStatusDialog({uploadTracker: this.uploadTracker});
	    var uploadStatusButton = this._widgetUtilities.createButton(
	    		this.localResources.UPLOAD,
				true,
				"loadingIcon",
				null,
				 this.id + "_uploadStatus",
				true,
				this.uploadStatusDialog,
				true);
	    dojo.place(uploadStatusButton.domNode ,this.uploadStatusDialogattach ,"first");
	   //var uploadStatusButton = this._sessionFileTable.addToolbarButton(this.localResources.UPLOAD, true, "loadingIcon", null, this.id + "_uploadStatus", true, true, true, null, this.uploadStatusDialog,true);
	    dojo.style(uploadStatusButton.domNode,"visibility","hidden");
		this.uploadStatusDialog.set("uploadStatusButton", uploadStatusButton);
	},
	_addFiles : function() {
			this.uploadFilesDialog.show({filesURI : this.filesURI, sessionName : this.sessionName});
		},
		_deleteSelected : function(){
		    deleteConfirmMessage = this.logMessages.CONSOLE_DELETE_FILES_CONFIRMATION;
		    var indexOfMsgId = deleteConfirmMessage.indexOf("CTJ");
		    if (indexOfMsgId >= 0) {//startsWith
			 messageId = deleteConfirmMessage.substring(indexOfMsgId,10);		
			 deleteConfirmMessage = deleteConfirmMessage.substring(indexOfMsgId + 10);
		   }
		    //Show a confirmation dialog and then on OK make the call to _deleteFiles method
		    dojo.require("com.ibm.security.modeling.widgets.ConfirmMessageDialog");
			var deleteDialog = dijit.byId("filesDeleteConfirmDialog");
			this.itemsToDelete = this._sessionFileTable.grid.selection.getSelected();
			if(!deleteDialog){
				var deleteDialog = new com.ibm.security.modeling.widgets.ConfirmMessageDialog({
							   id:"filesDeleteConfirmDialog",
							   submitButtonText:this.globalResources.OK,
							   cancelButtonText:this.globalResources.CANCEL,
							   messageId:messageId,
							   message:deleteConfirmMessage,
							   title:this.localResources.DELETE_FILE,
							   onSubmit: dojo.hitch(this,this._deleteFiles)
							});
				deleteDialog.show();
				deleteDialog.startup();										
			}else{
				deleteDialog.message = deleteConfirmMessage;
				//Replacing the innerHTML text of the contentPane to display the updated session name.
				//var contentNode = dijit.byId("filesDeleteConfirmDialog_content");
				//contentNode.attr("content", "<h3>"+messageId+"</h3>" + deleteConfirmMessage);
				deleteDialog.show();
			}
			this._sessionFileTable.deselectAll();
		},
		_deleteFiles : function() {
			//
			// Summary:
			// 		Submits deletion of the selected files from the session.
			// 
			//  
			   
			   
			   var remains = this.itemsToDelete.length;

			   // When done.
			   var actions = [];
			   var self = this;
			   //loop through items to delete and issue delete command to store
			   for (var i = 0; i < this.itemsToDelete.length; i++) {
			   	  this.fileToDelete = this.itemsToDelete[i];
			   	  this.store.changing(this.fileToDelete);
				  //this.store.deleteItem(this.fileToDelete);
				  this.store.save({
						   revertOnError: true,
//						   onComplete: dojo.hitch(this, function(actions){
//								return handleComplete(actions[0], false);
//						   }),
						   onError: dojo.hitch(this, this._showErrorMessage)});
			   }
		},
		
		_showErrorMessage : function(error) {
			//
			// Callback handler for file delete operations
			// 
			// displays error message if delete failes
			//
			
				//this.messageArea.showErrorMessage(this._errorUtil.getErrorMessageFromRestCallback(this.pluginResources,error));
			this._errorUtil.handleRESTError(error, this.messageArea);
		
			
		},
		showMessage:function(item){
		//	var shouldShowMessage=(item.sessionName==this.sessionName && this._IsrmDialog.open);
			var shouldShowMessage=(item.sessionName==this.sessionName);
			if(shouldShowMessage){
				//this.calculate();
				this.message++;	
			}
			return shouldShowMessage;
		},
		_displayUploadComplete:function(item) {
				//
				// Displays upload completion message
				 //
			if(this.showMessage(item)){
				this.msgArea.showInfoMessage(dojo.string.substitute(this.pluginResources.CONSOLE_IMPORT_SESSION_FILEUPLOAD_REQUEST_COMPLETED, {"fileName":item.fileName}));	
			}	
		},
		_displayUploadError:function(item, error) {
			//
			// Displays upload error message
			//
			if(this.showMessage(item)){			     
			     var errorText= this._messageUtil.formatMessage(this.pluginResources[error.key],error.inserts,null,null); 	
	    		 this.messageArea.showErrorMessage(errorText);	
			 }
	},
	_addFileinTable:function(item){
	    if(item.sessionName==this.sessionName ){
	        this.store.service["post"]=function(){
	        	
	           var itemDfd = item.deferred;
	           var dfd =  new dojo.Deferred();
	           itemDfd.addCallback(function(result){
	        	   if(result.id) dfd.callback(result);
	        	   else dfd.errback(result);
	        	   return result;
	           });
              itemDfd.addErrback(function(error){
            	  dfd.errback(error);
	        	   return error;
	           });
	          
	           
	           
			   dfd.addCallback(function(result){
				dfd.ioArgs={};
				dfd.ioArgs.xhr={};
				dfd.ioArgs.xhr.getResponseHeader=function(header){
			   		if(header=="Location"){
			   		 return result.id;
			   		 }
			  	 }
				return result;
			   });
			   
	           
	        
	           return dfd;
	        }
	        var newitem=dojo.clone(item);
	        delete newitem.deferred;
	        this.store.newItem(newitem);
	        this.store.save({alwaysPostNewItems:true});
					
	    }
	}
});