dojo.provide("com.ibm.security.modeling.importer.UploadFilesDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");

dojo.require("dijit.form.Button");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("dijit._Container");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");

dojo.require("com.ibm.security.modeling.widgets.MultiMessageArea");
dojo.require("com.ibm.security.modeling.widgets.MultiFileInput");

dojo.require("dojox.form.FileInput");

dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling.importer", "UploadFilesDialogText");

dojo.declare("com.ibm.security.modeling.importer.UploadFilesDialog", [ dijit._Widget, dijit._Templated ], {

	templatePath : dojo.moduleUrl("com.ibm.security.modeling.importer", "templates/UploadFilesDialog.html"),
	uploadTracker : null,
	widgetsInTemplate : true,
	parentWidget : null,
	filesURI : null,
	sessionName : null,
		
	
	constructor : function() {
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
	this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.importer", "UploadFilesDialogText");
		this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");

	},
	postCreate : function() {
		this.inherited(arguments);
	},
	startup : function() {
	    this.inherited(arguments);
	   },
   	 onOK : function() {
			this._enqueueUpload();
			this.hide();
		},
	hide : function() {
		   this.uploadFilesDialog.hide();
		},
		
	onCancel : function() {
			this.multiFileInput.deleteAndReplaceForm();
			this.hide();
		},
	destroy : function() {
			this.inherited(arguments);
		},
	
	show : function(args) {	
			if (args) {
				if (args.filesURI) {
					this.filesURI = args.filesURI;
				} 
				if (args.sessionName) {
					this.sessionName = args.sessionName;
					this.uploadFilesDialog.set("title",this.localResources.PANEL_NAME.replace("${0}",(new String(args.sessionName))));
				}
			}		
			
	     this.uploadFilesDialog.show();
		
	},
		
	
	_enqueueUpload : function () {	
		var uploadData = this.multiFileInput.getFormsForUploadAndReplace();
					
		this.uploadTracker.startUpload(this.filesURI, uploadData, {sessionName : this.sessionName} );
	}
	
	
}
	
	



);