dojo.provide("com.ibm.security.modeling.importer.UploadStatusDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.TooltipDialog");

dojo.require("dijit.form.Button");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("dijit._Container");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");

dojo.require("com.ibm.security.modeling.widgets.MultiMessageArea");
dojo.require("dojox.grid.EnhancedGrid");
dojo.require("dojox.data.AndOrWriteStore");
             

dojo.require("dijit.TooltipDialog");
dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling.importer", "UploadStatusDialogText");

dojo.declare("com.ibm.security.modeling.importer.UploadStatusDialog", [ dijit._Widget, dijit._Templated ], {

	templatePath : dojo.moduleUrl("com.ibm.security.modeling.importer", "templates/UploadStatusDialog.html"),
	uploadStore : null,
	widgetsInTemplate : true,
	_tableStarted : false,
	uploadTracker : null,
	uploadStatusButton : null,
		
	constructor : function() {
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
		this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.importer", "UploadStatusDialogText");
		this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
		
		

	},
	postCreate : function() {
	
		this.inherited(arguments);
		this.tableStructure = [{field: 'sessionName', name : this.localResources.HEADER_COLUMN_SESSION, width: '30%'}, {field: 'fileName', name : this.localResources.HEADER_COLUMN_FILE, width: '70%'}];
		this.uploadStore = new dojox.data.AndOrWriteStore({data : {identifier: 'id', label : 'fileName', items:[]}});
		this.uploadStatusTable = new dojox.grid.EnhancedGrid({
			id: this.id+"_grid",
			queryOptions: {ignoreCase: true, cache: true},
			store: this.uploadStore,
			structure: this.tableStructure,
			autoHeight: this.autoHeight,
			query:"",
			clientSort: true,
			elasticView: 1,
			rowSelector: "0",//hide the selector column since we use indirect selection
			rowsPerPage: 50,
			selectionMode: "single",
			plugins: {indirectSelection: false}
			
		},
		this.uploadStatusTableAnchor);
		
		this.uploadStatusTable.rowHeight = 32;
		dojo.addClass(this.uploadStatusTable.domNode,"fullSizeTable");
		
		if (this.uploadTracker) {
			dojo.connect(this.uploadTracker,"onUpload", dojo.hitch(this, this._onUpload));	
			dojo.connect(this.uploadTracker,"onComplete", dojo.hitch(this, this._onUploadComplete));
			dojo.connect(this.uploadTracker,"onError", dojo.hitch(this, this._onUploadError));
		}
		
	},
	_onUpload : function(item) {
		this.uploadStore.newItem(item);
		this.uploadStore.save();
		this._updateButtonVisibility();
	},
	_onUploadComplete : function(item) {
		this.uploadStore.fetchItemByIdentity({identity:item.id, onItem: dojo.hitch(this,this._removeItem)});	
		this._updateButtonVisibility();
	},
	_onUploadError : function(item, error) {
		this._onUploadComplete(item);
	},
	_updateButtonVisibility : function() {
		if (this.uploadStatusButton) {
			if (this.uploadTracker.getUploadCount() > 0) {
				 dojo.style(this.uploadStatusButton.domNode,"visibility","visible");			
			} else {
				 dojo.style(this.uploadStatusButton.domNode,"visibility","hidden");
			}
		}
	},
	_removeItem:function(item) {
		this.uploadStore.deleteItem(item);
		this.uploadStore.save();
	},
	
	
	onOpen : function() {
		if (!this._tableStarted) {
			this.uploadStatusTable.startup();
			this._tableStarted = true;
		}
	}, 
	startup : function() {
	    this.inherited(arguments);
	    this.uploadStatusTable.startup();
	   // this.setupMessageArea();
	   },
	 validate : function () {
		return true;   
	  },
   	 onOK : function() {
			
		},
	
	hide : function() {
		  this.uploadStatusDialog.hide();
	
		},
		
	destroy : function() {
			this.inherited(arguments);
		},
	
	show : function() {	
			
			this.uploadStatusDialog.show();
		
	}
	
}
	
	



);