/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.security.modeling.importer.editTable");

dojo.require("com.ibm.security.modeling.tables.Table");
dojo.require("com.ibm.security.modeling.widgets.FileUploadWidget");
dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling.importer", "EditSessionDialogText");
dojo.declare("com.ibm.security.modeling.importer.editTable",com.ibm.security.modeling.tables.Table , {
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.importer.FilesDialog"),			
	

    _updateButtons:function(args) {	
		// summary:
		//		Updates Button activation based on rows selected in the table. 
		
		//Since this event is fired from all tables we need to check if the event happened from this grid.
		//Also, this method can be invoked locally with no arguments param.  in that case, we will assume 
		// that the grid is from this object.
		if(typeof args == "undefined" || args.grid===this.grid) { 
			this._trace.info(this.id + " - Event received on this grid, updating buttons", "_updateButtons");
			var numberOfSelectedRows = this.grid.selection.getSelectedCount();
			//then only enable Buttons appropriate to the selections
			if(numberOfSelectedRows == 1) {
                                this.toggleButtonActivation(this.multiSelectButtons, true);
			        this.toggleButtonActivation(this.noSelectButtons, true);		
				this.toggleButtonActivation(this.singleSelectButtons, false);
			}
			if (numberOfSelectedRows > 1) {
			        this.toggleButtonActivation(this.singleSelectButtons, true);
			        this.toggleButtonActivation(this.noSelectButtons, true);		
				this.toggleButtonActivation(this.multiSelectButtons, false);			
			}
			if (numberOfSelectedRows == 0) {
			        this.toggleButtonActivation(this.multiSelectButtons, true);
			        this.toggleButtonActivation(this.singleSelectButtons, true);
				this.toggleButtonActivation(this.noSelectButtons, false);			
			}
		}
	}
		
});
