/* 
Licensed Materials - Property of IBM

5724-Z11??

� Copyright IBM Corp. 2009 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("com.ibm.security.modeling.dijit.layout.ContentPane");
dojo.require("ibm.tivoli.tip.dijit.TIPMessageArea");	
dojo.require("com.ibm.security.modeling.util.NlsUtilities");
dojo.require("dijit.Dialog");

dojo.provide("com.ibm.security.modeling.layouts.BasicLayout");

dojo.declare("com.ibm.security.modeling.layouts.BasicLayout",
            [ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("com.ibm.security.modeling.layouts","templates/BasicLayout.html"),	
	widgetsInTemplate: true,
	// globalResources: Object
	//			Reference to the global shared resource bundle
	globalResources: null,
	// localResources: Object
	//			Reference to the resource bundle unique to this widget
	localResources: null,
	// namespace: [readonly] String
	// 			Unique identifier to the instance of portlet page where this item will exist
	namespace: "",
	// contextRoot: String
	//			The context root of the server from which Content is being served.
	contextRoot: "",
	
	_workingDialogCount:0,
	
	constructor: function () {
		// summary:
		// 			Widget that provides the Common UI layout.
		// description: 
		//			This widget sets up the layout of the page, as well as base layout and 
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
	},
	postCreate:function(){
		this.inherited(arguments);
		this.workingDialog.titleBar.style.display='none';
		this.container.isLeftToRight = NlsUtilities.isLtr;
		dojo.removeClass(this.workingDialog.containerNode, "dijitDialogPaneContent");
	},
	startup: function(){	
		try {
			this.inherited(arguments);
			var callBack = dojo.hitch (this, this._startResizeChain);
			
			this.msgArea.show = function () {
				// call super: the show() of msgArea widget.
				this.inherited( "show", arguments );
				// now set timer for this wizard resize.
				setTimeout (callBack, 500);
			};
			
			this.msgArea.hide = function() {
				// call super: the hide() of msgArea widget.
				this.inherited( "hide", arguments );
				// now set timer for this wizard resize.
				setTimeout (callBack, 500);
			};
		} catch (e) {
			console.error("Error creating Common Layout 1: " + e);
			this.msgArea.setType("critical");
			this.msgArea.setMessage(e);
			this.msgArea.show();
		}
	},
	_startResizeChain:function(){
		this.container.resize();
	},
	showWorkingDialog:function(msg){
		this._workingDialogCount++;
		if(msg !=null && typeof msg == "string"){
			this.msgPlaceHolder.innerHTML=msg;
		}else{
			msg=this.globalResources.LOADING;
		}
		this.workingDialog.show();
	},
	hideWorkingDialog:function()  {
		this._workingDialogCount--;
		if ( this._workingDialogCount <= 0 ) {
			this.workingDialog.hide();
			this._workingDialogCount = 0;
		}
			
	},
	destroy: function()
	{
		this.inherited(arguments);
	}
});