dojo.provide("com.ibm.security.modeling.membership.FilterBuilderPanelLauncher");

dojo.require("com.ibm.security.modeling.controller.PanelLauncher");

dojo.declare("com.ibm.security.modeling.membership.FilterBuilderPanelLauncher", com.ibm.security.modeling.controller.PanelLauncher, {
	roleItem: null,
	notebookTitle: null,
	filterData: null,
	panelStack: null,
	titleName: null,
	fileName: "ui_role_membership_addfilter.html",
	
	constructor: function(panelStack, contentPane, panelWidget, filterData, roleItem, notebookTitle, globalResources) {
		// summary:
		// 			Launches the role hierarchy panel
		// panelStack: com.ibm.security.modeling.dijit.layout.StackContainer
		//			Stack container controlling display of panels
		// contentPane: com.ibm.security.modeling.dijit.layout.ContentPane
		//			Content pane for the stack container to show.
		// panelWidget: Object
		//			The panel widget object to be loaded.
		// filterData: Object
		// 			Object representing the filter data in json format	
		// roleItem: Object
		//			Object representing the role for whom the filter is being built for. 
		// globalResources: Object
		//			Resource bundle to load title text from.
		this.roleItem = roleItem;
		this.notebookTitle = notebookTitle;
		this.filterData = filterData;
		this.contentPane = contentPane;
		this.panelWidget = panelWidget;
		this.titleName = globalResources.MEMBERSHIP_FILTER;
		this.breadcrumbKwArgs = {
			label: this.titleName,
			hideFunction: "_navigateAway",
			canHide: dojo.hitch(this.panelWidget, this.panelWidget.canHide),
			context: this.panelWidget
		};
		
		this.panelWidget.launcher = this;
	},

	launch:function() {
		if (!this.panelWidget.isNew) {
			this.panelWidget.populate(this.filterData, this.roleItem, this.notebookTitle);
		} else {
			this.panelWidget.isNew = false;
		}
		this.inherited(arguments, [this.contentPane, this.titleName, this.fileName]);
		this.publishPanelChangedEvent(this.breadcrumbKwArgs, dojo.config.panels.FILTER.id);
		this.panelWidget.adjustLayout();
	}
});