/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

(c) Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.security.modeling.membership.FilterGroupPhraseHierarchyValue");

dojo.require("dijit._Templated");

dojo.require("com.ibm.security.modeling.membership._FilterGroupPhraseEntityValue");
dojo.require("com.ibm.security.modeling.util.Trace");

// define the widget class
dojo.declare (
	"com.ibm.security.modeling.membership.FilterGroupPhraseHierarchyValue", 
    [ com.ibm.security.modeling.membership._FilterGroupPhraseEntityValue], {
		
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.membership.FilterGroupPhraseHierarchyValue"),
	
	_type:"HIERARCHY",
	
	_filterAttribute: "value",
	
	postMixInProperties: function() {
		// Summary:
		//		Widget life-cycle method. 
		
		this._trace.entering(this.id, "postMixInProperties");
		this.inherited(arguments);
		
		this.hintText = this.localResources.HINT_CONDITION_VALUE_HIERARCHY;
		this._trace.exiting(this.id, "postMixInProperties");
	},
	
	_launchSearchDialog:function(){
		// summary:
		//			Launch the Search Dialog. 
		this._trace.entering("", "launchSearchDialog");

		dojo.require("com.ibm.security.modeling.membership.SearchDialogForIdentityAndHierarchyValues");
		if(this.searchDialog !=null){
			this.searchDialog = null;
		}
		
			this.searchDialog= new com.ibm.security.modeling.membership.SearchDialogForIdentityAndHierarchyValues({
										id:this.id+"_searchDialog",
										selectedItemFromMembershipFilterPanel: this._data,
										selectedValues: this.getSelectedValuesItems(),
										parentWidget:this
										});
			this.searchDialog.startup();
		
		
		this.searchDialog.show();
		
		this._trace.exiting("", "_launchCopyRolesDialog");
	}
});