dojo.provide("com.ibm.security.modeling.mining.DefaultRoleMiningPanel");
dojo.require("com.ibm.security.modeling.mining.SingleRoleImpactPane");
dojo.require("com.ibm.security.modeling.mining.HierarchicalImpactPane");
dojo.require("com.ibm.security.modeling.util.ValidationUtilities");
dojo.require("com.ibm.security.modeling.util.CommonUtilities");
dojo.requireLocalization("com.ibm.security.modeling.mining", "DefaultRoleMiningPanelText");

dojo.declare("com.ibm.security.modeling.mining.DefaultRoleMiningPanel", [ dijit._Widget, dijit._Templated ], {
	
	templatePath : dojo.moduleUrl("com.ibm.security.modeling.mining", "templates/DefaultRoleMiningPanel.html"),
 
	widgetsInTemplate : true,
	validator : new com.ibm.security.modeling.util.Validator(),
	constructor:function(){
	    //have al the widgets used by this panel
	    this.widgets=[];
	   this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
	  this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.mining", "DefaultRoleMiningPanelText");
	  this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
	 this.keyForValue={
	      "SingleRoleImpactPanel":"allowDirect",
	      "HierarchicalImpactPane":"HIERARCHY",
	      "RolePrefix":"rolePrefix"	  
	      };
	   
	     this.stringUtil = new com.ibm.security.modeling.util.StringUtils();
	},
	
	postCreate : function() {
		
		//dojo.addClass(this.domNode, "contentArea");
		this.inherited( arguments);
		
		this.widgets.push(this.attachSingleRoleImpactPane());
		this.widgets.push(this.attachHierarchicalImpactPane());
		

	},
	applyCommonStyle:function(widget){
		
	  widget.placeAt(this.attachmentContainer,"last");
	  dojo.style(widget.domNode,"margin","10px 0 0 0");
      this.rolePrefix._inputNode.style.width = "33%";
	},
    attachSingleRoleImpactPane:function(){
      var widget = new com.ibm.security.modeling.mining.SingleRoleImpactPane({keyForValue:this.keyForValue['SingleRoleImpactPanel']});
      
      this.applyCommonStyle(widget);
      return widget;
    },
    attachHierarchicalImpactPane:function(){
      var widget = new com.ibm.security.modeling.mining.HierarchicalImpactPane({keyForValue:this.keyForValue['HierarchicalImpactPane']});
      this.applyCommonStyle(widget);
      return widget;
    },
    validate:function(){
        //can have an array for all vaidation messages 
        var validationObject=this.validateSelf(); ; 
        for(var i=0;i<this.widgets.length;i++){
            var widget = this.widgets[i];
            if(!validationObject.valid) break;
            validationObject = ("validate" in widget)?widget.validate():{valid:false,message:"Provide validation method for " + widget.toString()};
            
        }
        return validationObject;
        
    },
    validateSelf:function(){
        
  
    	 var value=this.getSelfValue()[this.keyForValue['RolePrefix']];
         var validationObject={};
         validationObject.valid = this.validator.checkEmptyValue(value);
         if(!validationObject.valid) {
             this.rolePrefix.setStatus({state: this.rolePrefix.constants.ERROR});
             validationObject.message = (validationObject.valid)?'':this.pluginResources.PLUGIN_ROLE_MINING_REST_MISSING_ROLE_NAME_PREFIX;
          }else{
              validationObject.valid = this.validator.checkMaxLength(value, 230);
              
              var msgStr = this.pluginResources.PLUGIN_ROLE_MINING_REST_STRING_EXCEEDS_MAX;
 	    	   validationObject.message = (validationObject.valid)?'':msgStr;
          }
         
		 
		 return validationObject;
		 
    },
    //return the extracted value for widget , which will be send to server
    //each widget should give some different fieldname else mixin will kill that data
  
    getRoleGeneration:function(){
        var data=this.getSelfValue();
        for(var i=0;i<this.widgets.length;i++){
            var widget = this.widgets[i];
            var obj = ("getValue" in widget)?widget.getValue():{};
            dojo.mixin(data,obj);
        }
        //we can further fitler the data if needed by server
        return data;
    },
    getSelfValue:function(){
        var key = this.keyForValue['RolePrefix'];
        var obj={};
         var stringValue = (this.rolePrefix.getValue()||" ");  
         //performing ltrim
         stringValue = stringValue.replace(/^\s+/,"");
	    obj[key]= stringValue;
        return obj;
    }
    
});