dojo.provide("com.ibm.security.modeling.mining.HierarchicalImpactPane");
dojo.require("com.ibm.security.modeling.widgets.RequiredTextField");
dojo.requireLocalization("com.ibm.security.modeling.mining", "HierarchicalImpactPaneText");
dojo.declare("com.ibm.security.modeling.mining.HierarchicalImpactPane", [ dijit._Widget, dijit._Templated ], {
	
	templatePath : dojo.moduleUrl("com.ibm.security.modeling.mining", "templates/MiningAlgorithmImpactPane.html"),


    attributeMap : {
		impactLabel : {node : "impactLabelnode", type : "innerText"}
		
	},
	widgetsInTemplate : true,
	keyForValue:'value',
	constructor:function(){
	   this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
	  this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.mining", "HierarchicalImpactPaneText");
	  this.valueEnum ={
	      0:"NONE",
	      1:"MODERATE",
	      2:"FULL"
	      
	  }
	   
	},
	
	postCreate : function() {
		
		//dojo.addClass(this.domNode, "contentArea");
		this.inherited( arguments);
		this.slider = this.attachWidget();
		this.slider.placeAt(this.widget,"replace");
		this.impactLabelnode.innerHTML=this.localResources.IMPACTLABEL_0+"<br/><br/>"+this.localResources.IMPACTLABEL_1+"<br/><br/>"+this.localResources.IMPACTLABEL_2;
        
	},
    attachWidget:function(){
        
        dojo.require("dijit.form.VerticalRuleLabels");
        dojo.require("dijit.form.VerticalRule");
        dojo.require("dijit.form.VerticalSlider");
         var vertical = document.createElement('div');
            
            var rulesNode = document.createElement('div');
            vertical.appendChild(rulesNode);
            var sliderRules = new dijit.form.VerticalRuleLabels({
                count: 3,
                style: "width:5px;margin:0px 8px",
                labels:[this.localResources.VerticalLabel_FLAT,this.localResources.VerticalLabel_FULL]
            },
            rulesNode);
        
            
            var slider = new dijit.form.VerticalSlider({
                name: "vertical",
                value: 1,
                minimum: 0,
                discreteValues:"3",
                showButtons:false,
                maximum: 2,
                intermediateChanges: false,
                style: "height:110px;margin:5px"
                
            },
            vertical);
            //default message for default value
          //  this.set("impactLabel",this.localResources["IMPACTLABEL_"+slider.value]);
            slider.onChange=dojo.hitch(this,this.onChange);
            return slider;
    },
    onChange:function(value){
      //  this.set("impactLabel",this.localResources["IMPACTLABEL_"+value]);
    },
    validate:function(){
        var validationObject = {valid:true,message:""};
        return validationObject;
    },
    getValue:function(){
        var key = this.keyForValue;
        var obj = {};
        obj[key]=this.valueEnum[this.slider.attr("value")];
        return obj;
    }
});

