dojo.provide("com.ibm.security.modeling.mining.polling");
dojo.declare("com.ibm.security.modeling.mining.polling", null, {
    //url , checkSuccessStatus()  is must to pass , url is used for Get Call
	//checkSuccessStatus is a callback which is called to check whether this call was succesful
	
	//A common polling utility , which keep polling until success is achieved for a max of maximumPollingTime
	//Gaurantees only once success/error callback will be called 
	//success can be called in a time less than maximumPolling time , but error/timeoutError will be called only
	//after maxinumPollingTime
	//once success or error callBack is called polling will stop , and request which has already been fired will be discarded.
	
	
    //class will poll maximum of this time , in sec
    maximumPollingTime:30,
    //polling interval time , in sec
    pollingInterval:0,
    polledCount:0,
    constructor:function(args){
	this.errorUtil = new com.ibm.security.modeling.util.ErrorUtilities();
        dojo.mixin(this,args);
        this._totalPolledTime = 0;
        this.success = false;
        this.failed = false;
        //will move this to correct place
        
    },
    poll:function(){
    	this.handler =[];
    	for(var i=0;this.pollingInterval < this.maximumPollingTime;i++){
    		
    		if(this.pollingInterval <= 10){
        		this.pollingInterval = this.pollingInterval + (i+1); //1->1,2->3,3->6,4->10
        	}else{
        		this.pollingInterval = this.pollingInterval + 5; //5->15, 6->20, 7->25, 8->30
        	}
    		this.handler[i] = setTimeout( dojo.hitch(this,this.getUpdatedStatus),this.pollingInterval*1000);
    	}
    },
    clearHandlerTimeout : function(){
    	for(var i=0;i<this.handler.length;i++){
    		clearTimeout(this.handler[i]);
    	}
    },
    //will be called under two circumstances , either a time out or an error
     onError:function(error,isError){
        //final onError
        if(!this.failed && !this.success){
            //this job will be performed only once
            this.failed=true;
            this.clearHandlerTimeout();
            this.errBack(error,isError);
           
        }
        //if code come here means onError has already been called and action is taken
        
    },
    onSuccess:function(item){
       //final onSuccess
       if(!this.failed && !this.success){
            this.sucess=true;
            this.clearHandlerTimeout();
            //this job will be performed only once
             this.sucBack(item);
           
       }
      
    },
    getUpdatedStatus:function(){
    	this.polledCount ++;
        var projectRequest = this.doAjaxCall(this.url);
        projectRequest.addCallback(dojo.hitch(this, this.successCallBack));
        projectRequest.addErrback(dojo.hitch(this, this.errorCallBack));
        
    },
    successCallBack:function(item){
        
       if(this.checkSuccessStatus(item)){
            this.onSuccess(item);
        }else{
            this.checkPolledCount(item,false);
        } 
    },
    checkPolledCount:function(obj,isError){
        if(this.polledCount == this.handler.length){
                //Handle the time out
                this.onError(obj,isError);
         }
    },
    errorCallBack:function(error){
    	this.checkPolledCount(error,true);
    },
   
    doAjaxCall : function(url , args){
         
            var xhrArgs = {
                url: url,
                handleAs: "json",
                sync:false,
                headers: {
					Accept:  'application/json'
				},
                timeout:this.maximumPollingTime*1000,
                load: function(data) {
                    return data;
                    
                },
                error: function(error) {
                   return error;
                }
            };

        return dojo.xhrGet(xhrArgs);
    }
});