
dojo.provide("com.ibm.security.modeling.notebook.AttributeDialogFactory");
dojo.require("com.ibm.security.modeling.widgets.RequiredTextArea");
dojo.require("ibm.tivoli.tip.dijit.NumberInputBox"); 
dojo.require("com.ibm.security.modeling.util.ValidationUtilities");
dojo.require("com.ibm.security.modeling.projects.ProjectUtil");
dojo.requireLocalization("com.ibm.security.modeling", "LogMessages");
dojo.requireLocalization("com.ibm.security.modeling.notebook", "AttributeDialogText");
dojo.require("com.ibm.security.modeling.topology.TopologyUtil");

dojo.declare("com.ibm.security.modeling.notebook.AttributeDialogFactory", null, {
    
    //will return widgetFactory
	getWidgetFactory:function(item,args){
		//current value which is selected
		var widgetFactory;
	     //this.value = value ;
		args.item = item;
		    if(item.type=="IDENTITY"){
		        widgetFactory= new com.ibm.security.modeling.notebook.AttributeDialogTable(args);
		    }else if(item.type=="HIERARCHY"){
		        widgetFactory= new com.ibm.security.modeling.notebook.AttributeDialogTopology(args);
		        
		    }else if(item.type=="STRING"){
		        widgetFactory= new com.ibm.security.modeling.notebook.AttributeDialogTextArea(args);
		    	
		    }else{
		        widgetFactory= new com.ibm.security.modeling.notebook.AttributeDialogTextField(args);
		        
	         }
	         return widgetFactory;
	}
});

dojo.declare("com.ibm.security.modeling.notebook.AbstractFactory",null,{
    getWidget:function(){
        
    },
    extractValue:function(){
        
    },
    destroy:function(){
        
    },
    validate:function(){
        
    }
});


dojo.declare("com.ibm.security.modeling.notebook.AttributeDialogTextArea",com.ibm.security.modeling.notebook.AbstractFactory, {
	validator : new com.ibm.security.modeling.util.Validator(),
    constructor:function(args){
        this.properties = args;
        this.item = this.properties.item;
        this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
        this.id=(this.properties&&this.properties.id)?this.properties.id:"id";
          this.stringUtil = new com.ibm.security.modeling.util.StringUtils();
         
    },
	getWidget:function(value,args){
		  
		var msgArea = (args && args.msgArea)?args.msgArea:(this.properties && this.properties.msgArea)?this.properties.msgArea:null;
		var length = 240;
		var DYNAMIC_ROLE_RULE_DEFINITION_ATTRIBUTE_NAME="Identity Manager Rule Definition";
		if(this.item.attributeName.toUpperCase() == DYNAMIC_ROLE_RULE_DEFINITION_ATTRIBUTE_NAME.toUpperCase()){
			length = 3750;
		}
		this.textArea = new com.ibm.security.modeling.widgets.RequiredTextArea({_messageArea:msgArea,isTextArea:true,id:this.id +value,required:"true",maxLength:length,rows:"5",style:"width:80%; height: auto;",
			startup:function(){//overriding startup as parent of this widget must have class tip to show properly
				if(this.domNode && this.domNode.parentNode){
					dojo.addClass(this.domNode.parentNode,"tip");
				}
				this.inherited("startup", arguments);
		}}); 
		//test approach
		this.textArea.extractValue = dojo.hitch(this,this.extractValue);
		this.textArea.setEditValue = dojo.hitch(this,this.setEditValue);
		this.textArea.widgetValidator = dojo.hitch(this,this.validate);
		
	    return this.textArea;
	},
	
	extractValue:function(){
		var dataObject={};
		
		dataObject.attributeId = this.item.id;
		dataObject.attributeName=this.item.attributeName;
		dataObject.type=this.item.type;
	    dataObject.value= this.extractSelf();
		return dataObject;
	},
	extractSelf:function(){
	    var stringValue = (this.textArea.getValue()||" ").trim();
	    return [stringValue] ;
	},
	setEditValue:function(item){
		 var htmlData = item.value;
        this.textArea.attr("value",htmlData);
        
     },
     validate:function(byPassTest){
          var validationObject={valid:true,message:""};
        //check Emptyness
        var value = this.extractSelf();
        
        if(!("EMPTYNESS"in byPassTest)){
        	validationObject.valid = this.validator.checkEmptyValues(value);
            validationObject.message = this.pluginResources.PLUGIN_REST_ATTRIBUTE_REST_ATTRIBUTE_VALUE_MISSING;
        }
            
        if(validationObject.valid){
            var length= 240;
            var DYNAMIC_ROLE_RULE_DEFINITION_ATTRIBUTE_NAME="Identity Manager Rule Definition";
            if(this.item.attributeName.toUpperCase() == DYNAMIC_ROLE_RULE_DEFINITION_ATTRIBUTE_NAME.toUpperCase()){
                length = 3750;
            }
            validationObject.valid = this.validator.checkMaxLength(value[0], length);
			var msgStr = this.pluginResources.PLUGIN_REST_ATTRIBUTE_ADD_STRING_EXCEEDS_MAX.replace("{0}", this.item.attributeName);
			validationObject.message = msgStr;

        }
        
        return validationObject;
     }
});

dojo.declare("com.ibm.security.modeling.notebook.AttributeDialogTextField", com.ibm.security.modeling.notebook.AbstractFactory, {
    
	validator : new com.ibm.security.modeling.util.Validator(),
	 constructor:function(args){
        this.properties = args;
        this.item = this.properties.item;
        this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
        this.id=(this.properties&&this.properties.id)?this.properties.id:"id";
      
    },
	getWidget:function(value,args){
       var msgArea = (args && args.msgArea)?args.msgArea:(this.properties && this.properties.msgArea)?this.properties.msgArea:null;
	 this.textbox = new ibm.tivoli.tip.dijit.NumberInputBox({
	 	//
	 	//The setStatus method is overridden here to avoid the 
	 	//tooltip from being displayed for the Integer Type attribute value.
	 	//
	 	setStatus: function(status){
	 		status.message = "";
	 		this.inherited("setStatus", arguments);
	 	},
		startup:function(){//overriding startup as parent of this widget must have class tip to show properly
			if(this.domNode && this.domNode.parentNode){
				dojo.addClass(this.domNode.parentNode,"tip");
			}
			this.inherited("startup", arguments);
		},
	 	id:this.id +value,
	 	required:"true",
	 	style:"height:20px"});
	   
	   this.textbox.extractValue = dojo.hitch(this,this.extractValue);
	   this.textbox.setEditValue = dojo.hitch(this,this.setEditValue);
	   this.textbox.widgetValidator = dojo.hitch(this,this.validate);
	   
	   return this.textbox;
	},
	extractValue:function(){
		
		
		var dataObject={};
		dataObject.attributeId = this.item.id;
		dataObject.attributeName=this.item.attributeName;
		dataObject.type=this.item.type;
	    dataObject.value= this.extractSelf();
		return dataObject
	},
	extractSelf:function(){
	    var value = this.textbox.getValue();
	    if(isNaN(value)) value = null;
	    else value = value.toString();
	    return [value];
	},
	 setEditValue:function(item){
        
        this.textbox.attr("value",item.value);
         
    },
    validate:function(byPassTest){
    	 var validationObject={valid:true,message:""};
        //check Emptyness
    	 
    	 if(!("EMPTYNESS"in byPassTest)){
    		 validationObject.valid = this.validator.checkEmptyValues([this.textbox.getTextValue()]);
    	        validationObject.message = this.pluginResources.PLUGIN_REST_ATTRIBUTE_REST_ATTRIBUTE_VALUE_MISSING;
         }
       
        //checks for an integer
        if(validationObject.valid){
            //invalid value
        	validationObject.valid = !(isNaN(this.textbox.getValue()));
        	
            validationObject.message = this.pluginResources.PLUGIN_REST_ATTRIBUTE_ADD_INTEGER_INVALID.replace("{0}", this.textbox.getTextValue());
       
        }
        //checks the limit
        if(validationObject.valid){
            //out of limit for int
            validationObject.valid = this.validator.intValidValue(this.textbox.getValue());
            validationObject.message = this.pluginResources.PLUGIN_REST_ATTRIBUTE_ADD_INTEGER_INVALID.replace("{0}", this.item.attributeName);
       
        }
      //if emptyness is allowed then empty value will be considered as correct int value
    	if("EMPTYNESS"in byPassTest) validationObject.valid =( this.textbox.getTextValue().trim()=='');
        return validationObject;
    }
});


dojo.declare("com.ibm.security.modeling.notebook.AttributeDialogTable", com.ibm.security.modeling.notebook.AbstractFactory, {
	validator : new com.ibm.security.modeling.util.Validator(),
   constructor:function(args){
    this.properties = args;
    this.item = this.properties.item;
    this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
     this.id=(this.properties&&this.properties.id)?this.properties.id:"id";
     this.editMode=(this.properties&&this.properties.editMode)?this.properties.editMode:false;
     },
	  
		
	getWidget:function(value){
		  
		dojo.require("com.ibm.security.modeling.api.UserRestManager");
		var schemaRestMgr= new com.ibm.security.modeling.api.UserRestManager();
        var store = schemaRestMgr.getIsrmTableRestStore();
        var editMode=this.properties.editMode;

		dojo.require("com.ibm.security.modeling.tables.UserTable");
		this.table = new com.ibm.security.modeling.tables.UserTable(
		{
			id : this.id +"_attributeUserTable"+ value,
			isMultiSelect:!this.editMode,
			dataStore:store
		});
		this.table.extractValue = dojo.hitch(this,this.extractValue);
		this.table.widgetValidator = dojo.hitch(this,this.validate);
		return this.table;
	},
	extractValue:function(){
		
		
		var dataObject={};
		dataObject.attributeId = this.item.id;
		dataObject.attributeName=this.item.attributeName;
		dataObject.type=this.item.type;
	     dataObject.value = this.extractSelf();
		return dataObject;
	},
	extractSelf:function(){
	    return this.table.getSelectedItems();
	},
	validate:function(byPassTest){
	    
	    	 
	    var validationObject={valid:true,message:''};
	    var items = this.extractSelf();
	    if(!("EMPTYNESS"in byPassTest)){
	    	if(items==null || items.length == 0){
	   	     
	            //check Emptyness
	            validationObject.valid = false;
	            validationObject.message = this.pluginResources.PLUGIN_REST_ATTRIBUTE_REST_ATTRIBUTE_VALUE_MISSING;
	    	    }
        }
	    
	    return validationObject;
	}
		
		
});


dojo.declare("com.ibm.security.modeling.notebook.AttributeDialogTopology", com.ibm.security.modeling.notebook.AbstractFactory, {
	validator : new com.ibm.security.modeling.util.Validator(),
    constructor:function(args){
        this.properties = args;
        this.item = this.properties.item;
        this.id=(this.properties&&this.properties.id)?this.properties.id:"id";
        this.editMode=(this.properties&&this.properties.editMode)?this.properties.editMode:false;
        this.connections=[];
        this.subscriptions=[];
        this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
        this.logMessages = dojo.i18n.getLocalization("com.ibm.security.modeling", "LogMessages");
        this.dataSetFactory=new com.ibm.security.modeling.topology.TopologyDataSets();
        this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.notebook", "AttributeDialogText");
        //just to prevent pii hit , using other nls files 
        this.tempLocalResources = dojo.i18n.getLocalization("com.ibm.security.modeling.notebook", "AttributePanelText");
        this.subscriptions.push(dojo.subscribe("RoleHierarchTopologySwitchTableView", dojo.hitch(this,this._setUpTopologyTable)));
    },
   destroy:function(){
       dojo.forEach(this.subscriptions,function(handle){dojo.unsubscribe(handle)});
       dojo.forEach(this.connections,function(handle){dojo.disconnect(handle)});
       
   },
	getWidget:function(value,args){
	   	this.messsageArea = (args && args.msgArea)?args.msgArea:(this.properties && this.properties.msgArea)?this.properties.msgArea:null;
		this.value=value;
	    this.stackContainer= new com.ibm.security.modeling.dijit.layout.StackContainer({
		        id:this.id+"_stackContainer"+value
		    }); 
		dojo.addClass(this.stackContainer.domNode,"contentArea");  
		var storeUri = (args && args.storeUri)?args.storeUri:(this.properties && this.properties.storeUri)?this.properties.storeUri:null;
		this.attributeURL=storeUri  +"/"+ value;
		this._setUpTopologyTable(value);
		this.stackContainer.widgetValidator = dojo.hitch(this,this.validate);
		this.stackContainer.extractValue = dojo.hitch(this,this.extractValue);
		return this.stackContainer;
	},
	_attributeCountAllowedForTopology:1000,
	switchtotopology:function(value){
		var projUtil = new com.ibm.security.modeling.projects.ProjectUtil();
		var countOnlyUrl=this.attributeURL +'/?countOnly=true';
		var attributeCount = projUtil.getCountOnlyInfo(countOnlyUrl);
	
		if(projUtil.getCountOnlyErrorMessage() == null){
			if(attributeCount > this._attributeCountAllowedForTopology){
				this.messsageArea.hideMessages();
				this.messsageArea.showInfoMessage(this.logMessages.COUNT_EXCEEDED_FOR_TOPOLOGY);
			}else {	
				if(this.stackContainer.getChildren().length==2){
					this.stackContainer.forward();
					return;
				}
				this._setUpTopologyView(value);
			}	
			
		}else {
			this.messsageArea.hideMessages();
		 	this.messsageArea.showErrorMessage(projUtil.getCountOnlyErrorMessage());		 
		 }	
	},
	
	_setUpTopologyView:function(value){		
		dojo.require("com.ibm.security.modeling.topology.HierarchicalAttributeTopologyFactory");
		var factory= new com.ibm.security.modeling.topology.HierarchicalAttributeTopologyFactory();
		var menuProvider=factory.createMenuProvider();
		
		var dataset = this.dataSetFactory.createHierarchyAttributeDataSet(value,value,value, true);
		dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyView");
		var navWidget = new ibm.tivoli.tip.navwidget.topology.dijit.TopologyView(
			{
				id:this.id + value,
				dataset: dataset,
				cmProvider:menuProvider,
				widgetDefinitionId: "HierarchicalRoleAttrTopology-0.1.0"
			}
			
		);
		this.connections.push(dojo.connect(navWidget,"_createToolbar",this,function(){
			com.ibm.security.modeling.topology.TopologyUtil.updateTopologyButtonLabels(navWidget) ;
		}));
		this.stackContainer.addChild(navWidget);
		this.stackContainer.selectChild(navWidget);		
		
		//Since we dont have other option to remove default height
		if(dojo.isFF && navWidget._canvas && navWidget._canvas.domNode){
			dojo.style(navWidget._canvas.domNode, {height: ""});	
		}
	},
	_setUpTopologyTable:function(value){
	
		if(this.stackContainer.getChildren().length==2){
		  this.stackContainer.forward();
		  return;
		}
		var attributeValueStructure = [
										{field : 'value',name : this.localResources.HEADER_COLUMN_0,width : '20%' },
										{field : 'description',name : this.localResources.HEADER_COLUMN_1,width : '30%'},
										{field : 'children',name : this.localResources.HEADER_COLUMN_2,width : '30%'},
										{field : 'parent',name : this.localResources.HEADER_COLUMN_3,width : '20%'}
									  ];
								
							var store = new com.ibm.security.modeling.tables.JsonRestStore( {
							target : this.attributeURL,
							idAttribute : "id"
							});
							
			//Override the getValue method of the store
			var self = this;
			var extractStoreValue = function(item){
					var retValue = "";
					if(item){
						if(item.length > 0){
							for(var i = 0; i < item.length; i++){
								if(item[i].value){
									retValue += item[i].value;
								}
								retValue += ",";
							}
							retValue = retValue.slice(0, retValue.length - 1);
						}else{
							if(item.value)
								retValue = item.value ;
						}
					}
					return retValue;
			};
			var getValue = store.getValue;
			store.getValue = function(/*Object*/item, /*String*/property, /*value?*/defaultValue) {
				var value = getValue(item, property, defaultValue);
				
				if(property == 'parent'){
					var parentItem = item.parent;
					var parentValue = extractStoreValue(parentItem);
					return parentValue;
				}else if(property == 'children'){
					var childItem = item.children;
					var childValue = extractStoreValue(childItem);
					return childValue;
				}
				
				return value;
			};
			//id can be commented but just kept for ease of testing , and hence this.value is kept
			var table = new com.ibm.security.modeling.tables.Table(
					{
						dataStore: store, 
						id:this.id+"_attributeTopologyTable"+this.value,
						structure: attributeValueStructure, 
						isClientSide: true,
						isFilterRendered: true,
						isRefreshRendered: true,
						isMultiSelect: !this.editMode,
						autoHeight: false,
						isDynamic: true,
						entityTypeText:this.tempLocalResources.PANEL_TITLE
					
					});
		    dojo.addClass(table.domNode,"fullSize"); 
			table.addToolbarButton(this.localResources.SWITCHTOTOPOLOGY, false,"hierarchicalLayoutIcon", dojo.hitch(this,this.switchtotopology,value),this.id + "_edit"+this.value, true, true, true);
			dojo.connect(table.grid.selection, "onSelected", this,"_clearMessages");
			dojo.connect(table.grid.selection, "onDeselected", this,"_clearMessages");
			this.stackContainer.addChild(table);
			this.connections.push(dojo.connect(this.stackContainer,"destroy",this,"destroy"));
			this.stackContainer.forward();
	},
	
	_clearMessages:function(){
		this.messsageArea.hideMessages();
	},
	extractValue:function(){

		var dataObject={};
		dataObject.attributeId = this.item.id;
		dataObject.attributeName=this.item.attributeName;
		dataObject.type=this.item.type;
	    dataObject.value=this.extractSelf();
		return dataObject;
	},
	extractSelf:function(){
	    var values=[];
		        //widget would be a stackContainer
		        var seletedWidget = this.stackContainer.selectedChildWidget;
		        var selectedItems=null;
		        
		        if(seletedWidget.grid) {
		        	selectedItems=seletedWidget.getSelectedItems();
		         }
		        else {
		        	selectedItems=seletedWidget._canvas.selection.getItems();
		         }
		        
		        for(var i=0;i<selectedItems.length;i++){
		        
		        //resonstructing item so that it match slightly to the store 
		        var item = selectedItems[i]._item||selectedItems[i] ;
		        item.name=item.label||item.value;
		        //faking id , for topology view , as uri is currently not sent by server
		        item.uri = item.uri||"id://"+item.id;
		        values.push(item);
		        }
		        return values;
	},
	validate:function(byPassTest){
	    
	    var validationObject={valid:true,message:''};
	    var items = this.extractSelf();
	    
	    if(!("EMPTYNESS"in byPassTest)){
	    	if(items==null || items.length == 0){
	   	     
	            //check Emptyness
	            validationObject.valid = false;
	            validationObject.message = this.pluginResources.PLUGIN_REST_ATTRIBUTE_REST_ATTRIBUTE_VALUE_MISSING;
	    	    }
        }
	    return validationObject;
	    
	    
	}
});


