dojo.provide("com.ibm.security.modeling.notebook.RolePanelLauncher");

dojo.require("com.ibm.security.modeling.controller.PanelLauncher");

dojo.declare("com.ibm.security.modeling.notebook.RolePanelLauncher", com.ibm.security.modeling.controller.PanelLauncher, {
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.notebook.RolePanelLauncher"),
	roleUrl: null,
	panelStack: null,
	titleName: null,
	initialPanel: null,
	fileName: "ui_role_details_notebook.html",
	tabs: {
		ERROR_WARNING: "errorWarning"
	},
	
	constructor: function(panelStack, contentPane, panelWidget, roleUrl, initialPanel, projectUrl, modelId) {
		this._trace.entering("Role Uri: "+roleUrl+", ProjectUrl: "+projectUrl+", Model ID: "+ modelId, "constructor");
		this.roleUrl = roleUrl;
		this.contentPane = contentPane;
		this.panelWidget = panelWidget;
		this.titleName = this.panelWidget.getTitle();
		this.initialPanel = initialPanel;
		this.breadcrumbArgs = {
			context: this.panelWidget,
			hideFunction: "_navigateAway",
			canHide: dojo.hitch(this.panelWidget, this.panelWidget.canHide),
			label: this.titleName
		};
		this.roleAnalysisData = {
			roleUrl: roleUrl,
			projectUrl: projectUrl,
			modelId: modelId
		};		
		this.panelWidget.launcher = this;
		this._trace.exiting("Role Uri: "+roleUrl, "constructor");
	},

	launch:function() {
		this._trace.entering(this.roleUrl, "launch");
		//Event is published to add/update breadCrumb , doing this after creation 
		//causes timing issue between creation and updation , e.g sometimes update happen before creation 
		this.publishPanelChangedEvent(this.breadcrumbArgs, dojo.config.panels.ROLE.id, this.roleAnalysisData);
		this.inherited(arguments, [this.contentPane, this.titleName, this.fileName]);
		if (!this.panelWidget.isNew && this.roleUrl) {			
			this.panelWidget.refreshBasicData(this.roleUrl, this.isDefaultingToErrorWarningTab(), /*populateAllPanels*/false);
			this._selectInitialTab();
		} 
		
		
		if (this.panelWidget.isNew) {
			this.panelWidget.startResizeChain();
			this.panelWidget.isNew = false;
		}
		this._trace.exiting(this.roleUrl, "launch");
	},
	
	_selectInitialTab:function() {
		try {
			this.panelWidget.setIgnorePopulateOnTabChange(true);
			if (this.isDefaultingToErrorWarningTab()) {
				this.panelWidget.selectErrorWarningTab();
			} else {
				this.panelWidget.selectGeneralTab();
			}
		} finally {
			this.panelWidget.setIgnorePopulateOnTabChange(false);
		}
	},
	
	isDefaultingToErrorWarningTab:function() {
		return this.initialPanel === this.tabs.ERROR_WARNING;
	}
});