/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

 Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.notebook.RoleTypeStore");

dojo.require("dojox.data.JsonRestStore");

dojo.requireLocalization("com.ibm.security.modeling", "RoleTypeText");

dojo.declare("com.ibm.security.modeling.notebook.RoleTypeStore", dojox.data.JsonRestStore, {
	resources: null,
	constructor: function(options) {
		this.resources = dojo.i18n.getLocalization("com.ibm.security.modeling", "RoleTypeText");
	},	
	_processResults: function(results, deferred) {
		var totalCountResult = 0;
		if ((results != null) &&
			(results.length != null)) {
			totalCountResult = results.length;
			for (var i = 0; i < results.length; i++) {
				var type = results[i];
				var typeName = type.name;
				var typeTranslatedName = this.resources[typeName.toUpperCase()];
				if (typeTranslatedName == null) {
					typeTranslatedName = typeName;
				}
				type.translatedName = typeTranslatedName;
			}
			results.sort(this._sortType);
		}
		return {totalCount: totalCountResult, items: results};
	},
	_sortType: function(a, b) {
		var result = 0;
		var aTranslatedName = a.translatedName;
		var bTranslatedName = b.translatedName;
		if (aTranslatedName < bTranslatedName) {
			result = -1;
		} else if (aTranslatedName == bTranslatedName) {
			result = 0;
		} else {
			result = 1;
		}
		return result;
	}
});