/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

© Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.notebook.SODHelperClasses");
dojo.require("com.ibm.security.modeling.util._DialogUtilities");
dojo.require("com.ibm.security.modeling.widgets.IsrmDialogBase");

dojo.declare("com.ibm.security.modeling.notebook.MemberConflictDialog",
		com.ibm.security.modeling.widgets.IsrmDialogBase,{	
			
	templatePath : dojo.moduleUrl("com.ibm.security.modeling.notebook","templates/MemberConflictDialog.html"),
	widgetsInTemplate : true,
	heightFactor:1.8,
	widthFactor:1.4,
	minHeight:300,
	
	constructor:function(){
	  this.helpFile="ui_role_details_sod_user_conflict.html"  
	},
	 postMixInProperties:function(){
		
		
	    this.inherited(arguments);
        this.dialogTitle = this.localResources.CONFLICT_TITLE;
        this.dialogInstruction="";
        
    },
    postCreate : function() {
		this.inherited(arguments);                 
		this.closeButton = this.addCommonButton({
								onClick:dojo.hitch(this, this.onCancel),
								type:"CLOSE"
							});
		this._IsrmDialog.autofocus = false ;
	 	
},
	startup:function(){
		this.inherited(arguments);
		
		
		this.pane = new com.ibm.security.modeling.notebook.newPane({
								localResources:this.localResources,
								globalResources:this.globalResources,
								target:this.target								
							  },dojo.byId(this.id+"_PaneContent"));
		this.pane.startup();
		this.pane.populate();
		
	}
	
});


dojo.declare("com.ibm.security.modeling.notebook.newPane",
				[ dijit._Widget, dijit._Templated],{
	input:null,
	callback:null,
	add:null,
	localResources:null,	
	 widgetsInTemplate : true ,
	
	//templateString:" <div ><p class='TUIG_description'>${localResources.CONFLICT_INSTRUCTIONS}<p><div style='width:95%;height:70%;'><div id='MemberConflict' ></div></div></div>",
	
	templateString:	"<div>"+
			    "<div dojoType='com.ibm.security.modeling.dijit.layout.BorderContainer' dojoAttachPoint='container' class='contentArea' gutters='false' style='overflow: auto;'>"+
					"<div dojoType='com.ibm.security.modeling.dijit.layout.ContentPane' region='top'>"+
						
						"<p class='TUIG_description'>${localResources.CONFLICT_INSTRUCTIONS}</p>"+
					       
					"</div>"+

			 	      " <div dojoAttachPoint='TableContainer' dojoType='com.ibm.security.modeling.dijit.layout.ContentPane' region='center' style='width:100%;height:70%'>"+
						"<div    id='MemberConflict'></div>"+
					"</div>"+
			
						
				"</div>"+
			"</div>",

        postCreate : function() {
						//this._trace.entering("", "postCreate");
						this.inherited(arguments);
						dojo.addClass(this.domNode, "fullSize");						
						this.connect(this.container, "resize", "_resizePanels");
						//this._trace.exiting("", "postCreate");
					},
	startup:function(){
		this.inherited(arguments);
		
	},
	_resizePanels: function() {
						this.TableContainer.resize();
					},
	populate:function(){
		this.setTable();
		this.table.startup();
	},
	destroy:function(){
		//this.table.destroy();
		this.inherited(arguments);
	},
	setTable:function(){		    
								this.sodTableStructure = [
										{field : 'identity',name : this.localResources.CONFLICT_HEADER_COLUMN_0,width : '45%',formatter:function(identity){return com.ibm.security.modeling.util.HtmlEscapingUtils.parseHTMLTag(identity.name);}},
										{field : 'roles',name : this.localResources.CONFLICT_HEADER_COLUMN_1,width : '45%'}
								];
		this.store=new 	com.ibm.security.modeling.tables.JsonRestStore({
			target:this.target,
			idAttribute:"noId"
		});
		var getValue=this.store.getValue;
		this.store.getValue = function(/*Object*/ item, /*String*/property, /*value?*/defaultValue){
		    var value = getValue(item,property,defaultValue);
		    if(property == 'roles'){
				var roles = value;
				var roleString ="" ;
				for(var i=0;i<roles.length;i++){
						roleString +=roles[i].name+",";
				}
																	
				return roleString.substring(0,roleString.length-1);
			}
            return value;
		};
		
		
		
		
		
		
								this.table = new com.ibm.security.modeling.tables.Table(
										{
											id : this.id + "_conflictTable",
											dataStore : this.store,
											structure : this.sodTableStructure,
											isClientSide : false,
											isFilterRendered : true,
											isRefreshRendered : false,
											isMultiSelect : true,
											isDynamic:true,
											autoHeight:false,
											needSelection:false,
											isSelectAllRendered:false,
											entityTypeText:this.globalResources.USERS,
											searchInstructions: this.localResources.SOD_CONFLICTS_DIALOG_SEARCH_INSTRUCTIONS

										}, dojo.byId("MemberConflict"));
							
				                             dojo.addClass(this.table.domNode,"contentArea");
	}
					
});
