/*
Licensed Materials - Property of IBM

Role and Policy Modeler

� Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.projects.ProjectCreationWelcomePanel");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.security.modeling.dijit.layout.ContentPane");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("com.ibm.security.modeling.layouts.TemplatedPanelWithLayout");

dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling", "PluginMessages");
dojo.requireLocalization("com.ibm.security.modeling.projects", "ProjectCreationWelcomePanelText");
dojo.declare("com.ibm.security.modeling.projects.ProjectCreationWelcomePanel",
        [ com.ibm.security.modeling.layouts.TemplatedPanelWithLayout ],
{
	
	templatePath: dojo.moduleUrl("com.ibm.security.modeling.projects","templates/ProjectCreationWelcomePanel.html"),
	widgetsInTemplate:true,
	// globalResources: Object
	//		The global resource bundle
	globalResources: null,
	// localResources: Object
	//		The resource bundle for this widget set
	localResources: null,
	// messageResources: Object
	//      The resource bundel for TMS messages
	messageResources: null,
	// wizardResources: Object
	//		The resource bundle for the overall project creation wizard
	// namespace: String
	//		The identifier for the current portlet
	namespace: "",
	//		Message area for error display
	messageArea: null,
	image_path: dojo.moduleUrl("com.ibm.security.modeling.projects","../themes/images"),
	
	constructor: function (args) {
		// summary:
		//		Widget that provides the UI for the user and resource selection page.
		// description: 
		//			this widget sets up the selection widgets and behavior
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
		this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.projects", "ProjectCreationWelcomePanelText");
		this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
	},
	
	postCreate: function() {
		this.inherited(arguments);
		dojo.addClass(this.domNode,"fullSize");
		
	},
	
	getHelpFileName: function(){
	
		return "ui_projects_home.html";
	},
	
	destroy: function()	{
		this.inherited(arguments);
	}
			
	
});