/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

� Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.security.modeling.projects.ProjectMessagesDialog");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("dijit._Container");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("com.ibm.security.modeling.widgets.ErrorsWarningsDialog");
dojo.require("com.ibm.security.modeling.tables.Table");
dojo.require("com.ibm.security.modeling.util._DialogUtilities");
dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling.projects", "ProjectMessagesDialogText");
dojo.declare("com.ibm.security.modeling.projects.ProjectMessagesDialog", com.ibm.security.modeling.widgets.ErrorsWarningsDialog, {
	
	projectItem:null,
	
	constructor : function() {
		
		this.globalResources = dojo.i18n.getLocalization(
				"com.ibm.security.modeling", "GlobalText");
		this.localResources = dojo.i18n.getLocalization(
				"com.ibm.security.modeling.projects", "ProjectMessagesDialogText");
		
		this.inherited(arguments);
	},
	//method take care of , whether this is session error/warning or file error/warning
	postMixInProperties:function(){
		this.inherited(arguments);
	  	this.entityTypeName=this.localResources.PROJECT;
  		this.entityTypeValue=this.projectItem.name; 
	    this.entityValue= this.projectItem.status;
  		this.dialogTitle=this.localResources.DIALOG_TITLE;
  		this.storeUri = this.projectItem.messagesURI;
       	this.dialogInstruction=this.localResources.DIALOG_INSTRUCTION;
        this.searchInstructionsText = this.localResources.SEARCH_PROJECT_MESSAGES;
        this.entityTypeText=this.localResources.PROJECT_STATUS;
   	    this.entityTypeTableText=this.localResources.ENTITY_PROJECT_MESSAGES;
    	this.entityTypeNameLabelTextMarginClass="projectLabelTextMargin"; 
    	this.tableArgs={
    			defaultSortIndex : 2,
    			isDefaultSortAscending:false,
    			toolTipRequired : [ 'description' ]
    	},
	   	this.errorTableStructure = [
								{field : 'severity',name : this.localResources.HEADER_COLUMN_0,width : '10%',formatter : dojo.hitch(this,this.formatSeverity)},									
								{field : 'description',name : this.localResources.HEADER_COLUMN_1,width : '75%',get:function(rowIndex,item){return item;},toolTipFormatter:dojo.hitch(this, this.formatMessage),formatter:dojo.hitch(this, function(item, rowIndex, cell){
									return com.ibm.security.modeling.tables.FormatterUtils.formatLongCellValue(this.formatMessage(item, rowIndex, cell));
								})},
								{field : 'timeStamp',name : this.localResources.HEADER_COLUMN_2,width : '15%', isSearchable : false}
							];
		this.helpFile="ui_projects_status.html";	  
		
	},
	
	postCreate : function() {
		this.inherited(arguments);
		//If I remove the below line the table touches the bottom
		//TODO: remove this line and see if the issue can be addressed at the template level
		dojo.addClass(this.domNode, "contentArea");
	}
});
