/*
Licensed Materials - Property of IBM

Role and Policy Modeler

 Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.projects.ProjectsRestStore");

dojo.require("dojox.data.JsonRestStore");

//dojo.requireLocalization("com.ibm.security.modeling", "IdentityAttributeText");

dojo.declare("com.ibm.security.modeling.projects.ProjectsRestStore", dojox.data.JsonRestStore, {
	resources: null,
	_projects: null,
	schema:{"description":"A Project","type":"object",				
					"properties": {
						"uri":{"type":"string","format":"url"},
						"id":{"type":"integer"},
						"name":{"type":"string"},
						"description":{"type":"string"},
						"status":{"type":"string"},
						"coveragePercentage":{"value":"number"},
						"coveredPoliciesCount":{"type":"integer"},
						"sodRoleConstraintCount":{"type":"integer"},
						"coveredRolesCount":{"type":"integer"}
					}
			},
	constructor: function(options) {
		//this.resources = dojo.i18n.getLocalization("com.ibm.security.modeling", "IdentityAttributeText");
	},	
	_processResults: function(results, deferred) {
		var totalCountResult = 0;
		if ((results != null) &&
			(results.length != null)) {
			totalCountResult = results.length;
			/*for (var i = 0; i < results.length; i++) {
				var userAttribute = results[i];
				var userAttributeName = userAttribute.name;
				var userAttributeTranslatedName = this.resources[userAttributeName.toUpperCase()];
				if (userAttributeTranslatedName == null) {
					userAttributeTranslatedName = userAttributeName;
				}
				userAttribute.translatedName = userAttributeTranslatedName;
			}*/
			//results.sort(this._sortIdentityAttribute);
		}
		return {totalCount: totalCountResult, items: results};
	},
	_sortIdentityAttribute: function(a, b) {
		var result = 0;
		var aTranslatedName = a.translatedName;
		var bTranslatedName = b.translatedName;
		if (aTranslatedName < bTranslatedName) {
			result = -1;
		} else if (aTranslatedName == bTranslatedName) {
			result = 0;
		} else {
			result = 1;
		}
		return result;
	},
	isProjectNameExist: function(projectname){
		var returnVal = false;
		//If the projects are already loaded, dont want to again make REST call unnecessarily on each click.
		if(this._projects == null){
			var attritems;
			var fx = function(items, request){
				  attritems = items;
				};
			var request = this.fetch({onComplete: fx});
			if(attritems == null){
				throw("Rest API failed.");
			}
			this._projects = attritems;
		}
		
		for(i=0; i<this._projects.length; i++){
			var name = this.getValue(this._projects[i], "name");
			if(projectname == name){
				returnVal = true;
				break;
			}
		}
		return returnVal;
	}
});