dojo.provide("com.ibm.security.modeling.tables.CommonTableToolbar");

dojo.require("ibm.tivoli.tip.dijit.TIPTableToolbar");

dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");

dojo.declare("com.ibm.security.modeling.tables.CommonTableToolbar", ibm.tivoli.tip.dijit.TIPTableToolbar, {
	templatePath: dojo.moduleUrl("com.ibm.security.modeling.tables.","templates/CommonTableToolbar.html"),
	// shownub: boolean
	//		Overrides this setting from the TIPTableToolbar because its not needed(or wanted) in our implementation
	shownub: false,
	// globalResources: Object
	// 		Global resource bundle for common table text
	globalResources: null,
	// isSearchMultiSelect: boolean
	//		Indicates whether selection mode of the search columns of search field is single or multi
	isSearchMultiSelect: true,	  
	constructor: function(args) {
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
	},
	postCreate:function() {
		// tags:
		// 		protected
		this.inherited(arguments);
		this.connect(this.searchButton, "onClick", this._searchButtonClicked);
	},
	setSearchDisable:function(){
		if (this.searchField) {
			this.searchField.setDisable();
		}
		if (this.searchButton) {
			this.searchButton.attr("disabled",true);
		}
	},
	setSearchEnable:function(){
		if  (this.searchField) {
			this.searchField.setEnable();
		}
		if (this.searchButton) {
			this.searchButton.attr("disabled",false);
		}
	},
	_searchButtonClicked: function() {
		if (this.searchField && this.searchField.isSearchFieldFocused()) {
			// on click should have moved the focus away from search input field.
			// But it does not happen in correct order on IE. Hence update the search edited flag. 
			this.searchField.updateSearchEdited();
		}
	}

});