/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

�  Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.security.modeling.tables.GlobalRoleTable");

dojo.require("com.ibm.security.modeling.tables.RoleTable");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.tables.GlobalRoleTable", com.ibm.security.modeling.tables.RoleTable, {
	
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.tables.GlobalRoleTable"),
	postMixInProperties:function() {
		this.isClientSide=false;
		this.isFilterRendered=true;
		this.isRefreshRendered=false;
		this.autoHeight = false;
		this.isDynamic = true;
		this.isMultiSelect = true;
		this.defaultSortIndex = 1;

		if (this.structure == null || !this.structure || this.structure == undefined) {
			this.structure = this._getStructure();
		}
				
		this.inherited(arguments);//this needs to be called after isDynamic is set
		this.unSortableColumns = [4,5];
		this.isSelectAllRendered = false;
	},
	postCreate:function() {
		this.inherited(arguments);
	},
	_getStructure: function() {
		return [
	        {field: 'name',name: this.globalResources.ROLE,width: '25%'}, 
    		{field: 'description',name: this.globalResources.DESCRIPTION,width: '25%'},
    		{field: 'parents',name: this.globalResources.PARENT_ROLES,width: '25%',formatter: dojo.hitch(this, this._getParentChildObjectNameCommaSepList), isSearchable:true},
    		{field: 'children',name: this.globalResources.CHILD_ROLES,width: '25%',formatter: dojo.hitch(this, this._getParentChildObjectNameCommaSepList), isSearchable:true}
    	];
	}
	
});