dojo.provide("com.ibm.security.modeling.tables.ToolTipHelper");
dojo.declare("com.ibm.security.modeling.tables.ToolTipHelper",null,{
	
	
	constructor: function(args) {	
	
	    //dojo.mixin(this,args);
	    this.table = args.table;
		this.connections = [];
	    //Construct the tooltip used for this object . 
		this.tooltip = new dijit.Tooltip({
			duration:0,
			id:this.table.id+"_tooltip"
		});
		this._setupTooltips();
		
		
	},
    
   //  Set up various connections over which we need to showToolTip and hide TooTip
     
	_setupTooltips:function() {
		this.canOpen = true;
		this.connections.push(dojo.connect(this.table.grid,"onCellMouseOver",this,"showToolTip"));
		this.connections.push(dojo.connect(this.table.grid,"onHeaderCellMouseOver",this,"showToolTip"));
		this.connections.push(dojo.connect(this.table.grid,"onCellFocus",this,"showToolTip"));
		
		this.tooltip.onShow = function(){
			
			this.canOpen = false;
		};
		this.tooltip.onHide = function(){
			dojo.forEach(this.connections, dojo.disconnect);
			this.connections=[];
		    this.canOpen = true;	
		};
	},
	
	showToolTip:function(e,/* onCellFocus set it */rowIndex){
		//cellmouseover and cellFocus generates different events and parameter
		//hence need to handle
		var cell = (e.cell)?e.cell:e;
		var showToolTip=false;
		var isHeader=false;
		if(e && e.rowIndex === -1 && !this.table._isSelectColumnIndex(e.cellIndex)){
			showToolTip=true;
			isHeader=true;
		}else{
			for (var i =0;i<this.table.toolTipRequired.length;i++){
				if(cell.name===this.table.toolTipRequired[i] ||
					cell.field===this.table.toolTipRequired[i] ||
					cell.index===this.table.toolTipRequired[i]-1){
					showToolTip=true;
				}
			}
		}
		if(showToolTip === true && e.cellNode && e.cellNode.innerHTML) {
			var label="";
			var cellNode="";
			if(isHeader && cell){
				cellNode=e.cellNode;
				if(!cellNode) {return;	}
				if(e.grid && e.grid.structure && e.grid.structure[cell.layoutIndex] && e.grid.structure[cell.layoutIndex].toolTipText){
					label=e.grid.structure[cell.layoutIndex].toolTipText;
				}else{
					label=cell.name;
				}
			}else{
				cellNode = cell.getNode(rowIndex||e.rowIndex);
				if(dojo.isFunction(e.grid.structure[cell.layoutIndex].toolTipFormatter)){
					var item = this.table.grid.getItem(rowIndex||e.rowIndex); 
					var value=cell.get ? cell.get(rowIndex||e.rowIndex, item) : (cell.value || cell.defaultValue);
					label=e.grid.structure[cell.layoutIndex].toolTipFormatter(value,rowIndex||e.rowIndex,cell);
				}else if(cellNode){
					label=cellNode.innerHTML;
				}
			}
			
			this.tooltip.set("label",label);
			try{
				if(this.canOpen){
					
					this.connections.push(dojo.connect(cellNode, "onmouseleave", this,"hideToolTip"));
					this.connections.push(dojo.connect(cellNode, "onblur", this,"hideToolTip"));
					if(cellNode){
						if(cellNode.firstChild && cellNode.firstChild.onclick) this.connections.push(dojo.connect(cellNode.firstChild, "onclick", this,"hideToolTip"));
					}
					this.tooltip.open(cellNode);
				}
			}catch(e){
				this.canOpen = true;
			}
				
			
		}
	},
	//Since the tooltip is constructed in constructor only , so we can safely call close on tooltip object
	//Hide the tooltip 
	hideToolTip:function(e){
		try{
			 this.tooltip.close();
		}catch(e){
			this.tooltip.onHide();
			this.canOpen = true;
		}
		
						
	},
//	
//	 This won't be called automatically , this is destructor for tooltip object .
//	 
	destroy:function(){
		dojo.forEach(this.connections, dojo.disconnect);
		this.tooltip.destroy();
	}
});