dojo.provide("com.ibm.security.modeling.tables._DisabledSelection");

dojo.declare("com.ibm.security.modeling.tables._DisabledSelection", null, {
	_isTrue:function(value) {
		var boolValue = false;
		if (typeof value == 'string') {
			//convert string to boolean.  Assuming true only if the string is "true", otherwise false.
			boolValue = value === "true";
		} else if (typeof value == 'boolean') {
			boolValue = value;
		}
		return boolValue;//boolean
	},

	_setupSelectionLogic: function() {
		if(this.grid.rowSelectCell){
			this.grid.rowSelectCell.disabledIdMap={};//map keeps the ids of diabled rows
		}
		this.connect(this.grid, "onStyleRow", function(rowObject) {
			var item = this.grid.getItem(rowObject.index);
			var isDisabled = false;
			if (item != null && item.directlyAttached != null) {	
				isDisabled = !this._isTrue(item.directlyAttached);
			}
			
			if(this.grid.rowSelectCell.disabledMap[rowObject.index]!=isDisabled)this.grid.rowSelectCell.setDisabled(rowObject.index, isDisabled);
			if(item){
				var itemId = this.grid.store.getIdentity(item);
				if (itemId) this.grid.rowSelectCell.disabledIdMap[itemId]=isDisabled;
			}
		});
		this.grid.rowSelectCell._onSelectionChanged = function(){
			// summary:
			//		Update header selector anytime selection changed		
			if(!this.map[-1] || this.grid._isSelectingRange){ return; }
			var grid = this.grid, headSelector = this.map[-1];
			var disabledCount = 0;
			for (var i in this.disabledMap) {
				if (this.disabledMap[i] == true){
					disabledCount++;
				}
			}
			var enabledCount = grid.rowCount - disabledCount;
			var allSelected = false;
			// handle case where all rows are disabled -- the SelectAll button should be unselected
			if (enabledCount <= 0){
				allSelected = false;
			}else {
				allSelected = grid.rowCount > 0 && enabledCount <= grid.selection.getSelectedCount();
			}

			dojo.toggleClass(headSelector, this.checkedClass, allSelected);
			dijit.setWaiState(headSelector, 'pressed', allSelected);	
			if(this.inA11YMode){
				dojo.attr(headSelector.firstChild, 'innerHTML', allSelected ? this.checkedText : this.unCheckedText);
			}
		};
		this.grid.rowSelectCell._toggletHeader = function(){
			// summary:
			// Toggle state for head selector
			this.grid._isSelectingRange = true;
			var disabledCount = 0;
			for (var i in this.disabledMap) {
				if (this.disabledMap[i] == true){
					disabledCount++;
				}
			}
			var enabledCount = this.grid.rowCount - disabledCount;
			var allSelected = false;
			//handle case where all rows are disabled..
			if (enabledCount <= 0){
				allSelected = false;
			}else {
				allSelected = this.grid.rowCount > 0 && enabledCount <= this.grid.selection.getSelectedCount();
			}

			this.toggleAllSelection(!allSelected);
			this.grid._isSelectingRange = false;
			this._onSelectionChanged();
		};
	
	}
});