dojo.provide("com.ibm.security.modeling.topology.AbstractTopologyFactory");

dojo.require("ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider");

dojo.declare("com.ibm.security.modeling.topology.AbstractTopologyFactory", null, {
	createMenuProviderHelper:function(){},
	createDoubleClickHandler:function(itemId, pageWidget){},
	createDataSet:function(dataSetId){},
	getWidgetDefinitionId:function(){},
	
	createMenuProvider: function() {
		var helper = this.createMenuProviderHelper();
		if (helper) {
			return this._createMenuProviderFromHelper(helper);
		}
	},
	createDoubleClickHelper: function(itemId, pageWidget) {
		var handler = this.createDoubleClickHandler(itemId, pageWidget);
		if (handler) {
			return this._createDoubleClickHelperFromHandler(handler);
		}
	},
	_createMenuProviderFromHelper:function(helper) {
		var cmProvider = new ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider({
	        getMenuItemsCallback: dojo.hitch(helper, helper.getMenuItems),
	        getMenuCommandCallback: dojo.hitch(helper, helper.getMenuCommand)
	    });
		return cmProvider;		
	}, 
	
	_createDoubleClickHelperFromHandler: function(handler) {
		return new ibm.tivoli.tip.navwidget.topology.dijit.DefaultActionHelper({
	        defaultActionCallback: dojo.hitch(handler, handler.handle)
	    });
	}
});