dojo.provide("com.ibm.security.modeling.topology.RoleModelingDoubleClickHandler");

dojo.require("com.ibm.security.modeling.util.Trace");
dojo.require("com.ibm.security.modeling.notebook.RoleNotebookDialogView");

dojo.declare("com.ibm.security.modeling.topology.RoleModelingDoubleClickHandler", null, {
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.topology.RoleModelingDoubleClickHandler"),
	modelId: null,
	constructor: function(modelId) {
		this.modelId = modelId;
	},
	handle:function(context){
		this._trace.entering("", "handle");
		this._trace.object("context", context);
		if(context.selection.getItemCount()==1){
	   		var items=context.selection.getItemIds();
	   		var roleUri=this._getFullRoleUri(this.modelId,items[0]);
	   		this._launchEditRoleDialog(roleUri);
		}else{
			this._trace.error("More than one node selected can't show details", "doubleClickHandler");
		}
	}, 

	_getFullRoleUri:function(modelId,roleId){
		return "/isrm/rest/models/"+modelId+"/roles/"+roleId;
		
	},
	_launchEditRoleDialog:function(roleUri){
		dojo.publish(dojo.config.panels.ROLE.launchEventAddress, [roleUri]);
	}
});