dojo.provide("com.ibm.security.modeling.topology.TopologyBuilder");

dojo.require("ibm.tivoli.tip.navwidget.topology.dijit.TopologyView");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.topology.TopologyBuilder", null,{
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.topology.TopologyBuilder"),
	constructor: function(topologyFactory) {
		this._trace.entering("", "constructor");
		this._trace.object("constructor arg topologyFactory", topologyFactory);
		this.topologyFactory = topologyFactory;
		this.topologyArgs = {};
		this._trace.exiting("", "constructor");
	},
	withId: function(id) {
		this._trace.entering("id: "+id, "withId");
		this.topologyArgs.id = id;
		this._trace.exiting("id: "+id, "withId");
		return this;
	},
	withDataSet: function(dataSetId) {
		this._trace.entering("dataSetId: "+dataSetId, "withDataSet");
		this.dataSetId = dataSetId;
		var dataSet = this.topologyFactory.createDataSet(dataSetId);
		this.topologyArgs.dataset = dataSet;
		this._trace.exiting("dataSetId: "+dataSetId, "withDataSet");
		return this;
	},
	onDiv: function(divId) {
		this._trace.entering("divId: "+divId, "onDiv");
		this.divId = divId;
		this._trace.exiting("divId: "+divId, "onDiv");
		return this;
	},
	onPageWidget:function(pageWidget) {
		this._trace.entering(pageWidget.id, "build");
		this.pageWidget = pageWidget;
		this._trace.exiting(pageWidget.id, "build");
		return this;
	},
	build: function() {
		this._trace.entering("", "build");
		this._trace.object(this.topologyArgs, "build", "topo args at start of build");
		if (this._trace.isFinest()) {
			var topoDiv = dojo.byId(this.divId);
			this._trace.object(topoDiv, "build", "topology div found");			
		}
		this._trace.finest("creating menu provider", "build");
		var menuProvider = this.topologyFactory.createMenuProvider();
		this._trace.object(menuProvider, "build", "Menu Provider");
		if (menuProvider) { this.topologyArgs.cmProvider = menuProvider; }
		this._trace.finest("creating double click handler", "build");
		var doubleClickHelper = this.topologyFactory.createDoubleClickHelper(this.dataSetId, this.pageWidget);
		this._trace.object(doubleClickHelper, "build", "DoubleClickHelper");
		if (doubleClickHelper) { this.topologyArgs.daHelper = doubleClickHelper; }
		this._trace.finest("getting widget def id", "build");
		var widgetDefinitionId = this.topologyFactory.getWidgetDefinitionId();
		this._trace.finest(widgetDefinitionId, "build", "widget definition id");
		if (widgetDefinitionId) { this.topologyArgs.widgetDefinitionId = widgetDefinitionId; }
		this.topologyArgs.id="roleTopology";
		this._trace.object(this.topologyArgs, "build");
		this._trace.finest("creating topo view", "build");
		var topology = new ibm.tivoli.tip.navwidget.topology.dijit.TopologyView(this.topologyArgs, dojo.byId(this.divId) );
		/*this.topologyArgs.dataset.onComplete = function(dataset, kwArgs) {
			topology.setDataset(dataset);
		};*/
		topology.domNode.title="";
		if (menuProvider) {menuProvider.view = topology;}
		//this._trace.object(topology, "build");
		this._trace.exiting("", "build");
		return topology;
	}
});