dojo.provide("com.ibm.security.modeling.util.HelpUtilities");

dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.util.HelpUtilities", null, {
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.util.HelpUtilities"),

	setHelp: function(filename){
		this._trace.entering(filename, "setHelp");
		if(filename){
			this._set_Cookie( 'isrmhelpfile', filename, 30, '/', '', true );
		}else{
			this.unsetHelp();
		}
		this._trace.exiting(filename, "setHelp");
	},
	
	unsetHelp: function(){
		this._trace.entering("", "_unsetHelp");
		//filename = "ui_new_project.html";
		this._unset_Cookie( 'isrmhelpfile');
		this._trace.exiting("", "unsetHelp");
	},
	
	_set_Cookie: function( cookie_name, cookie_value, cookie_expires, cookie_path, cookie_domain, cookie_secure )
	{
		this._trace.entering("", "_set_Cookie");
		// set time, it's in milliseconds
		var today = new Date();
		today.setTime( today.getTime() );
	
		if ( cookie_expires )
		{
			cookie_expires = cookie_expires * 1000 * 60 * 60 * 24;
		}
		var expiry_date = new Date( today.getTime() + (cookie_expires) );
	
		document.cookie = cookie_name + "=" +escape( cookie_value ) +
		( ( cookie_expires ) ? ";expires=" + expiry_date.toGMTString() : "" ) +
		( ( cookie_path ) ? ";path=" + cookie_path : "" ) +
		( ( cookie_domain ) ? ";domain=" + cookie_domain : "" ) +
		( ( cookie_secure ) ? ";secure" : true );
		this._trace.exiting("", "_set_Cookie");
	},
	
	_unset_Cookie: function(cookie_name){
		this._trace.entering(cookie_name, "_unset_Cookie");
		cookie_path = "/";
		cookie_domain = "";
		document.cookie = cookie_name + "=" + ( ( cookie_path ) ? ";path=" + cookie_path : "") + ( ( cookie_domain ) ? ";domain=" + cookie_domain : "" ) + ";expires=Thu, 01-Jan-1970 00:00:01 GMT";
		this._trace.exiting(cookie_name, "_unset_Cookie");
	}
	
	
});