dojo.provide("com.ibm.security.modeling.util.NlsUtilities");

(function() {
	NlsUtilities = {

	isLtr: function() {
		var isLtr = true;
		var body = dojo.body();	
		if (body.dir === "rtl") {
			isLtr = false;
		}
		return isLtr;
	},
	setBodyLanguageDirection: function(contextPath, locale) {
		var direction = "ltr";
		if (this.isLocaleBidi(locale) && this.isBidiLangAvailable(contextPath, locale)) {
			direction = "rtl";
			dojo._bodyLtr = false;
		}
		dojo.body().dir = direction;
	},
	isBidiLangAvailable: function(contextPath, lang) {
		var bidiLangAvailable = false;
		dojo.xhrGet({
			url: contextPath + "/js/src/com/ibm/security/modeling/nls/ar/LogMessages.js",
			handleAs: "javascript",
			failOk: true,
			sync: true,
			handle: function(data, ioargs) {
				if (ioargs.xhr.status == 200) {
					bidiLangAvailable = true;
				}
			}
		});
		return bidiLangAvailable;
	},
	isLocaleBidi: function(locale) {
		var isBidi = false;
		var lang = locale.substring(0, 2);
		if (lang == "he" || lang == "ar") {
			isBidi = true;
		}
		return isBidi;
	}
};

if (djConfig.contextPath && djConfig.locale) {
	NlsUtilities.setBodyLanguageDirection(djConfig.contextPath, djConfig.locale);
}

})();
