dojo.provide("com.ibm.security.modeling.util.TableTransformer");

dojo.declare("com.ibm.security.modeling.util.TableTransformer", null, {
	
	transformRoleItems: function(roleItems){
		// summary:
		//     Transform the roles raw data 
		// roleItems: Object
		//     Object contains reference to the raw role items object
		
		if(this.validateRoleItem(roleItems)){
			var roleList = [];
			for(var i=0;i<roleItems.length;i++){
				roleList.push({
					id: roleItems[i].id,
					name: roleItems[i].name,
					description: roleItems[i].description,
					status: roleItems[i].status});
			}
			return roleList;
		}else{
			throw  "Object not suported";
		}
	},
	
	validateRoleItem: function(roleItems){
		// summary:
		//     Validate role item data to confirm that, transformer understand raw data.
		// roleItems: Object
		//     Object contains reference to the raw role items object
		
		if(roleItems && roleItems.length > 0 && roleItems[0] && roleItems[0].name){
			return true;
		}
		return false;
	}
});