dojo.provide("com.ibm.security.modeling.util.TitleUtilities");

dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.util.TitleUtilities", null, {

	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.util.TitleUtilities"),

	// _titleNode: Dom Element H1
	//			The html element h1 which holds the portlet title
	_titleNode:null,
	
	constructor: function() {
		this._trace.entering("", "constructor");
		
		// globalResources: Object
		//			Reference to the global shared resource bundle
		// this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
	},
	
	// Currently, the findTitleNode would fetch nodes related only to the Projects Portlet.
	// Some more enhancements need to go for supporting the other portlet, if it is desired
	// to use this function.	
	findTitleNode:function() {
		// summary:
		//			finds the title of the portlet and sets the node object to this panel object for future updates.
		// returns:
		//			dom node of the title
		// tags:
		//			private
	
		if ( (this.globalResources == null) || 
			 (this.globalResources == undefined) ) {
			this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
		}

		/* Get the title node for the Projects Portlet. */
		var titleNode = dojo.query("div[id='title.com.ibm.security.modeling.console.projects.window'] h1[name='portletTitleInnerDIV']", parent.document);

		if (titleNode && titleNode[0]) {
			return titleNode[0];
		}
		
		return null;
	},
	
	updateTitle:function(/*String*/ title){
		// summary:
		//			sets the title for this portlet according to the specified text.
	    this._trace.entering(title, "updatePortletTitle");
		var _fontFamily = "Trebuchet MS"; // The prototype uses this font family and manipulating here as the Title is out of scope of IFrame
		if(this._titleNode == null) {
			this._titleNode = this.findTitleNode();
		}
		if(typeof title =="string" && this._titleNode!=null){
			this._titleNode.innerHTML=title;			
			dojo.style(this._titleNode,"fontFamily",_fontFamily);							
		}else{
			this._trace.error(" - Can't update the portlet title", "updatePortletTitle");
		}
		this._trace.exiting(title, "updatePortletTitle");
	},
	
	getHomeTitle:function() {
		var titleNodes = dojo.query("div[id='title.com.ibm.security.modeling.console.home.window'] h1[name='portletTitleInnerDIV']", parent.document);
		var titleNode = "";
		if (titleNodes && titleNodes[0]) {
			titleNode = titleNodes[0];
		}
		return titleNode.innerHTML;
	}
	
});