dojo.provide("com.ibm.security.modeling.util.Trace");

dojo.require("ibm.tivoli.navmodel.Trace");

dojo.declare("com.ibm.security.modeling.util.Trace", ibm.tivoli.navmodel.Trace, {
	
	object: function(/*Object*/dbgObject, /*String*/methodName, /*String?*/text) {
		if (this.isFine()) {
			console.info(this._output("OBJECT", methodName, text));
			if (dojo.isFF) {
				console.dir(dbgObject);
			} else if (dojo.isIE) {
				console.info(this._toObjString(dbgObject));
			}
		} 
	},
	
	_toObjString: function(dbgObject) {
		console.log("obj is " + dbgObject + " and type of dbg object is " + typeof dbgObject);
		if (typeof dbgObject == 'object') {
			var objString = "{\n";
			for(var x in dbgObject) {
				var value = "";
				if (typeof dbgObject[x] == 'function'){
					value = "[function]";
				} else {
					value = dbgObject[x];
				}
				objString += x + ":" + value + ",\n";
			}
			objString += "}";
			return objString;
		} else if (typeof dbgObject == 'array') {
			var arrayString = "[\n";
			dojo.forEach(dbgObject, function(item){
				arrayString += item + ",\n";
			});
			arrayString += "]";
			return arrayString;
		}
	},
		

	exception: function(/*Exception*/dbgException, /*String*/methodName) {
		if (this.isError()) {
			console.error(this._output("ERROR", methodName, dbgException.name + ":" + dbgException.message));
    		console.dir(dbgException);
	    }
	},

	enteringWithStack: function(/*String*/dbgString, /*String*/methodName) {
    	this.entering(dbgString, methodName);
    	if (this.isFinest()) {
    		console.trace();
    	}
    },
	
	stack: function() {
		if (this.isFinest() && dojo.isFF) {			
			console.trace();
		} 
	}


	
});