dojo.provide("com.ibm.security.modeling.util.ValidationUtilities");
dojo.require("dojox.html.entities");

dojo.declare("com.ibm.security.modeling.util.Validator",
				null,{
				    
	MIN_INT:-2147483648,
	MAX_INT: 2147483647,
	checkInt:function(value,args){
		var valid =true, message="";
		if(value instanceof Number) return true ;
		valid = !isNaN(value);
		valid = valid & ( !isNaN(Number(value)) && value.toString().indexOf(".")==-1);
	//	if(!valid)  message=this.pluginResources.PLUGIN_REST_ATTRIBUTE_ADD_INTEGER_INVALID.replace("{0}", attributeName);	
		return valid;	 
		
	},
	intValidValue:function(value,args){
		var valid =true, message="";
		
		valid = (value > this.MIN_INT && value < this.MAX_INT);
		//if(!valid)  message=this.pluginResources.PLUGIN_REST_ATTRIBUTE_ADD_INTEGER_INVALID.replace("{0}", attributeName);
			
		return valid;	 
		
	},
	checkMaxLength:function(value,length,args){
		var valid =true, message="";
		if(value.length>length ) {
	  		valid = false;
	  		//var msgStr = this.pluginResources.PLUGIN_REST_ATTRIBUTE_ADD_STRING_EXCEEDS_MAX.replace("{0}",attributeName);
	  		//message = msgStr.replace("{1}", length);
	  	}
		
		return valid
	},
	checkEmptyValues:function(values,args){
	    var valid = true;
	    if(values.length==0) return false;
	    for(var i in values){
	        valid = this.checkEmptyValue(values[i],args);
	        if(!valid) break;
	    }
	    return valid;
	},
	checkEmptyValue:function(value,args){
		
		
		
		var valid =true, message="";
		//exception will be thrown when trim function is not there for value
		
		if(value==null) valid=false;
		
		//empty array or string
		if(valid && value.length==0 ) {
			  valid=false;
		 }
		 
		//empty string
		try{
		    value=value.trim();
		    if(value.length==0) valid = false;
		}catch(e){
		    
		}
	 
		
		 
		 return valid;
		
	},
	
	escapeHTMLAndScriptTags: function(inputString) {
		outputString = inputString.replace(/</g, "&lt;").replace(/>/g, "&gt;");
		return outputString;
	},
	
	escapeUnwantedTags: function(inputString) {
		outputString = this.escapeHTMLAndScriptTags(inputString);
		return outputString;
	},
	
	// This function will take care of converting characters like &lt; to <. This conversion
	// was done through the function escapeUnwantedTags, to ensure that we prevent any 
	// script OR HTML executions.
	
	decodeString: function(inputString) {
		outputString = dojox.html.entities.decode(inputString);
		return outputString;		
	}
		
});