dojo.provide("com.ibm.security.modeling.util._DialogUtilities");

dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.util._DialogUtilities",null,{
	heightFactor:1.8,
	widthFactor:1.6,
	minHeight:400,	
	killOnHide:true,
	
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.util._DialogUtilities"),
	
	postCreate: function() { 
		this._trace.entering(this.id, "DialogUtilities::postCreate");
		this.inherited(arguments);
		
		this._setupDialogButtons();
		
		if (this.helpFile) {
			this._setUpHelp();
		}
		
		this.manageResize();
		
		this._trace.exiting(this.id, "DialogUtilities::postCreate");
	},
	
	manageResize:function(){
	    //this.connect(this, "startup", "resizeDialog");
		this.connect(this._IsrmDialog, "show", "resizeDialog");
		this.connect(window, "onresize", "resizeDialog");	
	},
	
	resizeDialog :function() {
       // this._trace.entering("", "resizeDialog");
		var x=dijit.getViewport();
		var height=x.h/this.heightFactor;
		var width=x.w/this.widthFactor;
		if(this.minHeight && height<=this.minHeight) height=this.minHeight;
		if(this.minWidth && width<=this.minWidth) width=this.minWidth;
		this.dialogBody.resize({h:height,w:width});
		//this is done as dialog do not get center allign after calling resize
		this.positionCentre( this._IsrmDialog);
       
      //  this._trace.exiting("", "resizeDialog");
     
     },
    positionCentre: function(widget){
		// summary:
		//		Position modal dialog in the viewport. If no relative offset
		//		in the viewport has been determined (by dragging, for instance),
		//		center the node. Otherwise, use the Dialog's stored relative offset,
		//		and position the node to top: left: values based on the viewport.
		// tags:
		//		private
		if(!dojo.hasClass(dojo.body(),"dojoMove")){
			var node = widget.domNode;
			var viewport = dijit.getViewport();
				//p = this._relativePosition,
			var bb =  dojo._getBorderBox(node);
			var l = Math.floor(viewport.l + ( (viewport.w - bb.w) / 2));
			var t = Math.floor(viewport.t);
			dojo.style(node,{
				left: l + "px",
				top: t + "px"
			});
		}
	},
	
	_setupDialogButtons: function() {
		this._trace.entering(this.id, "_setupDialogButtons");
		
		// Close button of dialog.
		this._IsrmDialog.onCancel = dojo.hitch (this, this.onCancel);	// on esc key.
		this._IsrmDialog.onClose = dojo.hitch (this, this.onCancel);
		
		// Dialog's close button tooltip shows: "Cancel".
		// Updating it to display: "Close" 
		this._IsrmDialog.closeButtonNode.title=this.globalResources.CLOSE;
		this._IsrmDialog.closeButtonNode.id=this.id+"_CloseDialog";
		
		this._trace.exiting(this.id, "_setupDialogButtons");
	},
	
	_setUpHelp:function(helpFile,contextRoot){
		
		if(dojo.isIE) {
			dojo.addClass(this._IsrmDialog.titleNode,"userDialogtitleStyle");
		}
	    dojo.require("com.ibm.security.modeling.help.Help");
	    this.helpSpan = new com.ibm.security.modeling.help.Help( {
	    	id: this.id+"_Help",
	    	containerDialog : this._IsrmDialog,
	    	helpFile : helpFile || this.helpFile
	    }, null);
	},
	
	destroy : function(){
	  //  this._trace.entering("", "destroy"); 
		if (this.helpSpan) {
			this.helpSpan.destroyRecursive();
		}
		if (this._IsrmDialog) {
			this._IsrmDialog.destroyRecursive();
		}
	    this.inherited(arguments);
	 //   this._trace.exiting("", "destroy"); 
	},
	
	show:function(){
		this._IsrmDialog.show();
	},
	
	onCancel:function(){
        this.hide();
    },
    
	hide : function() {
		this._IsrmDialog.hide();
		if(this.killOnHide) setTimeout (dojo.hitch (this, this.kill), (this._IsrmDialog.duration+100));
	},
	
	kill : function() {
     	 	
		this.destroyRecursive();
	}	
});
