/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

� Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.widgets.ConfirmMessageDialog");

dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("com.ibm.security.modeling.dijit.layout.ContentPane");
dojo.require("dijit.Dialog");
dojo.require("dojo.parser");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.widgets.ConfirmMessageDialog",dijit.Dialog,{
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.ConfirmMessageDialog"),
	content: dojo.cache("com.ibm.security.modeling.widgets", "templates/ConfirmMessageDialog.html"),
	icon: dojo.moduleUrl("com.ibm.security.modeling.themes", "images/ConfirmIcon.png"),
	submitButtonText: "ProvideText",
	cancelButtonText: "ProvideText",
	messageId:"",
	

	postMixInProperties:function() {
		this._trace.entering(this.id, "postMixInProperties");
		try {			
			this.inherited(arguments);
			if(this.completeMessage) this.setMessageAndId(this.completeMessage);
			this._fillInVariables();
			
			
			// onCancel: function
			//		Callback function to be invoked, then cancel is clicked.
		} catch (e) {
			this._trace.exception(e, "postMixInProperties");
			throw e;
		} finally {
			this._trace.exiting(this.id, "postMixInProperties");
		}
	},
	_fillInVariables: function() {
		this._trace.entering(this.id, "_fillInVariables");
		this.content = dojo.string.substitute(this.content, this, function(value, key){//substitute variables with their values from this object
			if(typeof value == "undefined"){ throw new Error("com.ibm.security.modeling.widgets.ConfirmMessageDialog template:"+key); }
			return value!=null?value.toString().replace(/"/g,"&quot;"):""; 
		}, this);
		this._trace.exiting(this.id, "_fillInVariables");
	},
	setMessage:function(message){
	     
	     this.setMessageAndId(message);
	     this._setmessageAttr(this.messageId,this.message);
	     //this._setmessageIdAttr(this.messageId);
	 },
	 _setmessageAttr:function(messageId,message){
	     
	     
	     var domNode=dijit.byId(this.id+"_content");
	     domNode.attr("content", "<h3>"+this.messageId+"</h3>" + this.message);

	 },
	setMessageAndId : function (messageAndId){
		this._trace.entering(this.id, "setMessageAndId");
		
		if (messageAndId.indexOf("CTJ") == 0) {//startsWith
			this.messageId = messageAndId.substring(0,10);		
			this.message = messageAndId.substring(10);
		}else{
			this.messageId = "";
			this.message = messageAndId;
		}
		
		this._trace.exiting(this.id, "setMessageAndId");
	},
	postCreate: function() {
		this.inherited(arguments);
		if(dojo.isIE) {
			dojo.addClass(this.titleNode,"userDialogtitleStyle");
		}
		this._hookUpButtons();
	},
	_hookUpButtons:function() {
		var submitButton = dijit.byId(this.id+"SubmitButton");
		var cancelButton = dijit.byId(this.id+"CancelButton");
		this.connect(submitButton, "onClick", "submitButtonPressed");
		this.connect(cancelButton, "onClick", "cancelButtonPressed");
	},
	submitButtonPressed: function(evt) {
		this._trace.entering(this.id, "submitButtonPressed");
		try {
			this.hide();
			if (this.onSubmit) {
				this.onSubmit(this.callbackParms);
			}			
		} catch (e) {
			this._trace.exception(e, "submitButtonPressed");
			throw e;
		} finally {
			this._trace.exiting(this.id, "submitButtonPressed");			
		}
	},
	cancelButtonPressed: function() {
		this._trace.entering(this.id, "cancelButtonPressed");
		try {
		    if (this.onCancel) {
				this.onCancel();
			}
			this.hide();			
		} catch(e) {
			this._trace.exception(e, "cancelButtonPressed");
			throw e;
		} finally {
			this._trace.exiting(this.id, "cancelButtonPressed");			
		}
	}
	
});