/* 
Licensed Materials - Property of IBM

5724-Z11??

 Copyright IBM Corp. 2009 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.widgets.CoverageContainer");

dojo.require("com.ibm.security.modeling.util.Trace");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("com.ibm.security.modeling.widgets.CoverageContainer",
		[dijit._Widget,dijit._Templated],
{
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.CoverageContainer"),
	templatePath: dojo.moduleUrl("com.ibm.security.modeling.widgets", "templates/CoverageContainer.html"),
	widgetsInTemplate: true,	
	// Coverage percentage value
	coverageValue:"",	
	// Coverage text
	coverageText:"",	
	// namespace: String
	//		The identifier for the current portlet
	namespace: "",	

	// Coverage icon source
	coverageIconSrc: "",
    
	// Image urls	
	emptyImage: dojo.moduleUrl("com.ibm.security.modeling","themes/images/CoverageEmpty.jpg"),
	fullImage: dojo.moduleUrl("com.ibm.security.modeling","themes/images/CoverageFull.jpg"),
	image25Percent: dojo.moduleUrl("com.ibm.security.modeling","themes/images/Coverage25Percent.jpg"),
	image50Percent: dojo.moduleUrl("com.ibm.security.modeling","themes/images/Coverage50Percent.jpg"),
	image75Percent: dojo.moduleUrl("com.ibm.security.modeling","themes/images/Coverage75Percent.jpg"),
	
	postMixInProperties:function(){
		this._trace.entering("", "postMixInProperties");
		this.inherited(arguments);
		this._trace.exiting("", "postMixInProperties");
	},
	setCoveragePercentage:function(coveragePercentage){
		this._trace.entering(this.namespace, "setCoveragePercentage");
		
		this.coverageValue = coveragePercentage;
		
		this._trace.finest("Raw coverage value is: " + this.coverageValue, "setCoveragePercentage");
		if (this.coverageValue>0){
			this.coverageValue = this.coverageValue*100;
		}
		this._trace.finest("coverage percentage is: " + this.coverageValue, "setCoveragePercentage");
				
		this.coverageValue = Math.round(this.coverageValue);
		this._trace.finest("Rounded coverage value is: " + this.coverageValue, "setCoveragePercentage");
			
		// Determine the coverage icon
		if (this.coverageValue == 0) {
			this.coverageIconSrc = this.emptyImage;
		}
		else if (this.coverageValue <= 30) {
			this.coverageIconSrc = this.image25Percent;
		} 
		else if (this.coverageValue <= 60) {
			this.coverageIconSrc = this.image50Percent;
		}
		else if (this.coverageValue <= 90) {
			this.coverageIconSrc = this.image75Percent;
		}
		else if (this.coverageValue <= 100) {
			this.coverageIconSrc = this.fullImage;
		}
			
		dojo.query("img", this.domNode)[0].src = this.coverageIconSrc;
        dojo.query("span[id="+this.namespace+"coveragePercentage]", this.domNode)[0].innerHTML=this.coverageValue;
		this._trace.exiting(this.namespace, "setCoveragePercentage");
	}
});