dojo.provide("com.ibm.security.modeling.widgets.FileUploadWidget");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("dijit._Container");
dojo.require("ibm.tivoli.tip.dijit.TIPButton");
dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("dojox.grid.enhanced._Plugin");
dojo.require("com.ibm.security.modeling.widgets.RequiredTextField");
dojo.require("dojox.form.FileUploader");

dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling", "PluginMessages");
dojo.requireLocalization("com.ibm.security.modeling.widgets", "FileUploadWidgetText");

dojo.declare("com.ibm.security.modeling.widgets.FileUploadWidget", [ dijit._Widget, dijit._Templated ], {

	templatePath : dojo.moduleUrl("com.ibm.security.modeling.widgets", "templates/FileUploadWidget.html"),
	image_path: dojo.moduleUrl("com.ibm.security.modeling.widgets","../themes/images"),
	
	widgetsInTemplate : true,
	parentWidget : null,
	force : "html",
	htmlFieldName : "dataFile",
	uploadUrl : null,
	needCustom:false,
        postdata:null,

	constructor : function() {
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
		this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
		this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.widgets", "FileUploadWidgetText");

	},
	postCreate : function() {
		//dojo.addClass(this.domNode, "fullSize");
		this.inherited("postCreate", arguments);
		if(!this.needCustom) this.customButton.destroy();
		else this.customButton.onClick=dojo.hitch(this,this.customeCallback);

	},

	startup : function() {
		this.inherited(arguments);
		this.fileName._inputNode.style.width = "70%";
		this.fileName.setDisabled(true);
		this.fileloader = new dojox.form.FileUploader( {
			force : "html",
			htmlFieldName : "dataFile",
			uploadUrl : this.uploadUrl
		}, this.id+"_fileLoader");

		dojo.connect(this.fileloader, "onChange", dojo.hitch(this, function(data) {
		
			this.fileName.setValue(data[0].name);

		}));

	},
	upload : function() {
		console.log("the post data in fileUploaderWidget");
                console.log(this.postdata);
		this.fileloader.upload(this.postdata);
		this.fileloader._setDisabledAttr(false);
	},
	clear :  function(){
		
		this.fileloader.removeFile(this.fileName.getValue(),true);
		this.fileName.setValue("");
		this.fileloader._resetHTML();
	},
	 getFileName : function(){
        return this.fileName.getValue();
     },
	validate : function() {
		
		var valid = false;
		var errorMsg = "";
		var fileName = this.fileName.getValue();
	    var reqExt = ".csv";
     	var ext = fileName.slice(fileName.indexOf(".")).toLowerCase();
		
        if (fileName.length == 0) {
			//errorMsg="no fileName .Please enter one";
    	errorMsg = this.pluginResources.PLUGIN_FILENAME_MISSING;
	    valid = false;
	    } else if (fileName.length > 1024) {
		errorMsg = this.pluginResources.PLUGIN_FILENAME_TOO_LONG;
		valid = false;
	    }else	if(reqExt!=ext){
			errorMsg = this.pluginResources.PLUGIN_INVALID_FILE_INPUT;
			valid = false;
			
		
	    } else
		valid = true;
	
	    return errorMsg;
	},
	destroy : function() {
		                     
		if(this.needCustom) this.customButton.destroy();
		this.fileloader.destroy();
		this.inherited(arguments);
	}

});