/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

dojo.provide("com.ibm.security.modeling.widgets.FilteringHelper");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("com.ibm.security.modeling.notebook.AttributeDialogFactory");
dojo.require("com.ibm.security.modeling.util.ValidationUtilities");
dojo.require("com.ibm.security.modeling.util.Trace");
dojo.require("com.ibm.security.modeling.widgets.FilteringWidget");
dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling.notebook", "AttributeDialogText");
dojo.declare("com.ibm.security.modeling.widgets.FilteringHelper", [ dijit._Widget], {
	_trace : new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.FilteringHelper"),
	//widgetsInTemplate : true,
	//validator : new com.ibm.security.modeling.util.Validator(),
	attributeUri:"",
        hookForFilteringSelect:null,
        hookForStackContainer:null,
        editMode:false,
        widgetFactory:null,
        editItem:null,

	parentWidget : null,

	constructor : function() {
		this._trace.entering("", "constructor");
		this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
		this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
		this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.notebook", "AttributeDialogText");
		this._trace.exiting("", "constructor");

	},
	postCreate : function() {
		this._trace.entering("", "postCreate");
		dojo.addClass(this.domNode, "contentArea");
		this.inherited("postCreate", arguments);
		
		
                if(this.editMode)
                 {
                this.directlyAttachWidget();
                  }else{
                 
		this.addFilteringWidget();
                }
		//this._setUpHelp("ui_attributes_add.html");

	},
        startup : function(){
                 this.inherited(arguments);
                 if(this.filteringWidget)
                 this.filteringWidget.startup();
        },
	addFilteringWidget : function() {

	

		this.filteringWidget = new com.ibm.security.modeling.widgets.FilteringWidget( {
                       
			searchAttr : "attributeName",
			store : this.stateStore,
			selectedValueCallback : dojo.hitch(this, this.selectedValueCallback),
			hookForFilteringSelect : this.hookForFilteringSelect,
			hookForStackContainer : this.hookForStackContainer,
			onSelection : this.onSelection,
			noItems :this.noItems

		});

	},
	directlyAttachWidget : function(){
                //TODO remove this line , 
                 this.editItem.attributeType=this.editItem.type;
                 this.widget=this.selectedValueCallback(this.editItem.name,this.editItem);
              //  this.WidContainer.set("content", this.widget);
               // this.widget.resize();
                dojo.place(this.widget.domNode,this.hookForStackContainer,"replace");
                   //why ??
                   this.onSelection("value",this.editItem);
                 //  this.widget.setValue(this.editItem);
//how will you gaurante setEditValue
                   this.widget.setEditValue(this.editItem);
                  
        },
	selectedValueCallback : function(value, item) {
	//current value which is selected
		//this.value = value ;
                console.log("item in attr dialog");
                console.log(item);
		this.widgetFactory = this.widgetFactory || new com.ibm.security.modeling.notebook.AttributeDialogFactory();


		this.wid= this.widgetFactory.getWidgetFactory(item, {
			msgArea : this.msgArea,
                        editMode:this.editMode,
			storeUri : this.storeUri
		}).getWidget(value);
	      //
//widgetFactory.getWidget(item,args);
	
                return this.wid;
	},
	
	
	
	destroy : function() {
		this._trace.entering("", "destroy");
	
		this._trace.exiting("", "destroy");
	},
	
	extractValue : function() {
              var widget=null;
              var item=null;
          if(!this.editMode){
               widget=this.filteringWidget.getSelectedChild();
               item=this.filteringWidget.getFilteringSelectItem();
          }
          else{
               widget=this.wid;
               item=this.editItem;

          }
	  if (!widget)
		return;
	 return widget.extractValue(item);
	
	}
	
});
