/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

© Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.widgets.InfoMessageDialog");

dojo.require("ibm.tivoli.tip.dijit.TIPMessageDialog");
dojo.require("com.ibm.security.modeling.dijit.layout.BorderContainer");
dojo.require("com.ibm.security.modeling.dijit.layout.ContentPane");
dojo.require("dijit.Dialog");
dojo.require("dojo.parser");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.widgets.InfoMessageDialog",dijit.Dialog,{
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.InfoMessageDialog"),
	content: dojo.cache("com.ibm.security.modeling.widgets", "templates/InfoMessageDialog.html"),
	icon: dojo.moduleUrl("com.ibm.security.modeling.themes", "images/InfoIcon.png"),
	
      

	/**
	 * Override method to set the property.
	 * 
	 * @return
	 */
	 isSubmitNeeded:false,
	 setMessage:function(message){
	     
	     this.setMessageAndId(message);
	     this._setmessageoAttr(this.messageId,this.message);
	     //this._setmessageIdAttr(this.messageId);
	 },
	 _setmessageoAttr:function(messageId,message){
	     var domNode=dijit.byId(this.id+"_content");
	     domNode.attr("content", "<h3>"+messageId+"</h3>" + message);
	     
	     
	    
	 },
	
	postMixInProperties:function() {
		this._trace.entering(this.id, "postMixInProperties");

		try {			
			this.inherited(arguments);
			this.closeButtonText = this.globalResources.CLOSE;
			this.setMessageAndId(this.infoMessages);
			this._fillInVariables();			
		} catch (e) {
			this._trace.exception(e, "postMixInProperties");
			throw e;
		} finally {
			this._trace.exiting(this.id, "postMixInProperties");
		}
	},
	
	/**
	 * To split and set Message Id and Message.
	 * 
	 * @param messageAndId
	 * @return
	 */
	setMessageAndId : function (messageAndId){
		this._trace.entering(this.id, "setMessageAndId");
		
		if (messageAndId.indexOf("CTJ") == 0) {//startsWith
			this.messageId = messageAndId.substring(0,10);		
			this.message = messageAndId.substring(10);
		}else{
			this.messageId = "";
			this.message = messageAndId;
		}
		
		this._trace.exiting(this.id, "setMessageAndId");
	},
	
	/**
	 * To fill the variable value in templates.
	 * 
	 * @return
	 */
	_fillInVariables: function() {
		this._trace.entering(this.id, "_fillInVariables");
		
		this.content = dojo.string.substitute(this.content, this, function(value, key){//substitute variables with their values from this object
			if(typeof value == "undefined"){ throw new Error("com.ibm.security.modeling.widgets.InfoMessageDialog template:"+key); }
			return value!=null?value.toString().replace(/"/g,"&quot;"):""; 
		}, this);
		this._trace.exiting(this.id, "_fillInVariables");
	},
	
	/**
	 * Override method.
	 * 
	 * @return
	 */
	postCreate: function() {
		this.inherited(arguments);
		this._hookUpButtons();
	},
	
	/**
	 * To connect button with event.
	 * 
	 * @return
	 */
	_hookUpButtons:function() {
		this._trace.entering(this.id, "_hookUpButtons");
		
		var closeButton = dijit.byId(this.id+"CloseButton");
		this.connect(closeButton, "onClick", "closeButtonPressed");
		
		this._trace.exiting(this.id, "_hookUpButtons");
	},
	
	/**
	 * To hide the info dialog box.
	 * 
	 * @return
	 */
	closeButtonPressed: function() {
		this._trace.entering(this.id, "closeButtonPressed");
		try {
			this.hide();			
		} catch(e) {
			this._trace.exception(e, "closeButtonPressed");
			throw e;
		} finally {
			this._trace.exiting(this.id, "closeButtonPressed");			
		}
	}
	
});
