dojo.provide("com.ibm.security.modeling.widgets.IsrmDialogBase");

dojo.require("com.ibm.security.modeling.util.Trace");
dojo.require("com.ibm.security.modeling.util.CommonUtilities");
dojo.require("com.ibm.security.modeling.widgets.MultiMessageArea");
dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling", "PluginMessages");


dojo.declare("com.ibm.security.modeling.widgets.IsrmDialogBase",[dijit._Widget,dijit._Templated ],{
	heightFactor:1.8,
	widthFactor:1.6,
	minHeight:400,	
	killOnHide:true,
	widgetsInTemplate : true,
	viewPortHeightOffset : 30,
	viewPortWidthtOffset : 30,
      
	
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.IsrmDialogBase"),
	myTemplateString:dojo.cache("com.ibm.security.modeling.widgets", "templates/IsrmBaseDialog.html"),
	
	
	constructor:function(){
	    this.globalResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "GlobalText");
		this.pluginResources = dojo.i18n.getLocalization("com.ibm.security.modeling", "PluginMessages");
		this.messageResources = this.logMessages=dojo.i18n.getLocalization("com.ibm.security.modeling", "LogMessages");
	    this._widgetUtilities = new com.ibm.security.modeling.util.WidgetUtilities();
	    this.buttonsEnableDisableOnHideShow=[];
    },
	postMixInProperties:function(){   
		this.dialogTitle = this.dialogTitle||"";
		this.dialogInstruction=this.dialogInstruction||"";
	    var templateString = this.templateString || dojo.cache(this.templatePath, {sanitize: true});
	    this.templateString = this.substitute(this.myTemplateString,{__contents:templateString});
    },
    buildRendering:function(){
		//we dont expect any formatted html as part of our dialog title . 
		this.dialogTitle=com.ibm.security.modeling.util.HtmlEscapingUtils.parseHTMLandNormalize(this.dialogTitle);
		this.inherited(arguments);
    },
	postCreate: function() { 
		this._trace.entering(this.id, "postCreate");
		
		this.inherited(arguments);

		this._setupMessageArea();
		this._setupDialogButtons();
		
		if (this.helpFile) {
			this._setUpHelp();
		}
		
		this.manageResize();
		this.setDialogTitleTooltipText();
		this._trace.exiting(this.id, "postCreate");
	},
    substitute:function(	/*String*/		template, 
			/*Object|Array*/map, 
			/*Function?*/	transform, 
			/*Object?*/		thisObject){

		thisObject = thisObject || dojo.global;
		transform = transform ? 
		dojo.hitch(thisObject, transform) : function(v){ return v; };
		
		return template.replace(/\$\{([^\s\:\}]+)(?:\:([^\s\:\}]+))?\}/g,
		function(match, key, format){
		var value = dojo.getObject(key, false, map);
		if(format){
		value = dojo.getObject(format, false, thisObject).call(thisObject, value, key);
		}
		if(!value){
			value='${'+key+'}';
		}
		return transform(value, key).toString();
		}); // String
	},
	addCommonButton: function(args) {
		
		args=args||{};
		var label = args.label;
		var commonButton = {OK:"",CANCEL:"",CLOSE:"",SUBMIT:""};
		if(args.type in commonButton){
			label = label||this.globalResources[args.type];
		}
		var button = new dijit.form.Button({label:label,id:args.id,onClick:args.onClick});
		dojo.addClass(button.domNode,"dialogButton");
		dojo.place(button.domNode,this.bottomContentPane.domNode,"last");
		this.buttonsEnableDisableOnHideShow.push(button);
		return  button;
	},
	
	_setupMessageArea: function() {
		this.messageArea.borderContainer = this.container;
	},
	
	manageResize:function(){
	    this.connect(this, "startup", "resizeDialog");
		this.connect(this._IsrmDialog, "show", "resizeDialog");
		if (customizer) {
			this._trace.finest("Using TIP customizer.windowResize for resize processing", "manageResize");
			this.connect(customizer, "windowResize", "resizeDialog");
		} else {
			this._trace.finest("Using window.onresize for resize processing", "manageResize");
			this.connect(dojo.global, "onresize", "resizeDialog");			
		}
	},
	
	resizeDialog :function() {
		this._trace.entering("#############", "resizeDialog");
		var x=dijit.getViewport();
	    var height=x.h/this.heightFactor;
        var width=x.w/this.widthFactor;
		if(this.minHeight && height<=this.minHeight) { height=this.minHeight; }
		if(this.minWidth && width<=this.minWidth) { width=this.minWidth; }
		var size=dojo.marginBox(this.container.domNode);
		var maxDialogHeightForViewport = x.h - this.viewPortHeightOffset;
        if(/*this will work only when viewport become less*/ (height > maxDialogHeightForViewport || width > x.w)){  
			this._trace.finest("height: " + height + " is greater than viewport height " + maxDialogHeightForViewport + " or width: " + width + "is greater than viewport width: " + x.w, "resizeDialog");
			this._trace.finest("setting dialog body height to " + maxDialogHeightForViewport +"px and width to " + width+"px", "resizeDialog");
			dojo.style(this.dialogBody.domNode,{"height":maxDialogHeightForViewport+"px","width":width+"px"});
			this._trace.finest("setting container height to " + maxDialogHeightForViewport+"px and width to " + (width) +"px", "resizeDialog");
			//we want the top border container to be sized to the same as the dialog, so that the buttons are not hidden
			this.container.resize({h:maxDialogHeightForViewport,w:width});
        }else{
			this._trace.finest("setting dialog body height to " + height+"px and width to " + width +"px", "resizeDialog");
			this.dialogBody.resize({h:height,w:width});
			//this is done as dialog do not get center allign after calling resize
			this.positionCentre(this._IsrmDialog);		     
        }
		this._trace.exiting("", "resizeDialog");
     },
     
    positionCentre: function(widget){
		// summary:
		//		Position modal dialog in the viewport. If no relative offset
		//		in the viewport has been determined (by dragging, for instance),
		//		center the node. Otherwise, use the Dialog's stored relative offset,
		//		and position the node to top: left: values based on the viewport.
		// tags:
		//		private
		this._trace.entering("", "positionCentre");
		if(!dojo.hasClass(dojo.body(),"dojoMove")){
			var node = widget.domNode;
			var viewport = dijit.getViewport();
			//p = this._relativePosition,
			var bb =  dojo._getBorderBox(node);
			var l = Math.floor(viewport.l + ( (viewport.w - bb.w) / 2));
			var t = Math.floor(viewport.t +( (viewport.h - bb.h) / 2));
			dojo.style(node,{
				left: l + "px",
				top: t + "px"
			});
		}
		this._trace.exiting("", "positionCentre");
	},
	
	_setupDialogButtons: function() {
		this._trace.entering(this.id, "_setupDialogButtons");
		
		// Close button of dialog.
		this._IsrmDialog.onCancel = dojo.hitch(this, this.onCancel);	// on esc key.
		this._IsrmDialog.onClose = dojo.hitch(this, this.onCancel);
		
		// Dialog's close button tooltip shows: "Cancel".
		// Updating it to display: "Close" 
		this._IsrmDialog.closeButtonNode.title=this.globalResources.CLOSE;
		this._IsrmDialog.closeButtonNode.id=this.id+"_CloseDialog";
		
		this._trace.exiting(this.id, "_setupDialogButtons");
	},
	
	_setUpHelp:function(helpFile,contextRoot){
		
		if(dojo.isIE) {
			dojo.addClass(this._IsrmDialog.titleNode,"userDialogtitleStyle");
		}
	    dojo.require("com.ibm.security.modeling.help.Help");
	    this.helpSpan = new com.ibm.security.modeling.help.Help( {
			id: this.id+"_Help",
			containerDialog : this._IsrmDialog,
			helpFile : helpFile || this.helpFile
	    }, null);
	},
	
	destroy : function(){
	  //  this._trace.entering("", "destroy"); 
	 // dojo.forEach(this.connections,dojo.disconnect);
		if (this.helpSpan) {
			this.helpSpan.destroyRecursive();
		}
		if (this._IsrmDialog) {
			this._IsrmDialog.destroyRecursive();
		}
	    this.inherited(arguments);
	 //   this._trace.exiting("", "destroy"); 
	},
	
	show:function(){
		//having this try-catch so that if some body remove it from dom , then panel should not fail 
		try{
			var childrens = this.bottomContentPane.getChildren();
			//if(childrens.length==0) dojo.style(this.bottomContentPane.domNode,"height","0px" );
			if(childrens.length===0) {
				dojo.style(this.bottomContentPane.domNode,"display","none" );
			}
		}catch(e){}
		
        for(var i=0;i<this.buttonsEnableDisableOnHideShow.length;i++){
		    this.buttonsEnableDisableOnHideShow[i].set("disabled",false);
        }

		this._IsrmDialog.show();
		this.setDialogTitleTooltipText();
	},
	
	onCancel:function(){
        this.hide();
    },
    
	hide : function() {
        for(var i=0;i<this.buttonsEnableDisableOnHideShow.length;i++){
		    this.buttonsEnableDisableOnHideShow[i].set("disabled",true);
        }
		this._IsrmDialog.hide();
		if(this.killOnHide) {
			setTimeout(dojo.hitch(this, this.kill), (this._IsrmDialog.duration+100));
		}
	},
	hideDialogIfStateEnforcementError:function(error){
		//will hide dialog if Invalid action is performed, as it will show an error dialog and will launch projects page
		if(error && error.status && error.status===409){//409 is status code for invalid action
			this.hide();
		}
		
	},
	kill : function() {
		this.destroy();
	},
	setDialogTitleTooltipText : function(){
		if(this._IsrmDialog && this._IsrmDialog.titleBar && this._IsrmDialog.titleBar.title){
			this._IsrmDialog.titleBar.title = com.ibm.security.modeling.util.HtmlEscapingUtils.denormalizeAndConvertBackToHTML(this._IsrmDialog.titleBar.title);	
		}
	}	
});