/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

� Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.widgets.MemberAttributeDistributionChartWidget");

dojo.require("com.ibm.security.modeling.widgets.ChartWidget");

dojo.declare("com.ibm.security.modeling.widgets.MemberAttributeDistributionChartWidget", 
	[ com.ibm.security.modeling.widgets.ChartWidget],{
		
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.MemberAttributeDistributionChartWidget"),			
	helpFile: "ui_role_membership_distribution.html",
	distributionChartDrillFactoryName:dojo.config.analysisFactories.DISTRIBUTION_DRILL_FACTORY,
	inChartDrillFactoryName:dojo.config.analysisFactories.IN_DRILL_FACTORY,
	outChartDrillFactoryName:dojo.config.analysisFactories.OUT_DRILL_FACTORY,
	constructor : function(args) {
		this.inherited(arguments);
		this.titleText = this.localResources.USER_TITLE;
		this.defaultTitleText = this.localResources.DEFAULT_USER_TITLE;	
		this._showMousePointer = true;
	},
	postMixInProperties: function(args) {
		this._trace.entering("", "postMixInProperties");
		this._trace.object(args, "postMixInProperties", "postMixInProperties args");
		
		this.inherited(arguments);
		this.attributeUri="/isrm/rest/userscope/attributes";
		this.distributionPath = "/users";
		
		this._trace.exiting("", "postMixInProperties");
		
	},
	postCreate: function() {
		this.inherited(arguments);
		this.subscribe(dojo.config.panels.ANALYSIS_DRILL_DOWN.launchEventAddress, this.launchDrillDown);
	},
	getInheritanceLabel: function() {
		// Summary:
		//		Gets the label to be shown against the inheritance check-box of each task. 
		//
		// returns: string
		//		inheritanceLabel
		return this.localResources.INCLUDE_ROLE_MEMBER_INHERITANCE;
	},

	launchDrillDown: function(attributeValue, factoryName) {
		this._trace.entering("attributeValue: " + attributeValue + ", factoryName: " + factoryName, "launchDrillDown");
		var contextData = this._makeDrillDownData(attributeValue);
		this.launchAnalysisPane(factoryName, contextData);
		this._trace.exiting("", "launchDrillDown");
	},
	setupDistributionAnalysisTable: function(attributeDistribution) {
		this._trace.entering("", "setupDistributionAnalysisTable");
		this.inherited(arguments, [attributeDistribution, true]);	
		this._trace.exiting("", "setupDistributionAnalysisTable");
	},
	setupInOutAnalysisTable: function(attributeDistribution) {
		this._trace.entering("", "setupInOutAnalysisTable");
		this.inherited(arguments, [attributeDistribution, true]);
		this._trace.exiting("", "setupInOutAnalysisTable");
	}
});