/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

� Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.widgets.PermissionAttributeDistributionChartWidget");

dojo.require("com.ibm.security.modeling.widgets.ChartWidget");

dojo.declare("com.ibm.security.modeling.widgets.PermissionAttributeDistributionChartWidget", 
	[ com.ibm.security.modeling.widgets.ChartWidget],{
		
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.PermissionAttributeDistributionChartWidget"),			
	helpFile: "ui_permission_distribution.html", 
	constructor : function(args) {
		this.inherited(arguments);
		this.titleText = this.localResources.PERMISSION_TITLE;
		this.defaultTitleText = this.localResources.DEFAULT_PERMISSION_TITLE;		
	},
	postMixInProperties: function(args) {
		this._trace.entering("", "postMixInProperties");
		this._trace.object(args, "postMixInProperties", "postMixInProperties args");
		
		this.inherited(arguments);
		this.attributeUri="/isrm/rest/permissionscope/attributes";
		this.distributionPath = "/permissions";
		
		this._trace.exiting("", "postMixInProperties");
		
	},
	startup:function() {
		// tags:
		// protected
		this._trace.entering(this.id, "startup");
		this.inherited(arguments);
		
		this._trace.exiting(this.id, "startup");
	},
	getInheritanceLabel: function() {
		// Summary:
		//		Gets the label to be shown against the inheritance check-box of each task. 
		//
		// returns: string
		//		inheritanceLabel
		return this.localResources.INCLUDE_ROLE_PERMISSION_INHERITANCE;
	},
	setupDistributionAnalysisTable: function(attributeDistribution) {
		this._trace.entering("", "setupDistributionAnalysisTable");
		this.inherited(arguments, [attributeDistribution, false]);	
		this._trace.exiting("", "setupDistributionAnalysisTable");
	},
	setupInOutAnalysisTable: function(attributeDistribution) {
		this._trace.entering("", "setupInOutAnalysisTable");
		this.inherited(arguments, [attributeDistribution, false]);
		this._trace.exiting("", "setupInOutAnalysisTable");
	}
});