/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

� Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.security.modeling.widgets.PermissionPickerDialog");

dojo.require("com.ibm.security.modeling.util.Trace");
dojo.require("com.ibm.security.modeling.widgets.PickerDialog");
dojo.require("com.ibm.security.modeling.tables.PermissionTable");

// NLS
dojo.requireLocalization("com.ibm.security.modeling.widgets", "PermissionPickerText");



// define the widget class
dojo.declare (
	"com.ibm.security.modeling.widgets.PermissionPickerDialog", com.ibm.security.modeling.widgets.PickerDialog , {
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.PermissionPickerDialog"),
	
	// tableQuery: object
	//		query to be passed to table.
	widthFactor:1.4,
	
	postMixInProperties:function() {
		this._trace.entering(this.id, "postMixInProperties");
		this.inherited(arguments);
		
		this.localResources = this.localResources || dojo.i18n.getLocalization("com.ibm.security.modeling.widgets", "PermissionPickerText");
		
		this._trace.exiting(this.id, "postMixInProperties");
	},

	postCreate: function() { 
		this._trace.entering(this.id, "postCreate");
		this.inherited(arguments);
		// create table
		this._setupTable();
		this._trace.exiting(this.id, "postCreate");
	},
	
	startup: function () {
		this._trace.entering(this.id, "startup");
		this.inherited(arguments);
		
		// start table
		this._pickerTable.startup();
		this._trace.exiting(this.id, "startup");
	},
	
	_setupTable: function () {
		this._trace.entering(this.id, "_setupTable");
		
		var tableArgs = {
			id: this.id+"_permissionTable",
			dataStore: this.fromDataStore, 
			isClientSide: false,
			isFilterRendered: true,
			isRefreshRendered: true,
			parentContainer: this.container,
			messageArea: this.messageArea,
			tableTyep:"permissionPicker"
		};
		
		if (this.tableQuery) {
			tableArgs.query = this.tableQuery;
		}
		
		this._pickerTable = new com.ibm.security.modeling.tables.PermissionTable (tableArgs, this.id+"_pickerDialogTableContainer");
		
		this._trace.exiting(this.id, "_setupTable");
	}
});


