/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

� Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.security.modeling.widgets.PropertiesDialog");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.security.modeling.tables.Table");
dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");
dojo.requireLocalization("com.ibm.security.modeling.widgets", "PropertiesDialogText");
dojo.require("com.ibm.security.modeling.notebook.AttributePanel");
dojo.require("com.ibm.security.modeling.widgets.IsrmDialogBase");
dojo.declare("com.ibm.security.modeling.widgets.PropertiesDialog",com.ibm.security.modeling.widgets.IsrmDialogBase, {
	templatePath : dojo.moduleUrl("com.ibm.security.modeling.widgets",
			"templates/PropertiesDialog.html"),
				
	widgetsInTemplate : true,
	panelHeaderName:"",
	minHeight:300,
    _messageUtil : new com.ibm.security.modeling.util.MessageUtilities(),
    postMixInProperties:function(){
	
	
	    this.inherited(arguments);
        this.localResources = dojo.i18n.getLocalization("com.ibm.security.modeling.widgets", "PropertiesDialogText");
       
        if(this.type=='USER'){ 
        	this.dialogTitle = this._messageUtil.formatMessage(this.localResources.PANEL_TITLE_USER, [this.panelHeaderName]);
        	this.attributeInstruction=this.localResources.PANEL_INSTRUCTIONS_USER;
            this.helpFile="ui_properties_user.html";
        }
        else if(this.type=='PERMISSION'){         
          	this.dialogTitle = this._messageUtil.formatMessage(this.localResources.PANEL_TITLE_PERMISSION, [this.panelHeaderName]);  
        	this.attributeInstruction=this.localResources.PANEL_INSTRUCTIONS_PERMISSION;
            this.helpFile="ui_properties_permission.html";
        } 
        this.dialogInstruction="";
        
    },
    postCreate : function() {
			this.inherited(arguments);                                             
			dojo.addClass(this.domNode, "contentArea");
			this.closeButton = this.addCommonButton({
									onClick:dojo.hitch(this, this.onCancel),
									type:"CLOSE"
								});
		 	
	},
	startup:function(){   
	   this.inherited(arguments);
	   this.storeUri=this.entityItem+"/attributes";
	   var attributePanel = this._createAttributePanel();
	   attributePanel.populate(this.entityItem);   
	},
	
	_createAttributePanel :function(){
	   
	    dojo.require("com.ibm.security.modeling.notebook.AttributePanel");
	    //storeURi is the uri for attributes , this.contextRoot for help	
		var attributePanel = new com.ibm.security.modeling.notebook.AttributePanel (
				{
					id:this.id+"_attributePanel",
					messageArea: this.messageArea,
					globalResources: this.globalResources,
					localResources:this.localResources,
					attributeInstruction:this.attributeInstruction,
					contextRoot: this.contextRoot,
					hyperLinkIdentities:false,
					parentWidget:this,
					needToolBar:false,
					storeUri:this.storeUri
				},
				this.id+"_MemberConflict");
		
		return attributePanel;
	}

    
	
});
