/*
 * This TextBox is a wrapper over the ibm.tivoli.tip.dijit.TextInputBox.
 * It overrides setStatus method to clear a previous validation error
 * message, and to suppress the tooltip on validation.  The tooltip is
 * not required per Role Modeler UI guidelines.
 */
dojo.provide("com.ibm.security.modeling.widgets.RequiredTextArea");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("ibm.tivoli.tip.dijit.TextInputBox");

dojo.declare("com.ibm.security.modeling.widgets.RequiredTextArea", ibm.tivoli.tip.dijit.TextInputBox, {

	_messageArea: null,
isTextArea:false,
needDivinput:false,
attributeMap: {
      rows: {node: "_focusNode", type: "attribute" },
      cols: {node: "_focusNode", type: "attribute" }
},

	// rows: Number
	//		The number of rows of text.
	rows: "3",
        cols:"20",
	// rows: Number
	//		The number of characters per line.
	
   templateString:"<div dojoAttachPoint='requiredTextArea' class='textInputDefault requiredContainer' >"+
                                           "<span class='requiredImageIcon'>"+
                                           "<img  class='textInputIcon imageNode'    src='${constants.DEFAULT_ICON}'   dojoAttachPoint='_iconNode'  /></span>"+
                                           "<div dojoAttachPoint='divElement' class='textAreaPostion'>"+
                                            "<textarea  class='textInputNode cursorBiDI textAreaOverFlow'      value='' "+
                                            "  dojoAttachPoint='_inputNode, _focusNode'    dojoAttachEvent='onkeyup:_onKeyUp, onkeypress:_onKeyPress, onchange:_onChange'>"+
                                           "</textarea></div>"+
                                       "<br style='clear:both'>"+
                                   "</div>",

	setMessageArea: function(messageArea) {
		this._messageArea = messageArea;
	},
	postCreate:function(){
	  this.manageResize();
	  this.inherited(arguments);
	},
	manageResize:function(){
        this.connect(this, "startup", "resize");
	   this.connect(window, "onresize", "resize");	
	},
	//need to think for a bettersolution for this , any how connect this to onShow of stackContainer in which it is used or any event which come to pictur when this become enabled
	//better solution is here :)
	resize :function() {
	
        if(this.isTextArea|| this.needDivinput){
	 var x =dojo.style(this.requiredTextArea,"width");
	 
	
	 try{
	 if(x>13) dojo.style(this._inputNode,"width",(x-13)+"px");
	 }catch(e){
	 }
	
	 }
     
     },
	setStatus: function(status) {
		var currentStatus = this.getStatus();
		if ((currentStatus != null) &&
			(currentStatus.state == this.constants.ERROR) &&
			((status.state == this.constants.DEFAULT) || (status.state == this.constants.REQUIRED)) &&
			(this._messageArea != null)) {
			try{
			this._messageArea.hide();
		    }catch(e){
		        
		    }
		    try{
			this._messageArea.hideMessages();
		    }catch(e){
		        
		    }
		}
		status.message = "";
		this.inherited("setStatus", arguments);
		this._updateWidget();
	},
	  setFieldStatusToError: function(){
    	this.domNode.className = "textInputError";
        this._iconNode.src = this.constants.ERROR_ICON;
    }
    

});
