/*
 * This TextBox is a wrapper over the ibm.tivoli.tip.dijit.TextInputBox.
 * It overrides setStatus method to clear a previous validation error
 * message, and to suppress the tooltip on validation.  The tooltip is
 * not required per Role Modeler UI guidelines.
 */
dojo.provide("com.ibm.security.modeling.widgets.RequiredTextField");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("ibm.tivoli.tip.dijit.TextInputBox");

dojo.declare("com.ibm.security.modeling.widgets.RequiredTextField", ibm.tivoli.tip.dijit.TextInputBox, {

	_messageArea: null,

	inputClasses: "",

	setMessageArea: function(messageArea) {
		this._messageArea = messageArea;
	},
	postCreate:function(){
	  dojo.addClass(this._inputNode, this.inputClasses);
	  if (this.maxLength > 0) {
		  this._inputNode.setAttribute("maxLength", this.maxLength);
	  }
	  this.inherited(arguments);
	},

	setStatus: function(status) {
		status.message = "";
		this.inherited("setStatus", arguments);
	},
	  setFieldStatusToError: function(){
    	this.domNode.className = "textInputError";
        this._iconNode.src = this.constants.ERROR_ICON;
    },
    getValue:function(){
    	//At the time of get , this widget value should always be , the value in the acutal text node value . 
    	//this is differing , since update is happening on key-up , so right click and paste is failing .
    	this._value=this._inputNode.value;
        return this.inherited(arguments);
    }
    

});