/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

 Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

dojo.provide("com.ibm.security.modeling.widgets.RolePickerDialog");

dojo.require("com.ibm.security.modeling.util.Trace");
dojo.require("com.ibm.security.modeling.widgets.PickerDialog");
dojo.require("com.ibm.security.modeling.tables.RoleTable");

// NLS
dojo.requireLocalization("com.ibm.security.modeling", "GlobalText");


// define the widget class
dojo.declare (
	"com.ibm.security.modeling.widgets.RolePickerDialog", com.ibm.security.modeling.widgets.PickerDialog , {
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.RolePickerDialog"),
	
	// tableQuery: object
	//		query to be passed to table.
	
	postCreate: function() { 
		this._trace.entering(this.id, "postCreate");
		this.inherited(arguments);
		// create table
		this._setupTable();
		this._trace.exiting(this.id, "postCreate");
	},
	
	startup: function () {
		this._trace.entering(this.id, "startup");
		this.inherited(arguments);
		
		// start table
		this._pickerTable.startup();
		this._trace.exiting(this.id, "startup");
	},
	
	_setupTable: function () {
		this._trace.entering(this.id, "_setupTable");
		
		var tableArgs = {
			id: this.id+"_rolesTable",
			dataStore: this.fromDataStore, 
			isClientSide: false,
			isFilterRendered: true,
			isRefreshRendered: true,
			isSearchMultiSelect: false,
			messageArea: this.messageArea,
			parentContainer: this.container
		};
		
		if (this.tableQuery) {
			tableArgs.query = this.tableQuery;
		}
		
		this._pickerTable = new com.ibm.security.modeling.tables.RoleTable (tableArgs, this.id+"_pickerDialogTableContainer");
		
		this._trace.exiting(this.id, "_setupTable");
	}
});


