/* 
Licensed Materials - Property of IBM

Role and Policy Modeler

 Copyright IBM Corp. 2011 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or 
disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
dojo.provide("com.ibm.security.modeling.widgets.ScoreChart");

dojo.require("dojox.widget.AnalogGauge2");
dojo.require("dojox.widget.AnalogGauge2.VolumeBarStyle");
dojo.require("dojox.charting.themes.CubanShirts");

dojo.require("dojox.charting.themes.PlotKit.blue");
dojo.require("com.ibm.security.modeling.util.Trace");

dojo.declare("com.ibm.security.modeling.widgets.ScoreChart", [ dijit._Widget,
		dijit._Templated  ],{
		
	_trace: new com.ibm.security.modeling.util.Trace("com.ibm.security.modeling.widgets.ScoreChart"),			
	widgetsInTemplate : true,
	templatePath : dojo.moduleUrl("com.ibm.security.modeling.widgets", "templates/ScoreChart.html"),
	attributeMap : {
		score : {node : "scoreNode", type : "innerText"},
		scoreValue : {node : "scoreValueNode", type : "innerText"}
	},
	populate: function(score){
		this._trace.entering(this.id, "populate");
		
		if (score) {
			if(this.scoreChart == null){
				this.scoreChart = new dojox.widget.AnalogGauge2({
					width: 75,
					height: 175,
					majorTickSeparation: 20,
					minValue: 0,
					maxValue: 100,
					units:"Score",
					styler: new
					dojox.widget.AnalogGauge2.VolumeBarStyle({
						outlinecolor:"black", 
						outlinewidth:1,
						fillcolor:"#270e96",
						font:{
							family: "Verdana", 
							size:'.8em',
							color:"#959595",
							margin: "10px"
						}
					})

				}, dojo.byId(this.id+"_scoreChart"));
			}
			this.scoreChart.setValue(score);
			this.scoreChart.startup();		

			this.removeScoreText();

			this.set("score",this.localResources.SCORE+" : ");
			this.set("scoreValue",score);					
		}
			this._trace.exiting(this.id, "populate");			
	},
	removeScoreText : function(){
		if(dojo.isIE){
			var g = dojo.byId(this.id+"_scoreChart").childNodes[0].childNodes[0].childNodes[1].childNodes[3];
			g.removeChild(g.childNodes[2]);
		}else if(dojo.isFF){
			var g = dojo.byId(this.id+"_scoreChart").childNodes[0].childNodes[1].childNodes[2];
			g.removeChild(g.childNodes[1]);
		}
	}
});